# Try to find the gmm library
# Once done this will define
#
# GMM_FOUND         - system has gmm and it can be used
# GMM_INCLUDE_DIR   - directory where the header file can be found
#

SET (GMM_FOUND FALSE)

IF(EXISTS GMM_INCLUDE_DIR)  # already found

  IF( GMM_INCLUDE_DIR )
    SET(GMM_FOUND TRUE)
  ENDIF( GMM_INCLUDE_DIR )

ELSE(EXISTS GMM_INCLUDE_DIR)
  FIND_PATH(GMM_INCLUDE_DIR gmm_kernel.h
  /usr/include
  )

  IF( GMM_INCLUDE_DIR )
    SET(GMM_FOUND TRUE)
  ENDIF( GMM_INCLUDE_DIR )

ENDIF(EXISTS GMM_INCLUDE_DIR)

IF(NOT GMM_FOUND)
  IF(GMM_FIND_REQUIRED)
    MESSAGE(FATAL_ERROR "GMM was not found.")
  ELSE (GMM_FIND_REQUIRED)
    MESSAGE(STATUS "GMM was not found.")
  ENDIF(GMM_FIND_REQUIRED)
ENDIF(NOT GMM_FOUND)
