#
# Setting of the variables MIPS_SYSTEM_NAME and MIPS_SYSTEM_RELEASE
#
IF(UNIX)
  EXEC_PROGRAM(uname ARGS -r OUTPUT_VARIABLE UNAME_RELEASE)
  EXEC_PROGRAM(uname ARGS -s OUTPUT_VARIABLE UNAME_SYSTEM)
  SET (MIPS_SYSTEM_RELEASE "${UNAME_RELEASE}" 
	  CACHE STRING "System release (uname -r)")
  MARK_AS_ADVANCED(MIPS_SYSTEM_RELEASE)
  SET (MIPS_SYSTEM_NAME "${UNAME_SYSTEM}" 
	  CACHE STRING "System name (uname -s)")
  MARK_AS_ADVANCED(MIPS_SYSTEM_NAME)
ENDIF(UNIX)

#
# OVERRIDE  standard CMake compilations flags 
#   for -fPIC problem
#
IF(UNIX)
  IF(${MIPS_SYSTEM_RELEASE} MATCHES "^2.*")
    IF(${MIPS_SYSTEM_NAME} MATCHES "Linux")
 	  SET(CMAKE_USER_MAKE_RULES_OVERRIDE 
		  "${CMAKE_SOURCE_DIR}/CommonConfig/CMakeRulesOverride.cmake" 
		  CACHE STRING "Override makefile generation rules."
	  )
	  MARK_AS_ADVANCED(CMAKE_USER_MAKE_RULES_OVERRIDE)
    ENDIF(${MIPS_SYSTEM_NAME} MATCHES "Linux")
  ENDIF(${MIPS_SYSTEM_RELEASE} MATCHES "^2.*")
ENDIF(UNIX)

#
# Set following variables :
#    LINUX for linux system
#    SOLARIS for Sun OS
#
IF(MIPS_SYSTEM_NAME MATCHES "Linux")
  SET(LINUX True)
ENDIF(MIPS_SYSTEM_NAME MATCHES "Linux")

IF(${MIPS_SYSTEM_NAME} MATCHES "SunOS")
  SET(SOLARIS True)
ENDIF(${MIPS_SYSTEM_NAME} MATCHES "SunOS")
