
/*
* Written by: Thomas Yeo
* 
* Example usage:
* ConvertFiles a.nhdr b.nii
* 
*/


#include "itkImageFileReader.h"
#include "itkImageFileWriter.h"
#include "itkImage.h"

#include <getopt.h>
#include <iostream>
#include <string>
#include "Debug.h"
#include "UsefulFunctions.h"

int main( int argc, char *argv[] )
{   

  //Read in Arguments
  const std::string input_filename = argv[1];
  const std::string output_filename = argv[2];

  std::cout<<"input_filename: "<<input_filename<<std::endl;
  std::cout<<"output_filename: "<<output_filename<<std::endl;
  
  typedef itk::Image< float, 3 >   ImageType;
  ImageType::Pointer input = ImageType::New();
  
  yeoReadImage<ImageType>(input, input_filename);
  yeoWriteImage<ImageType>(input, output_filename);
  
  std::cout<<"Conversion success!"<<std::endl;
  exit(EXIT_SUCCESS);
}

