#ifndef _itk_TensorToDispersionFunction_txx_
#define _itk_TensorToDispersionFunction_txx_

#include "itkTensorToDispersionFunction.h"

#define SMALL_NO 0.0000000001

namespace itk
{


  template <class TInputPixelType, class TOutputPixelType>
  typename TensorToDispersionFunction<TInputPixelType,TOutputPixelType>::OutputPixelType
  TensorToDispersionFunction<TInputPixelType,TOutputPixelType>
  ::ComputeScalar (const InputPixelType & T) const
  {

    OutputPixelType disp;

    disp = sqrt((T.GetEigenvalue(0) +  T.GetEigenvalue(1))/(2 * T.GetEigenvalue(2) + SMALL_NO));
    
    return disp;
  }
  


}// end of namespace



#endif
