#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "basics/FileInfo.h"
#include <basics/FileInfo.h>

namespace yav {


TclString FileInfo::directory(void) const {
  unsigned int i;
  int last = -1;
  for(i = 0; i < name.getLength(); i++)
    if(name[i] == '/') last = i;
  if(last < 0) return EMPTY_STRING;
  else return TclString(name, 0, last - 1);
}

TclString FileInfo::file(void) const {
  unsigned int i;
  int last = -1;
  for(i = 0; i < name.getLength(); i++)
    if(name[i] == '/') last = i;
  return TclString(name, last + 1, name.getLength() - 1);
}

TclString FileInfo::noextension(const char *ext) const {
  unsigned int i = strlen(ext);
  if(i >= name.getLength()) return name;
  if(TclString(name, name.getLength() - i,  name.getLength() - 1) == ext)
    return TclString(name, 0, name.getLength() - i - 1);
  else
    return name;
}

bool FileInfo::exists(void) const {
  struct stat bstat;
  return stat((const char *) name, &bstat) == 0;
}

off_t FileInfo::size(void) const {
  struct stat bstat;
  stat((const char *) name, &bstat);
  return bstat.st_size;
}



} // namespace yav
