#ifndef ARCHITECTURE_H
#define ARCHITECTURE_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 4996)
#endif

#ifndef WIN32
#pragma interface "basics/Architecture.h"
#endif

#ifdef WIN32
#include "basics/export.h"

#endif

#if defined __CYGWIN__ || defined WIN32
/* wtypes.h will be somehow included. As it defines nasty constants,
   let's include it now and undef the defs */
# define LONG LONG
# ifndef NOMINMAX
#  define NOMINMAX
# endif
# include <wtypes.h>
#ifndef WIN32 //FS - 2002-09-07
# undef interface
#endif //FS - 2002-09-07
# undef PACKED
# undef LONG
#endif


#ifndef LONGINT

#if (defined _ALPHA_ || (defined _SGI_ && (defined _64_ || defined _64_M4_ || defined _64_M3_)))
/* the 64-bits type on 64-bits platform (long int) */
#define LONGINT long  int
#else
#ifdef __GNUC__
/* the 64-bits type on 32-bits platform (long long int) */
#define LONGINT long long int
#else
/*#define LONGINT __int64 */
#define LONGINT long int
#endif
#endif

#endif


#if ((!defined( _SGI_) || (defined(BASIC_IOSTREAM))) && (!defined(OLD_OSTREAM)))
#include <iostream>
#include <fstream>
#include <iomanip>

namespace yav {

#define STD_OSTREAM std::ostream
#define STD_ISTREAM std::istream
#define STD_FLUSH std::flush
#define CERR std::cerr
#define COUT std::cout
#define ENDL std::endl
#define ENDS std::ends
#define IFSTREAM std::ifstream
#define OFSTREAM std::ofstream
#define FSTREAM std::fstream
#define IOS std::ios
#define SETPRECISION std::setprecision
}

#else
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>

namespace yav {

#define STD_OSTREAM ostream
#define STD_ISTREAM istream
#define STD_FLUSH flush
#define CERR cerr
#define COUT cout
#define ENDL endl
#define ENDS ends
#define FSTREAM fstream
#define IFSTREAM ifstream
#define OFSTREAM ofstream
#define IOS ios
#define SETPRECISION setprecision
}

#endif



#endif
