// link an instance in static list
template<class T> AutoLink<T>::AutoLink() :
  prev (tail), next (0), ref (nextRef()) {

  // if list is empty
  if (!tail)
    head = tail = this;

  // if list is not empty
  else
    tail = tail->next = this;

  count++;
}


// copy an instance in static list
template<class T> AutoLink<T>::AutoLink(const AutoLink& al) :
  prev (tail), next (0), ref (nextRef()) {

   // list should not be empty
  tail = tail->next = this;

  count++;
}


// unlink an instance from static list
template<class T> AutoLink<T>::~AutoLink() {
  if (next)
    next->prev = prev;
  else
    tail = prev;

  if (prev)
    prev->next = next;
  else
    head = next;

  count--;
  if(count == 0) {
    typename std::list<typename AutoLink<T>::AutoWarn *>::iterator it;
    for(it = warn.begin(); it != warn.end(); it++)
      (*it)->empty();
  }
}


// do nothing since one instance is discarded and another added.
// needs to be defined though since ref is a constant object.
template<class T> AutoLink<T>& AutoLink<T>::operator=(const AutoLink& al) {
   return *this ;
}


template <class T> unsigned int AutoLink<T>::nextRef(void) {
  return tail ? tail->ref + 1 : 1;
}


template <class T> T* AutoLink<T>::getByRef(unsigned int n) {
  AutoLink<T> *ptr;

  for(ptr = head; ptr && ptr->ref != n; ptr = ptr->next) ;
  return (T*) ptr;
}

