namespace yav {

template <class T> void ListElement<T>::remove(void) {
  if(next) next->prev = prev;
  else list->tail = prev;
  if(prev) prev->next = next;
  else list->head = next;

  list->count--;
  if(list->count == 0) list->empty();
  next = prev = 0;
  list = 0;
}

template <class T> void ListElement<T>::insert(ListElement<T> *le) {
  next=le->next;
  if (next)
    next->prev=this;
  else
    le->list->tail=this;
  prev=le;
  le->next=this;
  list=le->list;
  list->count++;
}

template <class T> void ListElement<T>::disconnect(void) {
  if(list) {
    if(next) next->prev = prev;
    else list->tail = prev;
    if(prev) prev->next = next;
    else list->head = next;

    list->count--;
    list=0;
  }
}

template <class T> int ListElement<T>::getRank(void) const  {
  if (list==0)
    return(-1);
  else
    {
      typename ObjectsList<T>::Iterator it(*list);
      int rank=0;
      for(; (it.current!=this);it++,rank++);
      return(rank);
    }
}

}

