#if defined WIN32 && defined DLL_BUILD

#ifndef YAV_EXPORTH
#define YAV_EXPORTH

#ifdef BUILDING_LIBBASICS
#define LIBBASICS_API __declspec(dllexport)
#else
#define LIBBASICS_API __declspec(dllimport)
#endif

//-- list of ignored warnings
#pragma warning( disable : 4251)
#pragma warning( disable : 4275)

namespace yav {

// Types
typedef LIBBASICS_API unsigned int Index;

// Classes
template<Index Dim, class Real=double> class LIBBASICS_API IKdTree;
template<Index Dim, class Real=double> class LIBBASICS_API KdTree;

template <Index L, Index C, class T> class LIBBASICS_API Mat;
template <Index D, class T> class LIBBASICS_API Matrix;
template <Index D, class T> class LIBBASICS_API Sym;
template <Index D, class T> class LIBBASICS_API Vect;

template <class T> class LIBBASICS_API HVec4;
template <class T> class LIBBASICS_API Matrix2x2;
template <class T> class LIBBASICS_API Matrix3x3;
template <class T> class LIBBASICS_API Matrix4x4;
template <class T> class LIBBASICS_API Vec2;
template <class T> class LIBBASICS_API Vec3;
template <class T> class LIBBASICS_API Vec4;

class LIBBASICS_API Exception;
class LIBBASICS_API IniFile;
class LIBBASICS_API Normal3D;
class LIBBASICS_API RigidMat3D;
class LIBBASICS_API RigidVec3D;
class LIBBASICS_API RotMat3D;
class LIBBASICS_API RotVec3D;
class LIBBASICS_API UnitQuat;

// Methods
template<class T> void LIBBASICS_API Xlinalg_Small_Val(T&);
template<class T> void LIBBASICS_API Xlinalg_Class_Name(T&,char*);

template<> void LIBBASICS_API Xlinalg_Small_Val<double>(double& v);
template<> void LIBBASICS_API Xlinalg_Small_Val<float>(float& v);

template<> void LIBBASICS_API Xlinalg_Class_Name<double>(double& v,char*buf);
template<> void LIBBASICS_API Xlinalg_Class_Name<float>(float& v,char*buf);

bool LIBBASICS_API GetInitFileString (const char * FileName, const char * EntryName, const char * KeyName, char * Buffer, const char * Default, bool warning);
bool LIBBASICS_API GetInitFileStringND (const char * FileName, const char * EntryName, const char * KeyName, char * Buffer, bool warning);
bool LIBBASICS_API GetInitFileInt (const char * FileName, const char * EntryName, const char * KeyName, int & Buffer, int Default, bool warning);
bool LIBBASICS_API GetInitFileIntND (const char * FileName, const char * EntryName, const char * KeyName, int & Buffer, bool warning);
bool LIBBASICS_API GetInitFileFloat (const char * FileName, const char * EntryName, const char * KeyName, float & Buffer, float Default, bool warning);
bool LIBBASICS_API GetInitFileFloatND (const char * FileName, const char * EntryName, const char * KeyName, float & Buffer, bool warning);
bool LIBBASICS_API GetInitFileDouble (const char * FileName, const char * EntryName, const char * KeyName, double & Buffer, double Default, bool warning);
bool LIBBASICS_API GetInitFileDoubleND (const char * FileName, const char * EntryName, const char * KeyName, double & Buffer, bool warning);
bool LIBBASICS_API GetInitFileBool (const char * FileName, const char * EntryName, const char * KeyName, bool & Buffer, bool Default, bool warning);
bool LIBBASICS_API GetInitFileBoolND (const char * FileName, const char * EntryName, const char * KeyName, bool & Buffer, bool warning);

void LIBBASICS_API RigidMat3DToRigidVec3D( const RigidMat3D& rig, RigidVec3D& r) throw();
void LIBBASICS_API RigidVec3DToRigidMat3D( const RigidVec3D& r, RigidMat3D& rig) throw();
bool LIBBASICS_API atob(const char*str, bool defaut=false) throw();


};

#endif // YAV_EXPORTH
#endif // WIN32

