#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "framework/Activable.h"
#include <framework/Activable.h>

namespace yav {


AUTOLINK_STATIC_VARIABLES(Activable);

unsigned int Activable::activatedObjects = 0;


Activable::Activable() {
  activated = false;
}


Activable::~Activable() {
  off();
}


void Activable::on(void) {
  if(!activated) {
    activated = true;
    activatedObjects++;
  }
}


void Activable::off(void) {
  if(activated) {
    activated = false;
    activatedObjects--;
  }
}

void Activable::activate(void) {
  if(activatedObjects > 0) {
    for(Activable *obj = getHead(); obj; obj = obj->following())
      if(obj->activated) obj->activation();
  }
}

} // namespace yav

