#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "framework/Constraint.h"
#pragma implementation "framework/RangeInformation.h"
#include <framework/Constraint.h>
#include <framework/RangeInformation.h>


namespace yav {


std::map<char *,RangeInformation::RIREADFUNCTION,CStringCompare> RangeInformation::readFunctionMap;

std::map<char *,Constraint::CONSTRAINTREADFUNCTION,CStringCompare> Constraint::readFunctionMap;


void ConstraintContainer::applyForceConstraint()
{
  ObjectsList<Constraint>::iterator it=forceConstraintList.begin();
  for(;it!=forceConstraintList.end();it++)
    {
      if ((*it)->isActive()==true)
	(*it)->apply();
    }
}

void ConstraintContainer::applyAddStiffnessMatrix()
{
	ObjectsList<Constraint>::iterator it=forceConstraintList.begin();
	for(;it!=forceConstraintList.end();it++)
	{
		if ((*it)->isActive()==true)
			(*it)->addStiffnessMatrix();
	}
}

void ConstraintContainer::applyPositionConstraint()
{
  ObjectsList<Constraint>::iterator it=positionConstraintList.begin();
  for(;it!=positionConstraintList.end();it++)
    {
      if ((*it)->isActive()==true)
	(*it)->apply();
    }
}

Constraint * ConstraintContainer::getPositionConstraint(TclString name){
  ObjectsList<Constraint>::iterator it=positionConstraintList.begin();
  Constraint * cstr = NULL;
  for(;it!=positionConstraintList.end();it++){
    if (name.compare((*it)->getName())==0){
      cstr = (*it);
    }
  }      
  return (cstr);
}

Constraint * ConstraintContainer::getForceConstraint(TclString name){
  ObjectsList<Constraint>::iterator it=forceConstraintList.begin();
  Constraint * cstr = NULL;
  for(;it!=forceConstraintList.end();it++){
    if (name.compare((*it)->getName())==0){
      cstr = (*it);
    }
  }
  return (cstr);
}

}
