#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "framework/Interface.h"
#include <framework/Interface.h>


namespace yav {


Interface::NullClient::NullClient(const std::string& from)
  : Exception(from,
              "cannot create an interface pointing on a null client") {
}


Interface::Interface(Client *_client) throw(Interface::NullClient)
  : client(_client), destroyClient(true) {
  if(!client) throw NullClient("Interface::Interface");
}

 /// returns client
Client *Interface::getData(void) { return client; }
  /// returns client
Client *Interface::getClient(void) const { return client; }

Interface::~Interface() {
  if(destroyClient && client) {
    client->interfaceDied();
    client = 0;
  }
}


void Interface::clientDying(void) {
  destroyClient = false;
  delete this;
}


void Interface::setClient(Client *c) {
  client = c;
}



} // namespace yav

