#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "framework/PointSet.h"
#include <framework/PointSet.h>


namespace yav {

  // constructor:
  PointSetIterator::PointSetIterator() {}
  // destructor:
  PointSetIterator::~PointSetIterator() {}

  // resets iterator to first point
  void PointSetIterator::first() {
    CERR << "[error] PointSetIterator::first()\n";
  }
  // increments iterator
  void PointSetIterator::operator++() {}
  // increments iterator
  void PointSetIterator::operator++(int) {}
  // returns true if end of list was reached
  bool PointSetIterator::isAtEnd() const {
    return true;
  }
  
  // returns current point coordinates
  const Vec3<double> PointSetIterator::get() const {
    return Vec3<double>(0,0,0);
  }
  
  // returns current point weight
  double PointSetIterator::getWeight() const {
    return 0.0;
  }
  
  // returns current point X coordinate
  double PointSetIterator::getX() const {
    return 0.0;
  }
  // returns current point Y coordinate
  double PointSetIterator::getY() const {
    return 0.0;
  }
  // returns current point Z coordinate
  double PointSetIterator::getZ() const {
    return 0.0;
  }
  
  // changes the coordinates of the current point
   void PointSetIterator::set(const Vec3<double>& Coordinates) {}



  // computes the barycenter:
  unsigned int PointSetIterator::barycenter(Vec3<double>& G) {

    unsigned int N = 0;
    G = Vec3<double>();
    double somme = 0.0;

    for(first(); !isAtEnd(); operator ++())
      if(getWeight() > 0.0) {
	G[0] += getWeight()*getX();
	G[1] += getWeight()*getY();
	G[2] += getWeight()*getZ();
	N++;
	somme += getWeight();
      }
    
    if(N > 0)
      G /= somme;
    
    return N;
  }


} // namespace yav
