#ifndef CLIENT_H
#define CLIENT_H

#pragma interface "framework/Client.h"
#include <framework/Interface.h>


namespace yav {


/*! \class Client Client.h basics/Client.h
  \ingroup libBasics
  client object that offers services to its client 
*/
class Client {
 protected:
  /// object interface (may be 0)
  Interface *TclInterface;

 public:
  /// constructor
  Client();

  /// virtual destructor
  virtual ~Client();

  /** Set a new interface object for this object. Old interface (if any)
      is deleted
      @param i new interface object */
  void setInterface(Interface *i);

  /** the function called when the interface is destroyed */
  void interfaceDied(void);

  /** returns this object interface object */
  Interface *getInterface(void) const;

  /** Copy operation. Copied object's interface set to 0
      @param c object to copy.
      @return this */
  Client& operator=(Client const& c){
     TclInterface=0;
     return *this;
  }
};



} // namespace yav


#endif
