
#ifndef _BASICS_TEST_H
#define _BASICS_TEST_H


template<class Real> inline Real EPS(const Real&);
template<> inline double EPS<double>(const double&) { return  1e-12;};
template<> inline float EPS<float>(const float&) { return (float) 1e-6; };

template<class Real> inline char * classname(void);
template<> inline char * classname<double>(void) {return "double";};
template<> inline char * classname<float>(void) {return "float";};


// Test functions to declare
int BasicsErrorTest(int argc, char *argv[]);
int BasicsVectTest(int argc, char *argv[]);
int BasicsVect3Test(int argc, char *argv[]);
int BasicsMatTest(int argc, char *argv[]);
int BasicsInvTest(int argc, char *argv[]);
int BasicsSVDTest(int argc, char *argv[]);
int BasicsQuatTest(int argc, char *argv[]);
int BasicsRegTest(int argc, char *argv[]);
int BasicsRotationTest(int argc, char *argv[]);

#endif // _BASICS_TEST_H
