#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "linearAlgebra/Rotation2D.h"
#include <linearAlgebra/Rotation2D.h>

namespace yav {

#ifdef __GNUC__
  const double Rotation2D::determinantThreshold = 1e-6;
#endif

Rotation2D::Rotation2D(double matrix[2][2]) throw(NonRotationMatrix)
  : Matrix2x2<double>(matrix)
{
  if ( ::fabs(Matrix2x2<double>::det()-1)>determinantThreshold)
    throw(NonRotationMatrix("Rotation2D::Rotation2D(double [2][2]))"));
}


Rotation2D::Rotation2D(double angle)
  : Matrix2x2<double>(VIM_NOINIT)
{
  double ca= cos(angle);
  double sa= sin(angle);

  this->setValue(0,0,ca);
  this->setValue(1,1,ca);
  this->setValue(0,1,-sa);
  this->setValue(1,0,sa);

}


Rotation2D::Rotation2D(const Vec2<double> &v1,const Vec2<double> &v2)
  throw(NonRotationMatrix) :
  Matrix2x2<double>(v1,v2)
{
  if ( ::fabs(Matrix2x2<double>::det()-1)>determinantThreshold)
    throw(NonRotationMatrix("Rotation2D::Rotation2D(Vec2<double v1, Vec2<double> v2))"));
}


double Rotation2D::getRotationAngle() const
{
  return(atan2(getValue(1,0), getValue(0,0)));
}

} // namespace yav
