
namespace yav {


template <class T> const double ActiveVertex<T>::defaultAlpha = 1.0;
template <class T> const double ActiveVertex<T>::defaultBeta = 0.1;
template <class T> const double ActiveVertex<T>::defaultDamping = 0.65;
template <class T> const double ActiveVertex<T>::defaultElasticDamping = 0.1;
template <class T> const unsigned int ActiveVertex<T>::defaultRigidity = 1;
template <class T> const double ActiveVertex<T>::defaultLocality = 1.0;


template <class T> ActiveVertex<T>::ActiveVertex(void) {
    alpha=defaultAlpha;
    beta=defaultBeta;
    damping=defaultDamping;
    elasticDamping=defaultElasticDamping;
    forceRange=0;
    fixed=false;
    maximumRigidity=rigidity=defaultRigidity;
    locality=defaultLocality;
    rangeInformation=0;
}
template <class T> ActiveVertex<T>::~ActiveVertex(void) {
  if (rangeInformation)
    delete rangeInformation;
}
template <class T, class V> InternalForceItem<T,V>::InternalForceItem
( InternalForceType<T,V> *ft, V *v)  : functionScope(LOCAL),
  internalForceType(ft), vertex(v) { }

template <class T, class V> InternalForceItem<T,V>::InternalForceItem 
( InternalForceType<T,V> *ft) :
  functionScope(GLOBAL),  internalForceType(ft), vertex(0) { }



template <class T, class V>
InternalForceType<T, V> *InternalForceType<T, V>::getByName(const char *name) {
  AutoLink <InternalForceType<T, V> > *el;
  for(el = AutoLink<InternalForceType<T, V> >::getHead(); el;
      el = el->following()) {
    if(!strcmp(name, ((InternalForceType<T, V> *) el)->name))
      return (InternalForceType<T, V> *) el;
  }
  return 0;
}



} // namespace yav

