#ifndef DEFORMABLEMODEL_C
#define DEFORMABLEMODEL_C

#include <basics/AutoLink.h>

namespace yav {


template <class SCENE, class DEFORMABLE >
DeformableModel<SCENE, DEFORMABLE >::DeformableModel(SCENE *scn)
  : active(true) {
  if (!scn)
    {
      // If there are no existing scene
      if (AutoLink<SCENE>::getCount()==0)
	{
	  // creates a new scene
	  scn = new SCENE();
	}
      else
	// Otherwise gets the first in list
	scn= AutoLink<SCENE>::getHead();
    }
  scn->addDeformableModel((DEFORMABLE *) this);
}



template <class SCENE, class DEFORMABLE >
void DeformableModel<SCENE, DEFORMABLE >::setScene(SCENE *scn) {
  scn->addDeformableModel((DEFORMABLE *) this);
}

}
#endif
