#ifndef FILESCENE_H
#define FILESCENE_H

#pragma interface "graphics/FileScene.h"
#include <basics/Exception.h>
#include <basics/AutoLink.h>
#include <basics/TclString.h>


namespace yav {

/** \class FileScene
    \ingroup Graphics
*/
template <class T> class FileScene : public AutoLink<FileScene<T> > 
{
 public:
  typedef bool (*TESTMAGICNUMBER)(const TclString &filename);
  typedef void (*READFILE)(const TclString &filename,T *);
  /** \class EmptyReadFunction
    \ingroup Graphics
  */
  class EmptyReadFunction : public Exception {
  public:
    EmptyReadFunction(const std::string& from) : 
      Exception(from, "No Read function has been provided") {}
  };
 private:
  TclString keyword;
  TclString fileExtension;
  READFILE readFunction;
  TESTMAGICNUMBER magicFunction;
 public:
  FileScene(const TclString &key,const TclString &fext,
	    READFILE readf,TESTMAGICNUMBER magicFunction=0) throw(EmptyReadFunction);
  static bool readScene(const TclString &filename,T *);
};


} // namespace yav

#include "FileScene.txx"

#endif
