#include <graphics/FileScene.h>

namespace yav {

template<class T> FileScene<T>::FileScene(const TclString &key,const TclString &fext,READFILE readf,TESTMAGICNUMBER magicf)
  throw(EmptyReadFunction)  : keyword(key), fileExtension(fext), readFunction(readf),magicFunction(magicf) 
{
  if (readFunction==0)
    throw(EmptyReadFunction("FileScene::FileScene"));
}

template<class T> bool FileScene<T>::readScene(const TclString &filename,T *scn)
{
  FileScene<T> *fscn;

  // First tests if there is an entry 
  if (AutoLink<FileScene<T> >::getCount()==0)
    return(false);


  // tests if the file exists
  IFSTREAM input(filename);
  if (!input)
    return(false);
  char c;
  // reads the first character
  input.get(c);
  if (c!='#')
    goto extension;

  char keyw[100];
  // Then reads the keyword
  input >> keyw ;
  // close the file
  input.close();
  //Tests if there is an entry that match the keyword
  fscn=AutoLink<FileScene<T> >::getHead();
  // finds the entry having the same keyword
  for(;(fscn!=0) && (fscn->keyword!=(const char *)keyw);fscn=fscn->following());
  
  if (fscn!=0)
    {
      // Found the format try to read it
      try 
	{
	  (*fscn->readFunction)(filename,scn);
	}
      catch (Exception e)
      {
	/*It did not work */
	return(false);
      }
      /* it worked */
      return(true);
    }
  // Trying to read the file through its extension
 extension:
  int el, fl;

  for(fscn=AutoLink<FileScene<T> >::getHead(); fscn;
      fscn = fscn->following()) {
    fl = filename.getLength();
    el = fscn->fileExtension.getLength();
    if(el > 0 && fl >= el) {
      // Found the format try to read it
      if(fscn->fileExtension == TclString(filename, fl - el, fl - 1)) {
	try {
	  (*fscn->readFunction)(filename,scn);
	}
	catch(Exception e) {
	  /*It did not work */
	  return(false);
	}
	/* it worked */
	return(true);
      }
    }
  }
  
  // Now tests if one magic function works for this file
  //Tests if there is an entry whose magicFunction returns true
  fscn=AutoLink<FileScene<T> >::getHead();
  for(;(fscn!=0) && (fscn->magicFunction!=0) && 
	((*(fscn->magicFunction))(filename)==false);fscn=fscn->following());
  // found nothing : returns
  if (fscn==0)
    return(false);
  else
    {
      // Found the format try to read it
      try 
	{
	  (*fscn->readFunction)(filename,scn);
	}
      catch (Exception e)
      {
	/*It did not work */
	return(false);
      }
      /* it worked */
      return(true);
    }
}


} // namespace yav
