#ifndef RANGEDATA_C
#define RANGEDATA_C


namespace yav {

template <class VEC, class SCENE, class RANGE >
RangeData<VEC, SCENE, RANGE >::RangeData(SCENE *scn) 
{
  if (!scn)
    {
      // If there are no existing scene
      if (AutoLink<SCENE>::getCount()==0)
	{
	  // creates a new scene
	  scene = new SCENE();
	}
      else
	// Otherwise gets the first in list
	scene= AutoLink<SCENE>::getHead();
    }
  else scene = scn;
  scene->addRangeData((RANGE *) this);
}


template <class VEC, class SCENE, class RANGE >
void RangeData<VEC, SCENE, RANGE >::setScene(SCENE *scn) {
  if(scene && scene != scn) scn->addRangeData((RANGE *) this);
}

}
#endif
