


template <   class SCENE>
void Scene< SCENE>::stepIteration(void) 
{
  /// gets the current time
#ifndef WIN32
  struct timeval tv;
#endif
  unsigned LONGINT startIteration;

  for(unsigned int i=0; i<iterationStep;++i)
    {
     ObjectsList< IteratedActiveObject >::iterator it =
			activeObjectList.begin();
		

		for(; it!=activeObjectList.end(); it++) 
		{
      
	  if ((*it)->getActivation() && (*it)->continueDeformation())
	    {
#ifndef WIN32
		  // record the time before deformation
	      gettimeofday(&tv, 0);
	      startIteration=tv.tv_sec * 1000000 + tv.tv_usec;
#else
	      startIteration=time(0);
#endif
	      (*it)->iterate(nbIterationsPerCall);
	      (*it)->iterationNumber+=nbIterationsPerCall;
	      // get the time after deformation
#ifndef WIN32
	      gettimeofday(&tv, 0);
	      // updates the duration of deformation
	      if (i==0)
		(*it)->computationTime=tv.tv_sec * 1000000 + tv.tv_usec -
		  startIteration;
	      else
		(*it)->computationTime+=tv.tv_sec * 1000000 + tv.tv_usec -
		  startIteration;
#else
		  if (i==0)
			  (*it)->computationTime=time(0)-startIteration;
			else
				(*it)->computationTime+=time(0)-startIteration;
#endif
	    }
	}
    }
}


