#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "graphics/SceneItem.h"
#include <graphics/SceneItem.h>
#include <graphics2D/TclScene2D.h>
#include <graphics2D/TclScale.h>
#include <graphics2D/SliceScale.h>
#include <graphics2D/TclCamera2D.h>
#include <graphics2D/TclSurfaceView.h>
#include <graphics2D/TclBasicCameraBackground.h>
#include <graphics2D/Graphics2DCmd.h>

#ifdef EMBEDED_TCL_SCRIPTS
#include "tclGraphics2D.tcl.h" // generated by tcl2h
#endif

namespace yav {

  typedef SceneItem <Scene2D> SceneItem2D;
  AUTOLINK_STATIC_VARIABLES( SceneItem2D );
  
  //template <typename  SceneItem <Scene2D> > AutoLink< SceneItem< Scene2D > > *AutoLink< SceneItem< Scene2D > >::head = 0;
  //template <typename T> AutoLink<T> *AutoLink<T>::tail = 0;
  //template <typename T> unsigned int AutoLink<T>::count = 0;
  //template <typename T> std::list<typename AutoLink< T >::AutoWarn *> AutoLink< T >::warn;

const char *TclGraphics2DInit::tclGraphics2DName="tclGraphics2D";
static TclGraphics2DInit tclGraphics2DInit;


void Tclgraphics2d_Init(TclModule *m) {
  TclObjectKind *kind;

  kind = new Scene2DItem(m, typeid(TclScale), "scale","Scaler",
			 &TclScale::create, &TclScale::list,
			 TclScene2D::OTHER, 0);
  kind->newOption("-destroy", (TclObject::OPTION) &TclScale::destroyCmd, 0,
		  "Destroy scale object");
  kind->newOption("-widget", (TclObject::OPTION) &TclScale::widgetCmd, 0,
		  "Return TCL scale name");
  kind->newOption("-maxSteps", (TclObject::OPTION) &TclScale::maxStepsCmd, "[%ud]",
		  "Get/Set the maximum number of steps when the scale is activated");
  kind->newOption("-from", (TclObject::OPTION) &TclScale::fromCmd, "[%f]",
		  "Get/Set scale min value");
  kind->newOption("-to", (TclObject::OPTION) &TclScale::toCmd, "[%f]",
		  "Get/Set scale max value");
  kind->newOption("-resolution", (TclObject::OPTION) &TclScale::resolutionCmd,
		  "[%f]", "Get/Set scale resolution");
  kind->newOption("-get", (TclObject::OPTION) &TclScale::getCmd, 0,
		  "Get scale value");
  kind->newOption("-add", (TclObject::OPTION) &TclScale::addCmd,
		  "slicecam%u+",
		  "Add given slice camera to scale object");
  kind->newOption("-set", (TclObject::OPTION) &TclScale::setCmd, "%f",
		  "Set scale to given value");
  kind->newOption("-command", (TclObject::OPTION) &TclScale::commandCmd, "%f",
		  "Activate scale command to given value");
  kind->newOption("-activate", (TclObject::OPTION) &TclScale::activateCmd,
		  "[%b]",
		  "Get/Set activation flag. Activation cause scale to loop up and down from its min to its max value.");

  m->newCommand("scalables", &TclScale::scalablesCmd, 0,
		"Returns all created scalables");
  m->newCommand("surfaceSliceables", &TclSurfaceView::surfaceSliceablesCmd, 0,
		"Returns all surface sliceables");
  kind->newOption("-objects",
		  (TclObject::OPTION) &TclScale::objectsCmd, 0,
		  "Return list of attached objects");
  kind->newOption("-remove", (TclObject::OPTION) &TclScale::removeCmd,
		  "slicecam%u+",
		  "Remove given inrimage viewers from scale");
  kind->newOption("-die", (TclObject::OPTION) &TclScale::dieCmd,"[%b]","True if inrimagescale dies when it runs out of images");

  kind = new Scene2DItem(m, typeid(SliceScale), "slicescale","Slice Scaler",
			 &SliceScale::create, &SliceScale::list,
			 TclScene2D::OTHER,
			 "-in %w ");
  m->newCommand("slicescale%u", kind->getOptions(),
		"Slice scale management command");
  kind->addOptions(typeid(TclScale));

 kind = new TclObjectKind(m, typeid(TclBasicCameraBackground), "basicBgnd","2D Image Background in 2D camera","cam%u filename=%s",
			   &TclBasicCameraBackground::create, &TclBasicCameraBackground::list);
  kind->newOption("-destroy", (TclObject::OPTION) &TclBasicCameraBackground::destroyCmd, 0,
		  "destroy a 2D camera background");


 kind = new Scene2DItem(m, typeid(TclSurfaceView), "surfview","3D Surface Slice Viewer",
			&TclSurfaceView::create, &TclSurfaceView::list,
			TclScene2D::OTHER, "[tr%u|sm%u|tet3D%u] [-scene scn2D%u]");
 m->newCommand("surfview%u", kind->getOptions(), "3D Surface viewer management command");
 kind->newOption("-destroy", (TclObject::OPTION) &TclSurfaceView::destroyCmd, 0,
		 "Destroy 3D Surface view");
  kind->newOption("-useZonesColor",
		  (TclObject::OPTION) &TclSurfaceView::useZonesColorCmd, "[%b]",
		  "Indicates if the surface should be displayed with one color (false) or if each zone should be drawn with a different color (true)");
 kind->newOption("-mesh", (TclObject::OPTION) &TclSurfaceView::meshCmd, 0,
		 "Returns the 3D surface attached to Surface view");
 kind->newOption("-width", (TclObject::OPTION) &TclSurfaceView::widthCmd, "[%f]",
		 "Set/get the contour line width");
 kind->newOption("-scene", (TclObject::OPTION) &TclSurfaceView::sceneCmd, 0,
		 "Returns the 2D scene where the view is located");
 kind->newOption("-color",
		 (TclObject::OPTION) &TclSurfaceView::colorCmd,
		 "%f %f %f",
		 "Set/get trace colors in cameras.");
 kind->newOption("-interactionMode",
		 (TclObject::OPTION) &TclSurfaceView::interactionModeCmd,
		 "[grab|position|movePosition|removePosition]",
		 "Set/get the action performed when the left mouse button is activated");

 
  m->newCommand("scn2D", TclScene2D::whichCmd,
		"<-which [none] [scene] [camera] [file] [other] | -suffix %s | -realName %s>",
		"Returns objects handled by 2D scenes (filtered by construction mode) or filename suffixes used for a given object type or the expanded name associated with a given object type");

  kind = new TclObjectKind(m, typeid(TclScene2D), "scn2D","2D scene",
			   &TclScene2D::create, &TclScene2D::list, 0);
  m->newCommand("scn2D%u", kind->getOptions(), "2D scene management command");
  kind->newOption("-destroy", (TclObject::OPTION) &TclScene2D::destroyCmd, 0,
		  "Delete 2D scene");
  kind->newOption("-objects", (TclObject::OPTION) &TclScene2D::objectsCmd,
		  0, "Return scene objects list");
  kind->newOption("-deformable", (TclObject::OPTION) &TclScene2D::deformableCmd,
		  0, "return scene deformable models  list");
  kind->newOption("-camera", (TclObject::OPTION) &TclScene2D::cameraCmd,
		  0, "Return scene list of cameras");
  kind->newOption("-load", (TclObject::OPTION) &TclScene2D::loadCmd, "%s",
		  "Load 2D scene from given file name");
  kind->newOption("-iteration", (TclObject::OPTION) &TclScene2D::iterationCmd, "[step|call] [%u]",
		  "If no parameter is provided then all activated deformable models of the scene are deformed. Otherwise, get or set the number of iterations per step or the number of iterations per background call");
  kind->newOption("-computation", (TclObject::OPTION) &TclScene2D::computationCmd,
		  "[%b|%u|loop]", "Get/set the boolean corresponding to the activation status of the scene; if true it means that the scene is activating all deformable models. An integer value indicates the number of step to iterate before a complete stop. \"loop\" indicates that the scene iterates until no deformable models are active");

#ifdef GRAPHICS
  kind->newOption("-redraw", (TclObject::OPTION) &TclScene2D::redrawCmd, 0,
		  "Redraw all cameras viewing this 2D scene");
  kind->newOption("-focus", (TclObject::OPTION) &TclScene2D::focusCmd, 0,
		  "Reset all cameras viewing this 2D scene focus");
  /// create commands for 2D camera
  TclCamera2D::createCommands(m);

  char pkgName[]="graphics2DTCL";
  char pkgVers[]="1.0";
  Tcl_PkgProvide(m->getInterp(), pkgName, pkgVers);

#endif

#ifdef EMBEDED_TCL_SCRIPTS
 /* Statically loads the tcl script from tclModules.tcl.h (generated by tcl2h) */
 Tcl_Eval(m->getInterp(), tclGraphics2D_tcl);
 /* Tell the TclModule constructor not to load the script again */
 m->tclScriptLoaded();
#endif
 /* Otherwise, the tcl script will be loaded dynamically from tclModules.tcl by the TclModule constructor */

}


/************
#ifdef _SOLARIS_
int main() {
}
#endif
************/

}
