#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif


#pragma implementation "graphics2D/TclBoundingBox4D.h"
#include <graphics2D/TclBoundingBox4D.h>


namespace yav {

TclBoundingBox4D::TclBoundingBox4D(TclModule *m,
				   TclScene2D *scene, 
				   unsigned int x1, unsigned int y1, 
				   unsigned int z1,unsigned int t1,
				   unsigned int x2, unsigned int y2, 
				   unsigned int z2, unsigned int t2,
				   const TclString& _color, const TclString& _menu)
  :  TimeSliceable(scene->getClient()),TclObject(typeid(TclBoundingBox4D),m), color(_color), menu(_menu), face(NONE)  {

  done(typeid(TclBoundingBox4D));
  
  if(x1 < x2) {
    box[0] = x1;
    box[3] = x2;
  }
  else {
    box[0] = x2;
    box[3] = x1;
  }
  if(y1 < y2) {
    box[1] = y1;
    box[4] = y2;
  }
  else {
    box[1] = y2;
    box[4] = y1;
  }
  if(z1 < z2) {
    box[2] = z1;
    box[5] = z2;
  }
  else {
    box[2] = z2;
    box[5] = z1;
  }
  if(t1 < t2) {
    box[6] = t1;
    box[7] = t2;
  }
  else {
    box[6] = t2;
    box[7] = t1;
  }

  ObjectsList<Camera2D>::iterator it = scene->getClient()->firstCamera();
  for(;it!=scene->getClient()->lastCamera(); it++) {
    TclTimeSliceCamera *cam = dynamic_cast<TclTimeSliceCamera *> ((*it)->getInterface());
    if (cam)
      {
	cam->applyObjectSelection(this);
	if(menu != EMPTY_STRING) {
	  cam->tickle("%s %s%u %s%u", (char *) menu,
		      TclObjectKind::getObjectName(typeid(TclTimeSliceCamera)),
		      cam->getRef(),TclObjectKind::getObjectName(typeid(TclBoundingBox4D)),TclObject::getRef());
	}
      }
  }
  
  updateDisplay();
}


TclBoundingBox4D::~TclBoundingBox4D() {

  //  unselectScene();
  ObjectsList<Camera2D>::iterator it = scene->firstCamera();
  for(;it!=scene->lastCamera(); it++) {
    TclTimeSliceCamera *cam = dynamic_cast<TclTimeSliceCamera *> ((*it)->getInterface());
    if (cam)
      {
#ifdef OLD_CODE
	cam->tickle("%s delete bbox", (char *) cam->getCanvas());
	cam->installDefaultPopupMenuCommand();
#endif

	  }
  }
 TclScene2D *tclscene=  (TclScene2D *)( this->getScene()->getInterface());
  tclscene->unselectCameraObject((Data2D *) this);
  deleted(typeid(TclBoundingBox4D));
}


void TclBoundingBox4D::setClosestFace(TimeSliceCamera::TIME_GEOMETRY geom, 
				      unsigned int x, unsigned int y, 
				      unsigned int z, unsigned int t) {
  unsigned int opt, v;
  
  switch(geom) {
  case TimeSliceCamera::SLICE_X:
    opt = abs((int)(box[1] - y));
    face = YMIN;
    v = abs((int)(box[2] - z));
    if(v < opt) { 
      opt = v; 
      face = ZMIN;
    }
    v = abs((int)(box[4] - y));
    if(v < opt) { 
      opt = v;
      face = YMAX;
    }
    v = abs((int)(box[5] - z));
    if(v < opt) {
      opt = v;
      face = ZMAX;
    }
    break;
  case TimeSliceCamera::SLICE_Y:
    opt = abs((int)(box[0] - x));
    face = XMIN;
    v = abs((int)(box[2] - z));
    if(v < opt) { 
      opt = v; 
      face = ZMIN;
    }
    v = abs((int)(box[3] - x));
    if(v < opt) { 
      opt = v; 
      face = XMAX;
    }
    v = abs((int)(box[5] - z));
    if(v < opt) {
      opt = v;
      face = ZMAX;
    }
    break;
  case TimeSliceCamera::SLICE_Z:
  case TimeSliceCamera::SLICE_ALPHA:
    opt = abs((int)(box[0] - x));
    face = XMIN;
    v = abs((int)(box[1] - y));
    if(v < opt) {
      opt = v; 
      face = YMIN;
    }
    v = abs((int)(box[3] - x));
    if(v < opt) { 
      opt = v; 
      face = XMAX;
    }
    v = abs((int)(box[4] - y));
    if(v < opt) { 
      opt = v;
      face = YMAX;
    }
    break;
  case TimeSliceCamera::SLICE_XT:
    opt = abs((int)(box[0] - x));
    face = XMIN;
    v = abs((int)(box[6] - t));
    if(v < opt) {
      opt = v; 
      face = TMIN;
    }
    v = abs((int)(box[3] - x));
    if(v < opt) { 
      opt = v; 
      face = XMAX;
    }
    v = abs((int)(box[7] - t));
    if(v < opt) { 
      opt = v;
      face = TMAX;
    }
    break;
  case TimeSliceCamera::SLICE_YT:
    opt = abs((int)(box[1] - y));
    face = YMIN;
    v = abs((int)(box[6] - t));
    if(v < opt) {
      opt = v; 
      face = TMIN;
    }
    v = abs((int)(box[4] - y));
    if(v < opt) { 
      opt = v; 
      face = YMAX;
    }
    v = abs((int)(box[7] - t));
    if(v < opt) { 
      opt = v;
      face = TMAX;
    }
    break;
  case TimeSliceCamera::SLICE_ZT:
    opt = abs((int)(box[2] - z));
    face = ZMIN;
    v = abs((int)(box[6] - t));
    if(v < opt) {
      opt = v; 
      face = TMIN;
    }
    v = abs((int)(box[5] - z));
    if(v < opt) { 
      opt = v; 
      face = ZMAX;
    }
    v = abs((int)(box[7] - t));
    if(v < opt) { 
      opt = v;
      face = TMAX;
    }
    break;
  }

  moveFace(x, y, z,t);
}


void TclBoundingBox4D::moveFace(unsigned int x, unsigned int y, unsigned int z,
			      unsigned int t) {
  if(face != NONE) {
    if(face == XMIN || face == XMAX) box[(int) face] = x;
    else if(face == YMIN || face == YMAX) box[(int) face] = y;
    else if(face == ZMIN || face == ZMAX) box[(int) face] = z;
    else if(face == TMIN || face == TMAX) box[(int) face] = t;
    updateDisplay();
  }
}


void TclBoundingBox4D::recompute(SliceCamera *c) {
  TimeSliceCamera *cam= dynamic_cast<TimeSliceCamera *>(c);
  TclTimeSliceCamera *tcam=0;

  int mx1, mx2, my1, my2;
  if((cam) && (cam->getBackground())) {
    TimeSliceCamera::TIME_GEOMETRY geom = cam->getGeometry();
    
    cam->getBackground()->getPixelPositionFromImageCoordinates(box[0],box[1],box[2],box[6],mx1,my1);
    cam->getBackground()->getPixelPositionFromImageCoordinates(box[3],box[4],box[5],box[7],mx2,my2);
#ifdef OLD_CODE
	tcam = cam->getInterface();

    tcam->tickle("%s delete bbox", (char *) tcam->getCanvas());
    
    if((geom == TimeSliceCamera::SLICE_X && cam->getSlice() >= box[0] &&
	cam->getSlice() <= box[3] && cam->getSecondSlice() >= box[6] &&
	cam->getSecondSlice() <= box[7]) ||
       (geom == TimeSliceCamera::SLICE_Y && cam->getSlice() >= box[1] &&
	cam->getSlice() <= box[4] && cam->getSecondSlice() >= box[6] &&
	cam->getSecondSlice() <= box[7]) ||
       (geom == TimeSliceCamera::SLICE_Z && cam->getSlice() >= box[2] &&
	cam->getSlice() <= box[5] && cam->getSecondSlice() >= box[6] &&
	cam->getSecondSlice() <= box[7]) ||
       (geom == TimeSliceCamera::SLICE_XT && cam->getSlice() >= box[1] &&
	cam->getSlice() <= box[4] && cam->getSecondSlice() >= box[2] &&
	cam->getSecondSlice() <= box[5]) ||
       (geom == TimeSliceCamera::SLICE_YT && cam->getSlice() >= box[0] &&
	cam->getSlice() <= box[3] && cam->getSecondSlice() >= box[2] &&
	cam->getSecondSlice() <= box[5]) ||
       (geom == TimeSliceCamera::SLICE_ZT && cam->getSlice() >= box[0] &&
	cam->getSlice() <= box[3] && cam->getSecondSlice() >= box[1] &&
	cam->getSecondSlice() <= box[4]))
       {
	 tcam->getModule()->tickle("%s create rectangle %u %u %u %u -outline %s -width 3 -tags bbox",
				   (char *) tcam->getCanvas(),
				   mx1, my1, mx2, my2, (char *) color);
    }
#endif
  }
}

void TclBoundingBox4D::redraw(Camera2D *cam) {
  switch(redrawFlag) {
  case Data2D::UPDATE:
    recompute(dynamic_cast<SliceCamera *>(cam));
    break;
  case Data2D::CREATION:
  case Data2D::REDRAW:
    break;
  case Data2D::DESTRUCTION:
    break;
  }
}
void TclBoundingBox4D::mouseButtonPressed(CameraTypes::WHICH_BUTTON button,
					  CameraTypes::KEY_MODIFIER modifier,
					  Camera2D *cam,int mx,int my) {
  SliceCamera *slicecam=dynamic_cast<SliceCamera *> (cam);
  if ((slicecam) && (slicecam->getBackground()))
    {
      unsigned int vx,vy,vz,vt;
      TimeSliceCamera *tcam=dynamic_cast<TimeSliceCamera *>(slicecam);
      if (tcam)
	{
	  tcam->getBackground()->getImageCoordinates(mx,my,vx,vy,vz,vt);
	  setClosestFace(tcam->getGeometry(), vx, vy, vz,vt);      
	}
    }
}
void TclBoundingBox4D::mouseButtonMoved(Camera2D *cam,int mx,int my) {
  SliceCamera *slicecam=dynamic_cast<SliceCamera *> (cam);
  if ((slicecam) && (slicecam->getBackground()))
    {
      unsigned int vx,vy,vz,vt;
      TimeSliceCamera *tcam=dynamic_cast<TimeSliceCamera *>(slicecam);
      if (tcam)
	{
	  tcam->getBackground()->getImageCoordinates(mx,my,vx,vy,vz,vt);
	  moveFace(vx, vy, vz,vt);      
	}
    }
}
void TclBoundingBox4D::mouseButtonReleased(CameraTypes::WHICH_BUTTON button,
					   CameraTypes::KEY_MODIFIER modifier,
					   Camera2D *cam,int mx,int my) {
  SliceCamera *slicecam=dynamic_cast<SliceCamera *> (cam);
  if ((slicecam) && (slicecam->getBackground()))
    {
      unsigned int vx,vy,vz,vt;
      TimeSliceCamera *tcam=dynamic_cast<TimeSliceCamera *>(slicecam);
      if (tcam)
	{
	  tcam->getBackground()->getImageCoordinates(mx,my,vx,vy,vz,vt);
	  releaseFace();      
	}
    }
}
int TclBoundingBox4D::destroyCmd(int argc, char **argv) {
  TclModule *m;
  unsigned int ref;

  if(argc != 0) return COMMAND_SYNOPSIS;
  m = getModule();
  ref = TclObject::getRef();
  TclString oname=TclBoundingBox4D::getObjectName();
  delete this;
  m->setResult("%s%u", (char *) oname, ref);
  return TCL_OK;
}
int TclBoundingBox4D::boxSizeCmd(int argc, char **argv) {

  if(argc != 1) return COMMAND_SYNOPSIS;
  if (!strcmp(argv[0],"-org"))
    {
      setResult("%u %u %u %u",box[0],box[1],box[2],box[6]);
      return TCL_OK;
    }
  else if (!strcmp(argv[0],"-end"))
    {
      setResult("%u %u %u %u",box[3],box[4],box[5],box[7]);
      return TCL_OK;
    }
  else return COMMAND_SYNOPSIS;
}

int TclBoundingBox4D::create(TclModule *m, int argc, char **argv) {
  int i;

  if (argc<2)
    return COMMAND_SYNOPSIS;

  TclTimeSliceCamera *slicecam=(TclTimeSliceCamera *)
    TclObjectKind::getObject(typeid(TclTimeSliceCamera), argc, argv, 1);
  if (!slicecam)
    {
      m->setResult("%s is not a time slice camera",argv[1]);
      return TCL_ERROR;
    }


  unsigned int x1,y1,z1,t1;
  x1=y1=z1=t1=0;
  unsigned int x2,y2,z2,t2;
  if (slicecam->getClient()->getBackground())
    {
      const unsigned int *v = slicecam->getClient()->getBackground()->getVisibleArea();
      x1=v[0];
      y1=v[1];
      z1=v[2];
      t1=v[6];
      x2=v[3];
      y2=v[4];
      z2=v[5];
      t2=v[7];
    }
  else
    {
      x2=y2=z2=t2=1;
    }
  TclString color="green";
  TclString menu="graphics2D::viewerVisibleMenu";
  

  for(i=2; i < argc; i++) {
    if(!strcmp(argv[i], "-area")) {
      if( (i+8) >= argc) return COMMAND_SYNOPSIS;
      ++i;
      x1=(unsigned int) atoi(argv[i++]);
      y1=(unsigned int) atoi(argv[i++]);
      z1=(unsigned int) atoi(argv[i++]);
      t1=(unsigned int) atoi(argv[i++]);
      x2=(unsigned int) atoi(argv[i++]);
      y2=(unsigned int) atoi(argv[i++]);
      z2=(unsigned int) atoi(argv[i++]);
      t2=(unsigned int) atoi(argv[i++]);
    }
    else if(!strcmp(argv[i], "-color")) {
      if( ++i >= argc) return COMMAND_SYNOPSIS;
      color=argv[i];
    }
    else if(!strcmp(argv[i], "-menu")) {
      if( ++i >= argc) return COMMAND_SYNOPSIS;
      menu=argv[i];
    }
    else return COMMAND_SYNOPSIS;
  }

  TclBoundingBox4D *bbox = new TclBoundingBox4D(m,slicecam->getScene(),x1,y1,
						z1,t1,x2,y2,z2,t2,color,menu);
  m->setResult("%s%u", bbox->getObjectName(), bbox->TclObject::getRef());
  return TCL_OK;
}


} // namespace yav


