#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif



#pragma implementation "graphics2D/TclScene2D.h"
#pragma implementation "graphics/TclSceneObject.h"
#pragma implementation "graphics/TclScene.h"
#include <basics/Constants.h>
#include <graphics/TclSceneObject.h>
#include <graphics2D/TclScene2D.h>

namespace yav {

TclScene2D::TclScene2D(TclModule *m)
  : TclScene<Scene2D, TclScene2D, Data2D,  Camera2D,TclCamera2D>(typeid(TclScene2D), new Scene2D(), m) {
  getClient()->setInterface(this);
#ifndef WIN32
  aDisplay=0;
#endif
  done(typeid(TclScene2D));
}

TclScene2D *TclScene2D::getDefaultScene(TclModule *m) {
  TclObjectKind *kind = TclObjectKind::findByKind(typeid(TclScene2D));
  if(kind->getFirstObject()) return (TclScene2D *) kind->getFirstObject();
  else return new TclScene2D(m);
}


TclScene2D::~TclScene2D() {

  deleted(typeid(TclScene2D));
}

int TclScene2D::destroyCmd(int argc, char **argv) {
  //unsigned int u = getRef();
  TclModule *m = getModule();
  if(argc > 0) return COMMAND_SYNOPSIS;
  TclString n=name();
  delete this;
  m->setResult("%s does not exist any longer",(char*)n);
  return TCL_OK;
}


int TclScene2D::loadCmd(int argc, char **argv) {
  if(argc != 1) return COMMAND_SYNOPSIS;
  if(TclScene2D::read(argv[0])) {
    setResult("one object added in scene %s%u",
	      TclScene2D::getObjectName(), getRef());
#ifdef GRAPHICS
    getClient()->redraw();
#endif
  }
  else
    setResult("load error");
  return TCL_OK;
}

int TclScene2D::objectsCmd(int argc, char **argv) {
  return TclScene<Scene2D,TclScene2D, Data2D,  Camera2D,TclCamera2D>::objectsCmd(argc, argv);
}
int TclScene2D::deformableCmd(int argc, char **argv) {
  return TclScene<Scene2D,TclScene2D, Data2D,  Camera2D,TclCamera2D>::deformableCmd(argc, argv);
}


int TclScene2D::cameraCmd(int argc, char **argv) {
  if(argc > 0) return COMMAND_SYNOPSIS;
  TclString output;
  Client  *c;
  ObjectsList<Camera2D>::iterator it=getClient()->firstCamera();
  for(; it!=getClient()->lastCamera(); it++) {
    c= dynamic_cast<Client *>(*it);
    if (c)
      {
	Interface *i = c->getInterface();
	if(i) {
	  output += dynamic_cast<TclObject *>(i)->name();
	  output += SPACE_STRING;
	}
      }
  }
  setResult(output);
  return TCL_OK;
}

int TclScene2D::iterationCmd(int argc, char **argv) {
  return TclScene<Scene2D,TclScene2D, Data2D,  Camera2D,TclCamera2D>::iterationCmd(argc, argv);
}


int TclScene2D::computationCmd(int argc, char **argv) {
  return TclScene<Scene2D,TclScene2D, Data2D,  Camera2D,TclCamera2D>::computationCmd(argc, argv);
}

#ifdef GRAPHICS
int TclScene2D::redrawCmd(int argc, char **argv) {
  if(argc > 0) return COMMAND_SYNOPSIS;
  getClient()->redraw();
  setResult("%s%u redrawn", TclScene2D::getObjectName(), getRef());
  return TCL_OK;
}
#endif


#ifdef GRAPHICS
int TclScene2D::focusCmd(int argc, char **argv) {
  if(argc > 0) return COMMAND_SYNOPSIS;
  getClient()->focus();
  setResult("focused on %s%u", TclScene2D::getObjectName(), getRef());
  return TCL_OK;
}
#endif



int TclScene2D::create(TclModule *m, int argc, char **argv) {
  TclScene2D *scn;

  if(argc != 1) return COMMAND_SYNOPSIS;

  scn = new TclScene2D(m);
  m->setResult("%s%u", scn->getObjectName(), scn->getRef());

  return TCL_OK;
}


} // namespace yav
