#ifndef CAMERA2DACTIVATION_H
#define CAMERA2DACTIVATION_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#include <graphics2D/Camera2D.h>

namespace yav {

class Camera2D;

/** a class that handles the autorotation of a camera or an object */
class Camera2DActivation : public Activable {
protected:
	Camera2D *camera;
public:
/** Creates a new camera. The camera visualize given scene. If scn is 0
@param cam the scene where the camera should look at. If scn is 0 the
camera visualize the first scene in global scene list (if any) or a
	new scene is created */
	Camera2DActivation(Camera2D *cam):camera(cam) {
	}
	
	/** @name destructor */
	//@{
	/// empty
	virtual ~Camera2DActivation(){}
	//@}
	
	/// starts the automotion of the camera
	virtual void startAutoMotion(){
		Activable::on();
	}
	/// stop the automotion of the camera
	virtual void stopAutoMotion(){
		Activable::off();
	}
	/// callback function when the object is activated
    // virtual void activation(){}
	///  function for redrawing the camera
	virtual void redraw(){}

	///  function for setting the OpenGL context
	virtual void setContext(){}

    /** function that forces the camera to change its size
	it must be handled at the GUI level */ 
	virtual void resize(const unsigned int width, const unsigned int height){}
};
}

#endif
