#ifndef TCLBASICCAMERABACKGROUND_H
#define TCLBASICCAMERABACKGROUND_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma interface "graphics2D/TclBasicCameraBackground.h"

#include <graphics2D/BasicCameraBackground.h>
#include <modules/TclObject.h>


namespace yav {

	class TclCamera2D;

/** \class BasicCameraBackground
    \ingroup Graphics2D
    \brief A single image Background on a 2D camera */
class TclBasicCameraBackground : public BasicCameraBackground, public TclObject {
public:
	/** @name constructor */
  //@{
	 /** constructor based an image filename
	 @param cam the camera associated with this background
	  @param filename the name of an SGI format image */ 
  TclBasicCameraBackground(TclCamera2D *cam,const char *filename);
/** constructor based an image buffer
	 @param cam the camera associated with this background
	  @param b a buffer of integer 
	  @param nr the number of rows
	  @param nc the number of columns
	  @param f the format of the input image */ 
  TclBasicCameraBackground(TclCamera2D *cam,unsigned int *b, const unsigned int nr, const unsigned int nc,
	    Format f=TEXTURE_RGBA);
  //@}

  /** @name destructor */
  //@{
  virtual ~TclBasicCameraBackground();
  //@}
 
  
  /// -destroy option
  int destroyCmd(int argc, char **argv);
  /// new TCL command callback
  static int create(TclModule *m, int argc, char **argv);
};

}

#endif
