#ifndef TCLCAMERA2DACTIVATION_H
#define TCLCAMERA2DACTIVATION_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#include <graphics2D/Camera2DActivation.h>

namespace yav {


/** a class that handles the autorotation of a camera or an object */
class TclCamera2DActivation : public Camera2DActivation {
public:
/** Creates a new camera. The camera visualize given scene. If scn is 0
	@param cam the scene where the camera should look at. If scn is 0 the camera visualize the first scene in global scene list (if any) or a new scene is created */
    TclCamera2DActivation(Camera2D *cam): Camera2DActivation(cam) {}
    
    /** @name destructor */
    //@{
    /// empty
    virtual ~TclCamera2DActivation(){}
    //@}
    
    /// callback function when the object is activated
     virtual void activation();
     ///  function for redrawing the camera
     virtual void redraw();
	 	///  function for setting the OpenGL context
	virtual void setContext();
	 /** function that forces the camera to change its size */
	virtual void resize(const unsigned int width, const unsigned int height);
  
};
}

#endif
