#ifndef TCLSURFACEVIEW_H
#define TCLSURFACEVIEW_H

#pragma interface "graphics2D/TclSurfaceView.h"
#include <graphics2D/SurfaceView.h>
#include <graphics2D/TclScene2DObject.h>
#include <graphics2D/TclScene2D.h>


namespace yav {


/** \class TclSurfaceView
    \ingroup Graphics2D
    \brief SurfaceView Tcl interface */
class TclSurfaceView : public TclScene2DObject {
 public:
  /** @name constructors */
  //@{
  /** builds object client from an inrimage then this interface
      @param m module this object is built in
      @param scene scene to build client in 
      @param _mesh a surface mesh displayed by the object SurfaceView */
  TclSurfaceView(TclModule *m, TclScene2D *scene, SurfaceSliceable *_mesh);
  //@}

  /** @name destructor */
  //@{
  /// destroys a surface View interface
  virtual ~TclSurfaceView();
  //@}
  
  /// returns client
  SurfaceView *getClient() const {
    return((SurfaceView *)client);
  }

  /// raise ambigous list() function call
  static int list(TclModule *m, int argc, char **argv) {
    return TclObject::list(m, argc, argv);
  }
  /// TCL object creation function
  static int create(TclModule *m, int argc, char **argv);
  
  /// command for listing all surface sliceables
  static int surfaceSliceablesCmd(TclModule *m,int argc, char **argv);
  /// -destroy TCL option
  int destroyCmd(int argc, char **argv);
  /// -scene TCL option
  int sceneCmd(int argc, char **argv);
  /// -interactionMode TCL option
  int interactionModeCmd(int argc, char **argv);
  /// -color TCL option
  int colorCmd(int argc, char **argv);
  /// -width TCL option
  int widthCmd(int argc, char **argv);
  /// -mesh TCL option
  int meshCmd(int argc, char **argv);
  /// -useZonesColor TCL option
  int useZonesColorCmd(int argc, char **argv);
};


} // namespace yav


#endif
