#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "graphics3D/ClippingPlane.h"
#include <graphics3D/ClippingPlane.h>

namespace yav {



ClippingPlane::ClippingPlane(unsigned int _index,double z)
  : Plane(), index(_index), active(true), moving (false) {
  
  equation[3] = z;
  //-cam->getRefCenter().getZ();
}


ClippingPlane::ClippingPlane(unsigned int _index, const GLdouble *eqn)
  : Plane(eqn), index(_index), active(true) , moving (false){
}


ClippingPlane::ClippingPlane(unsigned int _index, const Vec3<double>& P,
			     const Vec3<double>& n)
  : Plane(P, n), index(_index), active(true), moving (false) {
}

ClippingPlane::~ClippingPlane() {
  glDisable(getIndex());    
}


void ClippingPlane::enable(void) {
  active = true;
}


void ClippingPlane::disable(void) {
  active = false;
  glDisable(index);
}


void ClippingPlane::setEquation(const GLdouble *eqn) {
  Plane::setEquation(eqn);
}


void ClippingPlane::setEquation(const Vec3<double>& P, const Vec3<double>& n) {
  Plane::setEquation(P, n);  
}

void ClippingPlane::translate(const Vec3<double>& t) {
  Plane::translate(t);
}


void ClippingPlane::rotate(const Rotation3D& r) {
  Plane::rotate(r);
}


void ClippingPlane::rotate(const Rotation3D& r, const Vec3<double>& P) {
  Plane::rotate(r, P);

}


void ClippingPlane::putInCamera(void) const {
  if(active) {
    glClipPlane(index, equation);
    glEnable(index);
  }
}

} // namespace yav

