#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif
#pragma implementation "graphics3D/ForceFeedbackInterface3D.h"

#include <graphics3D/ForceFeedbackInterface3D.h>


namespace yav {


LaparoscopicInterface3D::LaparoscopicInterface3D(Scene3D *scene,double l, double r,double gl, double gw): UserInterface3D (scene),coordScale(1),length(l) {
  if(r>=0) LIEradius = r;
  else LIEradius = l*0.015;
  if(gl>=0) gripperLength = gl;
  else gripperLength = l*0.04;
  if(gw>=0) gripperWidth = gw;
  else gripperWidth = LIEradius/2.0;

  forceScale=1.0;
}

PhantomInterface3D::PhantomInterface3D(Scene3D *scene, double sl, double sr, double tl, double tr): UserInterface3D (scene) {
  CERR << coordScale << "W'sldkg;lsdg;lsdkg;lskdg;sldkarning: If you see this, edit PhantomInterface3D::PhantomInterface3D(...)\n";

  stylusLength  = sl;
  stylusRadius  = sr;
  tipLength     = tl;
  tipRadius     = tr;
  phantomLength = sl + tl;
  phantomRadius = (sr > tr)? sr : tr;
  forceScale    = 1.0;

  coordScale    = 1.0;

  // DEBUG
  // Apparently this function is never executed and coordScale is never initalized.
  // Therfore it is re-initialized in DirectPhantom::DirectPhantom(...)
  // Nonetheless the other parameters are initialized, somewhere else...
  // If ever the CERR below is executed, adjust things.
  CERR << coordScale << "Warning: If you see this, edit PhantomInterface3D::PhantomInterface3D(...)\n";

}


} // namespace yav

