#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "graphics3D/Grid.h"
#include <graphics3D/Grid.h>
#include <GL/gl.h>
#include <GL/glu.h>
namespace yav {

Grid::Grid(CameraOGL *_cam){
  cam = _cam;
  axis = Z;
  center.setValue(0.0,0.0,0.0);
  nLines = 20;
  size = 1000.0;
  col.setColor(1.0,1.0,1.0,1.0); 
  lineWidth=1.0;
}
  
void Grid::setProperties(NORMAL_AXIS _axis,Vec3<double> _center,int _nLines,double _size,double colorR,double colorG,double colorB,double _lineWidth){
axis = _axis;
center=_center;
nLines=_nLines;
size=_size;
col.setColor((GLfloat)colorR,(GLfloat)colorG,(GLfloat)colorB);
lineWidth=_lineWidth;
}
  

void Grid::redraw(){
  int i = 0;
  Vec3<double> stepX(size / ((double)(nLines-1)),0.0,0.0);
  Vec3<double> stepY(0.0,size / ((double)(nLines-1)),0.0);
  Vec3<double> endX(-size/2.0,size/2,0.0);
  Vec3<double> endY(size/2.0,-size/2.0,0.0); 
  Vec3<double> orgX = Vec3<double>(-size/2.0,-size/2.0,0.0);
  Vec3<double> orgY = orgX;
  glLineWidth((GLfloat)lineWidth);
  glDisable(GL_LIGHTING);  
  col.glSet();
  glPushMatrix();  
  if(axis==X){
    glRotatef(90.0,0.0,1.0,0.0);
  }
  if(axis==Y){
    glRotatef(90.0,1.0,0.0,0.0);  
  }
  glBegin(GL_LINES);
  for(;i<nLines;i++){
    glVertex3dv((const double *) orgX);
    glVertex3dv((const double *) endX);
    glVertex3dv((const double *) orgY);
    glVertex3dv((const double *) endY);    
    orgX+=stepX;
    orgY+=stepY;
    endX+=stepX;
    endY+=stepY;
  } 
  glEnd();
  glPopMatrix();
  glEnable(GL_LIGHTING);
}

} // namespace yav

