#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "graphics3D/PickingObject.h"
#include <graphics3D/PickingObject.h>




namespace yav {




int PickingObject::doPicking(GLuint displayList, const Vec2<double> &pixel, 
			     Camera3D *cam, double areaSize)
{
  GLint viewport[4];
  GLuint hits;
  int selectedRef= -1;
  GLuint z, zmin = 0;
  glGetIntegerv(GL_VIEWPORT,viewport);
      
  glSelectBuffer(_pickingBufferSize,pickingBuffer);
  (void) glRenderMode(GL_SELECT);

  cam->applyTransformation();  
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  gluPickMatrix((GLdouble)pixel.getX(),(GLdouble)(viewport[3]-pixel.getY()),
		areaSize,areaSize,viewport); 
  glScaled(cam->getScale(), cam->getScale(), 1);
#ifdef _ALPHA_
  gluPerspective(cam->getFieldOfView()/cam->getScale(), (GLfloat) cam->getWidth()/(GLfloat) cam->getHeight(), 1e-3*cam->getRadius(),10*cam->getRadius());
#else
  gluPerspective(cam->getFieldOfView()/cam->getScale(), (GLfloat) cam->getWidth()/(GLfloat) cam->getHeight(), fabs((cam->getFieldDepthRatio()-2.0))*cam->getRadius(),10*cam->getRadius());
#endif
  glMatrixMode(GL_MODELVIEW);  

 

  glCallList(displayList);
  

  glPopMatrix();
  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glFlush();
  glMatrixMode(GL_MODELVIEW);
  
  hits=glRenderMode(GL_RENDER);
  //  cerr << " number of hits "<< hits << endl;
  
  GLuint *ptr=pickingBuffer;
  for (unsigned int i=0;i<hits;i++) {
    //    cerr << " nb of names " << names << endl;
    ptr++; 
    //    cerr << "first Info " << *ptr++ << endl;
    z=*ptr; ptr++;
    //    cerr << "second Info " << *ptr++ << endl;
    ptr++;
    //    cerr << " name of triangle " << *ptr << endl;
    if ((selectedRef== -1) || (z<zmin))
      {
	selectedRef=*ptr;
	zmin=z;
      }
    ptr++;
  }
  return(selectedRef);
}


}


