#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "graphics3D/TclMaterialSphere.h"
#include <graphics3D/TclMaterialSphere.h>


namespace yav {





TclMaterialSphere::TclMaterialSphere(const std::type_info& id,
				     MaterialSphere *ms, TclModule *m)
  : TclScene3DObject(id, ms, m) {
  TclObject::done(typeid(TclMaterialSphere));
}


TclMaterialSphere::TclMaterialSphere(TclModule *m, TclScene3D *scene)
  : TclScene3DObject(typeid(TclMaterialSphere),
		     new MaterialSphere(scene->getClient()), m) {
  done(typeid(TclMaterialSphere),
       "graphics3D::installSphereMenu", "graphics3D::uninstallSphereMenu");
}


TclMaterialSphere::~TclMaterialSphere() {
  deleted(typeid(TclMaterialSphere));
}


int TclMaterialSphere::destroyCmd(int argc, char **argv) {
  if(argc > 0) return COMMAND_SYNOPSIS;

  TclModule *m = getModule();
  TclString n=name();
  delete this;
  m->setResult("%s does not exist any longer",
	       (char *) n);
  return TCL_OK;
}


int TclMaterialSphere::radiusCmd(int argc, char **argv) {
  if(argc > 1) return COMMAND_SYNOPSIS;
  if(argc == 1) {
    double radius;

    if(sscanf(argv[0], "%lf", &radius) != 1) return COMMAND_SYNOPSIS;
    getClient()->setRadius(radius);
  }

  setResult("%f", getClient()->getRadius());
  return TCL_OK;
}


int TclMaterialSphere::create(TclModule *m, int argc, char **argv) {
  TclScene3D *scene = 0;

  if(argc != 1 && argc != 3) return COMMAND_SYNOPSIS;
  if(argc == 3) {
    if(strcmp(argv[1], "-scene")) return COMMAND_SYNOPSIS;
    scene = (TclScene3D *) TclObjectKind::getObject(typeid(TclScene3D), argc, argv, 2);
  } else {
    scene = TclScene3D::getDefaultScene(m);
  }
  if(!scene) return TCL_ERROR;

  TclMaterialSphere *sphere =  new TclMaterialSphere(m, scene);
  m->setResult("%s%u",
	       TclObjectKind::getObjectName(typeid(TclMaterialSphere)),
	       sphere->getRef());
  return TCL_OK;
}


} // namespace yav

