#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "graphics3D/TclRectangle3D.h"
#include <graphics3D/TclRectangle3D.h>
#include <graphics3D/TclTexture2D.h>
#include <graphics3D/TclCamera3D.h>
#include <graphics3D/TclScene3D.h>
#include <graphics3D/Texture2D.h>

namespace yav {


TclRectangle3D::TclRectangle3D(TclScene3D *scene,const Vec3<double> &p1,
			       const Vec3<double> &p2, const Vec3<double> &v1,
			       const Vec3<double> &v2) :   TclScene3DObject(typeid(TclRectangle3D), new Rectangle3D(scene->getClient(),p1,p2,v1,v2), scene->getModule()) {
 done( typeid(TclRectangle3D),"graphics3D::installRectangle3DMenu","graphics3D::uninstallRectangle3DMenu");
}
TclRectangle3D::~TclRectangle3D() {
 
}
int TclRectangle3D::renderOptionCmd(int argc, char **argv) {

  if(argc > 0) 
    return COMMAND_SYNOPSIS;
  else
    return getClient()->renderOptionCmd(getModule(), (Data3D *) client, argc, argv);
}
int TclRectangle3D::scaleCmd(int argc, char **argv) {
  if(argc !=1) 
    return COMMAND_SYNOPSIS;
  else{
    double s;
    if(sscanf(argv[0],"%lf",&s)!=1) return COMMAND_SYNOPSIS;
    getClient()->scale(s);
  }
  return TCL_OK;
}
int TclRectangle3D::flipNormalsCmd(int argc, char **argv) {
  if(argc ==0) {
    getClient()->flipNormals();
    getClient()->redrawScene();
    return TCL_OK;
  }
  else
    return COMMAND_SYNOPSIS;
}
int TclRectangle3D::texture2DOptionCmd(int argc, char **argv) {
  return getClient()->texture2DOptionCmd(getModule(), (Data3D *) client, argc, argv);
}
int TclRectangle3D::texture1DOptionCmd(int argc, char **argv) {
  return getClient()->texture1DOptionCmd(getModule(), (Data3D *) client, argc, argv);
}
int TclRectangle3D::highlightTextureCmd(int argc, char **argv) {
  return getClient()->highlightTextureCmd(getModule(), (Data3D *) client, argc, argv);
}
int TclRectangle3D::texture2DCmd(int argc, char **argv) {
  return getClient()->texture2DCmd(getModule(), (Data3D *) client, argc, argv);
}
int TclRectangle3D::texture1DCmd(int argc, char **argv) {
  return getClient()->texture1DCmd(getModule(), (Data3D *) client, argc, argv);
}
int TclRectangle3D::textureScaleCmd(int argc, char **argv) {
  if (argc==0)
    {
      double s,t;
      getClient()->getTextureScale(s,t);
      setResult("%f %f",s,t);
      return TCL_OK;
    }
  else if (argc==2)
    {
      double s=(double) atof(argv[0]);
      double t=(double) atof(argv[1]);
      getClient()->setTextureScale(s,t);
      getClient()->getTextureScale(s,t);
      getClient()->surfaceChanged();
      setResult("%f %f",s,t);
      return TCL_OK;
    }
  else
    return COMMAND_SYNOPSIS;
}
int TclRectangle3D::colorCmd(int argc, char **argv) {
int res;
 
 if(argc > 0) {
   res=getClient()->colorCmd(getModule(),
			     (Data3D *) client, argc, argv);
   
   if(res != TCL_OK) return res;
   else
     return TCL_OK;
 }
 else
   return getClient()->colorCmd(getModule(),
				(Data3D *) client, argc, argv);
}
int TclRectangle3D::materialCmd(int argc, char **argv) {
  int res;

  if(argc > 0) {
    res = getClient()->materialCmd(getModule(),
				   (Data3D *) client, argc, argv);
    if(res != TCL_OK) return res;
    else
      return TCL_OK;
  }
  else
    return getClient()->materialCmd(getModule(),
				    (Data3D *) client, argc, argv);
}
int TclRectangle3D::renderCmd(int argc, char **argv) 
{
  int res;

  if(argc > 0) {
    res = getClient()->renderCmd(getModule(), (Data3D *) client, argc, argv);
    if(res != TCL_OK) return res;
    else
      {
	getClient()->redrawScene();
	return TCL_OK;
      }
  }
  else
    return getClient()->renderCmd(getModule(), (Data3D *) client, argc, argv);
}
int TclRectangle3D::directionCmd(int argc, char **argv) {
  if (argc!=1)
    return COMMAND_SYNOPSIS;
  else
    {
      if (!strcmp(argv[0],"X")) {
	Vec3<double> t=getClient()->getVertex(1)-getClient()->getVertex(0);
	t/=t.norm();
	setResult("%f %f %f %f",t.getX(),t.getY(),t.getZ(),-dot<double>(t,getClient()->getVertex(0)));
	return TCL_OK;
      }
      else if (!strcmp(argv[0],"Y")) {
	Vec3<double> t=getClient()->getVertex(3)-getClient()->getVertex(0);
	t/=t.norm();
	setResult("%f %f %f %f",t.getX(),t.getY(),t.getZ(),-dot<double>(t,getClient()->getVertex(0)));
	return TCL_OK;
      }
      else {
	setResult("%s must be X or Y",argv[0]);
	return TCL_ERROR;
      }
    }
}
int TclRectangle3D::coordinateCmd(int argc, char **argv) {
  if (argc!=1)
    return COMMAND_SYNOPSIS;
  else
    {
      if (!strcmp(argv[0],"X")) {
	Vec3<double> t=getClient()->getVertex(1)-getClient()->getVertex(0);
	t/=t.norm2();
	setResult("%f %f %f %f",t.getX(),t.getY(),t.getZ(),-dot<double>(t,getClient()->getVertex(0)));
	return TCL_OK;
      }
      else if (!strcmp(argv[0],"Y")) {
	Vec3<double> t=getClient()->getVertex(3)-getClient()->getVertex(0);
	t/=t.norm2();
	setResult("%f %f %f %f",t.getX(),t.getY(),t.getZ(),-dot<double>(t,getClient()->getVertex(0)));
	return TCL_OK;
      }
      else {
	setResult("%s must be X or Y",argv[0]);
	return TCL_ERROR;
      }
    }
}
int TclRectangle3D::pointCmd(int argc, char **argv) 
{
  if (argc==1)
    {
      unsigned int i=(unsigned int) atoi(argv[0]);
      if (i>3)
	{
	  setResult("%s must be between 0 and 3",argv[0]);
	  return TCL_ERROR;
	}
      else
	{
	  Vec3<double> p=getClient()->getVertex(i);
	  setResult("%f %f %f",p[0],p[1],p[2]);
	  return TCL_OK;
	}
    }
  else
    return COMMAND_SYNOPSIS;
}
int TclRectangle3D::destroyCmd(int argc, char **argv) 
{
  if (argc>0)
    return COMMAND_SYNOPSIS;
  else
    {
      TclString n=name();
      TclModule *m = getModule();
      delete this;
      m->setResult("%s does not exist any longer",
		   (char *)n);
      return TCL_OK;
    }
}
int TclRectangle3D::create(TclModule *m, int argc, char *argv[]) {
  TclScene3D *scn = 0;
  TclRectangle3D *t;
  
  if (argc==3)
    {
      TclCamera3D *cam= (TclCamera3D *)
	TclObjectKind::getObject(typeid(TclCamera3D), argc, argv, 2);
      if (!cam) {
	m->setResult("Illegal camera name : %s",argv[2]);
	return TCL_ERROR;
      }
      scn= cam->getScene();
      Vec2<double> pixel[4];
      pixel[0]=Vec2<double>(cam->getClient()->getWidth()*0.1,
	       cam->getClient()->getHeight()*0.1); 
      pixel[1]=Vec2<double>(cam->getClient()->getWidth()*0.9,
	       cam->getClient()->getHeight()*0.1); 
      pixel[2]=Vec2<double>(cam->getClient()->getWidth()*0.9,
	       cam->getClient()->getHeight()*0.9); 
      pixel[3]=Vec2<double>(cam->getClient()->getWidth()*0.1,
	       cam->getClient()->getHeight()*0.9); 
      Vec3<double> p[4];
      for(unsigned int i=0;i<4;++i)
	p[i]=cam->getClient()->getMousePosition(pixel[i]);
      Vec3<double> v1,v2;
      v1=p[1]-p[0];
      v2=p[3]-p[0];
     t= new TclRectangle3D(scn,p[0],p[2],v1,v2);
     m->setResult("%s",(char *)t->name());
     return TCL_OK;
    }
  else if (argc==15)
    {
      scn= (TclScene3D *)
	TclObjectKind::getObject(typeid(TclScene3D), argc, argv, 2);
      if(!scn) {
	m->setResult("Illegal scene name : %s",argv[2]);
	return TCL_ERROR;
      }
      Vec3<double> p[4];
      unsigned int i,j,k;
      for (k=0,j=0,i=0;i<12;++i,k++)
	{
	  double v=(double) atof(argv[i+3]);
	  p[j][(int)k%3]=v;
	  if (k%3==2)
	    j++;
	}
      Vec3<double> v1,v2;
      v1=p[1]-p[0];
      v2=p[3]-p[0];
      t= new TclRectangle3D(scn,p[0],p[2],v1,v2);
      m->setResult("%s",(char *)t->name());
      return TCL_OK;
    }
  else return COMMAND_SYNOPSIS;
}

}

