#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "graphics3D/TclTexture2D.h"
#include <graphics3D/TclTexture2D.h>


namespace yav {


TclTexture2D::TclTexture2D(TclModule *m,unsigned int *b, 
			   const unsigned int nr, const unsigned int nc,
			   Format f) : Texture2D(b,nr,nc,f), 
  TclObject(typeid(TclTexture2D),m) {
  done(typeid(TclTexture2D));
}
TclTexture2D::TclTexture2D(TclModule *m,char *name) : Texture2D(name), 
  TclObject(typeid(TclTexture2D),m) {
  done(typeid(TclTexture2D));
}
TclTexture2D::TclTexture2D(TclModule *m,Texture2D::GenericTexture type,
			   const unsigned int size, const double e, const double r): Texture2D(type,size,e,r), 
  TclObject(typeid(TclTexture2D),m) {
  done(typeid(TclTexture2D));
}
TclTexture2D::~TclTexture2D() {
  deleted(typeid(TclTexture2D));
}

int TclTexture2D::destroyCmd(int argc, char **argv) {
  if(argc != 0) return COMMAND_SYNOPSIS;
  TclModule *m = getModule();
  unsigned int u = getRef();
  m->setResult("%s%u does not exist any longer",
	       TclTexture2D::getObjectName(), u);
  delete this;
  return TCL_OK;
}

int TclTexture2D::create(TclModule *m, int argc, char **argv) {
  TclTexture2D *t=0;
  if(argc == 2) {
    try{
      t= new TclTexture2D(m,argv[1]);
    }catch (Exception e) {
      m->setResult("illegal texture file");
    }
  }
  else if ((argc >= 3) && (argc<=5)){
    GenericTexture type;
  
    if (!strcmp(argv[1],"checker"))
      type=CHECKER;
    else if (!strcmp(argv[1],"gaussian"))
      type=GAUSSIAN;
    else if (!strcmp(argv[1],"halo"))
      type=HALO;
    else
      {
	m->setResult("%s must be either checker or gaussian or halo",argv[1]);
	return TCL_ERROR;
      }
    try{
      if (argc==3)
	t= new TclTexture2D(m,type,(unsigned int) atoi(argv[2]));
      else {
	double val=(double) atof(argv[3]);
	if (argc==4)
	  t= new TclTexture2D(m,type,(unsigned int) atoi(argv[2]),val);
	else 
	  t= new TclTexture2D(m,type,(unsigned int) atoi(argv[2]),val,(double) atof(argv[4]));
      }
    }catch (Exception e) {
      m->setResult("illegal texture file");
    }
  }
  else
    return COMMAND_SYNOPSIS;
  m->setResult(t->name());
  return TCL_OK;
}
void TclTexture2D::createCommands(TclModule *m) 
{
	 TclObjectKind *kind;
 kind = new TclObjectKind(m, typeid(TclTexture2D), "text2D","2D Texture","filename=%s|[checker|halo|gaussian] %u [%f] [%f]",
			   &TclTexture2D::create, &TclTexture2D::list);
  kind->newOption("-destroy", (TclObject::OPTION) &TclTexture2D::destroyCmd, 0,
		  "destroy a 2D texture");


}
}


