#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "graphics3D/Texture1D.h"
#include <graphics3D/Texture1D.h>
#include <graphics3D/Texture2D.h>
#include <math.h>
#include <cstring>
#include <cstdlib>


namespace yav {


  void Texture1D::enlargeTexture(const void *bb, 
    const unsigned int nc) {
      unsigned int i;
      for(i=1;i<nc;i*=2);
      ncols=i;
      nbRealColumns=nc;

      if (format==TEXTURE_RGBA)
      {
        const unsigned int *b=( unsigned int *) bb;
        buffer=new unsigned int[ncols];
        /// put 0 in the image
        memset((void *) buffer,0,ncols*sizeof(unsigned int));
        // copy buffer
        memcpy((void *)buffer,(void *) b,nc*sizeof(unsigned int));

      }
      else if (format==TEXTURE_LUMINANCE) {
        const unsigned char *b=( unsigned char *) bb;
        buffer=new unsigned char[ncols];
        /// put 0 in the image
        memset((void *) buffer,0,ncols*sizeof(unsigned char));
        // copy buffer
        memcpy((void *)buffer,(void *) b,nc*sizeof(unsigned char));
      }
    }

    Texture1D::Texture1D(GenericTexture t, const unsigned int size) : binded(false), textureType(t) {

      unsigned int i,s;
      for(i=1;i<size;i*=2);
      ncols= i;
      s=i;
      nbRealColumns=size;
      format=TEXTURE_RGBA;
      buffer= (void *)new unsigned int[s];

      drawGenericTexture(t);
      init();
    }

    void Texture1D::drawGenericTexture(GenericTexture t) {
      if (format==TEXTURE_RGBA) {
        if (t==Texture1D::TEMPERATURE) {
          unsigned int *b = (unsigned int *) buffer;
          unsigned int i;
          unsigned char *p;
          for(i=0;i<ncols/2;++i,b++) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)(255*2*i/ncols);
            p[1]=(unsigned char)(128+255*i/ncols);
            p[2]=(unsigned char)(255-255*2*i/ncols);
            p[3]=0;
          }
          for(i=0;i<ncols/2;++i,b++) {
            p=(unsigned char *)b;
            p[0]=255;
            p[1]=(unsigned char)(255-255*2*i/ncols);
            p[2]=0;
            p[3]=0;
          }
        }
 	else if(t==Texture1D::RANDOM) {
          unsigned int * b = (unsigned int *)buffer;
          unsigned int i;
          unsigned char * p;
	  srand((unsigned int) 0);
          for(i=0;i<nbRealColumns;++i,b++) {
            p = (unsigned char *)b;
            p[0] = (unsigned char)(255*((double)rand()/((double)RAND_MAX)));
            p[1] = (unsigned char)(255*((double)rand()/((double)RAND_MAX)));
            p[2] = (unsigned char)(255*((double)rand()/((double)RAND_MAX)));
            p[3] = 0;
          }
        }
        else if(t==Texture1D::TEMPERATURE_REVERSE) {
          unsigned int *b = (unsigned int *) buffer;
          unsigned int i;
          unsigned char *p;
          for(i=0;i<ncols/2;++i,b++) {
            p=(unsigned char *)b;
            p[0]=255;
            p[1]=(unsigned char)(255*2*i/ncols);
            p[2]=0;
            p[3]=0;
          }
          for(i=0;i<ncols/2;++i,b++) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)(255-255*2*i/ncols);
            p[1]=(unsigned char)(255-255*i/ncols);
            p[2]=(unsigned char)(255*2*i/ncols);
            p[3]=0;
          }
        }
        else if(t==Texture1D::BLUE2YELLOW) {
          unsigned int *b = (unsigned int *) buffer;
          unsigned int i;
          unsigned char *p;
          for(i=0;i<ncols/2;++i,b++) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)(255*2*i/ncols);
            p[1]=0;
            p[2]=(unsigned char)(255-255*2*i/ncols);
            p[3]=0;
          }
          for(i=0;i<ncols/2;++i,b++) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)255;
            p[1]=(unsigned char)(255*2*i/ncols);
            p[2]=0;
            p[3]=0;
          }
        }

        else if (t==Texture1D::HEART) {
          unsigned int *buf = (unsigned int *) buffer;
          unsigned char *pointeur;
          int Hi;
	  unsigned char r, g, b; 
          double H, f, p, q, t, R, G, B; 
          double S = 1.0; 
          double V = 1.0; 

          // On �crit la premi�re couleur r�serv�e 
          pointeur = (unsigned char *) buf;
          pointeur[0] = (unsigned char) 255; 
          pointeur[1] = (unsigned char) 255; 
          pointeur[2] = (unsigned char) 255; 
          pointeur[3] = (unsigned char) 0; 
          buf++; 

          for(unsigned int k=0;k<ncols-1;k++,buf++) { 

            // On parcourt les teintes sans changer la saturation ni la brillance 
            H = 240.0*(double)k/((double)ncols-2);   

            // Conversion des couleurs 
            Hi = (int) floor(H/60.0) % 6; 
            f = H/60.0 - Hi; 
            p = V*(1-S); 
            q = V*(1-f*S); 
            t = V*(1-(1-f)*S); 
            if(Hi==0) { R=V; G=t; B=p; }
            else if(Hi==1) { R=q; G=V; B=p; }
            else if(Hi==2) { R=p; G=V; B=t; }
            else if(Hi==3) { R=p; G=q; B=V; }
            else if(Hi==4) { R=t; G=p; B=V; }
            else { R=V; G=p; B=q; }

            // Normalisation 
            r = (unsigned char) (255*R); 
            g = (unsigned char) (255*G); 
            b = (unsigned char) (255*B); 

            // Ecriture des couleurs 
            pointeur = (unsigned char *) buf;
            pointeur[0] = (unsigned char) r; 
            pointeur[1] = (unsigned char) g; 
            pointeur[2] = (unsigned char) b; 
            pointeur[3] = (unsigned char) 0; 
          }
        }

        else if (t==Texture1D::HEART_REVERSE) {
          unsigned int *buf = (unsigned int *) buffer;
          unsigned char *pointeur;
          int Hi;
	  unsigned char r, g, b; 
          double H, f, p, q, t, R, G, B; 
          double S = 1.0; 
          double V = 1.0; 

          // On �crit la premi�re couleur r�serv�e 
          pointeur = (unsigned char *) buf;
          pointeur[0] = (unsigned char) 255; 
          pointeur[1] = (unsigned char) 255; 
          pointeur[2] = (unsigned char) 255; 
          pointeur[3] = (unsigned char) 0; 
          buf++; 

          for(unsigned int k=0;k<ncols-1;k++,buf++) { 

            // On parcourt les teintes sans changer la saturation ni la brillance 
            H = 240.0*(double)(ncols-2-k)/((double)ncols-2);   

            // Conversion des couleurs 
            Hi = (int) floor(H/60.0) % 6; 
            f = H/60.0 - Hi; 
            p = V*(1-S); 
            q = V*(1-f*S); 
            t = V*(1-(1-f)*S); 
            if(Hi==0) { R=V; G=t; B=p; }
            else if(Hi==1) { R=q; G=V; B=p; }
            else if(Hi==2) { R=p; G=V; B=t; }
            else if(Hi==3) { R=p; G=q; B=V; }
            else if(Hi==4) { R=t; G=p; B=V; }
            else { R=V; G=p; B=q; }

            // Normalisation 
            r = (unsigned char) (255*R); 
            g = (unsigned char) (255*G); 
            b = (unsigned char) (255*B); 

            // Ecriture des couleurs 
            pointeur = (unsigned char *) buf;
            pointeur[0] = (unsigned char) r; 
            pointeur[1] = (unsigned char) g; 
            pointeur[2] = (unsigned char) b; 
            pointeur[3] = (unsigned char) 0; 
          }
        }

        else if (t==Texture1D::JET) {
          unsigned int *b = (unsigned int *) buffer;
          double i, n = floor(((double) ncols)/3.0+0.5);
          unsigned char *p;
          for(i=0.0;i<n;++i,++b) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)0;
            p[1]=(unsigned char)(255.0*i/(n-1.0));
            p[2]=(unsigned char)255;
            p[3]=(unsigned char)0;
          }
          for(i=0.0;i<n;++i,++b) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)(255.0*i/(n-1.0));
            p[1]=(unsigned char)255;
            p[2]=(unsigned char)(255.0*(1.0-i/(n-1.0)));
            p[3]=(unsigned char)0;
          }      
          for(i=0.0;i<n;++i,++b) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)255;
            p[1]=(unsigned char)(255.0*(1.0-i/(n-1.0)));
            p[2]=(unsigned char)0;
            p[3]=(unsigned char)0;
          }
        }
        else if (t==Texture1D::JET_REVERSE) {
          unsigned int * b = (unsigned int *) buffer;
          double i, n = floor(((double) ncols)/3.0+0.5);
          unsigned char *p;
          for(i=0.0;i<n;++i,++b) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)255;
            p[1]=(unsigned char)(255.0*i/(n-1.0));
            p[2]=(unsigned char)0;
            p[3]=(unsigned char)0;
          }
          for(i=0.0;i<n;++i,++b) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)(255.0*(1.0-i/(n-1.0)));
            p[1]=(unsigned char)255;
            p[2]=(unsigned char)(255.0*i/(n-1.0));
            p[3]=(unsigned char)0;
          }      
          for(i=0.0;i<n;++i,++b) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)0;
            p[1]=(unsigned char)(255.0*(1-i/(n-1.0)));
            p[2]=(unsigned char)255;
            p[3]=(unsigned char)0;
          }
        }
        else if (t==Texture1D::ACTIVATION) {
          unsigned int *b=(unsigned int *)buffer;
          unsigned int i;
          unsigned char *p;
          for(i=0;i<ncols;++i,++b) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)(255*i/ncols);
            p[1]=(unsigned char)(128 + 255*i/(2*ncols));
            p[2]=(unsigned char)(255 - 255*i/ncols);
            p[3]=(unsigned char)0;
          }
        }
        else if (t==Texture1D::BRB) {
          unsigned int *b=(unsigned int *)buffer;
          unsigned int i;
          unsigned char *p;
          p=(unsigned char *)b;
          p[0]=(unsigned char)0;
          p[1]=(unsigned char)0;
          p[2]=(unsigned char)255;
          p[3]=(unsigned char)0;
          ++b;
          for(i=1;i<ncols-1;++i,++b) {
            p=(unsigned char *)b;
            p[0]=(unsigned char)255;
            p[1]=(unsigned char)0;
            p[2]=(unsigned char)0;
            p[3]=(unsigned char)0;
          }
          p=(unsigned char *)b;
          p[0]=(unsigned char)0;
          p[1]=(unsigned char)0;
          p[2]=(unsigned char)255;
          p[3]=(unsigned char)0;
        }
      }
    }

    Texture1D::Texture1D(unsigned int *b, 
      const unsigned int nc,   Texture1D::Format f) : binded(false), format(f),textureType(OTHER) {
        enlargeTexture(b,nc);
        init();
      }

      void Texture1D::init() {
        updateDisplayList=true;
      }

      Texture1D::~Texture1D() {
        if (format==TEXTURE_RGBA)
          delete [] (unsigned int *)buffer;
        else if (format==TEXTURE_LUMINANCE)
          delete [] (unsigned char *)buffer;

      }
      void Texture1D::createTexture() {
        glGenTextures(1,&id);
        binded=true;
        glBindTexture(GL_TEXTURE_1D, id);
        updateTexture();
      }
      void Texture1D::updateTexture() const {
        if (format==TEXTURE_RGBA)
          glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
        else if (format==TEXTURE_LUMINANCE)
          glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

        if (format==TEXTURE_RGBA)
          glTexImage1D(GL_TEXTURE_1D, 0, GL_RGBA, ncols, 0,
          GL_RGBA, GL_UNSIGNED_BYTE, buffer);
        else if (format==TEXTURE_LUMINANCE)
          glTexImage1D(GL_TEXTURE_1D, 0, GL_LUMINANCE, ncols, 0,
          GL_LUMINANCE, GL_UNSIGNED_BYTE, buffer);


        glBindTexture(GL_TEXTURE_1D, 0);
      }
      void Texture1D::getColor( const unsigned int col,
        unsigned char *color) const{
          unsigned char *c=(unsigned char *) buffer;
          c +=4*col;
          if (format==TEXTURE_RGBA)
          {
            color[0]=(*c); c++;
            color[1]=(*c); c++;
            color[2]=(*c); c++;
            color[3]=(*c); c++;
          }
          else
          {
            color[3]=(*c); c++;
            color[0]=(*c); c++;
            color[1]=(*c); c++;
            color[2]=(*c); c++;
          }
        }

        Texture1D::Texture1D(char *name) : binded(false){
          unsigned int nr,nc;
          unsigned int components;
          unsigned int *b=Texture2D::read_texture(name,&nc,&nr,&components); 
          format=TEXTURE_RGBA;
          enlargeTexture(b,nc);
          delete [] b;
          init();
        }


}


