#ifndef CAMERA3DACTIVATION_H
#define CAMERA3DACTIVATION_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#include <graphics3D/Camera3D.h>

namespace yav {


/** a class that handles the autorotation of a camera or an object */
class Camera3DActivation : public Activable {
protected:
	Camera3D *camera;
public:
/** Creates a new camera. The camera visualize given scene. If scn is 0
@param cam the scene where the camera should look at. If scn is 0 the
camera visualize the first scene in global scene list (if any) or a
	new scene is created */
	Camera3DActivation(Camera3D *cam):camera(cam) {
	}
	
	/** @name destructor */
	//@{
	/// empty
	virtual ~Camera3DActivation(){}
	//@}
	
	/// starts the automotion of the camera
	virtual void startAutoMotion(){
		Activable::on();
	}
	/// stop the automotion of the camera
	virtual void stopAutoMotion(){
		Activable::off();
	}
	
	///  function for redrawing the camera
	virtual void redraw(){}
		///  function for setting the OpenGL context
	virtual void setContext(){}
};
}

#endif
