#ifndef GRID_H
#define GRID_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma interface "graphics3D/Grid.h"
#include <linearAlgebra/Vec3.h>
#include <graphics3D/Color.h>
namespace yav {
class CameraOGL;

class Grid{
 public:
  typedef enum {
    X,
    Y,
    Z
  }NORMAL_AXIS;
  
 protected:  
  CameraOGL *cam;
  NORMAL_AXIS axis;
  Vec3<double> center;
  int nLines;
  double size;
  double lineWidth;
  Color col;
  public:
  Grid(CameraOGL *_cam);
  void setProperties(NORMAL_AXIS _axis,Vec3<double> _center,int _nLines,double _size,double colorR,double colorG,double colorB,double _lineWidth);
  virtual void redraw();
  virtual ~Grid() {}
};


} // namespace yav


#endif // ifdef GRID_H
