#ifndef TCLLIGHTFANTOM_H
#define TCLLIGHTFANTOM_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma interface "graphics3D/TclLightFantom.h"
#include <graphics3D/TclMaterialSphere.h>
#include <graphics3D/LightFantom.h>


namespace yav {


class TclLight;

/** \class TclLightFantom
    \ingroup Graphics3D
    \brief light fantom interface */
class TclLightFantom : public TclMaterialSphere {
 public:
  /** @name constructor */
  //@{
  /** builds a TCL interface for a light fantom
      @param light light to build fantom for 
	 @param cam camera where the fantom appears */
  TclLightFantom(Light *light, TclCamera3D *cam);
  //@}

  /** @name destructor */
  //@{
  virtual ~TclLightFantom();
  //@}

  /// returns client
  LightFantom *getClient(void) { return (LightFantom *) client; }
  
  /// -destroy TCL command
  int destroyCmd(int argc, char **argv);  
};



} // namespace yav


#include <graphics3D/TclLight.h>

#endif   // ifndef TCLLIGHTFANTOM_H
