#ifndef TCLRECTANGLE3D_H
#define TCLRECTANGLE3D_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma interface "graphics3D/TclRectangle3D.h"
#include <graphics3D/Rectangle3D.h>
#include <graphics3D/TclScene3DObject.h>


namespace yav {


/** \class TclRectangle3D
    \ingroup Graphics3D
*/
class TclRectangle3D : public TclScene3DObject {
 public:
  /** @name Constructors */
  //@{
  /** create an interface of a 3D rectangle 
      @param scene the 3D scene ehere the rectangle is stored
      @param p1 first diagonal point of the rectangle
      @param p2 first diagonal point of the rectangle
      @param v1 the direction of the first axis of the rectangle
      @param v2 the direction of the second axis of the rectangle */
  TclRectangle3D(TclScene3D *scene,const Vec3<double> &p1,
		 const Vec3<double> &p2, const Vec3<double> &v1,
		 const Vec3<double> &v2); 
  //@}

  /** @name destructor */
  //@{
  /// destroys display list
  virtual ~TclRectangle3D();
  //@}

  /** returns the FileTCL associated with this interface */
  Rectangle3D *getClient(void) const {
    return (Rectangle3D *) client;
  }
  
  /// raise ambiguity on list() function
  static int list(TclModule *m, int d, char **a) {
    return(TclObject::list(m,d,a));
  }
  /// Tcl command to create the TclTriangulation3D
  static int create(TclModule *m, int argc, char **argv); 
  /// -destroy TCL command
  int destroyCmd(int argc, char **argv);
  /// -destroy TCL command
  int scaleCmd(int argc, char **argv);
  /// -point TCL command
  int pointCmd(int argc, char **argv);
  /// -direction TCL command
  int directionCmd(int argc, char **argv);
  /// -coordinate TCL command
  int coordinateCmd(int argc, char **argv);
  /// -render TCL command
  int renderCmd(int argc, char **argv);
  /// -renderOption TCL command
  int renderOptionCmd(int argc, char **argv);
  /// -texture2D TCL command
  int texture2DCmd(int argc, char **argv);
  /// -texture2DOption TCL command
  int texture2DOptionCmd(int argc, char **argv);
 /// -texture1D TCL command
  int texture1DCmd(int argc, char **argv);
  /// -texture1DOption TCL command
  int texture1DOptionCmd(int argc, char **argv);
  /// -textureScale TCL command
  int textureScaleCmd(int argc, char **argv);
  /// -highlightTexture TCL command
  int highlightTextureCmd(int argc, char **argv);
  /// -material TCL command
  int materialCmd(int argc, char **argv);
  /// -color TCL command
  int colorCmd(int argc, char **argv);
  /// -flipNormals TCL command
  int flipNormalsCmd(int argc, char **argv);
};



}


#endif
