#ifndef USERINTERFACE3D_H
#define USERINTERFACE3D_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif


#pragma interface "graphics3D/UserInterface3D.h"

#include <linearAlgebra/Vec3.h>
#include <graphics/Data.h>
#include <graphics/UserInterface.h>

namespace yav {


class Scene3D;

/** \class UserInterface3D
    \ingroup Graphics3D
    3D user Interface that exists in a Scene3D. These objects
    have an "getPosition" and "setForce" routines that are  suitable 
    for interaction with a Scene2D */
class UserInterface3D : public UserInterface<Scene3D, Vec3<double>,
                                             UserInterface3D> {
 public:
  /// constructor
  UserInterface3D(Scene3D *scene);
  /// destructor
  virtual ~UserInterface3D();
};

/** \class BasicUserInterface3DIterator
    \ingroup Graphics3D
    basic iterator on user interfaces */
template <class INTERFACE> class BasicUserInterface3DIterator{
 private:
  Scene3D* scene;
  ObjectsList<UserInterface3D>::iterator it;
 public:
  BasicUserInterface3DIterator(Scene3D* scene);

  void first();
  void next();
  bool isAtEnd();

  INTERFACE * operator*();
  INTERFACE * operator++();
  INTERFACE * operator++(int);

};


/** iterator on userinterfaces **/
typedef ObjectsList<UserInterface3D>::iterator UserInterface3DIterator;


} // namespace yav



#endif // USERINTERFACE3D_H
