#ifndef USERINTERFACE3D_TXX
#define USERINTERFACE3D_TXX

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#include <graphics3D/Scene3D.h>

namespace yav {

template <class INTERFACE> BasicUserInterface3DIterator<INTERFACE>::BasicUserInterface3DIterator(Scene3D* scene) {
  this->scene = scene;
  it = scene->firstUserInterface();
}

template <class INTERFACE> INTERFACE* BasicUserInterface3DIterator<INTERFACE>::operator*(){
  return (INTERFACE*)*it;
}
template <class INTERFACE> INTERFACE* BasicUserInterface3DIterator<INTERFACE>::operator++(){
  next();
  return (INTERFACE*)*it;
}
template <class INTERFACE> INTERFACE* BasicUserInterface3DIterator<INTERFACE>::operator++(int){
  INTERFACE *interf = (INTERFACE*)*it;
  next();
  return interf;
}
template <class INTERFACE> void BasicUserInterface3DIterator<INTERFACE>::next(){
  ++it;
  while((it!=scene->lastUserInterface())&&(dynamic_cast<INTERFACE*>(*it)==0)) ++it;
}
template <class INTERFACE> void BasicUserInterface3DIterator<INTERFACE>::first(){
  it = scene->firstUserInterface();
  while((it!=scene->lastUserInterface())&&(dynamic_cast<INTERFACE*>(*it)==0)) ++it;
}
template <class INTERFACE> bool BasicUserInterface3DIterator<INTERFACE>::isAtEnd(){
  if(it==scene->lastUserInterface()) return true;
  else return false;
}

}
#endif
