#ifndef MIPS_DATASET_H
#define MIPS_DATASET_H

#include <string>

namespace mips {

class ViewSpace;  
  
/** \class DataSet
    \ingroup MipsGUI
*/
class DataSet 
{
 public:
  /** Create a DataSet.  */
  DataSet();

  /** Destroy the DataSet */
  virtual ~DataSet();

  /** Return the associated full filename. */
  const char* GetFileName();
  /** Return the associated filename without the path.
      This function return pointer to new allocated memory that have
      to be freed with C free() function. */
  const char* GetFileBaseName();
  /** Return the associated filename path only.
      This function return  pointer to new allocated memory that have
      to be freed with C free() function. */
  const char* GetFileDirName();

  void SetFileName(const char * p_filename);  

  /** Create a new page in the viewSpace with the standard views displayed in
      the standard layout. */
  virtual void CreatePageInViewSpace(ViewSpace* p_viewSpace)=0;
  
 private:
  std::string m_filename;  
  
};

} //namespace mips

#endif /* MIPS_DATASET_H */
