#include <string>
#include <iostream>
#include <stdlib.h>

#include "MIPS_GUIPKG_config.h"

#include "mipsGladeGui.h"

namespace mips {




GladeGui::GladeGui (const char * p_filename)
{
  std::string glade_files_dir;  
  char *mips_home = getenv("MIPS_HOME");
  if (mips_home) {
    glade_files_dir = std::string(mips_home) + "/lib/glade";    
  }
  else {
    glade_files_dir = MIPS_GLADE_FILES_DIR;    
  }    
  std::string full_name = glade_files_dir + std::string("/") + p_filename;
  
  m_gladeXml = glade_xml_new(full_name.c_str(), NULL, NULL);
  glade_xml_signal_autoconnect(m_gladeXml);
}

GladeGui::~GladeGui ()
{
  // free or delete  ????
  free(m_gladeXml);
}

GtkWidget* 
GladeGui::GetWidget(const char * p_widgetName)
{
  GtkWidget* result_widget = glade_xml_get_widget(m_gladeXml,p_widgetName);
  if (!result_widget) {
	  g_critical("GladeGui::GetWidget -> Could not find the following widget : %s",p_widgetName);
  }
  return result_widget;
}

gulong 
GladeGui::SignalConnect(const char* widget_name, 
							   const char* detailed_signal, 
							   GCallback cb_handler, gpointer user_data)
{
  GtkWidget *widget;
  widget = this->GetWidget(widget_name);
  return g_signal_connect (G_OBJECT (widget), detailed_signal, cb_handler, user_data);
}

void 
GladeGui::Reparent(const char* p_widgetName, GtkWidget* p_newParent)
{
  GtkWidget *widget;
  widget = this->GetWidget(p_widgetName);  
  gtk_widget_reparent(widget, p_newParent);
}

} //namespace mips
