#ifndef _MIPS_INTERACTOR_STYLE_IMAGE2D_H_
#define _MIPS_INTERACTOR_STYLE_IMAGE2D_H_

#include "vtkInteractorStyleImage.h"

// Motion flags (See VTKIS_PICK and so on in vtkInteractorStyleImage.h)
#define MIPSIS_MEASURE      5050
#define MIPSIS_ZSLICE_MOVE  5051

namespace mips
{
  
class VtkViewImage2D;
 
class InteractorStyleImage2D : public vtkInteractorStyleImage
{
 public:
  static InteractorStyleImage2D *New()
    { return new InteractorStyleImage2D; }
  
  virtual void OnMouseMove();
  virtual void OnLeftButtonDown();
  virtual void OnLeftButtonUp();
  virtual void OnRightButtonDown();
  virtual void OnRightButtonUp();
  virtual void OnChar();

  void SetView(VtkViewImage2D* p_view);
  int  GetZSliceStep();

 protected:
  InteractorStyleImage2D();
  ~InteractorStyleImage2D();

 private:
  void StartZSliceMove();
  void ZSliceMove();
  void EndZSliceMove();
  void FullPage();
  void StartMeasure();
  void Measure();
  void EndMeasure();  
  
  InteractorStyleImage2D(const InteractorStyleImage2D&);  // Not implemented.
  void operator=(const InteractorStyleImage2D&);  // Not implemented.
  
 private:
  VtkViewImage2D*  m_view;
  int              m_ZSliceMoveStep;
  
};

} // end of namespace
 
#endif
