#ifndef MIPS_NEW_PAGE_DIALOG_H
#define MIPS_NEW_PAGE_DIALOG_H

#include "gtk/gtk.h"
#include "mipsViewSpace.h"

namespace mips {

class GladeGui;
  
  
/** \class NewPageDialog
    \ingroup MipsGUI
*/
class NewPageDialog 
{
 public:
  /** Create a NewPageDialog. */
  NewPageDialog(GtkWidget* p_parentTopWidget);  
  ~NewPageDialog();

  gint Run(const ViewSpace::ViewArrayType&    p_views,
                 ViewSpace::Page&             p_page);  

  

// LAYOUT DIALOG CALLBACKS
  void OnLayoutDialogAdd();
  static void OnLayoutDialogAddCallback(GtkButton *p_button,gpointer p_data);
  void OnLayoutDialogRemove();
  static void OnLayoutDialogRemoveCallback(GtkButton *p_button,gpointer p_data);
  void OnLayoutComboChanged();
  static void OnLayoutComboChangedCallback(GtkCombo *p_combo,gpointer p_data);
  
 private:
  GladeGui*   m_gladeGui;
  GtkWidget*  m_layoutEditorDialog;
  GtkWidget*  m_parentTopWidget;

  // No default constructor.
  NewPageDialog();  

};

} //namespace mips

#endif /* MIPS_VIEW_LAYOUT_DIALOG_H */
