#ifndef _MIPS_VTKVIEWIMAGE2DCOMMAND_H_
#define _MIPS_VTKVIEWIMAGE2DCOMMAND_H_

#include <glib-object.h>
#include<vtkCommand.h>
#include<vtkObjectFactory.h>

class vtkInteractorStyleImage;

namespace mips
{


  
class VtkViewImage2D;
  
class VtkViewImage2DCommand : public vtkCommand
{    
 public:
  VtkViewImage2DCommand(); 
  
  static  VtkViewImage2DCommand* New() 
    { return new VtkViewImage2DCommand; }
  
  void Execute(vtkObject *   caller, 
               unsigned long event, 
               void *        callData);    
  
  void SetView(VtkViewImage2D *p_view);

 public:
  enum EventsIds{
    ZSliceMoveEvent=(vtkCommand::UserEvent+1),
    StartZSliceMoveEvent,
    EndZSliceMoveEvent,
    StartMeasureEvent,
    MeasureEvent,
    EndMeasureEvent,
    FullPageEvent
  };

 private:
  void ChangeZSlice(int p_nbSlices);
  void EndWindowing();
  void Windowing(vtkInteractorStyleImage* p_isi);
  void StartWindowing();  
  void StartPicking();
  void EndPicking(vtkInteractorStyleImage* p_isi);  
  
 private:
  VtkViewImage2D*            m_view;
  float                      m_initialWindow;
  float                      m_initialLevel;

  bool                       m_windowEventStatus;
  
  /// Test g_signal_emit
  gpointer                   m_signalEmitTest;
};

} // end of namespace

#endif
