#ifndef GTK_CAMERA_OGL_H
#define GTK_CAMERA_OGL_H

#include "gtk/gtk.h"
#include "gtk/gtkgl.h"

namespace yav {        
class CameraOGL;
}

/** \class GtkCameraOGL
    \ingroup MipsViewer
*/
class GtkCameraOGL
{
 public:
        GtkCameraOGL();        
        GtkWidget* GetGtkWidget();
        bool GetAnimate() { return m_animate; };
        void SetAnimate(bool v) { m_animate = v; };
        void Render();        
        
 private:
        void         timeout_add       (GtkWidget   *widget);
        void         timeout_remove    (GtkWidget   *widget);
        GdkGLConfig *configure_gl      (void);        
        GtkWidget   *create_popup_menu (GtkWidget   *drawing_area);
        void         Initialize        ();

 private:
        // Callbacks
        static void realize (GtkWidget *widget, gpointer   data);
        static void unrealize (GtkWidget *widget, gpointer   data);
        static gboolean configure_event (GtkWidget *widget, GdkEventConfigure *event,
                                  gpointer  data);
        static gboolean expose_event (GtkWidget *widget,GdkEventExpose *event,
                               gpointer  data);        
        static gboolean timeout (GtkWidget *widget);
        static gboolean motion_notify_event (GtkWidget      *widget,
                                      GdkEventMotion *event,
                                      gpointer       data);
        static gboolean button_press_event (GtkWidget      *widget,
                                     GdkEventButton *event,
                                     gpointer        data);
        static gboolean button_press_event_popup_menu (GtkWidget      *widget,
                                                GdkEventButton *event,
                                                gpointer        data);
        static gboolean key_press_event (GtkWidget   *widget,
                                  GdkEventKey *event,
                                  gpointer     data);
        static gboolean map_event (GtkWidget *widget, 
                            GdkEvent  *event,
                            gpointer   data);
        static gboolean unmap_event (GtkWidget *widget,
                              GdkEvent  *event,
                              gpointer   data);
        static gboolean visibility_notify_event (GtkWidget          *widget,
                                          GdkEventVisibility *event,
                                          gpointer            data);
        // Popup
        static void toggle_animation  (GtkWidget   *widget);        

 private:
        gboolean m_animate;        
        yav::CameraOGL *m_cameraOGL;                
        GtkWidget* m_topWidget;                
        guint timeout_id;
};



#endif // GTK_CAMERA_OGL_H
