#ifndef MIPS_APPLICATION_GUI_MANAGER_H
#define MIPS_APPLICATION_GUI_MANAGER_H

#include <vector>

namespace mips {

class ApplicationGUI;
  
/** \class ApplicationGUIManager
    \ingroup MipsViewer
*/
class ApplicationGUIManager 
{
 public:
  /** Get the list of found plug-in */
  static const std::vector<ApplicationGUI*>& GetApplicationGUIs();

  /** Add a reader to try when loading a DataSet from a file.*/
  static void AddApplicationGUI(ApplicationGUI* p_application);

 private:
  /** The Factory have not to be instanciated.  */
  ApplicationGUIManager(){};

  // Attributes
 private:  
  static std::vector<ApplicationGUI*> m_applicationGUIs;  
};

} //namespace mips

#endif /* MIPS_APPLICATION_GUI_MANAGER_H */
