#include "mipsIterationSchedulerGlib.h"
#include <glib.h>


#include <iostream>

using namespace std;
namespace mips {

void IterationSchedulerGlib::Iterate (unsigned long nb_iter)
{
  if (this->IsRunning()) return;
  this->StartTheRun();

  while ((this->GetIterationsDone()<nb_iter) && (!this->IsStopAsked())) {
	this->Step();
  }

  this->StopTheRun();
}

void IterationSchedulerGlib::Run ()
{
  if (this->IsRunning()) return;
  this->StartTheRun();
  g_idle_add(IterationSchedulerGlib::DoStepInGlibIdleCallback, this);
}


gboolean IterationSchedulerGlib::DoStepInGlibIdle() {
   if (! this->IsStopAsked()) {
 	this->Step();
	return true;
   }
  else {
	this->StopTheRun();
  }
  return false;
}

gboolean IterationSchedulerGlib::DoStepInGlibIdleCallback(gpointer scheduler) {
  return static_cast<IterationSchedulerGlib*>(scheduler)->DoStepInGlibIdle();
}


} //namespace mips
