#ifndef MIPS_ITERATION_SCHEDULER_GLIB_H
#define MIPS_ITERATION_SCHEDULER_GLIB_H

#include "mipsIterationScheduler.h"

#include <glib.h>

namespace mips {

/** \class IterationSchedulerGlib
    \ingroup MipsViewer
*/
class IterationSchedulerGlib :public IterationScheduler {
 public:
  /** Iterate nb_iter over the added units. Iteration can be stopped by calling 
	  the Stop method. */
  virtual void Iterate(unsigned long nb_iter=1);
  /** Iterate over the added units until the Stop method is called. */
  virtual void Run();
  /** Ask to stop the current iteration loop. This method only register the 
	  request and returns without waiting the effective end of the loop. The
	  loop will stop effectively when the current running unit will 
	  terminate. */

 private:
  static gboolean DoStepInGlibIdleCallback(gpointer scheduler);
  gboolean DoStepInGlibIdle();
};

} // namespace mips
#endif /* MIPS_ITERATION_SCHEDULER_GLIB_H */
