#ifndef MIPS_ITERATION_UNIT_C_H
#define MIPS_ITERATION_UNIT_C_H

#include "mipsIterationUnit.h"

namespace mips {

/** \class IterationUnitC
    \ingroup MipsViewer
*/
class IterationUnitC : public IterationUnit
{
 public:
  /** The type of the C function to run */
  typedef void (*CFunctionToRunType) (void); 

  /** Construct an IterationUnitC with the function to run */
  IterationUnitC(CFunctionToRunType func_to_run);

 private:
  /** Call the C function. This method is called by IterationUnit::Run method  */
  virtual void CallFunction();

  CFunctionToRunType m_functionToRun;
  
  IterationUnitC(){}; //Default constructor is not allowed
};

} //namespace mips

#endif /* MIPS_ITERATION_UNIT_C_H */
