#ifndef MIPS_ITERATION_UNIT_CPP_H
#define MIPS_ITERATION_UNIT_CPP_H

#include "mipsIterationUnit.h"


namespace mips {

/** \class IterationUnitCpp
    \ingroup MipsViewer
*/
template<class T_ClassToRun>
class IterationUnitCpp : public IterationUnit
{
 public:
  /** The type of the member function to run */
  typedef void (T_ClassToRun::*MethodToRunType) (void);

  /** Construct an IterationUnit with the method to run on the given object*/
  IterationUnitCpp(T_ClassToRun* object_ptr, MethodToRunType method_to_run);

 private:
  
  /** Call the C function. This method is called by IterationUnit::Run method  */
  virtual void CallFunction();
  
  T_ClassToRun* m_objectToRun;
  MethodToRunType m_methodToRun ;

  IterationUnitCpp(){}; //Default constructor is not allowed
};

} //namespace mips

#include "mipsIterationUnitCpp.txx"

#endif /* MIPS_ITERATION_UNIT_CPP_H */
