#ifndef MIPS_ITERATION_UNIT_CPP_TXX
#define MIPS_ITERATION_UNIT_CPP_TXX

#include "mipsIterationUnitCpp.h"
#include <iostream>
#include <assert.h>

namespace mips {

template<class T_ClassToRun>
IterationUnitCpp<T_ClassToRun>
::IterationUnitCpp (T_ClassToRun* object_ptr, MethodToRunType method_to_run) 
  : IterationUnit()
{
  assert(object_ptr);
  assert(method_to_run);
  m_objectToRun = object_ptr;
  m_methodToRun = method_to_run;
}

template<class T_ClassToRun>
void 
IterationUnitCpp<T_ClassToRun>
::CallFunction ()
{
  (m_objectToRun->*m_methodToRun) ();
}


} //namespace mips

#endif //MIPS_ITERATION_UNIT_CPP_TXX
