#ifndef MIPS_PLUGIN_FACTORY_H
#define MIPS_PLUGIN_FACTORY_H

#include <string>
#include <vector>
#include <gmodule.h>

namespace mips {

class PlugIn;  
  
/** \class PlugInFactory
    \ingroup MipsViewer
*/
class PlugInFactory 
{
 public:
  static void LoadPlugIns();
  static void LoadPlugIn (const char* p_name);
  static void SetPath(const char* p_path);
  static const char* GetPath();  
    
 private:
  /** The factory have not to be instanciated.  */
  PlugInFactory(){};
  
  static void LoadPlugInsInDirectory(const char* p_dir);
  static void LoadPlugInInDirectory (const char* p_dir,
                                     const char* p_name,
                                     bool p_addPrefixAndSuffixes = true);
    
  // Attributes
 private:  
  static std::vector<PlugIn*> m_plugIns;  
  static std::string m_path;  
 
};

} //namespace mips

#endif /* MIPS_PLUGIN_FACTORY_H */
