#include "mipsTimer.h"
#include <time.h>

namespace mips {

Timer::Timer ()
{
  this->Reset();
  m_is_running=false;
}

Timer::~Timer ()
{
}

void Timer::Start ()
{
  if (m_is_running) return;
  m_last_clock_call=clock();
  m_is_running=true;
}

double Timer::Stop()
{
  //GetTime have to be called before setting m_is_running to false
  this->GetTime();
  m_is_running=false;
  return m_accumulated_time;
}

void Timer::Reset()
{
  m_accumulated_time=0;
}

double Timer::GetTime()
{
  if (m_is_running) {
	clock_t curr_time = clock();
	m_accumulated_time+=double(curr_time - m_last_clock_call) / double(CLOCKS_PER_SEC);
	m_last_clock_call=curr_time;
  }
  return m_accumulated_time;
}

bool Timer::IsRunning()
{
  return m_is_running;
}
} //namespace mips
