#ifndef MIPS_TIMER_H
#define MIPS_TIMER_H


namespace mips {

/** \class Timer
    \ingroup MipsViewer
*/
class Timer 
{
 public:
  /** Create a timer. The count is set to 0.  */
  Timer();
  /** Destroy the timer. */
  virtual ~Timer();

  /** Start the timer from the last stop value without any reset.  */
  virtual void Start();
  /** Stop the time counting and return the accumulated time in seconds.*/
  virtual double Stop();
  /** Reset the the count to zero. If the timer is running, it will not 
	  be stoped. */
  virtual void Reset();
  /** Get the current time count. If the timer is running, it will not 
	  be stoped. */
  virtual double GetTime();
  /** Inform if the timer is running or not */
  virtual bool IsRunning();

 private: 
  unsigned long int m_last_clock_call;
  double m_accumulated_time;
  bool m_is_running;
};

} //namespace mips

#endif /* MIPS_TIMER_H */
