#include "GtkCameraOGL.h"
#include "mipsView3D.h"
#include "assert.h"

namespace mips {

View3D::View3D ():View()
{
  this->Initialize ();
}

View3D::~View3D()
{
  delete m_camera;  
};

void
View3D::Initialize()
{
  // Set the m_camera and attach it to the top widget
  m_camera= new GtkCameraOGL();
  this->AddGtkWidget (m_camera->GetGtkWidget());
  
  // View3D selection initialisation
  this->SetUnselected();
}

void 
View3D::Render ()
{
  m_camera->Render();
}

bool 
View3D::IsContaining(GtkWidget* p_widget)
{
  return (this->View::IsContaining (p_widget) || 
          (p_widget == m_camera->GetGtkWidget()));
}


} //namespace mips
