#ifndef MIPS_VIEW3D_H
#define MIPS_VIEW3D_H

#include "mipsView.h"

class GtkCameraOGL;

namespace mips {
  
/** \class View3D
    \ingroup MipsViewer
*/
class View3D : public View
{
 public:
  /** Create a View3D.  */
  View3D();

  /** Destroy the View and unreference the GtkWidget.  */
  virtual ~View3D();

  /** Send a render message to the vtkRenderWindow associated */
  virtual void Render();

  /** Return true if the view contains the given widget in it's widget tree. */
  virtual bool IsContaining(GtkWidget* p_widget);

 private: 
  GtkCameraOGL *m_camera;

  /** Class initialisation. */
  void Initialize();
};

} //namespace mips

#endif /* MIPS_VIEW3D_H */
