#include <gtk/gtk.h>
#include <mipsGladeGui.h>
#include <mipsViewSpace.h>
#include <iostream>

#include <mipsViewer.h>

namespace mips {

ViewSpace*  Viewer::m_viewSpace=NULL;  
GladeGui*   Viewer::m_gladeGui=NULL;


static gboolean
delete_event( GtkWidget *widget,
              GdkEvent  *event,
              gpointer   data )
{
  /* If you return FALSE in the "delete_event" signal handler,
   * GTK will emit the "destroy" signal. Returning TRUE means
   * you don't want the window to be destroyed.
   * This is useful for popping up 'are you sure you want to quit?'
   * type dialogs. */

  // g_print ("delete event occurred\n");
  gtk_main_quit ();

  /* Change TRUE to FALSE and the main window will be destroyed with
   * a "delete_event". */
  return TRUE;
}

/* Another callback */
static void destroy( GtkWidget *widget,
                     gpointer   data )
{
  // g_print ("destroy event occurred\n");
  gtk_main_quit ();
}

  
void
Viewer::Initialize()
{
  m_gladeGui = new mips::GladeGui("mipsviewer.glade");
  m_viewSpace = new  mips::ViewSpace;
  
  /* Set the default window size and callbacks */
  GtkWidget *main_window = m_gladeGui->GetWidget("main_window");
  gtk_window_resize(GTK_WINDOW(main_window), 700,500);
  /* When the window is given the "delete_event" signal (this is given
   * by the window manager, usually by the "close" option, or on the
   * titlebar). */
  g_signal_connect (G_OBJECT (main_window), "delete_event",
                    G_CALLBACK (delete_event), NULL);
    
  /* Here we connect the "destroy" event to a signal handler.  
   * This event occurs when we call gtk_widget_destroy() on the window,
   * or if we return FALSE in the "delete_event" callback. */
  g_signal_connect (G_OBJECT (main_window), "destroy",
                    G_CALLBACK (destroy), NULL);

  /* Attach the viewspace to the viewer */
  GtkWidget *mipsviewer_hpaned;
  mipsviewer_hpaned = m_gladeGui->GetWidget("mipsviewer_hpaned");
  gtk_paned_add2(GTK_PANED(mipsviewer_hpaned), m_viewSpace->GetTopWidget());
}

GtkWidget*
Viewer::GetWorkSpaceNotebook()
{
  return m_gladeGui->GetWidget("workspace_notebook");    
}

  
ViewSpace* 
Viewer::GetViewSpace() {
  return m_viewSpace;
}


} //namespace mips
