#ifndef MIPS_VIEWER_H
#define MIPS_VIEWER_H

#include "gtk/gtk.h"

namespace mips {

class ViewSpace;
class GladeGui;
class DataSetFactory;
class ApplicationGuiManager;
 
/** \class Viewer
    \ingroup MipsViewer
*/
class Viewer 
{
 public:

  /** Initialisation of the viewer. Have to be called after gtk_init and
      gtk_gl_init functions.*/
  static void Initialize();  
  
  static ViewSpace*             GetViewSpace();
  static DataSetFactory*        GetDataSetFactory();
  static ApplicationGuiManager* GetApplicationGuiManager();
  static GtkWidget*             GetWorkSpaceNotebook();
  
 private:
  /** Viewer is a singleton class and cannot be instanciated.  */
  Viewer(){};

  // Attributes 
 private:
  /** The manager in charge of the viewer glade project. */
  static GladeGui*              m_gladeGui;

  static ViewSpace*             m_viewSpace;
};

} //namespace mips

#endif /* MIPS_VIEWER_H */
