#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "modules/TclSon.h"
#include <modules/TclSon.h>


namespace yav {



TclSon::TclSon(TclModule *m, const TclString& name)
  : module(m), deleteProc(0), deleteData(0) {
  if(name != EMPTY_STRING) setTCLwindow(name);
}


TclSon::~TclSon() {
  Tcl_CmdInfo info;

  // if name is EMPTY_STRING, the scale has been destroyed by the
  // TCL destroy command
  if(TCLwindow != EMPTY_STRING) {
    Tcl_GetCommandInfo(module->getInterp(), (char *) TCLwindow, &info);
    info.deleteProc = deleteProc;
    info.deleteData = deleteData;
    Tcl_SetCommandInfo(module->getInterp(), (char *) TCLwindow, &info);
    module->tickle("destroy %s", (char *) TCLwindow);
  }
}


void TclSon::setTCLwindow(const TclString& name) {
  Tcl_CmdInfo info;

  if(module->windowExists(name)) {
    TCLwindow = name;
    Tcl_GetCommandInfo(module->getInterp(), (char *) TCLwindow, &info);
    deleteProc = info.deleteProc;
    deleteData = info.deleteData;
    info.deleteProc = TclSon::deleted;
    info.deleteData = this;
    Tcl_SetCommandInfo(module->getInterp(), (char *) TCLwindow, &info);
  }

  return;
}


void TclSon::deleted(ClientData cd) {
  TclSon *son = (TclSon *) cd;
  (*son->deleteProc)(son->deleteData);
  son->TCLwindow = EMPTY_STRING;
  delete son;
}


} // namespace yav




