#ifndef TCLGENERICHISTOGRAM_H
#define TCLGENERICHISTOGRAM_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 )
#pragma warning ( disable : 4786 )
#endif

#pragma interface "modules/TclGenericHistogram.h"

#include <modules/TclObject.h>
#include <basics/GenericHistogram.h>


namespace yav {

/** \class TclGenericHistogram
    \ingroup Modules
    \brief a TCL interface over an histogram */
class TclGenericHistogram : public TclObject, public Owner<GenericHistogram> {
 public:
  /** @name constructors */
  //@{
  /** construct a new histogram
      @param m module to create TCL object 
      @param h an histogram */
  TclGenericHistogram(TclModule *m, GenericHistogram *h);
  //@}
  
  /** @name destructor */
  //@{
  ~TclGenericHistogram();
  //@}

  static void createCommands(TclModule *m);
  /// die on histogram  deletion
  virtual void dying(const ObjectPointer < GenericHistogram > &g) {
    if (g()==pointer()) {
	  pointer= 0;	
      delete this;
	  }
  }


  //destroy option
  int destroyCmd(int argc, char **argv);

  /// -value option
  int valueCmd(int argc, char **argv);
  /// -bucket option
  int bucketCmd(int argc, char **argv);
  /// -addHistogram option
  int addHistogramCmd(int argc, char **argv);
 /// -plot option
  int plotCmd(int argc, char **argv);
  /// -minValue option
  int minValueCmd(int argc, char **argv);
  /// -maxValue option
  int maxValueCmd(int argc, char **argv);
  /// -stat option
  int statCmd(int argc, char **argv);
  
  /// -save option
  int saveCmd(int argc, char **argv);
  /// -smooth option
  int smoothCmd(int argc, char **argv);
  /// -nb option
  int nbCmd(int argc, char **argv);
  
  
  /// new TCL command callback
  static int create(TclModule *m, int argc, char **argv);

  // return object by name (argv[i]) or 0 with an error message
  // in module interpretor if it is not found
  static TclGenericHistogram *getObject(int argc, char **argv, int i = 1) {
    return
      dynamic_cast<TclGenericHistogram *>(TclObjectKind::getObject(typeid(TclGenericHistogram),
								   argc, argv, i));
  }

  /// returns TclObject client
  GenericHistogram *getClient(void) { return  pointer(); }
};
 

} // namespace yav


#endif
