/* epi_extent.h 2.1 5/14/98 */
/*=============================================================================
 *
 * File           : $MEDIAN/usr/people/haibin/epidaure/include/epi_extent.h
 * Module         : 
 * $Id: epi_extent.h,v 1.1 2004/01/26 16:00:47 xpennec Exp $
 * $Header: /proj/epidaure/home/private/CVS/mips/AuxPkgs/EpidaureLibPkg/epidaure/epi_extent.h,v 1.1 2004/01/26 16:00:47 xpennec Exp $
 * Test File      : 
 * Author         : Haibin YIN
 * Creation       : Fri Oct 15 16:00:31 1993
 *
 *=============================================================================
 *     (c) Copyright 1992, ALEPH MED, all rights reserved
 *=============================================================================
 *
 *------------------------- Description ---------------------------------------
 *
 *   Structure defined for the volume voxel quick access
 *   
 *   
 *------------------------- Modifications -------------------------------------
 *   
 * $Log: epi_extent.h,v $
 * Revision 1.1  2004/01/26 16:00:47  xpennec
 * Added Package EpidaureLibPkg in AuxPkgs
 * source of EpidaureLib taken from Roboscope (~ nov 99)
 *
 * Revision 2.5  94/02/03  13:36:51  haibin
 * Epidaure New version 2.5 
 * 
 * 
 * Revision 2.1  94/02/03  11:03:58  haibin
 * function d'acces interne Epidaure
 * 
 * Revision 2.0  93/11/08  09:48:08  haibin
 * version fixed to 2.0
 * 
 * Revision 1.2  93/10/18  18:23:52  haibin
 * ajout de l'object interne pour l'optimisation de l'acces auc donnees
 * 
 * Revision 1.1  93/10/18  14:26:13  haibin
 * object for quick access to an image
 *   
 * 
 */

/*---------------------------------------------------------------------------
 *  O b j e c t 
 *---------------------------------------------------------------------------
 */

#ifndef _epi_extent_h_
#define _epi_extent_h_

#include <epidaure.h>

typedef struct _EPI_Imaccess {
  /*-------
    static info.
    -------*/
  t_ImagePtr ima;           /* image pointer */
  char *buff;               /* adress of the buffer */
  char type;                /* TYPEIM_256 or TYPEIM_16B or TYPEIM_FLOAT */
  int voxel_size;           /* nombre of bytes at a voxel = 
			       sizeof(unsigned char) if voxel_type = TYPEIM_256;
			       sizeof(unsigned short) if voxel_type = TYPEIM_16B;
			       sizeof(reeltype) if voxel_type = TYPEIM_FLOAT */
  int tx, ty, tz;           /* image dimensions along X, Y and Z */
  int ln_voxel_nb;          /* nombre of voxels on a line = tx */
  int pln_voxel_nb;         /* nombre of voxels in a plane = tx * ty */
  int ln_size;              /* (ln_voxel_nb * voxel_size) */
  int pln_size;             /* (pln_voxel_nb * voxel_size) */
  
  /*---------
    access info.
    ---------*/
  char *curr_adr;               /* last acces adress to the buffer */
  int curr_x, curr_y, curr_z;   /* coordinates of the last access */
} EPI_Imaccess;



/*---------------------------------------------------------------------------
 *      Fin de fichier 
 *---------------------------------------------------------------------------
 */

#endif
