/* epi_filter.h 2.1 5/14/98 */
/*==========================================================================
*
* File : $EPI/src/epi_filter.h
* Module : ?
* $ Id : ?
* Test file : $EPI/test/test.im $EPI/test/test.tr
* Author : J-P Thirion
* Creation: December 10, 1992
*===========================================================================
*   (c) Copyright 1992-1993, Inria, all right reserved
*===========================================================================
*
*------------------------------Description----------------------------------
*
* Fonctions de filtrage gaussien et gaussien se'pare'.
*
*-----------------------------Modification----------------------------------
*
*/

/*======================================================================*/
/*
    epi_filter.h

  Compute and apply filters to 3D images

  (c) Jean-Philippe THIRION -- INRIA -- Nov. 1991
  */
/*======================================================================*/


#ifndef _epi_filter_h_
#define _epi_filter_h_


typedef struct e_SepFilterPar{
  
  t_3Point vSigma; /* sigma according to x,y,z */
  t_3Point vScale; /* scale according to x,y,z */
  t_3IPoint vSize; /* kernel support size (in voxels) according to x,y,z */
  t_3IPoint vDer; /* derivative orders in x,y,z */
  int verb; /* if TRUE, print additional information during execution */
  int mode;				/* access mode type to the voxels */
  int boardModes;			/* board effects in filtering  */
  int normModes;          /* normalization of the filter */
  
} e_SepFilterPar, *e_SepFilterParPtr;

#endif /* _epi_filter_h_ */








