/* epi_gutil.c 2.4 5/14/98 */

#include <epidaure.h>
#include <epidaure.ee>
#include <epidaure.ei>


/* Initialisation de la structure e_ParamNames.

*/
#if defined(_ANSI_)
void E_InitNames( e_ParamNames *par )
#else
void E_InitNames( par )
e_ParamNames *par;
#endif
{
	par->nameIn[0] = 0;
	par->nameOut[0] = 0;
	par->nameSup[0] = 0;
	par->inverse = FALSE;
	par->swap = FALSE;
}

#ifdef COMPILE_UNUSED

#if defined(_ANSI_)
static int E_Binarise( t_ImagePtr theIm, t_ImagePtr resIm, float fseuil, int iseuil )
#else
static int E_Binarise(theIm, resIm, fseuil, iseuil )
t_ImagePtr theIm;
t_ImagePtr resIm;
float fseuil;
int iseuil;
#endif
{
  register int x, y, z, i, v;
  unsigned char *buf;
  
  E_ERR( (theIm==NULL) || (theIm->buf==NULL), E_ERRNULL, FALSE,
	"E_Binarise", "input image not allocated");
  E_ERR( (resIm==NULL) || (resIm->buf==NULL), E_ERRNULL, FALSE,
	"E_Binarise", "output image not allocated");
  E_ERR( (theIm->tx!=resIm->tx) || (theIm->ty!=resIm->ty) || (theIm->tz!=resIm->tz),
	E_ERRFATAL, FALSE, "E_Binarise", 
	"input and output have different dimensions");

  if (resIm->type == TYPEIM_256) {
	  buf = (unsigned char*)resIm->buf;
	  v = theIm->tx * theIm->ty * theIm->tz;
	  switch (theIm->type) {
	  case TYPEIM_BW :
		  for (z=0; z<theIm->tz; z++)
		  for (y=0; y<theIm->ty; y++)
	          for (x=0; x<theIm->tx; x++) {
			  if ( T_GetIPoint( x, y, z, theIm ) < iseuil ) *(buf++) &= ~0xff;
			  else *(buf++) |= 0xff;
		  }
		  break;
	  case TYPEIM_256 :
		  {
		  unsigned char *tmp;
		  tmp = (unsigned char*)theIm->buf;
		  for (i=0; i<v; i++) {
			  if ( *(tmp++) < iseuil ) *(buf++) &= ~0xff;
			  else *(buf++) |= 0xff;
		  }}
		  break;
	  case TYPEIM_16B :
		  {
	          unsigned short int *tmp;
		  tmp = (unsigned short int*)theIm->buf;
		  for (i=0; i<v; i++) {
			  if ( *(tmp++) < iseuil ) *(buf++) &= ~0xff;
			  else *(buf++) |= 0xff;
		  }}
		  break;
	  case TYPEIM_S16B :
		  {
	          short int *tmp;
		  tmp = (short int*)theIm->buf;
		  for (i=0; i<v; i++) {
			  if ( *(tmp++) < iseuil ) *(buf++) &= ~0xff;
			  else *(buf++) |= 0xff;
		  }}
		  break;
	  case TYPEIM_FLOAT :
		  {
	          float *tmp;
		  tmp = (float*)theIm->buf;
		  for (i=0; i<v; i++) {
			  if ( *(tmp++) < fseuil ) *(buf++) &= ~0xff;
			  else *(buf++) |= 0xff;
		  }}
		  break;
	  default :
		  for (z=0; z<theIm->tz; z++)
	          for (y=0; y<theIm->ty; y++)
	          for (x=0; x<theIm->tx; x++) {
			  if ( T_Get3Point( x, y, z, theIm ) < fseuil ) *(buf++) &= ~0xff;
			  else *(buf++) |= 0xff;
		  }
	  }
	  return( TRUE );
  }
  for (z=0; z<theIm->tz; z++)
  for (y=0; y<theIm->ty; y++)
  for (x=0; x<theIm->tx; x++) {
	  if ( T_Get3Point( x, y, z, theIm ) < fseuil ) 
		  T_Set3Point( x, y, z, resIm, (reeltype)0.0, (char)MODE_SET );
	  else
		  T_Set3Point( x, y, z, resIm, (reeltype)1.0, (char)MODE_SET );
  }
  return( TRUE );
}

#endif /* COMPILE_UNUSED */


/* Mise a blanc (ou noir) d'une image.

   Si le flag white a pour valeur TRUE, l'image est blanchie,
   c'est-a-dire que pour les types d'image TYPEIM_BW, TYPEIM_256
   ou TYPEIM_16B tous les bits sont mis a 1, pour les types
   TYPEIM_S16B, TYPEIM_FLOAT ou par defaut, les points sont 
   mis a 32767 ou a 1.0.

   Sinon, les points sont mis a 0.

RETURN
   Retourne FALSE en cas d'erreur (dans ce cas, l'image est
   inchangee).
*/

#if defined(_ANSI_)
int E_RAZ( t_ImagePtr theIm /* image to be whitened (or blackened) */, 
	  int white /* flag */ )
#else
int E_RAZ( theIm, white )
t_ImagePtr theIm; /* image to be whitened (or blackened) */
int white;        /* flag */
#endif
{
	register int x, y, z;
	int dim, taille;
	char *tab;

	E_ERR( (theIm==NULL) || (theIm->buf==NULL), E_ERRNULL, FALSE,
	      "E_RAZ", "input image not allocated");
	
	dim = theIm->tx * theIm->ty * theIm->tz;
	taille = T_ImageSize( theIm );
	tab = theIm->buf;

	if ( white == TRUE ) {
		switch (theIm->type) {
		case TYPEIM_BW :
		case TYPEIM_256 :
		case TYPEIM_16B :
			for (x=0; x<taille; x++)
				*tab++ |= 0xff;
			break;
		case TYPEIM_S16B :
			{
		        short int *tmp;
			tmp = (short int*)theIm->buf;
			for (x=0; x<dim; x++) 
				*(tmp++) = (short int)32767;
		        }
			break;
		case TYPEIM_FLOAT :
			{
			float *tmp;
			tmp = (float*)theIm->buf;
			for (x=0; x<dim; x++) 
				*(tmp++) = (float)1.0;
		        }
			break;
		default :
			for (z=0; z<theIm->tz; z++)
			for (y=0; y<theIm->ty; y++)
	                for (x=0; x<theIm->tx; x++)
				T_Set3Point( x, y, z, theIm, (reeltype)1.0, (char)MODE_SET );
		}
		return( TRUE );
	}
	/* sinon white == FALSE */
	switch (theIm->type) {
	case TYPEIM_BW :
	case TYPEIM_256 :
	case TYPEIM_16B :
		for (x=0; x<taille; x++)
			*tab++ &= ~0xff;
		break;
	case TYPEIM_S16B :
		{
		short int *tmp;
		tmp = (short int*)theIm->buf;
		for (x=0; x<dim; x++) 
			*(tmp++) = (short int)0;
		}
		break;
	case TYPEIM_FLOAT :
		{
		float *tmp;
		tmp = (float*)theIm->buf;
		for (x=0; x<dim; x++) 
			*(tmp++) = (float)0.0;
	        }
		break;
	default :
		for (z=0; z<theIm->tz; z++)
		for (y=0; y<theIm->ty; y++)
	        for (x=0; x<theIm->tx; x++)
			T_Set3Point( x, y, z, theIm, (reeltype)0.0, (char)MODE_SET );
	}
	return( TRUE );
}	

/* Calcul des passages par zeros dans une image.

   Ce calcul est realise de maniere separee selon X, Y et Z.
   Un point est declare passage par zeros s'il verifie (exemple
   selon X) :
   - soit  I(X,Y,Z) > 0  ET  I(X+1,Y,Z) <= 0
   - soit  I(X,Y,Z) <= 0  ET  I(X+1,Y,Z) > 0
   Si le parametre mode vaut MODE_2D, alors le calcul n'est fait
   qu'en dimension 2 (seulement selon X et Y).
   Sinon (si ce parametre vaut MODE_3D par exemple), le calcul
   est fait en dimension 3.

RETURN
   Retourne FALSE en cas d'erreur.
*/

#if defined(_ANSI_)
int E_ZeroCrossings( t_ImagePtr theIm /* image where the zero-crossings are to be computed */, 
		    t_ImagePtr resIm /* result image */, 
		    int mode /* dimension of the computation */ )
#else
int E_ZeroCrossings( theIm, resIm, mode )
t_ImagePtr theIm; /* image where the zero-crossings are to be computed */
t_ImagePtr resIm; /* result image */
int mode;         /* dimension of the computation */
#endif
{
	register int x, y, z, i, j;
	int dx, dy, dz, dxy, dx1, dy1, dz1;
		
	E_ERR( (theIm==NULL) || (theIm->buf==NULL), E_ERRNULL, FALSE,
	      "E_ZeroCrossings", "input image not allocated");
	E_ERR( (resIm==NULL) || (resIm->buf==NULL), E_ERRNULL, FALSE,
	      "E_ZeroCrossings", "output image not allocated");
	E_ERR( (theIm->tx!=resIm->tx) || (theIm->ty!=resIm->ty) || (theIm->tz!=resIm->tz),
	      E_ERRFATAL, FALSE, "E_ZeroCrossings", 
	      "input and output have different dimensions");

	/*---  mise a zero de l'image resultat ---*/
	E_RAZ( resIm, (int)FALSE );
	
	dx = theIm->tx;   dy = theIm->ty;   dz = theIm->tz;
	dx1 = dx - 1;   dy1 = dy - 1;   dz1 = dz - 1;
	dxy = dx*dy;
	
	switch ( resIm->type ) {
	case TYPEIM_256 :
		{
		unsigned char *buf;
		buf = (unsigned char*)resIm->buf;
		switch (theIm->type) {
		case TYPEIM_S16B :
			{
			short int *tmp;
			tmp = (short int*)theIm->buf;
			/*--- zero-crossings along X ---*/
			if ( dx > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( y = 0; y < dy; y++ ) {
					i = z*dxy + y*dx;   j = i+1;
					for ( x = 0; x < dx1; x++, i++, j++ ) {
						if ( tmp[i] > 0 ) {
							if ( tmp[j] > 0 ) continue;
							buf[i] |= 0xff;  continue;
						}
						if ( tmp[j] <= 0 ) continue;
						buf[j] |= 0xff; 
					}
				}
			}
			/*--- zero-crossings along Y ---*/
			if ( dy > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( x = 0; x < dx; x++ ) {
					i = z*dxy + x;   j = i+dx;
					for ( y = 0; y < dy1; y++, i+=dx, j+=dx ) {
						if ( tmp[i] > 0 ) {
							if ( tmp[j] > 0 ) continue;
							buf[i] |= 0xff;  continue;
						}
						if ( tmp[j] <= 0 ) continue;
						buf[j] |= 0xff; 
					}
				}
		        }
			if ( mode == MODE_2D ) break;
			/*--- zero-crossings along Z ---*/
			if ( dz > 1 ) {
				for ( y = 0; y < dy; y++ )
				for ( x = 0; x < dx; x++ ) {
					i = y*dx + x;   j = i+dxy;
					for ( z = 0; z < dz1; z++, i+=dxy, j+=dxy ) {
						if ( tmp[i] > 0 ) {
							if ( tmp[j] > 0 ) continue;
							buf[i] |= 0xff;  continue;
						}
						if ( tmp[j] <= 0 ) continue;
						buf[j] |= 0xff; 
					}
				}
			}}
			break;
		case TYPEIM_FLOAT :
			{
			float *tmp;
			tmp = (float*)theIm->buf;
			/*--- zero-crossings along X ---*/
			if ( dx > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( y = 0; y < dy; y++ ) {
					i = z*dxy + y*dx;   j = i+1;
					for ( x = 0; x < dx1; x++, i++, j++ ) {
						if ( tmp[i] > 0.0 ) {
							if ( tmp[j] > 0.0 ) continue;
							buf[i] |= 0xff;  continue;
						}
						if ( tmp[j] <= 0.0 ) continue;
						buf[j] |= 0xff; 
					}
				}
			}
			/*--- zero-crossings along Y ---*/
			if ( dy > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( x = 0; x < dx; x++ ) {
					i = z*dxy + x;   j = i+dx;
					for ( y = 0; y < dy1; y++, i+=dx, j+=dx ) {
						if ( tmp[i] > 0.0 ) {
							if ( tmp[j] > 0.0 ) continue;
							buf[i] |= 0xff;  continue;
						}
						if ( tmp[j] <= 0.0 ) continue;
						buf[j] |= 0xff; 
					}
				}
		        }
			if ( mode == MODE_2D ) break;
			/*--- zero-crossings along Z ---*/
			if ( dz > 1 ) {
				for ( y = 0; y < dy; y++ )
				for ( x = 0; x < dx; x++ ) {
					i = y*dx + x;   j = i+dxy;
					for ( z = 0; z < dz1; z++, i+=dxy, j+=dxy ) {
						if ( tmp[i] > 0.0 ) {
							if ( tmp[j] > 0.0 ) continue;
							buf[i] |= 0xff;  continue;
						}
						if ( tmp[j] <= 0.0 ) continue;
						buf[j] |= 0xff; 
					}
				}
			}}
			break;
	      default :
			/*--- zero-crossings along X ---*/
			if ( dx > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( y = 0; y < dy; y++ ) {
					i = z*dxy + y*dx;   j = i+1;
					for ( x = 0; x < dx1; x++, i++, j++ ) {
						if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
							if ( T_Get3Point( x+1, y, z, theIm ) >  0.0 )
								continue;
							buf[i] |= 0xff;
							continue;
						}
						if ( T_Get3Point( x+1, y, z, theIm ) <=  0.0 )
							continue;
						buf[j] |= 0xff; 
					}
				}
			}
			/*--- zero-crossings along Y ---*/
			if ( dy > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( x = 0; x < dx; x++ ) {
					i = z*dxy + x;   j = i+dx;
					for ( y = 0; y < dy1; y++, i+=dx, j+=dx ) {
						if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
							if ( T_Get3Point( x, y+1, z, theIm ) >  0.0 )
								continue;
							buf[i] |= 0xff;
							continue;
						}
						if ( T_Get3Point( x, y+1, z, theIm ) <=  0.0 )
							continue;
						buf[j] |= 0xff; 
					}
				}
		        }
			if ( mode == MODE_2D ) break;
			/*--- zero-crossings along Z ---*/
			if ( dz > 1 ) {
				for ( y = 0; y < dy; y++ )
				for ( x = 0; x < dx; x++ ) {
					i = y*dx + x;   j = i+dxy;
					for ( z = 0; z < dz1; z++, i+=dxy, j+=dxy ) {
						if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
							if ( T_Get3Point( x, y, z+1, theIm ) >  0.0 )
								continue;
							buf[i] |= 0xff;
							continue;
						}
						if ( T_Get3Point( x, y, z+1, theIm ) <=  0.0 )
							continue;
						buf[j] |= 0xff; 
					}
				}
			}
		}}
		return( TRUE );
	case TYPEIM_16B :
		{
		unsigned short int *buf;
		buf = (unsigned short int*)resIm->buf;
		switch (theIm->type) {
		case TYPEIM_S16B :
			{
			short int *tmp;
			tmp = (short int*)theIm->buf;
			/*--- zero-crossings along X ---*/
			if ( dx > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( y = 0; y < dy; y++ ) {
					i = z*dxy + y*dx;   j = i+1;
					for ( x = 0; x < dx1; x++, i++, j++ ) {
						if ( tmp[i] > 0 ) {
							if ( tmp[j] > 0 ) continue;
							buf[i] = (unsigned short int)65535;  continue;
						}
						if ( tmp[j] <= 0 ) continue;
						buf[j] = (unsigned short int)65535; 
					}
				}
			}
			/*--- zero-crossings along Y ---*/
			if ( dy > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( x = 0; x < dx; x++ ) {
					i = z*dxy + x;   j = i+dx;
					for ( y = 0; y < dy1; y++, i+=dx, j+=dx ) {
						if ( tmp[i] > 0 ) {
							if ( tmp[j] > 0 ) continue;
							buf[i] = (unsigned short int)65535;  continue;
						}
						if ( tmp[j] <= 0 ) continue;
						buf[j] = (unsigned short int)65535; 
					}
				}
		        }
			if ( mode == MODE_2D ) break;
			/*--- zero-crossings along Z ---*/
			if ( dz > 1 ) {
				for ( y = 0; y < dy; y++ )
				for ( x = 0; x < dx; x++ ) {
					i = y*dx + x;   j = i+dxy;
					for ( z = 0; z < dz1; z++, i+=dxy, j+=dxy ) {
						if ( tmp[i] > 0 ) {
							if ( tmp[j] > 0 ) continue;
							buf[i] = (unsigned short int)65535;  continue;
						}
						if ( tmp[j] <= 0 ) continue;
						buf[j] = (unsigned short int)65535; 
					}
				}
			}}
			break;
		case TYPEIM_FLOAT :
			{
			float *tmp;
			tmp = (float*)theIm->buf;
			/*--- zero-crossings along X ---*/
			if ( dx > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( y = 0; y < dy; y++ ) {
					i = z*dxy + y*dx;   j = i+1;
					for ( x = 0; x < dx1; x++, i++, j++ ) {
						if ( tmp[i] > 0.0 ) {
							if ( tmp[j] > 0.0 ) continue;
							buf[i] = (unsigned short int)65535;  continue;
						}
						if ( tmp[j] <= 0.0 ) continue;
						buf[j] = (unsigned short int)65535; 
					}
				}
			}
			/*--- zero-crossings along Y ---*/
			if ( dy > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( x = 0; x < dx; x++ ) {
					i = z*dxy + x;   j = i+dx;
					for ( y = 0; y < dy1; y++, i+=dx, j+=dx ) {
						if ( tmp[i] > 0.0 ) {
							if ( tmp[j] > 0.0 ) continue;
							buf[i] = (unsigned short int)65535;  continue;
						}
						if ( tmp[j] <= 0.0 ) continue;
						buf[j] = (unsigned short int)65535; 
					}
				}
		        }
			if ( mode == MODE_2D ) break;
			/*--- zero-crossings along Z ---*/
			if ( dz > 1 ) {
				for ( y = 0; y < dy; y++ )
				for ( x = 0; x < dx; x++ ) {
					i = y*dx + x;   j = i+dxy;
					for ( z = 0; z < dz1; z++, i+=dxy, j+=dxy ) {
						if ( tmp[i] > 0.0 ) {
							if ( tmp[j] > 0.0 ) continue;
							buf[i] = (unsigned short int)65535;  continue;
						}
						if ( tmp[j] <= 0.0 ) continue;
						buf[j] = (unsigned short int)65535; 
					}
				}
			}}
			break;
	      default :
			/*--- zero-crossings along X ---*/
			if ( dx > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( y = 0; y < dy; y++ ) {
					i = z*dxy + y*dx;   j = i+1;
					for ( x = 0; x < dx1; x++, i++, j++ ) {
						if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
							if ( T_Get3Point( x+1, y, z, theIm ) >  0.0 )
								continue;
							buf[i] = (unsigned short int)65535;
							continue;
						}
						if ( T_Get3Point( x+1, y, z, theIm ) <=  0.0 )
							continue;
						buf[j] = (unsigned short int)65535; 
					}
				}
			}
			/*--- zero-crossings along Y ---*/
			if ( dy > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( x = 0; x < dx; x++ ) {
					i = z*dxy + x;   j = i+dx;
					for ( y = 0; y < dy1; y++, i+=dx, j+=dx ) {
						if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
							if ( T_Get3Point( x, y+1, z, theIm ) >  0.0 )
								continue;
							buf[i] = (unsigned short int)65535;
							continue;
						}
						if ( T_Get3Point( x, y+1, z, theIm ) <=  0.0 )
							continue;
						buf[j] = (unsigned short int)65535; 
					}
				}
		        }
			if ( mode == MODE_2D ) break;
			/*--- zero-crossings along Z ---*/
			if ( dz > 1 ) {
				for ( y = 0; y < dy; y++ )
				for ( x = 0; x < dx; x++ ) {
					i = y*dx + x;   j = i+dxy;
					for ( z = 0; z < dz1; z++, i+=dxy, j+=dxy ) {
						if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
							if ( T_Get3Point( x, y, z+1, theIm ) >  0.0 )
								continue;
							buf[i] = (unsigned short int)65535;
							continue;
						}
						if ( T_Get3Point( x, y, z+1, theIm ) <=  0.0 )
							continue;
						buf[j] = (unsigned short int)65535; 
					}
				}
			}
		}}
		return( TRUE );
	case TYPEIM_S16B :
		{
		short int *buf;
		buf = (short int*)resIm->buf;
		switch (theIm->type) {
		case TYPEIM_S16B :
			{
			short int *tmp;
			tmp = (short int*)theIm->buf;
			/*--- zero-crossings along X ---*/
			if ( dx > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( y = 0; y < dy; y++ ) {
					i = z*dxy + y*dx;   j = i+1;
					for ( x = 0; x < dx1; x++, i++, j++ ) {
						if ( tmp[i] > 0 ) {
							if ( tmp[j] > 0 ) continue;
							buf[i] = (short int)32767;  continue;
						}
						if ( tmp[j] <= 0 ) continue;
						buf[j] = (short int)32767; 
					}
				}
			}
			/*--- zero-crossings along Y ---*/
			if ( dy > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( x = 0; x < dx; x++ ) {
					i = z*dxy + x;   j = i+dx;
					for ( y = 0; y < dy1; y++, i+=dx, j+=dx ) {
						if ( tmp[i] > 0 ) {
							if ( tmp[j] > 0 ) continue;
							buf[i] = (short int)32767;  continue;
						}
						if ( tmp[j] <= 0 ) continue;
						buf[j] = (short int)32767; 
					}
				}
		        }
			if ( mode == MODE_2D ) break;
			/*--- zero-crossings along Z ---*/
			if ( dz > 1 ) {
				for ( y = 0; y < dy; y++ )
				for ( x = 0; x < dx; x++ ) {
					i = y*dx + x;   j = i+dxy;
					for ( z = 0; z < dz1; z++, i+=dxy, j+=dxy ) {
						if ( tmp[i] > 0 ) {
							if ( tmp[j] > 0 ) continue;
							buf[i] = (short int)32767;  continue;
						}
						if ( tmp[j] <= 0 ) continue;
						buf[j] = (short int)32767; 
					}
				}
			}}
			break;
		case TYPEIM_FLOAT :
			{
			float *tmp;
			tmp = (float*)theIm->buf;
			/*--- zero-crossings along X ---*/
			if ( dx > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( y = 0; y < dy; y++ ) {
					i = z*dxy + y*dx;   j = i+1;
					for ( x = 0; x < dx1; x++, i++, j++ ) {
						if ( tmp[i] > 0.0 ) {
							if ( tmp[j] > 0.0 ) continue;
							buf[i] = (short int)32767;  continue;
						}
						if ( tmp[j] <= 0.0 ) continue;
						buf[j] = (short int)32767; 
					}
				}
			}
			/*--- zero-crossings along Y ---*/
			if ( dy > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( x = 0; x < dx; x++ ) {
					i = z*dxy + x;   j = i+dx;
					for ( y = 0; y < dy1; y++, i+=dx, j+=dx ) {
						if ( tmp[i] > 0.0 ) {
							if ( tmp[j] > 0.0 ) continue;
							buf[i] = (short int)32767;  continue;
						}
						if ( tmp[j] <= 0.0 ) continue;
						buf[j] = (short int)32767; 
					}
				}
		        }
			if ( mode == MODE_2D ) break;
			/*--- zero-crossings along Z ---*/
			if ( dz > 1 ) {
				for ( y = 0; y < dy; y++ )
				for ( x = 0; x < dx; x++ ) {
					i = y*dx + x;   j = i+dxy;
					for ( z = 0; z < dz1; z++, i+=dxy, j+=dxy ) {
						if ( tmp[i] > 0.0 ) {
							if ( tmp[j] > 0.0 ) continue;
							buf[i] = (short int)32767;  continue;
						}
						if ( tmp[j] <= 0.0 ) continue;
						buf[j] = (short int)32767; 
					}
				}
			}}
			break;
	      default :
			/*--- zero-crossings along X ---*/
			if ( dx > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( y = 0; y < dy; y++ ) {
					i = z*dxy + y*dx;   j = i+1;
					for ( x = 0; x < dx1; x++, i++, j++ ) {
						if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
							if ( T_Get3Point( x+1, y, z, theIm ) >  0.0 )
								continue;
							buf[i] = (short int)32767;
							continue;
						}
						if ( T_Get3Point( x+1, y, z, theIm ) <=  0.0 )
							continue;
						buf[j] = (short int)32767; 
					}
				}
			}
			/*--- zero-crossings along Y ---*/
			if ( dy > 1 ) {
				for ( z = 0; z < dz; z++ ) 
				for ( x = 0; x < dx; x++ ) {
					i = z*dxy + x;   j = i+dx;
					for ( y = 0; y < dy1; y++, i+=dx, j+=dx ) {
						if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
							if ( T_Get3Point( x, y+1, z, theIm ) >  0.0 )
								continue;
							buf[i] = (short int)32767;
							continue;
						}
						if ( T_Get3Point( x, y+1, z, theIm ) <=  0.0 )
							continue;
						buf[j] = (short int)32767; 
					}
				}
		        }
			if ( mode == MODE_2D ) break;
			/*--- zero-crossings along Z ---*/
			if ( dz > 1 ) {
				for ( y = 0; y < dy; y++ )
				for ( x = 0; x < dx; x++ ) {
					i = y*dx + x;   j = i+dxy;
					for ( z = 0; z < dz1; z++, i+=dxy, j+=dxy ) {
						if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
							if ( T_Get3Point( x, y, z+1, theIm ) >  0.0 )
								continue;
							buf[i] = (short int)32767;
							continue;
						}
						if ( T_Get3Point( x, y, z+1, theIm ) <=  0.0 )
							continue;
						buf[j] = (short int)32767; 
					}
				}
			}
		}}
		return( TRUE );
	default :
		/*--- resIm->type != TYPEIM_256 ---*/
		/*--- zero-crossings along X ---*/
		if ( dx > 1 ) {
			for ( z = 0; z < dz; z++ ) 
			for ( y = 0; y < dy; y++ ) 
			for ( x = 0; x < dx1; x++ ) {
				if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
					if ( T_Get3Point( x+1, y, z, theIm ) >  0.0 )
						continue;
					T_Set3Point( x, y, z, resIm, (reeltype)1.0, (char)MODE_SET );
					continue;
				}
				if ( T_Get3Point( x+1, y, z, theIm ) <=  0.0 )
					continue;
				T_Set3Point( x+1, y, z, resIm, (reeltype)1.0, (char)MODE_SET );
			}
		}
		/*--- zero-crossings along Y ---*/
		if ( dy > 1 ) {
			for ( z = 0; z < dz; z++ ) 
			for ( x = 0; x < dx; x++ ) 
			for ( y = 0; y < dy1; y++ ) {
				if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
					if ( T_Get3Point( x, y+1, z, theIm ) >  0.0 )
						continue;
					T_Set3Point( x, y, z, resIm, (reeltype)1.0, (char)MODE_SET );
					continue;
				}
				if ( T_Get3Point( x, y+1, z, theIm ) <=  0.0 )
					continue;
				T_Set3Point( x, y+1, z, resIm, (reeltype)1.0, (char)MODE_SET );
			}
		}
		if ( mode == MODE_2D ) return( TRUE );
		/*--- zero-crossings along Z ---*/
		if ( dz > 1 ) {
			for ( x = 0; x < dx; x++ ) 
			for ( y = 0; y < dy; y++ ) 
			for ( z = 0; z < dz1; z++ ) {
				if ( T_Get3Point( x, y, z, theIm ) > 0.0 ) {
					if ( T_Get3Point( x, y, z+1, theIm ) >  0.0 )
						continue;
					T_Set3Point( x, y, z, resIm, (reeltype)1.0, (char)MODE_SET );
					continue;
				}
				if ( T_Get3Point( x, y, z+1, theIm ) <=  0.0 )
					continue;
				T_Set3Point( x, y, z+1, resIm, (reeltype)1.0, (char)MODE_SET );
			}
		}
		return( TRUE );
	}
}	

/* Procedure de copie d'une image dans une autre avec conversion.

   La conversion tient compte de la normalisation
   effectuee par T_Get3Point et T_Set3Point. 

   Les 2 images doivent deja etre allouees.
*/

#if defined(_ANSI_)
int E_CopyImage( t_Image *theIm /* input image */,
		 t_Image *resIm /* output image */ )
#else
int E_CopyImage( theIm, resIm )
t_Image *theIm; /* input image */
t_Image *resIm; /* output image */
#endif
{
    register int z, y, x, i;
    int dz, dxy;
    register double mul = 1.0;
    double *tmp;

    E_ERR( (theIm==NULL) || (theIm->buf==NULL), E_ERRNULL, FALSE,
	   "E_CopyImage", "input image not allocated");
    E_ERR( (resIm==NULL) || (resIm->buf==NULL), E_ERRNULL, FALSE,
	   "E_CopyImage", "output image not allocated");
    E_ERR( (theIm->tx != resIm->tx) || (theIm->ty != resIm->ty) || (theIm->tz != resIm->tz),
	   E_ERRNULL, FALSE, "E_CopyImage", "images have different dimensions");

    /*--- initialisations ---*/
    dz = theIm->tz;
    dxy = theIm->tx * theIm->ty;
    switch ( theIm->type ) {
    case TYPEIM_256 :
	mul = 1.0 / (double)255.0;
	break;
    case TYPEIM_16B :
	mul = 1.0 / (double)65535.0;
	break;
    case TYPEIM_S16B :
	mul = 1.0 / (double)32767.0;
	break;
    default :
	mul = 1.0;
    }
    switch ( resIm->type ) {
    case TYPEIM_256 :
	mul *= (double)255.0;
	break;
    case TYPEIM_16B :
	mul *= (double)65535.0;
	break;
    case TYPEIM_S16B :
	mul *= (double)32767.0;
	break;
    default :
	mul *= 1.0;
    }
    tmp = (double*)T_Alloc( (unsigned)(dxy * sizeof(double)) );
    E_ISERR(FALSE, "E_CopyImage", "no more memory");

    for ( z = 0; z < dz; z++ ) {
	switch ( theIm->type ) {
	case TYPEIM_256 :
            {
	    unsigned char *buf;
	    buf = (unsigned char*)(theIm->buf);
	    buf += z * dxy;
	    for ( i = 0; i < dxy ; i++ ) tmp[i] = (double)(*buf++);
	    }
	    break;
	case TYPEIM_16B :
            {
	    unsigned short int *buf;
	    buf = (unsigned short int*)(theIm->buf);
	    buf += z * dxy;
	    for ( i = 0; i < dxy ; i++ ) tmp[i] = (double)(*buf++);
	    }
	    break;
	case TYPEIM_S16B :
            {
	    short int *buf;
	    buf = (short int*)(theIm->buf);
	    buf += z * dxy;
	    for ( i = 0; i < dxy ; i++ ) tmp[i] = (double)(*buf++);
	    }
	    break;
	case TYPEIM_FLOAT :
	    {
	    float *buf;
	    buf = (float*)(theIm->buf);
	    buf += z * dxy;
	    for ( i = 0; i < dxy ; i++ ) tmp[i] = (double)(*buf++);
	    }
	    break;
	default :
	    i = 0;
	    for ( y = 0; y < theIm->ty ; y++ )
	    for ( x = 0; x < theIm->tx ; x++ )
		tmp[i++] = (double)( T_Get3Point( x, y, z, theIm ) );
	}

	for ( i = 0; i < dxy ; i++ ) tmp[i] *= mul;

	switch ( resIm->type ) {
	case TYPEIM_256 :
            {
	    unsigned char *buf;
	    buf = (unsigned char*)(resIm->buf);
	    buf += z * dxy;
	    for ( i = 0; i < dxy ; i++ ) {
		if ( tmp[i] > 255.0 )     buf[i] = (unsigned char)255;
		else if ( tmp[i] <= 0.0 ) buf[i] = (unsigned char)0;
		else                      buf[i] = (unsigned char)(tmp[i] + 0.5);
	    }}
	    break;
	case TYPEIM_16B :
            {
	    unsigned short int *buf;
	    buf = (unsigned short int*)(resIm->buf);
	    buf += z * dxy;
	    for ( i = 0; i < dxy ; i++ ) {
		if ( tmp[i] > 65535.0 )   buf[i] = (unsigned short int)65535;
		else if ( tmp[i] <= 0.0 ) buf[i] = (unsigned short int)0;
		else                      buf[i] = (unsigned short int)(tmp[i] + 0.5);
	    }}
	    break;
	case TYPEIM_S16B :
            {
	    short int *buf;
	    buf = (short int*)(resIm->buf);
	    buf += z * dxy;
	    for ( i = 0; i < dxy ; i++ ) {
		if ( tmp[i] > 32767.0 )        buf[i] = (short int)32767;
		else if ( tmp[i] <= -32768.0 ) buf[i] = (short int)(-32768);
		/*--- cette ligne plante avec l'optimisateur de gcc 2.7.0
		else buf[i] = (tmp[i] < 0) ? (short int)(tmp[i] - 0.5) : (short int)(tmp[i] + 0.5);
		---*/
		else { 
		    if ( tmp[i] < 0 ) buf[i] = (short int)(tmp[i] - 0.5);
		    else              buf[i] = (short int)(tmp[i] + 0.5);
		}
	    }}
	    break;
	case TYPEIM_FLOAT :
	    {
	    float *buf;
	    buf = (float*)(resIm->buf);
	    buf += z * dxy;
	    for ( i = 0; i < dxy ; i++ ) *buf++ = (float)(tmp[i]);
	    }
	    break;
	default :
	    i = 0;
	    for ( y = 0; y < theIm->ty ; y++ )
	    for ( x = 0; x < theIm->tx ; x++ )
		T_Set3Point( x, y, z, resIm, (float)( tmp[i++] ), MODE_SET );
	}
    }
    T_Free( (void**)(&tmp) );
    return( TRUE );
}



