/* epi_logic.c 2.1 5/14/98 */

#include <epidaure.h>
#include <epidaure.ee>

/* Inversion logique d'un buffer.

*/

#if defined(_ANSI_)
void E_InverseBits( char *tab /* buffer to be inversed */, 
		   int taille /* size of the buffer, when considered as char* */ )
#else
void E_InverseBits( tab , taille)
char *tab;  /* buffer to be inversed */
int taille; /* size of the buffer, when considered as char* */
#endif
{
        register int i;

        for (i=0;i<taille;i++)
                *tab++ ^= 0xff;
}

/* "ET" logique entre deux buffers.

*/

#if defined(_ANSI_)
void E_LogicAnd( char *tab1 /* first buffer */, 
		char *tab2 /* second buffer */, 
		char *tab3 /* result buffer */, 
		int taille /* size of the buffer, when considered as char* */ )
#else
void E_LogicAnd( tab1, tab2, tab3, taille )
char *tab1; /* first buffer */
char *tab2; /* second buffer */
char *tab3; /* result buffer */
int taille; /* size of the buffer, when considered as char* */
#endif
{
        register int i;
        for (i=0;i<taille;i++)
                *tab3++ = *tab1++ & *tab2++;
}

/* "OU" logique entre deux buffers.

*/

#if defined(_ANSI_)
void E_LogicOr( char *tab1 /* first buffer */, 
		char *tab2 /* second buffer */, 
		char *tab3 /* result buffer */, 
		int taille /* size of the buffer, when considered as char* */ )
#else
void E_LogicOr(tab1, tab2, tab3, taille)
char *tab1; /* first buffer */
char *tab2; /* second buffer */
char *tab3; /* result buffer */
int taille; /* size of the buffer, when considered as char* */
#endif
{
        register int i;
        for (i=0;i<taille;i++)
                *tab3++ = *tab1++ | *tab2++;
}

/* "XOU" logique (OU exclusif) entre deux buffers.

*/

#if defined(_ANSI_)
void E_LogicXor( char *tab1 /* first buffer */, 
		char *tab2 /* second buffer */, 
		char *tab3 /* result buffer */, 
		int taille /* size of the buffer, when considered as char* */ )
#else
void E_LogicXor(tab1, tab2, tab3, taille)
char *tab1; /* first buffer */
char *tab2; /* second buffer */
char *tab3; /* result buffer */
int taille; /* size of the buffer, when considered as char* */
#endif
{
        register int i;
        for (i=0;i<taille;i++)
                *tab3++ = *tab1++ ^ *tab2++;
}

/* Swap d'octets dans un buffer.

   Cette procedure sert a swapper les buffers codes
   sur 2 octets. Attention, la taille passee est la
   taille des buffers en sizeof(char) et non en
   sizeof(short int).
*/

#if defined(_ANSI_)
void E_Swap2octets( char *tab1 /* buffer to be swapped */, 
		   char *tab2 /* result buffer */, 
		   int taille /* size of the buffer, when considered as char* */ )
#else 
void E_Swap2octets( tab1, tab2, taille )
char *tab1; /* buffer to be swapped */
char *tab2; /* result buffer */
int taille; /* size of the buffer, when considered as char* */
#endif
{
	/*--- attention : taille designe la taille des buffers en sizeof(char) ---*/
	/*--- (rendue par T_ImageSize(), et non en sizeof(short int)           ---*/

	register int i;
	register char t;
	char *c1, *c2;
	short int *s1, *s2;

	s1 = (short int*)tab1;
	s2 = (short int*)tab2;
	for ( i=0; i<taille; i+=2 ) {
		c1 = (char*)(s1++);
		c2 = (char*)(s2++);
		t = c1[0];
		c2[0] = c1[1];
		c2[1] = t;
	}
}

