/* epi_math.h 2.1 5/14/98 */
/*==========================================================================
*
* File : $EPI/include/epi_math.h
* Module : ?
* $ Id : ?
* Test file :
* Author : S Benayoun & J-P Thirion
* Creation: July 27, 1993
*===========================================================================
*   (c) Copyright 1992-93, Inria, all right reserved
*===========================================================================
*
*------------------------------Description----------------------------------
*
* Operations mathematiques et matricielles
*
*-----------------------------Modification----------------------------------
*
*/

/*=========================================================================*/
/*
    epi_math.h

  General mathematical operations on points and matrices

    S. Benayoun and J-P Thirion
*/
/*=========================================================================*/


#ifndef _epi_math_h_
#define _epi_math_h_

#define E_GCONJ_POLAK 1
#define E_GCONJ_FLETCHER 2
#define NB_TAB 5

#define  NON_AFFICHAGE 0
#define  AFFICHAGE 1

#ifndef NO_PROTO
typedef void (*t_GCP_func_type)( t_MatPtr, t_NPointPtr, t_NPointPtr );
#else
typedef void (*t_GCP_func_type)( );
#endif

typedef struct t_GradConjPar{

reeltype eps;
int nbIterMax;
int nbIter;
reeltype vtest;
t_GCP_func_type func;
int mode;
int affiche;

} t_GradConjPar, *t_GradConjParPtr;


typedef struct t_FastGradConjPar{

reeltype eps;
int nbIterMax;
int nbIter;
reeltype vtest;
t_GCP_func_type func;
int affiche;

} t_FastGradConjPar, *t_FastGradConjParPtr;

#endif /* _epi_math_h_ */
