/* epi_morpho.h 2.1 5/14/98 */
#ifndef _epi_morpho_h_
#define _epi_morpho_h_

/*-------------------------------------------------------------------------
*   parameters of mathematical morphology
*------------------------------------------------------------------------*/

#define DILATION 1
#define EROSION 2
#define CLOSING 3
#define OPENING 4
#define CDILATION 5
#define CEROSION 6
#define MGRADIENT 7
#define MCONTRAST 8
#define MLAPLACIAN 9

#define GRADIENT 1
#define ZEROCROSS 2

#define EPI_MAX(A,B) ( (A) > (B) ? (A) : (B) )
#define EPI_MIN(A,B) ( (A) < (B) ? (A) : (B) )

typedef struct e_ParamMorpho{
	int operation;       /* type of the morphological operation */
	int order;           /* size of the operation */
	int connexite;       /* type of the connectivity */
	int mode;            /* mode 2D ou 3D */
	int binaire;         /* mode binaire ? */
	int scnd_op;         /* second operation (morphological laplacian */
} e_ParamMorpho, *e_ParamMorphoPtr;

#endif
