/* epi_recfilt.h 2.2 5/14/98 */
#ifndef _epi_recfilt_h_
#define _epi_recfilt_h_

#define MODE_2D 2
#define MODE_3D 3

#define BORD_TORUS 1
#define BORD_MIRROR 2
#define BORD_CONT 3

#define ESTI_NEAREST 1
#define ESTI_D1      2
#define ESTI_EUCLI   3
#define ESTI_D2      4
#define ESTI_LINEAR  5 

/*-------------------------------------------------------------------------
*   parameters of recursive filtering :
*
*   the value of derive? must be 0, 1, 2 or 3, else there is no filtering
*   the value of alpha? must be in the range [0.5,1.5]
*------------------------------------------------------------------------*/
typedef struct e_ParamRecFil{
	int deriveX;         /* order of filtering along the X axis */
	int deriveY;         /* order of filtering along the Y axis */
	int deriveZ;         /* order of filtering along the Z axis */
	float alphaX;        /* value of coeff. for the filtering along the X axis */
	float alphaY;        /* value of coeff. for the filtering along the Y axis */
	float alphaZ;        /* value of coeff. for the filtering along the Z axis */
	int bord_typeX;      /* border type : torus or mirror */
	int bord_longX;      /* number of external points */
	int bord_typeY; 
	int bord_longY;
	int bord_typeZ; 
	int bord_longZ;
	int extr_mode;
	int esti_mode;
	int norm_mode;       /* normalization: gaussien or default */
	int verb;            /* messages */
} e_ParamRecFil, *e_ParamRecFilPtr;

typedef struct e_CoeffRecFil{
	float d1, d2, d3, d4;         /* denominateur       */
	float p0, p1, p2, p3;         /* numerateur positif */
	float n0, n1, n2, n3, n4;     /* numerateur negatif */
} e_CoeffRecFil, *e_CoeffRecFilPtr;

#endif
