/* epi_reech.h 2.1 5/14/98 */

/*==========================================================================*/
/*
    epi_reech.h

  Resample 3D images

  Resample a 3D image into another 3D image with a 3D geometric transform,
  using spline interpolation

  (c) Jean-Philippe THIRION & Andre' Gueziec -- INRIA -- 9/3/92
*/
/*==========================================================================*/

#ifndef _epi_reech_h_
#define _epi_reech_h_

#ifndef _epi_kernel_
#include <epi_kernel.h>
#endif

#ifndef _epi_spline_
#include <epi_spline.h>
#endif

typedef struct t_ReechPar{		/* general structure for resampling		*/
  
  ReechParPtr_func_type func;	/* resampling function					*/
  sPar_ SPline;					/* special data structure for splines	*/
  int verbose;				/* print messages						*/
  
} t_ReechPar, *t_ReechParPtr;

#endif
