/* epi_spline.h 2.1 5/14/98 */
#ifndef _epi_spline_h_
#define _epi_spline_h_

/*****************************************************************************/
/* 
          spline  parameters  are defined within this file  
*/
/*****************************************************************************/

typedef struct SPar{
	int             *Inf,*Jnf,*Knf;
	float           *U,*V,*W,*UNIF,*VNIF,*WNIF; /* parametrisation */
	float           *BspU,*BspV,*BspW;
	float           *CspU,*CspV,*CspW;
	float           *UUt,*VVt,*WWt; /*  NAG specifications*/
	float           *LLt,*Gvt,*VUt,taux,tauy,tauz;
	int              De,desQ,des0,des1,des2,des3,m;
	/*spline degree */
	
	/* VUt is the spline coefficient matrix : c_x */

} sPar_, *sPtr;

typedef struct CurveDer{
	float *x,*xu,*xuu,*xuuu;
}cDer,*cDerP;

typedef struct CurveSurfPar{
	/* all these parameters come from a spline approximation */

	float u, s_u, ks_u3;
	float x[3],xu[3],xuu[3],xuuu[3]; /* 3 derivatives */
	float r[3]; /* surface frame as a rotation vector*/
	float rsf[3]; /* rotation vector CURVE->SURFACE frame */
	
	float k,tau; /* curvature, torsion */
	float kn_theta,kg_theta; /* normal curvature, geodesic curvature */
	float taug_N,taug_euler;  /* geodesic torsion */
	float k1,k2; /* principle curvatures */
	float t[3],n[3],b[3]; /* frenet frame b= t^n*/
	         /* curvature vector k n : tangential component kg*/
	         /*   p 153 DoCarmo     : normal  component kn k^2=kg^2+kn^2*/
	      
	float /*t[3],*/ g[3],N[3],Nu[3]; /* darboux frame g=N^t*/
	           /* kn =(t_s,N) we have it already (k n,N) = k cos(theta)*/
	           /* kg =(t_s,g) =(t_s,N^t) =(t_s,N,t)=(k n,N,t) ksin(theta)*/
                   /* taug = (g_s,N)=(N_s,t,n) */
	float e1[3],e2[3]; /* principle directions */
	float theta; /* (N,n)angle between normals */
	           /* tau-taug = theta_s p 153 DoCarmo */
	float cos_theta,sin_theta;          
	float phi; /* (e1,t) angle between tangents */
	float rho; /* (e2,b) angle between binormals */
	float cos_phi,sin_phi;          
	           /* taug=(k1-k2)cos(phi)sin(phi) p 153 DoCarmo*/
	           /*  kn =k1cos^2(phi)+k2sin^2(phi)=k*cos(theta)*/
	float kn_euler;  /*  TEST : k1cos^2(phi)-k2sin^2(phi) */
	float psi,cos_psi; /* angle between N and t */
	float alpha; /* angle between Nu and N should be = 0*/
	float beta; /* angle between Nu and t */
	            /* (Ns,t)=kn  (Nu,t)= kn*s_u */
	float kn_N; /* (Nu,t)/s_u */
	float kg_t; /* (t_s,N,t)=(xuu,N,t)/s_u^2 */
	
} cSPar, *cSPtr,**cSHand;

/*****************************************************************************/

#endif
