#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#include <modules/TclModule.h>
#include <imagedata/IntensityProfile.h>
#include <imagedata/TclRangeInrimage3D.h>
#include <imagedata/TclRangeInrimage2D.h>
#include <imagedata/TclImage3DViewer.h>
#include <imagedata/TclIntensityProfile.h>
#include <imagedata/ImageDataCmd.h>

#ifdef EMBEDED_TCL_SCRIPTS
#include "tclImageData.tcl.h" // generated by tcl2h
#endif

namespace yav {

const char *TclImageDataInit::tclImageDataName="tclImageData";

static TclImageDataInit tclImageDataInit;

void Tclimagedata_Init(TclModule *m)
{
	TclModule *tclinr = TclModule::findModuleByName("tclInrimage");

	if(!tclinr)
	{
		CERR << "Tclimagedata_Init: fatal error: module tclInrimage not loaded" << ENDL;
		exit(-1);
	}

	/** add ability to load an Intensity Profile from a file */
	RangeInformation::readFunctionMap[IntensityProfileInformation::informationName]=IntensityProfileInformation::readIntensityProfile;
	/** add ability to load gradient information from a file */
	RangeInformation::readFunctionMap[GradientInrimageInformation::informationName]=GradientInrimageInformation::readGradientInformation;
	/** add ability to load region information from a file */
	RangeInformation::readFunctionMap[RegionInrimageInformation::informationName]=RegionInrimageInformation::readRegionInformation;
	/** add ability to load gradient gradient information from a file */
	RangeInformation::readFunctionMap[GradientGradientInrimageInformation::informationName]=GradientGradientInrimageInformation::readGradientGradientInformation;
	/** add ability to load gradient balloon information from a file */
	RangeInformation::readFunctionMap[GradientBalloonInrimageInformation::informationName]=GradientBalloonInrimageInformation::readGradientBalloonInformation;
	/** add ability to load classify information from a file */
	RangeInformation::readFunctionMap[ClassInrimageInformation::informationName]=ClassInrimageInformation::readClassInformation;
	/** add ability to load classify information from a file */
	RangeInformation::readFunctionMap[IntensityProfileInformation::informationName]=IntensityProfileInformation::readIntensityProfile;
	/** add ability to load block matching information from a file */
	RangeInformation::readFunctionMap[BlockMatchingInformation::informationName]=BlockMatchingInformation::readBlockMatchingInformation;

	TclRangeInrimage::createCommands(m);
#ifdef old
	kind = new Scene3DItem(m, typeid(TclImageData), "img3D","3D Image Display", &TclImageData::create, &TclImageData::list, TclScene3D::FILE | TclScene3D::OTHER, "", ".inr,.inr.gz", &TclImageData::load, 0, "<filename=%s|inr%u> [-scene scn3D%u]");

	m->newCommand("img3D%u", kind->getOptions(), "3D image viewer management command");

	kind->newOption("-scene", (TclObject::OPTION) &TclImageData::sceneCmd, 0,
			"return the scene where is the img3D");
	kind->newOption("-destroy", (TclObject::OPTION) &TclImageData::destroyCmd, 0,
			"destroy this data image");
	kind->newOption("-box", (TclObject::OPTION) &TclImageData::boxCmd,
			"[width %f] [color %f %f %f]",
			"get/set bounding box line widht and color");
	kind->newOption("-grid", (TclObject::OPTION) &TclImageData::gridCmd,
			"[frame|grid|voxel] [width %f] [color %f %f %f]",
			"get/set grid display mode, width and color");
	kind->newOption("-display", (TclObject::OPTION) &TclImageData::displayCmd,
			"[intensity | gradient | direction]",
			"get/set displayed inrimage kind");
	kind->newOption("-render", (TclObject::OPTION) &TclImageData::renderCmd,
			"[none|solid|texture|volume]",
			"get/set image slices rendering mode");
	kind->newOption("-resolution",
			(TclObject::OPTION) &TclImageData::resolutionCmd, "[%u]",
			"get/set image rendering resolution");
	kind->newOption("-showBlackPixels",
			(TclObject::OPTION) &TclImageData::showBlackPixelsCmd, "[%b]",
			"get/set boolean if black pixels should be displayed");
	kind->newOption("-transparency",
			(TclObject::OPTION) &TclImageData::transparencyCmd,
			"[true [%f] | false]",
			"enable (with given opacity)/disable slice transparency");
	kind->newOption("-texture", (TclObject::OPTION) &TclImageData::textureCmd,
			"[mapping <decal | modulate | blend>] [bg <%f %f %f %f>]",
			"set texture options");
	kind->newOption("-inrimage", (TclObject::OPTION) &TclImageData::inrimageCmd,
			0,"get the inrimage being displayed");
	kind->newOption("-volume", (TclObject::OPTION) &TclImageData::volumeCmd,
			"[nslices %u] [minGreyLevel %f] [maxGreyLevel %f] [blending <over | attenuate | MIP | under>] [transparency %s %s %s %s %f]",
			"Get/set volume rendering parameters (number of slices and blending mode). The transparency option allow to specify four tcl variable arrays corresponding to R, G, B and A component for lookup table and an overall blending coefficient. The min/max grey level option allows to perform windowing for volume rendering (transparent outside the grey level range)");
#endif
	TclImage3DViewer::createCommands(m);
	TclRangeInrimage3D::createCommands(m);
	TclRangeInrimage2D::createCommands(m);
#ifdef EMBEDED_TCL_SCRIPTS
	/* Statically loads the tcl script from tclModules.tcl.h (generated by tcl2h) */
	Tcl_Eval(m->getInterp(), tclImageData_tcl);
	/* Tell the TclModule constructor not to load the script again */
	m->tclScriptLoaded();
#endif
/* Otherwise, the tcl script will be loaded dynamically from tclModules.tcl by the TclModule constructor */
}
#ifdef _SOLARIS_
int main() {}
#endif
}
