#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#include <imagedata/RangeInrimage3D.h>


namespace yav {

RangeInrimage3D::RangeInrimage3D(Inrimage *intensity, 
				 Inrimage *gradient, Inrimage *gradientdir,
				 Inrimage *edge, Inrimage *gradient2,
				 Inrimage *classify, bool allCameras)
  throw(Inrimage::ImageNotFound, Inrimage::UnknownImageType,
	Inrimage::InvalidHeader, Inrimage::InvalidData,
	Inrimage::UnknownType)
  : RangeInrimage(intensity, gradient, gradientdir, edge, gradient2, classify)
 {
  initFormat();
}


RangeInrimage3D::RangeInrimage3D(const TclString& fileName,
				 bool allCameras)
  throw(Inrimage::ImageNotFound, Inrimage::UnknownImageType,
	Inrimage::InvalidHeader, Inrimage::InvalidData,
	Inrimage::UnknownType)
  :  RangeInrimage(fileName)
 {
   initFormat();
}


RangeInrimage3D::~RangeInrimage3D() {
}

bool RangeInrimage3D::getClosestPoint(const Vec3<double> &position,
				      const Vec3<double> &normal,
				      const double range,
				      Vec3<double> &closest,
					  double &confidence,
				      const RangeInformation *clientData) const {
  if (clientData==0)
    return false;
  else {
    if ((clientData->getName()==GradientInrimageInformation::informationName) && gradientForce)
      return(gradientForce->getPoint(position, normal, range, closest,confidence,
			      (GradientInrimageInformation *) clientData));
    else if ((clientData->getName()==GradientGradientInrimageInformation::informationName) && gradientGradientForce)
      return(gradientGradientForce->getPoint(position, normal, range, closest,confidence,
					     (GradientGradientInrimageInformation *) clientData));
    else if ((clientData->getName()==GradientBalloonInrimageInformation::informationName) && gradientBalloonForce)
      return(gradientBalloonForce->getPoint(position, normal, range, closest,confidence,
					    (GradientBalloonInrimageInformation *) clientData));
    else if ((clientData->getName()==RegionInrimageInformation::informationName) && regionForce)
      return(regionForce->getPoint(position, normal, range, closest,confidence,
			    (RegionInrimageInformation *) clientData));
    else if ((clientData->getName()==IsosurfaceInrimageInformation::informationName) && isosurfaceForce)
      return(isosurfaceForce->getPoint(position, normal, range, closest,confidence,
			    (IsosurfaceInrimageInformation *) clientData));
    else if ((clientData->getName()==ClassInrimageInformation::informationName) && classForce)
      return(classForce->getPoint(position, normal, range, closest,confidence,
				  (ClassInrimageInformation *) clientData));
    else if ((clientData->getName()==IntensityProfileInformation::informationName) && intensityProfileForce)
      return(intensityProfileForce->getPoint(position, normal, range, closest,confidence,
					     (IntensityProfileInformation *) clientData));
    else if ((clientData->getName()==BlockMatchingInformation::informationName) && blockMatchingForce)
      return(blockMatchingForce->getPoint(position, normal, range, closest,confidence,
					     (BlockMatchingInformation *) clientData)); 
  }
  return false;
}






} // namespace yav
