#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#include <imagedata/TclRangeInrimage2D.h>

namespace yav {

TclRangeInrimage2D::TclRangeInrimage2D(TclInrimage *intensity,
				       TclScene2D *scene,
				       TclInrimage *gradient,
				       TclInrimage *gradientdir,
				       TclInrimage *edge,
				       TclInrimage *gradient2,
				       TclInrimage *classify,
				       const std::type_info& id,
				       RangeInrimage2DGraphics *data)
  : TclScene2DObject(id,
      data ? data
	   : new RangeInrimage2DGraphics(intensity->getClient(),
				 scene->getClient(),
				 gradient ? gradient->getClient() : 0,
				 gradientdir ? gradientdir->getClient() : 0,
				 edge ? edge->getClient() : 0,
				 gradient2 ? gradient2->getClient() : 0,
				 classify ? classify->getClient() : 0),scene->getModule()) {
  done(typeid(TclRangeInrimage2D),"imagedata::range2Dinstall","imagedata::range2Duninstall");
}



TclRangeInrimage2D::TclRangeInrimage2D(const TclString& filename,
				       TclScene2D *scene,
				       const std::type_info& id,
				       RangeInrimage2DGraphics *data)
  : TclScene2DObject(id,
		    data ? data
		    : new RangeInrimage2DGraphics(filename, scene->getClient()),
			scene->getModule()) {

  if (getClient()->getIntensity())  {
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getIntensity()));
   // getClient()->InrimageView::init();
  }
  if (getClient()->getGradient())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getGradient()));
  if (getClient()->getGradientDirection())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getGradientDirection()));

  if(getClient()->getGradientGradient())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getGradientGradient()));
  if(getClient()->getEdge())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getEdge()));
  if (getClient()->getClassify())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getClassify()));

  done(typeid(TclRangeInrimage2D),"imagedata::range2Dinstall","imagedata::range2Duninstall");
}

		    


TclRangeInrimage2D::TclRangeInrimage2D(
				       TclScene2D *scene,
				       RangeInrimage2DGraphics *data)
					   : TclScene2DObject(typeid(TclRangeInrimage2D),data,
					   scene->getModule()) {
		
  if (getClient()->getIntensity())  {
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getIntensity()));
//    getClient()->InrimageView::init();
  }
  if (getClient()->getGradient())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getGradient()));
  if (getClient()->getGradientDirection())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getGradientDirection()));

  if(getClient()->getGradientGradient())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getGradientGradient()));
  if(getClient()->getEdge())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getEdge()));
  if (getClient()->getClassify())
    (void) new TclInrimage(getModule(), typeid(TclInrimage),
			   (getClient()->getClassify()));


  done(typeid(TclRangeInrimage2D),"imagedata::range2Dinstall","imagedata::range2Duninstall");
}



TclRangeInrimage2D::~TclRangeInrimage2D() {
  deleted(typeid(TclRangeInrimage2D));
}

TclRangeInrimage2D *TclRangeInrimage2D::getInterface(RangeInrimage2D *range) 
{
	TclRangeInrimage2D *r,*res;
	res=0;
	TclObjectKind *ok=TclObjectKind::findByKind(typeid(RangeInrimage2D));
	  ObjectsList<TclObject>::iterator it=ok->firstObject();
	  while (it!=ok->lastObject()) {
		  r=(TclRangeInrimage2D *)(*it);
		  if (r->getClient()==range)
			  res=r;
		  it++;
	  }
	  return res;
}


int TclRangeInrimage2D::create(TclModule *m, int argc, char **argv) {
  TclRangeInrimage2D *img;
  TclInrimage *inr = 0, *gradient = 0, *gradientdir = 0, *edge = 0,
    *gradient2 = 0, *classify = 0;
  TclScene2D *scene = 0;
  int i, filename = -1;

  for(i = 1; i < argc; i++) {
    if(argv[i][0] != '-') {
      if(inr || (filename >= 0)) return COMMAND_SYNOPSIS;
      inr = TclInrimage::getObject(argc, argv, i);
      if(!inr) filename = i;
    }
    else if(!strcmp(argv[i], "-scene")) {
      scene = (TclScene2D *)
	TclObjectKind::getObject(typeid(TclScene2D), argc, argv, ++i);
      if(!scene) return TCL_ERROR;
    }
    else if(!strcmp(argv[i], "-gradient")) {
      if(gradient) return COMMAND_SYNOPSIS;
      gradient = TclInrimage::getObject(argc, argv, ++i);
      if(!gradient) return TCL_ERROR;
    }
    else if(!strcmp(argv[i], "-gradientdir")) {
      if(gradientdir) return COMMAND_SYNOPSIS;
      gradientdir = TclInrimage::getObject(argc, argv, ++i);
      if(!gradientdir) return TCL_ERROR;
    }
    else if(!strcmp(argv[i], "-edge")) {
      if(edge) return COMMAND_SYNOPSIS;
      edge = TclInrimage::getObject(argc, argv, ++i);
      if(!edge) return TCL_ERROR;
    }
    else if(!strcmp(argv[i], "-gradient2")) {
      if(gradient2) return COMMAND_SYNOPSIS;
      gradient2 = TclInrimage::getObject(argc, argv, ++i);
      if(!gradient2) return TCL_ERROR;
    }
    else if(!strcmp(argv[i], "-classify")) {
      if(classify) return COMMAND_SYNOPSIS;
      classify = TclInrimage::getObject(argc, argv, ++i);
      if(!classify) return TCL_ERROR;
    }
    else return COMMAND_SYNOPSIS;
  }

  if(!scene) scene = TclScene2D::getDefaultScene(m);
  if(filename < 0) {
    if(!inr) return COMMAND_SYNOPSIS;
    img = new TclRangeInrimage2D(inr, scene, gradient, gradientdir, edge,
				 gradient2, classify);
  }
  else {
    try {
      img = new TclRangeInrimage2D(TclString(argv[filename]), scene);
    }
    catch(Inrimage::ImageNotFound&) {
      m->setResult("file not found");
      return TCL_ERROR;
    }
    catch(Inrimage::UnknownImageType&) {
      m->setResult("unknown image type");
      return TCL_ERROR;
    }
    catch(Inrimage::InvalidHeader&) {
      m->setResult("invalid inrimage header");
      return TCL_ERROR;
    }
    catch(Inrimage::InvalidData&) {
      m->setResult("invalid inrimage data");
      return TCL_ERROR;
    }
    catch(Inrimage::UnknownType&) {
      m->setResult("non supported inrimage type");
      return TCL_ERROR;
    }
  }
  
  m->setResult("%s", (char *)img->name());
  return TCL_OK;
}


int TclRangeInrimage2D::imagesCmd(int argc, char **argv) {
  TclString res;
  int error = TclRangeInrimage::imagesCmd(argc, argv, getClient(), res);
  setResult(res);
  return error;
}

int TclRangeInrimage2D::saveCmd(int argc, char **argv) {
  TclString res;
  int error = TclRangeInrimage::saveCmd(argc, argv, getClient(), res);
  setResult(res);
  return error;
}


int TclRangeInrimage2D::displayLineCmd(int argc, char **argv) {
  TclString res;
  int error = TclRangeInrimage::displayLineCmd(argc, argv, getClient(), res,
					       getModule());
  setResult(res);
  return error;
}


int TclRangeInrimage2D::forceCmd(int argc, char **argv) {
  TclString res;
  int error = this->TclRangeInrimage::forceCmd(argc, argv, (RangeInrimage *)getClient(), res);
  setResult(res);
  return error;
}




void TclRangeInrimage2D::load(const TclString &filename, Scene2D *scn) {
  TclInrimage *inr = new TclInrimage(((TclScene2D *)scn->getInterface())->getModule(),
				     filename);
  (void) new TclRangeInrimage2D(inr, (TclScene2D *)scn->getInterface());
}

/// creates the Tcl commands when the module is loaded
void  TclRangeInrimage2D::createCommands(TclModule *m)
{
	TclObjectKind *kind;	
	kind = new Scene2DItem(m, typeid(TclRangeInrimage2D), "rimg2D","2D Image Deformation",
			 &TclRangeInrimage2D::create,
			 &TclObject::list,
			 TclScene2D::FILE | TclScene2D::OTHER,
			 "", ".inr,.inr.gz", &TclRangeInrimage2D::load, 0,
			 "<filename=%s|inr%u [-gradient inr%u] [-gradientdir inr%u] [-edge inr%u] [-gradient2 inr%u]> [-scene scn3D%u] [-classify inr%u]");
  m->newCommand("rimg2D%u", kind->getOptions(), "range image management command");
 // kind->addOptions(typeid(TclInrimageView));
  kind->newOption("-images", (TclObject::OPTION) &TclRangeInrimage2D::imagesCmd,
		  "[[intensity inr%u] [gradient inr%u] [gradientdir inr%u] [edge inr%u] [gradient2 inr%u]]",
		  "get/set inrimages composing data image");
  
  kind->newOption("-force",
		  (TclObject::OPTION) &TclRangeInrimage2D::forceCmd,
		  "[ list | none | gradient | ... ]",
		  "get/set external force type or return available forces list");
  kind->newOption("-save",
		  (TclObject::OPTION) &TclRangeInrimage2D::saveCmd,
		  "%s",
		  "save the range inrimage 2D in a General Format file");
  kind->newOption("-displayLine",
		  (TclObject::OPTION) &TclRangeInrimage2D::displayLineCmd,
		  "%f %f %f  %f %f %f %f",
		  "display in a window the image intensity, gradient and gradientDirection profile along a 3D segment. The first 3 parameters are the coordinates of the middle profile. The second 3 parameters are the coordinates of the direction of the line segment. The last parameter is the half length of the segment");

}

} // namespace yav
