namespace yav{

 template <class T>
    void buildQuads(T,ImageData *id,
		    Inrimage *inr, const double min,const double max,
		    unsigned int slice,const unsigned char *redColorMap, 
		    const unsigned char *greenColorMap, 
		    const unsigned char *blueColorMap,
		    SliceCamera::SLICE_ORIENTATION geom)  {
    unsigned int x, y, z;
    double  a, Mi, Mj, Mk, i1, i2, j1, j2, k1, k2, d, i, j, md, ar;
    unsigned short int r;
    unsigned int resolution=id->getResolution();
    double vx=inr->getVX();
    double vy=inr->getVY();
    double vz=inr->getVZ();
    unsigned int dimx=inr->getX();
    unsigned int dimy=inr->getY();
    unsigned int dimz=inr->getZ();
    double alpha=id->getAlpha();

    T *l1;
    
    a = (double) max - (double) min;
    if(a == 0.0) a = 1.0;
    else a = 255.0 / a;

    
    switch(geom) {
      
    case SliceCamera::SLICE_X:
      j1 = vx * (slice + 0.5);
      Mi = vy * dimy;
      Mk = vz * dimz;
      
      
      k2 = 0.0;
      for(z = 0; z < dimz; z += resolution) {
	l1 = (T *) inr->getData() + z * dimx * dimy + slice;
	
	k1 = k2;
	k2 += vz * resolution;
	if(k2 > Mk) k2 = Mk;
	i2 = 0.0;
	if (id->AreBlackPixelsShown())
	  {
	    glBegin(GL_QUADS);
	    
	    for(x = 0; x < dimy; x += resolution,
		  l1 += resolution * dimx) {
	      i1 = i2;
	      i2 += vy * resolution;
	      if(i2 > Mi) i2 = Mi;
	      d = (double) *l1;
	      if(d < min) r = 0;
	      else if(d > max) r = 256;
	      else r = (unsigned char )(a * (d - min));
	      glColor4d(redColorMap[r]/255.0,greenColorMap[r]/255.0,
			blueColorMap[r]/255.0 , alpha);
	      glVertex3d(j1, i1, k1);
	      glVertex3d(j1, i2, k1);
	      glVertex3d(j1, i2, k2);
	      glVertex3d(j1, i1, k2);
	    }
	    glEnd();
	  }
	else
	{
	  bool begin=false;
	  for(x = 0; x < dimy; x += resolution,
		l1 += resolution * dimx) {
	    i1 = i2;
	    i2 += vy * resolution;
	    if(i2 > Mi) i2 = Mi;
	    d = (double) *l1;
	    if(d < min) r = 0;
	    else if(d > max) r = 255;
	    else r = (unsigned char )(a * (d - min));
	     if (r>0)
	      {
		if (begin==false)
		  {
		    glBegin(GL_QUADS);
		    begin=true;
		  }
		glColor4d(redColorMap[r]/255.0,greenColorMap[r]/255.0,
			  blueColorMap[r]/255.0 , alpha);
		glVertex3d(j1, i1, k1);
		glVertex3d(j1, i2, k1);
		glVertex3d(j1, i2, k2);
		glVertex3d(j1, i1, k2);
	      }
	     else if (begin==true)
	       {
		 glEnd();
		 begin=false;
	       }
	  }
	  if (begin==true)
	    glEnd();
	}
    }
    break;

  case SliceCamera::SLICE_Y:
    i1 = vy * (slice + 0.5);
    Mj = vx * dimx;
    Mk = vz * dimz;
    
    k2 = 0.0;
    for(z = 0; z < dimz; z += resolution) {
      l1 = (T *) inr->getData() +
	z * dimx * dimy + slice * dimx;
      
      k1 = k2;
      k2 += vz * resolution;
      if(k2 > Mk) k2 = Mk;
      j2 = 0.0;
      if (id->AreBlackPixelsShown())
	{
	  glBegin(GL_QUADS);
	  for(x = 0; x < dimx; x += resolution, l1 += resolution) {
	    j1 = j2;
	    j2 += vx * resolution;
	    if(j2 > Mj) j2 = Mj;
	    d = (double) *l1;
	    if(d < min) r = 0;
	    else if(d > max) r = 256;
	    else r = (unsigned char )(a * (d - min));
	    glColor4d(redColorMap[r]/255.0,greenColorMap[r]/255.0,
		      blueColorMap[r]/255.0 , alpha);
	    glVertex3d(j1, i1, k1);
	    glVertex3d(j2, i1, k1);
	    glVertex3d(j2, i1, k2);
	    glVertex3d(j1, i1, k2);
	  }
	  glEnd();
      	}
      else
	{ 
	  bool begin=false;
	  for(x = 0; x < dimx; x += resolution, l1 += resolution) {
	    j1 = j2;
	    j2 += vx * resolution;
	    if(j2 > Mj) j2 = Mj;
	    d = (double) *l1;
	    if(d < min) r = 0;
	    else if(d > max) r = 256;
	    else r = (unsigned char )(a * (d - min));
	    if (r>0)
	      {
		if (begin==false)
		  {
		    glBegin(GL_QUADS);
		    begin=true;
		  }
		glColor4d(redColorMap[r]/255.0,greenColorMap[r]/255.0,
			  blueColorMap[r]/255.0 , alpha);
		glVertex3d(j1, i1, k1);
		glVertex3d(j2, i1, k1);
		glVertex3d(j2, i1, k2);
		glVertex3d(j1, i1, k2);
	      }
	    else if (begin==true)
	      {
		glEnd();
		begin=false;
	      }
	  }
	  if (begin==true)
	    glEnd();
	}  
    }
    break;

  case SliceCamera::SLICE_Z:
    k1 = vz * (slice + 0.5);
    Mi = vy * dimy;
    Mj = vx * dimx;
    
    
    i2 = 0.0;
    for(y = 0; y < dimy; y += resolution) {
      l1 = (T *) inr->getData() +
	y * dimx + slice * dimx * dimy;
      
      i1 = i2;
      i2 += vy * resolution;
      if(i2 > Mi) i2 = Mi;
      j2 = 0.0;
	if (id->AreBlackPixelsShown())
	{
	  glBegin(GL_QUADS);
	  for(x = 0; x < dimx; x += resolution, l1 += resolution) {
	    j1 = j2;
	    j2 += vx * resolution;
	    if(j2 > Mj) j2 = Mj;
	    d = (double) *l1;
	    if(d < min) r = 0;
	    else if(d > max) r = 256;
	    else r = (unsigned char )(a * (d - min));
	    glColor4d(redColorMap[r]/255.0,greenColorMap[r]/255.0,
		      blueColorMap[r]/255.0 , alpha);
	    glVertex3d(j1, i1, k1);
	    glVertex3d(j1, i2, k1);
	    glVertex3d(j2, i2, k1);
	    glVertex3d(j2, i1, k1);
	  }
	  glEnd();
	}
      else
	{
	  bool begin=false;
	  for(x = 0; x < dimx; x += resolution, l1 += resolution) {
	    j1 = j2;
	    j2 += vx * resolution;
	    if(j2 > Mj) j2 = Mj;
	    d = (double) *l1;
	    if(d < min) r = 0;
	    else if(d > max) r = 256;
	    else r = (unsigned char )(a * (d - min));
	    if (r>0)
	      {
		if (begin==false)
		  {
		    glBegin(GL_QUADS);
		    begin=true;
		  }
		glColor4d(redColorMap[r]/255.0,greenColorMap[r]/255.0,
			  blueColorMap[r]/255.0 , alpha);
		glVertex3d(j1, i1, k1);
		glVertex3d(j1, i2, k1);
		glVertex3d(j2, i2, k1);
		glVertex3d(j2, i1, k1);
	      }
	    else if (begin==true)
	      {
		glEnd();
		begin=false;
	      }
	  }
	  if (begin==true)
	    glEnd();
	}
    }
    break;

  case SliceCamera::SLICE_ALPHA:
    ar = ((double) (slice % 180) * M_PI / dimz);
    md = dimx * vx / 2.0;
    Mi = md * (1.0 - sin(ar));
    Mj = md * (1.0 + cos(ar));
    i = -sin(ar) * vx * resolution;
    j = cos(ar) * vx * resolution;
    Mk = dimy * vy;

    
    k2 = 0.0;
    for(y = 0; y < dimy; y += resolution) {
      l1 = (T *) inr->getData() +
	y * dimx + slice * dimx * dimy;

      k1 = k2;
      k2 += vy * resolution;
      if(k2 > Mk) k2 = Mk;
      i2 = md * (1.0 + sin(ar));
      j2 = md * (1.0 - cos(ar));
      if (id->AreBlackPixelsShown())
	{
	  glBegin(GL_QUAD_STRIP);
	  
	  for(x = 0; x < dimx; x += resolution, l1 += resolution) {
	    i1 = i2;
	    i2 += i;
	    j1 = j2;
	    j2 += j;
	    
	    d = (double) *l1;
	    if(d < min) r = 0;
	    else if(d > max) r = 256;
	    else r = (unsigned char )(a * (d - min));
	    glColor4d(redColorMap[r]/255.0,greenColorMap[r]/255.0,
		      blueColorMap[r]/255.0 , alpha);
	    glVertex3d(i1, j1, k2);
	    glVertex3d(i1, j1, k1);
	  }
	  glVertex3d(Mi, Mj, k2);
	  glVertex3d(Mi, Mj, k1);
	  glEnd();
	}
      else
	{
	  bool begin=false;
	  for(x = 0; x < dimx; x += resolution, l1 += resolution) {
	    i1 = i2;
	    i2 += i;
	    j1 = j2;
	    j2 += j;
	    
	    d = (double) *l1;
	    if(d < min) r = 0;
	    else if(d > max) r = 256;
	    else r = (unsigned char )(a * (d - min));
	    if (r>0)
	      {
		if (begin==false)
		  {
		    glBegin(GL_QUAD_STRIP);
		    begin=true;
		  }
		glColor4d(redColorMap[r]/255.0,greenColorMap[r]/255.0,
			  blueColorMap[r]/255.0 , alpha);
		glVertex3d(i1, j1, k2);
		glVertex3d(i1, j1, k1);
	      }
	    else if (begin==true)
	      {
		glEnd();
		begin=false;
	      }
	  }
	  if (begin==true)
	    { 
	      glVertex3d(Mi, Mj, k2);
	      glVertex3d(Mi, Mj, k1);
	      glEnd();
	    }
	  
	}
    }
    break;
  }
}


  template <class T>
    void buildTexture(T,
		      Inrimage *inr, ImageData *id,
		      const double min,const double max,
		      unsigned int slice,const unsigned char *redColorMap, 
		      const unsigned char *greenColorMap, 
		      const unsigned char *blueColorMap,
		      SliceCamera::SLICE_ORIENTATION geom) {
  unsigned int x, y, z, i, j, k, p;
  float *texture;
  double plane, a, b, ar, mx, my;
  T *l1;
  unsigned short int r;
  double d;
  double vx=inr->getVX();
  double vy=inr->getVY();
  double vz=inr->getVZ();
  unsigned int dimx=inr->getX();
  unsigned int dimy=inr->getY();
  unsigned int dimz=inr->getZ();
  double alpha=id->getAlpha();
  const float *textbg;
  textbg=id->getTextureBackground();

  b = min;
  a = max - b;
  if(a == 0.0) a = 1.0;
  else a = 1.0 / a;

  switch(geom) {

  case SliceCamera::SLICE_X:
    y = (unsigned int) (log((double) dimy)/log(2.0));
    if(dimy > (unsigned int) (1 << y)) y++;
    y = 1 << y;
    z = (unsigned int) (log((double) dimz)/log(2.0));
    if(dimz > (unsigned int) (1 << z)) z++;
    z = 1 << z;
    
    texture = new float [4 * y * z];
    for(k = 0, p = 0; k < dimz; k++) {
      l1 = (T *) inr->getData() + k * dimx * dimy + slice;
      for(j = 0; j < dimy; j++, l1 += dimx) {
	d = (double) *l1;
	if(d < min) r = 0;
	else if(d > max) r = 256;
	else r = (unsigned char )(255*a * (d - min));
	texture[p++] = redColorMap[r]/255.0f;
	texture[p++] = greenColorMap[r]/255.0f;
	texture[p++] = blueColorMap[r]/255.0f;
	texture[p++] = (float)alpha;
      }
      for(j = dimy; j < y; j++) {
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = (float)alpha;
      }
    }
    for(k = dimz; k < z; k++) {
      for(j = 0; j < y; j++) {
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = (float)alpha;
      }
    }

    glColor4f(textbg[0], textbg[1], textbg[2], textbg[3]);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, y, z, 0,
		 GL_RGBA, GL_FLOAT, texture);
    delete texture;
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, id->getTextMap());

    glEnable(GL_TEXTURE_2D);
    glShadeModel(GL_FLAT);

    glBegin(GL_QUADS);
    plane = (slice + 0.5) * vx;
    glTexCoord2f(0.0, 0.0);
    glVertex3d(plane, 0.0, 0.0);
    glTexCoord2f(0.0, (float) dimz / (float) z);
    glVertex3d(plane, 0.0, dimz * vz);
    glTexCoord2f((float) dimy / (float) y, (float) dimz / (float) z);
    glVertex3d(plane, dimy * vy, dimz * vz);
    glTexCoord2f((float) dimy / (float) y, 0.0);
    glVertex3d(plane, dimy * vy, 0.0);
    glEnd();

    glDisable(GL_TEXTURE_2D);
    break;

  case SliceCamera::SLICE_Y:
    x = (unsigned int) (log((double) dimx)/log(2.0));
    if(dimx > (unsigned int) (1 << x)) x++;
    x = 1 << x;
    z = (unsigned int) (log((double) dimz)/log(2.0));
    if(dimz > (unsigned int) (1 << z)) z++;
    z = 1 << z;
    
   texture = new float[4 * x * z];
    for(k = 0, p = 0; k < dimz; k++) {
      l1 = (T *) inr->getData() + k * dimx * dimy + slice * dimx;
      for(i = 0; i < dimx; i++, l1++) {
	d = (double) *l1;
	if(d < min) r = 0;
	else if(d > max) r = 256;
	else r = (unsigned char )(255*a * (d - min));
	texture[p++] = redColorMap[r]/255.0f;
	texture[p++] = greenColorMap[r]/255.0f;
	texture[p++] = blueColorMap[r]/255.0f;
	texture[p++] = (float)alpha;
      }
      for(i = dimx; i < x; i++) {
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = (float)alpha;
      }
    }
    for(k = dimz; k < z; k++) {
      for(i = 0; i < x; i++) {
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = (float)alpha;
      }
    }
 
    glColor4f(textbg[0], textbg[1], textbg[2], textbg[3]);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, x, z, 0,
		 GL_RGBA, GL_FLOAT, texture);
    delete texture;
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, id->getTextMap());

    glShadeModel(GL_FLAT);
    glEnable(GL_TEXTURE_2D);
    glBegin(GL_QUADS);
    plane = (slice + 0.5) * vy;
    glTexCoord2f(0.0, 0.0);
    glVertex3d(0.0, plane, 0.0);
    glTexCoord2f(0.0, (float) dimz / (float) z);
    glVertex3d(0.0, plane, dimz * vz);
    glTexCoord2f((float) dimx / (float) x, (float) dimz / (float) z);
    glVertex3d(dimx * vx, plane, dimz * vz);
    glTexCoord2f((float) dimx / (float) x, 0.0);
    glVertex3d(dimx * vx, plane, 0.0);
    glEnd();

    glDisable(GL_TEXTURE_2D);
    break;

  case SliceCamera::SLICE_Z:
    x = (unsigned int) (log((double) dimx)/log(2.0));
    if(dimx > (unsigned int) (1 << x)) x++;
    x = 1 << x;
    y = (unsigned int) (log((double) dimy)/log(2.0));
    if(dimy > (unsigned int) (1 << y)) y++;
    y = 1 << y;
    
    texture = new float[4 * x * y];
    l1 = (T *) inr->getData() + dimx * dimy * slice;
    for(j = 0, p = 0; j < dimy; j++) {
      for(i = 0; i < dimx; i++) {
	d = (double) *l1;
	l1++;
	if(d < min) r = 0;
	else if(d > max) r = 256;
	else r = (unsigned char )(255*a * (d - min));
	texture[p++] = redColorMap[r]/255.0f;
	texture[p++] = greenColorMap[r]/255.0f;
	texture[p++] = blueColorMap[r]/255.0f;
	texture[p++] = (float)alpha;
      }
      for(i = dimx; i < x; i++) {
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = (float)alpha;
      }
    }
    for(j = dimy; j < y; j++) {
      for(i = 0; i < x; i++) {
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = (float)alpha;
      }
    }

    glColor4f(textbg[0], textbg[1], textbg[2], textbg[3]);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, x, y, 0,
		 GL_RGBA, GL_FLOAT, texture);
    delete texture;
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, id->getTextMap());
    glShadeModel(GL_FLAT);

    glEnable(GL_TEXTURE_2D);
    plane = (slice + 0.5) * vz;
    glBegin(GL_QUADS);
    glTexCoord2f(0.0, 0.0);
    glVertex3d(0.0, 0.0, plane);
    glTexCoord2f(0.0, (float) dimy / (float) y);
    glVertex3d(0.0, dimy * vy, plane);
    glTexCoord2f((float) dimx / (float) x, (float) dimy / (float) y);
    glVertex3d(dimx * vx, dimy * vy, plane);
    glTexCoord2f((float) dimx / (float) x, 0.0);
    glVertex3d(dimx * vx, 0.0, plane);
    glEnd();

    glDisable(GL_TEXTURE_2D);
    break;

  case SliceCamera::SLICE_ALPHA:
    ar = ((double) (slice % 180) * M_PI / dimz);
    //    slice = (unsigned int) ((slice % 180) * dimz / 180.0 + 0.5);
    mx = dimx * vx / 2.0;
    my = dimy * vy;

    x = (unsigned int) (log((double) dimx)/log(2.0));
    if(dimx > (unsigned int) (1 << x)) x++;
    x = 1 << x;
    y = (unsigned int) (log((double) dimy)/log(2.0));
    if(dimy > (unsigned int) (1 << y)) y++;
    y = 1 << y;
    
    texture = new float[4 * x * y];
    l1 = (T *) inr->getData() + dimx * dimy * slice;
    for(j = 0, p = 0; j < dimy; j++) {
      for(i = 0; i < dimx; i++) {
	d = (double) *l1;
	if(d < min) r = 0;
	else if(d > max) r = 256;
	else r = (unsigned char )(255*a * (d - min));
	l1++;
	texture[p++] = redColorMap[r]/255.0f;
	texture[p++] = greenColorMap[r]/255.0f;
	texture[p++] = blueColorMap[r]/255.0f;
	texture[p++] = (float)alpha;
      }
      for(i = dimx; i < x; i++) {
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = (float)alpha;
      }
    }
    for(j = dimy; j < y; j++) {
      for(i = 0; i < x; i++) {
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = 0.0;
	texture[p++] = (float)alpha;
      }
    }

    glColor4f(textbg[0], textbg[1], textbg[2], textbg[3]);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, x, y, 0,
		 GL_RGBA, GL_FLOAT, texture);
    delete texture;
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, id->getTextMap());
    glEnable(GL_TEXTURE_2D);
    glShadeModel(GL_FLAT);

    glBegin(GL_QUADS);
    glTexCoord2f(0.0, 0.0);
    glVertex3d(mx * (1.0 + sin(ar)), mx * (1.0 - cos(ar)), 0.0);
    glTexCoord2f(0.0, (float) dimy / (float) y);
    glVertex3d(mx * (1.0 + sin(ar)), mx * (1.0 - cos(ar)), my);
    glTexCoord2f((float) dimx / (float) x, (float) dimy / (float) y);
    glVertex3d(mx * (1.0 - sin(ar)), mx * (1.0 + cos(ar)), my);
    glTexCoord2f((float) dimx / (float) x, 0.0);
    glVertex3d(mx * (1.0 - sin(ar)), mx * (1.0 + cos(ar)), 0.0);
    glEnd();

    glDisable(GL_TEXTURE_2D);
    break;
  }
}

 template <class T>
   void build3DTexture(T,ImageData *id,Inrimage *inr,Voxel *glmin,Voxel *glmax) {
#ifndef NO_VOLUMETRIC_TEXTURE 

  unsigned int x, y, z;
  unsigned int i, j, k, p  ;
#ifndef _LINUX_
  float *texture;
#else
  unsigned char *texture;
#endif
  double a, b,min,max;
 double vx=inr->getVX();
 double vy=inr->getVY();
  double vz=inr->getVZ();
  unsigned int dimx=inr->getX();
  unsigned int dimy=inr->getY();
  unsigned int dimz=inr->getZ();
  T *l1;
  GLfloat textmap=  id->getTextMap();

  min = glmin->getValueAsDouble();
  max= glmax->getValueAsDouble();
  
  b=min;
  a = max-min;
  if(a <= 0.0) a = 1.0;
  else a = 1.0 / a;
  
  x = (unsigned int) (log((double) dimx)/log(2.0));
  if(dimx > (unsigned int) (1 << x)) x++;
  x = 1 << x;
  y = (unsigned int) (log((double) dimy)/log(2.0));
  if(dimy > (unsigned int) (1 << y)) y++;
  y = 1 << y;
  z = (unsigned int) (log((double) dimz)/log(2.0));
  if(dimz > (unsigned int) (1 << z)) z++;
  z = 1 << z;

#if (defined(GL_SGI_texture_color_table)||defined(GL_EXT_color_table))
  #undef GL_EXT_color_table
#endif

#if (defined(GL_SGI_texture_color_table)||defined(GL_EXT_color_table))

#ifndef _LINUX_
  texture = new float[2 * x * y * z];
#else
  texture = new unsigned char[4 * x * y * z];
#endif

#else

#ifdef GL_EXT_paletted_texture
  texture = new unsigned char[x * y * z];
#else
#ifndef _LINUX_
  texture = new float[2 * x * y * z];
#else
  texture = new unsigned char[4 * x * y * z];
#endif

#endif
#endif

  l1 = (T *) inr->getData();
  for(k = 0, p = 0 ; k < dimz; k++) {
    for(j = 0; j < dimy; j++) {
      for(i = 0; i < dimx; i++) {
#if (defined(GL_SGI_texture_color_table)||defined(GL_EXT_color_table))
	float v = a * (*l1++ - min);
#ifndef _LINUX_
	texture[p++] = v;
	texture[p++] = v;
#else
	v*=255;
	texture[p++] = (unsigned char )v;
	texture[p++] = (unsigned char )v;
	texture[p++] = (unsigned char )v;
	texture[p++] = (unsigned char )v;
#endif

#else	
#ifdef GL_EXT_paletted_texture
	T val;
	val=(*l1++);
	if (val >max)
	  texture[p++] = (unsigned char)0;
	else if (val <min)
	  texture[p++] = (unsigned char)0;
	else 
	  texture[p++] = (unsigned char)(255*a * (val - min));
	
#else	
#ifndef _LINUX_
	texture[p++] = a * (*l1++ - min);
	texture[p++] = 1.0;
#else
	unsigned char v = (unsigned char)(255*a * (*l1++ - min));
	texture[p++] = v;
	texture[p++] = v;
	texture[p++] = v;
	texture[p++] = 255;
#endif
#endif
#endif
      }
      for(i = dimx ; i < x; i++) {
#ifndef _LINUX_
	texture[p++] = 0.0;
	texture[p++] = 1.0;
#else
#ifdef GL_EXT_paletted_texture
	texture[p++] = 0;
#else
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 255;
#endif
#endif
      }
    }
    for(j = dimy; j < y; j++) {
      for(i = 0; i < x; i++) {
#ifndef _LINUX_
	texture[p++] = 0.0;
	texture[p++] = 1.0;
#else

#ifdef GL_EXT_paletted_texture
	texture[p++] = 0;
#else
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 255;
#endif
#endif
      }
    }
  }
  for(k = dimz; k < z; k++) {
    for(j = 0; j < y; j++) {
      for(i = 0; i < x; i++) {
#ifndef _LINUX_
	texture[p++] = 0.0;
	texture[p++] = 1.0;
#else
#ifdef GL_EXT_paletted_texture
	texture[p++] = 0;
#else
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 255;
#endif
#endif
      }
    }
  }

  static GLfloat splane[4] = {1.0 / (x * vx), 0.f, 0.f, 0.f};
  static GLfloat tplane[4] = {0.f, 1.0 / (y * vy), 0.f, 0.f};
  static GLfloat rplane[4] = {0.f, 0.f, 1.0 / (z * vz), 0.f};
  
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR);
  
  glTexGenfv(GL_S, GL_OBJECT_PLANE, splane);
  glTexGenfv(GL_T, GL_OBJECT_PLANE, tplane);
  glTexGenfv(GL_R, GL_OBJECT_PLANE, rplane);

#ifndef _LINUX_
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
  glTexImage3DEXT(TEXTURE3D, 0, GL_LUMINANCE_ALPHA, x, y, z, 0,
		  GL_LUMINANCE_ALPHA, GL_FLOAT, texture);
#else
  glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

#ifdef GL_EXT_paletted_texture
  /* 
   * The GeForce card uses paletted texture to provide the palette control as given by the SGI texture color table
   * The following command  is to specify that the texture data will consist of a set of indices into the color palette and not a normal RGBA image
   */
  glTexImage3DEXT(TEXTURE3D, 0, GL_COLOR_INDEX8_EXT, x, y, z, 0,
		  GL_COLOR_INDEX, GL_UNSIGNED_BYTE, texture);
  
#else 
  glTexImage3DEXT(TEXTURE3D, 0, GL_RGBA, x, y, z, 0,
		  GL_RGBA, GL_UNSIGNED_BYTE, texture);
#endif

#endif
  delete texture;
  glTexParameterf(GL_TEXTURE_3D_EXT, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameterf(GL_TEXTURE_3D_EXT, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameterf(GL_TEXTURE_3D_EXT, GL_TEXTURE_WRAP_R_EXT, GL_REPEAT);

  glTexParameterf(GL_TEXTURE_3D_EXT, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameterf(GL_TEXTURE_3D_EXT, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, textmap);

#ifdef USE_COLOR_TABLE
  GLCOLORTABLE(TEXTURE3D,256, id->getLookupTable()); 
#endif
#endif
}


 template <class T>
   void buildIndexedTexture(T,ImageData *id,Inrimage *inr, Voxel *glmin,Voxel*glmax,unsigned int slice, SliceCamera::SLICE_ORIENTATION geom,GLuint *textures) 
   {
   unsigned int x, y, z, i, j, k, p;
   //Since the texture consist of simple 8-bit indices, its of type unsigned char 
   unsigned int dimx=inr->getX();
   unsigned int dimy=inr->getY();
   unsigned int dimz=inr->getZ();
   unsigned char *texture;
   double a, b ;
   T *l1;
   unsigned short int r;
   double d;
   double min = glmin->getValueAsDouble();
   double max = glmax->getValueAsDouble();
   b = min;
   a = max - b;
   if(a == 0.0) a = 1.0;
   else a = 1.0 / a;
   unsigned int nslices=id->getNSlices();
  const float *textbg;
  textbg=id->getTextureBackground();
  GLfloat textmap=  id->getTextMap();
   

   switch(geom) {

  case SliceCamera::SLICE_X:
    y = (unsigned int) (log((double) dimy)/log(2.0));
    if(dimy > (unsigned int) (1 << y)) y++;
    y = 1 << y;
    z = (unsigned int) (log((double) dimz)/log(2.0));
    if(dimz > (unsigned int) (1 << z)) z++;
    z = 1 << z;

    x = ((dimx-1)* slice)/(nslices-1);

#ifdef GL_EXT_paletted_texture
    texture = new unsigned char [y * z];
#else
    texture = new unsigned char [3 * y * z];
#endif
    for(k = 0, p = 0; k < dimz; k++) {
      l1 = (T *) inr->getData() + k * dimx * dimy + ((int)x);
      for(j = 0; j < dimy; j++, l1 += dimx) {
	d = (double) *l1;
	if(d < min) r = 0;
	else if(d > max) r = 0;
	else r = (unsigned char )(255 * a * (d - min));
	//Simply store the monochrome intensity value, that serves as the index in the texture 	
#ifdef GL_EXT_paletted_texture
	texture[p++] = (unsigned char)r;
#else
	texture[p++] = r;
	texture[p++] = r;
	texture[p++] = r;
#endif
      }
      for(j = dimy; j < y; j++) {
#ifdef GL_EXT_paletted_texture
	texture[p++] = 0;
#else
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 0;
#endif
      }
    }
    for(k = dimz; k < z; k++) {
      for(j = 0; j < y; j++) {
#ifdef GL_EXT_paletted_texture
	texture[p++] = 0;
#else
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 0;
#endif
      }
    }

    glColor4f(textbg[0], textbg[1], textbg[2], textbg[3]);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
    glShadeModel(GL_FLAT);


    glBindTexture(GL_TEXTURE_2D, textures[slice]);  
#ifdef GL_EXT_paletted_texture
    glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, y, z, 0,
		 GL_COLOR_INDEX, GL_UNSIGNED_BYTE, texture);
#else
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, y, z, 0,
		 GL_RGB, GL_UNSIGNED_BYTE, texture);
#endif
    delete texture;

    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, textmap);

    break;

  case SliceCamera::SLICE_Y:
    x = (unsigned int) (log((double) dimx)/log(2.0));
    if(dimx > (unsigned int) (1 << x)) x++;
    x = 1 << x;
    z = (unsigned int) (log((double) dimz)/log(2.0));
    if(dimz > (unsigned int) (1 << z)) z++;
    z = 1 << z;
    
    y = ((dimy-1)* slice)/(nslices-1) ; //+1 is solely to make al possible value positive, exculsive of 0
    
#ifdef GL_EXT_paletted_texture
    texture = new unsigned char [x * z];
#else
    texture = new unsigned char [3 * x * z];
#endif
    for(k = 0, p = 0; k < dimz; k++) {
      l1 = (T *) inr->getData() + k * dimx * dimy + ((int)y) * dimx;
      for(i = 0; i < dimx; i++, l1++) {
	d = (double) *l1;
	if(d < min) r = 0;
	else if(d > max) r = 0;
	else r = (unsigned char )(255*a * (d - min));
#ifdef GL_EXT_paletted_texture
	texture[p++] = (unsigned char) r;
#else
	texture[p++] = r;
	texture[p++] = r;
	texture[p++] = r;
#endif
      }
      for(i = dimx; i < x; i++) {
#ifdef GL_EXT_paletted_texture
	texture[p++] = 0;
#else
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 0;
#endif
      }
    }
    for(k = dimz; k < z; k++) {
      for(i = 0; i < x; i++) {
#ifdef GL_EXT_paletted_texture
	texture[p++] = 0;
#else
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 0;
#endif
      }
    }
 
    glColor4f(textbg[0], textbg[1], textbg[2], textbg[3]);
    glShadeModel(GL_FLAT);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

    glBindTexture(GL_TEXTURE_2D, textures[slice]);  

#ifdef GL_EXT_paletted_texture
    glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, x, z, 0,
		 GL_COLOR_INDEX, GL_UNSIGNED_BYTE, texture);
#else
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, x, z, 0,
		 GL_RGB, GL_UNSIGNED_BYTE, texture);
#endif
    delete texture;

    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, textmap);

    break;

  case SliceCamera::SLICE_Z:
    x = (unsigned int) (log((double) dimx)/log(2.0));
    if(dimx > (unsigned int) (1 << x)) x++;
    x = 1 << x;
    y = (unsigned int) (log((double) dimy)/log(2.0));
    if(dimy > (unsigned int) (1 << y)) y++;
    y = 1 << y;

    z = ((dimz-1)* slice)/(nslices-1) ; //+1 is solely to make al possible value positive, exculsive of 0

#ifdef GL_EXT_paletted_texture
    texture = new unsigned char [x * y];
#else
    texture = new unsigned char [3 * x * y];
#endif
    l1 = (T *) inr->getData() + dimx * dimy * ((int)z) ;
    for(j = 0, p = 0; j < dimy; j++) {
      for(i = 0; i < dimx; i++) {
	d = (double) *l1;
	l1++;
	if(d < min) r = 0;
	else if(d > max) r = 0;
	else r = (unsigned char )(255*a * (d - min));
#ifdef GL_EXT_paletted_texture
	texture[p++] = (unsigned char) r;
#else
	texture[p++] = r;
	texture[p++] = r;
	texture[p++] = r;
#endif
      }
      for(i = dimx; i < x; i++) {
#ifdef GL_EXT_paletted_texture
	texture[p++] = 0;
#else
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 0;
#endif
      }
    }
    for(j = dimy; j < y; j++) {
      for(i = 0; i < x; i++) {
#ifdef GL_EXT_paletted_texture
	texture[p++] = 0;
#else
	texture[p++] = 0;
	texture[p++] = 0;
	texture[p++] = 0;
#endif
      }
    }

    glColor4f(textbg[0], textbg[1], textbg[2], textbg[3]);
    glShadeModel(GL_FLAT);
    glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

    //    cerr<<"Creating texture object with id - "<<textures[slice]<<" and setting its color table"<<ENDL;
    //create the texture object..
    glBindTexture(GL_TEXTURE_2D, textures[slice]);  
#ifdef GL_EXT_paletted_texture
    glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, x, y, 0,
		 GL_COLOR_INDEX, GL_UNSIGNED_BYTE, texture);
#else
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, x, y, 0,
		 GL_RGB, GL_UNSIGNED_BYTE, texture);
#endif
    delete texture;
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, textmap);

    break;

  case SliceCamera::SLICE_ALPHA:
    break;
  }
    //and set the color table appropriately
  
#ifdef USE_COLOR_TABLE
    GLCOLORTABLE(GL_TEXTURE_2D,256, id->getLookupTable()); 
#endif

}

}
