#ifndef TCLIMAGE3DVIEWER_H
#define TCLIMAGE3DVIEWER_H


#include <graphics3D/TclScene3DObject.h>
#include <imagedata/Image3DViewer.h>


namespace yav {

/** \class TclImage3DViewer
    \ingroup ImageData
    \brief Image3DViewer class interface */
class TclImage3DViewer : public TclScene3DObject {
 public:
  /** @name constructors */
  //@{
  /** Builds a new range inrimage from an images set.
      @param intensity intensity image (mandatory)
      @param scene 3D scene to set object in
      @param gradient gradient image
      @param gradientDirection gradient direction image
      @param edge edge image
      @param gradientGradient gradient derivative image
      @param classify classified image
      @param id dynamic object id
      @param data client */
  TclImage3DViewer(Image3DBackgroundManager *manager,
		     TclScene3D *scene);
  //@}

  /** @name destructor */
  //@{
  /// empty
  virtual ~TclImage3DViewer();
  //@}
  
 /// -destroy TCL option
  int destroyCmd(int argc, char **argv);
  /// -box TCL option
  int boxCmd(int argc, char **argv);
  /// -grid TCL option
  int gridCmd(int argc, char **argv);

  /// returns client real type
  Image3DViewer *getClient(void) { return (Image3DViewer *) client; }

  /// new operator call back function
  static int create(TclModule *m, int argc, char **argv);

  /// creates the Tcl commands when the module is loaded
  static void  createCommands(TclModule *m);



};

} // namespace yav

#endif  // TCLIMAGE3DVIEWER_H
