#include "mipsInrimagePlugIn.h"
#include "mipsDataSetManager.h"
#include "mipsInrimageReader.h"
#include "mipsImageDataSetFactory.h"
#include "mipsApplicationGUIManager.h"
#include "mipsInrimageDemoGui.h"
#include <iostream>

// PlugIn magic function declaration
MIPS_PLUGIN(mips::InrimagePlugIn)

namespace mips {
  
  void
  InrimagePlugIn::Init(GModule * p_module)
  {
    std::cout << "InrimagePlugIn::Init\n";    
    this->SetModule(p_module);
    // Register DataSetFactory
    //DataSetManager::AddDataSetFactory(new InrimageDataSetFactory);    
  
    // Register Readers and Writers
    //DataSetManager::AddReader(new InrimageReader);    
  
    // MeshIterateDemo Functional Application
    ApplicationGUIManager::AddApplicationGUI(new InrimageDemoGui());
  };

  void
  InrimagePlugIn::Finalize()
  {
  }

  const char*
  InrimagePlugIn::GetName()
  {
    return "Inrimage";    
  }
   
} //namespace mips

