#include "gtk/gtk.h"
#include "gtk/gtkgl.h"
#include "mipsImageDataSetFactory.h"
#include "mipsInrimageReader.h"
#include "mipsVtkImageReader.h"
#include "mipsDataSetManager.h"
#include "mipsImageViewer.h"


int
main(int argc, char **argv)
{
    gtk_init(&argc, &argv);
    gtk_gl_init (&argc, &argv);

    // Initialise the DataSetManager
    mips::DataSetManager::AddDataSetFactory(new mips::ImageDataSetFactory);
    mips::DataSetManager::AddReader(new mips::InrimageReader);
    mips::DataSetManager::AddReader(new mips::VtkImageReader);

    // Create the ImageViewer
    new mips::ImageViewer();
   
    gtk_main();
    
    return 0;
}
