#include "mipsInrimageDataSet.h"
#include "mipsVtkImageDataSet.h"

#include "mipsImageDataSetFactory.h"

namespace mips {
  
ImageDataSetFactory::ImageDataSetFactory()
{
  AddTypeName("InrimageDataSet");  
  AddTypeName("VtkImageDataSet");  
}
  
DataSet*
ImageDataSetFactory::NewDataSet(const char * p_datatSetTypeName)
{
  if (strcmp(p_datatSetTypeName, "InrimageDataSet") == 0){
    return new InrimageDataSet;
  }
  if (strcmp(p_datatSetTypeName, "VtkImageDataSet") == 0){
    return new VtkImageDataSet;
  }
  
  return 0;  
}

}
