#ifndef MIPS_IMAGE_VIEWER_H
#define MIPS_IMAGE_VIEWER_H

#include "gtk/gtk.h"

class vtkImageData;

namespace mips {

class GladeGui;
class ViewSpace;
class DataSet;

/** \class ImageViewer
    \ingroup ImageGUI
*/
class ImageViewer 
{
 public:
  
  /** ImageViewer have to be instantiate after gtk_init and
      gtk_gl_init functions call.*/
  ImageViewer();
  
  void RefreshFileList (DataSet* p_selectedDataSet);
  
private:
  /** Callbacks */
         void OnOpenMenuItemActivate    ();  
  static void OnOpenMenuItemActivateCbk (GtkMenuItem *menuitem,
                                         gpointer user_data);  
         void OnOrientationMenuItemActivate    ();  
  static void OnOrientationMenuItemActivateCbk (GtkMenuItem *menuitem,
                                                gpointer user_data);  
         void OnFileListSelectionChanged    (GtkTreeSelection* p_treeSelection);
  static void OnFileListSelectionChangedCbk (GtkTreeSelection *p_treeSelection,
                                             gpointer p_imageViewer);
 private:
  void          CreateFileList();
  DataSet*      GetSelectedDataSet();  
  vtkImageData* GetImageDataFromDataSet(DataSet* p_dataSet);  

  // Attributes 
 private:
  /** The manager in charge of the viewer glade project. */
  GladeGui*              m_gladeGui;
  ViewSpace*             m_viewSpace;
  GtkTreeView*           m_fileListTreeView;
  GtkWidget*             m_mainWindow;

};

} //namespace mips

#endif /* MIPS_IMAGE_VIEWER_H */
