#include "vtkImageData.h"
#include "mipsInrimageDataSet.h"
#include "mipsInrimageToVTKImageData.h"
#include <inrimage/Inrimage.h>

namespace mips {

InrimageDataSet::InrimageDataSet() :
  ImageDataSet(), m_inrimage(0), m_exporter(0)
{
}
  
InrimageDataSet::~InrimageDataSet()
{
  delete m_inrimage;
  delete m_exporter;
}

void
InrimageDataSet::SetInrimage(yav::Inrimage* p_inrimage)
{
  m_inrimage = p_inrimage;
  if (!m_exporter) {
    m_exporter = new InrimageToVTKImageData;
  }
  m_exporter->SetInput(m_inrimage);
  this->UpdateVtkImageData();    
  this->SetVtkImageData(m_exporter->GetOutput());  
}

yav::Inrimage* 
InrimageDataSet::GetInrimage()
{
  return m_inrimage;  
}

void
InrimageDataSet::UpdateVtkImageData()
{
  if(m_exporter)  m_exporter->Update();  
}

}
