#ifndef MIPS_INRIMAGE_DATASET_H
#define MIPS_INRIMAGE_DATASET_H

#include "mipsImageDataSet.h" 

namespace yav 
{
  class Inrimage;  
}

namespace mips {

/** \class InrimageToVtkExporter
    \ingroup ImageGUI
*/
class InrimageToVTKImageData;
  
/** \class InrimageDataSet mipsInrimageDataSet.h "PlugIn/mipsInrimageDataSet.h"
    \brief DataSet for Inrimage viewer plugin */
class InrimageDataSet : public ImageDataSet
  {
  public:
    InrimageDataSet();            /**< Default constructor */
    virtual ~InrimageDataSet();   /**< Default destructor */ 
    void SetInrimage(yav::Inrimage* p_inrimage);
    yav::Inrimage* GetInrimage(); /**< Extract the inrimage class from
                                   * dataset */
    
    // Overriden methods
    virtual void          UpdateVtkImageData();
    
   //Attributes
  private:
    yav::Inrimage*          m_inrimage;    /**< Data, within an inrimage */
    InrimageToVTKImageData* m_exporter;    
  
  };

} // namespace mips

#endif //MIPS_INRIMAGE_DATASET_H
