#include "mipsInrimageReader.h"

#include "inrimage/Inrimage.h"
#include "mipsDataSetManager.h"
#include "mipsInrimageDataSet.h"

namespace mips {

  DataSet*
  InrimageReader::Read (const char* p_filename) const
  {
    yav::Inrimage* inrimage = 0;
  
    try{
      inrimage = new yav::Inrimage(p_filename);    
    }catch (...) {
      return 0;
    }    

    InrimageDataSet* dataset = 0;
    dataset = dynamic_cast<InrimageDataSet*>
      (DataSetManager::NewDataSet("InrimageDataSet"));
    if (dataset){    
      dataset->SetInrimage(inrimage);
      dataset->SetFileName(p_filename);
    }
    else {
      delete inrimage;
      std::cout << "ERROR : DataSetManager::NewDataSet(\"InrimageDataSet\")  failed on "
                << p_filename << std::endl;
    }  
    return dataset ;  
  }

}
