#ifndef MIPS_ORIENTATION_DIALOG_H
#define MIPS_ORIENTATION_DIALOG_H

#include "gtk/gtk.h"

class vtkImageData;  
class vtkTransform;  

namespace mips {

class GladeGui;
class VtkViewImage2D;
class ImageDataSet;

/** \class OrientationDialog
    \ingroup ImageGUI
*/
class OrientationDialog 
{
 public:
  /** Create a OrientationDialog. */
  OrientationDialog(GtkWidget* p_parentTopWidget);  
  ~OrientationDialog();

  gint Run(ImageDataSet* p_image);
  
// LAYOUT DIALOG CALLBACKS
 private:
  void                  RotateX90(vtkImageData* p_image);  
  void                  RotateY90(vtkImageData* p_image);  
  void                  RotateZ90(vtkImageData* p_image);  
  void                  FlipY();  
  void                  ComputeTransform(int p_x_start,
                                         int p_y_start,
                                         int p_z_end);
  
 private:
  GladeGui             *m_gladeGui;
  GtkWidget            *m_orientationDialogWidget;
  GtkWidget            *m_parentTopWidget;
  GtkComboBox          *m_xStartComboBox;
  GtkComboBox          *m_yStartComboBox;
  GtkComboBox          *m_zEndComboBox;
  VtkViewImage2D       *m_xyAxialView;
  VtkViewImage2D       *m_yzSagittalView;
  vtkTransform         *m_transform;  

  // No default constructor.
  OrientationDialog();  

};

} //namespace mips

#endif /* MIPS_ORIENTATION_DIALOG_H */
