#include "vtkStructuredPointsReader.h"
#include "vtkStructuredPoints.h"
#include "mipsDataSetManager.h"
#include "mipsVtkImageDataSet.h"
#include <iostream>

#include "mipsVtkImageReader.h"

namespace mips {

DataSet*
VtkImageReader::Read (const char* p_filename) const
{
  vtkStructuredPoints*       image  = 0;
  vtkStructuredPointsReader* reader = vtkStructuredPointsReader::New();
  reader->SetFileName(p_filename);
  
  try{
    image = reader->GetOutput();
    image->Update();
  }catch (...) {
    return 0;
  }    

  VtkImageDataSet* dataset = 0;
  dataset = dynamic_cast<VtkImageDataSet*>
    (DataSetManager::NewDataSet("VtkImageDataSet"));
  if (dataset){    
    dataset->SetVtkImage(image);
    dataset->SetFileName(p_filename);
  }
  else {
    image->Delete();
    std::cout << "ERROR : DataSetManager::NewDataSet(\"VtkImageDataSet\")  failed on "
              << p_filename << std::endl;
  }  
  return dataset ;  
}

}
