#include "mipsInrimageToVTKImageData.h"

#include <inrimage/Inrimage.h>



using namespace yav;
namespace mips {

//----------------------------------------------------------------------------
  InrimageToVTKImageData::InrimageToVTKImageData()
  {
    m_inputImage = NULL;
    m_Importer = vtkImageImport::New();
    m_Exporter = new InrimageVTKImageExport;

    m_Importer->SetDataScalarTypeToDouble();
    //m_Importer->SetUpdateInformationCallback(m_Exporter->GetUpdateInformationCallback());
    m_Importer->SetWholeExtentCallback(m_Exporter->GetWholeExtentCallback());
    m_Importer->SetSpacingCallback(m_Exporter->GetSpacingCallback());
    m_Importer->SetOriginCallback(m_Exporter->GetOriginCallback());
    m_Importer->SetScalarTypeCallback(m_Exporter->GetScalarTypeCallback());
    m_Importer->SetNumberOfComponentsCallback(m_Exporter->GetNumberOfComponentsCallback());
    m_Importer->SetDataExtentCallback(m_Exporter->GetDataExtentCallback());
    //m_Importer->SetUpdateDataCallback(m_Exporter->GetUpdateDataCallback());
    m_Importer->SetBufferPointerCallback(m_Exporter->GetBufferPointerCallback());
    m_Importer->SetCallbackUserData(m_Exporter->GetCallbackUserData());
  }

  InrimageToVTKImageData::~InrimageToVTKImageData()
  {
    m_Importer->Delete();
    delete m_Exporter;
  }

  void
  InrimageToVTKImageData::SetInput(const Inrimage* im)
  {
    m_Exporter->SetInput(im);
  }

  void
  InrimageToVTKImageData::Update()
  {
    m_Importer->Update();
  }

//----------------------------------------------------------------------------




}//end of namespace mips
