#ifndef __mipsInrimageToVTKImageData_h
#define __mipsInrimageToVTKImageData_h

#include <inrimage/Inrimage.h>
#include "mipsInrimageVTKImageExport.h"
#include <vtkImageImport.h>
#include <vtkImageData.h>


namespace yav {
  class Inrimage;
};


namespace mips {

/** \class InrimageToVTKImageData
    \ingroup ImageGUI
*/
class InrimageToVTKImageData
{
 public:

  typedef yav::Inrimage  Inrimage;

  /// Create an empty exporter
  InrimageToVTKImageData();
  virtual ~InrimageToVTKImageData();
  
  void SetInput(const Inrimage*);
  vtkImageData* GetOutput(void)
    {return m_Importer->GetOutput();};
  void Update(void);
  
 private:
  const Inrimage * m_inputImage;
  vtkImageImport* m_Importer;
  InrimageVTKImageExport* m_Exporter;
  
};

} // namespace mips
#endif
