#ifndef _MIPS_INRIMAGEVTKIMAGEEXPORT_H_
#define _MIPS_INRIMAGEVTKIMAGEEXPORT_H_

#include <inrimage/Inrimage.h>
#include "mipsVTKImageExportBase.h"

namespace mips
{

/** \class InrimageVTKImageExport
    \ingroup ImageGUI
*/
class InrimageVTKImageExport: public VTKImageExportBase
{
 public:
  typedef yav::Inrimage Inrimage;
  
  InrimageVTKImageExport();
  ~InrimageVTKImageExport();
  
  /** Set the input image of this image exporter. */
  void SetInput(const Inrimage*);
  
 protected:
  
  const Inrimage* GetInput(void);
  
  void UpdateInformationCallback(){};
  int PipelineModifiedCallback(){return 0;};
  int* WholeExtentCallback();
  double* SpacingCallback();
  double* OriginCallback();
  float* FloatSpacingCallback();
  float* FloatOriginCallback();
  const char* ScalarTypeCallback();
  int NumberOfComponentsCallback();
  void PropagateUpdateExtentCallback(int* extent){};
  void* BufferPointerCallback();
  int* DataExtentCallback();
  void UpdateDataCallback(){};
  
 private:
  const Inrimage* m_Input;
  std::string m_ScalarTypeName;
  int m_WholeExtent[3];
  double m_DataSpacing[3];
  double m_DataOrigin[3];
  float m_FloatDataSpacing[3];
  float m_FloatDataOrigin[3];  
};


} // end if namespace

#endif
