#include "mipsVTKImageDataToInrimage.h"

namespace mips
{
  
  VTKImageDataToInrimage::VTKImageDataToInrimage()
  {
    m_Input = 0;

    m_Exporter = vtkImageExport::New();
    m_Importer = new InrimageVTKImageImport;

    m_Importer->SetSpacingCallback ( m_Exporter->GetSpacingCallback() );
    m_Importer->SetOriginCallback  ( m_Exporter->GetOriginCallback() );
    m_Importer->SetScalarTypeCallback ( m_Exporter->GetScalarTypeCallback() );
    m_Importer->SetNumberOfComponentsCallback ( m_Exporter->GetNumberOfComponentsCallback() );
    m_Importer->SetDataExtentCallback ( m_Exporter->GetDataExtentCallback () );
    m_Importer->SetBufferPointerCallback ( m_Exporter->GetBufferPointerCallback() );
    m_Importer->SetCallbackUserData ( m_Exporter->GetCallbackUserData() );
  }

  VTKImageDataToInrimage::~VTKImageDataToInrimage()
  {
    m_Exporter->Delete();
    delete m_Importer;
  }


  void VTKImageDataToInrimage::SetInput (vtkImageData* input)
  {
    m_Input = input;
    m_Exporter->SetInput (m_Input);
  }


  void VTKImageDataToInrimage::Update()
  {
    m_Importer->Update();
  }
  
  
  
}
