#ifdef _MSC_VER
#pragma warning ( disable : 4068 )
#pragma warning ( disable : 4786 )
#pragma warning ( disable : 4081 )
#endif

#pragma implementation "inrimage/ImageLandmarkSet.h"

#include <inrimage/ImageLandmarkSet.h>
#include <graphics2D/Camera2D.h>
#include <inrimage/Image3DCameraBackground.h>


namespace yav {



void ImageLandmarkSet::addLandmark(ImageLandmark *imagelandmark)
{
  LandmarkSet::addLandmark(imagelandmark);
}


void ImageLandmarkSet::removeLandmark(ImageLandmark *imagelandmark)
{ 
	LandmarkSet::removeLandmark(imagelandmark);
}


void ImageLandmarkSet::init() {
	selectionMode=CREATE_LANDMARK;
	movingLandmark=0;
	displayMode=CROSS;
	landmarkColor[0]=1.0;
	landmarkColor[1]=0.0;
	landmarkColor[2]=1.0;

	selectedLandmarkColor[0]=1.0;
	selectedLandmarkColor[1]=1.0;
	selectedLandmarkColor[2]=0.0;

	selectedLandmark=0;
	crossSize=2;
	displayName=false;
}

ImageLandmarkSet::~ImageLandmarkSet() {}
void ImageLandmarkSet::mouseButtonPressed(CameraTypes::WHICH_BUTTON button,
										  CameraTypes::KEY_MODIFIER modifier,
										  Camera2D *cam,int mx,int my) 
{
	if (cam->getBackground()) 
	{
		Image3DCameraBackground *b=static_cast<Image3DCameraBackground *> (cam->getBackground());
		switch(selectionMode) {
	case CREATE_LANDMARK:
		{
			Vec2<double> pixel(mx,my);
			Vec2<double> pos2D;
			Vec4<double> posVoxel4D;
			Vec3<double> pos3D,posVoxel3D;
			cam->mapScreenTo2DWorldCoordinates(pixel,pos2D);
			b->map2DWorldToImageCoordinates(pos2D,posVoxel4D);
			posVoxel3D=Vec3<double>(posVoxel4D.getX(),posVoxel4D.getY(),posVoxel4D.getZ());
			b->map2DWorldTo3DWorldCoordinates(pos2D,pos3D);
			unsigned int   rank = getNumberOfLandmarks()+1;
			TclString identifiant;
			identifiant.sprintf("landmark_no_%u",rank);
			ImageLandmark *imagelandmark = new ImageLandmark(posVoxel3D, pos3D,identifiant);
			addLandmark(imagelandmark);
			selectedLandmark=imagelandmark;
			redrawScene();
		}
		break;
	case DELETE_LANDMARK:
		{
			Vec2<double> pixel(mx,my);
			Vec2<double> pos2D;
			Vec3<double> pos3D;
			double dist,minDist;
			double distThreshold=b->getPixelSize()*3;
			minDist= -1.0;
			cam->mapScreenTo2DWorldCoordinates(pixel,pos2D);
			b->map2DWorldTo3DWorldCoordinates(pos2D,pos3D);

			ObjectsList<ImageLandmark>::iterator it;
			for(it=firstLandmark();it!=lastLandmark();it++) {
				if (b->isPointInSlice((*it)->getRealPosition())) {
					dist=(pos3D-(*it)->getRealPosition()).norm2();
					if ((minDist<0) || (dist<minDist))
					{
						minDist=dist;
						selectedLandmark=(*it);
					} 
				}
			}
			if ((minDist<distThreshold) && (minDist>0)) {
				removeLandmark(selectedLandmark);
				redrawScene();
			}
		}
		break;
		case SELECT_LANDMARK:
		{
			Vec2<double> pixel(mx,my);
			Vec2<double> pos2D;
			Vec3<double> pos3D;
			double dist,minDist;
			double distThreshold=b->getPixelSize()*3;
			minDist= -1.0;
			cam->mapScreenTo2DWorldCoordinates(pixel,pos2D);
			b->map2DWorldTo3DWorldCoordinates(pos2D,pos3D);

			ObjectsList<ImageLandmark>::iterator it;
			ImageLandmark *l=0;
			for(it=firstLandmark();it!=lastLandmark();it++) {
				if (b->isPointInSlice((*it)->getRealPosition())) {
					dist=(pos3D-(*it)->getRealPosition()).norm2();
					if ((minDist<0) || (dist<minDist))
					{
						minDist=dist;
						l=(*it);
					} 
				}
			}
			if ((minDist<distThreshold) && (minDist>0)) {
				selectedLandmark=l;
				redrawScene();
			}
		}
		break;
	case MOVE_LANDMARK:
		{
			Vec2<double> pixel(mx,my);
			Vec2<double> pos2D;
			Vec3<double> pos3D;
			double dist,minDist;
			double distThreshold=b->getPixelSize()*3;
			minDist= -1.0;
			cam->mapScreenTo2DWorldCoordinates(pixel,pos2D);
			b->map2DWorldTo3DWorldCoordinates(pos2D,pos3D);

			ObjectsList<ImageLandmark>::iterator it;
			for(it=firstLandmark();it!=lastLandmark();it++) {
				if (b->isPointInSlice((*it)->getRealPosition())) {
					dist=(pos3D-(*it)->getRealPosition()).norm2();
					if ((minDist<0) || (dist<minDist))
					{
						minDist=dist;
						movingLandmark=(*it);
					} 
				}
			}
			if ((minDist>distThreshold) || (minDist<0))
				movingLandmark=0;

		}
		break;
	default:
		break;
		}

	}

}

void ImageLandmarkSet::mouseButtonMoved(Camera2D *cam, 
										int  mx, int my) 
{
	if (cam->getBackground()) 
	{
		Image3DCameraBackground *b=static_cast<Image3DCameraBackground *> (cam->getBackground());
		if ((selectionMode==MOVE_LANDMARK) && (movingLandmark)) {
			Vec2<double> pixel(mx,my);
			Vec2<double> pos2D;
			Vec4<double> posVoxel;
			Vec3<double> pos3D;
			cam->mapScreenTo2DWorldCoordinates(pixel,pos2D);
			b->map2DWorldToImageCoordinates(pos2D,posVoxel);
			movingLandmark->setVoxelPosition(Vec3<double>(posVoxel.getX(),posVoxel.getY(),posVoxel.getZ()));
			b->map2DWorldTo3DWorldCoordinates(pos2D,pos3D);
			movingLandmark->setRealPosition(pos3D);
			redrawScene();
		}
	}

}
void ImageLandmarkSet::mouseButtonReleased(CameraTypes::WHICH_BUTTON button,
										   CameraTypes::KEY_MODIFIER modifier,
										   Camera2D *cam,int mx,int my) 
{
	
}
void  ImageLandmarkSet::redraw(Camera2D *cam) 
{
	if (cam->getBackground()) {
		Image3DCameraBackground *b=static_cast<Image3DCameraBackground *> (cam->getBackground());
		ObjectsList<ImageLandmark>::iterator it;
		Vec2<double> pos2D;
		double size=crossSize;
		if (displayMode==CROSS) 
			glBegin(GL_LINES);
		for(it=firstLandmark();it!=lastLandmark();it++) {
			if (b->map3DWorldTo2DWorldCoordinates((*it)->getRealPosition(),pos2D)) {
				if ((*it)==selectedLandmark)
					glColor3fv(selectedLandmarkColor); 
				else 
					glColor3fv(landmarkColor);
				if (displayMode==CROSS) {
					glVertex2d(pos2D.getX()-size,pos2D.getY());
					glVertex2d(pos2D.getX()+size,pos2D.getY());
					glVertex2d(pos2D.getX(),pos2D.getY()-size);
					glVertex2d(pos2D.getX(),pos2D.getY()+size);
				} else if (displayMode==VOXEL){
					glBegin(GL_POLYGON);
					glVertex2d(pos2D.getX()-size,pos2D.getY()-size);
					glVertex2d(pos2D.getX()+size,pos2D.getY()-size);
					glVertex2d(pos2D.getX()+size,pos2D.getY()+size);
					glVertex2d(pos2D.getX()-size,pos2D.getY()+size);
					glEnd();
				}
			}
		}
		if (displayMode==CROSS) 
			glEnd();

	}

}




ImageLandmarkSet::ImageLandmarkSet(Scene2D *_scene) : LandmarkSet(),Data2D(_scene,false)
{
	init();
}
ImageLandmarkSet::ImageLandmarkSet(Scene2D *_scene,char *filename) : LandmarkSet(filename),Data2D(_scene,false)
{
	init();
}

ImageLandmarkSet::ImageLandmarkSet(Scene2D *_scene, std::list<ImageLandmark *> list) : LandmarkSet(list),Data2D(_scene,false)
{
	init();
}


} 



























