
#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#include <tk.h>
#include <modules/TclModule.h>
#include <graphics2D/TclCamera2D.h>
#include <graphics2D/TclScene2D.h>
#include <inrimage/TclImageLandmarkSet.h>
#include <inrimage/TclBoundingBox3D.h>
#include <inrimage/TclInrimageROI.h>
#include <inrimage/TclROIEdit.h>
#include <inrimage/TclInrimage.h>
#include <inrimage/TclInrimage4D.h>
#include <inrimage/TclColorMap.h>
//#include <inrimage/MultiView.h>
//#include <inrimage/MultiView4D.h>
#include <inrimage/GLScale.h>
#include <inrimage/InrimageCmd.h> 
#include <inrimage/TclDisplacementField3D.h>
#include <inrimage/TclImage3DCameraBackground.h>
#include <inrimage/TclImage3DBackgroundManager.h>
#include <inrimage/TclStructuringElement.h>


#ifdef EMBEDED_TCL_SCRIPTS
#include "tclInrimage.tcl.h" // generated by tcl2h
#endif


namespace yav {

const char *TclInrimageInit::tclInrimageName="tclInrimage";
static TclInrimageInit tclInrimageInit;

// module initialization
void Tclinrimage_Init(TclModule *m) {
  TclObjectKind *kind;

//  TclInrimage::CreateInrimagePhotoFormat();
//  TclInrimage4D::CreateInrimage4DPhotoFormat();
 
  TclModule *tclgr2D = TclModule::findModuleByName("tclGraphics2D");
  if(!tclgr2D) {
    CERR << "Tclinrimage_Init: fatal error: module tclGraphics2D not loaded" << ENDL;
    exit(-1);
  }
  m->newCommand("image4DFormat", TclInrimage4D::imageFormatCmd,
		"input | output",
		"returns the available file format for reading or writing a 4D image. For each format gives the \"real name\" and the file extensions separated with a comma");

  TclImage3DCameraBackground::createCommands(m);
  TclImage3DBackgroundManager::createCommands(m);
  TclBoundingBox3D::createCommands(m);
  TclInrimage::createCommands(m);
  TclInrimageROI::createCommands(m);
  TclROIEdit::createCommands(m);
  TclROIList::createCommands(m);


#ifdef OLD_CODE
  kind = new Scene2DItem(m, typeid(MultiView), "multiview","Multiview Widget", 
			 &MultiView::create, &MultiView::list, 
			 TclScene2D::OTHER, "[-in %w] [-add slicecam%u+]"); 
  m->newCommand("multiview%u", kind->getOptions(), 
		"multiview management command"); 
  kind->newOption("-destroy", (TclObject::OPTION) &MultiView::destroyCmd, 0, 
		  "destroy multi-viewer"); 
  kind->newOption("-scene", (TclObject::OPTION) &MultiView::sceneCmd, 
		  0, 
		  "return the scene associated with the multiview"); 
  kind->newOption("-add", (TclObject::OPTION) &MultiView::addCmd, 
		  "slicecam%u+", 
		  "add all given inrimage views to multi-viewer"); 
  kind->newOption("-addmview", (TclObject::OPTION) &MultiView::addmviewCmd, 
		  "[multiview%u -mat mat4D%u]+", 
		  "add a multiview with a transformation to multi-viewer"); 
  kind->newOption("-removemview", (TclObject::OPTION) &MultiView::removemviewCmd, 
		  "multiview%u+", 
		  "remove a multiview to multi-viewer"); 
  kind->newOption("-removeAllmview", (TclObject::OPTION) &MultiView::removeAllmviewCmd, 
		  "", 
		  "remove all multiviews attached to multi-viewer"); 
  kind->newOption("-listmview", (TclObject::OPTION) &MultiView::listmviewCmd, 
		  "", 
		  "return all associated multiview with their transfo"); 
  kind->newOption("-remove", (TclObject::OPTION) &MultiView::removeCmd, 
		  "slicecam%u+", 
		  "remove all given inrimage views from multi-viewer"); 
  kind->newOption("-parentWidget", (TclObject::OPTION) &MultiView::parentWidgetCmd, 
		  "%w", 
		  "connects a multiview with a widget such that when the multiview is deleted the widget is destroyed"); 
  kind->newOption("-views", (TclObject::OPTION) &MultiView::viewsCmd, "[X|Y|Z|alpha]", 
		  "Returns all handled viewers. If a geometry argument is given, only viewers to corresponding geometry are returned.");
  kind->newOption("-mousevoxel", (TclObject::OPTION) &MultiView::mousevoxelCmd,
		  "slicecam%u %x %y",
		  "set mouse motion in all handled viewers when cursor location is (x, y) in given slicecam%u");
  kind->newOption("-changeview", (TclObject::OPTION) &MultiView::changeViewCmd,
		  "slicecam%u %x %y",
		  "Change all handled viewers slice when point (x, y) is clicked in given slicecam%u");
  kind->newOption("-axis", (TclObject::OPTION) &MultiView::axisCmd, "[%b]",
		  "set/get use axis flag");
  kind->newOption("-axisColors", (TclObject::OPTION) &MultiView::axisColorCmd,
		  "[%s %s]", "set/get axis display colors");
  kind->newOption("-activate", (TclObject::OPTION) &MultiView::activateCmd, "[%b]",
		  "set/get activation flag. Activation cause all handled viewer to be activated");
  kind->newOption("-ignoreVoxelSize", (TclObject::OPTION) &MultiView::ignoreVoxelSizeCmd,
		  "[%b]", "set/get all handled viewers ignore voxel size flag");
  kind->newOption("-scale", (TclObject::OPTION) &MultiView::scaleCmd, "[%f]",
		  "set/get all handled viewers zoom factor");
  kind->newOption("-redraw", (TclObject::OPTION) &MultiView::redrawCmd, 0,
		  "cause all attached slice cameras to be redrawn");
  kind->newOption("-min", (TclObject::OPTION) &MultiView::minCmd, "%v",
		  "set min grey level threshold values");
  kind->newOption("-max", (TclObject::OPTION) &MultiView::maxCmd, "%v",
		  "set max grey level threshold values");
  kind->newOption("-inrimage", (TclObject::OPTION) &MultiView::inrimageCmd, "inr%u",
		  "set all handled viewers image");
  kind->newOption("-visible", (TclObject::OPTION) &MultiView::visibleCmd,
		  "<all | %u %u %u %u %u %u>",
		  "set visible area of all handled viewers to maximum scale (all parameter) or given box (two voxel coordinates)");
  kind->newOption("-die", (TclObject::OPTION) &MultiView::dieCmd,"[%b]","true if multiview dies when it runs out of images"); 
#endif
  
  
#ifdef OLD_CODE
  kind = new Scene2DItem(m, typeid(TclInrimageView), "inrview","Image Viewer",
			 &TclInrimageView::create, &TclInrimageView::list,
			 TclScene2D::OTHER, "inr%u scn2D%u [-noGLScale]");
  m->newCommand("inrview%u", kind->getOptions(), "inrimage view management command");
  kind->newOption("-arrow", (TclObject::OPTION) &TclInrimageView::arrowCmd, "[%b]",
		  "set/get the arrow display mode. true draw the end of the arrow. false draw only a line");
  kind->newOption("-vectorScale", (TclObject::OPTION) &TclInrimageView::vectorScaleCmd, "[%f]",
		  "vector Scale for display of vectorial image");
  kind->newOption("-vectorWidth", (TclObject::OPTION) &TclInrimageView::vectorWidthCmd, "[%f]",
		  "vector Width for display of vectorial image");
  kind->newOption("-displayMode", (TclObject::OPTION) &TclInrimageView::displayModeCmd, "< WITHOUT_VECTOR | WITH_VECTOR  <%u %u %u %f %f [ [alpha %f beta %f]> | normalized ] | VECTOR_ONLY <%u %u %u %f %f [ [alpha %f beta %f] | normalized ]> >",
		  "displayMode for vectorial image. In case of WITH_VECTOR or VECTOR_ONLY, you need to supply under sample in x, y and z, vector width and scale. By defaults, you see real vector norms. You may want to use special visualization in which the the projected norm x of a vector is adjusted with the function B*(1-exp(-A/B*x)). The normalized norms draws all the vectors the same size.\
                   This allows to better distinguish some vectors dimensions.");
  kind->newOption("-destroy", (TclObject::OPTION) &TclInrimageView::destroyCmd, 0,
		  "destroy inrimage view");
  kind->newOption("-scene", (TclObject::OPTION) &TclInrimageView::sceneCmd, 0,
		  "return inrimage view's scene");
  kind->newOption("-GLScale", (TclObject::OPTION) &TclInrimageView::GLScaleCmd, "slicecam%u [-min|-max]",
		  "return the grey level scales associated with a given slicecam");
  kind->newOption("-background", (TclObject::OPTION) &TclInrimageView::backgroundCmd, "slicecam%u | all",
		  "return the Tcl inrimage background associated with a slice camera");
  kind->newOption("-inrimage", (TclObject::OPTION) &TclInrimageView::inrimageCmd,"[inr%u]" ,
		  "get/set the observed inrimage");

  kind = new Scene2DItem(m, typeid(TclOverlayInrimageView), "overinrview","Overlay Image Viewer",
			 &TclOverlayInrimageView::create, &TclOverlayInrimageView::list,
			 TclScene2D::OTHER, "inr%u inr2%u scn2D%u [-noGLScale]");
  m->newCommand("overinrview%u", kind->getOptions(), "overlay inrimage view management command");
  kind->addOptions(typeid(TclInrimageView));
  kind->newOption("-secondInrimage", (TclObject::OPTION) &TclOverlayInrimageView::secondInrimageCmd,"[inr%u]" ,
		  "get/set the second inrimage");


  kind = new Scene2DItem(m, typeid(TclTransformedInrimageView), "transinrview","Transformed Image Viewer",
			 &TclTransformedInrimageView::create, &TclTransformedInrimageView::list,
			 TclScene2D::OTHER, "inr%u scn2D%u [-noGLScale]");
  m->newCommand("transinrview%u", kind->getOptions(), "transformed inrimage view management command");
  kind->addOptions(typeid(TclInrimageView));
  kind->newOption("-transformation", (TclObject::OPTION) &TclTransformedInrimageView::transformationCmd,"[ mat4D%u | +   mat4D%u | - mat4D%u  | * mat4D%u]" ,
		  "Without any parameters returns the current transformation matrix. If a 4D matrix is provided, then set the transformation matrix to this matrix. Otherwise performs addition, multiplication and substraction with a given matrix");
  kind->newOption("-scaleTransformation", (TclObject::OPTION) &TclTransformedInrimageView::scaleTransformationCmd,"%f | %f %f %f",
		  "with one floating number multiply the matrix with one scale and with three numbers scale each axis separately");
  kind->newOption("-resetTransformation", (TclObject::OPTION) &TclTransformedInrimageView::resetTransformationCmd,"translation | rotation | scale",
		  "set the translation part of the 4x4 matrix or set the rotation part to identity or set the scale part to 1.0");


  kind = new Scene2DItem(m, typeid(TclInrimageBackground), "inrbgrnd","Inrimage Background",
			 &TclInrimageBackground::create, &TclInrimageBackground::list,
			 TclScene2D::OTHER,
			 "inr%u slicecam%u [-scene scn2D%u | -min glscale%u | -max glscale%u]");
  m->newCommand("inrbgrnd%u", kind->getOptions(),
		"Inrimage background  management command");
  kind->newOption("-scalemode", (TclObject::OPTION) &TclInrimageBackground::scalemodeCmd,
		  "[affine|threshold|pet|spect|hotiron|blue]",
		  "get/set the displayed grey-level transformation mode");
  kind->newOption("-destroy", (TclObject::OPTION) &TclInrimageBackground::destroyCmd, 0,
		  "destroy inrimage background");
  kind->newOption("-ignoreVoxelSize",
		  (TclObject::OPTION) &TclInrimageBackground::ignoreVoxelSizeCmd, "%b",
		  "get/set ignore voxel size flag");
  kind->newOption("-greyLevel", (TclObject::OPTION) &TclInrimageBackground::greyLevelCmd,"min [glscale%u] | max [glscale%u] " ,
		  "get/set each grey-level scale (min and max) associated to a background");
  kind->newOption("-interpolation", (TclObject::OPTION) &TclInrimageBackground::interpolationCmd,"[nearest | bilinear ]" ,
		  "get/set the interpolation mode for displaying images. By default the nearest neighbor method is used (nearest). Bilinear interpolation is also available");


  kind = new Scene2DItem(m, typeid(TclOverlayBackground), "overinrbgrnd","Overlay Inrimage Background",
			 &TclOverlayBackground::create, &TclOverlayBackground::list,
			 TclScene2D::OTHER,
			 "inr%u inr%u slicecam%u [-scene scn2D%u | -min glscale%u | -max glscale%u | -min2 glscale%u | -max2 glscale%u | -opac opacscale%u]");
  m->newCommand("overinrbgrnd%u", kind->getOptions(), "overlay inrimage background view management command");
  kind->addOptions(typeid(TclInrimageBackground));
  kind->newOption("-opacity", (TclObject::OPTION) &TclOverlayBackground::opacityCmd,"[opascale%u]" ,
		  "get/set the opacity scale");
  kind->newOption("-scalemode2", (TclObject::OPTION) &TclOverlayBackground::scalemode2Cmd,
		  "[affine|threshold|pet|spect|hotiron|blue]",
		  "get/set the displayed grey-level transformation mode for the second image");
  kind->newOption("-greyLevel", (TclObject::OPTION) &TclOverlayBackground::greyLevelCmd,"min [glscale%u] | max [glscale%u] | min2 [glscale%u] | max2 [glscale%u]" ,
		  "get/set each grey-level scale (min and max) associated to each image");


  kind = new Scene2DItem(m, typeid(TclTransformedInrimageBackground), "transinrbgrnd","Transformed Inrimage Background",
			 &TclTransformedInrimageBackground::create, &TclTransformedInrimageBackground::list,
			 TclScene2D::OTHER,
			 "inr%u slicecam%u [-scene scn2D%u | -min glscale%u | -max glscale%u ]");
  m->newCommand("transinrbgrnd%u", kind->getOptions(), "transformed inrimage background view management command");
  kind->addOptions(typeid(TclInrimageBackground));
#endif



  kind = new Scene2DItem(m, typeid(GLScale), "glscale","Grey Level Scaler",
			 &GLScale::create, &GLScale::list,
			 TclScene2D::OTHER,
			 "-in %w <-min|-max> [-add slicecam%u+]");
  m->newCommand("glscale%u", kind->getOptions(),
		"greylevel scale management command");
  kind->addOptions(typeid(TclScale));

  kind = new Scene2DItem(m, typeid(OpacityScale), "opascale","Opacity Scaler",
			 &OpacityScale::create, &OpacityScale::list,
			 TclScene2D::OTHER,
			 "-in %w <-min|-max> [-add slicecam%u+]");
  m->newCommand("opascale%u", kind->getOptions(),
		"opacity scale management command");
  kind->addOptions(typeid(TclScale));

  kind = new Scene2DItem(m, typeid(TclColorMap), "cm","Color Map",
			 &TclColorMap::create, &TclColorMap::list,
			 TclScene2D::OTHER,
			 "[inr%u | %s]");
  m->newCommand("cm%u", kind->getOptions(),
		"color map management command");
  kind->newOption("-destroy", (TclObject::OPTION) &TclColorMap::destroyCmd, 0,
		  "destroy a color map");
  kind->newOption("-getColor", (TclObject::OPTION) &TclColorMap::getColorCmd, 
		  "[%u]",
		  "without argument returns the 257x3 array of colormap entries; with an index between 0 and 256, returns the RGB color associated with that index");
  kind->newOption("-setColor", (TclObject::OPTION) &TclColorMap::setColorCmd, 
		  "[%u %u %u %u]",
		  "modifies the color map entry : first value is the  colormap index between 0 and 256 whereas the following three parameters are the RGB components of the color");
  
  kind = new Scene2DItem(m, typeid(TclStructuringElement), "structelem","Structuring Element", &TclStructuringElement::create, &TclStructuringElement::list); 
		
  m->newCommand("structelem%u", kind->getOptions(),
		"Structuring Element management comand");

  kind = new Scene2DItem(m, typeid(TclInrimage4D), "inr4D","4D Image",
			 &TclInrimage4D::create, &TclInrimage4D::list,
			 TclScene2D::FILE | TclScene2D::OTHER,
			 "4D Inrimage", ".inr4D", &TclInrimage4D::load, 0,
			 "filename=%s [-scene scn4D%u]");
  m->newCommand("inr4D%u", kind->getOptions(), "4D inrimage management command");
  kind->newOption("-destroy", (TclObject::OPTION) &TclInrimage4D::destroyCmd, 0,
		  "delete a 4D inrimage");
  kind->newOption("-save", (TclObject::OPTION) &TclInrimage4D::saveCmd,
		  "[filename=%s]",
		  "save 4D inrimage (if filename is given, 4D inrimage is saved as filename and each 3D inrimage is saved as name000.inr, name001.inr... where name is filename without .inr4D suffix)");
  kind->newOption("-name", (TclObject::OPTION) &TclInrimage4D::nameCmd,
		  "[filename=%s]", "set/get 4D inrimage file name");
  kind->newOption("-type", (TclObject::OPTION) &TclInrimage4D::typeCmd,
		  "[[cast|scale] <8bits|16bits|s16bits|32bits|s32bits|64bits|s64bits|float|double|rgb|rgba|floatVector|doubleVector>]",
		  "get/set 4D inrimage type");
  kind->newOption("-glbounds", (TclObject::OPTION) &TclInrimage4D::glboundsCmd,
		  "[min %%v] [max %%v]",
		  "get/set 4D inrimage min and max grey level values");
  kind->newOption("-voxel", (TclObject::OPTION) &TclInrimage4D::voxelCmd,
		  "[%f %f %f]",
		  "get/set 4D inrimage voxels size");
  kind->newOption("-gradient", (TclObject::OPTION) &TclInrimage4D::gradientCmd,
		  "[sigma %f] [2D|3D] [rec [marta|gaussian|deriche] | sobel] [dir <vectors|sample>] [max] [lt %f]",
		  "compute each 3D image gradient and build a 4D gradient inrimage");
  kind->newOption("-redraw", (TclObject::OPTION) &TclInrimage4D::redrawCmd,
		  0,"force inrimage to be redisplayed in any viewer it appears");
  kind->newOption("-slicecams", (TclObject::OPTION) &TclInrimage4D::slicecamsCmd, 0,
		  "return a list of timeslicecams associated with the image");
  kind->newOption("-anisotropicDiffusion", (TclObject::OPTION) &TclInrimage4D::anisotropicDiffusionCmd,
		  "[%f %f %f %b %f %s %b]",
		  "compute the anisotropic diffusion of the image. The first parameter is the time step dt (dt>0). The second parameter is the diffusion time tmax with tmax>=dt. Indeed, (tmax/dt) is the number of iterations. The third parameter is the quantile quant that set the gradient threshold (0<quant<100). The fourth paramater is a boolean that indicates if we smooth the gradient information in the diffusity matrix. The fifth parameter is the standard deviation of smoothing kernel. The sixth parameter indicates the diffusion function df used. Currently, df is either \"aubert\" or \"perona\". And the last parameter indicates wether the temporary buffers are saved to disk to save memory (for big images) or not.");
  kind->newOption("-crop", (TclObject::OPTION) &TclInrimage4D::cropCmd,
		  "<org %u %u %u | center %u %u %u> <end %u %u %u | size %u %u %u>",
		  "crop inrimage with given box (from org to end or centered on center and with given size)");
#ifdef OLD_CODE
  
  kind = new Scene2DItem(m, typeid(MultiView4D), "multiview4D"," 4D Multiview Widget", 
			 &MultiView4D::create, &MultiView4D::list, 
			 TclScene2D::OTHER, "[-in %w] [-add timecam%u+]"); 
  m->newCommand("multiview4D%u", kind->getOptions(), 
		"4D multiview management command"); 
  kind->newOption("-destroy", (TclObject::OPTION) &MultiView4D::destroyCmd, 0, 
		  "destroy multi-viewer"); 
  kind->newOption("-scene", (TclObject::OPTION) &MultiView4D::sceneCmd, 
		  0, 
		  "return the scene associated with the multiview"); 
  kind->newOption("-add", (TclObject::OPTION) &MultiView4D::addCmd, 
		  "timecam%u+", 
		  "add all given inrimage views to multi-viewer"); 
  kind->newOption("-remove", (TclObject::OPTION) &MultiView4D::removeCmd, 
		  "timecam%u+", 
		  "remove all given inrimage views from multi-viewer"); 
  kind->newOption("-parentWidget", (TclObject::OPTION) &MultiView4D::parentWidgetCmd, 
		  "%w", 
		  "connects a multiview with a widget such that when the multiview is deleted the widget is destroyed"); 
  kind->newOption("-views", (TclObject::OPTION) &MultiView4D::viewsCmd, "[X|Y|Z|alpha|XT|YT|ZT]", 
		  "Returns all handled viewers. If a geometry argument is given, only viewers to corresponding geometry are returned.");
  kind->newOption("-mousevoxel", (TclObject::OPTION) &MultiView4D::mousevoxelCmd,
		  "timecam%u %x %y",
		  "set mouse motion in all handled viewers when cursor location is (x, y) in given timecam%u");
  kind->newOption("-changeview", (TclObject::OPTION) &MultiView4D::changeViewCmd,
		  "timecam%u %x %y",
		  "Change all handled viewers slice when point (x, y) is clicked in given timecam%u");
  kind->newOption("-axis", (TclObject::OPTION) &MultiView4D::axisCmd, "[%b]",
		  "set/get use axis flag");
  kind->newOption("-axisColors", (TclObject::OPTION) &MultiView4D::axisColorCmd,
		  "[%s %s]", "set/get axis display colors");
  kind->newOption("-activate", (TclObject::OPTION) &MultiView4D::activateCmd, "[%b]",
		  "set/get activation flag. Activation cause all handled viewer to be activated");
  kind->newOption("-ignoreVoxelSize", (TclObject::OPTION) &MultiView4D::ignoreVoxelSizeCmd,
		  "[%b]", "set/get all handled viewers ignore voxel size flag");
  kind->newOption("-scale", (TclObject::OPTION) &MultiView4D::scaleCmd, "[%f]",
		  "set/get all handled viewers zoom factor");
  kind->newOption("-redraw", (TclObject::OPTION) &MultiView4D::redrawCmd, 0,
		  "cause all attached slice cameras to be redrawn");
  kind->newOption("-min", (TclObject::OPTION) &MultiView4D::minCmd, "%v",
		  "set min grey level threshold values");
  kind->newOption("-max", (TclObject::OPTION) &MultiView4D::maxCmd, "%v",
		  "set max grey level threshold values");
  kind->newOption("-inrimage", (TclObject::OPTION) &MultiView4D::inrimageCmd, "inr%u",
		  "set all handled viewers image");
  kind->newOption("-visible", (TclObject::OPTION) &MultiView4D::visibleCmd,
		  "<all | %u %u %u %u %u %u %u %u>",
		  "set visible area of all handled viewers to maximum scale (all parameter) or given box (two voxel coordinates)");
  kind->newOption("-die", (TclObject::OPTION) &MultiView4D::dieCmd,"[%b]","true if multiview dies when it runs out of images"); 

  kind = new Scene2DItem(m, typeid(TclInrimage4DView), "inr4Dview","Image Viewer",
			 &TclInrimage4DView::create, &TclInrimage4DView::list,
			 TclScene2D::OTHER, "inr4D%u scn2D%u [-noGLScale]");
  m->newCommand("inr4Dview%u", kind->getOptions(), "4D inrimage view management command");
  kind->newOption("-destroy", (TclObject::OPTION) &TclInrimage4DView::destroyCmd, 0,
		  "destroy 4D inrimage view");
  kind->newOption("-scene", (TclObject::OPTION) &TclInrimage4DView::sceneCmd, 0,
		  "return inrimage view's scene");
  kind->newOption("-GLScale", (TclObject::OPTION) &TclInrimage4DView::GLScaleCmd, "timecam%u [-min|-max]",
		  "return the grey level scales associated with a given slicecam");
  kind->newOption("-background", (TclObject::OPTION) &TclInrimage4DView::backgroundCmd, "timecam%u | all",
		  "return the Tcl inrimage background associated with a slice camera");
  kind->newOption("-inrimage", (TclObject::OPTION) &TclInrimage4DView::inrimageCmd,"[inr4D%u]" ,
		  "get/set the observed inrimage");

  kind = new Scene2DItem(m, typeid(TclOverlayInrimage4DView), "overinr4Dview","Overlay Image 4D Viewer",
			 &TclOverlayInrimage4DView::create, &TclOverlayInrimage4DView::list,
			 TclScene2D::OTHER, "inr4D%u inr24D%u scn2D%u [-noGLScale]");
  m->newCommand("overinr4Dview%u", kind->getOptions(), "overlay inrimage 4D view management command");
  kind->addOptions(typeid(TclInrimage4DView));
  kind->newOption("-secondInrimage", (TclObject::OPTION) &TclOverlayInrimage4DView::secondInrimageCmd,"[inr%u]" ,
		  "get/set the second inrimage 4D");
  
  
  kind = new Scene2DItem(m, typeid(TclInrimage4DBackground), "inr4Dbgrnd","4D Inrimage Background",
			 &TclInrimage4DBackground::create, 
			 &TclInrimage4DBackground::list,
			 TclScene2D::OTHER,
			 "inr%u timecam%u [-scene scn2D%u | -min glscale%u | -max glscale%u]");
  m->newCommand("inr4Dbgrnd%u", kind->getOptions(),
		"4D Inrimage background  management command");
  kind->newOption("-scalemode", (TclObject::OPTION) &TclInrimage4DBackground::scalemodeCmd,
		  "[affine|threshold|pet|spect|hotiron|blue]",
		  "get/set the displayed grey-level transformation mode");
  kind->newOption("-destroy", (TclObject::OPTION) &TclInrimage4DBackground::destroyCmd, 0,
		  "destroy inrimage background");
  kind->newOption("-ignoreVoxelSize",
		  (TclObject::OPTION) &TclInrimage4DBackground::ignoreVoxelSizeCmd, "%b",
		  "get/set ignore voxel size flag");
  
  kind->newOption("-greyLevel", (TclObject::OPTION) &TclInrimage4DBackground::greyLevelCmd,"min [glscale%u] | max [glscale%u] " ,
		  "get/set each grey-level scale (min and max) associated to a background");
  kind->newOption("-interpolation", (TclObject::OPTION) &TclInrimage4DBackground::interpolationCmd,"[nearest | bilinear ]" ,
		  "get/set the interpolation mode for displaying images. By default the nearest neighbor method is used (nearest). Bilinear interpolation is also available");

  kind = new Scene2DItem(m, typeid(TclOverlay4DBackground), "overinr4Dbgrnd","Overlay Inrimage 4D Background",
			 &TclOverlay4DBackground::create, &TclOverlay4DBackground::list,
			 TclScene2D::OTHER,
			 "inr4D%u inr4D%u slicecam%u [-scene scn2D%u | -min glscale%u | -max glscale%u | -min2 glscale%u | -max2 glscale%u | -opac opacscale%u]");
  m->newCommand("overinr4Dbgrnd%u", kind->getOptions(), "overlay inrimage 4D background view management command");
  kind->addOptions(typeid(TclInrimage4DBackground));
  kind->newOption("-opacity", (TclObject::OPTION) &TclOverlay4DBackground::opacityCmd,"[opascale%u]" ,
		  "get/set the opacity scale");
  kind->newOption("-scalemode2", (TclObject::OPTION) &TclOverlay4DBackground::scalemode2Cmd,
		  "[affine|threshold|pet|spect|hotiron|blue]",
		  "get/set the displayed grey-level transformation mode for the second image");
  kind->newOption("-greyLevel", (TclObject::OPTION) &TclOverlay4DBackground::greyLevelCmd,"min [glscale%u] | max [glscale%u] | min2 [glscale%u] | max2 [glscale%u]" ,
		  "get/set each grey-level scale (min and max) associated to each image");
#endif

  kind = new TclObjectKind(m, typeid(TclDisplacementField3D), "def3D",
			   "3D Displacement Field", &TclDisplacementField3D::create,
			   &TclDisplacementField3D::list, "<%s>");

  m->newCommand("def3D%u", kind->getOptions(),
		"3D Displacement Field management command");

  kind->newOption("-defx", (TclObject::OPTION) &TclDisplacementField3D::defxCmd, "", "get the x deformation field" );
  kind->newOption("-defy", (TclObject::OPTION) &TclDisplacementField3D::defyCmd, "", "get the y deformation field" );
  kind->newOption("-defz", (TclObject::OPTION) &TclDisplacementField3D::defzCmd, "", "get the z deformation field" );

  TclImageLandmarkSet::createCommands(m);

  char pkgName[]="inrimageTCL";
  char pkgVers[]="1.0";
  Tcl_PkgProvide(m->getInterp(), pkgName, pkgVers);

#ifdef EMBEDED_TCL_SCRIPTS
 /* Statically loads the tcl script from tclModules.tcl.h (generated by tcl2h) */
 Tcl_Eval(m->getInterp(), tclInrimage_tcl);
 /* Tell the TclModule constructor not to load the script again */
 m->tclScriptLoaded();
#endif
 /* Otherwise, the tcl script will be loaded dynamically from tclModules.tcl by the TclModule constructor */


}

#ifdef _SOLARIS_
int main() {
return 1;
}
#endif

} // namespace yav
