#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "inrimage/InrimageSliceInterface.h"

#include <inrimage/InrimageSliceInterface.h>

namespace yav {

AUTOLINK_STATIC_VARIABLES(InrimageSliceInterface);


InrimageSliceInterface::NoImageProvided::NoImageProvided(const std::string& from)
  : Exception(from, "Null Inrimage pointer provided") {
}
InrimageSliceInterface::InrimageSliceInterface(Inrimage * inr) : Owner<Inrimage>(inr) 
{
  if (inr==0)
    throw(NoImageProvided("InrimageSliceInterface::InrimageSliceInterface(Inrimage * inr)"));
}

void InrimageSliceInterface::addSlice(SliceCameraBackground *b) const {
  ObjectsList<InrimageSliceDisplayContainer>::iterator it=containerList.begin();
  for(;it!=containerList.end();it++)
    (*it)->sliceCreation(b);
}


void InrimageSliceInterface::deleteSlice(SliceCameraBackground *b) const {
  ObjectsList<InrimageSliceDisplayContainer>::iterator it=containerList.begin();
  for(;it!=containerList.end();it++)
    (*it)->sliceDestruction(b);
}


void InrimageSliceInterface::updateSlice(SliceCameraBackground *b) const {
  ObjectsList<InrimageSliceDisplayContainer>::iterator it=containerList.begin();
  for(;it!=containerList.end();it++)
    (*it)->sliceUpdate(b);
}


void InrimageSliceInterface::addContainer(InrimageSliceDisplayContainer *c) {
  containerList+=c;
}


void InrimageSliceInterface::updateImage() const {
  ObjectsList<InrimageSliceDisplayContainer>::iterator it=containerList.begin();
  for(;it!=containerList.end();it++)
    (*it)->imageUpdate(getInrimage());
}


void InrimageSliceInterface::deleteImage() const {
  ObjectsList<InrimageSliceDisplayContainer>::iterator it=containerList.begin();
  ObjectsList<InrimageSliceDisplayContainer>::iterator it2;
  for(;it!=containerList.end();it=it2)
  {
	it2=it;
	it2++;
    (*it)->imageDestroyed(getInrimage());
  }
}





void InrimageSliceInterface::dying(const ObjectPointer<Inrimage>& inr) {
  /*    if (inr==getInrimage())
      {
	delete this;	
	}*/
  deleteImage();
}

}
