/******************************************************************************/
/* MaskCalcAnisotropYZ.h                                                      */
/******************************************************************************/

#ifndef MASKCALCANISOTROPYZ_H
#define MASKCALCANISOTROPYZ_H

#ifdef _YAV_ // namespace for INRIA
#include "MaskTri.h"
#include "MaskCalculation.h"
namespace yav {
#else
#include "distancemap/MaskTri.h"
#include "distancemap/MaskCalculation.h"
#endif //_YAV_


class MaskCalcAnisotropYZ : public MaskCalculation
{
public :
  // Constructors 
  MaskCalcAnisotropYZ(float dy, float dz);
  MaskCalcAnisotropYZ(MaskTri * aTriangulation, float dy, float dz);

  // Destructor
  ~MaskCalcAnisotropYZ();

protected :
  float normeInf(chamferTriElmt elmt);
  float norme1(chamferTriElmt elmt);

  void relativeErrorCalc(chamferTriangle tri, RelErrorElmt * errElmt);

  // Fields 
  float dy;
  float dz;
};

#ifdef _YAV_
} // namespace yav
#endif

#endif // MASKCALCANISOTROPYZ_H
