/******************************************************************************/
/* MaskCalcAnisotropZ.h                                                       */
/******************************************************************************/

#ifndef MASKCALCANISOTROPZ_H
#define MASKCALCANISOTROPZ_H

#ifdef _YAV_ // namespace for INRIA
#include "MaskTri.h"
#include "MaskCalculation.h"
namespace yav {
#else
#include "distancemap/MaskTri.h"
#include "distancemap/MaskCalculation.h"
#endif //_YAV_



class MaskCalcAnisotropZ : public MaskCalculation
{
public :
  // Constructors 
  MaskCalcAnisotropZ(int maskSize, MaskTri * aTriangulation, float dz);
  MaskCalcAnisotropZ(float dz); 

  // Destructor
  ~MaskCalcAnisotropZ();

protected :
  //  float delta(chamferTriangle tri);
  float normeInf(chamferTriElmt elmt);
  float norme1(chamferTriElmt elmt);

  //  bool localConvexityCond();

  //  void wheightsCalcRec(int k);
  
  void relativeErrorCalc(chamferTriangle tri, RelErrorElmt * errElmt);

  // Fields 
  float dz;
};

#ifdef _YAV_
} // namespace yav
#endif

#endif //MASKCALCANISOTROPZ_H
