/* Fichier MaskTri.cpp */
#include <stdio.h>
#ifdef _YAV_
#include "MaskTri.h"
using namespace yav;
#else
#include "distancemap/MaskTri.h"
#endif
#include <cstdlib>

MaskTri::MaskTri(int _order)
{
  this->order = _order;
  this->elmtIt = -1;
  this->triIt  = -1;
  this->nbPts  = 0;

}

MaskTri::~MaskTri()
{
}

int
MaskTri::getNbPts()
{
  return nbPts;
}

int 
MaskTri::getNbTri()
{
  return myTris.size();
}

int
MaskTri::isInSet(chamferTriElmt elmt)
{
  for (unsigned int i = 0; i < myElmts.size(); i++)
    if ((elmt.x == myElmts[i].x) &&
	(elmt.y == myElmts[i].y) &&
	(elmt.z == myElmts[i].z))
      return (int) i;
  return -1;
}

void
MaskTri::deleteTri(int index)
{
  unsigned int dim = myTris.size();

  for (unsigned int i = index + 1; i < dim; i++)
    {
      myTris[i-1].A = myTris[i].A;
      myTris[i-1].B = myTris[i].B;
      myTris[i-1].C = myTris[i].C;
      myTris[i-1].Abc = myTris[i].Abc;
      myTris[i-1].Bac = myTris[i].Bac;
      myTris[i-1].Cab = myTris[i].Cab;
    }

  myTris.erase(myTris.end() - 1);
}


unsigned char ***
MaskTri::editFinalMask()
{
  int i, j, k;
  maskSize = 2*order + 1;
  finalMask = (unsigned char ***) malloc((order + 1)*sizeof(unsigned char **));
  for (i = 0; i < (order + 1); i++)
    {
      finalMask[i] = (unsigned char **) malloc((order + 1)*sizeof(unsigned char *));
      for (j = 0; j < (order + 1); j++)
	finalMask[i][j] = (unsigned char *) malloc((order + 1)*sizeof(unsigned char));  
    }
  
  for (k = 0; k < (order + 1); k++) 
    for (j = 0; j < (order + 1); j++)
      for (i = 0; i < (order + 1); i++)
	finalMask[i][j][k] = 0;

  return finalMask;
}


