#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "inrimage/MultiView.h"

#include <modules/TclMatrix4D.h>
#include <inrimage/MultiView.h>
#include <inrimage/TclInrimageBackground.h>


namespace yav {

MultiView::MultiView(TclModule *m,
		     const std::list<TclSliceCamera *>& _views,
		     const TclString& window)
  : TclSon(m, window), TclObject(typeid(MultiView), m), DPOwner<TclSliceCamera>(_views),
    axis(false), zoom(1.0), ignoreVoxelSize(false),
    axisColor("red"), axisColor2("cyan"), dieWhenEmpty(true) {
}



MultiView::MultiView(TclModule *m, const TclString& window)
  : TclSon(m, window), TclObject(typeid(MultiView), m), DPOwner<TclSliceCamera>(),
    axis(false), zoom(1.0), ignoreVoxelSize(false),
    axisColor("red"), axisColor2("cyan"), dieWhenEmpty(true) {
}



MultiView::~MultiView() {
  DPList<TclSliceCamera>::const_iterator it;
  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it=DPOwner<TclSliceCamera>::getFirst()) {
    {
      TclSliceCamera *slicecam=(*it);
      remove(slicecam);
      delete slicecam;
    }
  }
  // il faut detacher tous les multiview qui etaient rattaches
  DPList<MultiView>::const_iterator itmv;
  for (itmv=DPOwner<MultiView>::getFirst(); itmv!=DPOwner<MultiView>::getLast(); ++itmv) {
    (*itmv)->DPOwner<MultiView>::remove(this);
    (*itmv)->matrixMultiViewMap.erase(this);
  }


}


void MultiView::dying(const TclSliceCamera *elt) {
   if(DPOwner<TclSliceCamera>::elements.size() == 0 && dieWhenEmpty) delete this;
}


void MultiView::append(TclSliceCamera *inrv)
  throw(DPList<TclSliceCamera>::NullPointer,
	DPList<TclSliceCamera>::AlreadyInList) {
  double slice = -1.0;

  if(DPOwner<TclSliceCamera>::elements.empty()) {
    zoom = inrv->getClient()->getScale();
    TclInrimageBackground *b=dynamic_cast<TclInrimageBackground *> (inrv->getClient()->getBackground());
    if (b)
      {
	ignoreVoxelSize = b->getIVS();
      }
  }
  else {
    inrv->getClient()->scaleCamera(zoom / inrv->getClient()->getScale());
    TclInrimageBackground *b=dynamic_cast<TclInrimageBackground *> (inrv->getClient()->getBackground());
    if (b)
      {
	b->setIVS(ignoreVoxelSize);
      }
    DPList<TclSliceCamera>::const_iterator it;
    for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast() && slice < 0.0; it++) {
      if((*it)->getClient()->getGeometry() == inrv->getClient()->getGeometry())
	slice = (*it)->getClient()->getSlice();
    }
    if(slice >= 0.0) inrv->getClient()->setSlice(slice);
  }

  getModule()->tickle("if [winfo exists %s] {bind %s <Motion> {%s%u -mousevoxel %s%u %%x %%y}}",
		      (char *) inrv->getCanvas(),(char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef());
  /*  getModule()->tickle("bind %s <ButtonPress-1> {+%s%u -buttonPressed %s%u %%x %%y;bind %s <Motion> {+%s%u -buttonMotion %s%u %%%%x %%%%y}}",
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef(),
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef());*/
  /*  getModule()->tickle("bind %s <Shift-ButtonPress-1> {+%s%u -shiftButtonPressed %s%u %%x %%y;bind %s <Motion> {+%s%u -shiftButtonMotion %s%u %%%%x %%%%y}}",
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef(),
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef());*/
  /*  getModule()->tickle("bind %s <ButtonRelease-1> {+%s%u -buttonReleased %s%u %%x %%y;bind %s <Motion> {+%s%u -mousevoxel %s%u %%%%x %%%%y;%s%u -buttonMotion %s%u %%%%x %%%%y }}",
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef(),
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef(),
		      getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef() );*/
  /*  getModule()->tickle("bind %s <Shift-ButtonRelease-1> {+%s%u -shiftButtonReleased %s%u %%x %%y;bind %s <Motion> {+%s%u -mousevoxel %s%u %%%%x %%%%y;%s%u -buttonMotion %s%u %%%%x %%%%y }}",
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef(),
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef(),
		      getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef() );*/
  getModule()->tickle("bind %s <ButtonPress-2> {%s%u -changeview %s%u %%x %%y; bind %s <Motion> {%s%u -changeview %s%u %%%%x %%%%y; %s%u -mousevoxel %s%u %%%%x %%%%y}}",
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef(),
		      (char *) inrv->getCanvas(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef(), getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef());
  getModule()->tickle("bind %s <ButtonRelease-2> {bind %s <Motion> {%s%u -mousevoxel %s%u %%%%x %%%%y}}",
		      (char *) inrv->getCanvas(), (char *) inrv->getCanvas(),
		      getObjectName(), getRef(),
		      inrv->getObjectName(), inrv->getRef());
  DPOwner<TclSliceCamera>::append(inrv);
}


void MultiView::remove(TclSliceCamera *inrv)
  throw(DPList<TclSliceCamera>::NotFound) {

  try {
    DPOwner<TclSliceCamera>::remove(inrv);
    getModule()->tickle("if [winfo exists %s] {bind %s <ButtonPress-2> {} }",
			(char *) inrv->getCanvas(),(char *) inrv->getCanvas());
    getModule()->tickle("if [winfo exists %s] {bind %s <ButtonRelease-2> {} }",
			(char *) inrv->getCanvas(),(char *) inrv->getCanvas());
    getModule()->tickle("if [winfo exists %s] {bind %s <Motion> {} }",
			(char *) inrv->getCanvas(),(char *) inrv->getCanvas());
    getModule()->tickle("if [winfo exists %s] {%s delete axis}",
			(char *) inrv->getCanvas(),(char *) inrv->getCanvas());
    inrv->bindMouseMotion(true);
  }
  catch(DPList<TclSliceCamera>::NotFound& e) {
    e.push("MultiView::operator-=(TclSliceCamera *)");
    throw e;    
  }
}


void MultiView::setAxis(bool _axis) {
  axis = _axis;
  if(!axis) {
    DPList<TclSliceCamera>::const_iterator it;
    for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
      getModule()->tickle("%s delete axis",
			  (char *) (*it)->getCanvas());
    }
  }
}


void MultiView::setScale(double val) {
  if(val > 0.0) {
    getModule()->tickle("set graphics2D::busy 1");
    zoom *= val;
    DPList<TclSliceCamera>::const_iterator it;
    double w;
    for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
      w=(*it)->getClient()->getWidth();
      (*it)->getClient()->resize((unsigned int)((*it)->getClient()->getWidth() * val),
				 (unsigned int)((*it)->getClient()->getHeight() * val));
      (*it)->getClient()->scaleCamera((*it)->getClient()->getWidth()/w);
    }
    getModule()->tickle("set graphics2D::busy 0");
  }
}


void MultiView::setIVS(bool val) {
  ignoreVoxelSize = val;
  DPList<TclSliceCamera>::const_iterator it;
  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++)
    {
      TclInrimageBackground *b=dynamic_cast<TclInrimageBackground *> ((*it)->getClient()->getBackground());
      if (b)
	{
	  b->setIVS(val);
	}
    }
}

void MultiView::activation(void) { }

void MultiView::on(void) {
  DPList<TclSliceCamera>::const_iterator it;
  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++)
    if ((*it)->getClient()->getScaleCamera())
      (*it)->getClient()->getScaleCamera()->on();
  Activable::on();
}

void MultiView::off(void) {
  DPList<TclSliceCamera>::const_iterator it;
  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++)
    if ((*it)->getClient()->getScaleCamera())
      (*it)->getClient()->getScaleCamera()->off();
  Activable::off();
}


int MultiView::destroyCmd(int argc, char **argv) {
  TclModule *m;
  unsigned int ref;

  if(argc != 0) return COMMAND_SYNOPSIS;
  m = getModule();
  ref = getRef();
  delete this;
  m->setResult("%s%u does not exist any longer",
	       TclObjectKind::getObjectName(typeid(MultiView)), ref);
  return TCL_OK;
}

int MultiView::addCmd(int argc, char **argv) {
  if(argc < 1) return COMMAND_SYNOPSIS;

  int i = 0;
  TclString res;
  while(i < argc) {
    TclSliceCamera *inrv;
    inrv = TclSliceCamera::getObject(argc, argv, i);
    if(!inrv) return TCL_ERROR;
    try {
      *this += inrv;
      res += TclString(argv[i]) + " ";
    }
    catch(DPList<TclSliceCamera>::AlreadyInList&) {
    }
    i++;
  }
  res += "added";
  setResult(res);
  return TCL_OK;
}


int MultiView::removeCmd(int argc, char **argv) {
  if(argc < 1) return COMMAND_SYNOPSIS;

  int i = 0;
  TclString res;
  while(i < argc) {
    TclSliceCamera *inrv;
    inrv = TclSliceCamera::getObject(argc, argv, i);
    if(!inrv) return TCL_ERROR;
    try {
      *this -= inrv;
    }
    catch(DPList<TclSliceCamera>::NotFound e) {
      setResult("%s%u not handled by %s%u", inrv->getObjectName(), inrv->getRef(),
		getObjectName(), getRef());
      return TCL_ERROR;
    }
    res += TclString(argv[i]) + SPACE_STRING;
    i++;
  }
  res += "supressed";
  setResult(res);
  return TCL_OK;
}


int MultiView::viewsCmd(int argc, char **argv) {
  TclString res, one;
  DPList<TclSliceCamera>::const_iterator it;

  if(argc > 1) return COMMAND_SYNOPSIS;
  if(argc == 0) {
    for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
      one.sprintf("%s%u ", (*it)->getObjectName(), (*it)->getRef());
      res += one;
    }
  }

  else {
    // -views X
    if(!strcmp(argv[0], "X")) {
      for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
	if((*it)->getClient()->getGeometry() == SliceCamera::SLICE_X) {
	  one.sprintf("%s%u ", (*it)->getObjectName(), (*it)->getRef());
	  res += one;
	}
      }
    }
    // -views Y
    else if(!strcmp(argv[0], "Y")) {
      for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
	if((*it)->getClient()->getGeometry() == SliceCamera::SLICE_Y) {
	  one.sprintf("%s%u ", (*it)->getObjectName(), (*it)->getRef());
	  res += one;
	}
      }
    }
    // -views Z
    else if(!strcmp(argv[0], "Z")) {
      for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
	if((*it)->getClient()->getGeometry() == SliceCamera::SLICE_Z) {
	  one.sprintf("%s%u ", (*it)->getObjectName(), (*it)->getRef());
	  res += one;
	}
      }
    }
    // -views alpha
    else if(!strcmp(argv[0], "alpha")) {
      for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
	if((*it)->getClient()->getGeometry() == SliceCamera::SLICE_ALPHA) {
	  one.sprintf("%s%u ", (*it)->getObjectName(), (*it)->getRef());
	  res += one;
	}
      }
    }
    else return COMMAND_SYNOPSIS;
  }

  setResult(res);
  return TCL_OK;
}

int MultiView::mousevoxelCmd(int argc, char **argv) {
  if(argc != 3) return COMMAND_SYNOPSIS;

  TclSliceCamera *inrv = TclSliceCamera::getObject(argc, argv,0);
  if (!inrv)
    return TCL_ERROR;
  
  DPList<TclSliceCamera>::const_iterator it;
 
  int mx, my;
  if(sscanf(argv[1], "%i", &mx) != 1) return COMMAND_SYNOPSIS;
  if(sscanf(argv[2], "%i", &my) != 1) return COMMAND_SYNOPSIS;
  
  SliceCamera::SLICE_ORIENTATION geom = inrv->getClient()->getGeometry();
  TclInrimageBackground *bg=(TclInrimageBackground *)inrv->getClient()->getBackground();
  VoxelCoordinate *vc = new VoxelCoordinate();
  VoxelCoordinate *vc_init = new VoxelCoordinate();
  CartesianCoordinate *cc=new CartesianCoordinate();

  if (bg){
    bg->getImageCoordinates(mx, my, vc->x, vc->y, vc->z);  
    bg->getImageCoordinates(mx, my, vc_init->x, vc_init->y, vc_init->z);  
    bg->getWorldCoordinates(mx, my, cc->x, cc->y,cc->z);
  }

  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
    if((axis)&& (vc)) (*it)->drawAxis(geom,mx,my,vc->x,vc->y,vc->z, axisColor, axisColor2);
    if((vc)&&((*it)->getClient()->getGeometry() == geom)) {
      (*it)->displayValue(((TclInrimageBackground *)(*it)->getClient()->getBackground())->getLabel(mx,my));
    }
  }
  
  DPList<MultiView>::const_iterator itmv = DPOwner<MultiView>::getFirst();
  CartesianCoordinate *newcc = new CartesianCoordinate();
  Matrix4x4<double> *mat = (Matrix4x4<double> *)NULL;

  for(; itmv != DPOwner<MultiView>::getLast(); ++itmv) {
    mat = matrixMultiViewMap[*itmv];
    newcc->x = cc->x*(*mat)[0][0]+cc->y*(*mat)[0][1]+cc->z*(*mat)[0][2]+(*mat)[0][3];
    newcc->y = cc->x*(*mat)[1][0]+cc->y*(*mat)[1][1]+cc->z*(*mat)[1][2]+(*mat)[1][3];
    newcc->z = cc->x*(*mat)[2][0]+cc->y*(*mat)[2][1]+cc->z*(*mat)[2][2]+(*mat)[2][3];
    
    it = (*itmv)->DPOwner<TclSliceCamera>::getFirst();
    for(; it != (*itmv)->DPOwner<TclSliceCamera>::getLast(); ++it){
      bg=(TclInrimageBackground *)(*it)->getClient()->getBackground();
      // on calcule les mx et les my correspondant a la position reelle
      bg->getPixelPositionFromWorldCoordinates(newcc->x, newcc->y, newcc->z, mx,my);
      // on calcule les coordonnees voxels correspondant a la position reelle
      // il ne faut pas utiliser la fonction getPixelPositionFromImageCoordinates !!!!!
      vc->x = (unsigned int) (newcc->x / bg->getInrimage()->getVX());
      vc->y = (unsigned int) (newcc->y / bg->getInrimage()->getVY());
      vc->z = (unsigned int) (newcc->z / bg->getInrimage()->getVZ());

      if(((*itmv)->getAxis())&& (vc)) (*it)->drawAxis(geom,mx,my,vc->x,vc->y,vc->z, (*itmv)->getAxisColor1(), (*itmv)->getAxisColor2());
      if((vc)&&((*it)->getClient()->getGeometry() == geom)) (*it)->displayValue(((TclInrimageBackground *)(*it)->getClient()->getBackground())->getLabel(mx,my));
    }
  }
  
  if (vc)
    {
      setResult("%u %u %u", vc->x, vc->y, vc->z);
      delete vc;
    }
  return TCL_OK;

}


int MultiView::sceneCmd(int argc, char **argv) {
  if (argc!=0)  return COMMAND_SYNOPSIS;
  DPList<TclSliceCamera>::const_iterator it=DPOwner<TclSliceCamera>::getFirst();
  if (it != DPOwner<TclSliceCamera>::getLast())
    {
      setResult("%s",(char *)(*it)->getScene()->name());
      return TCL_OK;
    }
  else
    {
      setResult("none");
      return TCL_OK;
    }
}
int MultiView::changeViewCmd(int argc, char **argv) {

  if(argc != 3) return COMMAND_SYNOPSIS;
  TclSliceCamera *inrv = (TclSliceCamera *)NULL;
  
  inrv = TclSliceCamera::getObject(argc,argv,0);
  if (!inrv)
    return TCL_ERROR;
  
  int mx, my;
  if(sscanf(argv[1], "%i", &mx) != 1) return COMMAND_SYNOPSIS;
  if(sscanf(argv[2], "%i", &my) != 1) return COMMAND_SYNOPSIS;

  SliceCamera::SLICE_ORIENTATION geom = inrv->getClient()->getGeometry();
  TclInrimageBackground *bg=(TclInrimageBackground *)inrv->getClient()->getBackground();
  VoxelCoordinate *vc = new VoxelCoordinate();
  VoxelCoordinate *vc_init = new VoxelCoordinate();
  CartesianCoordinate *cc = new CartesianCoordinate();

  if (bg) {
    bg->getImageCoordinates(mx, my, vc->x, vc->y, vc->z);  
    bg->getImageCoordinates(mx, my, vc_init->x, vc_init->y, vc_init->z);  
    bg->getWorldCoordinates(mx, my, cc->x, cc->y, cc->z);
  } else CERR << " Invalid TclInrimageBackground in MultioView::changeViewCmd " << ENDL;

  DPList<TclSliceCamera>::const_iterator it; 
  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); ++it) {
    if (vc) (*it)->changeView(vc->x,vc->y,vc->z);
    if((axis)&& (vc)) (*it)->drawAxis(geom,mx,my,vc->x,vc->y,vc->z, axisColor, axisColor2);
  }
  
  DPList<MultiView>::const_iterator itmv;
  CartesianCoordinate *newcc = new CartesianCoordinate();
  Matrix4x4<double> *mat = (Matrix4x4<double> *)NULL;

  for (itmv=DPOwner<MultiView>::getFirst(); itmv!=DPOwner<MultiView>::getLast(); ++itmv) {
    mat = matrixMultiViewMap[*itmv];
    newcc->x = cc->x*(*mat)[0][0]+cc->y*(*mat)[0][1]+cc->z*(*mat)[0][2]+(*mat)[0][3];
    newcc->y = cc->x*(*mat)[1][0]+cc->y*(*mat)[1][1]+cc->z*(*mat)[1][2]+(*mat)[1][3];
    newcc->z = cc->x*(*mat)[2][0]+cc->y*(*mat)[2][1]+cc->z*(*mat)[2][2]+(*mat)[2][3];
    
    it = (*itmv)->DPOwner<TclSliceCamera>::getFirst();
    for (; it != (*itmv)->DPOwner<TclSliceCamera>::getLast(); ++it) {
      bg=(TclInrimageBackground *)(*it)->getClient()->getBackground();
      // on calcule les mx et les my correspondant a la position reelle
      bg->getPixelPositionFromWorldCoordinates(newcc->x, newcc->y, newcc->z, mx,my);
      // on calcule les coordonnees voxels correspondant a la position reelle
      // il ne faut pas utiliser la fonction getPixelPositionFromImageCoordinates !!!!!
      vc->x = (unsigned int) (newcc->x / bg->getInrimage()->getVX());
      vc->y = (unsigned int) (newcc->y / bg->getInrimage()->getVY());
      vc->z = (unsigned int) (newcc->z / bg->getInrimage()->getVZ());

      if (vc) (*it)->changeView(vc->x,vc->y,vc->z);
      if(((*itmv)->getAxis())&& (vc)) (*it)->drawAxis(geom,mx,my,vc->x,vc->y,vc->z, (*itmv)->getAxisColor1(), (*itmv)->getAxisColor2());
    }
  }

  delete vc;
  delete cc;
  
  setResult("%u %u %u", vc_init->x, vc_init->y, vc_init->z);
  delete vc_init;
  
  return TCL_OK;
}


int MultiView::axisCmd(int argc, char **argv) {
  bool bval;

  if(argc > 1) return COMMAND_SYNOPSIS;
  if(argc == 1) {
    if(TclModule::boolValue(argv[0], bval)) {
      setAxis(bval);
    }
    else return COMMAND_SYNOPSIS;
  }
  setResult(TclModule::boolString(getAxis()));
  return TCL_OK;
}


int MultiView::axisColorCmd(int argc, char **argv) {
  if(argc != 0 && argc != 2) return COMMAND_SYNOPSIS;
  if(argc == 2) {
    setAxisColors(argv[0], argv[1]);
  }
  setResult("%s %s", (char *) getAxisColor1(), (char *) getAxisColor2());
  return TCL_OK;
}


int MultiView::activateCmd(int argc, char **argv) {
  bool bval;

  if(argc > 1) return COMMAND_SYNOPSIS;
  if(argc == 1) {
    if(!TclModule::boolValue(argv[0], bval)) return COMMAND_SYNOPSIS;
    if(bval) on();
    else off();
  }
  setResult(TclModule::boolString(active()));
  return TCL_OK;
}


int MultiView::ignoreVoxelSizeCmd(int argc, char **argv) {
  bool bval;

  if(argc > 1) return COMMAND_SYNOPSIS;
  if(argc == 1) {
    if(!TclModule::boolValue(argv[0], bval)) return COMMAND_SYNOPSIS;
    setIVS(bval);
  }
  setResult(TclModule::boolString(getIVS()));
  return TCL_OK;
}


int MultiView::scaleCmd(int argc, char **argv) {
  double val;

  if(argc > 2) return COMMAND_SYNOPSIS;
  if(argc > 0) {
    if(argv[0][0] == '*' || argv[0][0] == '/') {
      if(strlen(argv[0]) > 1) {
	if(sscanf(argv[0] + 1, "%lf", &val) != 1) return COMMAND_SYNOPSIS;
	if(argv[0][0] == '/') val = 1.0 / val;
	setScale(val);
      }
      else {
	if(argc > 1) {
	  if(sscanf(argv[1], "%lf", &val) != 1) return COMMAND_SYNOPSIS;
	  if(argv[0][0] == '/') val = 1.0 / val;
	  setScale(val);
	}
	else return COMMAND_SYNOPSIS;
      }
    }
    else {
      if(sscanf(argv[0], "%lf", &val) != 1) return COMMAND_SYNOPSIS;
      setScale(val / getScale());
    }
  }
  setResult("%f", getScale());
  return TCL_OK;
}


int MultiView::redrawCmd(int argc, char **argv) {
  if(argc > 0) return COMMAND_SYNOPSIS;

  DPList<TclSliceCamera>::const_iterator it;
  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
    tickle("%s%u -redraw", (*it)->getObjectName(), (*it)->getRef());
  }
  return TCL_OK;
}


int MultiView::minCmd(int argc, char **argv) {
  if(argc != 1) return COMMAND_SYNOPSIS;

  DPList<TclSliceCamera>::const_iterator it;
  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
    tickle("%s%u -min %s", (*it)->getObjectName(),
	   argv[0]);
  }
  return TCL_OK;
}

int MultiView::maxCmd(int argc, char **argv) {
  if(argc != 1) return COMMAND_SYNOPSIS;

  DPList<TclSliceCamera>::const_iterator it;
  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
    tickle("%s%u -max %s", (*it)->getObjectName(), (*it)->getRef(),
	   argv[0]);
  }
  return TCL_OK;
}

int MultiView::inrimageCmd(int argc, char **argv) {
  if(argc != 1) return COMMAND_SYNOPSIS;

  DPList<TclSliceCamera>::const_iterator it;
  for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++) {
    tickle("%s%u -inrimage %s", (*it)->getObjectName(), (*it)->getRef(),
	   argv[0]);
  }
  return TCL_OK;
}

int MultiView::parentWidgetCmd(int argc, char **argv) {
  if(argc != 1) return COMMAND_SYNOPSIS;

  setTCLwindow(argv[0]);
  return TCL_OK;
}

int MultiView::visibleCmd(int argc, char **argv) {
  if(argc != 1 && argc != 6) return COMMAND_SYNOPSIS;

  DPList<TclSliceCamera>::const_iterator it;
  if(argc == 1) {
    if(strcmp(argv[0], "all")) return COMMAND_SYNOPSIS;
    for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++)
      (*it)->getClient()->getBackground()->setVisibleArea();
  }    
  else {
    unsigned int v[6];
    if(sscanf(argv[0], "%u", &v[0]) != 1) return COMMAND_SYNOPSIS;
    if(sscanf(argv[1], "%u", &v[1]) != 1) return COMMAND_SYNOPSIS;
    if(sscanf(argv[2], "%u", &v[2]) != 1) return COMMAND_SYNOPSIS;
    if(sscanf(argv[3], "%u", &v[3]) != 1) return COMMAND_SYNOPSIS;
    if(sscanf(argv[4], "%u", &v[4]) != 1) return COMMAND_SYNOPSIS;
    if(sscanf(argv[5], "%u", &v[5]) != 1) return COMMAND_SYNOPSIS;
    for(it = DPOwner<TclSliceCamera>::getFirst(); it != DPOwner<TclSliceCamera>::getLast(); it++)
      (*it)->getClient()->getBackground()->setVisibleArea(v[0], v[1],
							  v[2], v[3],
							  v[4], v[5]);
  }
  return TCL_OK;
}


int MultiView::dieCmd(int argc, char **argv) {
  if(argc>1) return COMMAND_SYNOPSIS;
  if(argc==1){
    if(!TclModule::boolValue(argv[0],dieWhenEmpty)) return  COMMAND_SYNOPSIS;
  }
  setResult(TclModule::boolString(dieWhenEmpty));
  return TCL_OK;
}


/* "Create a new multiviewer object. -in %w: the given TCL window is associated to the multi-viewer and will be destroyed at the same time. -add slicecam%u+: add all given viewers to the multiviewer" */
int MultiView::create(TclModule *m, int argc, char **argv) {
  MultiView *mv;
  std::list<TclSliceCamera *> inrvl;
  char *name = 0;
  int i;

  for(i = 1; i < argc; i++) {
    // -in %w
    if(!strcmp(argv[i], "-in")) {
      if(++i >= argc) return COMMAND_SYNOPSIS;
      if(!m->windowExists(argv[i])) return COMMAND_SYNOPSIS;
      name = argv[i];
    }

    // -add slicecam%u...
    else if(!strcmp(argv[i], "-add")) {
      if(++i >= argc) return COMMAND_SYNOPSIS;
      TclSliceCamera *inrv;
      while(i < argc && argv[i][0] != '-') {
	inrv = TclSliceCamera::getObject(argc, argv, i);
	if(!inrv) return TCL_ERROR;
	inrvl.push_back(inrv);
	i++;
      }
    }

    else return COMMAND_SYNOPSIS;
  }

  mv = new MultiView(m, inrvl, name);
  m->setResult("%s%u", (char *) mv->getObjectName(), mv->getRef());
  return TCL_OK;
}


int MultiView::removemviewCmd(int argc, char **argv) {

  if (argc<1) return COMMAND_SYNOPSIS;
  int i=0;
  TclString res;
  TclString tmp;
  MultiView *mv = (MultiView *)NULL;

  while (i<argc) {
    mv = MultiView::getObject(argc, argv, i);
    if (!mv)
      return TCL_ERROR;
    else {
      try {
	DPOwner<MultiView>::remove(mv);
      }
      catch (DPList<MultiView>::NotFound &) {
	CERR << mv->getObjectName() << mv->getRef() << " not present in " << getObjectName() << getRef()<<ENDL;
	return TCL_ERROR;
      }
      matrixMultiViewMap.erase(mv);
      
      // pareil pour l'autre multiview
      try {
	mv->DPOwner<MultiView>::remove(this);
      }
      catch (DPList<MultiView>::NotFound &) {
	CERR << getObjectName() << getRef() << " not present in " << mv->getObjectName() << mv->getRef()<<ENDL;
	return TCL_ERROR;
      }
      mv->matrixMultiViewMap.erase(this);
      
      tmp.sprintf("%s%u ", getObjectName(), getRef());
      res += tmp;
    }
    ++i;
  }
  res += "supressed";
  setResult(res);
  return TCL_OK;
}


int MultiView::addmviewCmd(int argc, char **argv) {

  if (argc<1) return COMMAND_SYNOPSIS;

  int i = 0;
  TclString res;
  TclMatrix4D *transfo=(TclMatrix4D *)NULL;
  TclMatrix4D *inv_transfo=(TclMatrix4D *)NULL;

  MultiView *mview = (MultiView *)NULL;

  while(i < argc) {
    mview = MultiView::getObject(argc, argv, i);
    if(!mview) return TCL_ERROR;
    if( i+2<argc){
      if(!strcmp(argv[i+1], "-transfo")) {
	i+=2;
	transfo=TclMatrix4D::getObject(argc,argv,i);
	if (!transfo) return TCL_ERROR;
	inv_transfo = new TclMatrix4D(getModule(), *transfo);
	inv_transfo->inv(*inv_transfo);
      } 
    }
    else {
      transfo = new TclMatrix4D(typeid(TclMatrix4D), getModule());
      inv_transfo = new TclMatrix4D(typeid(TclMatrix4D), getModule());
    }
    
    ++i;
    try {
      DPOwner<MultiView>::append(mview);
      matrixMultiViewMap[mview]=transfo;
      
    }
    catch (Exception &e) {
      CERR << " Can not add " << mview->getObjectName()<<mview->getRef()<< " to " << getObjectName()<<getRef()<<ENDL;
      CERR << e << ENDL;
      return TCL_ERROR;
    }
    
    // on fait pareil pour l'autre  multiview
    try {
      mview->DPOwner<MultiView>::append(this);
      mview->matrixMultiViewMap[this]=inv_transfo;
    }
    catch (Exception &e) {
      CERR << " Cannot add " << getObjectName()<<getRef()<< " to " << mview->getObjectName()<<mview->getRef()<<ENDL;
      CERR << e << ENDL;
      return TCL_ERROR;
    }
  }
  return TCL_OK;
}

  int MultiView::listmviewCmd(int argc, char **argv) {
    if (argc>0) return COMMAND_SYNOPSIS;
    TclString res,one;
    DPList<MultiView>::const_iterator it = DPOwner<MultiView>::getFirst();

    for(; it != DPOwner<MultiView>::getLast(); ++it){
      one.sprintf("%s%u associated with transfo %s%u ", (*it)->getObjectName(), (*it)->getRef(), ((TclMatrix4D *)(matrixMultiViewMap[*it]))->getTCLObjectName(), ((TclMatrix4D *)(matrixMultiViewMap[*it]))->getRef());
      res += one;
    }
    setResult(res);
    return TCL_OK;
  }


  int MultiView::removeAllmviewCmd(int argc, char **argv) {
    
    if (argc>0) return COMMAND_SYNOPSIS;

    DPList<MultiView>::const_iterator itmv;
    

    for (itmv=DPOwner<MultiView>::getFirst(); itmv!=DPOwner<MultiView>::getLast(); itmv=DPOwner<MultiView>::getFirst()) {

      try {
	DPOwner<MultiView>::remove(*itmv);
      }
      catch (DPList<MultiView>::NotFound &) {
	CERR << (*itmv)->getObjectName() << (*itmv)->getRef() << " not present in " << getObjectName() << getRef()<<ENDL;
	return TCL_ERROR;
      }
      matrixMultiViewMap.erase(*itmv);
      try {
	(*itmv)->DPOwner<MultiView>::remove(this);
      }
      catch (DPList<MultiView>::NotFound &) {
	CERR << getObjectName() << getRef() << " not present in " << (*itmv)->getObjectName() << (*itmv)->getRef()<<ENDL;
	return TCL_ERROR;
      }
     (*itmv)->matrixMultiViewMap.erase(this);
     
    }
    setResult("no attached multiview to %s%u", getObjectName(), getRef());
    return TCL_OK;
  }

} // namespace yav


