#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif


#pragma implementation "inrimage/TclBoundingBox3D.h"
#include <inrimage/TclBoundingBox3D.h>
#include <graphics2D/TclScene2D.h>

namespace yav {


TclBoundingBox3D::TclBoundingBox3D(TclModule *m,
			 Scene2D *scene, const Vec3<double> _c[2],
			 const float _color[3], const TclString& _menu)
  :  TclScene2DObject(typeid(TclBoundingBox3D), new BoundingBox3D(scene,_c,_color),m)
 {
	 done(typeid(TclBoundingBox3D),(char *)_menu,"inrimage::uninstallCropMenu");
}


BoundingBox3D::BoundingBox3D(
			 Scene2D *scene, const Vec3<double> _c[2],
			 const float _color[3])
  :  Data2D(scene) {
  corner[0]=_c[0];
  corner[1]=_c[1];

  color[0]=_color[0];
  color[1]=_color[1];
  color[2]=_color[2];

  selectedCorner=false;
}

TclBoundingBox3D::~TclBoundingBox3D() {
  deleted(typeid(TclBoundingBox3D));
}

BoundingBox3D::~BoundingBox3D() {
}


void BoundingBox3D::redraw(Camera2D *cam) {
	Camera2DBackground *b=cam->getBackground();

	if (b) {
		Vec3<double> org,normal;
		Vec2<double> c[4];
		Vec3<double> slicePosition[4];
		unsigned int i;

		b->getImagePlane(org,normal);
		TclString sname= b->getSliceName();
		if ((sname=="sliceX")&& ((org.getX()-corner[0].getX())*(org.getX()-corner[1].getX())<=0.0)) {
			slicePosition[0]=Vec3<double>(org.getX(),corner[0].getY(),corner[0].getZ());
			slicePosition[1]=Vec3<double>(org.getX(),corner[1].getY(),corner[1].getZ());
			slicePosition[2]=Vec3<double>(org.getX(),corner[1].getY(),corner[0].getZ());
			slicePosition[3]=Vec3<double>(org.getX(),corner[0].getY(),corner[1].getZ());

			for (i=0;i<4;++i) 
				b->map3DWorldTo2DWorldCoordinates(slicePosition[i],c[i]);

			/// draw the rectangle
			glColor3f(color[0],color[1],color[2]);
			glBegin(GL_LINE_LOOP);
			glVertex2dv((const double *)c[0]);
			glVertex2dv((const double *)c[2]);
			glVertex2dv((const double *)c[1]);
			glVertex2dv((const double *)c[3]);
			glEnd();
		}
		else if ((sname=="sliceZ")&& ((org.getZ()-corner[0].getZ())*(org.getZ()-corner[1].getZ())<=0.0))
		{
			slicePosition[0]=Vec3<double>(corner[0].getX(),corner[0].getY(),org.getZ());
			slicePosition[1]=Vec3<double>(corner[1].getX(),corner[1].getY(),org.getZ());
			slicePosition[2]=Vec3<double>(corner[0].getX(),corner[1].getY(),org.getZ());
			slicePosition[3]=Vec3<double>(corner[1].getX(),corner[0].getY(),org.getZ());

			for (i=0;i<4;++i) 
				b->map3DWorldTo2DWorldCoordinates(slicePosition[i],c[i]);

			/// draw the rectangle
			glColor3f(color[0],color[1],color[2]);
			glBegin(GL_LINE_LOOP);
			glVertex2dv((const double *)c[0]);
			glVertex2dv((const double *)c[2]);
			glVertex2dv((const double *)c[1]);
			glVertex2dv((const double *)c[3]);
			glEnd();
		}
		else if ((sname=="sliceY")&& ((org.getY()-corner[0].getY())*(org.getY()-corner[1].getY())<=0.0))
		{
			slicePosition[0]=Vec3<double>(corner[0].getX(),org.getY(),corner[0].getZ());
			slicePosition[1]=Vec3<double>(corner[1].getX(),org.getY(),corner[1].getZ());
			slicePosition[2]=Vec3<double>(corner[0].getX(),org.getY(),corner[1].getZ());
			slicePosition[3]=Vec3<double>(corner[1].getX(),org.getY(),corner[0].getZ());

			for (i=0;i<4;++i) 
				b->map3DWorldTo2DWorldCoordinates(slicePosition[i],c[i]);

			/// draw the rectangle
			glColor3f(color[0],color[1],color[2]);
			glBegin(GL_LINE_LOOP);
			glVertex2dv((const double *)c[0]);
			glVertex2dv((const double *)c[2]);
			glVertex2dv((const double *)c[1]);
			glVertex2dv((const double *)c[3]);
			glEnd();
		}
	}
}






void BoundingBox3D::mouseButtonPressed(CameraTypes::WHICH_BUTTON button,
					  CameraTypes::KEY_MODIFIER modifier,
					  Camera2D *cam,int mx,int my) 
{
	if (cam->getBackground())
	{
		selectedCorner=false;
		Vec2<double> pixel((double)mx,(double)my);
		Vec2<double> pos2D;
		Vec3<double> pos3D;
		cam->mapScreenTo2DWorldCoordinates(pixel,pos2D);
		cam->getBackground()->map2DWorldTo3DWorldCoordinates(pos2D,pos3D);
		TclString bname=cam->getBackground()->getSliceName();
		if (bname=="sliceZ") {
			if (fabs(pos3D.getX()-corner[0].getX())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
				if (fabs(pos3D.getY()-corner[0].getY())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=0;
					modificationIndex[1]=0;
				} else if (fabs(pos3D.getY()-corner[1].getY())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=0;
					modificationIndex[1]=1;
				}
			} else if (fabs(pos3D.getX()-corner[1].getX())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
				if (fabs(pos3D.getY()-corner[0].getY())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=1;
					modificationIndex[1]=0;
				} else if (fabs(pos3D.getY()-corner[1].getY())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=1;
					modificationIndex[1]=1;
				}
			}

		}

		else if (bname=="sliceX") {
			if (fabs(pos3D.getY()-corner[0].getY())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
				if (fabs(pos3D.getZ()-corner[0].getZ())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=0;
					modificationIndex[1]=0;
				} else if (fabs(pos3D.getZ()-corner[1].getZ())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=0;
					modificationIndex[1]=1;
				}
			} else if (fabs(pos3D.getY()-corner[1].getY())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
				if (fabs(pos3D.getZ()-corner[0].getZ())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=1;
					modificationIndex[1]=0;
				} else if (fabs(pos3D.getZ()-corner[1].getZ())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=1;
					modificationIndex[1]=1;
				}
			}
		}

		else if (bname=="sliceY") {
			if (fabs(pos3D.getX()-corner[0].getX())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
				if (fabs(pos3D.getZ()-corner[0].getZ())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=0;
					modificationIndex[1]=0;
				} else if (fabs(pos3D.getZ()-corner[1].getZ())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=0;
					modificationIndex[1]=1;
				}
			} else if (fabs(pos3D.getX()-corner[1].getX())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
				if (fabs(pos3D.getZ()-corner[0].getZ())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=1;
					modificationIndex[1]=0;
				} else if (fabs(pos3D.getZ()-corner[1].getZ())<BOUNDINGBOX3D_SELECTION_DISTANCE) {
					selectedCorner=true;
					modificationIndex[0]=1;
					modificationIndex[1]=1;
				}
			}
		}

	}

}
void BoundingBox3D::mouseButtonMoved(Camera2D *cam, 
									 int  mx, int my) 
{
	if ((selectedCorner) && (cam->getBackground()))
	{
		Vec2<double> pixel((double)mx,(double)my);
		Vec2<double> pos2D;
		Vec3<double> pos3D;
		cam->mapScreenTo2DWorldCoordinates(pixel,pos2D);
		cam->getBackground()->map2DWorldTo3DWorldCoordinates(pos2D,pos3D);
		TclString bname=cam->getBackground()->getSliceName();
		if (bname=="sliceZ") {
			corner[modificationIndex[0]][0]=pos3D.getX();
			corner[modificationIndex[1]][1]=pos3D.getY();
			redrawScene();
		}
		else if (bname=="sliceX") {
			corner[modificationIndex[0]][1]=pos3D.getY();
			corner[modificationIndex[1]][2]=pos3D.getZ();
			redrawScene();
		}
		else if (bname=="sliceY") {
			corner[modificationIndex[0]][0]=pos3D.getX();
			corner[modificationIndex[1]][2]=pos3D.getZ();
			redrawScene();
		}

	}
}
void BoundingBox3D::mouseButtonReleased(CameraTypes::WHICH_BUTTON button,
					   CameraTypes::KEY_MODIFIER modifier,
					   Camera2D *cam,int mx,int my) {
	selectedCorner=false;
}
int TclBoundingBox3D::destroyCmd(int argc, char **argv) {
  TclModule *m;
  unsigned int ref;

  if(argc != 0) return COMMAND_SYNOPSIS;
  m = getModule();
  ref = TclObject::getRef();
  TclString oname=TclBoundingBox3D::getObjectName();
  delete this;
  m->setResult("%s%u", (char *) oname, ref);
  return TCL_OK;
}
int TclBoundingBox3D::boxSizeCmd(int argc, char **argv) {

  if(argc != 1) return COMMAND_SYNOPSIS;
  if (!strcmp(argv[0],"-org"))
    {
      setResult("%f %f %f",getClient()->corner[0].getX(),getClient()->corner[0].getY(),getClient()->corner[0].getZ());
      return TCL_OK;
    }
  else if (!strcmp(argv[0],"-end"))
    {
      setResult("%f %f %f",getClient()->corner[1].getX(),getClient()->corner[1].getY(),getClient()->corner[1].getZ());
      return TCL_OK;
    }
  else return COMMAND_SYNOPSIS;
}

int TclBoundingBox3D::create(TclModule *m, int argc, char **argv) {
  int i;

  if (argc<8)
    return COMMAND_SYNOPSIS;

  TclCamera2D *cam=(TclCamera2D *)
    TclObjectKind::getObject(typeid(TclCamera2D), argc, argv, 1);
  if (!cam)
    {
      m->setResult("%s is not a 2D camera",argv[1]);
      return TCL_ERROR;
    }
	double x1,y1,z1,x2,y2,z2;
	Vec3<double> c[2];


	x1=(double) atof(argv[2]);
	y1=(double) atof(argv[3]);
	z1=(double) atof(argv[4]);
	x2=(double) atof(argv[5]);
	y2=(double) atof(argv[6]);
	z2=(double) atof(argv[7]);
	c[0]=Vec3<double>(x1,y1,z1);
	c[1]=Vec3<double>(x2,y2,z2);

	float color[3];
	color[0]=0;
	color[1]=1.0;
	color[2]=0;



  TclString menu="graphics2D::viewerVisibleMenu";
  

  for(i=8; i < argc; i++) {
  
    if(!strcmp(argv[i], "-color")) {
      if( (i+3) >= argc) return COMMAND_SYNOPSIS;
      color[0]=(float)atof(argv[++i]);
      color[1]=(float)atof(argv[++i]);
      color[2]=(float)atof(argv[++i]);
    }
    else if(!strcmp(argv[i], "-menu")) {
      if( ++i >= argc) return COMMAND_SYNOPSIS;
      menu=argv[i];
    }
    else return COMMAND_SYNOPSIS;
  }

  TclBoundingBox3D *bbox = new TclBoundingBox3D(m,cam->getScene()->getClient(),c,color,menu);
  m->setResult("%s%u", bbox->getObjectName(), bbox->TclObject::getRef());
  return TCL_OK;
}

void TclBoundingBox3D::createCommands(TclModule *m) {
   TclObjectKind *kind;

  kind = new Scene2DItem(m, typeid(TclBoundingBox3D), "bbox3D","3D Bounding Box in 2D Camera",
			 &TclBoundingBox3D::create, &TclBoundingBox3D::list,
			 TclScene2D::OTHER,
			 "bbox%u cam2D%u %f %f %f %f %f %f [ -color %f %f %f] [ -menu %s]");
  m->newCommand("bbox3D%u", kind->getOptions(),
		"Camera Bounding Box  management command");
  kind->newOption("-destroy", (TclObject::OPTION) &TclBoundingBox3D::destroyCmd, 0,
		  "Destroy camera bounding box");
  kind->newOption("-boxSize", (TclObject::OPTION) &TclBoundingBox3D::boxSizeCmd, "-org|-end",
		  "Returns the corners of the bounding box in 3D world coordinates");
  TclScene2DObject::createOptionCommands(kind);
}
} // namespace yav


