#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "inrimage/TclDisplacementField3D.h"

#include <inrimage/TclInrimage.h>
#include <inrimage/TclDisplacementField3D.h>

namespace yav {

int TclDisplacementField3D::create(TclModule *m, int argc, char *argv[]) {
  

  if (argc<2) return COMMAND_SYNOPSIS;
  
  TclDisplacementField3D *d = new TclDisplacementField3D (m, argv[1]);
  
  m->setResult("%s%u", TclDisplacementField3D::getTCLObjectName(), d->getRef());
  return TCL_OK;

}


  TclDisplacementField3D::TclDisplacementField3D(TclModule *m, DisplacementField3D::FIELD_MODE mode, Inrimage *imx, Inrimage *imy, Inrimage *imz, float vx, float vy, float vz) throw (DisplacementField3D::DisplacementField3DMismatchType, DisplacementField3D::DisplacementField3DMismatchSize, DisplacementField3D::DisplacementField3DMismatchVoxelSize) : TclSceneObject(typeid(TclDisplacementField3D), new DisplacementField3D(mode,imx, imy, imz), m) {

  init(m);
  done(typeid(TclDisplacementField3D));

  }


TclDisplacementField3D::~TclDisplacementField3D(){

  deleted(typeid(TclDisplacementField3D));

}


TclDisplacementField3D::TclDisplacementField3D(TclModule *m, const char *name)
		       throw(GeneralFormat::FileNotFound, Inrimage::ImageNotFound, DisplacementField3D::InvalidDisplacementField3DImagesNb, DisplacementField3D::DisplacementField3DMismatchType, DisplacementField3D::DisplacementField3DMismatchSize ) 
		       : TclSceneObject(typeid(TclDisplacementField3D), new DisplacementField3D(name), m) {



  init(m);
  done(typeid(TclDisplacementField3D));
}

		       

void TclDisplacementField3D::init(TclModule *m) {
  
  Inrimage *image;
  TclInrimage *tinr;

  image = (*(getClient()->inrx))();
  tinr= TclInrimage::getInterface(image);
  if (tinr==0)
    new TclInrimage(m, typeid(TclInrimage), image);

  image = (*(getClient()->inry))();
  tinr= TclInrimage::getInterface(image);
  if (tinr==0)
    new TclInrimage(m, typeid(TclInrimage), image);

  image = (*(getClient()->inrz))();
  tinr= TclInrimage::getInterface(image);
  if (tinr==0)
    new TclInrimage(m, typeid(TclInrimage), image);

  /*
  cerr << ((InrimageClient *) ((*(getClient()->inrx))()))->getInterface() << endl;
  cerr << ((InrimageClient *) ((*(getClient()->inry))()))->getInterface() << endl;
  cerr << ((InrimageClient *) ((*(getClient()->inrz))()))->getInterface() << endl;
  */
  /*  if (!(((InrimageClient *) ((*(getClient()->inrx))()))->getInterface())) 
    new TclInrimage(m, typeid(TclInrimage), new Inrimage(*(*(getClient()->inrx))()) );

    if (!(((InrimageClient *) ((*(getClient()->inry))()))->getInterface())) 
    new TclInrimage(m, typeid(TclInrimage), new Inrimage(*(*(getClient()->inry))()) );

    if (!(((InrimageClient *) ((*(getClient()->inrz))()))->getInterface())) 
    new TclInrimage(m, typeid(TclInrimage), new Inrimage(*(*(getClient()->inrz))()) );
  */
}



int TclDisplacementField3D::defxCmd(int argc, char **argv) {

  if (argc > 0) return COMMAND_SYNOPSIS;

  Inrimage *inr = (*(getClient()->inrx))();

  TclInrimage *tinr=TclInrimage::getInterface(inr);

  if (tinr){
    setResult("%s%u", tinr->getObjectName(), tinr->getRef());
  }
  else
    CERR << "Probleme dans la creation du def3D Les tclInrimage associees ne sont pas crees" << ENDL;
  
  return TCL_OK;

}


int TclDisplacementField3D::defyCmd(int argc, char **argv) {

  if (argc > 0) return COMMAND_SYNOPSIS;

  Inrimage *inr = (*(getClient()->inry))();

  TclInrimage *tinr=TclInrimage::getInterface(inr);


  if (tinr) {
    setResult("%s%u", tinr->getObjectName(), tinr->getRef());
  }
  else
    CERR << "Probleme dans la creation du def3D Les tclInrimage associees ne sont pas crees" << ENDL;
  
  return TCL_OK;

}


int TclDisplacementField3D::defzCmd(int argc, char **argv) {

  if (argc > 0) return COMMAND_SYNOPSIS;

  Inrimage *inr = (*(getClient()->inrz))();
  TclInrimage *tinr=TclInrimage::getInterface(inr);

  if (tinr) {
    setResult("%s%u", tinr->getObjectName(), tinr->getRef());
  }
  else
    CERR << "Probleme dans la creation du def3D Les tclInrimage associees ne sont pas crees" << ENDL;
  
  return TCL_OK;

}

} // namespace yav
