#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "inrimage/TclImage3DBackgroundManager.h"

#include <inrimage/TclImage3DBackgroundManager.h>
#include <inrimage/TclInrimage.h>
#include <graphics2D/TclCamera2D.h>
#include <graphics2D/Camera2DActivation.h>
#include <graphics2D/SliceScale.h>
#include <inrimage/TclColorMap.h>

namespace yav {

	TclImage3DBackgroundManager::TclImage3DBackgroundManager(TclModule *m,TclInrimage *inr,
		const TclString& window ) : Image3DBackgroundManager(inr->getClient()),TclSon(m,window),
		TclObject(typeid(TclImage3DBackgroundManager),m) 
	{
		secondMinScale.setOwner(this);
		secondMaxScale.setOwner(this);
		zoom=1;
		done(typeid(TclImage3DBackgroundManager));

	}

	TclString TclImage3DBackgroundManager::objectName(void) const{
		return name();
	}

	void TclImage3DBackgroundManager::scaleValue(const TclScale *scale, double val) {
		if (((TclScale *)this->Owner<MinGLScale>::pointer())==scale)
			setMinWindow(val);
		else if (((TclScale *)this->Owner<MaxGLScale>::pointer())==scale)
		{	
			setMaxWindow(val);
		}
		else if (((TclScale *)this->Owner<OpacityScale>::pointer())==scale)
		{	
			setOpacity(val);
		}
		else if (((TclScale *)secondMinScale())==scale)
		{	
			setMinWindow2(val);
		}
		else if (((TclScale *)secondMaxScale())==scale)
		{	
			setMaxWindow2(val);
		}

	}
  
  
	void TclImage3DBackgroundManager::scaleTo(const TclScale *scale, double val){
	}

  
	double TclImage3DBackgroundManager::getMin(const TclScale *scale) const{
		if ((((TclScale *)secondMinScale())==scale) || ((TclScale *)secondMaxScale())==scale)
		return(getMinWindow2());
		else
		return(getMinWindow());
	}


	double TclImage3DBackgroundManager::getMax(const TclScale *scale) const{
		if ((((TclScale *)secondMinScale())==scale) || ((TclScale *)secondMaxScale())==scale)
		return(getMaxWindow2());
		else
		return(getMaxWindow());

	}

	double TclImage3DBackgroundManager::getStep(const TclScale *scale) const{
		if ((((TclScale *)secondMinScale())==scale) || ((TclScale *)secondMaxScale())==scale) {
			double val=getMaxWindow2()-getMinWindow2();
		if ((val<2000) && (val>10))
			return 1.0;
		else 
			return (val/300);
		} else {
		double val=getMaxWindow()-getMinWindow();
		if ((val<2000) && (val>10))
			return 1.0;
		else 
			return (val/300);
		}
	}

	

void	TclImage3DBackgroundManager::imageHasChangedTexture(Inrimage *inr)
{
	Image3DBackgroundManager::imageHasChangedTexture(inr);
	if (Owner<MinGLScale>::getPointer()) 
		Owner<MinGLScale>::getPointer()->reset(this);
	if (Owner<MaxGLScale>::getPointer()) 
		Owner<MaxGLScale>::getPointer()->reset(this);
}
TclImage3DBackgroundManager::~TclImage3DBackgroundManager(){

	TclObject::deleted(typeid(TclImage3DBackgroundManager));
}

int TclImage3DBackgroundManager::secondImageCmd(int argc, char **argv)
{
	if (argc>1) 
		return COMMAND_SYNOPSIS;
	else {
		if (argc==1) {
			TclInrimage *inr = (TclInrimage *) TclObjectKind::getObject(typeid(TclInrimage), argc, argv, 0); 
			if (!inr) {
				setResult("%s must be an image name",argv[0]);
				return TCL_ERROR;
			}	
			setSecondImage(inr->getClient());
		}
		if (getSecondImage()) 
		{
			TclInrimage *inr=TclInrimage::getInterface(getSecondImage());
			if (inr) {
				setResult(inr->name());
				return TCL_OK;
			}
		} 
		setResult("none");
		return TCL_OK;
	}
}


int TclImage3DBackgroundManager::colorMapCmd(int argc, char **argv){
if(argc > 0) {
    Image3DBackgroundManager::COLORMAP t;
    if(!strcmp(argv[0], "affine")) t = Image3DBackgroundManager::AFFINE;
    else if(!strcmp(argv[0], "threshold")) t = Image3DBackgroundManager::THRESHOLD;
    else if(!strcmp(argv[0], "spect")) t = Image3DBackgroundManager::SPECT_COLORS;
    else if(!strcmp(argv[0], "hotiron")) t = Image3DBackgroundManager::HOTIRON_COLORS;
    else if(!strcmp(argv[0], "blue")) t = Image3DBackgroundManager::BLUE;
    else if(!strcmp(argv[0], "red")) t = Image3DBackgroundManager::RED;
    else if(!strcmp(argv[0], "green")) t = Image3DBackgroundManager::GREEN;
    else if(!strcmp(argv[0], "pet")) t = Image3DBackgroundManager::PET_COLORS;
    else if(!strcmp(argv[0], "jet")) t = Image3DBackgroundManager::JET_COLORS;
	else if(!strcmp(argv[0], "user")) 
	{
		t = Image3DBackgroundManager::USER;
		if (argc>1)
		{
			TclColorMap *tc=(TclColorMap *)
				TclObjectKind::getObject(typeid(TclColorMap), argc, argv, 1);
			if (tc)
				setColorMap(t,tc->getRed(),tc->getGreen(),tc->getBlue());
			else {
				setResult("%s must be a colormap",argv[1]);
				return TCL_ERROR;
			}
		} else
			return COMMAND_SYNOPSIS;
	}
	else return COMMAND_SYNOPSIS;
	setColorMap(t);
}
  switch(getColorMap()) {
  case Image3DBackgroundManager::AFFINE:
    setResult("affine");
    break;
  case Image3DBackgroundManager::THRESHOLD:
    setResult("threshold");
    break;
  case Image3DBackgroundManager::PET_COLORS:
    setResult("pet");
    break;
  case Image3DBackgroundManager::JET_COLORS:
    setResult("jet");
    break;  
  case Image3DBackgroundManager::SPECT_COLORS:
    setResult("spect");
    break;
  case Image3DBackgroundManager::HOTIRON_COLORS:
    setResult("hotiron");
    break;
  case Image3DBackgroundManager::BLUE:
    setResult("blue");
    break;
  case Image3DBackgroundManager::USER:
    setResult("user");
    break;
  default:
    break;
  }
  return TCL_OK;
}

int TclImage3DBackgroundManager::colorMap2Cmd(int argc, char **argv){
if(argc > 0) {
    Image3DBackgroundManager::COLORMAP t;
    if(!strcmp(argv[0], "affine")) t = Image3DBackgroundManager::AFFINE;
    else if(!strcmp(argv[0], "threshold")) t = Image3DBackgroundManager::THRESHOLD;
    else if(!strcmp(argv[0], "spect")) t = Image3DBackgroundManager::SPECT_COLORS;
    else if(!strcmp(argv[0], "hotiron")) t = Image3DBackgroundManager::HOTIRON_COLORS;
    else if(!strcmp(argv[0], "blue")) t = Image3DBackgroundManager::BLUE;
    else if(!strcmp(argv[0], "red")) t = Image3DBackgroundManager::RED;
    else if(!strcmp(argv[0], "green")) t = Image3DBackgroundManager::GREEN;
    else if(!strcmp(argv[0], "pet")) t = Image3DBackgroundManager::PET_COLORS;
    else if(!strcmp(argv[0], "jet")) t = Image3DBackgroundManager::JET_COLORS;
	else if(!strcmp(argv[0], "user")) 
	{
		t = Image3DBackgroundManager::USER;
		if (argc>1)
		{
			TclColorMap *tc=(TclColorMap *)
				TclObjectKind::getObject(typeid(TclColorMap), argc, argv, 1);
			if (tc)
				setColorMap2(t,tc->getRed(),tc->getGreen(),tc->getBlue());
			else {
				setResult("%s must be a colormap",argv[1]);
				return TCL_ERROR;
			}
		} else
			return COMMAND_SYNOPSIS;
	}
	else return COMMAND_SYNOPSIS;
	setColorMap2(t);
}
  switch(getColorMap2()) {
  case Image3DBackgroundManager::AFFINE:
    setResult("affine");
    break;
  case Image3DBackgroundManager::THRESHOLD:
    setResult("threshold");
    break;
  case Image3DBackgroundManager::PET_COLORS:
    setResult("pet");
    break;
  case Image3DBackgroundManager::JET_COLORS:
    setResult("jet");
    break;  
  case Image3DBackgroundManager::SPECT_COLORS:
    setResult("spect");
    break;
  case Image3DBackgroundManager::HOTIRON_COLORS:
    setResult("hotiron");
    break;
  case Image3DBackgroundManager::BLUE:
    setResult("blue");
    break;
  case Image3DBackgroundManager::USER:
    setResult("user");
    break;
  default:
    break;
  }
  return TCL_OK;
}
void TclImage3DBackgroundManager::updateSliders() const{
	if (this->Owner<MinGLScale>::getPointer()) {
		Owner<MinGLScale>::getPointer()->to(getMinWindow());
	}
	if (this->Owner<MaxGLScale>::getPointer()) {
		Owner<MaxGLScale>::getPointer()->to(getMaxWindow());
	}
}

void TclImage3DBackgroundManager::updateLabel(const char *label){
	if ((labelWidget!=EMPTY_STRING) && (label)) {
		tickle("%s configure -text {%s}",(char *)labelWidget,label);
	}
}
 int TclImage3DBackgroundManager::showAxisCmd(int argc, char **argv){
	 if (argc==0) {
		 setResult(TclModule::boolString(getShowAxis()));
		 return TCL_OK;
	 } else if (argc==1) {
		 bool b;
		 if(!TclModule::boolValue(argv[0], b)) return COMMAND_SYNOPSIS;
		 setShowAxis(b);
		 setResult(TclModule::boolString(getShowAxis()));
		 return TCL_OK;
	 } else return COMMAND_SYNOPSIS;
 }

 int TclImage3DBackgroundManager::opacityScaleCmd(int argc, char **argv)
 {
	 if (argc==0)
	 {
		 if (Owner<OpacityScale>::pointer)
			 setResult("%s",(char *)Owner<OpacityScale>::pointer->name());
		 return TCL_OK;
	 }

	 else if (argc==1)
	 { 

		 OpacityScale *gl= dynamic_cast<OpacityScale *>(	
			 TclObjectKind::getObject(typeid(OpacityScale), argc, argv, 0));
		 if (gl)
		 {
			 Owner<OpacityScale>::pointer = gl;
			 *Owner<OpacityScale>::pointer += this;
			 gl->reset(this);
			 setResult("%s",(char *)gl->name());
			 return TCL_OK;
		 }
		 else
		 {
			 setResult("%s is not a OpacityScale",argv[0]);
			 return TCL_ERROR;
		 }

	 }
	 else
		 return COMMAND_SYNOPSIS;

 }
	  
  int TclImage3DBackgroundManager::GLScaleCmd(int argc, char **argv){
	  if (argc==1)
	  {
		  if (!strcmp(argv[0],"min"))
		  {
			  if (Owner<MinGLScale>::pointer)
				  setResult("%s",(char *)Owner<MinGLScale>::pointer->name());
			  return TCL_OK;
		  }
		  else if (!strcmp(argv[0],"max"))
		  {
			  if (Owner<MaxGLScale>::pointer)
				  setResult("%s",(char *)Owner<MaxGLScale>::pointer->name());
			  return TCL_OK;
		  }
		  else
			  return COMMAND_SYNOPSIS;	
	  }
	  else if (argc==2)
	  { 
		  if (!strcmp(argv[0],"min"))
		  {
			  MinGLScale *gl= dynamic_cast<MinGLScale *>(	
				  TclObjectKind::getObject(typeid(GLScale), argc, argv, 1));
			  if (gl)
			  {
				  Owner<MinGLScale>::pointer = gl;
				  *Owner<MinGLScale>::pointer += this;
				  gl->reset(this);
				  setResult("%s",(char *)gl->name());
				  return TCL_OK;
			  }
			  else
			  {
				  setResult("%s is not a minGLScale",argv[1]);
				  return TCL_ERROR;
			  }
		  }
		  else if (!strcmp(argv[0],"max"))
		  {
			  MaxGLScale *gl= dynamic_cast<MaxGLScale *>(	
				  TclObjectKind::getObject(typeid(GLScale), argc, argv, 1));
			  if (gl)
			  {
				  Owner<MaxGLScale>::pointer = gl;
				  *Owner<MaxGLScale>::pointer += this;
				  gl->reset(this);
				  setResult("%s",(char *)gl->name());
				  return TCL_OK;
			  }
			  else
			  {
				  setResult("%s is not a maxGLScale",argv[1]);
				  return TCL_ERROR;
			  }
		  }
		  else
			  return COMMAND_SYNOPSIS;

	  }
	  else
		  return COMMAND_SYNOPSIS;
  } 
    int TclImage3DBackgroundManager::moveToPointCmd(int argc, char **argv){
		if (argc!=3) {
			  return COMMAND_SYNOPSIS;
		}
		Vec3<double> p(atof(argv[0]),atof(argv[1]),atof(argv[2]));
		moveToPoint(p);
		return TCL_OK;
	}
  int TclImage3DBackgroundManager::GLScale2Cmd(int argc, char **argv){
	  if (argc==1)
	  {
		  if (!strcmp(argv[0],"min"))
		  {
			  if (secondMinScale)
				  setResult("%s",(char *)secondMinScale->name());
			  return TCL_OK;
		  }
		  else if (!strcmp(argv[0],"max"))
		  {
			  if (secondMaxScale)
				  setResult("%s",(char *)secondMaxScale->name());
			  return TCL_OK;
		  }
		  else
			  return COMMAND_SYNOPSIS;	
	  }
	  else if (argc==2)
	  { 
		  if (!strcmp(argv[0],"min"))
		  {
			  MinGLScale *gl= dynamic_cast<MinGLScale *>(	
				  TclObjectKind::getObject(typeid(GLScale), argc, argv, 1));
			  if (gl)
			  {
				  secondMinScale = gl;
				  *secondMinScale += this;
				  gl->reset(this);
				  setResult("%s",(char *)gl->name());
				  return TCL_OK;
			  }
			  else
			  {
				  setResult("%s is not a minGLScale",argv[1]);
				  return TCL_ERROR;
			  }
		  }
		  else if (!strcmp(argv[0],"max"))
		  {
			  MaxGLScale *gl= dynamic_cast<MaxGLScale *>(	
				  TclObjectKind::getObject(typeid(GLScale), argc, argv, 1));
			  if (gl)
			  {
				  secondMaxScale = gl;
				  *secondMaxScale += this;
				  gl->reset(this);
				  setResult("%s",(char *)gl->name());
				  return TCL_OK;
			  }
			  else
			  {
				  setResult("%s is not a maxGLScale",argv[1]);
				  return TCL_ERROR;
			  }
		  }
		  else
			  return COMMAND_SYNOPSIS;

	  }
	  else
		  return COMMAND_SYNOPSIS;
  } 

  /// -destroy option
int TclImage3DBackgroundManager::destroyCmd(int argc, char **argv){
	 if(argc != 0) return COMMAND_SYNOPSIS;
  TclModule *m = getModule();
  unsigned int u = TclObject::getRef();
  m->setResult("%s%u does not exist any longer",
	       TclImage3DBackgroundManager::getObjectName(), u);
  delete this;
  return TCL_OK;
}

void TclImage3DBackgroundManager::changeCameraSize(const double val) {
  if(val > 0.0) {
	double scaleFactor=val/zoom;	
    zoom = val;

ObjectsList<Image3DCameraBackground>::iterator itb;
		for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
	/// send the resize to the TclCamera object	
		if ((*itb)->getCamera()->getCameraActivation()) {
		(*itb)->getCamera()->getCameraActivation()->resize(
			(unsigned int)((*itb)->getCamera()->getHeight()*scaleFactor),
			(unsigned int)((*itb)->getCamera()->getWidth()*scaleFactor));
		}
    }
  }
}
int TclImage3DBackgroundManager::synchronizeCmd(int argc, char **argv){
	if (argc==0) {
		TclString res;
		res="{ ";
		DPList<Image3DBackgroundManager>::iterator itm;
		for(itm=begin();itm!=end();itm++) {
			TclImage3DBackgroundManager *m=dynamic_cast<TclImage3DBackgroundManager *>(*itm);
			if (m) {
				res+= m->name()+ " ";
			}
		}
		res+=" }";
		setResult(res);
		return TCL_OK;
	} 
	else if (argc==1) {
		TclImage3DBackgroundManager *m= (TclImage3DBackgroundManager *)
			TclObjectKind::getObject(typeid(TclImage3DBackgroundManager), argc, argv, 0);
		if (m) {
			synchronizeWithManager((Image3DBackgroundManager *)m);
			((Image3DBackgroundManager *)m)->synchronizeWithManager((Image3DBackgroundManager *)this);
			setResult("synchronized with manager %s",argv[0]);
			return TCL_OK;
		} else {
			setResult("%s must be a manager",argv[0]);
			return TCL_ERROR;
		}
	} 
	else if (argc==2) {
		if (!strcmp(argv[0],"remove")) {
			TclImage3DBackgroundManager *m= (TclImage3DBackgroundManager *)
				TclObjectKind::getObject(typeid(TclImage3DBackgroundManager), argc, argv, 1);
			if (m) {
				DPOwner<Image3DBackgroundManager>::remove((Image3DBackgroundManager *)m);
				m->DPOwner<Image3DBackgroundManager>::remove((Image3DBackgroundManager *)this);
				setResult("removed synchronisation with manager %s",argv[1]);
				return TCL_OK;
			} else {
				setResult("%s must be a manager",argv[1]);
				return TCL_ERROR;
			}
		} else
			return COMMAND_SYNOPSIS;

	} 
	else
return COMMAND_SYNOPSIS;
	}



int TclImage3DBackgroundManager::parentWidgetCmd(int argc, char **argv){
	if (argc==0) {
		setResult(windowName());
		return TCL_OK;
	} else if (argc==1) {
		setTCLwindow(argv[0]);
		setResult("%s is now attached to widget %s",(char *)name(),argv[0]);
		return TCL_OK;
	} else
		return COMMAND_SYNOPSIS;
}

int TclImage3DBackgroundManager::labelWidgetCmd(int argc, char **argv){
	if (argc==0) {
		setResult(labelWidget);
		return TCL_OK;
	} else if (argc==1) {
		labelWidget=argv[0];
		setResult("%s is now the label widget",argv[0]);
		return TCL_OK;
	} else
		return COMMAND_SYNOPSIS;
}


int TclImage3DBackgroundManager::middleMouseActionCmd(int argc, char **argv){
	if (argc==0) {
		switch(mouseAction) {
			case MOVE_SLICES:
				setResult("moveSlices");
				break;	
			default:
				setResult("changeWindowing");
				break;
		}
		return TCL_OK;
	} else if (argc==1) {
		if (!strcmp(argv[0],"moveSlices")) {
			mouseAction=MOVE_SLICES;
		} else if (!strcmp(argv[0],"changeWindowing")) {
			mouseAction=CHANGE_WINDOWING;
		}
		else {
			setResult("%s must be either moveSlices or changeWindowing",argv[0]);
			return TCL_ERROR;
		}
		setResult(argv[0]);
		return TCL_OK;
	} else 
		return COMMAND_SYNOPSIS;

}
		
int TclImage3DBackgroundManager::windowCmd(int argc, char **argv){
	if (argc==0) {
		
		setResult("%f %f",getMinWindow(),getMaxWindow());
		return TCL_OK;
	} else if (argc==2) {
		setMinWindow((double)atof(argv[0]));
		setMaxWindow((double)atof(argv[1]));
		setResult("%f %f",getMinWindow(),getMaxWindow());
		return TCL_OK;
	} else
		return COMMAND_SYNOPSIS;
}
		
int TclImage3DBackgroundManager::window2Cmd(int argc, char **argv){
	if (argc==0) {
		
		setResult("%f %f",getMinWindow2(),getMaxWindow2());
		return TCL_OK;
	} else if (argc==2) {
		setMinWindow2((double)atof(argv[0]));
		setMaxWindow2((double)atof(argv[1]));
		setResult("%f %f",getMinWindow2(),getMaxWindow2());
		return TCL_OK;
	} else
		return COMMAND_SYNOPSIS;
}
int TclImage3DBackgroundManager::widgetSizeCmd(int argc, char **argv) {
  double val;

  if(argc > 2) return COMMAND_SYNOPSIS;
  if(argc > 0) {
    if(argv[0][0] == '*' || argv[0][0] == '/') {
      if(strlen(argv[0]) > 1) {
	if(sscanf(argv[0] + 1, "%lf", &val) != 1) return COMMAND_SYNOPSIS;
	if(argv[0][0] == '/') val = 1.0 / val;
	changeCameraSize(zoom*val);
      }
      else {
	if(argc > 1) {
	  if(sscanf(argv[1], "%lf", &val) != 1) return COMMAND_SYNOPSIS;
	  if(argv[0][0] == '/') val = 1.0 / val;
	  changeCameraSize(zoom*val);
	}
	else return COMMAND_SYNOPSIS;
      }
    }
    else 
	{
      if(sscanf(argv[0], "%lf", &val) != 1) return COMMAND_SYNOPSIS;
      changeCameraSize(val);
    }
  }
  setResult("%f", zoom);
  return TCL_OK;
}
int TclImage3DBackgroundManager::interpolationCmd(int argc, char **argv) {
  if (argc>1)
    return COMMAND_SYNOPSIS;
  if (argc==1)
    {
      if (!strcmp(argv[0],"nearest"))
	{
		setInterpolationMethod(Image3DBackgroundManager::NEAREST);
	}
      else if (!strcmp(argv[0],"bilinear"))
	{
		setInterpolationMethod(Image3DBackgroundManager::BILINEAR);
	}
      else {
	setResult("%s must be one of the following : nearest, bilinear",argv[0]);
	return TCL_ERROR;
      }
	  ObjectsList<Image3DCameraBackground>::iterator itb;
	  for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
		  if ((*itb)->getCamera()->getCameraActivation()) {
			  (*itb)->getCamera()->getCameraActivation()->redraw();
		  }
	  }

    }
  switch (getInterpolationMethod()) {
  case Image3DBackgroundManager::NEAREST:
    setResult("nearest");
    break;
  case Image3DBackgroundManager::BILINEAR:
    setResult("bilinear");
    break;
  }
  return TCL_OK;
}

/// -background option
int TclImage3DBackgroundManager::backgroundCmd(int argc, char **argv){
	if (argc==0) {
		TclString res;
		res="";
		ObjectsList<Image3DCameraBackground>::iterator itb;
		for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
			res+= (*itb)->getName()+ " ";
		}
		res+=" ";
		setResult(res);
		return TCL_OK;
	} 
	else if (argc==1) {
		Image3DCameraBackground *b=AutoLink<Image3DCameraBackground>::getHead();
		for(;b && (b->getName()!=(const char *)argv[0]);
			b=b->AutoLink<Image3DCameraBackground>::following()){
			}

			if (!b)
			{
				setResult("cannot get background named %s",argv[0]);
				return TCL_ERROR;
			} else {
				addBackground(b);
				setResult("added background %s",argv[0]);
				return TCL_OK;
			}
	} 
	else if (argc==2) {
		if (!strcmp(argv[0],"remove")) {
			Image3DCameraBackground *b=AutoLink<Image3DCameraBackground>::getHead();
			for(;b && (b->getName()!=(const char *)argv[1]);
				b=b->AutoLink<Image3DCameraBackground>::following()){
				}

				if (!b)
				{
					setResult("cannot get background named %s",argv[1]);
					return TCL_ERROR;
				} else {
					removeBackground(b);
					setResult("removed background %s",argv[1]);
					return TCL_OK;
				}
		} else
			return COMMAND_SYNOPSIS;

	} 
	else
		return COMMAND_SYNOPSIS;
}
int TclImage3DBackgroundManager::showVectorsCmd(int argc, char **argv)
{
	if(argc > 1) return COMMAND_SYNOPSIS;
	if(argc == 1) {
		bool v;
		if(!TclModule::boolValue(argv[0], v)) return COMMAND_SYNOPSIS;
		ObjectsList<Image3DCameraBackground>::iterator itb;
		for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
			Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
			if (sb) {
				sb->setShowVectors(v);
				if ((sb)->getCamera()->getCameraActivation()) {
					(sb)->getCamera()->getCameraActivation()->redraw();
				}
			}
		}
		setResult(TclModule::boolString(v));
		return TCL_OK;
		
	} else {
			ObjectsList<Image3DCameraBackground>::iterator itb=backgroundList.begin();
			Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
			if (sb)
				setResult(TclModule::boolString(sb->getShowVectors()));
			else 
				setResult("true");
			return TCL_OK;
		}
	}
 int TclImage3DBackgroundManager::showArrowsCmd(int argc, char **argv){
	 if(argc > 1) return COMMAND_SYNOPSIS;
	 if(argc == 1) {
		 bool v;
		 if(!TclModule::boolValue(argv[0], v)) return COMMAND_SYNOPSIS;
		 ObjectsList<Image3DCameraBackground>::iterator itb;
		 for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
			 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
			 if (sb) {
				 sb->setShowArrows(v);
				 if ((sb)->getCamera()->getCameraActivation()) {
					 (sb)->getCamera()->getCameraActivation()->redraw();
				 }
			 }
		 }
		 setResult(TclModule::boolString(v));
		 return TCL_OK;	 

	 } else {

		 ObjectsList<Image3DCameraBackground>::iterator itb=backgroundList.begin();
		 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
		 if (sb)
			 setResult(TclModule::boolString(sb->getShowArrows()));
		 else 
			 setResult("true");
		 return TCL_OK;
	 }
 }
  int TclImage3DBackgroundManager::vectorScaleCmd(int argc, char **argv){
	 if(argc > 1) return COMMAND_SYNOPSIS;
	 if(argc == 1) {
		 double v=(double) atof(argv[0]);
		 ObjectsList<Image3DCameraBackground>::iterator itb;
		 for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
			 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
			 if (sb) {
				 sb->setVectorScale(v);
				 if ((sb)->getCamera()->getCameraActivation()) {
					 (sb)->getCamera()->getCameraActivation()->redraw();
				 }
			 }
		 }
		 setResult("%f",v);
		 return TCL_OK;
	 } else {
	 ObjectsList<Image3DCameraBackground>::iterator itb=backgroundList.begin();
	 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
	 if (sb)
		 setResult("%f",sb->getVectorScale());
	 else 
		 setResult("1.0");
	 return TCL_OK;
	 }
 }
  int TclImage3DBackgroundManager::vectorColorCmd(int argc, char **argv)
  {
	  if((argc > 3) || (argc==2) || (argc==1)) return COMMAND_SYNOPSIS;
	  if(argc == 3) {
		  float r= (float) atof(argv[0]);
		  float g= (float) atof(argv[1]);
		  float b= (float) atof(argv[2]);
		  ObjectsList<Image3DCameraBackground>::iterator itb;
		  for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
			  Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
			  if (sb){
				  sb->setVectorColor(r,g,b);
				  if ((sb)->getCamera()->getCameraActivation()) {
					  (sb)->getCamera()->getCameraActivation()->redraw();
				  }
			  }
		  }
		  setResult("%f %f %f",r,g,b);
		  return TCL_OK;

	  } else {
		  ObjectsList<Image3DCameraBackground>::iterator itb=backgroundList.begin();
		  Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
		  if (sb)
			  setResult("%f %f %f",sb->getVectorColor(0),sb->getVectorColor(1),sb->getVectorColor(2));
		  else 
			  setResult("1.0 0 0");
		  return TCL_OK;
	  }
  }
int TclImage3DBackgroundManager::vectorStepCmd(int argc, char **argv){
 if((argc > 2) || (argc==0) ) return COMMAND_SYNOPSIS;
 if (!strcmp(argv[0],"XY")) {
	 if (argc==2) {
		 unsigned int step=(unsigned int) atoi(argv[1]);

		 ObjectsList<Image3DCameraBackground>::iterator itb;
		 for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
			 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
			 if (sb){
				 sb->setVectorXYStep(step);
				 if ((sb)->getCamera()->getCameraActivation()) {
					 (sb)->getCamera()->getCameraActivation()->redraw();
				 }
			 }
		 }
		 setResult("%u",step);
		 return TCL_OK;
	 } else {
		 ObjectsList<Image3DCameraBackground>::iterator itb=backgroundList.begin();
		 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
		 if (sb)
			 setResult("%u",sb->getVectorXYStep());
		 else 
			 setResult("1");
		 return TCL_OK;
	 }
 }
 if (!strcmp(argv[0],"Z")) {
	 if (argc==2) {
		 unsigned int step=(unsigned int) atoi(argv[1]);

		 ObjectsList<Image3DCameraBackground>::iterator itb;
		 for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
			 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
			 if (sb) {
				 sb->setVectorZStep(step);
				 if ((sb)->getCamera()->getCameraActivation()) {
					 (sb)->getCamera()->getCameraActivation()->redraw();
				 }
		  }
		 }
		 setResult("%u",step);
		 return TCL_OK;
	 } else {
		 ObjectsList<Image3DCameraBackground>::iterator itb=backgroundList.begin();
		 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
		 if (sb)
			 setResult("%u",sb->getVectorZStep());
		 else 
			 setResult("1");
		 return TCL_OK;
	 }
 } else {
	 setResult("%s must be either XY or Z",argv[0]);
	 return TCL_ERROR;
 }
}
int TclImage3DBackgroundManager::arrowCmd(int argc, char **argv){
 if((argc > 2) || (argc==0) ) return COMMAND_SYNOPSIS;
 if (!strcmp(argv[0],"height")) {
	 if (argc==2) {
		 double h=atof(argv[1]);

		 ObjectsList<Image3DCameraBackground>::iterator itb;
		 for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
			 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
			 if (sb){
				 sb->setArrowHeight(h);
				 if ((sb)->getCamera()->getCameraActivation()) {
					 (sb)->getCamera()->getCameraActivation()->redraw();
				 }
			 }
		 }
		 setResult("%f",h);
		 return TCL_OK;
	 } else {
		 ObjectsList<Image3DCameraBackground>::iterator itb=backgroundList.begin();
		 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
		 if (sb)
			 setResult("%f",sb->getArrowHeight());
		 else 
			 setResult("1");
		 return TCL_OK;
	 }
 }
 if (!strcmp(argv[0],"width")) {
	 if (argc==2) {
		 double w=atof(argv[1]);

		 ObjectsList<Image3DCameraBackground>::iterator itb;
		 for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
			 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
			 if (sb) {
				 sb->setArrowWidth(w);
				 if ((sb)->getCamera()->getCameraActivation()) {
					 (sb)->getCamera()->getCameraActivation()->redraw();
				 }
		  }
		 }
		 setResult("%f",w);
		 return TCL_OK;
	 } else {
		 ObjectsList<Image3DCameraBackground>::iterator itb=backgroundList.begin();
		 Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
		 if (sb)
			 setResult("%f",sb->getArrowWidth());
		 else 
			 setResult("1");
		 return TCL_OK;
	 }
 } else {
	 setResult("%s must be either width  or height",argv[0]);
	 return TCL_ERROR;
 }
}
int TclImage3DBackgroundManager::imageCmd(int argc, char **argv) {
	if (argc==0) {
		TclInrimage *inr=TclInrimage::getInterface(getInrimage());
		if (inr) {
			setResult(inr->name());
		}
	return TCL_OK;
	} else
return COMMAND_SYNOPSIS;
}

int TclImage3DBackgroundManager::hideAxisCmd(int argc, char **argv)
{
	if(argc != 0) return COMMAND_SYNOPSIS;
	ObjectsList<Image3DCameraBackground>::iterator itb;
	for (itb=backgroundList.begin();itb!=backgroundList.end();itb++) {
		Image3DCameraBackground *sb=dynamic_cast<Image3DCameraBackground *>(*itb);
		if (sb) {
			sb->hideAxis();
			if ((sb)->getCamera()->getCameraActivation()) {
				(sb)->getCamera()->getCameraActivation()->redraw();
			}
		}
	}

	return TCL_OK;
}
  /// new TCL command callback
int TclImage3DBackgroundManager::create(TclModule *m, int argc, char **argv){
	TclImage3DBackgroundManager *manager=0;
	TclInrimage *inr=0;

	if(argc == 2) {
		inr = (TclInrimage *) TclObjectKind::getObject(typeid(TclInrimage), argc, argv, 1); 
		if (!inr) {
			m->setResult("%s must be an image name",argv[1]);
			return TCL_ERROR;
		}		 
		manager=new TclImage3DBackgroundManager(m,inr);
	} else {
		return COMMAND_SYNOPSIS;
	}
	m->setResult(manager->name());
	return TCL_OK;


}
void TclImage3DBackgroundManager::createCommands(TclModule *m) {
   TclObjectKind *kind;

	kind = new TclObjectKind(m, typeid(TclImage3DBackgroundManager),
		"multiview",
		"Object attached to an image that manages the colormap, windowing and synchronisation of several image backgrounds",
		"inr%u",
			   &TclImage3DBackgroundManager::create, 
			   &TclImage3DBackgroundManager::list);

  kind->newOption("-destroy", (TclObject::OPTION) &TclImage3DBackgroundManager::destroyCmd, 0,
		  "destroy the background manager and all its associated backgrounds");
    kind->newOption("-colormap2", (TclObject::OPTION) &TclImage3DBackgroundManager::colorMap2Cmd, 
		"[affine|threshold|pet|spect|hotiron|red|green|blue|user|cm%u]",
		  "set or get the current colormap applied to the second image");
  kind->newOption("-hideAxis", (TclObject::OPTION) &TclImage3DBackgroundManager::hideAxisCmd, 0,
		  "stop drawing axis around mouse");
  kind->newOption("-colormap", (TclObject::OPTION) &TclImage3DBackgroundManager::colorMapCmd, 
		"[affine|threshold|pet|spect|hotiron|red|green|blue|user|cm%u]",
		  "set or get the current colormap applied to the backgrounds");
    kind->newOption("-showAxis", (TclObject::OPTION) &TclImage3DBackgroundManager::showAxisCmd, "[true|false]",
		  "set or get the boolean that indicates if an axis should be drawn when a background gets focus");
	    kind->newOption("-widgetSize", (TclObject::OPTION) &TclImage3DBackgroundManager::widgetSizeCmd, "[[*|/] %f]",
		  "set or get the multiplicative factor by which the size of all cameras should be changed");
    kind->newOption("-window", (TclObject::OPTION) &TclImage3DBackgroundManager::windowCmd, 
		"[minWindow=%f maxWindow=%f ]",
		  "set or get the two grey level values corresponding to the minimum and maximum thresholds used in windowing the image");
    kind->newOption("-window2", (TclObject::OPTION) &TclImage3DBackgroundManager::window2Cmd, 
		"[minWindow=%f maxWindow=%f ]",
		  "set or get the two grey level values corresponding to the minimum and maximum thresholds used in windowing of the second image");
	kind->newOption("-image", (TclObject::OPTION) &TclImage3DBackgroundManager::imageCmd, 
		0,
		  "returns the image used by the manager of image backgrounds");

	kind->newOption("-arrow", (TclObject::OPTION) &TclImage3DBackgroundManager::arrowCmd, 
		"width [%f]| height [%f]",
		  "set or get the height and width of arrows as a percentage of vector length");
    kind->newOption("-opacityScale", (TclObject::OPTION) &TclImage3DBackgroundManager::opacityScaleCmd, 
		"[opascale%u]",
		  "set or get the Tk scale widget that controls the opacity between the two overlaid images");

    kind->newOption("-GLScale", (TclObject::OPTION) &TclImage3DBackgroundManager::GLScaleCmd, 
		"min [glscale%u] | max [glscale%u]",
		  "set or get the widget associated with the grey-level scales controling the windowing");
	    kind->newOption("-GLScale2", (TclObject::OPTION) &TclImage3DBackgroundManager::GLScale2Cmd, 
		"min [glscale%u] | max [glscale%u]",
		  "set or get the widget associated with the grey-level scales controling the windowing of the second Image");
    kind->newOption("-synchronize", (TclObject::OPTION) &TclImage3DBackgroundManager::synchronizeCmd, 
		"[multiview%u | remove multiview%u]",
		  "With no argument, returns the list of managers that are synchronized with this manager. Otherwise, add or remove a manager in widget in this list");
    kind->newOption("-background", (TclObject::OPTION) &TclImage3DBackgroundManager::backgroundCmd, 
		"[imageBgnd%u | remove imageBgnd%u]",
		  "With no argument, returns the list of backgrounds that are synchronized with this manager. Otherwise, add or remove a background in widget in this list");
    kind->newOption("-parentWidget", (TclObject::OPTION) &TclImage3DBackgroundManager::parentWidgetCmd, 
		"[widget=%s]",
		  "get or set the widget associated with the manager. When the widget is destroyed, the manager is destroyed too");
    kind->newOption("-secondImage", (TclObject::OPTION) &TclImage3DBackgroundManager::secondImageCmd, 
		"[inr%u]",
		  "get or set the image to be fused with the first image");

	kind->newOption("-interpolation", (TclObject::OPTION) &TclImage3DBackgroundManager::interpolationCmd, 
		"[nearest|bilinear]",
		  "get or set the interpolation method used by all the image backgrounds controlled by this object");
    kind->newOption("-labelWidget", (TclObject::OPTION) &TclImage3DBackgroundManager::labelWidgetCmd, 
		"[widget=%s]",
		  "get or set the label widget where the mouse position is printed");
    kind->newOption("-middleMouseAction", (TclObject::OPTION) &TclImage3DBackgroundManager::middleMouseActionCmd, 
		"[moveSlices|changeWindowing]",
		"get or set the action that occurs when the middle mouse button is pushed.");
    kind->newOption("-showVectors", (TclObject::OPTION) &TclImage3DBackgroundManager::showVectorsCmd, 
		"[%b]",
		  "get or set the boolean that controls the display of vectors on vectorial images");
    kind->newOption("-showArrows", (TclObject::OPTION) &TclImage3DBackgroundManager::showArrowsCmd, 
		"[%b]",
		  "get or set the boolean that controls if vectors should be displayed with an arrow");
    kind->newOption("-vectorScale", (TclObject::OPTION) &TclImage3DBackgroundManager::vectorScaleCmd, 
		"[%f]",
		  "get or set the scale at which the vector are drawn");
    kind->newOption("-vectorColor", (TclObject::OPTION) &TclImage3DBackgroundManager::vectorColorCmd, 
		"[r=%f g=%f b=%f]",
		  "get or set the rgb components of vector color");
    kind->newOption("-vectorStep", (TclObject::OPTION) &TclImage3DBackgroundManager::vectorStepCmd, 
		"XY [%u] | Z [%u]",
		  "get or set the level of subsampling in the XY and Z directions when drawing arrows");
    kind->newOption("-moveToPoint", (TclObject::OPTION) &TclImage3DBackgroundManager::moveToPointCmd, 
		"vx vy vz",
		  "change the slice number of the background associated with this manager around a given point in world coordinates");
}

}
