#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "inrimage/TclOverlayInrimage4DView.h"

#ifdef TCL_INTERFACE
#include <inrimage/TclOverlayInrimage4DView.h>

#include <graphics2D/TclTimeSliceCamera.h>
#include <inrimage/TclInrimage4D.h>
#include <inrimage/TclOverlay4DBackground.h>
#endif

namespace yav {

TclOverlayInrimage4DBackground *TclOverlayInrimage4DView::getInrimage4DBackground(TimeSliceCamera *cam) const {
    return  (TclOverlayInrimage4DBackground *)
      getClient()->getBackgroundFromCamera(cam); }


TclOverlayInrimage4DView::TclOverlayInrimage4DView(TclModule *m, TclInrimage4D *inr,
					       TclInrimage4D *inr2,
					       TclScene2D *scene,
					       bool _createGLScale)
  : TclInrimage4DView(scene,typeid(TclOverlayInrimage4DView),
		    new OverlayInrimage4DView(inr->getClient(), inr2->getClient(),
					    scene->getClient(),_createGLScale))
{
}
/* "inr%u [scn2D%u]",
   "create an inrview oject to view given inrimage in given scene (a new scene is created if none is provided)" */
int TclOverlayInrimage4DView::create(TclModule *m, int argc, char **argv) {
  TclInrimage4D *inr = 0;
  TclInrimage4D *inr2 = 0;
  TclScene2D *scn = 0;
  TclOverlayInrimage4DView *inrv;
  int i;
  bool addGLScale=true;

  if(argc > 5) return COMMAND_SYNOPSIS;
  inr = TclInrimage4D::getObject(argc, argv, 1);
  if(!inr) 
    return COMMAND_SYNOPSIS;
  inr2 = TclInrimage4D::getObject(argc, argv, 2);
  if(!inr2) 
    return COMMAND_SYNOPSIS;

  for(i = 3; i < argc; i++) {
    if(!scn) 
      {
	scn = (TclScene2D *) TclObjectKind::getObject(typeid(TclScene2D), argc, argv, i);
	if (!scn)
	  {
	    if (!strcmp(argv[i],"-noGLScale"))
	      {
		addGLScale=false;
	      }
	    else return COMMAND_SYNOPSIS;
	  }
      }
    else  if (!strcmp(argv[i],"-noGLScale"))
      {
	addGLScale=false;
      }
    else return COMMAND_SYNOPSIS;
  }
  if(!scn) scn = new TclScene2D(m);

  inrv = new TclOverlayInrimage4DView(m, inr, inr2,scn,addGLScale);
  m->setResult("%s%u", TclObjectKind::getObjectName(typeid(TclOverlayInrimage4DView)), inrv->getRef());
  return TCL_OK;
}


int TclOverlayInrimage4DView::secondInrimageCmd(int argc, char **argv) {
  TclInrimage4D *inr;

  if(argc > 1) return COMMAND_SYNOPSIS;
  if(argc == 1) {
    inr = TclInrimage4D::getObject(argc, argv, 0);
    if(!inr) return COMMAND_SYNOPSIS;
    getClient()->changeSecondInrimage(inr->getClient());
  }
  inr = TclInrimage4D::getInterface(getClient()->getSecondInrimage());
  if(inr)
    setResult("%s%u", 
	      TclObjectKind::getObjectName(typeid(TclInrimage)),
	      inr->getRef());
  else
    setResult("no inrimage");
  return TCL_OK;
}

} // namespace yav
