#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "inrimage/TclOverlayInrimageView.h"

#ifdef TCL_INTERFACE
#include <inrimage/TclOverlayInrimageView.h>

#include <graphics2D/TclSliceCamera.h>
#include <inrimage/TclInrimage.h>
#include <inrimage/TclOverlayInrimageView.h>
#include <inrimage/TclOverlayBackground.h>
#endif

namespace yav {

TclOverlayInrimageView::TclOverlayInrimageView(TclModule *m, TclInrimage *inr,
					       TclInrimage *inr2,
					       TclScene2D *scene,
					       bool _createGLScale)
  : TclInrimageView(scene,typeid(TclOverlayInrimageView),
		    new OverlayInrimageView(inr->getClient(), inr2->getClient(),
					    scene->getClient(),_createGLScale))
{
#ifdef GRAPHICS
  done(typeid(TclInrimageView),"inrimage::installInrviewMenu","inrimage::uninstallInrviewMenu");
  getClient()->focusScene();
#endif
}
/* "inr%u [scn2D%u]",
   "create an inrview oject to view given inrimage in given scene (a new scene is created if none is provided)" */
int TclOverlayInrimageView::create(TclModule *m, int argc, char **argv) {
  TclInrimage *inr = 0;
  TclInrimage *inr2 = 0;
  TclScene2D *scn = 0;
  TclOverlayInrimageView *inrv;
  int i;
  bool addGLScale=true;

  if(argc > 5) return COMMAND_SYNOPSIS;
  inr = TclInrimage::getObject(argc, argv, 1);
  if(!inr) 
    return COMMAND_SYNOPSIS;
  inr2 = TclInrimage::getObject(argc, argv, 2);
  if(!inr2) 
    return COMMAND_SYNOPSIS;

  for(i = 3; i < argc; i++) {
    if(!scn) 
      {
	scn = (TclScene2D *) TclObjectKind::getObject(typeid(TclScene2D), argc, argv, i);
	if (!scn)
	  {
	    if (!strcmp(argv[i],"-noGLScale"))
	      {
		addGLScale=false;
	      }
	    else return COMMAND_SYNOPSIS;
	  }
      }
    else  if (!strcmp(argv[i],"-noGLScale"))
      {
	addGLScale=false;
      }
    else return COMMAND_SYNOPSIS;
  }
  if(!scn) scn = new TclScene2D(m);

  inrv = new TclOverlayInrimageView(m, inr, inr2,scn,addGLScale);
  m->setResult("%s%u", TclObjectKind::getObjectName(typeid(TclOverlayInrimageView)), inrv->getRef());
  return TCL_OK;
}


int TclOverlayInrimageView::secondInrimageCmd(int argc, char **argv) {
  TclInrimage *inr;

  if(argc > 1) return COMMAND_SYNOPSIS;
  if(argc == 1) {
    inr = TclInrimage::getObject(argc, argv, 0);
    if(!inr) return COMMAND_SYNOPSIS;
    getClient()->changeSecondInrimage(inr->getClient());
  }
  inr = TclInrimage::getInterface(getClient()->getSecondInrimage());
  if(inr)
    setResult("%s%u", 
	      TclObjectKind::getObjectName(typeid(TclInrimage)),
	      inr->getRef());
  else
    setResult("no inrimage");
  return TCL_OK;
}

} // namespace yav
