#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "inrimage/TclTransformedInrimageView.h"

#ifdef TCL_INTERFACE
#include <inrimage/TclTransformedInrimageView.h>

#include <graphics2D/TclSliceCamera.h>
#include <inrimage/TclInrimage.h>
#include <modules/TclMatrix4D.h>
#include <inrimage/TclTransformedInrimageView.h>
#include <inrimage/TclTransformedInrimageBackground.h>
#endif

namespace yav {

TclTransformedInrimageView::TclTransformedInrimageView(TclModule *m, TclInrimage *inr,
						       TclScene2D *scene,
						       bool _createGLScale)
  : TclInrimageView(scene,typeid(TclTransformedInrimageView),
		    new TransformedInrimageView(inr->getClient(),
						scene->getClient(),_createGLScale))
{
  done(typeid(TclTransformedInrimageView),"inrimage::installTransformedInrimageMenu","graphics2D::uninstallTransformedInrimageMenu");

}
/* "inr%u [scn2D%u]",
   "create an inrview oject to view given inrimage in given scene (a new scene is created if none is provided)" */
int TclTransformedInrimageView::create(TclModule *m, int argc, char **argv) {
  TclInrimage *inr = 0;
  TclScene2D *scn = 0;
  TclTransformedInrimageView *inrv;
  int i;
  bool addGLScale=true;

  if(argc > 5) return COMMAND_SYNOPSIS;
  inr = TclInrimage::getObject(argc, argv, 1);
  if(!inr) 
    return COMMAND_SYNOPSIS;

  for(i = 2; i < argc; i++) {
    if(!scn) 
      {
	scn = (TclScene2D *) TclObjectKind::getObject(typeid(TclScene2D), argc, argv, i);
	if (!scn)
	  {
	    if (!strcmp(argv[i],"-noGLScale"))
	      {
		addGLScale=false;
	      }
	    else return COMMAND_SYNOPSIS;
	  }
      }
    else  if (!strcmp(argv[i],"-noGLScale"))
      {
	addGLScale=false;
      }
    else return COMMAND_SYNOPSIS;
  }
  if(!scn) scn = new TclScene2D(m);

  inrv = new TclTransformedInrimageView(m, inr, scn,addGLScale);
  m->setResult("%s%u", TclObjectKind::getObjectName(typeid(TclTransformedInrimageView)), inrv->getRef());
  return TCL_OK;
}
/*void TclTransformedInrimageView::init(){
  SliceCamera *sc;
  ObjectsList<Camera2D>::iterator it = getClient()->getScene()->firstCamera();
  for(; it!=getClient()->getScene()->lastCamera(); it++) {
    sc= dynamic_cast<SliceCamera *>(*it);
    if (sc) {
      getModule()->tickle("bind %s <ButtonPress-1> {%s%u -buttonPressed %s%u %%x %%y}", (char *) sc->getInterface()->getCanvas(), 
			  getObjectName(), getRef(), 
			  sc->getInterface()->getTCLObjectName(), sc->getInterface()->getRef());
      getModule()->tickle("bind %s <ButtonRelease-1> {%s%u -buttonReleased %s%u %%x %%y}", (char *) sc->getInterface()->getCanvas(), 
			  getObjectName(), getRef(), 
			  sc->getInterface()->getTCLObjectName(), sc->getInterface()->getRef());
      getModule()->tickle("bind %s <Motion> {%s%u -buttonMotion %s%u %%x %%y}", (char *) sc->getInterface()->getCanvas(), 
			  getObjectName(), getRef(), 
			  sc->getInterface()->getTCLObjectName(), sc->getInterface()->getRef());
    } else COUT << " TclTransformedInrimageView::init() :  Il n'y a pas de SliceCamera dans cette scene ?? " << ENDL;
  }

}
*/

int TclTransformedInrimageView::resetTransformationCmd(int argc, char **argv) {
  if (argc==1) {
    if (!strcmp(argv[0],"translation")) {
      getClient()->getTransformation().setValue(0,3,0);
      getClient()->getTransformation().setValue(1,3,0);
      getClient()->getTransformation().setValue(2,3,0);
      getClient()->redrawBackgrounds();
    setResult("matrix translation reset");
      return TCL_OK;
    }
    else if (!strcmp(argv[0],"rotation")) {
      Matrix4x4<double> &mat=getClient()->getTransformation();
      double scale= mat.getValue(0,0)*mat.getValue(0,0);
      scale+=  mat.getValue(0,1)*mat.getValue(0,1);
      scale+=  mat.getValue(0,2)*mat.getValue(0,2);
      scale=sqrt(scale);
      /// compute the location of the image center
      
      Vec4<double> center(getClient()->getInrimage()->getX()/2.0,
			  getClient()->getInrimage()->getY()/2.0,
			  getClient()->getInrimage()->getZ()/2.0,
			  1.0);
      Vec4<double> res=mat*center -scale*center;
      
      
      mat.setValue(0,0,scale); mat.setValue(2,2,scale); mat.setValue(1,1,scale);
      mat.setValue(0,1,0);  mat.setValue(0,2,0);
      mat.setValue(1,0,0);  mat.setValue(1,2,0);
      mat.setValue(2,0,0);  mat.setValue(2,1,0);
      // set the translation of the image such that center of the image does not change location
      mat.setValue(0,3,res[0]);  mat.setValue(1,3,res[1]); mat.setValue(2,3,res[2]);
      getClient()->redrawBackgrounds();
      setResult("matrix rotation reset");
      return TCL_OK;
    }
    else if (!strcmp(argv[0],"scale")) {
      Matrix4x4<double> &mat=getClient()->getTransformation();
      double scale= mat.getValue(0,0)*mat.getValue(0,0);
      scale+=  mat.getValue(0,1)*mat.getValue(0,1);
      scale+=  mat.getValue(0,2)*mat.getValue(0,2);
      scale=sqrt(scale);

      mat.setValue(0,0, mat.getValue(0,0)/scale);
      mat.setValue(0,1, mat.getValue(0,1)/scale);
      mat.setValue(0,2, mat.getValue(0,2)/scale);
      mat.setValue(1,0, mat.getValue(1,0)/scale);
      mat.setValue(1,1, mat.getValue(1,1)/scale);
      mat.setValue(1,2, mat.getValue(1,2)/scale);
      mat.setValue(2,0, mat.getValue(2,0)/scale);
      mat.setValue(2,1, mat.getValue(2,1)/scale);
      mat.setValue(2,2, mat.getValue(2,2)/scale);
      getClient()->redrawBackgrounds();
      setResult("matrix scale reset");
      return TCL_OK;
    }
    else {
      setResult("%s must be either \"rotation\" \"scale\" or \"translation\"",argv[0]);
      return TCL_ERROR;
    }
  }
  else
    return COMMAND_SYNOPSIS;
}
int TclTransformedInrimageView::scaleTransformationCmd(int argc, char **argv) {
  if (argc==1) {
    double s=(double) atof(argv[0]);
    Matrix4x4<double> mat(s,0,0,0,
			  0,s,0,0,
			  0,0,s,0,
			  0,0,0,1);

    getClient()->getTransformation()*= mat; 
    setResult("matrix scaled");
    return TCL_OK;
  } else if (argc==3) {
    double  sx=(double) atof(argv[0]);
    double  sy=(double) atof(argv[1]);
    double  sz=(double) atof(argv[2]);
    Matrix4x4<double> mat(sx,0,0,0,
			  0,sy,0,0,
			  0,0,sz,0,
			  0,0,0,1);
    getClient()->getTransformation()*= mat;
    getClient()->redrawBackgrounds();
    setResult("matrix scaled");
    return TCL_OK;
  }
  else 
    return COMMAND_SYNOPSIS;
}
int TclTransformedInrimageView::transformationCmd(int argc, char **argv) {
  if (argc==0) {
    TclMatrix4D *mat=new TclMatrix4D(getModule(),getClient()->getTransformation());
    setResult("%s%u",mat->getObjectName(),  mat->getRef());
    return TCL_OK;
  }
  else if (argc==1) { 
    TclMatrix4D *mget = TclMatrix4D::getObject(argc, argv, 0);
    if (mget==0) {
      setResult("could not read %s as a matrix object",argv[0]);
      return TCL_ERROR;
    }
    getClient()->getTransformation()= *((Matrix4x4<double> *)mget);
    getClient()->redrawBackgrounds();
    setResult("new matrix assigned");
    return TCL_OK;
  }
  else if (argc==2) { 
    TclMatrix4D *mget = TclMatrix4D::getObject(argc, argv, 1);
    if (mget==0) {
      setResult("could not read %s as a matrix object",argv[1]);
      return TCL_ERROR;
    }
    if (!strcmp(argv[0],"*")) {
      getClient()->getTransformation()*= *((Matrix4x4<double> *)mget);
    getClient()->redrawBackgrounds();
      setResult("matrix multiplied");
      return TCL_OK;
    }
    else if (!strcmp(argv[0],"+")) {
      getClient()->getTransformation()+= *((Matrix4x4<double> *)mget);
    getClient()->redrawBackgrounds();
      setResult("matrix added");
      return TCL_OK;
    }
    else if (!strcmp(argv[0],"-")) {
      getClient()->getTransformation()-= *((Matrix4x4<double> *)mget);
    getClient()->redrawBackgrounds();
      setResult("matrix substracted");
      return TCL_OK;
    }
    else {
      setResult("unknown matrix operation %s",argv[0]);
      return TCL_ERROR;
    }
  }
  else
    return COMMAND_SYNOPSIS;

}

} // namespace yav
