/******************************************************************************/
/* Tri3x3x3AnisotropYZ.cpp                                                    */
/******************************************************************************/
#include <stdio.h>
#include <math.h>

#ifdef _YAV_
#include "Tri3x3x3AnisotropYZ.h"
using namespace yav;
#else
#include "distancemap/Tri3x3x3AnisotropYZ.h"
#endif // _YAV_

Tri3x3x3AnisotropYZ::Tri3x3x3AnisotropYZ(int _order)
  : MaskTri(_order)
{
  chamferTriElmt a;
  chamferTriElmt b;
  chamferTriElmt c;
  chamferTriElmt a1;
  chamferTriElmt a2;
  chamferTriElmt b1;
  chamferTriElmt b2;

  chamferTriangle t0;
  chamferTriangle t1;
  chamferTriangle t2;
  chamferTriangle t3;
  chamferTriangle t4;
  chamferTriangle t5;

  a.x  = 1; a.y  = 0; a.z  = 0; a.w  = 0;
  b.x  = 1; b.y  = 1; b.z  = 0; b.w  = 0;
  c.x  = 1; c.y  = 1; c.z  = 1; c.w  = 0;
  b1.x = 1; b1.y = 0; b1.z = 1; b1.w = 0;
  a2.x = 0; a2.y = 0; a2.z = 1; a2.w = 0;
  b2.x = 0; b2.y = 1; b2.z = 1; b2.w = 0;
  a1.x = 0; a1.y = 1; a1.z = 0; a1.w = 0;
 
  myElmts.push_back(a);
  myElmts.push_back(b);
  myElmts.push_back(c);
  myElmts.push_back(b1);
  myElmts.push_back(a2);
  myElmts.push_back(b2);
  myElmts.push_back(a1);
  
  t0.A = 0;
  t0.B = 1;
  t0.C = 2;
  t0.Abc = -1; // symetrique dans la triangulation
  t0.Bac = -1; // symetrique dans la triangulation
  t0.Cab = -4; // symetrique par rapport a (P : z = 0)
  t0.whichPlan = 0;

  t1.A = 0;
  t1.B = 2;
  t1.C = 3;
  t1.Abc = -1; // symetrique dans la triangulation
  t1.Bac = -5; // symetrique par rapport a P : (y = 0)
  t1.Cab = -1; // symetrique dans la triangulation
  t1.whichPlan = 0;

  t2.A = 3;
  t2.B = 2;
  t2.C = 4;
  t2.Abc = -1; // symetrique dans la triangulation
  t2.Bac = -5; // symetrique par rapport a P : (y = 0)
  t2.Cab = -1; // symetrique dans la triangulation    
  t2.whichPlan = 2;

  t3.A = 4;
  t3.B = 2;
  t3.C = 5;
  t3.Abc = -1; // symetrique dans la triangulation
  t3.Bac = -6; // symetrique par rapport a P : (x = 0)
  t3.Cab = -1; // symetrique dans la triangulation
  t3.whichPlan = 2;

  t4.A = 2;
  t4.B = 6;
  t4.C = 5;
  t4.Abc = -6; // symetrique par rapport a P (x = 0)
  t4.Bac = -1; // symetrique dans la triangulation
  t4.Cab = -1; // symetrique dans la triangulation
  t4.whichPlan = 1;

  t5.A = 2;
  t5.B = 1;
  t5.C = 6;
  t5.Abc = -4; // symetrique par rapport a P (z = 0)
  t5.Bac = -1; // symetrique dans la triangulation
  t5.Cab = -1; // symetrique dans la triangulation
  t5.whichPlan = 1;

  myTris.push_back(t0);
  myTris.push_back(t1);
  myTris.push_back(t2);
  myTris.push_back(t3);
  myTris.push_back(t4);
  myTris.push_back(t5);

  nbPts = myElmts.size();

}


Tri3x3x3AnisotropYZ::~Tri3x3x3AnisotropYZ()
{
}

unsigned char ***
Tri3x3x3AnisotropYZ::editFinalMask()
{
  chamferTriElmt * elmt;
  MaskTri::editFinalMask();
  
  for(int i = 0; i < nbPts; i++)
    {
      elmt = &(myElmts[i]);
      finalMask[elmt->x][elmt->y][elmt->z] = (unsigned char) elmt->w;
     }
  
  return finalMask;
}


void 
Tri3x3x3AnisotropYZ::printTriangulation()
{
  printf("Toto\n");
}

