/* Fichier Tri3x3x3AnisotropZ.cpp */
#include <stdio.h>
#include <math.h>

#ifdef _YAV_
#include "Tri3x3x3AnisotropZ.h"
using namespace yav;
#else
#include "distancemap/Tri3x3x3AnisotropZ.h"
#endif // _YAV_

Tri3x3x3AnisotropZ::Tri3x3x3AnisotropZ(int _order)
  : MaskTri(_order)
{
  chamferTriElmt a;
  chamferTriElmt b;
  chamferTriElmt c;
  chamferTriElmt aZ;
  chamferTriElmt bZ;

  chamferTriangle t0;
  chamferTriangle t1;
  chamferTriangle t2;

  a.x  = 1; a.y  = 0; a.z  = 0; a.w  = 0;
  b.x  = 1; b.y  = 1; b.z  = 0; b.w  = 0;
  c.x  = 1; c.y  = 1; c.z  = 1; c.w  = 0;
  bZ.x = 1; bZ.y = 0; bZ.z = 1; bZ.w = 0;
  aZ.x = 0; aZ.y = 0; aZ.z = 1; aZ.w = 0;
 
  myElmts.push_back(a);
  myElmts.push_back(b);
  myElmts.push_back(c);
  myElmts.push_back(bZ);
  myElmts.push_back(aZ);
  elmtIt += 5;
  
  t0.A = 0;
  t0.B = 1;
  t0.C = 2;
  t0.Abc = -2; // symetrique par rapport a P : (x = y)
  t0.Bac = -1; // symetrique dans la triangulation
  t0.Cab = -4; // symetrique par rapport a (P : z = 0)
  t0.whichPlan = 0; // projection sur le plan x = 1

  t1.A = 0;
  t1.B = 2;
  t1.C = 3;
  t1.Abc = -1; // symetrique dans la triangulation
  t1.Bac = -5; // symetrique par rapport a P : (y = 0)
  t1.Cab = -1; // symetrique dans la triangulation
  t1.whichPlan = 0; // projection sur le plan x = 1

  t2.A = 3;
  t2.B = 2;
  t2.C = 4;
  t2.Abc = -2; // symetrique par rapport a P : (x = y)
  t2.Bac = -5; // symetrique par rapport a P : (y = 0)
  t2.Cab = -1; // symetrique dans la triangulation
  t2.whichPlan = 2; // projection sur le plan z = 1

  myTris.push_back(t0);
  myTris.push_back(t1);
  myTris.push_back(t2);

  nbPts = myElmts.size();

  //  this->initNC();
}


Tri3x3x3AnisotropZ::~Tri3x3x3AnisotropZ()
{
}

unsigned char ***
Tri3x3x3AnisotropZ::editFinalMask()
{
  chamferTriElmt * elmt;
  MaskTri::editFinalMask();
  
  for(int i = 0; i < nbPts; i++)
    {
      elmt = &(myElmts[i]);
      finalMask[elmt->x][elmt->y][elmt->z] = (unsigned char) elmt->w;
     }
  finalMask[0][1][1] = finalMask[1][0][1];
  finalMask[0][1][0] = finalMask[1][0][0];
  
  return finalMask;
}


void 
Tri3x3x3AnisotropZ::printTriangulation()
{
  printf("Toto\n");
}

