#ifdef _MSC_VER 
#pragma warning ( disable : 4068 4786 4081 ) 
#endif 

#pragma implementation "inrimage/VoxelIterator.h"
#include <inrimage/VoxelIterator.h> 
 
namespace yav { 

  VoxelIteratorObject::VoxelIteratorObject(const VoxelIteratorObject &it) throw (VoxelIteratorObject::OutOfRange) : index(it.index), maxIndex(it.maxIndex)  {
    
  }

  VoxelIteratorObject::VoxelIteratorObject(Inrimage *inr) throw (VoxelIteratorObject::MissingInrimage):index(0) {
    if (inr==0) throw(VoxelIteratorObject::MissingInrimage(" VoxelIteratorObject::VoxelIteratorObject(Inrimage *inr)"));
    index=0;
    maxIndex=inr->getX()*inr->getY()*inr->getZ()*inr->getVdim();
  }
  bool VoxelIteratorObject::operator==(const VoxelIteratorObject &t)const {
    if ((t.getInrimage()==getInrimage()) && (index==t.index))
      return true;
    else
      return false;
  }
  bool VoxelIteratorObject::operator!=(const VoxelIteratorObject &t)const {
    if ((t.getInrimage()==getInrimage()) && (index==t.index))
      return false;
    else
      return true;
  }
  void VoxelIteratorObject::getPosition(unsigned int &x, unsigned int &y, unsigned int &z) {
    unsigned int plane=getInrimage()->getX()*getInrimage()->getY()*getInrimage()->getVdim();
    z= index/plane;
    long int val= index-z*plane;
    x=val%(getInrimage()->getX()*getInrimage()->getVdim());
    y= val/(getInrimage()->getX()*getInrimage()->getVdim());
  }
  unsigned int VoxelIteratorObject::getArraySize() const {
    return getInrimage()->getVdim();
  }


} // namespace yav 
 
