#ifndef BACKGROUNDOVERLAY4DREDRAW_H
#define BACKGROUNDOVERLAY4DREDRAW_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma interface "inrimage/backgroundOverlay4DRedraw.h"
namespace yav {

template <class B> void drawOverlayXT(B,Inrimage4D *inr, 
				      Inrimage4D *inr2, 
				      SliceCamera *slicecam, 
				      unsigned int visible[6],
				      double min, double max,
				      double min2, double max2, 
				      Tk_PhotoImageBlock *block,
				      const unsigned char *redColorMap, 
				      const unsigned char *greenColorMap, 
				      const unsigned char *blueColorMap,
				      const unsigned char *redColorMap2, 
				      const unsigned char *greenColorMap2, 
				      const unsigned char *blueColorMap2,
				      unsigned int sx, double rx, 
				      unsigned int st, double rt, 
				      double opacity){

   unsigned int plane, i, j, x, t,*offset, o;
   register int r1, r2;
   double a1, a2, dr;
   float p = (float) opacity;
   float q = 1-p;  
   Inrimage *im;
   Inrimage *im2;
   
   
   plane = inr->getX() * inr->getY();
   if(slicecam->getGeometry() == SliceCamera::SLICE_ALPHA) {
     o = (((unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice()) % inr->getZ()) * plane;
   }
   else
     o = (unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice() * plane;
   o+=(unsigned int) slicecam->getSlice()*inr->getX();
   
   offset = new unsigned int[sx];
   for(i = 0; i < sx; i++) 
     {
       offset[i] = o+(int) ((double) i / rx) + visible[0];
     }
   
   a1 = (double) max - (double) min;
   if(a1 == 0.0) a1 = 255.0;
   else a1 = 255.0 / a1;
   a2 = (double) max2 - (double) min2;
   if(a2 == 0.0) a2 = 255.0;
   else a2 = 255.0 / a2;

   for(t = 0, j = 0; t < st; t++) {
          i =  ((int) ((double) t / rt) + visible[6]);
	  im=inr->getInrimage(i);
	  im2=inr2->getInrimage(i);
	  for(x = 0; x < sx; x++) {
	    dr = (double) ((B *) im->getData())[offset[x]];
	    if(dr < (double) min) r1 = 0;
	    else if(dr > (double) max) r1 = 256;
	    else r1 = (int) (a1 * (dr - min) + 0.5);
	    
	    dr = (double) ((B *) im2->getData())[offset[x]];
	    if(dr < (double) min2) r2 = 0;
	    else if(dr > (double) max2) r2 = 256;
	    else r2 = (int) (a2 * (dr - min2) + 0.5);
	    
	    block->pixelPtr[j++] = (unsigned char)(p*redColorMap[r1] +q*redColorMap2[r2]);
	    block->pixelPtr[j++] = (unsigned char)(p*greenColorMap[r1] +q*greenColorMap2[r2]);
	    block->pixelPtr[j++] = (unsigned char)(p*blueColorMap[r1] +q*blueColorMap2[r2]);
	  }
   }
   
   delete[] offset;	    
   
}    

template <class B> void drawOverlayXTVector(B,Inrimage4D *inr, 
					    Inrimage4D *inr2, 
					    SliceCamera *slicecam, 
					    unsigned int visible[6],
					    double min, double max,
					    double min2, double max2, 
					    Tk_PhotoImageBlock *block,
					    const unsigned char *redColorMap, 
					    const unsigned char *greenColorMap, 
					    const unsigned char *blueColorMap,
					    const unsigned char *redColorMap2, 
					    const unsigned char *greenColorMap2, 
					    const unsigned char *blueColorMap2,
					    unsigned int sx, double rx, 
					    unsigned int st, double rt, 
					    double opacity){


  unsigned int i, j, x, y,z,t, *offset;
  register int r1, r2;
  double a1, a2, dr, *norm, *norm2;
  float p= (float) opacity;
  float q= 1-p;  

  offset = new unsigned int[sx];
  if(slicecam->getGeometry() == SliceCamera::SLICE_ALPHA) {
    z = (((unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice()) % inr->getZ()) ;
  }
  else
    z = (unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice();

  y= (unsigned int) slicecam->getSlice();

  Inrimage *im;
  Inrimage *im2;
  
  offset = new unsigned int[sx];
  for(i = 0; i < sx; i++) offset[i] = (int) ((double) i / rx);

  j = (visible[3] - visible[0] + 1) * (visible[7] - visible[6] + 1);
  norm = new double[j];
  norm2 = new double[j];
  for(t = visible[6]; t <= visible[7]; t++) {
    im=inr->getInrimage(t);
    im2=inr2->getInrimage(t);
    for(x = visible[0]; x <= visible[3]; x++, norm++) {
      *norm = 0.0;
      *norm2 = 0.0;
      for(i = 0; i < im->getVdim(); i++)
	{
	  *norm += ((B ***) im->getArray())[z][y][x * inr->getVdim() + i]
	    * ((B ***) inr->getArray())[z][y][x * inr->getVdim() + i];
	  *norm2 += ((B ***) im2->getArray())[z][y][x * inr2->getVdim() + i]
	    * ((B ***) inr2->getArray())[z][y][x * inr2->getVdim() + i];
	}
      *norm = sqrt(*norm);
      *norm2 = sqrt(*norm2);
    }
  }
  
  a1 = (double) max - (double) min;
  if(a1 == 0.0) a1 = 255.0;
  else a1 = 255.0 / a1;
  
  a2 = max2 -min2;
  if(a2 == 0.0) a2 = 255.0;
  else a2 = 255.0 / a2;
  
  norm -= j;
  for(t = 0, j = 0; t < st; t++) {
    i = ((int) ((double) t / rt)) * (visible[3] - visible[0] + 1);
    for(x = 0; x < sx; x++) {
      dr = norm[offset[x] + i];
      if(dr < min) r1 = 0;
      else if(dr > max) r1 = 256;
      else r1 = (int) (a1 * (dr - min) + 0.5);

      dr = norm2[offset[x] + i];
      if(dr < min2) r2 = 0;
      else if(dr > max2) r2 = 256;
      else r2 = (int) (a2 * (dr - min2) + 0.5);
      
      block->pixelPtr[j++] = (unsigned char)(p*redColorMap[r1] +q*redColorMap2[r2]);
      block->pixelPtr[j++] = (unsigned char)(p*greenColorMap[r1] +q*greenColorMap2[r2]);
      block->pixelPtr[j++] = (unsigned char)(p*blueColorMap[r1] +q*blueColorMap2[r2]);
      
    }
  }

  delete[] norm;
  delete[] norm2;
  delete[] offset;

}
    




template <class B> void drawOverlayYT(B,Inrimage4D *inr, 
				      Inrimage4D *inr2, 
				      SliceCamera *slicecam, 
				      unsigned int visible[6],
				      double min, double max,
				      double min2, double max2, 
				      Tk_PhotoImageBlock *block,
				      const unsigned char *redColorMap, 
				      const unsigned char *greenColorMap, 
				      const unsigned char *blueColorMap,
				      const unsigned char *redColorMap2, 
				      const unsigned char *greenColorMap2, 
				      const unsigned char *blueColorMap2,
				      unsigned int sy, double ry, 
				      unsigned int st, double rt, 
				      double opacity){

  unsigned int plane, i, j, y,t,*offset, o;
  register int r1, r2;
  double a1, a2, dr;
  float p = (float) opacity;
  float q = 1-p;  
  Inrimage *im;
  Inrimage *im2;
    
     plane = inr->getX() * inr->getY();
    if(slicecam->getGeometry() == SliceCamera::SLICE_ALPHA) {
      o = (((unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice()) % inr->getZ()) * plane;
    }
    else
      o = (unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice() * plane;
    o+=(unsigned int) slicecam->getSlice();
    
    offset = new unsigned int[sy];
    for(i = 0; i < sy; i++) offset[i] = o+
			      ((int) ((double) i / ry) + visible[1])*inr->getX();
    
    a1 = (double) max - (double) min;
    if(a1 == 0.0) a1 = 255.0;
    else a1 = 255.0 / a1;
    a2 = (double) max2 - (double) min2;
    if(a2 == 0.0) a2 = 255.0;
    else a2 = 255.0 / a2;

       for(t = 0, j = 0; t < st; t++) {
	 i =  ((int) ((double) t / rt) + visible[6]);
	 im=inr->getInrimage(i);
	 im2=inr2->getInrimage(i);
	 for(y = 0; y < sy; y++) {
	   dr = (double) ((B *) im->getData())[offset[y]];
	   if(dr < (double) min) r1 = 0;
	   else if(dr > (double) max) r1 = 256;
	   else r1 = (int) (a1 * (dr - min) + 0.5);
	   
	   dr = (double) ((B *) im2->getData())[offset[y]];
	   if(dr < (double) min2) r2 = 0;
	   else if(dr > (double) max2) r2 = 256;
	   else r2 = (int) (a2 * (dr - min2) + 0.5);
	   
	   block->pixelPtr[j++] = (unsigned char)(p*redColorMap[r1] +q*redColorMap2[r2]);
	   block->pixelPtr[j++] = (unsigned char)(p*greenColorMap[r1] +q*greenColorMap2[r2]);
	   block->pixelPtr[j++] = (unsigned char)(p*blueColorMap[r1] +q*blueColorMap2[r2]);
	 }
       }
       delete[] offset;

}

template <class B> void drawOverlayYTVector(B,Inrimage4D *inr, 
					    Inrimage4D *inr2, 
				      SliceCamera *slicecam, 
				      unsigned int visible[6],
				      double min, double max,
				      double min2, double max2, 
				      Tk_PhotoImageBlock *block,
				      const unsigned char *redColorMap, 
				      const unsigned char *greenColorMap, 
				      const unsigned char *blueColorMap,
				      const unsigned char *redColorMap2, 
				      const unsigned char *greenColorMap2, 
				      const unsigned char *blueColorMap2,
				      unsigned int sy, double ry, 
				      unsigned int st, double rt, 
				      double opacity){


  unsigned int i, j, x, y,z,t, *offset;
  register int r1, r2;
  double a1, a2, dr, *norm, *norm2;
  float p= (float) opacity;
  float q= 1-p;  

  offset = new unsigned int[sy];
  if(slicecam->getGeometry() == SliceCamera::SLICE_ALPHA) {
    z = (((unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice()) % inr->getZ()) ;
  }
    else
      z = (unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice();
  x= (unsigned int) slicecam->getSlice();
  
  Inrimage *im;
  Inrimage *im2;
  offset = new unsigned int[sy];
  for(i = 0; i < sy; i++) offset[i] = (int) ((double) i / ry);
  
  j = (visible[4] - visible[1] + 1) * (visible[7] - visible[6] + 1);
  norm = new double[j];
  norm2 = new double[j];
  for(t = visible[6]; t <= visible[7]; t++) {
    im=inr->getInrimage(t);
    im2=inr2->getInrimage(t);
    for(y = visible[1]; y <= visible[4]; y++, norm++) {
      *norm = 0.0;
      *norm2 = 0.0;
      for(i = 0; i < im->getVdim(); i++){
	*norm += ((B ***) im->getArray())[z][y][x * im->getVdim() + i]
	  * ((B ***) inr->getArray())[z][y][x * im->getVdim() + i];
	*norm2 += ((B ***) im2->getArray())[z][y][x * im2->getVdim() + i]
	  * ((B ***) inr2->getArray())[z][y][x * im2->getVdim() + i];
      }
      *norm = sqrt(*norm);
      *norm2 = sqrt(*norm2);
    }
  }
  
  a1 = (double) max - (double) min;
  if(a1 == 0.0) a1 = 255.0;
  else a1 = 255.0 / a1;
  
  a2 = max2 -min2;
  if(a2 == 0.0) a2 = 255.0;
  else a2 = 255.0 / a2;
   for(t = 0, j = 0; t < st; t++) {
    i = ((int) ((double) t / rt)) * (visible[4] - visible[1] + 1);
    for(y = 0; y < sy; y++) {
      dr = norm[offset[y] + i];
      if(dr < min) r1 = 0;
      else if(dr > max) r1 = 256;
      else r1 = (int) (a1 * (dr - min) + 0.5);
       
      dr = norm2[offset[y] + i];
      if(dr < min2) r2 = 0;
      else if(dr > max2) r2 = 256;
      else r2 = (int) (a2 * (dr - min2) + 0.5);

      block->pixelPtr[j++] = (unsigned char)(p*redColorMap[r1] +q*redColorMap2[r2]);
      block->pixelPtr[j++] = (unsigned char)(p*greenColorMap[r1] +q*greenColorMap2[r2]);
      block->pixelPtr[j++] = (unsigned char)(p*blueColorMap[r1] +q*blueColorMap2[r2]);
      
    }
   }
   
   delete[] norm;
   delete[] norm2;
   delete[] offset;
   
}

template <class B> void drawOverlayZT(B,Inrimage4D *inr, 
				      Inrimage4D *inr2, 
				      SliceCamera *slicecam, 
				      unsigned int visible[6],
				      double min, double max,
				      double min2, double max2, 
				      Tk_PhotoImageBlock *block,
				      const unsigned char *redColorMap, 
				      const unsigned char *greenColorMap, 
				      const unsigned char *blueColorMap,
				      const unsigned char *redColorMap2, 
				      const unsigned char *greenColorMap2, 
				      const unsigned char *blueColorMap2,
				      unsigned int sz, double rz, 
				      unsigned int st, double rt, 
				      double opacity){


  unsigned int plane, i, j, z, t,*offset, o;
  register int r1, r2;
  double a1, a2, dr;
  float p = (float) opacity;
  float q = 1-p;  
  Inrimage *im;
  Inrimage *im2;
  
  plane = inr->getX() * inr->getY();
  
  o=(unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice()*inr->getX()+(unsigned int) slicecam->getSlice();
  
  offset = new unsigned int[sz];
  for(i = 0; i < sz; i++) offset[i] = o+
			    ((int) ((double) i / rz) + visible[2])*plane;
  
  a1 = (double) max - (double) min;
  if(a1 == 0.0) a1 = 255.0;
  else a1 = 255.0 / a1;
  a2 = (double) max2 - (double) min2;
  if(a2 == 0.0) a2 = 255.0;
  else a2 = 255.0 / a2;
  for(t = 0, j = 0; t < st; t++) {
    i =  ((int) ((double) t / rt) + visible[6]);
    im=inr->getInrimage(i);
    im2=inr2->getInrimage(i);
    for(z = 0; z < sz; z++) {
      dr = (double) ((B *) im->getData())[offset[z]];
      if(dr < (double) min) r1 = 0;
      else if(dr > (double) max) r1 = 256;
      else r1 = (int) (a1 * (dr - min) + 0.5);

      dr = (double) ((B *) im2->getData())[offset[z]];
      if(dr < (double) min2) r2 = 0;
      else if(dr > (double) max2) r2 = 256;
      else r2 = (int) (a2 * (dr - min2) + 0.5);
   
      block->pixelPtr[j++] = (unsigned char)(p*redColorMap[r1] +q*redColorMap2[r2]);
      block->pixelPtr[j++] = (unsigned char)(p*greenColorMap[r1] +q*greenColorMap2[r2]);
      block->pixelPtr[j++] = (unsigned char)(p*blueColorMap[r1] +q*blueColorMap2[r2]);
    }
  }
  
  delete[] offset;	    
  
}

template <class B> void drawOverlayZTVector(B,Inrimage4D *inr, 
					    Inrimage4D *inr2, 
				      SliceCamera *slicecam, 
				      unsigned int visible[6],
				      double min, double max,
				      double min2, double max2, 
				      Tk_PhotoImageBlock *block,
				      const unsigned char *redColorMap, 
				      const unsigned char *greenColorMap, 
				      const unsigned char *blueColorMap,
				      const unsigned char *redColorMap2, 
				      const unsigned char *greenColorMap2, 
				      const unsigned char *blueColorMap2,
				      unsigned int sz, double rz, 
				      unsigned int st, double rt, 
				      double opacity){

  unsigned int i, j, x, y,z,t, *offset;
  register int r1, r2;
  double a1, a2, dr, *norm, *norm2;
  float p= (float) opacity;
  float q= 1-p;  

  offset = new unsigned int[sz];
  
  x= (unsigned int) slicecam->getSlice();
  y= (unsigned int) ((TimeSliceCamera *)slicecam)->getSecondSlice();
  
  Inrimage *im;
  Inrimage *im2;
  for(i = 0; i < sz; i++) offset[i] = (int) ((double) i / rz);
  
  j = (visible[5] - visible[2] + 1) * (visible[7] - visible[6] + 1);
  norm = new double[j];
  norm2 = new double[j];
  for(t = visible[6]; t <= visible[7]; t++) {
    im=inr->getInrimage(t);
    im2=inr2->getInrimage(t);
    for(z = visible[2]; y <= visible[5]; z++, norm++) {
      *norm = 0.0;
      *norm2 = 0.0;
      for(i = 0; i < im->getVdim(); i++){
	*norm += ((B ***) im->getArray())[z][y][x * im->getVdim() + i]
	  * ((B ***) inr->getArray())[z][y][x * im->getVdim() + i];
	*norm2 += ((B ***) im2->getArray())[z][y][x * im2->getVdim() + i]
	  * ((B ***) inr2->getArray())[z][y][x * im2->getVdim() + i];
      }
      *norm = sqrt(*norm);
      *norm2 = sqrt(*norm2);
    }
  }

    a1 = (double) max - (double) min;
  if(a1 == 0.0) a1 = 255.0;
  else a1 = 255.0 / a1;
  
  a2 = max2 -min2;
  if(a2 == 0.0) a2 = 255.0;
  else a2 = 255.0 / a2;
  
  norm -= j;
  for(t = 0, j = 0; t < st; t++) {
    i = ((int) ((double) t / rt)) * (visible[5] - visible[2] + 1);
    for(z = 0; z < sz; z++) {
      dr = norm[offset[z] + i];
      if(dr < min) r1 = 0;
      else if(dr > max) r1 = 256;
      else r1 = (int) (a1 * (dr - min) + 0.5);
      dr = norm2[offset[z] + i];
      if(dr < min2) r2 = 0;
      else if(dr > max2) r2 = 256;
      else r2 = (int) (a2 * (dr - min2) + 0.5);

      block->pixelPtr[j++] = (unsigned char)(p*redColorMap[r1] +q*redColorMap2[r2]);
      block->pixelPtr[j++] = (unsigned char)(p*greenColorMap[r1] +q*greenColorMap2[r2]);
      block->pixelPtr[j++] = (unsigned char)(p*blueColorMap[r1] +q*blueColorMap2[r2]);
      
    }
  }
  
  delete[] norm;
  delete[] norm2;
  delete[] offset;
  
}

}
#endif
