#ifndef TCLOVERLAYINRIMAGE4DVIEW_H
#define TCLOVERLAYINRIMAGE4DVIEW_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma interface "inrimage/TclOverlayInrimage4DView.h"
#include <inrimage/TclInrimage4DView.h>
#include <inrimage/OverlayInrimage4DView.h>

namespace yav {

/** \class TclOverlayInrimage4DView
    \ingroup Inrimage
*/
class TclOverlayInrimage4DView : public TclInrimage4DView {
  /** @name constructors */
  //@{
  /** builds object client from an inrimage then this interface
      @param m module this object is built in
      @param inr displayed inrimage
      @param inr2 second displayed inrimage
      @param scene scene to build client in */
  TclOverlayInrimage4DView(TclModule *m, TclInrimage4D *inr,TclInrimage4D *inr2, 
			 TclScene2D *scene, bool _createGLScale);
  //@}

 public:
  /** @name desstructors */
  //@{
  /// destroys client and interface
  virtual ~TclOverlayInrimage4DView(){}
  //@}

  /// returns client
  OverlayInrimage4DView *getClient() const {
    return((OverlayInrimage4DView *)client);
  }
  /// returns the tcl overlay inrimage background interface attached to a given slicecam
  TclOverlayInrimage4DBackground *getInrimage4DBackground(TimeSliceCamera *cam) const;

  /// TCL object creation function
  static int create(TclModule *m, int argc, char **argv);
  /// -secondInrimage TCL option
  int secondInrimageCmd(int argc, char **argv);
};

} // namespace yav

#endif
