#ifndef TCLOVERLAYINRIMAGEVIEW_H
#define TCLOVERLAYINRIMAGEVIEW_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma interface "inrimage/TclOverlayInrimageView.h"
#include <inrimage/TclInrimageView.h>
#include <inrimage/OverlayInrimageView.h>

namespace yav {

/** \class TclOverlayInrimageView
    \ingroup Inrimage
*/
class TclOverlayInrimageView : public TclInrimageView {
  /** @name constructors */
  //@{
  /** builds object client from an inrimage then this interface
      @param m module this object is built in
      @param inr displayed inrimage
      @param inr2 second displayed inrimage
      @param scene scene to build client in */
  TclOverlayInrimageView(TclModule *m, TclInrimage *inr,TclInrimage *inr2, 
			 TclScene2D *scene, bool _createGLScale);
  //@}

 public:
  /** @name destructors */
  //@{
  /// destroys client and interface
  virtual ~TclOverlayInrimageView(){}
  //@}


  /// returns client
  OverlayInrimageView *getClient() const {
    return((OverlayInrimageView *)client);
  }
  /// returns the tcl overlay inrimage background interface attached to a given slicecam
  TclOverlayInrimageBackground *getInrimageBackground(SliceCamera *cam) const {
    return  (TclOverlayInrimageBackground *)
      getClient()->getBackgroundFromCamera(cam); }

  /// TCL object creation function
  static int create(TclModule *m, int argc, char **argv);
  /// -secondInrimage TCL option
  int secondInrimageCmd(int argc, char **argv);
};

} // namespace yav

#endif
