#ifndef TCLSTRUCTURINGELEMENT_H
#define TCLSTRUCTURINGELEMENT_H


#pragma interface "inrimage/TclStructuringElement.h"

#include <modules/TclObject.h>
#include <inrimage/StructuringElement.h>

namespace yav {


  /** Tcl interface for any StructuringElement  */
  
  /** \class TclStructuringElement
      \ingroup Inrimage
  */
  class TclStructuringElement :  public TclObject, public StructuringElement
    {
    public:
      /** @name constructors */
      //@{
      /** 
      */
      //      TclStructuringElement(const std::type_info& info, TclModule *m);
      /**
      */
      /*TclStructuringElement(const std::type_info& info, TclModule *m, StructuringElement *StructElem) throw( TclStructuringElement::InvalidElement );*/
      /** 
       */
      /*TclStructuringElement(const std::type_info& info, TclModule *m, const CONNECTIVITY_TYPE C=TWENTY_SIX_CONNECTIVITY) throw( InvalidElement );*/
      /** 
      */
      /*TclStructuringElement(const std::type_info& info, TclModule *m, const int x, const int y, const int z = 1) throw( InvalidElement );*/
      /** 
       */
      /*TclStructuringElement(const std::type_info& info, TclModule *m, const char *name ) throw( InvalidElement );*/
      /** 
       */
      TclStructuringElement(const std::type_info& info, TclModule *m, const Inrimage *image) throw(InvalidElement );
      
      //@}

      /** @name destructor */
      //@{
      // 
      virtual ~TclStructuringElement();
      //@}

      // return object by ref or 0 if it is not found
      static TclStructuringElement *getObject(unsigned int n) {
	return dynamic_cast<TclStructuringElement*>(TclObjectKind::getObject(typeid(TclStructuringElement), n));
      }
      
      // return object by name (argv[i]) or 0 with an error message
      // in module interpretor if it is not found
      static TclStructuringElement *getObject(int argc, char **argv, int i = 1) {
	return
	  dynamic_cast<TclStructuringElement *>(TclObjectKind::getObject(typeid(TclStructuringElement), argc, argv, i));
      }
      
      // return object id by command line arguments
      static const char *getTCLObjectName(void) {
	return TclObjectKind::getObjectName(typeid(TclStructuringElement));
      }
      
      // return object id by command line arguments
      static int list(TclModule *m, int argc, char **argv) {
	return TclObject::list(m, argc, argv);
      }
      
      /// createMatrix command callback
      static int create(TclModule *m, int argc, char **argv);
      
      
    };



} // namespace yav



#endif // STRUCTURINGELEMENT_H
