#ifndef TCLTRANSFORMEDINRIMAGEVIEW_H
#define TCLTRANSFORMEDINRIMAGEVIEW_H

#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma interface "inrimage/TclTransformedInrimageView.h"
#include <inrimage/TclInrimageView.h>
#include <inrimage/TransformedInrimageView.h>

namespace yav {

  /** \class TclTransformedInrimageView
      \ingroup Inrimage
  */
  class TclTransformedInrimageView : public TclInrimageView {
  /** @name constructors */
  //@{
  /** builds object client from an inrimage then this interface
      @param m module this object is built in
      @param inr displayed inrimage
      @param scene scene to build client in */
  TclTransformedInrimageView(TclModule *m, TclInrimage *inr,
			 TclScene2D *scene, bool _createGLScale);
  //@}

 public:
  /** @name destructors */
  //@{
  /// destroys client and interface
  virtual ~TclTransformedInrimageView(){}
  //@}


  /// returns client
  TransformedInrimageView *getClient() const {
    return((TransformedInrimageView *)client);
  }
  /// returns the tcl transformed inrimage background interface attached to a given slicecam
  TclTransformedInrimageBackground *getInrimageBackground(SliceCamera *cam) const {
    return  (TclTransformedInrimageBackground *)
      getClient()->getBackgroundFromCamera(cam); }

  /// TCL object creation function
  static int create(TclModule *m, int argc, char **argv);
  /// -transformation TCL option
  int transformationCmd(int argc, char **argv);
  /// -scaleTransformation TCL option
  int scaleTransformationCmd(int argc, char **argv);
  /// -resetTransformation TCL option
  int resetTransformationCmd(int argc, char **argv);
};

} // namespace yav

#endif
