#ifndef CONNECTIVITY_H
#define CONNECTIVITY_H

namespace yav {

/// The type of connectivity ( or neighborhood ) for a 2D and 3D image
  enum CONNECTIVITY_TYPE { 
    /** Four connectivity : the voxels sharing an edge
        in the same plane are considered as neighbors */
    FOUR_CONNECTIVITY = 4,
    /** Eight connectivity : the voxels sharing a vertex
        in the same plane are considered as neighbors */
     EIGHT_CONNECTIVITY = 8,

    /** Six connectivity : the voxels sharing a face
        in 3D are considered as neighbors */
    SIX_CONNECTIVITY = 6,
    /** Ten connectivity : the voxels sharing a vertex
        in the same plane, or a face in adjacent planes,
	are considered as neighbors */
    TEN_CONNECTIVITY = 10,
    /** Eighteen connectivity : the voxels sharing
        an edge in 3D are considered as neighbors */
    EIGHTEEN_CONNECTIVITY = 18,
    /** Twenty six connectivity : the voxels
        sharing a vertex in 3D are considered as neighbors */
    TWENTY_SIX_CONNECTIVITY = 26
  };

}

#endif


