/***************************************************************************\
|* Function parser class                                                   *|
|* ---------------------                                                   *|
|* Parses and evaluates the given funtion with the given variable values.  *|
|* ! Does not have any operator priorities                                 *|
\***************************************************************************/

#ifndef ONCE_FPARSER_H_
#define ONCE_FPARSER_H_

namespace yav {

class Var_list
{
 public:
	Var_list *next;    
	char name[255]; 
        void* im;
} ;

class FunctionParser
{
public:
    int Parse(const char* Function,Var_list *Vars,int mx,int my,int mz);
    const char* ErrorMsg(void);
    double Eval(double x=0,...);
    double Eval(double* Vars);
    inline int EvalError(void) { return EvalErrorType; }


    FunctionParser();
    ~FunctionParser();

private:
    int VarAmnt,ParseErrorType,EvalErrorType,sx,sy,sz;
    Var_list* Variable;
    struct Comp
    {  Comp();
        ~Comp();
        unsigned char* ByteCode;
        unsigned ByteCodeSize;
        double* Immed;
        unsigned ImmedSize;
        double* Stack;
        unsigned StackSize, StackPtr;
    } Comp;
    int CheckSyntax(char*);
    bool Compile(char*);
    void CompileSubstr(char*,int,int);
    bool IsVariable(int);
    unsigned char MathItemNumber(char* F);
    void AddCompiledByte(unsigned char);
};

}

#endif
