#include "preDefinedMasks.h"

namespace yav
{
  preDefinedMasks::preDefinedMasks()
  {
    initPredefinedMasks();
  }
  
  preDefinedMasks::~preDefinedMasks()
  {
    deletePredefinedMasks();
  }
  
  void preDefinedMasks::initPredefinedMasks()
  {
    int i, j;
    
    /* chamfer2D3x3 */
    chamfer2D3x3 = new unsigned char *[2];
    for (i = 0; i < 2; i++)
      chamfer2D3x3[i] = new unsigned char[2];
    
    chamfer2D3x3Init = new unsigned char *[2];
    for (i = 0; i < 2; i++)
      chamfer2D3x3Init[i] = new unsigned char[2];
    
    
    /* chamfer2D5x5 */
    chamfer2D5x5 = new unsigned char *[3];
    for (i = 0; i < 3; i++)
      chamfer2D5x5[i] = new unsigned char[3];
    
    chamfer2D5x5Init = new unsigned char *[2];
    for (i = 0; i < 2; i++)
      chamfer2D5x5Init[i] = new unsigned char[2];
    
    
    /* chamfer2D7x7 */
    chamfer2D7x7 = new unsigned char *[4];
    for (i = 0; i < 4; i++)
      chamfer2D7x7[i] = new unsigned char[4];
    
    chamfer2D7x7Init = new unsigned char *[2];
    for (i = 0; i < 2; i++)
      chamfer2D7x7Init[i] = new unsigned char[2];
    
    
    /* chamfer3D3x3x3 */
    chamfer3D3x3x3 = new unsigned char **[2];
    for (i = 0; i < 2; i++)
    {
      chamfer3D3x3x3[i] = new unsigned char *[2];
      for (j = 0; j < 2; j++)
        chamfer3D3x3x3[i][j] = new unsigned char [2];
    }
    
    chamfer3D3x3x3Init = new unsigned char **[2];
    for (i = 0; i < 2; i++)
    {
      chamfer3D3x3x3Init[i] = new unsigned char *[2];
      for (j = 0; j < 2; j++)
        chamfer3D3x3x3Init[i][j] = new unsigned char [2];
    }
    
    
    /* chamfer3D5x5x5 */
    chamfer3D5x5x5 = new unsigned char **[3];
    for (i = 0; i < 3; i++)
    {
      chamfer3D5x5x5[i] = new unsigned char *[3];
      for (j = 0; j < 3; j++)
        chamfer3D5x5x5[i][j] = new unsigned char [3];
    }
    
    chamfer3D5x5x5Init = new unsigned char **[2];
    for (i = 0; i < 2; i++)
    {
      chamfer3D5x5x5Init[i] = new unsigned char *[2];
      for (j = 0; j < 2; j++)
        chamfer3D5x5x5Init[i][j] = new unsigned char [2];
    }
    
    
    /* chamfer3D7x7x7  */
    chamfer3D7x7x7 = new unsigned char **[4];
    for (i = 0; i < 4; i++)
    {
      chamfer3D7x7x7[i] = new unsigned char *[4];
      for (j = 0; j < 4; j++)
        chamfer3D7x7x7[i][j] = new unsigned char [4];
    }
    
    chamfer3D7x7x7Init = new unsigned char **[2];
    for (i = 0; i < 2; i++)
    {
      chamfer3D7x7x7Init[i] = new unsigned char *[2];
      for (j = 0; j < 2; j++)
        chamfer3D7x7x7Init[i][j] = new unsigned char [2];
    }
    
    /* Mask 2D 3x3 */  
    epsilon2D3x3 = 6.14512f;
    maxRelErr2D3x3 = 0.079446f;
    chamfer2D3x3[0][0] = 0;               // (does not exist) 
    chamfer2D3x3[1][0] = 6;               // = 3 * 2
    chamfer2D3x3[0][1] = 6;               // = 3 * 2
    chamfer2D3x3[1][1] = 8;               // = 4 * 2
    // 2D 3x3 corresponding initialization mask
    chamfer2D3x3Init[0][0] = 0;           // (does not exist)
    chamfer2D3x3Init[1][0] = 3;           // chamfer2D3x3[1][0] * 1/2
    chamfer2D3x3Init[0][1] = 3;           // chamfer2D3x3[0][1] * 1/2
    chamfer2D3x3Init[1][1] = 4;           // chamfer2D3x3[1][1] * 1/2
  
  
    /* Mask 2D 5x5 */
    epsilon2D5x5 = 60.386264f;
    maxRelErr2D5x5 = 0.039993f;
    chamfer2D5x5[0][0] = 0;               // (does not exist)
    chamfer2D5x5[1][0] = 58;              // = 29 * 2
    chamfer2D5x5[2][0] = 0;               // (does not exist)
    chamfer2D5x5[0][1] = 58;              // = 29 * 2
    chamfer2D5x5[1][1] = 82;              // = 41 * 2
    chamfer2D5x5[2][1] = 140;             // = 70 * 2
    chamfer2D5x5[0][2] = 0;               // (does not exist)
    chamfer2D5x5[1][2] = 140;             // = 70 * 2
    chamfer2D5x5[2][2] = 0;               // (does not exist)
    // 2D 5x5 corresponding initialization mask
    chamfer2D5x5Init[0][0] = 0;           // (does not exist)
    chamfer2D5x5Init[1][0] = 29;          // chamfer2D5x5[1][0] * 1/2  
    chamfer2D5x5Init[0][1] = 29;          // chamfer2D5x5[0][1] * 1/2
    chamfer2D5x5Init[1][1] = 41;          // chamfer2D5x5[1][1] * 1/2
  
  
    /* Mask 2D 7x7 */
    epsilon2D7x7 = 22.533548f;
    maxRelErr2D7x7 = 0.027431f;
    chamfer2D7x7[0][0] = 0;               // (does not exist)
    chamfer2D7x7[1][0] = 22;              // = 11 * 2
    chamfer2D7x7[2][0] = 0;               // (does not exist)
    chamfer2D7x7[3][0] = 0;               // (does not exist)
  
    chamfer2D7x7[0][1] = 22;              // = 11 * 2
    chamfer2D7x7[1][1] = 32;              // = 16 * 2
    chamfer2D7x7[2][1] = 50;              // = 25 * 2
    chamfer2D7x7[3][1] = 72;              // = 36 * 2
  
    chamfer2D7x7[0][2] = 0;               // (does not exist)
    chamfer2D7x7[1][2] = 50;              // = 25 * 2
    chamfer2D7x7[2][2] = 0;               // (does not exist)
    chamfer2D7x7[3][2] = 82;              // = 41 * 2
  
    chamfer2D7x7[0][3] = 0;               // (does not exist)
    chamfer2D7x7[1][3] = 72;              // = 36 * 2
    chamfer2D7x7[2][3] = 82;              // = 41 * 2
    chamfer2D7x7[3][3] = 0;               // (does not exist)
  
    // 2D 5x5 corresponding initialization mask
    chamfer2D7x7Init[0][0] = 0;
    chamfer2D7x7Init[1][0] = 11;
    chamfer2D7x7Init[0][1] = 11;
    chamfer2D7x7Init[1][1] = 16;
  
  
  
    /* Mask 3D 3x3x3 */
    epsilon3D3x3x3 = 8.582576f;
    maxRelErr3D3x3x3 = 0.067879f;
    chamfer3D3x3x3[0][0][0] = 0;          // (does not exist)
    chamfer3D3x3x3[1][0][0] = 8;          // = 4 * 2
    chamfer3D3x3x3[0][1][0] = 8;          // = 4 * 2
    chamfer3D3x3x3[0][0][1] = 8;          // = 4 * 2
    chamfer3D3x3x3[1][1][0] = 12;         // = 6 * 2
    chamfer3D3x3x3[1][0][1] = 12;         // = 6 * 2
    chamfer3D3x3x3[0][1][1] = 12;         // = 6 * 2
    chamfer3D3x3x3[1][1][1] = 14;         // = 7 * 2
    // 3D 3x3x3 corresponding initialization mask
    chamfer3D3x3x3Init[0][0][0] = 0;      // (does not exist)
    chamfer3D3x3x3Init[1][0][0] = 4;      // chamfer3D3x3x3[1][0][0] * 1/2
    chamfer3D3x3x3Init[0][1][0] = 4;      // chamfer3D3x3x3[0][1][0] * 1/2
    chamfer3D3x3x3Init[0][0][1] = 4;      // chamfer3D3x3x3[0][0][1] * 1/2
    chamfer3D3x3x3Init[1][1][0] = 6;      // chamfer3D3x3x3[1][1][0] * 1/2
    chamfer3D3x3x3Init[1][0][1] = 6;      // chamfer3D3x3x3[1][0][1] * 1/2
    chamfer3D3x3x3Init[0][1][1] = 6;      // chamfer3D3x3x3[0][1][1] * 1/2
    chamfer3D3x3x3Init[1][1][1] = 7;      // chamfer3D3x3x3[1][1][1] * 1/2
  
  
  
    /* Mask 3D 5x5x5 */
    epsilon3D5x5x5 = 60.386264f;
    maxRelErr3D5x5x5 = 0.039993f;
    chamfer3D5x5x5[0][0][0] = 0;          // (does not exist)
    chamfer3D5x5x5[1][0][0] = 58;         // = 29 * 2
    chamfer3D5x5x5[2][0][0] = 0;          // (does not exist)
  
    chamfer3D5x5x5[0][1][0] = 58;         // = 29 * 2
    chamfer3D5x5x5[1][1][0] = 82;         // = 41 * 2
    chamfer3D5x5x5[2][1][0] = 140;        // = 70 * 2
  
    chamfer3D5x5x5[0][2][0] = 0;          // (does not exist)
    chamfer3D5x5x5[1][2][0] = 140;        // = 70 * 2
    chamfer3D5x5x5[2][2][0] = 0;          // (does not exist)
  
    chamfer3D5x5x5[0][0][1] = 58;         // = 29 * 2
    chamfer3D5x5x5[1][0][1] = 82;         // = 41 * 2
    chamfer3D5x5x5[2][0][1] = 140;        // = 70 * 2
    
    chamfer3D5x5x5[0][1][1] = 82;         // = 41 * 2
    chamfer3D5x5x5[1][1][1] = 102;        // = 51 * 2
    chamfer3D5x5x5[2][1][1] = 142;        // = 71 * 2
  
    chamfer3D5x5x5[0][2][1] = 140;        // = 70 * 2
    chamfer3D5x5x5[1][2][1] = 142;        // = 71 * 2
    chamfer3D5x5x5[2][2][1] = 174;        // = 87 * 2
  
    chamfer3D5x5x5[0][0][2] = 0;          // (does not exist)
    chamfer3D5x5x5[1][0][2] = 140;        // = 70 * 2
    chamfer3D5x5x5[2][0][2] = 0;          // (does not exist)
  
    chamfer3D5x5x5[0][1][2] = 140;        // = 70 * 2
    chamfer3D5x5x5[1][1][2] = 142;        // = 71 * 2
    chamfer3D5x5x5[2][1][2] = 174;        // = 87 * 2
  
    chamfer3D5x5x5[0][2][2] = 0;          // (does not exist)
    chamfer3D5x5x5[1][2][2] = 174;        // = 87 * 2
    chamfer3D5x5x5[2][2][2] = 0;          // (does not exist)
  
    // 3D 3x3x3 corresponding initialization mask
    chamfer3D5x5x5Init[0][0][0] = 0;      // (does not exist)
    chamfer3D5x5x5Init[1][0][0] = 29;     // chamfer3D5x5x5[1][0][0] * 1/2
    chamfer3D5x5x5Init[0][1][0] = 29;     // chamfer3D5x5x5[0][1][0] * 1/2
    chamfer3D5x5x5Init[0][0][1] = 29;     // chamfer3D5x5x5[0][0][1] * 1/2
    chamfer3D5x5x5Init[1][1][0] = 41;     // chamfer3D5x5x5[1][1][0] * 1/2
    chamfer3D5x5x5Init[1][0][1] = 41;     // chamfer3D5x5x5[1][0][1] * 1/2
    chamfer3D5x5x5Init[0][1][1] = 41;     // chamfer3D5x5x5[0][1][1] * 1/2
    chamfer3D5x5x5Init[1][1][1] = 51;     // chamfer3D5x5x5[1][1][1] * 1/2
  
  
    /* Mask 3D 7x7x7 */
    epsilon3D7x7x7 = 60.386264f;
    maxRelErr3D7x7x7 = 0.039993f;
  
    chamfer3D7x7x7[0][0][0] = 0;          // (does not exist)
    chamfer3D7x7x7[1][0][0] = 22;         // = 11 * 2
    chamfer3D7x7x7[2][0][0] = 0;          // (does not exist)
    chamfer3D7x7x7[3][0][0] = 0;          // (does not exist)
  
    chamfer3D7x7x7[0][1][0] = 22;         // = 11 * 2
    chamfer3D7x7x7[1][1][0] = 32;         // = 16 * 2
    chamfer3D7x7x7[2][1][0] = 50;         // = 25 * 2
    chamfer3D7x7x7[3][1][0] = 72;         // = 36 * 2
  
    chamfer3D7x7x7[0][2][0] = 0;          // (does not exist)
    chamfer3D7x7x7[1][2][0] = 50;         // = 25 * 2
    chamfer3D7x7x7[2][2][0] = 0;          // (does not exist)
    chamfer3D7x7x7[3][2][0] = 82;         // = 41 * 2
  
    chamfer3D7x7x7[0][3][0] = 0;          // (does not exist)
    chamfer3D7x7x7[1][3][0] = 72;         // = 36 * 2
    chamfer3D7x7x7[2][3][0] = 82;         // = 41 * 2        
    chamfer3D7x7x7[3][3][0] = 0;          // (does not exist)
  
    chamfer3D7x7x7[0][0][1] = 22;         // = 11 * 2        
    chamfer3D7x7x7[1][0][1] = 32;         // = 16 * 2
    chamfer3D7x7x7[2][0][1] = 50;         // = 25 * 2        
    chamfer3D7x7x7[3][0][1] = 72;         // = 36 * 2        
  
    chamfer3D7x7x7[0][1][1] = 32;         // = 16 * 2
    chamfer3D7x7x7[1][1][1] = 40;         // = 20 * 2
    chamfer3D7x7x7[2][1][1] = 54;         // = 27 * 2
    chamfer3D7x7x7[3][1][1] = 76;         // = 38 * 2
  
    chamfer3D7x7x7[0][2][1] = 50;         // = 25 * 2        
    chamfer3D7x7x7[1][2][1] = 54;         // = 27 * 2
    chamfer3D7x7x7[2][2][1] = 68;         // = 34 * 2        
    chamfer3D7x7x7[3][2][1] = 82;         // = 41 * 2
  
    chamfer3D7x7x7[0][3][1] = 72;         // = 36 * 2        
    chamfer3D7x7x7[1][3][1] = 76;         // = 38 * 2
    chamfer3D7x7x7[2][3][1] = 82;         // = 41 * 2        
    chamfer3D7x7x7[3][3][1] = 96;         // = 48 * 2
  
    chamfer3D7x7x7[0][0][2] = 0;          // (does not exist)
    chamfer3D7x7x7[1][0][2] = 50;         // = 25 * 2
    chamfer3D7x7x7[2][0][2] = 0;          // (does not exist)
    chamfer3D7x7x7[3][0][2] = 82;         // = 41 * 2        
  
    chamfer3D7x7x7[0][1][2] = 50;         // = 25 * 2
    chamfer3D7x7x7[1][1][2] = 54;         // = 27 * 2
    chamfer3D7x7x7[2][1][2] = 68;         // = 34 * 2
    chamfer3D7x7x7[3][1][2] = 82;         // = 41 * 2
  
    chamfer3D7x7x7[0][2][2] = 0;          // (does not exist)
    chamfer3D7x7x7[1][2][2] = 68;         // = 34 * 2
    chamfer3D7x7x7[2][2][2] = 0;          // (does not exist)
    chamfer3D7x7x7[3][2][2] = 94;         // = 47 * 2
  
    chamfer3D7x7x7[0][3][2] = 82;         // = 41 * 2        
    chamfer3D7x7x7[1][3][2] = 82;         // = 41 * 2
    chamfer3D7x7x7[2][3][2] = 94;         // = 47 * 2        
    chamfer3D7x7x7[3][3][2] = 108;        // = 54 * 2
  
    chamfer3D7x7x7[0][0][3] = 0;          // (does not exist)
    chamfer3D7x7x7[1][0][3] = 72;         // = 36 * 2
    chamfer3D7x7x7[2][0][3] = 82;         // = 41 * 2         
    chamfer3D7x7x7[3][0][3] = 0;          // (does not exist)
  
    chamfer3D7x7x7[0][1][3] = 72;         // = 36 * 2
    chamfer3D7x7x7[1][1][3] = 76;         // = 38 * 2
    chamfer3D7x7x7[2][1][3] = 82;         // = 41 * 2
    chamfer3D7x7x7[3][1][3] = 96;         // = 48 * 2
  
    chamfer3D7x7x7[0][2][3] = 82;         // = 41 * 2        
    chamfer3D7x7x7[1][2][3] = 82;         // = 41 * 2
    chamfer3D7x7x7[2][2][3] = 94;         // = 47 * 2        
    chamfer3D7x7x7[3][2][3] = 108;        // = 54 * 2
  
    chamfer3D7x7x7[0][3][3] = 0;          // (does not exist)
    chamfer3D7x7x7[1][3][3] = 96;         // = 48 * 2
    chamfer3D7x7x7[2][3][3] = 108;        // = 54 * 2        
    chamfer3D7x7x7[3][3][3] = 0;          // (does not exist)
    
    // 3D 3x3x3 corresponding initialization mask
    chamfer3D7x7x7Init[0][0][0] = 0;      // (does not exist)
    chamfer3D7x7x7Init[1][0][0] = 11;     // chamfer3D7x7x7[1][0][0] * 1/2
    chamfer3D7x7x7Init[0][1][0] = 11;     // chamfer3D7x7x7[0][1][0] * 1/2
    chamfer3D7x7x7Init[0][0][1] = 11;     // chamfer3D7x7x7[0][0][1] * 1/2
    chamfer3D7x7x7Init[1][1][0] = 16;     // chamfer3D7x7x7[1][1][0] * 1/2
    chamfer3D7x7x7Init[1][0][1] = 16;     // chamfer3D7x7x7[1][0][1] * 1/2
    chamfer3D7x7x7Init[0][1][1] = 16;     // chamfer3D7x7x7[0][1][1] * 1/2
    chamfer3D7x7x7Init[1][1][1] = 20;     // chamfer3D7x7x7[1][1][1] * 1/2
  
  }

  void preDefinedMasks::deletePredefinedMasks()
  {
    int i, j;
  
    /* chamfer2D3x3 */
    for (i = 0; i < 2; i++)
      delete[] chamfer2D3x3[i];
    delete[] chamfer2D3x3;
  
    for (i = 0; i < 2; i++)
      delete[] chamfer2D3x3Init[i];
    delete[] chamfer2D3x3Init;
  
  
    /* chamfer2D5x5 */
    for (i = 0; i < 3; i++)
      delete[] chamfer2D5x5[i]; 
    delete[] chamfer2D5x5;
  
    for (i = 0; i < 2; i++)
      delete[] chamfer2D5x5Init[i];
    delete[] chamfer2D5x5Init;
  
    /* chamfer2D7x7 */
    for (i = 0; i < 4; i++)
      delete[] chamfer2D7x7[i];
    delete[] chamfer2D7x7;
  
    for (i = 0; i < 2; i++)
      delete[] chamfer2D7x7Init[i];
    delete[] chamfer2D7x7Init;
  
    /* chamfer3D3x3x3 */
    for (i = 0; i < 2; i++) {
      for (j = 0; j < 2; j++)
        delete[] chamfer3D3x3x3[i][j];
      delete[] chamfer3D3x3x3[i];
    }
    delete[] chamfer3D3x3x3;
  
    for (i = 0; i < 2; i++) {
      for (j = 0; j < 2; j++)
        delete[] chamfer3D3x3x3Init[i][j];
      delete[] chamfer3D3x3x3Init[i];
    }
    delete[] chamfer3D3x3x3Init;
  
    /* chamfer3D5x5x5 */
    for (i = 0; i < 3; i++) {
      for (j = 0; j < 3; j++)
        delete[] chamfer3D5x5x5[i][j];
      delete[] chamfer3D5x5x5[i];
    }
    delete[] chamfer3D5x5x5;
  
    for (i = 0; i < 2; i++) {
      for (j = 0; j < 2; j++)
        delete[] chamfer3D5x5x5Init[i][j];
      delete[] chamfer3D5x5x5Init[i];
    }
    delete[] chamfer3D5x5x5Init;
  
    /* chamfer3D7x7x7 */
    for (i = 0; i < 4; i++) {
      for (j = 0; j < 4; j++)
        delete[] chamfer3D7x7x7[i][j];
      delete[] chamfer3D7x7x7[i];
    }
    delete[] chamfer3D7x7x7;
  
    for (i = 0; i < 2; i++) {
      for (j = 0; j < 2; j++)
        delete[] chamfer3D7x7x7Init[i][j];
      delete[] chamfer3D7x7x7Init[i];
    }
    delete[] chamfer3D7x7x7Init;  
  }

};
