#ifdef _MSC_VER
#pragma warning ( disable : 4068 4786 4081 )
#endif

#pragma implementation "inrimage/resample.h"


#include <_reech.C>

/* Fichier contenant les conversions de buffer */
#include <_convert.h>
#include <_cspline.h>


namespace yav {

Inrimage *resample4x4Nearest ( Inrimage *theBuf, Matrix4x4<double> &m, Inrimage::WORD_TYPE wt, unsigned int xdim, unsigned int ydim, unsigned int zdim, double vx, double vy, double vz, bool twoD, float gain, float bias ) {
 
  
  Inrimage *resBuf = new Inrimage(xdim, ydim, zdim, wt, 1, VM_SCALAR, (float)vx, (float)vy, (float)vz);
  resample4x4Nearest(theBuf, resBuf,m, twoD, gain, bias);
  return (resBuf);
}
  


void resample4x4Nearest ( Inrimage *theBuf, Inrimage *resBuf,Matrix4x4<double> &m, bool twoD, float gain, float bias ) {
  
  char proc[] = "Inrimage *resample4x4Nearest ( Inrimage *theBuf, Matrix4x4<double> &mat, bool twoD, float gain, float bias )";


  int theDim[3] = { theBuf->getX(), theBuf->getY(), theBuf->getZ() };
  int resDim[3] = { resBuf->getX(), resBuf->getY(), resBuf->getZ() }; 


  double mat[16]= { m(0,0), m(0,1), m(0,2), m(0,3),  \
		    m(1,0), m(1,1), m(1,2), m(1,3),  \
		    m(2,0), m(2,1), m(2,2), m(2,3),  \
		    m(3,0), m(3,1), m(3,2), m(3,3) };
  

  switch (theBuf->getType()) {
    
  case Inrimage::WT_UNSIGNED_CHAR : 

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, unsigned char> ( (unsigned char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned char, unsigned char> ( (unsigned char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, char> ( (unsigned char *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned char, char> ( (unsigned char *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, unsigned short int> ( (unsigned char *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned char, unsigned short int> ( (unsigned char *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, short int> ( (unsigned char *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned char, short int> ( (unsigned char *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, unsigned int> ( (unsigned char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned char, unsigned int> ( (unsigned char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, int> ( (unsigned char *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat , gain, bias);
      else
	Reech3DNearest4x4Buffer <unsigned char, int> ( (unsigned char *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, unsigned LONGINT> ( (unsigned char *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned char, unsigned LONGINT> ( (unsigned char *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, LONGINT> ( (unsigned char *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned char, LONGINT> ( (unsigned char *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, float> ( (unsigned char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned char, float> ( (unsigned char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned char, double> ( (unsigned char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned char, double> ( (unsigned char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }
    break;
  
  case Inrimage::WT_SIGNED_CHAR : 

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <char, unsigned char> ( (char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <char, unsigned char> ( (char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <char, char> ( (char *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <char, char> ( (char *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <char, unsigned short int> ( (char *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <char, unsigned short int> ( (char *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <char, short int> ( (char *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <char, short int> ( (char *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <char, unsigned int> ( (char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <char, unsigned int> ( (char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <char, int> ( (char *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat , gain, bias);
      else
	Reech3DNearest4x4Buffer <char, int> ( (char *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <char, unsigned LONGINT> ( (char *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <char, unsigned LONGINT> ( (char *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <char, LONGINT> ( (char *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <char, LONGINT> ( (char *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer <char, float> ( (char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <char, float> ( (char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer <char, double> ( (char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <char, double> ( (char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }
    break;
  
  case Inrimage::WT_UNSIGNED_SHORT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, unsigned char> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, unsigned char> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, char> ( (unsigned short int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, char> ( (unsigned short int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, unsigned short int> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, unsigned short int> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, short int> ( (unsigned short int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, short int> ( (unsigned short int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, unsigned int> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, unsigned int> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, int> ( (unsigned short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, int> ( (unsigned short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, unsigned LONGINT> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, unsigned LONGINT> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, LONGINT> ( (unsigned short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, LONGINT> ( (unsigned short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, float> ( (unsigned short int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, float> ( (unsigned short int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned short int, double> ( (unsigned short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned short int, double> ( (unsigned short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;

  case Inrimage::WT_SIGNED_SHORT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, unsigned char> ( ( short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, unsigned char> ( ( short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, char> ( ( short int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, char> ( ( short int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, unsigned short int> ( ( short int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, unsigned short int> ( ( short int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, short int> ( ( short int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, short int> ( ( short int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, unsigned int> ( ( short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, unsigned int> ( ( short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, int> ( ( short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, int> ( ( short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, unsigned LONGINT> ( ( short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, unsigned LONGINT> ( ( short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, LONGINT> ( ( short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, LONGINT> ( ( short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, float> (( short int *)theBuf->getData(),  theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, float> ( ( short int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer < short int, double> ( ( short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < short int, double> ( ( short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;		 
              
  case Inrimage::WT_UNSIGNED_INT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, unsigned char> ( (unsigned int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, unsigned char> ( (unsigned int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, char> ( (unsigned int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, char> ( (unsigned int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, unsigned short int> ( (unsigned int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, unsigned short int> ( (unsigned int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, short int> ( (unsigned int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, short int> ( (unsigned int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, unsigned int> ( (unsigned int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, unsigned int> ( (unsigned int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, int> ( (unsigned int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, int> ( (unsigned int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, unsigned LONGINT> ( (unsigned int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, unsigned LONGINT> ( (unsigned int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, LONGINT> ( (unsigned int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, LONGINT> ( (unsigned int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, float> ( (unsigned int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, float> ( (unsigned int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned int, double> ( (unsigned int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned int, double> ( (unsigned int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
    
  case Inrimage::WT_SIGNED_INT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer < int, unsigned char> ( ( int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, unsigned char> ( ( int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer < int, char> ( ( int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, unsigned char> ( ( int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer < int, unsigned short int> ( ( int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, unsigned short int> ( ( int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer < int, short int> ( ( int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, short int> ( ( int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer < int, unsigned int> ( ( int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, unsigned int> ( ( int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer < int, int> ( ( int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, int> ( ( int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer < int, unsigned LONGINT> ( ( int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, unsigned LONGINT> ( ( int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer < int, LONGINT> ( ( int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, LONGINT> ( ( int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer < int, float> ( ( int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, float> ( ( int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer < int, double> ( ( int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < int, double> ( ( int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
    
  case Inrimage::WT_UNSIGNED_LONG :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, unsigned char> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, unsigned char> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, char> ( (unsigned LONGINT *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, char> ( (unsigned LONGINT *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, unsigned short int> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, unsigned short int> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, short int> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, short int> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, unsigned int> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, unsigned int> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, int> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, int> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, unsigned LONGINT> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, unsigned LONGINT> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, LONGINT> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, LONGINT> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, float> ( (unsigned LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, float> ( (unsigned LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer <unsigned LONGINT, double> ( (unsigned LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <unsigned LONGINT, double> ( (unsigned LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
              
  case Inrimage::WT_SIGNED_LONG :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, unsigned char> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, unsigned char> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, char> ( ( LONGINT *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, char> ( ( LONGINT *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, unsigned short int> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, unsigned short int> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, short int> ( ( LONGINT *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, short int> ( ( LONGINT *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, unsigned int> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, unsigned int> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, int> ( ( LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, int> ( ( LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, unsigned LONGINT> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, unsigned LONGINT> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, LONGINT> ( ( LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, LONGINT> ( ( LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, float> ( ( LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, float> ( ( LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer < LONGINT, double> ( ( LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer < LONGINT, double> ( ( LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
             
  case Inrimage::WT_FLOAT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <float, unsigned char> ( (float *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, unsigned char> ( (float *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <float, char> ( (float *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, char> ( (float *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <float, unsigned short int> ( (float *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, unsigned short int> ( (float *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <float, short int> ( (float *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, short int> ( (float *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <float, unsigned int> ( (float *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, unsigned int> ( (float *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <float, int> ( (float *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, int> ( (float *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <float, unsigned LONGINT> ( (float *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, unsigned LONGINT> ( (float *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <float, LONGINT> ( (float *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, LONGINT> ( (float *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer <float, float> ( (float *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, float> ( (float *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer <float, double> ( (float *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <float, double> ( (float *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
    
  case Inrimage::WT_DOUBLE :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <double, unsigned char> ( (double *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, unsigned char> ( (double *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DNearest4x4Buffer <double, char> ( (double *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, char> ( (double *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <double, unsigned short int> ( (double *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, unsigned short int> ( (double *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DNearest4x4Buffer <double, short int> ( (double *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, short int> ( (double *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <double, unsigned int> ( (double *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, unsigned int> ( (double *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DNearest4x4Buffer <double, int> ( (double *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, int> ( (double *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <double, unsigned LONGINT> ( (double *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, unsigned LONGINT> ( (double *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DNearest4x4Buffer <double, LONGINT> ( (double *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, LONGINT> ( (double *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DNearest4x4Buffer <double, float> ( (double *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, float> ( (double *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DNearest4x4Buffer <double, double> ( (double *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DNearest4x4Buffer <double, double> ((double *)theBuf->getData(),  theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
    
  case Inrimage::WT_RGB :
  case Inrimage::WT_RGBA :
  case Inrimage::WT_FLOAT_VECTOR :
  case Inrimage::WT_DOUBLE_VECTOR :
  default :
    CERR << "Type of the input image not supported in " << proc << ENDL;
    break;

  }

}

Inrimage *resample4x4TriLinear ( Inrimage *theBuf, Matrix4x4<double> &m, Inrimage::WORD_TYPE wt, unsigned int xdim, unsigned int ydim, unsigned int zdim, double vx, double vy, double vz, bool twoD , float gain, float bias ) {



  Inrimage *resBuf = new Inrimage (xdim, ydim, zdim, wt, 1, VM_SCALAR, (float)vx, (float)vy, (float)vz); 

  resample4x4TriLinear (theBuf,resBuf,m, twoD ,gain, bias );
  return (resBuf);
}

void resample4x4TriLinear ( Inrimage *theBuf, Inrimage *resBuf, Matrix4x4<double> &m, bool twoD , float gain, float bias ) {

  char proc[] = "void resample4x4TriLinear ( Inrimage *theBuf, Matrix4x4<double> &mat, Inrimage::WORD_TYPE wt, unsigned int xdim, unsigned int ydim, unsigned int zdim, double vx, double vy, double vz, bool twoD = false, float gain, float bias )";


  int theDim[3] = { theBuf->getX(), theBuf->getY(), theBuf->getZ() };
  int resDim[3] = { resBuf->getX(), resBuf->getY(), resBuf->getZ() }; 
  
  double mat[16]  = { m(0,0), m(0,1), m(0,2), m(0,3),  \
		      m(1,0), m(1,1), m(1,2), m(1,3),  \
		      m(2,0), m(2,1), m(2,2), m(2,3),  \
		      m(3,0), m(3,1), m(3,2), m(3,3) }; 
  

  switch (theBuf->getType()) {
    
    
  case Inrimage::WT_UNSIGNED_CHAR : 

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, unsigned char> ( (unsigned char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, unsigned char> ( (unsigned char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, char> ( (unsigned char *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, char> ( (unsigned char *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, unsigned short int> ( (unsigned char *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, unsigned short int> ( (unsigned char *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, short int> ( (unsigned char *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, short int> ( (unsigned char *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, unsigned int> ( (unsigned char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, unsigned int> ( (unsigned char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, int> ( (unsigned char *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, int> ( (unsigned char *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, unsigned LONGINT> ( (unsigned char *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, unsigned LONGINT> ( (unsigned char *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, LONGINT> ( (unsigned char *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, LONGINT> ( (unsigned char *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, float> ( (unsigned char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, float> ( (unsigned char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned char, double> ( (unsigned char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned char, double> ( (unsigned char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }
    break;
  
  case Inrimage::WT_SIGNED_CHAR : 

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, unsigned char> ( (char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, unsigned char> ( (char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, char> ( (char *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, char> ( (char *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, unsigned short int> ( (char *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, unsigned short int> ( (char *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, short int> ( (char *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, short int> ( (char *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, unsigned int> ( (char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, unsigned int> ( (char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, int> ( (char *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, int> ( (char *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, unsigned LONGINT> ( (char *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, unsigned LONGINT> ( (char *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, LONGINT> ( (char *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, LONGINT> ( (char *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, float> ( (char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, float> ( (char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <char, double> ( (char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <char, double> ( (char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }
    break;
  
  case Inrimage::WT_UNSIGNED_SHORT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, unsigned char> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, unsigned char> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, char> ( (unsigned short int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, unsigned char> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, unsigned short int> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, unsigned short int> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, short int> ( (unsigned short int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, short int> ( (unsigned short int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, unsigned int> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, unsigned int> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, int> ( (unsigned short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, int> ( (unsigned short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, unsigned LONGINT> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, unsigned LONGINT> ( (unsigned short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, LONGINT> ( (unsigned short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, LONGINT> ( (unsigned short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, float> ( (unsigned short int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, float> ( (unsigned short int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned short int, double> ( (unsigned short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned short int, double> ( (unsigned short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;

  case Inrimage::WT_SIGNED_SHORT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, unsigned char> ( ( short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, unsigned char> ( ( short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, char> ( ( short int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, char> ( ( short int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, unsigned short int> ( ( short int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, unsigned short int> ( ( short int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, short int> ( ( short int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, short int> ( ( short int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, unsigned int> ( ( short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, unsigned int> ( ( short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, int> ( ( short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, int> ( ( short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, unsigned LONGINT> ( ( short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, unsigned LONGINT> ( ( short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, LONGINT> ( ( short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, LONGINT> ( ( short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, float> ( ( short int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, float> ( ( short int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < short int, double> ( ( short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < short int, double> ( ( short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;		 
              
  case Inrimage::WT_UNSIGNED_INT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, unsigned char> ( (unsigned int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, unsigned char> ( (unsigned int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, char> ( (unsigned int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, char> ( (unsigned int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, unsigned short int> ( (unsigned int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, unsigned short int> ( (unsigned int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, short int> ( (unsigned int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, short int> ( (unsigned int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, unsigned int> ( (unsigned int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, unsigned int> ( (unsigned int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, int> ( (unsigned int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, int> ( (unsigned int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, unsigned LONGINT> ( (unsigned int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, unsigned LONGINT> ( (unsigned int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, LONGINT> ( (unsigned int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, LONGINT> ( (unsigned int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, float> ( (unsigned int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, float> ( (unsigned int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned int, double> ( (unsigned int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned int, double> ( (unsigned int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
    
  case Inrimage::WT_SIGNED_INT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, unsigned char> ( ( int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, unsigned char> ( ( int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, char> ( ( int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, char> ( ( int *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, unsigned short int> ( ( int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, unsigned short int> ( ( int *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, short int> ( ( int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, short int> ( ( int *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, unsigned int> ( ( int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, unsigned int> ( ( int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, int> ( ( int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, int> ( ( int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, unsigned LONGINT> ( ( int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, unsigned LONGINT> ( ( int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, LONGINT> ( ( int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, LONGINT> ( ( int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, float> ( ( int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, float> ( ( int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < int, double> ( ( int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < int, double> ( ( int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
    
  case Inrimage::WT_UNSIGNED_LONG :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, unsigned char> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, unsigned char> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, char> ( (unsigned LONGINT *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, char> ( (unsigned LONGINT *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, unsigned short int> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, unsigned short int> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, short int> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, short int> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, unsigned int> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, unsigned int> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, int> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, int> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, unsigned LONGINT> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, unsigned LONGINT> ( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, LONGINT> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, LONGINT> ( (unsigned LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, float> ( (unsigned LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, float> ( (unsigned LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <unsigned LONGINT, double> ( (unsigned LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <unsigned LONGINT, double> ( (unsigned LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
              
  case Inrimage::WT_SIGNED_LONG :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, unsigned char> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, unsigned char> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, char> ( ( LONGINT *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, char> ( ( LONGINT *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, unsigned short int> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, unsigned short int> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, short int> ( ( LONGINT *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, short int> ( ( LONGINT *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, unsigned int> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, unsigned int> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, int> ( ( LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, int> ( ( LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, unsigned LONGINT> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, unsigned LONGINT> ( ( LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, LONGINT> ( ( LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, LONGINT> ( ( LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, float> ( ( LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, float> ( ( LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer < LONGINT, double> ( ( LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer < LONGINT, double> ( ( LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
             
  case Inrimage::WT_FLOAT :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, unsigned char> ( (float *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, unsigned char> ( (float *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, char> ( (float *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, char> ( (float *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, unsigned short int> ( (float *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, unsigned short int> ( (float *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, short int> ( (float *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, short int> ( (float *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, unsigned int> ( (float *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, unsigned int> ( (float *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, int> ( (float *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, int> ( (float *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, unsigned LONGINT> ( (float *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, unsigned LONGINT> ( (float *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, LONGINT> ( (float *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, LONGINT> ( (float *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, float> ( (float *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, float> ( (float *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <float, double> ( (float *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <float, double> ( (float *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
    
  case Inrimage::WT_DOUBLE :

    switch (resBuf->getType()) {

    case Inrimage::WT_UNSIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, unsigned char> ( (double *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, unsigned char> ( (double *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_CHAR:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, char> ( (double *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, char> ( (double *)theBuf->getData(), theDim, (char *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, unsigned short int> ( (double *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, unsigned short int> ( (double *)theBuf->getData(), theDim, (unsigned short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_SHORT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, short int> ( (double *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, short int> ( (double *)theBuf->getData(), theDim, ( short int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, unsigned int> ( (double *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, unsigned int> ( (double *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_INT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, int> ( (double *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, int> ( (double *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, unsigned LONGINT> ( (double *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, unsigned LONGINT> ( (double *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_SIGNED_LONG:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, LONGINT> ( (double *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, LONGINT> ( (double *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_FLOAT:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, float> ( (double *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, float> ( (double *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_DOUBLE:
      if (twoD)
	Reech2DTriLin4x4gbBuffer <double, double> ( (double *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      else
	Reech3DTriLin4x4gbBuffer <double, double> ( (double *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, gain, bias );
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Type of the output image not supported in " << proc << ENDL;
      break;
    }

    break;	
    
  case Inrimage::WT_RGB :
  case Inrimage::WT_RGBA :
  case Inrimage::WT_FLOAT_VECTOR :
  case Inrimage::WT_DOUBLE_VECTOR :
  default :
    CERR << "Type of the input image not supported in " << proc << ENDL;
    break;

  }

}


Inrimage *resample4x4CSpline (Inrimage *theBuf, Matrix4x4<double> &m, Inrimage::WORD_TYPE wt, unsigned int xdim, unsigned int ydim, unsigned int zdim, RESAMPLE_FILTER_DERIVATIVE deri[3], double vx, double vy, double vz) {

  Inrimage *resBuf = new Inrimage (xdim, ydim, zdim, wt, 1, VM_SCALAR, (float)vx, (float)vy, (float)vz); 

  resample4x4CSpline (theBuf,resBuf,m, deri);
  return resBuf;
}

void resample4x4CSpline (Inrimage *theBuf, Inrimage *resBuf,Matrix4x4<double> &m, RESAMPLE_FILTER_DERIVATIVE deri[3]) {

  char proc[] = "Inrimage *resample4x4CSpline ( Inrimage *theBuf, Matrix4x4<double> &mat, RESAMPLE_FILTER_DERIVATIVEderivative[3]]) ";


  int theDim[3] = { theBuf->getX(), theBuf->getY(), theBuf->getZ() };
  int resDim[3] = { resBuf->getX(), resBuf->getY(), resBuf->getZ() }; 

  double mat[16]  = { m(0,0), m(0,1), m(0,2), m(0,3),  \
		      m(1,0), m(1,1), m(1,2), m(1,3),  \
		      m(2,0), m(2,1), m(2,2), m(2,3),  \
		      m(3,0), m(3,1), m(3,2), m(3,3) }; 
		   

  int derivative[3];

  for (int i=0; i<3; ++i )
      derivative[i]=deri[i];

  switch (theBuf->getType()) {    
       
  case Inrimage::WT_UNSIGNED_CHAR :

    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR:
      ReechCSpline4x4 < unsigned char, unsigned char >( (unsigned char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      ReechCSpline4x4 < unsigned char, unsigned short >( (unsigned char *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT:
      ReechCSpline4x4 < unsigned char, short >( (unsigned char *)theBuf->getData(), theDim, ( short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT:
      ReechCSpline4x4 < unsigned char, unsigned int >( (unsigned char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT:
      ReechCSpline4x4 < unsigned char, int >( (unsigned char *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      ReechCSpline4x4 < unsigned char, unsigned LONGINT >( (unsigned char *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG:
      ReechCSpline4x4 < unsigned char, LONGINT >( (unsigned char *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_FLOAT:
      ReechCSpline4x4 < unsigned char, float >( (unsigned char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE:
      ReechCSpline4x4 < unsigned char, double >( (unsigned char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Output image type is not supported in " << proc << ENDL;
      break;
    }

    break;



  case Inrimage::WT_UNSIGNED_SHORT :

    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR:
      ReechCSpline4x4 < unsigned short int, unsigned char >( (unsigned short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      ReechCSpline4x4 < unsigned short int, unsigned short >( (unsigned short int *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT:
      ReechCSpline4x4 < unsigned short int, short >( (unsigned short int *)theBuf->getData(), theDim, ( short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT:
      ReechCSpline4x4 < unsigned short int, unsigned int >( (unsigned short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT:
      ReechCSpline4x4 < unsigned short int, int >( (unsigned short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      ReechCSpline4x4 < unsigned short int, unsigned LONGINT >( (unsigned short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG:
      ReechCSpline4x4 < unsigned short int, LONGINT >( (unsigned short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_FLOAT:
      ReechCSpline4x4 < unsigned short int, float >( (unsigned short int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE:
      ReechCSpline4x4 < unsigned short int, double >( (unsigned short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Output image type is not supported in " << proc << ENDL;
      break;
    }

    break;

  case Inrimage::WT_SIGNED_SHORT :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR:
      ReechCSpline4x4 < short int, unsigned char >( ( short int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      ReechCSpline4x4 < short int, unsigned short >( ( short int *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT:
      ReechCSpline4x4 < short int, short >( ( short int *)theBuf->getData(), theDim, ( short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT:
      ReechCSpline4x4 < short int, unsigned int >( ( short int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT:
      ReechCSpline4x4 < short int, int >( ( short int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      ReechCSpline4x4 < short int, unsigned LONGINT >( ( short int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG:
      ReechCSpline4x4 < short int, LONGINT >( ( short int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_FLOAT:
      ReechCSpline4x4 < short int, float >( ( short int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE:
      ReechCSpline4x4 < short int, double >( ( short int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Output image type is not supported in " << proc << ENDL;
      break;
    }

    break;
  case Inrimage::WT_UNSIGNED_INT :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR:
      ReechCSpline4x4 < unsigned int, unsigned char >( (unsigned int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      ReechCSpline4x4 < unsigned int, unsigned short >( (unsigned int *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT:
      ReechCSpline4x4 < unsigned int, short >( (unsigned int *)theBuf->getData(), theDim, ( short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT:
      ReechCSpline4x4 < unsigned int, unsigned int >( (unsigned int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT:
      ReechCSpline4x4 < unsigned int, int >( (unsigned int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      ReechCSpline4x4 < unsigned int, unsigned LONGINT >( (unsigned int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG:
      ReechCSpline4x4 < unsigned int, LONGINT >( (unsigned int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_FLOAT:
      ReechCSpline4x4 < unsigned int, float >( (unsigned int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE:
      ReechCSpline4x4 < unsigned int, double >( (unsigned int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Output image type is not supported in " << proc << ENDL;
      break;
    }


    break;
  case Inrimage::WT_SIGNED_INT :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR:
      ReechCSpline4x4 < int, unsigned char >( ( int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      ReechCSpline4x4 < int, unsigned short >( ( int *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT:
      ReechCSpline4x4 < int, short >( ( int *)theBuf->getData(), theDim, ( short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT:
      ReechCSpline4x4 < int, unsigned int >( ( int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT:
      ReechCSpline4x4 < int, int >( ( int *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      ReechCSpline4x4 < int, unsigned LONGINT >( ( int *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG:
      ReechCSpline4x4 < int, LONGINT >( ( int *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_FLOAT:
      ReechCSpline4x4 < int, float >( ( int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE:
      ReechCSpline4x4 < int, double >( ( int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Output image type is not supported in " << proc << ENDL;
      break;
    }


    break;
  case Inrimage::WT_UNSIGNED_LONG :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR:
      ReechCSpline4x4 < unsigned LONGINT, unsigned char >( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      ReechCSpline4x4 < unsigned LONGINT, unsigned short >( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT:
      ReechCSpline4x4 < unsigned LONGINT, short >( (unsigned LONGINT *)theBuf->getData(), theDim, ( short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT:
      ReechCSpline4x4 < unsigned LONGINT, unsigned int >( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT:
      ReechCSpline4x4 < unsigned LONGINT, int >( (unsigned LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      ReechCSpline4x4 < unsigned LONGINT, unsigned LONGINT >( (unsigned LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG:
      ReechCSpline4x4 < unsigned LONGINT, LONGINT >( (unsigned LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_FLOAT:
      ReechCSpline4x4 < unsigned LONGINT, float >( (unsigned LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE:
      ReechCSpline4x4 < unsigned LONGINT, double >( (unsigned LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Output image type is not supported in " << proc << ENDL;
      break;
    }


    break;
  case Inrimage::WT_SIGNED_LONG :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR:
      ReechCSpline4x4 < LONGINT, unsigned char >( ( LONGINT *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      ReechCSpline4x4 < LONGINT, unsigned short >( ( LONGINT *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT:
      ReechCSpline4x4 < LONGINT, short >( ( LONGINT *)theBuf->getData(), theDim, ( short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT:
      ReechCSpline4x4 < LONGINT, unsigned int >( ( LONGINT *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT:
      ReechCSpline4x4 < LONGINT, int >( ( LONGINT *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      ReechCSpline4x4 < LONGINT, unsigned LONGINT >( ( LONGINT *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG:
      ReechCSpline4x4 < LONGINT, LONGINT >( ( LONGINT *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_FLOAT:
      ReechCSpline4x4 < LONGINT, float >( ( LONGINT *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE:
      ReechCSpline4x4 < LONGINT, double >( ( LONGINT *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Output image type is not supported in " << proc << ENDL;
      break;
    }


    break;
  case Inrimage::WT_FLOAT :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR:
      ReechCSpline4x4 < float, unsigned char >( (float *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      ReechCSpline4x4 < float, unsigned short >( (float *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT:
      ReechCSpline4x4 < float, short >( (float *)theBuf->getData(), theDim, ( short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT:
      ReechCSpline4x4 < float, unsigned int >( (float *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT:
      ReechCSpline4x4 < float, int >( (float *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      ReechCSpline4x4 < float, unsigned LONGINT >( (float *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG:
      ReechCSpline4x4 < float, LONGINT >( (float *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_FLOAT:
      ReechCSpline4x4 < float, float >( (float *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE:
      ReechCSpline4x4 < float, double >( (float *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Output image type is not supported in " << proc << ENDL;
      break;
    }


    break;
  case Inrimage::WT_DOUBLE :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR:
      ReechCSpline4x4 < double, unsigned char >( (double *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT:
      ReechCSpline4x4 < double, unsigned short >( (double *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT:
      ReechCSpline4x4 < double, short >( (double *)theBuf->getData(), theDim, ( short *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT:
      ReechCSpline4x4 < double, unsigned int >( (double *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT:
      ReechCSpline4x4 < double, int >( (double *)theBuf->getData(), theDim, ( int *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG:
      ReechCSpline4x4 < double, unsigned LONGINT >( (double *)theBuf->getData(), theDim, (unsigned LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG:
      ReechCSpline4x4 < double, LONGINT >( (double *)theBuf->getData(), theDim, ( LONGINT *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_FLOAT:
      ReechCSpline4x4 < double, float >( (double *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE:
      ReechCSpline4x4 < double, double >( (double *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, mat, derivative);
      break;
    case Inrimage::WT_RGB:
    case Inrimage::WT_RGBA:
    case Inrimage::WT_FLOAT_VECTOR:
    case Inrimage::WT_DOUBLE_VECTOR:
    default:
      CERR << "Output image type is not supported in " << proc << ENDL;
      break;
    }


    break;

  case Inrimage::WT_RGB :
  case Inrimage::WT_RGBA :
  case Inrimage::WT_FLOAT_VECTOR :
  case Inrimage::WT_DOUBLE_VECTOR :
  default :
    CERR << "Input image type is not supported in " << proc <<ENDL; 
    break;

  }

}






void ReechDefNearestBuffer ( Inrimage *theIm, 
			     Inrimage *resIm, 
			     Inrimage * defxIm, 
			     Inrimage * defyIm, 
			     Inrimage * defzIm, 
			     double *theMat,
			     float gain,
			     float bias) 
  
{

  char *proc="void ReechDefNearestBuffer ( Inrimage *theIm, Inrimage *resIm, Inrimage * defxIm, Inrimage * defyIm, Inrimage * defzIm,double *theMat, float gain, float bias )";
  int theDim[3], resDim[3];
  double mat[16];
  register int i, dxy;
  int z;
  float *resSlice = (float*)NULL;
  float *defSlice[3];
  register float *rs;
  register double b=bias;
  register double g=gain;

  if ( (theIm == (Inrimage *)NULL) || (theIm->getData() == (char *)NULL) )
    CERR << "Null or not allocated input image in " << proc << ENDL;
  if ( (resIm == (Inrimage *)NULL) || (resIm->getData() == (char *)NULL) )
    CERR << "Null or not allocated input image in " << proc << ENDL;
  if (theIm->getData() == resIm->getData())
    CERR << "Input and output buffer are identical in " << proc << ENDL;
  
  theDim[0] = theIm->getX();
  theDim[1] = theIm->getY();
  theDim[2] = theIm->getZ();
  
  resDim[0] = resIm->getX();
  resDim[1] = resIm->getY();
  resDim[2] = resIm->getZ();
  dxy = resDim[0] * resDim[1];

  /* y-a-t'il une deformation ?
   */
  if ( (defxIm == (Inrimage *)NULL) || (defxIm->getData() == (char*)NULL) ||
       (defyIm == (Inrimage *)NULL) || (defyIm->getData() == (char*)NULL) ||
       (defzIm == (Inrimage *)NULL) || (defzIm->getData() == (char*)NULL) ) {
    /* pas de deformation ? => y-a-t'il une matrice ?
     */
    if ( theMat == (double*)NULL ) return;
    
    /* on reechantillonne avec une matrice 
     */
    
    if (theIm->getType() != resIm->getType())
      CERR << " Input and output images have different types in " << proc << ENDL;


    /* tmat4TOdoublearray( theMat, mat ); */
    Matrix4x4<double> mat_tmp(theMat);
    Inrimage::WORD_TYPE resIm_type = resIm->getType();
    unsigned int resIm_xdim = resIm->getX(), resIm_ydim = resIm->getY(), resIm_zdim = resIm->getY();
    delete resIm;
    resIm = resample4x4Nearest (theIm, mat_tmp, resIm_type, resIm_xdim, resIm_ydim, resIm_zdim, gain, bias );


  } else {
    /* on a une deformation
     */

   if ( (resIm->getX() != defxIm->getX()) || (resIm->getX() != defyIm->getX()) ||
	(resIm->getX() != defzIm->getX()) )
     CERR << "Output and deformation images have different X dimensions in " << proc << ENDL;
   if ( (resIm->getY() != defxIm->getY()) || (resIm->getY() != defyIm->getY()) ||
	(resIm->getY() != defzIm->getY()) )
     CERR << "Output and deformation images have different Y dimensions in " << proc << ENDL;
   if ( (resIm->getZ() != defxIm->getZ()) || (resIm->getZ() != defyIm->getZ()) ||
	(resIm->getZ() != defzIm->getZ()) )
     CERR << "Output and deformation images have different Z dimensions in " << proc << ENDL;
   if ( (defxIm->getType() != Inrimage::WT_FLOAT) || (defyIm->getType() != Inrimage::WT_FLOAT) || 
	(defzIm->getType() != Inrimage::WT_FLOAT) )
     CERR << "Deformation images do not have float type in " << proc << ENDL;

    /* verification de la matrice.
     * Si elle est NULL, on prend l'identite.
     */
   
   if ( theMat != (double*)NULL ) {
     /* tmat4TOdoublearray( theMat, mat ); */
     for ( i = 0; i<16; i++, theMat++ )
       mat[i] = *theMat;
   } else {
     for ( i = 0; i < 16; i++ ) mat[i] = 0.0;
     mat[0] = mat[5] = mat[10] = mat[15] = 1.0;
   }
   
   
   
   /* allocation of auxiliary slice 
    */
   
   if ( resIm->getType() != Inrimage::WT_FLOAT ) {
     /*
       resSlice = (float*)T_Alloc( (unsigned int)( dxy * sizeof(float) ) );
       E_ISERRN( proc, "Can not allocate auxiliary slice" );
     */
     resSlice = new float [ dxy ];
   }
   
   for ( z = 0; z < resDim[2]; z ++ ) {
     /* COUT << " slice number "<< z << ENDL; */
          
     /* on recupere les bons plans pour 
      * l'image resultat
      * et les deformations
      */
      
     if ( resIm->getType() == Inrimage::WT_FLOAT ) {
       resSlice = (float*)(resIm->getData());
       resSlice += z * dxy;
     }
     defSlice[0] = (float*)(defxIm->getData()); 
     defSlice[1] = (float*)(defyIm->getData()); 
     defSlice[2] = (float*)(defzIm->getData()); 
     defSlice[0] += z * dxy;
     defSlice[1] += z * dxy;
     defSlice[2] += z * dxy;
 
     /* computation of slice #z of result image 
      */
     
     switch ( theIm->getType() ) {
     case Inrimage::WT_UNSIGNED_CHAR :
       ReechNearestDefSliceBuffer <unsigned char> ((unsigned char *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_UNSIGNED_SHORT:
       ReechNearestDefSliceBuffer <unsigned short int> ((unsigned short int *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
      case Inrimage::WT_SIGNED_SHORT :
	ReechNearestDefSliceBuffer < short int> (( short int *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
	break;
     case Inrimage::WT_UNSIGNED_INT :
       ReechNearestDefSliceBuffer <unsigned int> ((unsigned int *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_SIGNED_INT :
       ReechNearestDefSliceBuffer < int> (( int *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_UNSIGNED_LONG :
       ReechNearestDefSliceBuffer <unsigned LONGINT> ((unsigned LONGINT *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_SIGNED_LONG :
       ReechNearestDefSliceBuffer < LONGINT> (( LONGINT *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_FLOAT :
       ReechNearestDefSliceBuffer <float> ((float *)theIm->getData(), theDim, resSlice, resDim,defSlice, mat, z);
       break;
     case Inrimage::WT_DOUBLE :
       ReechNearestDefSliceBuffer <double> ((double *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
       
     case Inrimage::WT_RGB :
     case Inrimage::WT_RGBA :
     case Inrimage::WT_FLOAT_VECTOR :
     case Inrimage::WT_DOUBLE_VECTOR :
     default :
       /* if ( resIm->type != TYPEIM_FLOAT ) (void)free( resSlice );
	  E_XERRN( E_ERRMISMATCH, proc,
	  "Can not deal with such input image type" );*/
       
       CERR << "Le type de l'image d'entree n'est pas supporte dans " << proc <<ENDL;
       
     }
     
     /* transformation with gain and bias 
      */

     rs = resSlice;
     
     if ( (bias != 0.0 ) && (gain != 1.0 ) ) {
       for ( i = 0; i < dxy; i++, rs++ ) 
	 *rs = (float)((*rs * g) + b);
     } else if ( (gain != 1.0 ) && (bias == 0.0 ) ) {
       for ( i = 0; i < dxy; i++, rs++ ) 
	 *rs *= (float)g;
     } else if ( (gain == 1.0 ) && (bias != 0.0 ) ) {
       for ( i = 0; i < dxy; i++, rs++ ) 
	 *rs += (float)b;
     }


     /* conversion into type of result image 
      */
     switch ( resIm->getType() ) {
     case Inrimage::WT_UNSIGNED_CHAR :
       {
	 unsigned char *resBuf = (unsigned char*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < unsigned char, float > ( (unsigned char *)0, (float *)0, resSlice, resBuf, dxy );
       }
     break;
     case  Inrimage::WT_UNSIGNED_SHORT :
       {
	 unsigned short int *resBuf = (unsigned short int*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < unsigned short int, float > ( (unsigned short int *)0, (float *)0, resSlice, resBuf, dxy );
       }
     break;
     case Inrimage::WT_SIGNED_SHORT:
       {
	 short int *resBuf = ( short int*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < short int, float > ( ( short int *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_UNSIGNED_INT:
       {
	 unsigned int *resBuf = (unsigned int*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < unsigned int, float > ( (unsigned int *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_SIGNED_INT:
       {
	 int *resBuf = ( int*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < int, float > ( ( int *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_UNSIGNED_LONG:
       {
	 unsigned LONGINT *resBuf = (unsigned LONGINT*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < unsigned LONGINT, float > ( (unsigned LONGINT *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_SIGNED_LONG:
       {
	 LONGINT *resBuf = ( LONGINT*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < LONGINT, float > ( ( LONGINT *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_FLOAT:
       break;
     case Inrimage::WT_DOUBLE:
       {
	 double *resBuf = (double *)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < double, float > ( (double *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;

     case Inrimage::WT_RGB:
     case Inrimage::WT_RGBA:
     case Inrimage::WT_FLOAT_VECTOR:
     case Inrimage::WT_DOUBLE_VECTOR:

     default :
       if ( resIm->getType() != Inrimage::WT_FLOAT ) delete resSlice;
       CERR << "Le type de l'image resultat " << resIm->getType() << "n'est pas supporte dans "<< proc << ENDL;
       
      }
   }
   if ( resIm->getType() != Inrimage::WT_FLOAT ) delete resSlice;
  }
}



Inrimage *resampleDefNearest ( Inrimage *theBuf, Inrimage *defx, Inrimage *defy, Inrimage *defz, Matrix4x4<double> &m, Inrimage::WORD_TYPE wt, double vx, double vy, double vz, float gain, float bias ) {

  char *proc = "Inrimage *resampleDefNearest ( Inrimage *theBuf, Inrimage *defx, Inrimage *defy, Inrimage *defz, Matrix4x4<double> &mat )";
  Inrimage *resBuf = new Inrimage(theBuf->getX(), theBuf->getY(), theBuf->getZ(), wt, 1, VM_SCALAR, (float)vx, (float)vy, (float)vz); 

  double mat[16]  = { m(0,0), m(0,1), m(0,2), m(0,3),  \
		      m(1,0), m(1,1), m(1,2), m(1,3),  \
		      m(2,0), m(2,1), m(2,2), m(2,3),  \
		      m(3,0), m(3,1), m(3,2), m(3,3) }; 

  switch (theBuf->getType()) {    
       
  case Inrimage::WT_UNSIGNED_CHAR :
  case Inrimage::WT_UNSIGNED_SHORT :
  case Inrimage::WT_SIGNED_SHORT :
  case Inrimage::WT_UNSIGNED_INT :
  case Inrimage::WT_SIGNED_INT :
  case Inrimage::WT_UNSIGNED_LONG :
  case Inrimage::WT_SIGNED_LONG :
  case Inrimage::WT_FLOAT :
  case Inrimage::WT_DOUBLE :
    ReechDefNearestBuffer ( theBuf, resBuf, defx, defy, defz, mat, gain, bias );
    break;	

  case Inrimage::WT_RGB :
  case Inrimage::WT_RGBA :
  case Inrimage::WT_FLOAT_VECTOR :
  case Inrimage::WT_DOUBLE_VECTOR :
    CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 

  default :
    CERR << " Le type de l'image d'entree n'est pas supporte dans " << proc <<ENDL; 
    break;

  }

  return resBuf;

}



void ReechDefTriLinBuffer ( Inrimage *theIm, 
			    Inrimage *resIm, 
			    Inrimage * defxIm, 
			    Inrimage * defyIm, 
			    Inrimage * defzIm, 
			    double *theMat, 
			    float gain, 
			    float bias ) 
  
{

  char *proc="void ReechDefTriLinBuffer ( Inrimage *theIm, Inrimage *resIm, Inrimage * defxIm, Inrimage * defyIm, Inrimage * defzIm,double *theMat,float gain,float bias )";
  int theDim[3], resDim[3];
  double mat[16];
  register int i, dxy;
  int z;
  float *resSlice = (float*)NULL;
  float *defSlice[3];
  register float *rs;
  register double b=bias;
  register double g=gain;


  if ( (theIm == (Inrimage *)NULL) || (theIm->getData() == (char *)NULL) )
    CERR << "Null or not allocated input image in " << proc << ENDL;
  if ( (resIm == (Inrimage *)NULL) || (resIm->getData() == (char *)NULL) )
    CERR << "Null or not allocated input image in " << proc << ENDL;
  if (theIm->getData() == resIm->getData())
    CERR << "Input and output buffer are identical in " << proc << ENDL;
  
  theDim[0] = theIm->getX();
  theDim[1] = theIm->getY();
  theDim[2] = theIm->getZ();
  
  resDim[0] = resIm->getX();
  resDim[1] = resIm->getY();
  resDim[2] = resIm->getZ();
  dxy = resDim[0] * resDim[1];

  /* y-a-t'il une deformation ?
   */
  if ( (defxIm == (Inrimage *)NULL) || (defxIm->getData() == (char*)NULL) ||
       (defyIm == (Inrimage *)NULL) || (defyIm->getData() == (char*)NULL) ||
       (defzIm == (Inrimage *)NULL) || (defzIm->getData() == (char*)NULL) ) {
    /* pas de deformation ? => y-a-t'il une matrice ?
     */
    if ( theMat == (double*)NULL ) return;
    
    /* on reechantillonne avec une matrice 
     */
    
    if (theIm->getType() != resIm->getType())
      CERR << " Input and output images have different types in " << proc << ENDL;


    /* tmat4TOdoublearray( theMat, mat ); */
    Matrix4x4<double> tmp_mat(theMat);
    Inrimage::WORD_TYPE resIm_type = resIm->getType();
    unsigned int resIm_xdim = resIm->getX(), resIm_ydim = resIm->getY(), resIm_zdim = resIm->getY();
    delete resIm;
    resIm = resample4x4TriLinear (theIm, tmp_mat, resIm_type, resIm_xdim, resIm_ydim, resIm_zdim, gain, bias);

  } else {
    /* on a une deformation
     */

   if ( (resIm->getX() != defxIm->getX()) || (resIm->getX() != defyIm->getX()) ||
	(resIm->getX() != defzIm->getX()) )
     CERR << "Output and deformation images have different X dimensions in " << proc << ENDL;
   if ( (resIm->getY() != defxIm->getY()) || (resIm->getY() != defyIm->getY()) ||
	(resIm->getY() != defzIm->getY()) )
     CERR << "Output and deformation images have different Y dimensions in " << proc << ENDL;
   if ( (resIm->getZ() != defxIm->getZ()) || (resIm->getZ() != defyIm->getZ()) ||
	(resIm->getZ() != defzIm->getZ()) )
     CERR << "Output and deformation images have different Z dimensions in " << proc << ENDL;
   if ( (defxIm->getType() != Inrimage::WT_FLOAT) || (defyIm->getType() != Inrimage::WT_FLOAT) || 
	(defzIm->getType() != Inrimage::WT_FLOAT) )
     CERR << "Deformation images do not have float type in " << proc << ENDL;

    /* verification de la matrice.
     * Si elle est NULL, on prend l'identite.
     */
   
   if ( theMat != (double*)NULL ) {
     /* tmat4TOdoublearray( theMat, mat ); */
     for ( i = 0; i<16; i++, theMat++ )
       mat[i] = *theMat;
   } else {
     for ( i = 0; i < 16; i++ ) mat[i] = 0.0;
     mat[0] = mat[5] = mat[10] = mat[15] = 1.0;
   }
   
   
   
   /* allocation of auxiliary slice 
    */
   
   if ( resIm->getType() != Inrimage::WT_FLOAT ) {
     /*
       resSlice = (float*)T_Alloc( (unsigned int)( dxy * sizeof(float) ) );
       E_ISERRN( proc, "Can not allocate auxiliary slice" );
     */
     resSlice = new float [ dxy ];
   }
   
   for ( z = 0; z < resDim[2]; z ++ ) {
     /* COUT << " slice number "<< z << ENDL; */
          
     /* on recupere les bons plans pour 
      * l'image resultat
      * et les deformations
      */
      
     if ( resIm->getType() == Inrimage::WT_FLOAT ) {
       resSlice = (float*)(resIm->getData());
       resSlice += z * dxy;
     }
     defSlice[0] = (float*)(defxIm->getData()); 
     defSlice[1] = (float*)(defyIm->getData()); 
     defSlice[2] = (float*)(defzIm->getData()); 
     defSlice[0] += z * dxy;
     defSlice[1] += z * dxy;
     defSlice[2] += z * dxy;
 
     /* computation of slice #z of result image 
      */
     
     switch ( theIm->getType() ) {
     case Inrimage::WT_UNSIGNED_CHAR :
       ReechTriLinDefSliceBuffer <unsigned char> ((unsigned char *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_UNSIGNED_SHORT:
       ReechTriLinDefSliceBuffer <unsigned short int> ((unsigned short int *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
      case Inrimage::WT_SIGNED_SHORT :
	ReechTriLinDefSliceBuffer < short int> (( short int *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
	break;
     case Inrimage::WT_UNSIGNED_INT :
       ReechTriLinDefSliceBuffer <unsigned int> ((unsigned int *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_SIGNED_INT :
       ReechTriLinDefSliceBuffer < int> (( int *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_UNSIGNED_LONG :
       ReechTriLinDefSliceBuffer <unsigned LONGINT> ((unsigned LONGINT *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_SIGNED_LONG :
       ReechTriLinDefSliceBuffer < LONGINT> (( LONGINT *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
     case Inrimage::WT_FLOAT :
       ReechTriLinDefSliceBuffer <float> ((float *)theIm->getData(), theDim, resSlice, resDim,defSlice, mat, z);
       break;
     case Inrimage::WT_DOUBLE :
       ReechTriLinDefSliceBuffer <double> ((double *)theIm->getData(), theDim, resSlice, resDim, defSlice, mat, z);
       break;
       
     case Inrimage::WT_RGB :
     case Inrimage::WT_RGBA :
     case Inrimage::WT_FLOAT_VECTOR :
     case Inrimage::WT_DOUBLE_VECTOR :
     default :
       /* if ( resIm->type != TYPEIM_FLOAT ) (void)free( resSlice );
	  E_XERRN( E_ERRMISMATCH, proc,
	  "Can not deal with such input image type" );*/
       
       CERR << "Le type de l'image d'entree n'est pas supporte dans " << proc <<ENDL;
       
     }
     
      
     /* transformation with gain and bias 
      */
     rs = resSlice;
     
     if ( (bias != 0.0 ) && (gain != 1.0 ) ) {
       for ( i = 0; i < dxy; i++, rs++ ) 
	 *rs = (float)((*rs * g) + b);
     } else if ( (gain != 1.0 ) && (bias == 0.0 ) ) {
       for ( i = 0; i < dxy; i++, rs++ ) 
	 *rs *= (float)g;
     } else if ( (gain == 1.0 ) && (bias != 0.0 ) ) {
       for ( i = 0; i < dxy; i++, rs++ ) 
	 *rs += (float)b;
     }
     
     /* conversion into type of result image 
      */
     switch ( resIm->getType() ) {
     case Inrimage::WT_UNSIGNED_CHAR :
       {
	 unsigned char *resBuf = (unsigned char*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < unsigned char, float > ( (unsigned char *)0, (float *)0, resSlice, resBuf, dxy );
       }
     break;
     case  Inrimage::WT_UNSIGNED_SHORT :
       {
	 unsigned short int *resBuf = (unsigned short int*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < unsigned short int, float > ( (unsigned short int *)0, (float *)0, resSlice, resBuf, dxy );
       }
     break;
     case Inrimage::WT_SIGNED_SHORT:
       {
	 short int *resBuf = (short int*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < short int, float > ( ( short int *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_UNSIGNED_INT:
       {
	 unsigned int *resBuf = (unsigned int*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < unsigned int, float > ( (unsigned int *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_SIGNED_INT:
       {
	 int *resBuf = ( int*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < int, float > ( ( int *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_UNSIGNED_LONG:
       {
	 unsigned LONGINT *resBuf = (unsigned LONGINT*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < unsigned LONGINT, float > ( (unsigned LONGINT *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_SIGNED_LONG:
       {
	 LONGINT *resBuf = ( LONGINT*)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < LONGINT, float > ( ( LONGINT *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;
     case Inrimage::WT_FLOAT :
       break;
     case Inrimage::WT_DOUBLE:
       {
	 double *resBuf = (double *)resIm->getData();
	 resBuf += (z*dxy);
	 ConvertBuffer < double, float > ( (double *)0, (float *)0, resSlice, resBuf, dxy );
       }
       break;

     case Inrimage::WT_RGB:
     case Inrimage::WT_RGBA:
     case Inrimage::WT_FLOAT_VECTOR:
     case Inrimage::WT_DOUBLE_VECTOR:

     default :
       if ( resIm->getType() != Inrimage::WT_FLOAT ) delete resSlice;
       CERR << "Le type de l'image resultat " <<resIm->getType() << "n'est pas supporte dans "<< proc << ENDL;
       
      }

   }

   if ( resIm->getType() != Inrimage::WT_FLOAT ) delete resSlice;

  }

}



Inrimage *resampleDefTriLinear ( Inrimage *theBuf, Inrimage *defx, Inrimage *defy, Inrimage *defz, Matrix4x4<double> &m, Inrimage::WORD_TYPE wt, double vx, double vy, double vz, float gain, float bias ) {


  char *proc = "Inrimage *resampleDefTriLin ( Inrimage *theBuf, Inrimage *defx, Inrimage *defy, Inrimage *defz, Matrix4x4<double> &mat, float gain = 1, float bias = 0 )";
  Inrimage *resBuf = new Inrimage(theBuf->getX(), theBuf->getY(), theBuf->getZ(), wt, 1, VM_SCALAR, (float)vx, (float)vy, (float)vz); 

  double mat[16]  = { m(0,0), m(0,1), m(0,2), m(0,3),  \
		      m(1,0), m(1,1), m(1,2), m(1,3),  \
		      m(2,0), m(2,1), m(2,2), m(2,3),  \
		      m(3,0), m(3,1), m(3,2), m(3,3) }; 

  switch (theBuf->getType()) {    
       
  case Inrimage::WT_UNSIGNED_CHAR :
  case Inrimage::WT_UNSIGNED_SHORT :
  case Inrimage::WT_SIGNED_SHORT :
  case Inrimage::WT_UNSIGNED_INT :
  case Inrimage::WT_SIGNED_INT :
  case Inrimage::WT_UNSIGNED_LONG :
  case Inrimage::WT_SIGNED_LONG :
  case Inrimage::WT_FLOAT :
  case Inrimage::WT_DOUBLE :
    ReechDefTriLinBuffer ( theBuf, resBuf, defx, defy, defz, mat, gain, bias );
    break;	

  case Inrimage::WT_RGB :
  case Inrimage::WT_RGBA :
  case Inrimage::WT_FLOAT_VECTOR :
  case Inrimage::WT_DOUBLE_VECTOR :
    CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 

  default :
    CERR << " Le type de l'image d'entree n'est pas supporte dans " << proc <<ENDL; 
    break;

  }

  return resBuf;

}





Inrimage *resampleDefCSpline ( Inrimage *theBuf, Inrimage *defx, Inrimage *defy, Inrimage *defz, Matrix4x4<double> &m, Inrimage::WORD_TYPE wt, RESAMPLE_FILTER_DERIVATIVE deri[3], double vx, double vy, double vz ) {


  char *proc = "Inrimage *resampleDefCSpline (Inrimage *theBuf, Inrimage *defx, Inrimage *defy, Inrimage *defz, Matrix4x4<double> &m, RESAMPLE_FILTER_DERIVATIVE deri[3])" ;
  Inrimage *resBuf = new Inrimage(theBuf->getX(), theBuf->getY(), theBuf->getZ(), wt, 1, VM_SCALAR, (float)vx, (float)vy, (float)vz); 

  float *theDef[3];

  if ( (defx->getType() != Inrimage::WT_FLOAT) || 
       (defy->getType() != Inrimage::WT_FLOAT) || 
       (defz->getType() != Inrimage::WT_FLOAT) )
  CERR << " Les images de deformation doivent etre de type FLOAT dans " << proc << ENDL;

  theDef[0]=(float *)(defx->getData());
  theDef[1]=(float *)(defy->getData());
  theDef[2]=(float *)(defz->getData());
  
  int theDim[3] = { theBuf->getX(), theBuf->getY(), theBuf->getZ() };
  int resDim[3] = { resBuf->getX(), resBuf->getY(), resBuf->getZ() }; 

  double mat[16]  = { m(0,0), m(0,1), m(0,2), m(0,3),  \
		      m(1,0), m(1,1), m(1,2), m(1,3),  \
		      m(2,0), m(2,1), m(2,2), m(2,3),  \
		      m(3,0), m(3,1), m(3,2), m(3,3) }; 

  int derivative[3];

  for (int i=0; i<3; ++i )
      derivative[i]=deri[i];

  switch (theBuf->getType()) {    
       
  case Inrimage::WT_UNSIGNED_CHAR : 

    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR : 
      ReechCSplineDef < unsigned char, unsigned char >( (unsigned char *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT :
      ReechCSplineDef < unsigned char, unsigned short >( (unsigned char *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT :
      ReechCSplineDef < unsigned char, signed short >( (unsigned char *)theBuf->getData(), theDim, (signed short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT :
      ReechCSplineDef < unsigned char, unsigned int >( (unsigned char *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT :
      ReechCSplineDef < unsigned char, signed int >( (unsigned char *)theBuf->getData(), theDim, (signed int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG :
      ReechCSplineDef < unsigned char, unsigned long >( (unsigned char *)theBuf->getData(), theDim, (unsigned long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG :
      ReechCSplineDef < unsigned char, signed long >( (unsigned char *)theBuf->getData(), theDim, (signed long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_FLOAT :
      ReechCSplineDef < unsigned char, float >( (unsigned char *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE :
      ReechCSplineDef < unsigned char, double >( (unsigned char *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
      
    case Inrimage::WT_RGB :
    case Inrimage::WT_RGBA :
    case Inrimage::WT_FLOAT_VECTOR :
    case Inrimage::WT_DOUBLE_VECTOR :
      CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
      break;
    default :
      CERR << " Le type de l'image de sortie n'est pas supporte dans " << proc <<ENDL; 
      break;
      
    }
    
    break;



  case Inrimage::WT_UNSIGNED_SHORT :

    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR : 
      ReechCSplineDef < unsigned short, unsigned char >( (unsigned short *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT :
      ReechCSplineDef < unsigned short, unsigned short >( (unsigned short *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT :
      ReechCSplineDef < unsigned short, signed short >( (unsigned short *)theBuf->getData(), theDim, (signed short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT :
      ReechCSplineDef < unsigned short, unsigned int >( (unsigned short *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT :
      ReechCSplineDef < unsigned short, signed int >( (unsigned short *)theBuf->getData(), theDim, (signed int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG :
      ReechCSplineDef < unsigned short, unsigned long >( (unsigned short *)theBuf->getData(), theDim, (unsigned long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG :
      ReechCSplineDef < unsigned short, signed long >( (unsigned short *)theBuf->getData(), theDim, (signed long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_FLOAT :
      ReechCSplineDef < unsigned short, float >( (unsigned short *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE :
      ReechCSplineDef < unsigned short, double >( (unsigned short *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
      
    case Inrimage::WT_RGB :
    case Inrimage::WT_RGBA :
    case Inrimage::WT_FLOAT_VECTOR :
    case Inrimage::WT_DOUBLE_VECTOR :
      CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
      break;
    default :
      CERR << " Le type de l'image de sortie n'est pas supporte dans " << proc <<ENDL; 
      break;
      
    }





    break;
  case Inrimage::WT_SIGNED_SHORT :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR : 
      ReechCSplineDef < signed short, unsigned char >( (signed short *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT :
      ReechCSplineDef < signed short, unsigned short >( (signed short *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT :
      ReechCSplineDef < signed short, signed short >( (signed short *)theBuf->getData(), theDim, (signed short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT :
      ReechCSplineDef < signed short, unsigned int >( (signed short *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT :
      ReechCSplineDef < signed short, signed int >( (signed short *)theBuf->getData(), theDim, (signed int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG :
      ReechCSplineDef < signed short, unsigned long >( (signed short *)theBuf->getData(), theDim, (unsigned long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG :
      ReechCSplineDef < signed short, signed long >( (signed short *)theBuf->getData(), theDim, (signed long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_FLOAT :
      ReechCSplineDef < signed short, float >( (signed short *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE :
      ReechCSplineDef < signed short, double >( (signed short *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
      
    case Inrimage::WT_RGB :
    case Inrimage::WT_RGBA :
    case Inrimage::WT_FLOAT_VECTOR :
    case Inrimage::WT_DOUBLE_VECTOR :
      CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
      break;
    default :
      CERR << " Le type de l'image de sortie n'est pas supporte dans " << proc <<ENDL; 
      break;
      
    }

    break;
  case Inrimage::WT_UNSIGNED_INT :

    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR : 
      ReechCSplineDef < unsigned int, unsigned char >( (unsigned int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT :
      ReechCSplineDef < unsigned int, unsigned short >( (unsigned int *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT :
      ReechCSplineDef < unsigned int, signed short >( (unsigned int *)theBuf->getData(), theDim, (signed short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT :
      ReechCSplineDef < unsigned int, unsigned int >( (unsigned int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT :
      ReechCSplineDef < unsigned int, signed int >( (unsigned int *)theBuf->getData(), theDim, (signed int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG :
      ReechCSplineDef < unsigned int, unsigned long >( (unsigned int *)theBuf->getData(), theDim, (unsigned long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG :
      ReechCSplineDef < unsigned int, signed long >( (unsigned int *)theBuf->getData(), theDim, (signed long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_FLOAT :
      ReechCSplineDef < unsigned int, float >( (unsigned int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE :
      ReechCSplineDef < unsigned int, double >( (unsigned int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
      
    case Inrimage::WT_RGB :
    case Inrimage::WT_RGBA :
    case Inrimage::WT_FLOAT_VECTOR :
    case Inrimage::WT_DOUBLE_VECTOR :
      CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
      break;
    default :
      CERR << " Le type de l'image de sortie n'est pas supporte dans " << proc <<ENDL; 
      break;
      
    }

    break;
  case Inrimage::WT_SIGNED_INT :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR : 
      ReechCSplineDef < signed int, unsigned char >( (signed int *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT :
      ReechCSplineDef < signed int, unsigned short >( (signed int *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT :
      ReechCSplineDef < signed int, signed short >( (signed int *)theBuf->getData(), theDim, (signed short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT :
      ReechCSplineDef < signed int, unsigned int >( (signed int *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT :
      ReechCSplineDef < signed int, signed int >( (signed int *)theBuf->getData(), theDim, (signed int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG :
      ReechCSplineDef < signed int, unsigned long >( (signed int *)theBuf->getData(), theDim, (unsigned long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG :
      ReechCSplineDef < signed int, signed long >( (signed int *)theBuf->getData(), theDim, (signed long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_FLOAT :
      ReechCSplineDef < signed int, float >( (signed int *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE :
      ReechCSplineDef < signed int, double >( (signed int *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
      
    case Inrimage::WT_RGB :
    case Inrimage::WT_RGBA :
    case Inrimage::WT_FLOAT_VECTOR :
    case Inrimage::WT_DOUBLE_VECTOR :
      CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
      break;
    default :
      CERR << " Le type de l'image de sortie n'est pas supporte dans " << proc <<ENDL; 
      break;
      
    }

    break;
  case Inrimage::WT_UNSIGNED_LONG :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR : 
      ReechCSplineDef < unsigned long, unsigned char >( (unsigned long *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT :
      ReechCSplineDef < unsigned long, unsigned short >( (unsigned long *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT :
      ReechCSplineDef < unsigned long, signed short >( (unsigned long *)theBuf->getData(), theDim, (signed short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT :
      ReechCSplineDef < unsigned long, unsigned int >( (unsigned long *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT :
      ReechCSplineDef < unsigned long, signed int >( (unsigned long *)theBuf->getData(), theDim, (signed int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG :
      ReechCSplineDef < unsigned long, unsigned long >( (unsigned long *)theBuf->getData(), theDim, (unsigned long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG :
      ReechCSplineDef < unsigned long, signed long >( (unsigned long *)theBuf->getData(), theDim, (signed long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_FLOAT :
      ReechCSplineDef < unsigned long, float >( (unsigned long *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE :
      ReechCSplineDef < unsigned long, double >( (unsigned long *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
      
    case Inrimage::WT_RGB :
    case Inrimage::WT_RGBA :
    case Inrimage::WT_FLOAT_VECTOR :
    case Inrimage::WT_DOUBLE_VECTOR :
      CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
      break;
    default :
      CERR << " Le type de l'image de sortie n'est pas supporte dans " << proc <<ENDL; 
      break;
      
    }

    break;
  case Inrimage::WT_SIGNED_LONG :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR : 
      ReechCSplineDef < signed long, unsigned char >( (signed long *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT :
      ReechCSplineDef < signed long, unsigned short >( (signed long *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT :
      ReechCSplineDef < signed long, signed short >( (signed long *)theBuf->getData(), theDim, (signed short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT :
      ReechCSplineDef < signed long, unsigned int >( (signed long *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT :
      ReechCSplineDef < signed long, signed int >( (signed long *)theBuf->getData(), theDim, (signed int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG :
      ReechCSplineDef < signed long, unsigned long >( (signed long *)theBuf->getData(), theDim, (unsigned long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG :
      ReechCSplineDef < signed long, signed long >( (signed long *)theBuf->getData(), theDim, (signed long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_FLOAT :
      ReechCSplineDef < signed long, float >( (signed long *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE :
      ReechCSplineDef < signed long, double >( (signed long *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
      
    case Inrimage::WT_RGB :
    case Inrimage::WT_RGBA :
    case Inrimage::WT_FLOAT_VECTOR :
    case Inrimage::WT_DOUBLE_VECTOR :
      CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
      break;
    default :
      CERR << " Le type de l'image de sortie n'est pas supporte dans " << proc <<ENDL; 
      break;
      
    }

    break;
  case Inrimage::WT_FLOAT :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR : 
      ReechCSplineDef < float, unsigned char >( (float *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT :
      ReechCSplineDef < float, unsigned short >( (float *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT :
      ReechCSplineDef < float, signed short >( (float *)theBuf->getData(), theDim, (signed short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT :
      ReechCSplineDef < float, unsigned int >( (float *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT :
      ReechCSplineDef < float, signed int >( (float *)theBuf->getData(), theDim, (signed int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG :
      ReechCSplineDef < float, unsigned long >( (float *)theBuf->getData(), theDim, (unsigned long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG :
      ReechCSplineDef < float, signed long >( (float *)theBuf->getData(), theDim, (signed long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_FLOAT :
      ReechCSplineDef < float, float >( (float *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE :
      ReechCSplineDef < float, double >( (float *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
      
    case Inrimage::WT_RGB :
    case Inrimage::WT_RGBA :
    case Inrimage::WT_FLOAT_VECTOR :
    case Inrimage::WT_DOUBLE_VECTOR :
      CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
      break;
    default :
      CERR << " Le type de l'image de sortie n'est pas supporte dans " << proc <<ENDL; 
      break;
      
    }

    break;
  case Inrimage::WT_DOUBLE :
    switch (resBuf->getType()) {
    case Inrimage::WT_UNSIGNED_CHAR : 
      ReechCSplineDef < double, unsigned char >( (double *)theBuf->getData(), theDim, (unsigned char *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_SHORT :
      ReechCSplineDef < double, unsigned short >( (double *)theBuf->getData(), theDim, (unsigned short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_SHORT :
      ReechCSplineDef < double, signed short >( (double *)theBuf->getData(), theDim, (signed short *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_INT :
      ReechCSplineDef < double, unsigned int >( (double *)theBuf->getData(), theDim, (unsigned int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_INT :
      ReechCSplineDef < double, signed int >( (double *)theBuf->getData(), theDim, (signed int *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_UNSIGNED_LONG :
      ReechCSplineDef < double, unsigned long >( (double *)theBuf->getData(), theDim, (unsigned long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_SIGNED_LONG :
      ReechCSplineDef < double, signed long >( (double *)theBuf->getData(), theDim, (signed long *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_FLOAT :
      ReechCSplineDef < double, float >( (double *)theBuf->getData(), theDim, (float *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
    case Inrimage::WT_DOUBLE :
      ReechCSplineDef < double, double >( (double *)theBuf->getData(), theDim, (double *)resBuf->getData(), resDim, theDef, mat, derivative);
      break;
      
    case Inrimage::WT_RGB :
    case Inrimage::WT_RGBA :
    case Inrimage::WT_FLOAT_VECTOR :
    case Inrimage::WT_DOUBLE_VECTOR :
      CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
      break;
    default :
      CERR << " Le type de l'image de sortie n'est pas supporte dans " << proc <<ENDL; 
      break;
      
    }

    break;

  case Inrimage::WT_RGB :
  case Inrimage::WT_RGBA :
  case Inrimage::WT_FLOAT_VECTOR :
  case Inrimage::WT_DOUBLE_VECTOR :
    CERR << " Les types WT_RGB WT_RGBA WT_FLOAT_VECTOR WT_DOUBLE_VECTOR ne sont pas supporte dans " << proc <<ENDL; 
    break;
  default :
    CERR << " Le type de l'image d'entree n'est pas supporte dans " << proc <<ENDL; 
    break;

  }

  return resBuf;

}


Inrimage * reformat(Inrimage *inr, unsigned int  orix, unsigned int  oriy, unsigned int  oriz, unsigned int  endx, unsigned int  endy, unsigned int  endz, 
					SLICE_ORIENTATION geom, Matrix4x4<double> *&transfo, bool verticalAxis){
  
  Inrimage *res;
  
  // angle de la ligne => |alpha|<(pi/2) et c'est bien ce qu'on veut !
  double alpha =0.0;
  switch (geom) {
  case SLICE_X:
    alpha = atan((((double)oriy)-((double)endy))*inr->getVY()/(((double)endz)-((double)oriz))/inr->getVZ());
    break;
  case SLICE_Y:
    alpha = atan((((double)oriz)-((double)endz))*inr->getVZ()/(((double)endx)-((double)orix))/inr->getVX());
    break;
  case SLICE_Z:
    alpha = atan((((double)oriy)-((double)endy))*inr->getVY()/(((double)endx)-((double)orix))/inr->getVX());
    break;
  default:
    break;
  }
  //double alpha = atan((((double)l->ori[1])-((double)l->end[1]))*inr->getVX()/(((double)l->end[0])-((double)l->ori[0]))/inr->getVY());

  // si on est en mode vertical
  if (verticalAxis)
    if (alpha<0)
      alpha = alpha + (M_PI/2);
    else 
      alpha = alpha - (M_PI/2);
	
 
  // centre de l'image
  double ori_x, ori_y, ori_z;
  ori_x = (((double)inr->getX())/2.0*inr->getVX());
  ori_y = (((double)inr->getY())/2.0*inr->getVY());
  ori_z = (((double)inr->getZ())/2.0*inr->getVZ());
  
  //Matrix4x4<double> mat
  double m[4][4];

  switch (geom) {
  case SLICE_Z:
    m[0][0]=cos(alpha);        m[0][1]=-sin(alpha);       m[0][2]=0.0;                 m[0][3]=ori_x*(1-cos(alpha))+ori_y*sin(alpha);
    m[1][0]=sin(alpha);        m[1][1]=cos(alpha);        m[1][2]=0.0;                 m[1][3]=ori_y*(1-cos(alpha))-ori_x*sin(alpha);
    m[2][0]=0.0;               m[2][1]=0.0;               m[2][2]=1.0;                 m[2][3]=0.0;  
    m[3][0]=0.0;               m[3][1]=0.0;               m[3][2]=0.0;                 m[3][3]=1.0;
    break;
  case SLICE_Y:
    m[0][0]=cos(alpha);        m[0][1]=0.0;               m[0][2]=-sin(alpha);         m[0][3]=ori_x*(1-cos(alpha))+ori_z*sin(alpha);
    m[1][0]=0.0;               m[1][1]=1.0;               m[1][2]=0.0;                 m[1][3]=0.0;
    m[2][0]=sin(alpha);        m[2][1]=0.0;               m[2][2]=cos(alpha);          m[2][3]=ori_z*(1-cos(alpha))-ori_x*sin(alpha);  
    m[3][0]=0.0;               m[3][1]=0.0;               m[3][2]=0.0;                 m[3][3]=1.0;
    break;
  case SLICE_X:
    m[0][0]=1.0;               m[0][1]=0.0;               m[0][2]=0.0;                 m[0][3]=0.0;
    m[1][0]=0.0;               m[1][1]=cos(alpha);        m[1][2]=-sin(alpha);         m[1][3]=ori_y*(1-cos(alpha))-ori_z*sin(alpha);
    m[2][0]=0.0;               m[2][1]=sin(alpha);        m[2][2]=cos(alpha);          m[2][3]=ori_z*(1-cos(alpha))+ori_y*sin(alpha);  
    m[3][0]=0.0;               m[3][1]=0.0;               m[3][2]=0.0;                 m[3][3]=1.0;
    
    break;
  default:
    CERR << " Invalid geometry in reformatCmd " << ENDL;
    break;
  }

  Matrix4x4<double> mat(m);
  mat.inv(mat);
  
  double v[4][4];
  double inv_v[4][4];
  v[0][0]=inr->getVX();  v[0][1]=0.0;           v[0][2]=0.0;           v[0][3]=0.0;
  v[1][0]=0.0;           v[1][1]=inr->getVY();  v[1][2]=0.0;           v[1][3]=0.0;
  v[2][0]=0.0;           v[2][1]=0.0;           v[2][2]=inr->getVZ();  v[2][3]=0.0;
  v[3][0]=0.0;           v[3][1]=0.0;           v[3][2]=0.0;           v[3][3]=1.0;
  inv_v[0][0]=1.0/inr->getVX();  inv_v[0][1]=0.0;               inv_v[0][2]=0.0;               inv_v[0][3]=0.0;
  inv_v[1][0]=0.0;               inv_v[1][1]=1.0/inr->getVY();  inv_v[1][2]=0.0;               inv_v[1][3]=0.0;
  inv_v[2][0]=0.0;               inv_v[2][1]=0.0;               inv_v[2][2]=1.0/inr->getVZ();  inv_v[2][3]=0.0;
  inv_v[3][0]=0.0;               inv_v[3][1]=0.0;               inv_v[3][2]=0.0;               inv_v[3][3]=1.0;

  Matrix4x4<double> mat_v(v);
  Matrix4x4<double> mat_inv_v(inv_v);
  
  mat = mat_inv_v * mat * mat_v;
  
  transfo = new Matrix4x4<double>(mat);

  res = resample4x4TriLinear(inr, mat, inr->getType(), inr->getX(), inr->getY(), inr->getZ(), inr->getVX(), inr->getVY(), inr->getVZ());

  return res;
}


} // namespace yav
