/*=========================================================================

Program:   Insight Segmentation & Registration Toolkit
Module:    $RCSfile: mipsInrimageImageIOFactory.cxx,v $
Language:  C++
Date:      $Date: 2002/12/20 18:22:43 $
Version:   $Revision: 1.1 $

Copyright (c) 2002 Insight Consortium. All rights reserved.
See ITKCopyright.txt or http://www.itk.org/HTML/Copyright.htm for details.

This software is distributed WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
PURPOSE.  See the above copyright notices for more information.

=========================================================================*/
#include "mipsInrimageImageIOFactory.h"
#include "itkCreateObjectFunction.h"
#include "mipsInrimageImageIO.h"
#include "itkVersion.h"


namespace itk
{
  void InrimageImageIOFactory::PrintSelf(std::ostream& os, Indent indent) const
  {

  }


  // on doit faire 
  // itk::ObjectFactoryBase::RegisterFactory( itk::InrimageImageIOFactory::New() );
  // quelque part pour que l'enregistrement se fasse
  InrimageImageIOFactory::InrimageImageIOFactory()
  {
    this->RegisterOverride("itkImageIOBase",
        "mipsInrimageImageIO",
        "Inrimage Image IO",
        1,
        CreateObjectFunction<InrimageImageIO>::New());
  }

  InrimageImageIOFactory::~InrimageImageIOFactory()
  {
  }

  const char*
    InrimageImageIOFactory::GetITKSourceVersion(void) const
    {
      return ITK_SOURCE_VERSION;
    }

  const char*
    InrimageImageIOFactory::GetDescription() const
    {
      return "Inrimage ImageIO Factory, allows the loading of Inrimage images into insight";
    }

} // end namespace itk

