#include <inrimage/Inrimage4D.h>


using namespace yav;

static void usage(char *name);

/* Main: let's go */
int main(int argc, char **argv) {
  if (argc==1)
    usage(argv[0]);
  else if (argc==2) {
    usage(argv[0]);
  }
  else  if (argc==3) {
    int posStar= -1;
    unsigned int i;
    for(i=0;i<strlen(argv[2]);++i)
      {
	if (argv[2][i]=='*')
	  posStar=i;
      }
    if (posStar<0)
      {
	fprintf(stderr, "Could find wildcard character in %s", argv[2]);
	exit(0);
      }
    else
      {
	char *baseName=new char[posStar+2];
	strncpy(baseName,argv[2],posStar);
	baseName[posStar]='\0';
	char *ext=argv[2]+posStar+1;
	int firstIndex= -1;
	for(i=0;(i<2) && (firstIndex<0);++i)
	  {
	    TclString fileName;
	    fileName.sprintf("%s%u%s",baseName,i,ext);
	    if (fopen((char *)fileName,"r")!=NULL)
	      firstIndex=i;
	  }
	if (firstIndex<0)
	  {
	    fprintf(stderr, "Could find file %s0%s or %s1%s\n",
		    baseName,ext,baseName,ext);
	    exit(0);
	  }
	else
	  {
	    std::list<Inrimage *> inrList;
	    bool foundFile=true;
	    i=firstIndex;
	    do {
	      TclString fileName;
	      
	      try {	
		fileName.sprintf("%s%u%s",baseName,i++,ext);
		Inrimage *im=new Inrimage((char *)fileName);
		inrList.push_back(im);
	      }
	      catch(Inrimage::ImageNotFound) {
		fprintf(stderr, "%s: warning: file \'%s\' not found\n", argv[0], (char *) fileName);
		foundFile=false;
	      }
	      catch(...) {
		foundFile=false;
	      }
	    } while(foundFile==true);
	    if (inrList.size()>1)
	      { 
		Inrimage4D *im4D;
		try {
		  im4D= new Inrimage4D(inrList);
		}
		catch(Inrimage4D::DifferentImageType)
		  {
		    fprintf(stderr, "%s: error: images do not all have the same type \n", argv[0]);
		    exit(0);
		  }
		catch(Inrimage4D::DifferentImageSize)
		  {
		    fprintf(stderr, "%s: error: images do not all have the same size \n", argv[0]);
		    exit(0);
		  }
		im4D->write(argv[1]);
	      }
	  }
      }
  }
  else if (argc>3)
    {
      unsigned int i;
      bool ok=true;
      std::list<Inrimage *> inrList;
      for(i=2;(i<(unsigned int)argc) && (ok==true);++i) {
	try {	
	  Inrimage *im=new Inrimage((char *)argv[i]);
	  inrList.push_back(im);
	}
	catch(Inrimage::ImageNotFound) {
	  fprintf(stderr, "%s: warning: file \'%s\' not found\n", argv[0], (char *) argv[i]);
	  ok=false;
	}
	catch(...) {
	  ok=false;
	}
      } 
      if (inrList.size()>1)
	{ 
	  Inrimage4D *im4D;
	  try {
	    im4D= new Inrimage4D(inrList);
	  }
	  catch(Inrimage4D::DifferentImageType)
	    {
	      fprintf(stderr, "%s: error: images do not all have the same type \n", argv[0]);
	      exit(0);
	    }
	  catch(Inrimage4D::DifferentImageSize)
	    {
	      fprintf(stderr, "%s: error: images do not all have the same size \n", argv[0]);
	      exit(0);
	    }
	  im4D->write(argv[1]);
	}
    }
  return 0;
}









void usage(char *name) {
  fprintf(stderr, "usage: %s outputFileName [ image3D_file_1 image3D_file_2 ... | baseName*ext  | -help ]\n\
  image3D_file_1, image3D_file_2 : a set of 3D volumetric images of the same size and type\n\
   baseName*ext                  : describes a list of 3D volumetric images of the same size and type where * (wildcard) matches a number starting from 0 or 1 \n\
  -help                          : program usage\n",name);
  
  exit(0);
}

