#include <inrimage/Inrimage.h>

using namespace yav;

int usage(char* pName)
{
	CERR << "usage: " << pName << " <-help | image=%s intensity_to_put_into_background=%i" << ENDL;
	return(0);
}

/* Main: let's go */
int main(int argc, char** argv)
{
 try
 {
	unsigned int i, j, k, heightImage, widthImage, depthImage;
	double intensity, voxValue;
	
	// Check input parameters
	for(int l=0; l<argc; l++)
	{
      	if(!strcmp(argv[l], "-help"))
			return usage(argv[0]);
    	}
    	if(argc!=3)
		return usage(argv[0]);

	Inrimage* inputImage = new Inrimage(argv[1]);
	intensity = (double)(atof(argv[2]));

	Inrimage::WORD_TYPE myType = inputImage->getType();
	Voxel* voxel = Voxel::voxelByType(myType);

	// Check size of input images
	widthImage = inputImage->ncols();
	heightImage = inputImage->nrows();
	depthImage = inputImage->nplanes();

	// Put intensity to background
	for (k=0; k<depthImage; k++)
	{
		for (j=0; j<heightImage; j++)
		{
			for (i=0; i<widthImage; i++)
			{
				inputImage->getVoxel(i,j,k,*voxel);
				voxValue = voxel->getValueAsDouble();

				if (voxValue==intensity)
				{
					voxel->setValueFromDouble(0.0);
					inputImage->setVoxel(i,j,k,*voxel);
				}
			}
		}
	}

	// Write the modified mesh in the output	
	inputImage->write(argv[1]);
 }
 catch(Exception& e)
 {
	CERR << e << ENDL;
 }
 return(0);
}
