# Generate the MIPSConfig.cmake file in the build tree.  Also configure
# one for installation.  The file tells external projects how to use
# MIPS.

#-----------------------------------------------------------------------------
# Settings specific to the build tree.

# The install-only section is empty for the build tree.
SET(MIPS_CONFIG_INSTALL_ONLY)

# The "use" file.
SET(MIPS_USE_FILE ${MIPS_BINARY_DIR}/UseMIPS.cmake)

# The build settings file.
SET(MIPS_BUILD_SETTINGS_FILE ${MIPS_BINARY_DIR}/MIPSBuildSettings.cmake)

# Library directory.
SET(MIPS_LIBRARY_DIRS_CONFIG ${LIBRARY_OUTPUT_PATH})

# Runtime library directory.
SET(MIPS_RUNTIME_LIBRARY_DIRS_CONFIG ${LIBRARY_OUTPUT_PATH})

# Determine the include directories needed.
SET(MIPS_INCLUDE_DIRS_CONFIG
  ${MIPS_INCLUDE_DIRS_BUILD_TREE}
  ${MIPS_INCLUDE_DIRS_SYSTEM}
#  ${MIPS_INCLUDE_DIRS_SOURCE_TREE}
)


#-----------------------------------------------------------------------------
# Configure MIPSConfig.cmake for the build tree.
CONFIGURE_FILE(${MIPS_SOURCE_DIR}/MIPSConfig.cmake.in
               ${MIPS_BINARY_DIR}/MIPSConfig.cmake @ONLY IMMEDIATE)


#-----------------------------------------------------------------------------
# Settings specific to the install tree.

# The "use" file.
SET(MIPS_USE_FILE ${MIPS_INSTALL_PREFIX}/lib/UseMIPS.cmake)

# The build settings file.
SET(MIPS_BUILD_SETTINGS_FILE ${MIPS_INSTALL_PREFIX}/lib/MIPSBuildSettings.cmake)

# Include directories.
SET(MIPS_INCLUDE_DIRS_CONFIG
  ${MIPS_INSTALL_PREFIX}/include
  ${MIPS_INCLUDE_DIRS_SYSTEM}
)

# Link directories.
IF(CYGWIN AND BUILD_SHARED_LIBS)
  # In Cygwin programs directly link to the .dll files.
  SET(MIPS_LIBRARY_DIRS_CONFIG ${MIPS_INSTALL_PREFIX}/bin/)
ELSE(CYGWIN AND BUILD_SHARED_LIBS)
  SET(MIPS_LIBRARY_DIRS_CONFIG ${MIPS_INSTALL_PREFIX}/lib/)
ENDIF(CYGWIN AND BUILD_SHARED_LIBS)

# Runtime directories.
IF(WIN32)
  SET(MIPS_RUNTIME_LIBRARY_DIRS_CONFIG ${MIPS_INSTALL_PREFIX}/bin/)
ELSE(WIN32)
  SET(MIPS_RUNTIME_LIBRARY_DIRS_CONFIG ${MIPS_INSTALL_PREFIX}/lib/)
ENDIF(WIN32)


#-----------------------------------------------------------------------------
# Configure MIPSConfig.cmake for the install tree.
CONFIGURE_FILE(${MIPS_SOURCE_DIR}/MIPSConfig.cmake.in
               ${MIPS_BINARY_DIR}/Utilities/MIPSConfig.cmake @ONLY IMMEDIATE)