#-----------------------------------------------------------------------------
# Include directories for other projects installed on the system.
SET(MIPS_INCLUDE_DIRS_SYSTEM "")

IF(MKL_FOUND)
  SET(MIPS_INCLUDE_DIRS_SYSTEM
  ${MKL_INCLUDE_DIRS}
  ${MIPS_INCLUDE_DIRS_SYSTEM}
  )
ENDIF(MKL_FOUND)

IF(ACML_FOUND)
  SET(MIPS_INCLUDE_DIRS_SYSTEM
  ${ACML_INCLUDE_DIRS}
  ${MIPS_INCLUDE_DIRS_SYSTEM}
  )
ENDIF(ACML_FOUND)

#IF(USE_BOOST AND BOOST_FOUND)
IF(BOOST_FOUND)
  SET(MIPS_INCLUDE_DIRS_SYSTEM
  ${BOOST_DIR}
  ${MIPS_INCLUDE_DIRS_SYSTEM}
  )
#ENDIF(USE_BOOST AND BOOST_FOUND)
ENDIF(BOOST_FOUND)

IF(USE_PETSC)
  SET(MIPS_INCLUDE_DIRS_SYSTEM
  ${PETSC_DIR}
  ${METIS_INCLUDE_DIR}
  ${MIPS_INCLUDE_DIRS_SYSTEM}
  )
ENDIF(USE_PETSC)

IF(USE_CAVELIB)
  SET(MIPS_INCLUDE_DIRS_SYSTEM
  ${CAVELIB_INCLUDE_DIR}
  ${MIPS_INCLUDE_DIRS_SYSTEM}
  )
ENDIF(USE_CAVELIB)

IF(GMM_FOUND)
  SET(MIPS_INCLUDE_DIRS_SYSTEM
  ${GMM_INCLUDE_DIR}
  ${MIPS_INCLUDE_DIRS_SYSTEM}
  )
ENDIF(GMM_FOUND)


#-----------------------------------------------------------------------------
# Include directories from the build tree.
SET(MIPS_INCLUDE_DIRS_BUILD_TREE ${MIPS_BINARY_DIR})

# These directories are always needed.
SET(MIPS_INCLUDE_DIRS_BUILD_TREE ${MIPS_INCLUDE_DIRS_BUILD_TREE}
  ${MIPS_SOURCE_DIR}/StdPkgs/CorePkg/Basics/
  ${MIPS_SOURCE_DIR}/StdPkgs/CorePkg/Classification/
  ${MIPS_SOURCE_DIR}/StdPkgs/CorePkg/Framework/
  ${MIPS_SOURCE_DIR}/StdPkgs/CorePkg/LinearAlgebra/
  ${MIPS_SOURCE_DIR}/StdPkgs/GuiPkg/Graphics/
  ${MIPS_SOURCE_DIR}/StdPkgs/GuiPkg/Graphics2D/
  ${MIPS_SOURCE_DIR}/StdPkgs/GuiPkg/Graphics3D/
  ${MIPS_SOURCE_DIR}/StdPkgs/GuiPkg/LibGlade/
  ${MIPS_SOURCE_DIR}/StdPkgs/GuiPkg/GUI/
  ${MIPS_SOURCE_DIR}/StdPkgs/GuiPkg/MipsViewer/
  ${MIPS_SOURCE_DIR}/StdPkgs/GuiPkg/Modules/
  ${MIPS_SOURCE_DIR}/StdPkgs/GuiPkg/Yav/  
  ${MIPS_SOURCE_DIR}/StdPkgs/ImagePkg/EpidaureLib/
  ${MIPS_SOURCE_DIR}/StdPkgs/ImagePkg/ImageData/
  ${MIPS_SOURCE_DIR}/StdPkgs/ImagePkg/ImageGUI/
  ${MIPS_SOURCE_DIR}/StdPkgs/ImagePkg/ImageIO/
  ${MIPS_SOURCE_DIR}/StdPkgs/ImagePkg/ImportExport/
  ${MIPS_SOURCE_DIR}/StdPkgs/ImagePkg/Inrimage/
  ${MIPS_SOURCE_DIR}/StdPkgs/ImagePkg/ItkImageIO/
  ${MIPS_SOURCE_DIR}/StdPkgs/ImagePkg/Tools/
  ${MIPS_SOURCE_DIR}/StdPkgs/ImagePkg/ZViewer/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/Contour/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/ContourViewer/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/ImportExport/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/SM2/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/SmViewer/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/Tetrahedrisation/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/Tools/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/Triangulation/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/TrianSmTools/
  ${MIPS_SOURCE_DIR}/StdPkgs/MeshPkg/TrianViewer/
  ${MIPS_SOURCE_DIR}/SpecPkgs/FrontEndPkg/JavaViewer/
  ${MIPS_SOURCE_DIR}/SpecPkgs/FrontEndPkg/Wrapping/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/CIsosurf/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/ContourDeform/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/ContourImage/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/IsoSurface/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/LevelSets/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/ManualSegmentationGUI/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/SM2Image/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/SmDeform/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/TetraDeform/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/TetraImage/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/Tools/
  ${MIPS_SOURCE_DIR}/SpecPkgs/MeshImagePkg/TrianDeform/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/Baladin/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/CrestMatch/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/Demons/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/ItkAladin/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/MatchDeformation/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/MatchParametric/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/Pasha/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/ProbabilistcFeatures/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/Runa/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/Yasmina/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/ExtendedDemons/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/DiffeomorphicDemons4D/
  ${MIPS_SOURCE_DIR}/SpecPkgs/RegistrationPkg/DiffeomorphicDemonsTensors/
  ${MIPS_SOURCE_DIR}/SpecPkgs/ShapeStatistics/UCLA/
  ${MIPS_SOURCE_DIR}/SpecPkgs/ShapeGenerationPkg/ImplicitFunctions/
  ${MIPS_SOURCE_DIR}/SpecPkgs/ShapeGenerationPkg/ImplicitMeshes/
  ${MIPS_SOURCE_DIR}/SpecPkgs/SimulationPkg/Brain/
  ${MIPS_SOURCE_DIR}/SpecPkgs/SimulationPkg/CAVE/
  ${MIPS_SOURCE_DIR}/SpecPkgs/SimulationPkg/ForceFeedback/
  ${MIPS_SOURCE_DIR}/SpecPkgs/SimulationPkg/Heart/
  ${MIPS_SOURCE_DIR}/SpecPkgs/SimulationPkg/HeartDeform/
  ${MIPS_SOURCE_DIR}/SpecPkgs/SimulationPkg/SimuDeform/
  ${MIPS_SOURCE_DIR}/SpecPkgs/SimulationPkg/Simulation/
  ${MIPS_SOURCE_DIR}/SpecPkgs/TensorPkg/TensorToolKit/
  ${MIPS_SOURCE_DIR}/AuxPkgs/StdLibsPkg/Zlib/  
  ${MIPS_SOURCE_DIR}/AppPkgs/HeartElecPkg/HeartElecMath/
  ${MIPS_SOURCE_DIR}/AppPkgs/HeartElecPkg/HeartElecObject/
  ${MIPS_SOURCE_DIR}/AppPkgs/HeartElecPkg/HeartElecIO/
  ${MIPS_SOURCE_DIR}/AppPkgs/SepPkg/Tools/
  ${MIPS_SOURCE_DIR}/AppPkgs/SepPkg/Segme/          
  ${MIPS_SOURCE_DIR}/AppPkgs/HeartSegmentationPkg/SegmentationPipeline/
  ${MIPS_SOURCE_DIR}/AppPkgs/HeartGenerationPkg/ImplicitHeart/
)

IF (WIN32)
SET(MIPS_INCLUDE_DIRS_BUILD_TREE
  ${MIPS_INCLUDE_DIRS_BUILD_TREE}
  ${MIPS_SOURCE_DIR}/AuxPkgs/StdLibsPkg/Itl-win/
  ${MIPS_SOURCE_DIR}/AuxPkgs/StdLibsPkg/Mtl-win/
  ${MIPS_SOURCE_DIR}/Compatibility/getoptcompat  
)
ELSE (WIN32)
SET(MIPS_INCLUDE_DIRS_BUILD_TREE
  ${MIPS_INCLUDE_DIRS_BUILD_TREE}
  ${MIPS_SOURCE_DIR}/AuxPkgs/StdLibsPkg/Itl-unix/
  ${MIPS_SOURCE_DIR}/AuxPkgs/StdLibsPkg/Mtl-unix/
)
ENDIF(WIN32)






#-----------------------------------------------------------------------------
# Include directories from the install tree.

SET(MIPS_INSTALL_INCLUDE_PATH "${CMAKE_INSTALL_PREFIX}/include/")

SET(MIPS_INCLUDE_DIRS_INSTALL_TREE ${MIPS_INCLUDE_DIRS_INSTALL_TREE}
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/CorePkg/Basics/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/CorePkg/Classification/ 
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/CorePkg/Framework/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/CorePkg/LinearAlgebra/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/GuiPkg/Graphics/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/GuiPkg/Graphics2D/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/GuiPkg/Graphics3D/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/GuiPkg/LibGlade/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/GuiPkg/GUI/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/GuiPkg/MipsViewer/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/GuiPkg/Modules/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/GuiPkg/Yav/  
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/ImagePkg/EpidaureLib/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/ImagePkg/ImageData/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/ImagePkg/ImageGUI/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/ImagePkg/ImageIO/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/ImagePkg/ImportExport/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/ImagePkg/Inrimage/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/ImagePkg/ItkImageIO/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/ImagePkg/Tools/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/ImagePkg/ZViewer/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/Contour/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/ContourViewer/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/ImportExport/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/SM2/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/SmViewer/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/Tetrahedrisation/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/Tools/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/Triangulation/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/TrianSmTools/
  ${MIPS_INSTALL_INCLUDE_PATH}/StdPkgs/MeshPkg/TrianViewer/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/ApplicationManagement/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/DTITrack/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/HelloWorld/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/ImageViewer/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/JavaViewer/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/LesionsDelineation/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/RegistrationTool/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/TensorViewer/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/vtkViewing/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/Wrapping/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/wxAddOn/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/wxVtk/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/FrontEndPkg/MedINRIA/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/CIsosurf/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/ContourDeform/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/ContourImage/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/IsoSurface/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/LevelSets/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/ManualSegmentationGUI/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/SM2Image/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/SmDeform/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/TetraDeform/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/TetraImage/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/Tools/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/MeshImagePkg/TrianDeform/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/Baladin/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/CrestMatch/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/Demons/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/ItkAladin/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/MatchDeformation/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/MatchParametric/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/Pasha/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/ProbabilistcFeatures/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/Runa/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/Yasmina/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/ExtendedDemons/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/DiffeomorphicDemons4D/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/RegistrationPkg/DiffeomorphicDemonsTensors/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/ShapeStatistics/UCLA/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/SimulationPkg/Brain/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/SimulationPkg/CAVE/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/SimulationPkg/ForceFeedback/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/SimulationPkg/Heart/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/SimulationPkg/HeartDeform/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/SimulationPkg/SimuDeform/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/SimulationPkg/Simulation/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/TensorPkg/TensorToolKit/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/ShapeGenerationPkg/ImplicitFunctions/
  ${MIPS_INSTALL_INCLUDE_PATH}/SpecPkgs/ShapeGenerationPkg/ImplicitMeshes/
  ${MIPS_INSTALL_INCLUDE_PATH}/AuxPkgs/StdLibsPkg/Itl/
  ${MIPS_INSTALL_INCLUDE_PATH}/AuxPkgs/StdLibsPkg/Mtl/
  ${MIPS_INSTALL_INCLUDE_PATH}/AuxPkgs/StdLibsPkg/Zlib/  
  ${MIPS_INSTALL_INCLUDE_PATH}/AppPkgs/HeartElecPkg/HeartMath/
  ${MIPS_INSTALL_INCLUDE_PATH}/AppPkgs/HeartElecPkg/HeartObject/
  ${MIPS_INSTALL_INCLUDE_PATH}/AppPkgs/HeartSegmentationPkg/SegmentationPipeline/
  ${MIPS_INSTALL_INCLUDE_PATH}/AppPkgs/HeartGenerationPkg/ImplicitHeart/
)
