

namespace eval inrimage {
    global busy
    set busy 0
    
    set ListBoxLandmarks [list]
    set registertype rigid
    set reg_resample resample
    set registerimg inr2
    set resamplset 2
    
    set reformatLineOriX -1
    set reformatLineOriY -1
    set reformatLineEndX -1
    set reformatLineEndY -1
    set reformatLineSlice -1
    set reformatLineSel ori
    set current_reformat_slicecam no
    
    set dispMode WITHOUT_VECTOR
    set longMaxMode MAX2
    set normMode LINEAR
    set arrow true
    set svector true
    set useVoxelSize true
    set useAxis false
    set activate false
    set mval inr1
    set inrslicemenu {jk}
    set theImage {jk}
    set mview multiview1 
    
    set operator add
    set operand cst
    
    set con 4
    
    set cmd nocrop
    
    set oper binary
    set tcc {}
    set ncc all
    set output binary
    set df perona
    set dt 1.0
    set tmax 3.0
    set smooth false
    set sigma 1.0
    set quant 80.0
    set quantx 80.0
    set quanty 80.0
    set quantz 80.0
    set disk false
    set threshold -1.0
    set thresh -1.0
    set scheme aos
    set disk false
    set td matkrissian
    
    set filter rec
    set rfilter deriche
    set dim 3D
    
    set fromimage 1
    
    set cropImage none
}


proc inrimage::initManualSegmentationDialog { } {
    set root .manualSegmentation
    set bg "PeachPuff2"
    if {![winfo exists $root]} {
	toplevel $root -bg $bg
	frame $root.f
	button $root.f.inr -text "Load 3D Image" -command "new inr \[tk_getOpenFile -filetypes { {{3D Image} {.inr .inr.gz} } } \]; destroy $root; view inr1; new rlist inr1 scn2D1" -width 20 -height 5 -bg $bg
	button $root.f.rlist -text "Load Manual Delineation" -command "new rlist \[tk_getOpenFile -filetypes { {{3D Manual Delineation} {.rl} } } \]; destroy $root;view inr1 scn2D1;yav::interface" -width 20 -height 5 -bg $bg
	
	pack $root.f.inr -side left -expand true
	pack $root.f.rlist -side left -expand true
	pack $root.f
	
	frame $root.f2
	
	button $root.f2.inr -text "Load 3D Image\n Single Slice" -command "new inr \[tk_getOpenFile -filetypes { {{3D Image} {.inr .inr.gz} } } \]; destroy $root; inrimage::singleViewImage inr1; new rlist inr1 scn2D1" -width 20 -height 5 -bg $bg
	button $root.f2.rlist -text "Load Manual Delineation\n Single Slice" -command "new rlist \[tk_getOpenFile -filetypes { {{3D Manual Delineation} {.rl} } } \]; destroy $root;inrimage::singleViewImage inr1 Z scn2D1;yav::interface" -width 20 -height 5 -bg $bg
	
	pack $root.f2.inr -side left -expand true
	pack $root.f2.rlist -side left -expand true
	
	pack $root.f2 -side bottom
	
    }
}

proc inrimage::roiDialog { inr  scene color} {
set root .roiSurface
    if ![winfo exists $root] {
	toplevel $root -bg $color
	wm title $root "ROI from surface or contour"
	frame $root.d  -bg $color
	frame $root.b  -bg $color
	labelframe $root.d.sliceables -bg $color -text "Surface or Contour"
	foreach s [surfaceSliceables] {
	radiobutton $root.d.sliceables.$s -text $s -variable inrimage::sliceable -value $s
	pack $root.d.sliceables.$s -fill x -anchor w
	set inrimage::sliceable $s
	}
	pack $root.d.sliceables -side top -fill x
	
	labelframe $root.d.method -bg $color -text "ROI definition"
	radiobutton $root.d.method.border  -variable inrimage::method  -text "Surface or Contour Boundary" -value "boundary"
	radiobutton $root.d.method.borderZ  -variable inrimage::method  -text "Surface or Contour Boundary in Z Slices" -value "boundaryZ"
	radiobutton $root.d.method.region  -variable inrimage::method  -text "Surface or Contour Region" -value "region"
	radiobutton $root.d.method.outside  -variable inrimage::method  -text "Surface or Contour Outside Region" -value "outside"
	radiobutton $root.d.method.band  -variable inrimage::method -text "Surface or Contour Band" -value "band"
	pack $root.d.method.border $root.d.method.borderZ $root.d.method.region $root.d.method.outside $root.d.method.band -fill x -anchor w
	pack $root.d.method -side right
	set inrimage::method region

	labelframe $root.d.param -bg $color -text "Size of Band"
	scale $root.d.param.sc -width 15 -from 1 -to 20 -orient horizontal -resolution 1 -showvalue true -bg $color
	pack $root.d.param.sc -fill x
	pack $root.d.param -side right -fill x
	
	labelframe $root.d.szone -bg $color -text "Selected Zone"
	scale $root.d.szone.sc -width 15 -from -1 -to 10 -orient horizontal -resolution 1 -showvalue true -bg $color
	$root.d.szone.sc set -1
	pack $root.d.szone.sc -fill x
	pack $root.d.szone -side right -fill x
	
	button $root.b.app -text "Apply" -command "if \[string match \$inrimage::method band\] { evaluate \"new roi $inr \$inrimage::sliceable \$inrimage::method -param \[ $root.d.param.sc  get\] -zone  \[ $root.d.szone.sc  get\] $scene \" } else {evaluate \"new roi $inr \$inrimage::sliceable \$inrimage::method  -zone \[ $root.d.szone.sc  get\]  $scene \" }; destroy $root" -bg $color
	button $root.b.dismiss -text "Dismiss"  -command "destroy $root" -bg $color
	
	pack  $root.b.app $root.b.dismiss -side left -padx 10 -pady 10
	
	pack $root.d $root.b -side top
	
	}
}
proc inrimage::vectorDialog { inr inrview color mode} {
    if ![winfo exists .vector] {
	toplevel .vector -bg $color
	wm title .vector "Display Mode of 3D Field"
	frame .vector.d  -bg $color
	frame .vector.b  -bg $color
	
	frame .vector.d.echan -bg $color
	frame .vector.d.norm -bg $color
	frame .vector.d.taille -bg $color
	frame .vector.d.scale -bg $color
	
	scan [$inrview -displayMode]  "%s %u %u %u %f %f" mymode ux uy uz vw vs
	
	label .vector.d.echan.l -text "Sampling" -bg blue -fg white
	set dimx [expr [lindex [$inr -size] 0]/10 ]
	set dimy [expr [lindex [$inr -size] 1] /10 ]
	set dimz [expr 1+[lindex [$inr -size] 2] /10 ]
	
	scale .vector.d.echan.x -orient horizontal -resolution 1 -from 1 -to $dimx -length 100 -font fixed  -width 10 -bg $color -label "sous-ech en x"
	scale .vector.d.echan.y -orient horizontal -resolution 1 -from 1 -to $dimy -length 100 -font fixed -width 10 -bg $color -label "sous-ech en y"
	scale .vector.d.echan.z -orient horizontal -resolution 1 -from 1 -to $dimz -length 100 -font fixed -width 10 -bg $color -label "sous-ech en z"
	pack .vector.d.echan.l .vector.d.echan.x .vector.d.echan.y .vector.d.echan.z -side top
	
	.vector.d.echan.x set $ux
	.vector.d.echan.y set $uy
	.vector.d.echan.z set $uz
	
	label .vector.d.taille.l -text "Width" -bg blue -fg white
	scale .vector.d.taille.s -orient vertical -resolution 0.2 -from 1 -to 10 -length 100 -font fixed -width 10 -bg $color -label "Width des fleches"
	.vector.d.taille.s set $vw
	checkbutton .vector.d.taille.b -text "with arrow" -variable inrimage::arrow -onvalue true -offvalue false -bg $color -anchor w -command "evaluate \"$inrview -arrow \$inrimage::arrow\""
	
	pack .vector.d.taille.l .vector.d.taille.s .vector.d.taille.b -side top -pady 10  
	
	
	label .vector.d.norm.l -text "Norm Mode" -bg blue -fg white
	radiobutton .vector.d.norm.r1 -text "LINEAR" -variable inrimage::normMode -value "LINEAR" -command ".vector.d.norm.alpha configure -state disabled; .vector.d.norm.beta configure -state disabled; " -bg $color
	radiobutton .vector.d.norm.r3 -text "NORMALIZED" -variable inrimage::normMode -value "NORMALIZED" -command ".vector.d.norm.alpha configure -state disabled; .vector.d.norm.beta configure -state disabled; " -bg $color
	radiobutton .vector.d.norm.r2 -text "EXP" -variable inrimage::normMode -value "EXP" -command ".vector.d.norm.alpha configure -state normal; .vector.d.norm.beta configure -state normal; " -bg $color
	set alpha 1
	set beta 1
	entry .vector.d.norm.alpha -fg black -bg white -relief sunken -textvariable alpha -state disabled
	entry .vector.d.norm.beta -fg black -bg white -relief sunken -textvariable beta -state disabled
	pack .vector.d.norm.l .vector.d.norm.r1 .vector.d.norm.r3 .vector.d.norm.r2 .vector.d.norm.alpha .vector.d.norm.beta -side top -pady 5 -padx 10 -anchor w
	
	label .vector.d.scale.l -text "Vector Scale" -bg blue -fg white
	scale .vector.d.scale.s  -orient vertical -resolution 0.2 -from 0 -to 10 -length 100 -font fixed -width 10 -bg $color -label "Scale des fleches"
	.vector.d.scale.s set $vs
	
	pack .vector.d.scale.l .vector.d.scale.s -side top -pady 5 -padx 10 -anchor w
	
	pack .vector.d.echan .vector.d.norm .vector.d.scale .vector.d.taille -side left -pady 10 -padx 10 -expand true
	
	button .vector.b.app -text "Apply" -command "set cmd \"$inrview -displayMode $mode \[.vector.d.echan.x get\] \[.vector.d.echan.y get\] \[.vector.d.echan.z get\] \[.vector.d.taille.s get\] \[.vector.d.scale.s get\]\"; if !\[string compare \$inrimage::normMode NORMALIZED\] {set cmd \[concat \$cmd normalized \]}; if !\[string compare \$inrimage::normMode EXP\] {set cmd \[concat \$cmd alpha \$alpha beta \$beta \]}; evaluate \$cmd" -bg $color
	button .vector.b.ok -text "OK" -command "" -bg $color
	button .vector.b.dismiss -text "Dismiss"  -command "destroy .vector" -bg $color
	
	pack .vector.b.ok .vector.b.app .vector.b.dismiss -side left -padx 10 -pady 10
	
	pack .vector.d .vector.b -side top
    }
}

proc inrimage::vectorImageDialog { inr multiview color mode} {
    set root .vector
    if ![winfo exists $root] {
	toplevel $root -bg $color
	wm title $root "Display of a vectorial field"
	frame $root.d  -bg $color
	frame $root.b  -bg $color
	frame $root.c  -bg $color
	
	labelframe $root.d.echan -bg $color -text "Sampling"
	labelframe $root.d.arrow -bg $color -text "Arrows"
	labelframe $root.c.vector -bg $color
	labelframe $root.d.scale -bg $color -text "Scale"
	
	set ux [$multiview -vectorStep XY] 
	set uz [$multiview -vectorStep Z]
	
	set dimx [expr [lindex [$inr -size] 0]/10 ]
	set dimz [expr 1+[lindex [$inr -size] 2] /10 ]
	
	scale $root.d.echan.x -orient horizontal -resolution 1 -from 1 -to $dimx -length 100 -font fixed  -width 10 -bg $color -label "Subsampling in X, Y"
	scale $root.d.echan.z -orient horizontal -resolution 1 -from 1 -to $dimz -length 100 -font fixed -width 10 -bg $color -label "Subsampling in Z "
	bind $root.d.echan.x 	<ButtonRelease-1> " evaluate \" $multiview -vectorStep XY \[$root.d.echan.x  get\]\" "
	bind $root.d.echan.z 	<ButtonRelease-1> " evaluate \" $multiview -vectorStep Z \[$root.d.echan.z get\]\" "
	
	
	pack  $root.d.echan.x  $root.d.echan.z -side top
	
	$root.d.echan.x set $ux
	$root.d.echan.z set $uz
	
	set inrimage::svector [$multiview -showVectors]
	checkbutton $root.c.vector.v -text "Show Vectors" -variable inrimage::svector -onvalue true -font fixed -offvalue false -bg $color -anchor w -command "evaluate \"$multiview -showVectors \$inrimage::svector\""
	
	pack  $root.c.vector.v  -side top -pady 10  
	
	set inrimage::arrow [$multiview -showArrows]
	checkbutton $root.d.arrow.b -text "Show arrows" -variable inrimage::arrow -onvalue true -offvalue false -font fixed -bg $color -anchor w -command "evaluate \"$multiview -showArrows \$inrimage::arrow\""
	scale $root.d.arrow.w  -orient horizontal -resolution 0.02 -from 0 -to 1 -length 100 -font fixed -width 10 -bg $color -label "Arrow Width"
	$root.d.arrow.w set [$multiview -arrow width]
	bind $root.d.arrow.w <ButtonRelease-1> " evaluate \"$multiview -arrow width \[$root.d.arrow.w get\]\" "
	scale $root.d.arrow.h  -orient horizontal -resolution 0.02 -from 0 -to 1 -length 100 -font fixed -width 10 -bg $color -label "Arrow Height"
	$root.d.arrow.h set [$multiview -arrow height]
	bind $root.d.arrow.h <ButtonRelease-1> " evaluate \"$multiview -arrow height \[$root.d.arrow.h get\]\" "
	
	pack  $root.d.arrow.b $root.d.arrow.w $root.d.arrow.h  -side top -pady 10  
	
	
	scale $root.d.scale.s  -orient vertical -resolution 0.2 -from 0 -to 10 -length 100 -font fixed -width 10 -bg $color -label "Vector Scale"
	$root.d.scale.s set [$multiview -vectorScale]
	bind $root.d.scale.s <ButtonRelease-1> " evaluate \"$multiview -vectorScale \[$root.d.scale.s get\]\" "
	
	pack  $root.d.scale.s  -pady 5 -padx 10 -anchor w
	
	pack $root.d.echan $root.d.scale $root.d.arrow  -side left -pady 10 -padx 10 -expand true -fill y
	pack  $root.c.vector -side top -pady 10 -padx 10 -expand true -fill x
	button $root.b.dismiss -text "Dismiss"  -command "destroy $root" -bg $color
	
	pack $root.b.dismiss -side left -padx 10 -pady 10
	
	pack $root.c $root.d $root.b -side top
    }
}
proc inrimage::installLandmarkMenu { viewer camera lset } {
    if {![winfo exists $viewer.context.land]} {
	set bg [$viewer cget -background]
	menubutton $viewer.context.land -text "Landmark" -menu $viewer.context.land.m -anchor w -bg $bg
	set mvertex [menu $viewer.context.land.m -bg $bg]
	#    $mvertex add command -label "Selected Landmark Color..." -command "set col \[ modules::selectColor  \[ $contour -selectedVertexColor\] \]; evaluate \"$contour -selectedVertexColor \[lindex \$col 0\] \[lindex \$col 1\] \[lindex \$col 2\] \""
	$mvertex add command -label "Landmark Info..." -command "scan \[$lset -selectedLandmark info \] \"%u %u %u %f %f %f %s \" vx vy vz tx ty tz name ;tk_messageBox -type ok -message \"Voxel position : \$vx \$vy \$vz \n World position : \$tx \$ty \$tz \n Name : \$name \" "
	$mvertex add command -label "Remove Landmark" -command "evaluate \"$lset -removeLandmark \[$lset -selectedLandmark\]\""
	pack  $viewer.context.land -side right
    }
}

proc inrimage::uninstallLandmarkMenu { viewer  landmark  } {
    puts $landmark
}
proc inrimage::installLandmarkSetPopupMenu { camera lset bg } {
    set widget .$lset-popup-tearoff
    if {[winfo exists $widget]} {
	destroy $widget
    }
    set popup [menu  $widget -bg "white" -postcommand "scan \[$lset -selectionMode \] {%s} inrimage::selectionMode " ]
    
    $popup add command -label "Left Button" -state disabled -command {}
    foreach mode [$lset -selectionMode list] {
	$popup add radio -label [lindex $mode 0] -variable inrimage::selectionMode -value [lindex $mode 1] -command "evaluate \"$lset -selectionMode [lindex $mode 1]  $camera\""
    }
    
    bind [$camera -widget] <Button-3> "tk_popup $popup %X %Y"
    $lset -selectionMode create $camera
}
proc inrimage::installROIEditPopupMenu {  camera roie bg } {
    set widget .roiedit
    if {[winfo exists $widget]} {
	destroy $widget
    }
    set popup [ menu $widget -tearoff 0 -bg "white" -postcommand "scan \[$roie -selectionMode \] {%s} inrimage::roieselMode" ]
    $popup add command -label "Left Button" -state disabled -command {}
    $popup add radio -label "Use Brush" -variable inrimage::roieselMode -value "brush" -command  "evaluate \"$roie -selectionMode brush \""
    $popup add radio -label "Use Eraser" -variable inrimage::roieselMode -value "eraser" -command  "evaluate \"$roie -selectionMode eraser \""
    $popup add radio -label "Use Polygon" -variable inrimage::roieselMode -value "line" -command  "evaluate \"$roie -selectionMode line \""
    $popup add separator
    $popup add command -label "Set Brush Size..." -command "modules::scaleDialog .{$roie}BrushSize $bg {Choose Brush Size} 1 5 \[$roie -brushWidth\] \"evaluate \{ $roie -brushWidth ...\} \" "
    $popup add command -label "Set Eraser Size..." -command "modules::scaleDialog .{$roie}EraserSize $bg {Choose Eraser Size} 1 5 \[$roie -eraserWidth\] \"evaluate \{ $roie -eraserWidth ...\} \" "
    bind [$camera -widget] <Button-3> "tk_popup $popup %X %Y"
}
proc inrimage::createROIList { rlist inr scn {bg "PeachPuff2"}} {
    set root .{$inr}ROIList
    if {![winfo exists $root]} {
	toplevel $root -bg $bg
	wm title $root "ROI Management"
	frame $root.f
	
	button $root.f.create -text "Create New ROI" -command "set r \[ evaluate \"$rlist -newROI\"\];modules::entryDialog .{\$r}Name $bg {Set the region name} \"\[\$r -realName\]\" \"evaluate \{ \$r -realName ... \} \"" -width 20 -height 5 -bg seashell3
	menubutton $root.f.select -text "Select ROI" -menu $root.f.select.m -anchor c -bg blue -width 20 -height 5
	menu  $root.f.select.m -bg $bg -postcommand "$root.f.select.m delete 0 last; foreach {i} \[ $rlist -rois \] { $root.f.select.m add command -label \" \[ \$i -realName \] (\$i)\" -command \" foreach {cam} \\\[$scn -camera\\\] \{ \\\$cam -select \$i \} \"}"
	menubutton $root.f.show -text "Show/Hide ROI" -menu $root.f.show.m -anchor c -bg green -width 20 -height 5
	menu  $root.f.show.m -bg $bg -postcommand "$root.f.show.m delete 0 last; foreach {i} \[ $rlist -rois \] { set inrimage::show(\$i) \[\$i -visibility \];$root.f.show.m add checkbutton -label \" \[ \$i -realName \] (\$i)\" -variable inrimage::show(\$i) -onvalue true -offvalue false -command \" \$i -visibility \\\$inrimage::show(\$i) \" }"
	button $root.f.write -text "Save all ROIs" -command "if  !\[ string compare  \[ $rlist -write name \] \"defaultName.rl\" \] {$rlist -write \[tk_getSaveFile -initialfile defaultName.rl -filetypes { { {ROI List} {.rl} } {{All} {*}} } -parent . -title {Select a ROI List} \] } else {$rlist -write}" -width 20 -height 5 -bg red
	button $root.f.quit -text "Quit" -command "$rlist -destroy;destroy $root" -width 20 -height 5 -bg brown
	
	pack $root.f.create -side top -expand true
	pack $root.f.select -side top -expand true
	pack $root.f.show -side top -expand true
	pack $root.f.write -side top -expand true
	pack $root.f.quit -side top -expand true
	pack $root.f
    }
    
}

proc inrimage::installLandmarkSetMenu { viewer camera lset bg } {
    
    if {![winfo exists $viewer.context.file]} {
	menubutton $viewer.context.file -text "File" -menu $viewer.context.file.m -anchor w -bg $bg
	set mfile [menu $viewer.context.file.m -bg $bg]
	$mfile add command -label "Save Landmark Set as..." -command "evaluate \" $lset -saveAs \[tk_getSaveFile -filetypes { {{Landmark Set} {.lset} } {\\\"All\\\" *} } -parent . -title {Select a Landmark Set} \] \" "
	$mfile add separator
	$mfile add command -label "Destroy" -command "evaluate \"$lset -destroy\""
	
	menubutton $viewer.context.display -text "Display" -menu $viewer.context.display.m -anchor w -bg $bg
	set mdisplay [menu $viewer.context.display.m -bg $bg]
	$mdisplay add cascade -label "Display Mode" -menu   $mdisplay.sub3
	set m3 [menu  $mdisplay.sub3 -tearoff 0 -postcommand "set inrimage::lsetm \[ $lset -displayMode \] " ]
	$m3 add radiobutton -variable inrimage::lsetm -label "Hide" -value "hide" -command "evaluate \"$lset -displayMode hide \""
	$m3 add radiobutton -variable inrimage::lsetm -label "Use Crosses" -value "cross" -command "evaluate \"$lset -displayMode cross \""
	$m3 add radiobutton -variable inrimage::lsetm -label "Use Voxels" -value "voxel" -command "evaluate \"$lset -displayMode voxel\""
	$mdisplay add command -label "Cross Size..." -command "modules::scaleDialog .{$lset}CrossSize $bg {Choose Cross Size} 1 15 \[$lset -crossSize\] \"evaluate \{ $lset -crossSize ...\} \" "
	$mdisplay add command -label "Landmark Color..." -command "set col \[ modules::selectColor  \[ $lset -color\] \]; evaluate \"$lset -color \[lindex \$col 0\] \[lindex \$col 1\] \[lindex \$col 2\] \""
	$mdisplay add command -label "Selected Landmark Color..." -command "set col \[ modules::selectColor  \[ $lset -color\] \]; evaluate \"$lset -color \[lindex \$col 0\] \[lindex \$col 1\] \[lindex \$col 2\] \""
	
	menubutton $viewer.context.landmark -text "Landmarks" -menu $viewer.context.landmark.m -anchor w -bg $bg
	set mland [menu $viewer.context.landmark.m -bg $bg]
	$mland add cascade -label "Landmark Information" -menu   $mland.sub3
	set m3 [menu  $mland.sub3 -tearoff 0 -postcommand "$mland.sub3 delete 0 last;set selectedLandmark \[$lset -selectedLandmark\];foreach {i} \[ $lset -landmarks \] { scan \$i \"%s %s %s %s %s %s \"  vx vy vz tx ty tz; $mland.sub3 add radio -variable selectedLandmark -label \[ lindex \$i 6\]  -command \" tk_messageBox -type ok -message \\\"Voxel position : \$vx \$vy \$vz \n World position : \$tx \$ty \$tz \n Name : \[ lindex \$i 6 \] \\\" \"} " ]
	$mland add cascade -label "Remove Landmarks" -menu   $mland.sub4
	set m4 [menu  $mland.sub4 -tearoff 0 -postcommand "$mland.sub4 delete 0 last;foreach {i} \[ $lset -landmarks \] { $mland.sub4 add command -label \[ lindex \$i 6\]  -command \"evaluate \\\"$lset -removeLandmark \\\[ lindex \\\$i 6\\\]\\\" \"} " ]
	$mland add cascade -label "Select Landmarks" -menu   $mland.sub1
	set m1 [menu  $mland.sub1 -tearoff 0 -postcommand "$mland.sub1 delete 0 last;set selectedLandmark \[$lset -selectedLandmark\]; foreach {i} \[ $lset -landmarks \] {  scan \$i \"%s %s %s \"  vx vy vz; $mland.sub1 add radio -label \[ lindex \$i 6\] -variable selectedLandmark -command \"  evaluate \\\" $lset -selectedLandmark \{\[ lindex \$i 6 \]\} \\\"  \" } " ]
	
	pack  $viewer.context.file -side left
	pack  $viewer.context.display -side left
	pack  $viewer.context.landmark -side left
	
	# inrimage::installLandmarkSetPopupMenu $viewer $camera $lset $bg
    }
}
proc inrimage::centerSliceCameraOnLandmark { lset mview vx vy vz} {
    puts "in centerSlice= [ $lset -selectedLandmark ]"
    if [string compare [ $lset -selectedLandmark ] "none" ] {
      puts "in sliceNumber"
	[ lindex [$imageView -background ] 0 ] -sliceNumber $vz
	[ lindex [$imageView -background ] 1 ] -sliceNumber $vy
	[ lindex [$imageView -background ] 2 ] -sliceNumber $vx
    }
}

proc inrimage::moveLandmark {lset camera x y } {
    set widget [$camera -widget]
    $widget configure -closeenough 2.0
    $widget dtag selected
    $widget addtag selected closest $x $y
    
    set tagList [split [$widget gettags selected ] ]
    
    set template [ format "%sland*" $lset ]
    set name [ format "%sland" $lset ]
    foreach t $tagList {
	if {[string match  $template $t] } {
	    scan  $t "$name%s" landm
	    $lset -movingLandmark $landm
	}
    }
    
}
proc inrimage::deleteLandmark {lset camera x y } {
    set widget [$camera -widget]
    $widget configure -closeenough 2.0
    $widget dtag selected
    $widget addtag selected closest $x $y
    
    set tagList [split [$widget gettags selected ] ]
    
    set template [ format "%sland*" $lset ]
    set name [ format "%sland" $lset ]
    foreach t $tagList {
	if {[string match  $template $t] } {
	    scan  $t "$name%s" landm
	    $lset -removeLandmark $landm
	}
    }
}


proc inrimage::uninstallLandmarkSetMenu {viewer camera line} {
    # remove frame children
    set list [winfo children $viewer.context]
    foreach w $list { destroy $w}
    pack $viewer.context -fill x
    #    bind [$camera -widget] <Button-3> ""
    
}
proc inrimage::installInrviewMenu { menu camera inrview bg } {
    
    # Ce menu est a afficher uniquement pour les images vectorielles de type floatVector ou doubleVector
    if { ![string compare [ [$inrview -inrimage] -type] "floatVector"] || ![string compare [ [$inrview -inrimage] -type] "doubleVector"] } {
	menubutton $menu.context.mode -text "Display Mode" -menu $menu.context.mode.mn -bg $bg
	set mn [menu $menu.context.mode.mn -bg $bg -postcommand ""] 
	$mn add command -label "Edit Vector Display Properties" -command "inrimage::vectorDialog [$inrview -inrimage] $inrview $bg \$inrimage::dispMode"
	pack $menu.context.mode -side left
    }
}

proc inrimage::uninstallInrviewMenu {viewer camera line} {
    # remove frame children
    set list [winfo children $viewer.context]  
    foreach w $list { destroy $w}
    pack $viewer.context -fill x
}

proc inrimage::loadImage { } {
    set ftype {}
    set a [ split [imageFormat input] "{}" ]
    foreach {i} $a {
	if [string compare $i ""] {
	    set b [split $i]
	    set c [split [lindex $b 1] ","]
	    set iform "{\"[lindex $b 0]\" {$c} }"
	    set ftype [concat $ftype $iform]
	}
    }
    set ftype [ concat $ftype "{\"All\" * }" ]
    
    return [tk_getOpenFile -filetypes $ftype -parent . -title {Select an image}]
}
proc inrimage::loadImage4D { } {
    set ftype {}
    set a [ split [image4DFormat input] "{}" ]
    foreach {i} $a {
	if [string compare $i ""] {
	    set b [split $i]
	    set c [split [lindex $b 1] ","]
	    set iform "{\"[lindex $b 0]\" {$c} }"
	    set ftype [concat $ftype $iform]
	}
    }
    set ftype [ concat $ftype "{\"All\" * }" ]
    
    return [tk_getOpenFile -filetypes $ftype -parent . -title {Select a 4D image}]
}

proc inrimage::saveImage {{name ""}} {
    set ftype {}
    set a [ split [imageFormat output] "{}" ]
    foreach {i} $a {
	if [string compare $i ""] {
	    set b [split $i]
	    set c [split [lindex $b 1] ","]
	    set iform "{\"[lindex $b 0]\" {$c} }"
	    set ftype [concat $ftype $iform]
	}
	
    }
    set ftype [ concat $ftype "{\"All\" * }" ]
    return [tk_getSaveFile -filetypes $ftype -parent . -title {Enter an image name}]
    #    return [tk_getSaveFile -filetypes {
    #	{"Inrimage, 3Ds" {.inr .inr.gz .hdr .dim} } 
    #	{"2Ds" {.ppm .pgm} }
    #	{"Iris" {.rgb} }
    #	{"All" * }} -parent . -initialfile $name -title {Enter an image name}]
}

proc inrimage::saveImage4D {{name ""}} {
    set ftype {}
    set a [ split [image4DFormat output] "{}" ]
    foreach {i} $a {
	if [string compare $i ""] {
	    set b [split $i]
	    set c [split [lindex $b 1] ","]
	    set iform "{\"[lindex $b 0]\" {$c} }"
	    set ftype [concat $ftype $iform]
	}
	
    }
    set ftype [ concat $ftype "{\"All\" * }" ]
    return [tk_getSaveFile -filetypes $ftype -parent . -title {Enter a 4D image name}]
}



proc inrimage::createToplevel { parent img color {widget toplevel} } {
    if { [lsearch [winfo visualsavailable .] "truecolor 24"] > 0 } {
	$widget $parent -bg $color
    } else {
	if {![string compare [$img -type] "rgb"] || ![string compare [$img -type] "rgba"]} {
	    $widget $parent -visual "truecolor 24" -bg $color
	} else {
	    if { [lsearch [winfo visualsavailable .] "grayscale 24"] > 0 } {
		$widget $parent -visual "grayscale 24" -bg $color
	    } elseif { [lsearch [winfo visualsavailable .] "grayscale 8"] > 0 } {
		$widget $parent -visual "grayscale 8" -bg $color
	    } else {
		$widget $parent -visual "best" -bg $color
	    }
	}
    }
}
proc inrimage::UpdateTable { root graph p1 p2 how } {
    table configure $root c0 -width [$graph extents leftmargin]
    table configure $root c2 -width [$graph extents rightmargin]
    table configure $root r1 -height [$graph extents topmargin]
    table configure $root r3 -height [$graph extents bottommargin]
}

proc inrimage::mergeView { inr1 inr2 {scene "none"} {color "#E8E0D2"} {subcolor "#D8D0C2"}} {
    set mulview [new multiview]
    set parent ".${mulview}"
    inrimage::createToplevel $parent $inr1 $color 
    
    wm title $parent "$inr1 ([lindex  [split  [$inr1 -name] /] end]  ) with $inr2 ([lindex  [split  [$inr2 -name] /] end]  ) "
    #attach multiview to widget ~/irm.inr  
    $mulview -parentWidget $parent
    #creates frames and sliders
    
    if {  $::tcl_platform(platform) == "windows" } {
	set theFont "ansifixed"
    } else {
	set theFont "fixed"
    }
    
    frame $parent.voxel -bg $color
    frame $parent.f1 -bg $color
    frame $parent.f2 -bg $color
    frame $parent.f2.g -bg $color
    frame $parent.f2.b -bg $color
    frame $parent.f2.m -bg $color
    frame $parent.f2.d -bg $color
    
    scale $parent.f2.b.opacity -orient horizontal -font $theFont -width 10 -bg $color -label "opacity between $inr1 and $inr2"
    label $parent.f2.g.l -text "min and max \ngrey level $inr1" -bg $color
    scale $parent.f2.g.glmin -orient vertical -font $theFont -width 10 -bg $color 
    scale $parent.f2.g.glmax -orient vertical -font  $theFont -width 10 -bg $color  	
    scale $parent.f2.d.glmin2 -orient vertical -font $theFont -width 10 -bg $color 
    label $parent.f2.d.l -text "min and max \ngrey level $inr2" -bg $color
    scale $parent.f2.d.glmax2 -orient vertical -font $theFont -width 10 -bg $color  
    pack $parent.voxel  -fill both
    pack $parent.f1   -fill both
    
    
    #creates frames for menu
    set submenu $parent.submenu 
    frame $parent.submenu  -bg "#D8D0C2"
    frame $submenu.context -height 26 -bg $subcolor
    label $submenu.name -text "no selected object" -anchor e -bg $subcolor
    pack $submenu.context -side left  -fill both
    pack $submenu.name -side right
    pack $submenu  -fill both
    
    #create min and max glscale
    set opacityscale [new opascale  -in $parent.f2.b.opacity]
    set minglscale [new glscale -min -in $parent.f2.g.glmin]
    set maxglscale [new glscale -max -in $parent.f2.g.glmax]
    set minglscale2 [new glscale -min -in $parent.f2.d.glmin2]
    set maxglscale2 [new glscale -max -in $parent.f2.d.glmax2]
    
    label $parent.voxel.v -font $theFont  -bg $color -text "Voxel Position "
    label $parent.voxel.l -font $theFont  -bg $color 
    pack $parent.voxel.v $parent.voxel.l  -side left
    #pack $parent.voxel.v   -side left
    
    pack $parent.f2.g.l $parent.f2.d.l -side top -fill both
    pack  $parent.f2.b -side bottom -fill both
    pack  $parent.f2.g $parent.f2.m $parent.f2.d -side left -fill both
    
    pack  $parent.f2   -expand true -fill both
    pack  $parent.f2.d.glmin2 $parent.f2.d.glmax2 $parent.f2.g.glmin  $parent.f2.g.glmax -fill both -side left
    
    pack $parent.f2.b.opacity -fill both
    frame $parent.f2.m.ne -bg $color
    frame $parent.f2.m.so -bg $color -borderwidth 1
    frame $parent.f2.m.se -bg $color -borderwidth 1
    
    grid $parent.f2.m.ne -column 2 -row 1
    grid $parent.f2.m.so -column 1 -row 2
    grid $parent.f2.m.se -column 2 -row 2
    
    if ![string compare $scene "none" ] {
	set inrv [new overinrview $inr1 $inr2 -noGLScale]
    } else {
	set inrv 0
	foreach {i} [$scene -objects] {
	    if {[string match overinrview* $i ]} {
		set inrv $i
	    }
	}
	if ![ string compare $inrv "0"] {
	    set inrv [new overinrview $inr1 $inr2 -noGLScale]
	}
    }
    
    set scn [$inrv -scene]
    #compute theoretical height and width
    set Theight [ expr [ lindex [ $inr1 -size ] 1 ] * [ lindex [ $inr1 -voxel ] 1 ] ]
    #    set Theight [ lindex [ $inr1 -size ] 1 ]
    set Twidth [ lindex [ $inr1 -size ] 0 ]
    if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	set heightOffset 260
	set Theight [ expr $Theight + [ expr [ lindex [ $inr1 -size ] 2 ] * [ lindex [ $inr1 -voxel ] 2 ] ] ]
	#	 set Theight [ expr $Theight + [ expr [ lindex [ $inr1 -size ] 2 ] * [lindex [$inr1 -voxel ] 2] / [lindex [$inr1 -voxel ] 0 ] ] ]
	set Twidth [ expr $Twidth + [ expr [ lindex [ $inr1 -size ] 2 ] * [lindex [$inr1 -voxel ] 2] / [lindex [$inr1 -voxel ] 0 ] ] ]
    } else {
	set heightOffset 160
    }
    set Theight [ expr $heightOffset+$Theight ]
    #compute the scale that should be  applied such that the widget fits in the screen
    set scale 1.0
    set ratioHeight [ expr 1.0 * $Theight / [ winfo  screenheight . ]   ] 
    set ratioWidth [ expr 1.0 * $Twidth / [ winfo  screenwidth . ]  ] 
    
    if [ expr $ratioHeight > $ratioWidth ] {
	set ratio $ratioHeight
    } else {
	set ratio $ratioWidth
    }
    if [ expr $ratio > 1.0 ] {
	if [ expr $ratioHeight > $ratioWidth ] {
	    set scale [expr 1.0 / [ expr [ expr $Theight - $heightOffset ] / [ expr [ winfo  screenheight . ] * 0.95 - $heightOffset ] ] ]
	} else {
	    set scale [ expr 1.0 / [ expr $ratio *1.1] ]
	}
    }
    #create first camera
    if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	set cam1 [new slicecam Z -scene $scn -in $parent.f2.m.se -motion  $parent.voxel.l -useSlice true -useMenu true -menu $parent.submenu -scale $scale] 
    } else {
	set cam1 [new slicecam Z -scene $scn -in $parent.f2.m.se -motion  $parent.voxel.l -useSlice false -useMenu true -menu $parent.submenu -scale $scale] 
    }
    $mulview -add $cam1
    #get background
    set bg1 [$inrv -background $cam1]
    #attach grey-level and opacity scales
    $bg1 -greyLevel min $minglscale
    $bg1 -greyLevel max $maxglscale
    $bg1 -greyLevel min2 $minglscale2
    $bg1 -greyLevel max2 $maxglscale2
    $bg1 -opacity $opacityscale
    #get slice scale
    set slicescale [$cam1 -slicescale]
    if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	#create second camera
	set cam2 [new slicecam Y -scene $scn -in $parent.f2.m.ne -motion  $parent.voxel.l -useSlice true -useMenu false -scale $scale]
	$mulview -add $cam2
	#get background
	set bg2 [$inrv -background $cam2]
	#attach grey-level and opacity scales
	$bg2 -greyLevel min $minglscale
	$bg2 -greyLevel max $maxglscale
	$bg2 -greyLevel min2 $minglscale2
	$bg2 -greyLevel max2 $maxglscale2
	$bg2 -opacity $opacityscale
	#create second camera
	set cam3 [new slicecam X -scene $scn -in $parent.f2.m.so -motion  $parent.voxel.l -useSlice true -useMenu false  -scale $scale]
	$mulview -add $cam3
	#get background
	set bg3 [$inrv -background $cam3]
	#attach grey-level and opacity scales
	$bg3 -greyLevel min $minglscale
	$bg3 -greyLevel max $maxglscale
	$bg3 -greyLevel min2 $minglscale2
	$bg3 -greyLevel max2 $maxglscale2
	$bg3 -opacity $opacityscale
	bind  $parent.f2.m.so.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
	bind  $parent.f2.m.ne.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
    }
    #add menu
    menubutton $parent.f1.mv -text "Multi-view" -anchor w -menu $parent.f1.mv.m -bg $color
    inrimage::multiviewMergeMenu $parent.f1.mv.m  $mulview $inr1 1
    pack $parent.f1.mv -side left
    menubutton $parent.f1.o  -text "Objects" -menu $parent.f1.o.m -anchor w -bg $color
    menu $parent.f1.o.m -bg $color -postcommand "
    scan \[ $cam1 -select \] {%s} selectedObject;  
    #delete previous items 
    $parent.f1.o.m  delete 0 last
    foreach {i} \[ \[$cam1 -scene\] -objects\] {
	$parent.f1.o.m  add radio -selectcolor \"black\" -variable selectedObject -label \$i -command \" $cam1 -select \$i \"
    }"
    pack  $parent.f1.o -side left
    menubutton $parent.f1.ao -text "Add Objects" -anchor w -menu $parent.f1.ao.m -bg $color
    inrimage::addObjectMenu $parent.f1.ao.m $mulview $inr1 1
    pack $parent.f1.ao -side left   
    
    $cam1 -select $inrv
    
    bind  $parent.f2.m.se.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
    update idletasks
    #    bind  $parent.f2 <Configure> "inrimage::resizeMergeGrid $mulview %W %h %w"
}
proc inrimage::mergeView4D { inr1 inr2 {color "#E8E0D2"} {subcolor "#D8D0C2"}} {
    set mulview [new multiview4D]
    set parent ".${mulview}"
    inrimage::createToplevel $parent $inr1 $color 
    
    wm title $parent "Merging $inr1 with $inr2"
    #attach multiview to widget
    $mulview -parentWidget $parent
    #creates frames and sliders
    frame $parent.f1 -bg $color
    frame $parent.f2 -bg $color
    scale $parent.opacity -orient horizontal -font fixed -width 10 -bg $color -label "opacity between $inr1 and $inr2"
    scale $parent.time -orient horizontal -font fixed -width 10 -bg $color -label "Time"
    scale $parent.slicex -orient horizontal -font fixed -width 10 -bg $color -label "X"
    scale $parent.slicey -orient horizontal -font fixed -width 10 -bg $color -label "Y"
    scale $parent.slicez -orient horizontal -font fixed -width 10 -bg $color -label "Z"
    scale $parent.glmin -orient horizontal -font fixed -width 10 -bg $color -label "min grey level for $inr1"
    scale $parent.glmax -orient horizontal -font fixed -width 10 -bg $color  -label "max grey level for $inr1"
    scale $parent.glmin2 -orient horizontal -font fixed -width 10 -bg $color -label "min grey level for $inr2"
    scale $parent.glmax2 -orient horizontal -font fixed -width 10 -bg $color  -label "max grey level for $inr2"
    pack $parent.f1 $parent.f2 $parent.opacity $parent.time $parent.slicex $parent.slicey $parent.slicez $parent.glmin $parent.glmax $parent.glmin2 $parent.glmax2 -expand true -fill x
    
    #create min and max glscale
    set timescale [new slicescale  -in $parent.time]
    set opacityscale [new opascale  -in $parent.opacity]
    set xscale [new slicescale  -in $parent.slicex]
    set yscale [new slicescale  -in $parent.slicey]
    set zscale [new slicescale  -in $parent.slicez]
    set minglscale [new glscale -min -in $parent.glmin]
    set maxglscale [new glscale -max -in $parent.glmax]
    set minglscale2 [new glscale -min -in $parent.glmin2]
    set maxglscale2 [new glscale -max -in $parent.glmax2]
    
    label $parent.f1.l -font fixed -anchor e -bg $color 
    pack $parent.f1.l -side right -expand true -fill x
    
    frame $parent.f2.zy -bg $color -borderwidth 1
    frame $parent.f2.xz -bg $color -borderwidth 1
    frame $parent.f2.xy -bg $color -borderwidth 1
    frame $parent.f2.xt -bg $color -borderwidth 1
    frame $parent.f2.yt -bg $color -borderwidth 1
    frame $parent.f2.zt -bg $color -borderwidth 1
    label $parent.f2.lzy -text "ZY" -bg $color
    label $parent.f2.lxz -text "XZ" -bg $color
    label $parent.f2.lxy -text "XY" -bg $color
    label $parent.f2.lxt -text "XT" -bg $color
    label $parent.f2.lyt -text "YT" -bg $color
    label $parent.f2.lzt -text "ZT" -bg $color
    
    
    grid $parent.f2.zy -column 1 -row 1
    grid $parent.f2.xz -column 2 -row 1
    grid $parent.f2.xy -column 3 -row 1
    grid $parent.f2.lzy -column 1 -row 2
    grid $parent.f2.lxz -column 2 -row 2
    grid $parent.f2.lxy -column 3 -row 2
    grid $parent.f2.xt -column 1 -row 3
    grid $parent.f2.yt -column 2 -row 3
    grid $parent.f2.zt -column 3 -row 3
    grid $parent.f2.lxt -column 1 -row 4
    grid $parent.f2.lyt -column 2 -row 4
    grid $parent.f2.lzt -column 3 -row 4
    
    set inrv [new overinr4Dview $inr1 $inr2 -noGLScale] 
    set scn [$inrv -scene]
    
    #create first camera
    set cam1 [new timecam Z -scene $scn -in $parent.f2.xy -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $zscale -slice2 $timescale]
    $mulview -add $cam1
    #get background
    set bg1 [$inrv -background $cam1]
    #attach grey-level and opacity scales
    $bg1 -greyLevel min $minglscale
    $bg1 -greyLevel max $maxglscale
    $bg1 -greyLevel min2 $minglscale2
    $bg1 -greyLevel max2 $maxglscale2
    $bg1 -opacity $opacityscale
    # ???????
    #get slice scale
    #set slicescale [$cam1 -slicescale]
    # ???????
    #create second camera
    set cam2 [new timecam Y -scene $scn -in $parent.f2.xz -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $yscale -slice2 $timescale]
    $mulview -add $cam2
    #get background
    set bg2 [$inrv -background $cam2]
    #attach grey-level and opacity scales
    $bg2 -greyLevel min $minglscale
    $bg2 -greyLevel max $maxglscale
    $bg2 -greyLevel min2 $minglscale2
    $bg2 -greyLevel max2 $maxglscale2
    $bg2 -opacity $opacityscale
    #create third camera
    set cam3 [new timecam X -scene $scn -in $parent.f2.zy -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $xscale -slice2 $timescale]
    $mulview -add $cam3
    #get background
    set bg3 [$inrv -background $cam3]
    #attach grey-level and opacity scales
    $bg3 -greyLevel min $minglscale
    $bg3 -greyLevel max $maxglscale
    $bg3 -greyLevel min2 $minglscale2
    $bg3 -greyLevel max2 $maxglscale2
    $bg3 -opacity $opacityscale
    #create fourth camera
    set cam4 [new timecam XT -scene $scn -in $parent.f2.xt -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $yscale -slice2 $zscale]
    $mulview -add $cam4
    #get background
    set bg4 [$inrv -background $cam4]
    #attach grey-level and opacity scales
    $bg4 -greyLevel min $minglscale
    $bg4 -greyLevel max $maxglscale
    $bg4 -greyLevel min2 $minglscale2
    $bg4 -greyLevel max2 $maxglscale2
    $bg4 -opacity $opacityscale
    #create fifth camera
    set cam5 [new timecam YT -scene $scn -in $parent.f2.yt -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $xscale -slice2 $zscale]
    $mulview -add $cam5
    #get background
    set bg5 [$inrv -background $cam5]
    #attach grey-level and opacity scales
    $bg5 -greyLevel min $minglscale
    $bg5 -greyLevel max $maxglscale
    $bg5 -greyLevel min2 $minglscale2
    $bg5 -greyLevel max2 $maxglscale2
    $bg5 -opacity $opacityscale
    #create sixth camera
    set cam6 [new timecam ZT -scene $scn -in $parent.f2.zt -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $xscale -slice2 $yscale]
    $mulview -add $cam6
    #get background
    set bg6 [$inrv -background $cam6]
    #attach grey-level and opacity scales
    $bg6 -greyLevel min $minglscale
    $bg6 -greyLevel max $maxglscale
    $bg6 -greyLevel min2 $minglscale2
    $bg6 -greyLevel max2 $maxglscale2
    $bg6 -opacity $opacityscale
    #add menu
    menubutton $parent.f1.mv -text "Multi-view 4D" -anchor w -menu $parent.f1.mv.m -bg $color
    inrimage::multiviewMergeMenu $parent.f1.mv.m  $mulview $inr1 1
    pack $parent.f1.mv -side left
    menubutton $parent.f1.o  -text "Objects" -menu $parent.f1.o.m -anchor w -bg $color
    menu $parent.f1.o.m -bg $color -postcommand "
    scan \[ $cam1 -select \] {%s} selectedObject;  
    #delete previous items 
    $parent.f1.o.m  delete 0 last
    foreach {i} \[ \[$cam1 -scene\] -objects\] {
	$parent.f1.o.m  add radio -selectcolor \"black\" -variable selectedObject -label \$i -command \" $cam1 -select \$i \"
    }"
    pack  $parent.f1.o -side left
    menubutton $parent.f1.ao -text "Add Objects" -anchor w -menu $parent.f1.ao.m -bg $color
    inrimage::addObjectMenu $parent.f1.ao.m $mulview $inr1 1
    pack $parent.f1.ao -side left   
    bind  $parent.f2.so.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
    bind  $parent.f2.se.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
    bind  $parent.f2.ne.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
    bind  $parent.f2 <Configure> "inrimage::resizeGrid $mulview %W %h %w"
} 
proc inrimage::resizeGrid {  mview grid newHeight newWidth} {
    if  [ expr [ winfo ismapped $grid ] || [ winfo ismapped $grid.so.f.view ] ]  {
	if [ string match $graphics2D::busy 0] {
	    set graphics2D::busy 1
	    set h [ winfo height $grid ]
	    set w [ winfo width $grid ]
	    set currentWidth [ expr [ winfo width $grid.so.f.view ] + [ winfo width $grid.se.f.view ] ]
	    set currentHeight [ expr [ winfo height $grid.ne.f.view ] + [ winfo height $grid.se.f.view ] ]
	    set sliderHeight [ expr [ winfo height $grid.ne.f.s ] + [ winfo height $grid.se.f.s ] ]
	    set rw [ expr [ expr $w + 0.0 ] / $currentWidth]
	    set rh [ expr  [ expr [ expr $h - $sliderHeight] + 0.0 ] / $currentHeight]
	    if [ expr $rw < $rh ] {
		set r  $rw
	    } else {
		set r  $rh  
	    }
	    set cam1  [ lindex [ $mview -views ] 0 ] 
	    $cam1 -scale [  expr $r * [ $cam1 -scale ] ]
	    set cam2  [ lindex [ $mview -views ] 1 ] 
	    $cam2 -scale [  expr $r * [ $cam2 -scale ] ]
	    set cam3  [ lindex [ $mview -views ] 2 ] 
	    $cam3 -scale [  expr $r * [ $cam3 -scale ] ]
	    set graphics2D::busy 0
	}
    }
}
proc inrimage::resizeMergeGrid {  mview grid newHeight newWidth} {
    if  [ expr [ winfo ismapped $grid ] && [ winfo ismapped $grid.m.so.f.view ]  ]  {
	if [ string match $graphics2D::busy 0] {
	    set graphics2D::busy 1
	    set h [ winfo height $grid ]
	    set w [ winfo width $grid ]
	    set currentWidth [ expr [ winfo width $grid.m.so.f.view ] + [ winfo width $grid.m.se.f.view ] + [ winfo width $grid.d ] + [ winfo width $grid.g ] ]
	    set currentHeight [ expr [ winfo height $grid.m.ne.f.view ] + [ winfo height $grid.m.se.f.view ] ]
	    set sliderHeight [ expr [ winfo height $grid.m.ne.f.s ] + [ winfo height $grid.m.se.f.s ] ]
	    set rw [ expr [ expr $w + 0.0 ] / $currentWidth]
	    set rh [ expr  [ expr [ expr $h - $sliderHeight] + 0.0 ] / $currentHeight]
	    if [ expr $rw < $rh ] {
		set r  $rw
	    } else {
		set r  $rh  
	    }
	    set cam1  [ lindex [ $mview -views ] 0 ] 
	    $cam1 -scale [  expr $r * [ $cam1 -scale ] ]
	    set cam2  [ lindex [ $mview -views ] 1 ] 
	    $cam2 -scale [  expr $r * [ $cam2 -scale ] ]
	    set cam3  [ lindex [ $mview -views ] 2 ] 
	    $cam3 -scale [  expr $r * [ $cam3 -scale ] ]
	    set graphics2D::busy 0
	}
    }
}
proc inrimage::resizeSingleGrid {  mview grid newHeight newWidth } {
    if  [ winfo ismapped $grid ] {
	if [ string match $graphics2D::busy 0] {
	    set graphics2D::busy 1
	    set h [ winfo height $grid ]
	    set w [ winfo width $grid ]
	    set currentWidth [  winfo width $grid.se.f.view ] 
	    set currentHeight [  winfo height $grid.se.f.view ] 
	    set sliderHeight [ winfo height $grid.se.f.s ] 
	    set rw [ expr [ expr $w + 0.0 ] / $currentWidth]
	    set rh [ expr  [ expr [ expr $h - $sliderHeight] + 0.0 ] / $currentHeight]
	    if [ expr $rw < $rh ] {
		set r  $rw
	    } else {
		set r  $rh  
	    }
	    set cam1  [ lindex [ $mview -views ] 0 ] 
	    $cam1 -scale [  expr $r * [ $cam1 -scale ] ]
	    set graphics2D::busy 0
	}
    }
}

proc inrimage::viewInrimage { inr1 {scene "none"} {viewType inrview} {color "#E8E0D2"} {subcolor "#D8D0C2"} } {
    
    set mulview [new multiview]
    set parent ".${mulview}"
    inrimage::createToplevel $parent $inr1 $color 
    
    wm title $parent "$inr1 ([lindex  [split  [$inr1 -name] /] end]  )"
    #attach multiview to widget
    $mulview -parentWidget $parent
    
    #creates frames and sliders
    frame $parent.voxel -bg $color
    frame $parent.f1 -bg $color
    frame $parent.f2 -bg $color
    
    if {  $::tcl_platform(platform) == "windows" } {
	set theFont "ansifixed"
    } else {
	set theFont "fixed"
    }
    
    scale $parent.glmin -orient horizontal -width 10 -bg $color -label "min grey level" -font $theFont
    scale $parent.glmax -orient horizontal -font $theFont -width 10 -bg $color  -label "max grey level" 
    
    
    #creates frames for menu
    set submenu $parent.submenu 
    frame $parent.submenu  -bg "#D8D0C2"
    frame $submenu.context -height 26 -bg $subcolor
    label $submenu.name -text "no selected object" -anchor e -bg $subcolor
    
    #create min and max glscale
    set minglscale [new glscale -min -in $parent.glmin]
    set maxglscale [new glscale -max -in $parent.glmax]
    
    
    label $parent.voxel.v  -font $theFont -bg $color -text "Voxel Position "
    label $parent.voxel.l -font $theFont  -bg $color 
    
    
    
    frame $parent.f2.ne -bg $color
    frame $parent.f2.so -bg $color -borderwidth 1
    frame $parent.f2.se -bg $color -borderwidth 1
    
    grid $parent.f2.ne -column 2 -row 1 
    grid $parent.f2.so -column 1 -row 2 
    grid $parent.f2.se -column 2 -row 2       
    grid rowconfigure $parent.f2 1 -weight 1
    grid rowconfigure $parent.f2 2 -weight 1
    
    if ![string compare $scene "none" ] {
	set inrv [new $viewType $inr1  -noGLScale]
    } else {
	set inrv 0
	foreach {i} [$scene -objects] {
	    if {[string match $viewType* $i ]} {
		set inrv $i
	    }
	}
	if ![ string compare $inrv "0"] {
	    set inrv [new $viewType $inr1  $scene -noGLScale]
	}
    }
    set scn [$inrv -scene]
    #compute theoretical height and width
    set Theight [ expr [ lindex [ $inr1 -size ] 1 ] * [ lindex [ $inr1 -voxel ] 1 ] ]
    set Twidth [ lindex [ $inr1 -size ] 0 ]
    if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	set heightOffset 280
	set Theight [ expr $Theight + [ expr [ lindex [ $inr1 -size ] 2 ] * [ lindex [ $inr1 -voxel ] 2 ] ] ]
	#	 set Theight [ expr $Theight + [ expr [ lindex [ $inr1 -size ] 2 ] * [lindex [$inr1 -voxel ] 2] / [lindex [$inr1 -voxel ] 0 ] ] ]
	set Twidth [ expr $Twidth + [ expr [ lindex [ $inr1 -size ] 2 ] * [lindex [$inr1 -voxel ] 2] / [lindex [$inr1 -voxel ] 0 ] ] ]
    } else {
	set heightOffset 180
    }
    set Theight [ expr $heightOffset+$Theight ]
    #compute the scale that should be  applied such that the widget fits in the screen
    set scale 1.0
    set ratioHeight [ expr 1.0 * $Theight / [ winfo  screenheight . ]   ] 
    set ratioWidth [ expr 1.0 * $Twidth / [ winfo  screenwidth . ]  ] 
    
    if [ expr $ratioHeight > $ratioWidth ] {
	set ratio $ratioHeight
    } else {
	set ratio $ratioWidth
    }
    if [ expr $ratio > 1.0 ] {
	if [ expr $ratioHeight > $ratioWidth ] {
	    set scale [expr 1.0 / [ expr [ expr $Theight - $heightOffset ] / [ expr [ winfo  screenheight . ] * 0.95 - $heightOffset ] ] ]
	} else {
	    set scale [ expr 1.0 / [ expr $ratio *1.1] ]
	}
    }
    #create first camera
    if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	set cam1 [new slicecam Z -scene $scn -in $parent.f2.se -motion  $parent.voxel.l -useSlice true -useMenu true -menu $parent.submenu -scale $scale] 
    } else {
	set cam1 [new slicecam Z -scene $scn -in $parent.f2.se -motion  $parent.voxel.l -useSlice false -useMenu true -menu $parent.submenu -scale $scale] 
    }
    $mulview -add $cam1
    #get background
    set bg1 [$inrv -background $cam1]
    #attach grey-level and opacity scales
    $bg1 -greyLevel min $minglscale
    $bg1 -greyLevel max $maxglscale
    #get slice scale
    set slicescale [$cam1 -slicescale]
    #test if additional cameras should be added
    if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	update idletasks
	#create second camera
	set cam2 [new slicecam Y -scene $scn -in $parent.f2.ne -motion  $parent.voxel.l -useSlice true -useMenu false -scale $scale]
	$mulview -add $cam2
	$cam2 -scale $scale
	#get background
	set bg2 [$inrv -background $cam2]
	#attach grey-level and opacity scales
	$bg2 -greyLevel min $minglscale
	$bg2 -greyLevel max $maxglscale
	#create second camera
	set cam3 [new slicecam X -scene $scn -in $parent.f2.so -motion  $parent.voxel.l -useSlice true -useMenu false -scale $scale]
	$cam3 -scale $scale
	$mulview -add $cam3
	#get background
	set bg3 [$inrv -background $cam3]
	#attach grey-level and opacity scales
	$bg3 -greyLevel min $minglscale
	$bg3 -greyLevel max $maxglscale
	bind  $parent.f2.so.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
	bind  $parent.f2.ne.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
    }
    #packing widgets 
    pack $parent.voxel  -fill both
    pack $parent.f1   -fill both
    
    pack $submenu.context -side left -expand true -fill both
    pack $submenu.name -side right
    pack $submenu  -fill both
    
    pack $parent.voxel.v $parent.voxel.l  -side left
    
    pack  $parent.f2   -expand true -fill both
    pack  $parent.glmax $parent.glmin -fill x  -side bottom -before $parent.f2  
    
    #add menu
    menubutton $parent.f1.mv -text "Multi-view" -anchor w -menu $parent.f1.mv.m -bg $color
    inrimage::multiviewmenu $parent.f1.mv.m  $mulview $inr1 1
    pack $parent.f1.mv -side left
    menubutton $parent.f1.o  -text "Objects" -menu $parent.f1.o.m -anchor w -bg $color
    menu $parent.f1.o.m -bg $color -postcommand "
    scan \[ $cam1 -select \] {%s} selectedObject;  
    #delete previous items 
    $parent.f1.o.m  delete 0 last
    set listecam \[ \[$cam1 -scene\] -camera\]
    
    foreach {i} \[ \[$cam1 -scene\] -objects\] {
	$parent.f1.o.m  add radio -selectcolor \"black\" -variable selectedObject -label \$i -command \" foreach {cam} \[ list \$listecam \]  { evaluate \\\" \\\$cam -select \$i \\\"} \" }"
	
	pack  $parent.f1.o -side left
	
	menubutton $parent.f1.ao -text "Add Objects" -anchor w -menu $parent.f1.ao.m -bg $color
	inrimage::addObjectMenu $parent.f1.ao.m $mulview $inr1 1
	pack $parent.f1.ao -side left   
	
	
	if { ![string compare [ $inr1 -type] "floatVector"] || ![string compare [ $inr1 -type] "doubleVector"] } {
	    menubutton $parent.f1.vec -text "Display Mode" -menu $parent.f1.vec.mn -bg $color
	    set mn [menu $parent.f1.vec.mn -bg $color -postcommand ""] 
	    $mn add radiobutton -label "hide Vectors" -variable inrimage::dispMode -value "WITHOUT_VECTOR" -command "evaluate \"$inrv -displayMode \$inrimage::dispMode\""
	    $mn add radiobutton -label "show Vectors" -variable inrimage::dispMode -value "WITH_VECTOR" -command  "evaluate \"$inrv -displayMode \$inrimage::dispMode\""
	    $mn add radiobutton -label "show Vectors only" -variable inrimage::dispMode -value "VECTOR_ONLY" -command  "evaluate \"$inrv -displayMode \$inrimage::dispMode\""
	    $mn add command -label "Edit Vector Display Properties" -command "inrimage::vectorDialog $inr1 $inrv $color \$inrimage::dispMode"
	    pack $parent.f1.vec -side left
	}
	
	bind  $parent.f2.se.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
	
	update idletasks
	#    bind  $parent.f2 <Configure> "inrimage::resizeGrid $mulview %W %h %w 
	#    puts " [ lindex [ $inr1 -size ] 0 ] [ winfo  screenheight . ]"
	#    puts "$ratioWidth $ratioHeight $ratio $Theight [ winfo  screenheight . ] "
	
	return $mulview
    }
    
    proc inrimage::resizeImageWidget { mulview scaleFactor } {
	set parent ".${mulview}"
	#scan all backgrounds
	foreach b [$mulview -background] {
	    #get the real size used by the background
	    scan [$b -requiredSize] "%f %f" col row
	    #compute the theoretical aspect ratio required by the background
	    set theoreticalRatio [expr $col / $row]
	    #compte the actual aspect ratio
	    set realRatio [ expr [ [ $b -camera] -width ]*1.0  / [ [ $b -camera] -height ] ]
	    
	    #puts "cam=[$b -camera] theroreticalRatio=$theoreticalRatio realRatio=$realRatio\n"
	    if [expr $realRatio > $theoreticalRatio ]  {
		set col [expr [ [ $b -camera] -height ] * $theoreticalRatio ]
		set row  [ [ $b -camera] -height  ]
	    } else {
		set row [expr [ [ $b -camera] -width ] / $theoreticalRatio ]
		set col  [ [ $b -camera] -width ] 
	    }
	    
	    if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parent.f2.se ] {
		set col2 [ expr $col * $scaleFactor ]
		set row2 [ expr $row * $scaleFactor ]
	    } 
	    if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parent.f2.ne ] {
		set row1 [ expr $row * $scaleFactor ]
		set col2 [ expr $col * $scaleFactor ]
	    } 
	    if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parent.f2.so ] {
		set col1 [ expr $col * $scaleFactor ]
		set row2 [ expr $row * $scaleFactor ]
	    } 
	}
	
	foreach b [$mulview -background] {
	    if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parent.f2.se ] {
		evaluate "[$b -camera] -resize $col2 $row2"
	    }
	    if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parent.f2.ne ] {
		evaluate "[$b -camera] -resize $col2 $row1"
	    }
	    if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parent.f2.so ] {
		evaluate "[$b -camera] -resize $col1 $row2"
	    }
	    
	}
	
    }
    proc inrimage::algorithmDialogAddTab { widget listEntries color } {
	frame $widget -bg $color
	set table1 [blt::table $widget ] 
	
	
	label  $table1.des -text "Algorithm Description" -background lightgrey -borderwidth 1 
	label  $table1.launch -text "Launch Algorithm" -background lightgrey -borderwidth 1 
	
	blt::table $table1 $table1.des 0,0 -fill x
	blt::table $table1 $table1.launch 0,1 -fill x
	blt::table configure $table1 r0 -height 0.3i
	if {  $::tcl_platform(platform) == "windows" } {
	blt::table configure $table1 c0 -width 3.0i 
	blt::table configure $table1 c1 -width 1.0i
	} else {
	blt::table configure $table1 c0 -width 4.5i -resize expand
	blt::table configure $table1 c1 -width 2.0i
	}
	set v 1
	foreach {i} $listEntries {
	    set labelEntry [lindex $i 0]
	    set labelCommand [lindex $i 1]
	    
	    label  $table1.des$v -text $labelEntry -background $color 
	    button  $table1.button$v -text "Launch" -background $color -command $labelCommand
	    
	    blt::table $table1 $table1.des$v $v,0  -anchor w
	    blt::table $table1 $table1.button$v $v,1 -fill x -padx 0 
	    blt::table configure $table1 r$v -height 0.3i
	    
	    set v [expr $v+1]
	}
    }
    proc inrimage::algorithmDialog { mulview inr1 color } {
	set root .algo
	if ![winfo exists $root] {
	    toplevel $root
	    frame $root.f2 -bg $color
	    frame $root.f1 -bg $color
	    pack $root.f1 -expand true -fill x
	    pack $root.f2 -expand true -fill both
	    
	    global algoImage
	    label $root.f1.label -text "Choose the image on which to apply algorithms" -bg $color
	    inrimage::inrOptionMenu $root.f1.menu "set algoImage ..." lightblue
	    set algoImage $inr1
	    pack $root.f1.label -side left 
	    pack $root.f1.menu -side right
	    
	    set tab [blt::tabset $root.f2.tabset -relief sunken -borderwidth 2 ]
	    $tab insert 0 "Copy" -background $color -selectbackground $color -activeforeground blue -selectforeground red
	    $tab insert 1 "Filtering" -background $color -selectbackground $color -activeforeground  blue -selectforeground red
	    $tab insert 2 "Morphology" -background $color -selectbackground $color -activeforeground blue -selectforeground red
	    $tab insert 3 "Mathematics" -background $color -selectbackground $color -activeforeground blue -selectforeground red
	    $tab insert 4 "Thresholding" -background $color -selectbackground $color -activeforeground blue -selectforeground red
	    $tab insert 5 "ROI" -background $color -selectbackground $color -activeforeground blue -selectforeground red
	    $tab insert 6 "3D" -background $color -selectbackground $color -activeforeground blue -selectforeground red
	    
	    $tab configure -tiers 2
	    
	    set theList "[ list  [ list "Modifiy Voxel Size"  "inrimage::voxelSizeDialog \$algoImage $color;puts \$algoImage" ] ]"
	    lappend theList [ list "Copy Image into new Image" "evaluate \" \$algoImage -copy\" " ] 
	    lappend theList [ list "Create a new Image from scratch" "inrimage::inrimageDialog $color" ] 
	    lappend theList [ list "Convert an image to a different type" "inrimage::convertDialog \$algoImage $color" ] 
	    lappend theList [ list "Insert an image inside a that image" "inrimage::melDialog \$algoImage $color" ] 
	    lappend theList [ list "Flip Image along a given direction" "inrimage::flipDialog \$algoImage $color" ] 
	    
	    inrimage::algorithmDialogAddTab $tab.copy $theList $color   
	    $tab tab configure "Copy" -window $tab.copy -anchor n -fill x -padx 0.25i -pady 0.05i
	
	    
	    set theList "[ list  [ list "Extract Gradient norm and direction"  "inrimage::gradientDialog \$algoImage $color" ] ]"
	    lappend theList [ list "Compute the Laplacian of the image" "inrimage::laplacianDialog \$algoImage $color" ] 
	    lappend theList [ list "Compute the convolution of the image with a kernel" "inrimage::convoluteDialog \$algoImage $color" ] 
	    lappend theList [ list "Apply recursive filters to an image" "inrimage::recursiveFilterDialog \$algoImage $color" ] 
	    lappend theList [ list "Add noise to an image" "inrimage::noiseDialog \$algoImage $color" ] 
	    lappend theList [ list "Anisotropic filtering with a scalar diffusion term" "inrimage::anisoDiffScalDialog \$algoImage $color" ] 
	    lappend theList [ list "Anisotropic filtering with a diffusion matrix" "inrimage::anisoDiffMatDialog \$algoImage $color" ] 
	    lappend theList [ list "Diffusion designed to enhance vessels" "inrimage::anisoDiffVesselsDialog \$algoImage $color" ] 
	        
	    
	    inrimage::algorithmDialogAddTab $tab.filtering $theList $color   
	    $tab tab configure "Filtering" -window $tab.filtering -anchor n -fill x -padx 0.25i -pady 0.05i
	    
	    set theList "[ list  [ list "Apply Erosion, Dilation, Opening or Closure"  "inrimage::morphomathematicDialog \$algoImage $color" ] ]"
	    lappend theList [ list "Extract connected components" "inrimage::connexeDialog \$algoImage $color" ] 
	    lappend theList [ list "Fill binary cavities in 2D and 3D" "inrimage::fillDialog \$algoImage $color" ] 
	    lappend theList [ list "Building Distance Maps (Chamfer Method)" "inrimage::chamferDialog \$algoImage $color" ] 
	    
	    inrimage::algorithmDialogAddTab $tab.morpho $theList $color   
	    $tab tab configure "Morphology" -window $tab.morpho -anchor n -fill x -padx 0.25i -pady 0.05i -background $color
	    
	    set theList "[ list  [ list "Combine images with arithmetic operators"  "inrimage::arithmeticDialog \$algoImage $color" ] ]"
	    lappend theList [ list "Combine images with logic operators" "inrimage::logicDialog \$algoImage $color" ] 
	    lappend theList [ list "Evaluate expression in a command dialog" "inrimage::evalDialog \$algoImage $color" ] 
	    lappend theList [ list "Compute 2D Fourier Transform" "evaluate \" \$algoImage -dft 2D\" " ] 
	    lappend theList [ list "Compute 3D Fourier Transform" "evaluate \" \$algoImage -dft 3D\" " ] 
	    
	    inrimage::algorithmDialogAddTab $tab.math $theList $color   
	    $tab tab configure "Mathematics" -window $tab.math -anchor n -fill x -padx 0.25i -pady 0.05i -background $color
	    
	    set theList "[ list  [ list "Threshold image"  "inrimage::thresholdDialog \$algoImage $color" ] ]"
	    lappend theList [ list "Display Image histogram" "set h \[ evaluate \"\$algoImage -histogram\" \];evaluate \" \$h -plot\" " ]
	    lappend theList [ list "Apply Image Windowing" "inrimage::windowDialog \$algoImage $color" ]
	    
	    inrimage::algorithmDialogAddTab $tab.thresh $theList $color   
	    $tab tab configure "Thresholding" -window $tab.thresh -anchor n -fill x -padx 0.25i -pady 0.05i -background $color
	    
	    set theList "[ list  [ list "Crop Image (with Dialog)"  "inrimage::cropDialog \$algoImage $color" ] ]"
	    lappend theList [ list "Crop Image (interactive)" "inrimage::boundingBoxAlgo  \$algoImage  inrimage::viewerXCropMenu" ] 
	    lappend theList [ list "Isolate Region (outside set to 0)  (interactive)" "inrimage::boundingBoxAlgo  \$algoImage  inrimage::viewerXIsolateMenu" ] 
	    lappend theList [ list "Zero Region (interactive)" "inrimage::boundingBoxAlgo  \$algoImage  inrimage::viewerXZeroMenu" ] 
	    lappend theList [ list "Manual delineation of a single ROI" "set mview \[inrimage::getMultiviewFromImage \$algoImage\]; if \[string match \$mview none\] { view \$algoImage; set mview \[inrimage::getMultiviewFromImage \$algoImage\]}; evaluate \" new roie \$algoImage \[inrimage::getScene2DFromMultiview \$mview\]\" " ]
	    lappend theList [ list "Manual delineation of a set of ROIs" "set mview \[inrimage::getMultiviewFromImage \$algoImage\]; if \[string match \$mview none\] { view \$algoImage; set mview \[inrimage::getMultiviewFromImage \$algoImage\]}; evaluate \" new rlist \$algoImage \[inrimage::getScene2DFromMultiview \$mview\]\" " ]
	    lappend theList [ list "Adding landmarks to an image" "set mview \[inrimage::getMultiviewFromImage \$algoImage\]; if \[string match \$mview none\] { view \$algoImage; set mview \[inrimage::getMultiviewFromImage \$algoImage\]}; evaluate \" new lset -scene \[inrimage::getScene2DFromMultiview \$mview\]\" " ]
	    lappend theList [ list "Loading landmarks from a image" "set mview \[inrimage::getMultiviewFromImage \$algoImage\]; if \[string match \$mview none\] { view \$algoImage; set mview \[inrimage::getMultiviewFromImage \$algoImage\]}; evaluate \" new lset -scene \[inrimage::getScene2DFromMultiview \$mview\] \[tk_getOpenFile -filetypes { {{Landmark Set} {.lset} } {{All} *} } -parent . -title {Select a Landmark Set} \]\" " ]
	    
	    inrimage::algorithmDialogAddTab $tab.roi $theList $color   
	    $tab tab configure "ROI" -window $tab.roi -anchor n -fill x -padx 0.25i -pady 0.05i -background $color
	    
	    set theList "[ list  [ list "Extract Isosurface" "if {!\[string compare \[isModuleLoaded tclCIsosurf \] no \]} { evaluate \"yav::setDependance; yav::loadModule tclCIsosurf yav::moduleDependance\"; if [winfo exists .yavModule ] {yav::updateModuleDialog .yavModule } }; cisosurf::extractIsosurf \$algoImage $color" ] ]"
	    lappend theList [ list "Extract Crest Lines" "if {!\[string compare \[isModuleLoaded tclCIsosurf \] no \]} { evaluate \"yav::setDependance; yav::loadModule tclCIsosurf yav::moduleDependance\"; if [winfo exists .yavModule ] {yav::updateModuleDialog .yavModule } }; cisosurf::extractIsosurf \$algoImage $color"
	    inrimage::algorithmDialogAddTab $tab.3d $theList $color   
	    $tab tab configure "3D" -window $tab.3d -anchor n -fill x -padx 0.25i -pady 0.05i -background $color
	    ] 
	    
	    
	    pack $tab -fill both -expand true
	    
	    
	}
    }
    
    proc inrimage::swapSingleView {mulview color cam inr1 strScene viewType theFont parentWidget menuWidget} {
	if [ expr [llength [$mulview -background] ] > 1 ] {
	    #remove all cameras but one
	    set height [winfo height $parentWidget]
	    set width [winfo width $parentWidget]
	    
	    foreach b [$mulview -background] {
		if ![string match [$b -camera] $cam] {
		    set widget [winfo parent [ [$b -camera] -widget] ]
		    [$b -camera] -destroy
		    destroy $widget
		} else {
		    set widget [winfo parent [ [$b -camera] -widget] ]
		    $widget.f1.button configure -text "3 views" -width 5
		    modules::setTooltip $widget.f1.button "Create two additional cameras"
		    set  theBackground $b  	    
		}
	    }
	    set wcol2 [ expr [ lindex [ $inr1 -size ] 0 ] * [ lindex [ $inr1 -voxel ] 0 ] ]
	    set hrow2 [ expr [ lindex [ $inr1 -size ] 1 ] * [ lindex [ $inr1 -voxel ] 1 ] ]
	    set hrow1 [ expr [ lindex [ $inr1 -size ] 2 ] * [ lindex [ $inr1 -voxel ] 2 ] ]
	    
	    if [string match [ winfo parent [ [$theBackground -camera ] -widget ] ] $parentWidget.se ] {
		set Twidth $wcol2
		set Theight $hrow2
	    }
	    if [string match [ winfo parent [ [$theBackground -camera ] -widget ] ] $parentWidget.so ] {
		set Twidth $hrow1
		set Theight $hrow2
	    }
	    if [string match [ winfo parent [ [$theBackground -camera ] -widget ] ] $parentWidget.ne ] {
		set Twidth $wcol2
		set Theight $hrow1
	    }
	    set ratioHeight [ expr 1.0 * $Theight / $height   ] 
	    set ratioWidth [ expr 1.0 * $Twidth / $width  ] 
	    
	    if [ expr $ratioHeight > $ratioWidth ] {
		set ratio $ratioHeight
	    } else {
		set ratio $ratioWidth
	    }
	    set scale [ expr 1.0 / $ratio ]
	    
	    set Twidth [ expr $scale * $Twidth]
	    set Theight [ expr $scale * $Theight]
	    
	    evaluate "[$theBackground -camera] -resize $Twidth $Theight"
	    
	    
	    
	} else {
	    #create all other cameras
	    set b [ lindex  [$mulview -background] 0 ]
	    set widget [winfo parent [ [$b -camera] -widget] ]
	    if [winfo exists $widget.f1] {
		destroy $widget.f1
	    } 
	    update idletasks
	    set height [winfo height $parentWidget]
	    set width [winfo width $parentWidget]
	    set wcol2 [ expr [ lindex [ $inr1 -size ] 0 ] * [ lindex [ $inr1 -voxel ] 0 ] ]
	    set hrow2 [ expr [ lindex [ $inr1 -size ] 1 ] * [ lindex [ $inr1 -voxel ] 1 ] ]
	    set hrow1 [ expr [ lindex [ $inr1 -size ] 2 ] * [ lindex [ $inr1 -voxel ] 2 ] ]
	    
	    set Theight [ expr $wcol2 +$hrow1 ]
	    set Twidth [ expr $hrow2 +$hrow1 + 8]
	    set ratioHeight [ expr 1.0 * $Theight / $height   ] 
	    set ratioWidth [ expr 1.0 * $Twidth / $width  ] 
	    
	    if [ expr $ratioHeight > $ratioWidth ] {
		set ratio $ratioHeight
	    } else {
		set ratio $ratioWidth
	    }
	    set scale [ expr 1.2 / $ratio ]
	    
	    set wcol2 [ expr [ lindex [ $inr1 -size ] 0 ] * [ lindex [ $inr1 -voxel ] 0 ] * $scale ]
	    set hrow2 [ expr [ lindex [ $inr1 -size ] 1 ] * [ lindex [ $inr1 -voxel ] 1 ] * $scale ]
	    set hrow1 [ expr [ lindex [ $inr1 -size ] 2 ] * [ lindex [ $inr1 -voxel ] 2 ] * $scale ]
	    
	    if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parentWidget.se ] {
		evaluate "[$b -camera] -resize $wcol2 $hrow2"
		
		set padx 2
		set pady 2
		frame $parentWidget.ne -bg $color -padx $padx -pady $pady
		frame $parentWidget.so -bg $color  -padx $padx -pady $pady
		
		grid $parentWidget.ne -column 2 -row 1 -sticky nsew
		grid $parentWidget.so -column 1 -row 2  -sticky nsew
		
		grid rowconfigure $parentWidget 1 -uniform 1
		grid rowconfigure $parentWidget 2 -uniform 2
		grid columnconfigure $parentWidget 1 -uniform 3
		grid columnconfigure $parentWidget 2 -uniform 4
		
		grid rowconfigure $parentWidget 1 -weight 1
		grid rowconfigure $parentWidget 2 -weight 1
		grid columnconfigure $parentWidget 1 -weight 1
		grid columnconfigure $parentWidget 2 -weight 1
		
		set cam2 [new cam2D -scene $strScene -in $parentWidget.ne -width $wcol2 -height $hrow1]
		$cam2 -alwaysTrackMouseMotion true
		if ![string match $menuWidget none] {
		$cam2 -menu $menuWidget
                }
		#get background
		set bg2 [new $viewType $cam2 $mulview Y]
		
		
		set cam3 [new cam2D -scene $strScene -in $parentWidget.so -width $hrow1 -height $hrow2]
		$cam3 -alwaysTrackMouseMotion true
		if ![string match $menuWidget none] {
		$cam3 -menu $menuWidget
                }
#		$cam3 -menu $parent.submenu
		set bg3 [new $viewType $cam3 $mulview X]
		update idletasks
		inrimage::changeSliders $mulview $color $theFont $inr1 $strScene $viewType $parentWidget $menuWidget
		
	    }
	    if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parentWidget.so ] {
		
		set padx 2
		set pady 2
		frame $parentWidget.ne -bg $color -padx $padx -pady $pady
		frame $parentWidget.se -bg $color  -padx $padx -pady $pady
		
		grid $parentWidget.ne -column 2 -row 1 -sticky nsew
		grid $parentWidget.se -column 2 -row 2  -sticky nsew
		
		grid rowconfigure $parentWidget 1 -uniform 1
		grid rowconfigure $parentWidget 2 -uniform 2
		grid columnconfigure $parentWidget 1 -uniform 3
		grid columnconfigure $parentWidget 2 -uniform 4
		
		grid rowconfigure $parentWidget 1 -weight 1
		grid rowconfigure $parentWidget 2 -weight 1
		grid columnconfigure $parentWidget 1 -weight 1
		grid columnconfigure $parentWidget 2 -weight 1
		
		set cam2 [new cam2D -scene $strScene -in $parentWidget.ne  -width $wcol2 -height $hrow1]
		$cam2 -alwaysTrackMouseMotion true
		if ![string match $menuWidget none] {
		$cam2 -menu $menuWidget
                }
#		$cam2 -menu $parent.submenu
		#get background
		set bg2 [new $viewType $cam2 $mulview Y]
		
		
		set cam3 [new cam2D -scene $strScene -in $parentWidget.se -width $wcol2 -height $hrow2]
		$cam3 -alwaysTrackMouseMotion true
		if ![string match $menuWidget none] {
		$cam3 -menu $menuWidget
                }
#		$cam3 -menu $parent.submenu
		set bg3 [new $viewType $cam3 $mulview Z]
		
		evaluate "[$b -camera] -resize $hrow1 $hrow2 "
		
		
		inrimage::changeSliders $mulview $color $theFont $inr1 $strScene $viewType $parentWidget $menuWidget
	    }
	    if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parentWidget.ne ] {
		
		set padx 2
		set pady 2
		frame $parentWidget.so -bg $color -padx $padx -pady $pady
		frame $parentWidget.se -bg $color  -padx $padx -pady $pady
		
		grid $parentWidget.so -column 1 -row 2 -sticky nsew
		grid $parentWidget.se -column 2 -row 2  -sticky nsew
		
		grid rowconfigure $parentWidget 1 -uniform 1
		grid rowconfigure $parentWidget 2 -uniform 2
		grid columnconfigure $parentWidget 1 -uniform 3
		grid columnconfigure $parentWidget 2 -uniform 4
		
		grid rowconfigure $parentWidget 1 -weight 1
		grid rowconfigure $parentWidget 2 -weight 1
		grid columnconfigure $parentWidget 1 -weight 1
		grid columnconfigure $parentWidget 2 -weight 1
		
		set cam2 [new cam2D -scene $strScene -in $parentWidget.so -width $wcol2 -height $hrow1]
		$cam2 -alwaysTrackMouseMotion true
		if ![string match $menuWidget none] {
		$cam2 -menu $menuWidget
                }
#		$cam2 -menu $parent.submenu
		#get background
		set bg2 [new $viewType $cam2 $mulview X]
		
		
		set cam3 [new cam2D -scene $strScene -in $parentWidget.se -width $wcol2 -height $hrow2]
		$cam3 -alwaysTrackMouseMotion true
		if ![string match $menuWidget none] {
		$cam3 -menu $menuWidget
                }
#		$cam3 -menu $parent.submenu
		set bg3 [new $viewType $cam3 $mulview Z]
		
		evaluate "[$b -camera] -resize $wcol2 $hrow1 "
		
		
		inrimage::changeSliders $mulview $color $theFont $inr1 $strScene $viewType $parentWidget $menuWidget 
	    }
	    
	}
    }
    
    proc inrimage::changeSliders {mulview color theFont inr1 strscene viewtype parentWidget menuWidget} {
	foreach b [$mulview -background] {
	    if ![string match [$b -sliceScale] "none"] {
		destroy [ winfo parent  [ [$b -sliceScale] -widget ] ]  
	    } else {
		if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parentWidget.se ] {
		    set label "Z"
		    set scaleWidget $parentWidget.se
		}
		if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parentWidget.ne ] {
		    set label "Y"
		    set scaleWidget $parentWidget.ne
		}
		if [string match [ winfo parent [ [$b -camera ] -widget ] ] $parentWidget.so ] {
		    set label "X"
		    set scaleWidget $parentWidget.so
		}
		inrimage::createSlider $scaleWidget $mulview $color $b $label $theFont $inr1 $strscene $viewtype $parentWidget $menuWidget
		modules::setTooltip $scaleWidget.f1.button "Maximize this camera"    
		
	    }
	}
    }

    proc inrimage::createSlider {scaleWidget mulview color b label theFont inr1 strscene viewtype parentWidget menuWidget} {
	set sliceframe [frame $scaleWidget.f1 -bg $color ]
	pack $sliceframe -side bottom -fill x -before [ [$b -camera] -widget] -expand true
	set slicescale [scale $sliceframe.scale -width 3 -orient horizontal -bg $color -showvalue false -font $theFont]
	set slicebutton [button $sliceframe.button -width 2 -text "+" -bg lightblue -command "inrimage::swapSingleView $mulview $color [$b -camera] $inr1 $strscene $viewtype $theFont $parentWidget $menuWidget" ]
	set slicelabel [label $sliceframe.label -width 2 -text $label -bg $color ]
	set sliceValue [label $sliceframe.value -width 2  -bg $color ]
	bind  $slicescale <Configure> "$sliceValue configure -text \[$slicescale get\]"
	bind  $slicescale <Motion> "$sliceValue configure -text \[$slicescale get\]"
	bind  $slicescale <Right> "$sliceValue configure -text \[$slicescale get\]"
	bind  $slicescale <Left> "$sliceValue configure -text \[$slicescale get\]"
	
	pack $slicebutton -side right
	pack $sliceValue -side right
	pack $slicelabel -side left
	pack $slicescale -fill x -expand true -side left
	$b -sliceScale $slicescale
    }
    
    proc inrimage::createGLSlider {glminframe glmaxframe orient side  color theFont} {
	
	set glminscale [scale $glminframe.scale -width 10 -showvalue false -orient $orient -bg $color -font $theFont]
	set glminvalue [label $glminframe.value -width 3 -font $theFont ]
	set glminlabel [label $glminframe.label -width 3 -wraplength 25 -text "min" -bg $color ]
	
	
	set glmaxscale [scale $glmaxframe.scale -width 10 -showvalue false -orient $orient -bg $color -font $theFont]
	set glmaxvalue [label $glmaxframe.value -width 3 -font $theFont ]
	set glmaxlabel [label $glmaxframe.label -width 3 -wraplength 25 -text "max" -bg $color ]
	
	bind  $glminscale <Configure> "$glminvalue configure -text \[$glminscale get\]"
	bind  $glminscale <Motion> "$glminvalue configure -text \[$glminscale get\]"
	bind  $glmaxscale <Configure> "$glmaxvalue configure -text \[$glmaxscale get\]"
	bind  $glmaxscale <Motion> "$glmaxvalue configure -text \[$glmaxscale get\]"
	
	
	#create min and max glscale
	set minglscale [new glscale -min -in $glminscale]
	set maxglscale [new glscale -max -in $glmaxscale]
	
	
	if [string match $orient "horizontal"] {
	    pack $glminvalue -side right
	    pack $glminlabel -side left
	    pack $glminscale -fill x -expand true -side left
	    
	    pack $glmaxvalue -side right
	    pack $glmaxlabel -side left
	    pack $glmaxscale -fill x -expand true -side left
	} else {
	    pack $glminvalue -side bottom
	    pack $glminlabel -side top
	    pack $glminscale -fill y -expand true -side top
	    
	    pack $glmaxvalue -side bottom
	    pack $glmaxlabel -side top
	    pack $glmaxscale -fill y -expand true -side top
	}
	
	return "$minglscale $maxglscale"    	
    }
    
    proc inrimage::viewImage { inr1 {inr2 "none"} {scene "none"} {viewType imageBgnd}  {color "#E8E0D2"} {subcolor "#D8D0C2"} } {
	
	set mulview [new multiview $inr1]
	set parent ".${mulview}"
	
	if ![string match $inr2 "none"] {
	    $mulview -secondImage $inr2
	}
	inrimage::createToplevel $parent $inr1 $color 
	
	wm title $parent "$inr1 ([lindex  [split  [$inr1 -name] /] end]  )"
	#attach multiview to widget
	$mulview -parentWidget $parent
	
	#creates frames and sliders
	frame $parent.voxel -bg $color
	frame $parent.f1 -bg $color
	frame $parent.f2 -bg $color
	frame $parent.f3 -bg $color
	
	if {  $::tcl_platform(platform) == "windows" } {
	    set theFont "ansifixed"
	    set theMenuButtonWidth 5
	} else {
	    set theFont "fixed"
   	    set theMenuButtonWidth 7
	}
	if ![string compare $scene "none" ] {
	    #always create a new scene when creating a new slicer
	    set strScene [new scn2D]
	} else {
	    set strScene "$scene"
	}
	
	set glminframe [frame $parent.glmin -bg $color ]
	set glmaxframe [frame $parent.glmax -bg $color ]
	
	if ![string match $inr2 "none"] {
	    scan [inrimage::createGLSlider $glminframe $glmaxframe vertical left  $color $theFont] "%s %s" minglscale maxglscale
	} else {
	    scan [inrimage::createGLSlider $glminframe $glmaxframe horizontal bottom  $color $theFont] "%s %s" minglscale maxglscale
	}
	
	
	if ![string match $inr2 "none"] {
	    frame $parent.f4 -bg $color
	    
	    label $parent.f4.l1 -bg $color -text $inr2 -width 5 -height 2 -wraplength 25
	    pack $parent.f4.l1 -side top -anchor n -fill none -expand false
	    modules::setTooltip   $parent.f4.l1 [$inr2 -name]
	    
	    
	    menubutton $parent.f4.b16 -relief raised -direction right -bg $color -text "Colormap" -width 4 -height 2 -wraplength 25 -menu $parent.f4.b16.m
	    inrimage::colormapMenu $parent.f4.b16.m $mulview $color -colormap2
	    pack $parent.f4.b16 -side top -anchor n -fill none -expand false
	    modules::setTooltip   $parent.f4.b16 "Change Image Colormap"
	    
	    button $parent.f4.b7 -bg $color -text "Info"  -width 5 -height 2 -command "inrimage::imageInfoDialog $inr2 $color"
	    pack $parent.f4.b7 -side top -anchor n -fill none -expand false
	    modules::setTooltip   $parent.f4.b7 "Display Image Information"    
	    
	    set opacframe [frame $parent.opacity -bg $color ]
	    set opacscale [scale $opacframe.scale -width 10 -orient horizontal -bg $color -font $theFont]
	    set opaclabel [label $opacframe.label -width 3 -wraplength 25 -text "Opacity" -bg $color ]
	    
	    pack $opaclabel -side left
	    pack $opacscale -fill x -expand true -side left
	    
	    set opacityscale [new opascale  -in $opacscale]
	    
	    $mulview -opacityScale $opacityscale
	    
	    set glminframe2 [frame $parent.glmin2 -bg $color ]
	    set glmaxframe2 [frame $parent.glmax2 -bg $color ]
	    
	    scan [inrimage::createGLSlider $glminframe2 $glmaxframe2 vertical left  $color $theFont] "%s %s" minglscale2 maxglscale2    
	} 
	
	
	label $parent.f3.l1 -bg $color -text $inr1 -width 5 -height 2 -wraplength 25
	pack $parent.f3.l1 -side top -anchor n -fill none -expand false
	modules::setTooltip   $parent.f3.l1 [$inr1 -name]
	
	checkbutton $parent.f3.b1 -bg $color -onvalue true -offvalue false -text "axis" -width $theMenuButtonWidth -height 2 -indicatoron false -command "$mulview -showAxis \$b1"
	pack $parent.f3.b1 -side top -anchor n -fill none -expand false
	if [$mulview -showAxis] {
	    $parent.f3.b1 select
	}
	modules::setTooltip   $parent.f3.b1 "Show/Hide Axis at mouse pointer"
	
	button $parent.f3.b2 -bg $color -text "+" -width 5 -height 2  -command "inrimage::resizeImageWidget $mulview 1.10"
	pack $parent.f3.b2 -side top -anchor n -fill none -expand false
	modules::setTooltip   $parent.f3.b2 "Enlarge all cameras by 10 percent"
	
	button $parent.f3.b3 -bg $color -text "-" -width 5 -height 2 -command "inrimage::resizeImageWidget $mulview 0.91"
	pack $parent.f3.b3 -side top -anchor n -fill none -expand false
	modules::setTooltip   $parent.f3.b3 "Shrink all cameras by 10 percent"
	
	menubutton $parent.f3.b16 -relief raised -direction right -bg $color -text "Colormap" -width $theMenuButtonWidth  -height 2 -wraplength 25 -menu $parent.f3.b16.m
	inrimage::colormapMenu $parent.f3.b16.m $mulview $color
	pack $parent.f3.b16 -side top -anchor n -fill none -expand false
	modules::setTooltip   $parent.f3.b16 "Change Image Colormap"
	
	checkbutton $parent.f3.b4 -bg $color -offvalue moveSlices -onvalue changeWindowing -text "Window" -width $theMenuButtonWidth  -height 2 -indicatoron false -command "$mulview -middleMouseAction \$b4"
	pack $parent.f3.b4 -side top -anchor n -fill none -expand false
	if [string match [$mulview -middleMouseAction] moveSlices ] {
	    $parent.f3.b4 deselect
	}
	modules::setTooltip   $parent.f3.b4 "Mouse motion control : change windowing or slices"
	
	
	button $parent.f3.b5 -bg $color -text "Sliders"  -width 5 -height 2 -command "inrimage::changeSliders $mulview $color $theFont $inr1 $strScene $viewType $parent.f2 $parent.submenu"
	pack $parent.f3.b5 -side top -anchor n -fill none -expand false
	modules::setTooltip   $parent.f3.b5 "Show or Hide scale widgets for each camera"
	
	button $parent.f3.algo -bg $color -text "Algo"  -width 5 -height 2 -command "inrimage::algorithmDialog  $mulview $inr1 $color"
	pack $parent.f3.algo -side top -anchor n -fill none -expand false
	modules::setTooltip   $parent.f3.algo "Apply algorithms on images"
	
	if { ![string compare [ $inr1 -type] "floatVector"] || ![string compare [ $inr1 -type] "doubleVector"] } {
	    button $parent.f3.b6 -bg $color -text "vector"  -width 5 -height 2 -command "inrimage::vectorImageDialog $inr1 $mulview $color $theFont"
	    pack $parent.f3.b6 -side top -anchor n -fill none -expand false
	    modules::setTooltip   $parent.f3.b6 "Change vector display"    
	}
	
	button $parent.f3.b7 -bg $color -text "info"  -width 5 -height 2 -command "inrimage::imageInfoDialog $inr1 $color"
	pack $parent.f3.b7 -side top -anchor n -fill none -expand false
	modules::setTooltip   $parent.f3.b7 "Display Image Information"    
	
	button $parent.f3.b15 -bg $color -text "script"  -width 5 -height 2 -command "if {!\[winfo exists .yav\]} {loadSource tclModules.tcl; loadSource yav++.tcl;yav::interface} else {destroy .yav}"
	pack $parent.f3.b15 -side top -anchor n -fill none -expand false
	modules::setTooltip   $parent.f3.b15 "Show or Hide Script window"    
	
	button $parent.f3.b20 -bg $color -text "exit"  -width 5 -height 2 -command "exit"
	pack $parent.f3.b20 -side top -anchor n -fill none -expand false
	modules::setTooltip   $parent.f3.b20 "Quit application"    
	
	#creates frames for menu
	set submenu $parent.submenu 
	frame $parent.submenu  -bg "#D8D0C2"
	frame $submenu.context -height 26 -bg $subcolor
	label $submenu.name -text "no selected object" -anchor e -bg $subcolor
	
	font create smallFont
	font configure smallFont -family "Times" -size 8
	label $parent.voxel.v  -font $theFont -bg lightgrey 
	label $parent.voxel.l   -bg lightgrey -font smallFont -justify left   
	font delete smallFont 
	
	set padx 2
	set pady 2
	frame $parent.f2.ne -bg $color -padx $padx -pady $pady
	frame $parent.f2.so -bg $color  -padx $padx -pady $pady
	frame $parent.f2.se -bg $color  -padx $padx -pady $pady
	
	grid $parent.f2.ne -column 2 -row 1 -sticky nsew
	grid $parent.f2.so -column 1 -row 2  -sticky nsew
	grid $parent.f2.se -column 2 -row 2   -sticky nsew
	
	grid rowconfigure $parent.f2 1 -uniform 1
	grid rowconfigure $parent.f2 2 -uniform 2
	grid columnconfigure $parent.f2 1 -uniform 3
	grid columnconfigure $parent.f2 2 -uniform 4
	
	grid rowconfigure $parent.f2 1 -weight 1
	grid rowconfigure $parent.f2 2 -weight 1
	grid columnconfigure $parent.f2 1 -weight 1
	grid columnconfigure $parent.f2 2 -weight 1
	
	
	#compute theoretical height and width
	set wcol2 [ expr [ lindex [ $inr1 -size ] 0 ] * [ lindex [ $inr1 -voxel ] 0 ] ]
	set hrow2 [ expr [ lindex [ $inr1 -size ] 1 ] * [ lindex [ $inr1 -voxel ] 1 ] ]
	set hrow1 [ expr [ lindex [ $inr1 -size ] 2 ] * [ lindex [ $inr1 -voxel ] 2 ] ]
	
	set Theight [ expr $wcol2 +$hrow1 ]
	set Twidth [ expr $hrow2 +$hrow1 + 4 * $padx]
	
	#compute the scale that should be  applied such that the widget fits in the screen
	set scale 1.0
	set ratioHeight [ expr 2.0 * $Theight / [ winfo  screenheight . ]   ] 
	set ratioWidth [ expr 2.0 * $Twidth / [ winfo  screenwidth . ]  ] 
	
	if [ expr $ratioHeight > $ratioWidth ] {
	    set ratio $ratioHeight
	} else {
	    set ratio $ratioWidth
	}
	
	set scale [ expr 1.3 / $ratio ]
	
	set wcol2 [ expr [ lindex [ $inr1 -size ] 0 ] * [ lindex [ $inr1 -voxel ] 0 ] * $scale ]
	set hrow2 [ expr [ lindex [ $inr1 -size ] 1 ] * [ lindex [ $inr1 -voxel ] 1 ] * $scale ]
	set hrow1 [ expr [ lindex [ $inr1 -size ] 2 ] * [ lindex [ $inr1 -voxel ] 2 ] * $scale ]
	
	#create first camera
	set cam1 [new cam2D -scene $strScene -in $parent.f2.se -width $wcol2 -height $hrow2] 
	$cam1 -alwaysTrackMouseMotion true
	$cam1 -menu $parent.submenu
	#get background
	set bg1 [new $viewType $cam1 $mulview Z]
	
	$mulview -GLScale min $minglscale
	$mulview -GLScale max $maxglscale
	$mulview -labelWidget $parent.voxel.l
	
	bind [$cam1 -widget] <Leave> "$mulview -hideAxis" 
	
	#attach grey-level and opacity scales
	#get slice scale
	#test if additional cameras should be added
	if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	    update idletasks
	    #create second camera
	    set cam2 [new cam2D -scene $strScene -in $parent.f2.ne -width $wcol2 -height $hrow1]
	    $cam2 -alwaysTrackMouseMotion true
	    $cam2 -menu $parent.submenu
	    #	$cam2 -scale $scale
	    #get background
	    set bg2 [new $viewType $cam2 $mulview Y]
	    bind [$cam2 -widget] <Leave> "$mulview -hideAxis" 
	    
	    #create second camera
	    set cam3 [new cam2D -scene $strScene -in $parent.f2.so -width $hrow1 -height $hrow2]
	    $cam3 -alwaysTrackMouseMotion true
	    $cam3 -menu $parent.submenu
	    set bg3 [new $viewType $cam3 $mulview X]
	    bind [$cam3 -widget] <Leave> "$mulview -hideAxis" 
	    
	}
	inrimage::changeSliders $mulview $color $theFont $inr1 $strScene $viewType $parent.f2 $parent.submenu
	
	#packing widgets 
	pack $parent.voxel  -fill both -side bottom -expand true
	pack $parent.f1   -fill both
	
	pack $submenu.context -side left -expand true -fill both
	pack $submenu.name -side right
	pack $submenu  -fill both
	
	pack  $parent.voxel.l  -side left -fill none -expand false
	pack  $parent.voxel.v  -side right -fill x -expand true
	
	pack  $parent.f3   -expand false -side left -fill y
	
	pack  $parent.f2   -expand true -fill both
	
	if ![string match $inr2 "none"] {
	    
	    $mulview -GLScale2 min $minglscale2
	    $mulview -GLScale2 max $maxglscale2
	    
	    pack  $glminframe $glmaxframe -fill y  -side left -before $parent.f3 -expand true 
	    pack  $opacframe -fill x  -side bottom -before $parent.f2 -expand true 
	    pack  $parent.f4   -expand false -before $parent.f2 -side right -fill y
	    pack  $glmaxframe2 $glminframe2  -fill y  -side right -before $parent.f4 -expand true 
	} else {
	    pack  $glmaxframe $glminframe -fill x  -side bottom -before $parent.f2 -expand true 
	}
	
	#add menu
	inrimage::viewerMenu $parent.f1 $mulview $inr1 $color
	
	#    bind  $parent.f2.se.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
	
	update idletasks
	
	wm resizable $parent 0 0
	return $mulview
    }
    
    
    proc inrimage::installTransformedInrimageMenu { viewer camera transinr bg } {
	
	frame  $viewer.context.f1 
	menubutton $viewer.context.f1.reset -text "Reset Transformation"  -anchor w -bg $bg  -menu  $viewer.context.f1.reset.m
	set mreset [menu $viewer.context.f1.reset.m -bg $bg]
	$mreset add command  -label "Reset Translation" -command "evaluate \"$transinr -resetTransformation translation\""  
	$mreset add command  -label "Reset Rotation" -command "evaluate \"$transinr -resetTransformation rotation\""  
	
	button $viewer.context.f1.view -text "View Transformation"  -anchor w -bg $bg  -command "set mat \[ $transinr -transformation \]; modules::viewTransformation4D \$mat "
	
	frame  $viewer.context.f2
	menubutton $viewer.context.f2.save -text "Save Transformation"  -anchor w -bg $bg  -menu  $viewer.context.f2.save.m
	set msave [menu $viewer.context.f2.save.m -bg $bg]
	$msave add command -label "Save as Row Major" -command "set mat \[ $transinr -transformation \]; evaluate \"\$mat -saveRowMajor \[ tk_getSaveFile -filetypes {{\"Matrix 4x4\" {.mat4D .mat } } {All *}} -parent . -title {Save 4x4 Matrix  as}\]  \"; \$mat -destroy "
	$msave add command -label "Save as Column Major" -command "set mat \[ $transinr -transformation \]; evaluate \"\$mat -saveColumnMajor \[ tk_getSaveFile -filetypes {{\"Matrix 4x4\" {.mat4D .mat} } {All *}} -parent . -title {Save 4x4 Matrix  as}\]  \"; \$mat -destroy "
	
	menubutton $viewer.context.f2.load -text "Load Transformation"  -anchor w -bg $bg  -menu  $viewer.context.f2.load.m
	set mload [menu $viewer.context.f2.load.m -bg $bg]
	$mload add command -label "Load as Row Major" -command "set mat \[ new mat4D -fileRow  \[ tk_getOpenFile -filetypes {{\"Matrix 4x4\" {.mat4D .mat} } {All *}} -parent . -title {Read 4x4 Matrix }\] \];  evaluate \"$transinr -transformation \$mat \"; \$mat -destroy "
	$mload add command -label "Load as Column Major" -command "set mat \[ new mat4D -fileCol  \[ tk_getOpenFile -filetypes {{\"Matrix 4x4\" {.mat4D .mat} } {All *}} -parent . -title {Read 4x4 Matrix }\] \];  evaluate \"$transinr -transformation \$mat \"; \$mat -destroy "
	
	
	
	pack $viewer.context.f1.reset -side left
	pack $viewer.context.f1.view -side left
	pack $viewer.context.f1 -side top  -anchor w
	
	pack $viewer.context.f2.save -side left
	pack $viewer.context.f2.load -side left
	pack $viewer.context.f2 -side top -anchor w
    }
    
    proc inrimage::manualRegisterInrimage { inr1 {scene "none"} {color "#E8E0D2"} {subcolor "#D8D0C2"} } {
	
	set mulview [new multiview]
	set parent ".${mulview}"
	inrimage::createToplevel $parent $inr1 $color 
	
	wm title $parent "$inr1 ([lindex  [split  [$inr1 -name] /] end]  )"
	#attach multiview to widget
	$mulview -parentWidget $parent
	
	#creates frames and sliders
	frame $parent.voxel -bg $color
	frame $parent.f1 -bg $color
	frame $parent.f2 -bg $color
	
	if {  $::tcl_platform(platform) == "windows" } {
	    set theFont "ansifixed"
	} else {
	    set theFont "fixed"
	}
	
	scale $parent.glmin -orient horizontal -width 10 -bg $color -label "min grey level" -font $theFont
	scale $parent.glmax -orient horizontal -font $theFont -width 10 -bg $color  -label "max grey level" 
	
	
	#creates frames for menu
	set submenu $parent.submenu 
	frame $parent.submenu  -bg "#D8D0C2"
	frame $submenu.context -height 26 -bg $subcolor
	label $submenu.name -text "no selected object" -anchor e -bg $subcolor
	
	#create min and max glscale
	set minglscale [new glscale -min -in $parent.glmin]
	set maxglscale [new glscale -max -in $parent.glmax]
	
	
	label $parent.voxel.v -font $theFont -bg $color -text "Voxel Position "
	label $parent.voxel.l -font $theFont -bg $color 
	
	
	
	frame $parent.f2.ne -bg $color
	frame $parent.f2.so -bg $color -borderwidth 1
	frame $parent.f2.se -bg $color -borderwidth 1
	
	grid $parent.f2.ne -column 2 -row 1 
	grid $parent.f2.so -column 1 -row 1 
	grid $parent.f2.se -column 3 -row 1       
	grid rowconfigure $parent.f2 1 -weight 1
	grid rowconfigure $parent.f2 2 -weight 1
	
	if ![string compare $scene "none" ] {
	    set inrv [new transinrview $inr1  -noGLScale]
	} else {
	    set inrv 0
	    foreach {i} [$scene -objects] {
		if {[string match transinrview* $i ]} {
		    set inrv $i
		}
	    }
	    if ![ string compare $inrv "0"] {
		set inrv [new transinrview $inr1  $scene -noGLScale]
	    }
	}
	set scn [$inrv -scene]
	#compute theoretical height and width
	set Theight [ expr [ lindex [ $inr1 -size ] 1 ] * [ lindex [ $inr1 -voxel ] 1 ] ]
	set Twidth [ lindex [ $inr1 -size ] 0 ]
	if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	    set heightOffset 280
	    set Theight [ expr $Theight + [ expr [ lindex [ $inr1 -size ] 2 ] * [ lindex [ $inr1 -voxel ] 2 ] ] ]
	    #	 set Theight [ expr $Theight + [ expr [ lindex [ $inr1 -size ] 2 ] * [lindex [$inr1 -voxel ] 2] / [lindex [$inr1 -voxel ] 0 ] ] ]
	    set Twidth [ expr $Twidth + [ expr [ lindex [ $inr1 -size ] 2 ] * [lindex [$inr1 -voxel ] 2] / [lindex [$inr1 -voxel ] 0 ] ] ]
	} else {
	    set heightOffset 180
	}
	set Theight [ expr $heightOffset+$Theight ]
	#compute the scale that should be  applied such that the widget fits in the screen
	set scale 1.0
	set ratioHeight [ expr 1.0 * $Theight / [ winfo  screenheight . ]   ] 
	set ratioWidth [ expr 1.0 * $Twidth / [ winfo  screenwidth . ]  ] 
	
	if [ expr $ratioHeight > $ratioWidth ] {
	    set ratio $ratioHeight
	} else {
	    set ratio $ratioWidth
	}
	if [ expr $ratio > 1.0 ] {
	    if [ expr $ratioHeight > $ratioWidth ] {
		set scale [expr 1.0 / [ expr [ expr $Theight - $heightOffset ] / [ expr [ winfo  screenheight . ] * 0.95 - $heightOffset ] ] ]
	    } else {
		set scale [ expr 1.0 / [ expr $ratio *1.1] ]
	    }
	}
	#create first camera
	if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	    set cam1 [new slicecam Z -scene $scn -in $parent.f2.se -motion  $parent.voxel.l -useSlice true -useMenu true -menu $parent.submenu -scale $scale] 
	} else {
	    set cam1 [new slicecam Z -scene $scn -in $parent.f2.se -motion  $parent.voxel.l -useSlice false -useMenu true -menu $parent.submenu -scale $scale] 
	}
	$mulview -add $cam1
	#create rotation slider
	#get background
	set bg1 [$inrv -background $cam1]
	#attach grey-level and opacity scales
	$bg1 -greyLevel min $minglscale
	$bg1 -greyLevel max $maxglscale
	#get slice scale
	set slicescale [$cam1 -slicescale]
	#test if additional cameras should be added
	if [ expr [ lindex [$inr1 -size] 2 ] != 1 ] {
	    #create second camera
	    set cam2 [new slicecam Y -scene $scn -in $parent.f2.ne -motion  $parent.voxel.l -useSlice true -useMenu false -scale $scale]
	    $mulview -add $cam2
	    $cam2 -scale $scale
	    #get background
	    set bg2 [$inrv -background $cam2]
	    #attach grey-level and opacity scales
	    $bg2 -greyLevel min $minglscale
	    $bg2 -greyLevel max $maxglscale
	    #create second camera
	    set cam3 [new slicecam X -scene $scn -in $parent.f2.so -motion  $parent.voxel.l -useSlice true -useMenu false -scale $scale]
	    $cam3 -scale $scale
	    $mulview -add $cam3
	    #get background
	    set bg3 [$inrv -background $cam3]
	    #attach grey-level and opacity scales
	    $bg3 -greyLevel min $minglscale
	    $bg3 -greyLevel max $maxglscale
	    bind  $parent.f2.so.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
	    bind  $parent.f2.ne.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
	}
	#packing widgets 
	pack $parent.voxel  -fill both
	pack $parent.f1   -fill both
	
	pack $submenu.context -side left -expand true -fill both
	pack $submenu.name -side right
	pack $submenu  -fill both
	
	pack $parent.voxel.v $parent.voxel.l  -side left
	
	pack  $parent.f2   -expand true -fill both
	pack  $parent.glmax $parent.glmin -fill x  -side bottom -before $parent.f2  
	
	#add menu
	menubutton $parent.f1.mv -text "Multi-view" -anchor w -menu $parent.f1.mv.m -bg $color
	inrimage::multiviewmenu $parent.f1.mv.m  $mulview $inr1 1
	pack $parent.f1.mv -side left
	menubutton $parent.f1.o  -text "Objects" -menu $parent.f1.o.m -anchor w -bg $color
	menu $parent.f1.o.m -bg $color -postcommand "
	scan \[ $cam1 -select \] {%s} selectedObject;  
	#delete previous items 
	$parent.f1.o.m  delete 0 last
	set listecam \[ \[$cam1 -scene\] -camera\]
	
	foreach {i} \[ \[$cam1 -scene\] -objects\] {
	    $parent.f1.o.m  add radio -selectcolor \"black\" -variable selectedObject -label \$i -command \" foreach {cam} \[ list \$listecam \]  { evaluate \\\" \\\$cam -select \$i \\\"} \" }"
	    
	    pack  $parent.f1.o -side left
	    
	    menubutton $parent.f1.ao -text "Add Objects" -anchor w -menu $parent.f1.ao.m -bg $color
	    inrimage::addObjectMenu $parent.f1.ao.m $mulview $inr1 1
	    pack $parent.f1.ao -side left   
	    
	    
	    bind  $parent.f2.se.f.view <Destroy> "bind  $parent.f2 <Configure> {} "
	    
	    update idletasks
	    #    bind  $parent.f2 <Configure> "inrimage::resizeGrid $mulview %W %h %w 
	    #    puts " [ lindex [ $inr1 -size ] 0 ] [ winfo  screenheight . ]"
	    #    puts "$ratioWidth $ratioHeight $ratio $Theight [ winfo  screenheight . ] "
	    
	    return $mulview
	}
	
	
	proc inrimage::view4D { inr1 {color "#E8E0D2"} {subcolor "#D8D0C2"}} {
	    set mulview [new multiview4D]
	    set parent ".${mulview}"
	    inrimage::createToplevel $parent $inr1 $color 
	    
	    wm title $parent "Viewing 4D image  $inr1"
	    #attach multiview to widget
	    $mulview -parentWidget $parent
	    #creates frames and sliders
	    frame $parent.f1 -bg $color
	    frame $parent.f2 -bg $color
	    scale $parent.time -orient horizontal -font fixed -width 10 -bg $color -label "Time"
	    scale $parent.slicex -orient horizontal -font fixed -width 10 -bg $color -label "X"
	    scale $parent.slicey -orient horizontal -font fixed -width 10 -bg $color -label "Y"
	    scale $parent.slicez -orient horizontal -font fixed -width 10 -bg $color -label "Z"
	    scale $parent.glmin -orient horizontal -font fixed -width 10 -bg $color -label "min grey level"
	    scale $parent.glmax -orient horizontal -font fixed -width 10 -bg $color  -label "max grey level"
	    pack $parent.f1 $parent.f2 $parent.time $parent.slicex $parent.slicey $parent.slicez $parent.glmin $parent.glmax  -expand true -fill x
	    
	    #create min and max glscale
	    set timescale [new slicescale  -in $parent.time]
	    set xscale [new slicescale  -in $parent.slicex]
	    set yscale [new slicescale  -in $parent.slicey]
	    set zscale [new slicescale  -in $parent.slicez]
	    set minglscale [new glscale -min -in $parent.glmin]
	    set maxglscale [new glscale -max -in $parent.glmax]
	    
	    label $parent.f1.l -font fixed -anchor e -bg $color 
	    pack $parent.f1.l -side right -expand true -fill x
	    
	    frame $parent.f2.zy -bg $color -borderwidth 1
	    frame $parent.f2.xz -bg $color -borderwidth 1
	    frame $parent.f2.xy -bg $color -borderwidth 1
	    frame $parent.f2.xt -bg $color -borderwidth 1
	    frame $parent.f2.yt -bg $color -borderwidth 1
	    frame $parent.f2.zt -bg $color -borderwidth 1
	    label $parent.f2.lzy -text "ZY" -bg $color
	    label $parent.f2.lxz -text "XZ" -bg $color
	    label $parent.f2.lxy -text "XY" -bg $color
	    label $parent.f2.lxt -text "XT" -bg $color
	    label $parent.f2.lyt -text "YT" -bg $color
	    label $parent.f2.lzt -text "ZT" -bg $color
	    
	    
	    grid $parent.f2.zy -column 1 -row 1
	    grid $parent.f2.xz -column 2 -row 1
	    grid $parent.f2.xy -column 3 -row 1
	    grid $parent.f2.lzy -column 1 -row 2
	    grid $parent.f2.lxz -column 2 -row 2
	    grid $parent.f2.lxy -column 3 -row 2
	    grid $parent.f2.xt -column 1 -row 3
	    grid $parent.f2.yt -column 2 -row 3
	    grid $parent.f2.zt -column 3 -row 3
	    grid $parent.f2.lxt -column 1 -row 4
	    grid $parent.f2.lyt -column 2 -row 4
	    grid $parent.f2.lzt -column 3 -row 4
	    
	    
	    set inrv [new inr4Dview $inr1 -noGLScale]
	    set scn [$inrv -scene]
	    #create first camera
	    set cam1 [new timecam Z -scene $scn -in $parent.f2.xy -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $zscale -slice2 $timescale]
	    $mulview -add $cam1
	    #get background
	    set bg1 [$inrv -background $cam1]
	    #attach grey-level and opacity scales
	    $bg1 -greyLevel min $minglscale
	    $bg1 -greyLevel max $maxglscale
	    #create second camera
	    set cam2 [new timecam Y -scene $scn -in $parent.f2.xz -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $yscale -slice2 $timescale]
	    $mulview -add $cam2
	    #get background
	    set bg2 [$inrv -background $cam2]
	    #attach grey-level and opacity scales
	    $bg2 -greyLevel min $minglscale
	    $bg2 -greyLevel max $maxglscale
	    #create third camera
	    set cam3 [new timecam X -scene $scn -in $parent.f2.zy -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $xscale -slice2 $timescale]
	    $mulview -add $cam3
	    #get background
	    set bg3 [$inrv -background $cam3]
	    #attach grey-level and opacity scales
	    $bg3 -greyLevel min $minglscale
	    $bg3 -greyLevel max $maxglscale
	    #create fourth camera
	    set cam4 [new timecam XT -scene $scn -in $parent.f2.xt -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $yscale -slice2 $zscale]
	    $mulview -add $cam4
	    #get background
	    set bg4 [$inrv -background $cam4]
	    #attach grey-level and opacity scales
	    $bg4 -greyLevel min $minglscale
	    $bg4 -greyLevel max $maxglscale
	    #create fifth camera
	    set cam5 [new timecam YT -scene $scn -in $parent.f2.yt -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $xscale -slice2 $zscale]
	    $mulview -add $cam5
	    #get background
	    set bg5 [$inrv -background $cam5]
	    #attach grey-level and opacity scales
	    $bg5 -greyLevel min $minglscale
	    $bg5 -greyLevel max $maxglscale
	    #create sixth camera
	    set cam6 [new timecam ZT -scene $scn -in $parent.f2.zt -motion  $parent.f1.l -useSlice true  -useSlice2 true -slice $xscale -slice2 $yscale]
	    $mulview -add $cam6
	    #get background
	    set bg6 [$inrv -background $cam6]
	    #attach grey-level and opacity scales
	    $bg6 -greyLevel min $minglscale
	    $bg6 -greyLevel max $maxglscale
	    #add menu
	    menubutton $parent.f1.mv -text "Multi-view" -anchor w -menu $parent.f1.mv.m -bg $color
	    inrimage::multiview4Dmenu $parent.f1.mv.m  $mulview $inr1 1
	    pack $parent.f1.mv -side left
	    menubutton $parent.f1.ao -text "Add Objects" -anchor w -menu $parent.f1.ao.m -bg $color
	    inrimage::addObjectMenu $parent.f1.ao.m $mulview $inr1 1
	    pack $parent.f1.ao -side left   
	}
	
	
	proc inrimage::singleViewImage { inr1 { geom Z} {scene "none"} {color "#E8E0D2"} {subcolor "#D8D0C2"}} {
	    set mulview [new multiview]
	    set parent ".${mulview}"
	    inrimage::createToplevel $parent $inr1 $color 
	    
	    wm title $parent "Viewing $inr1"
	    #attach multiview to widget
	    $mulview -parentWidget $parent
	    #creates frames and sliders
	    frame $parent.voxel -bg $color
	    frame $parent.f1 -bg $color
	    frame $parent.f2 -bg $color
	    
	    scale $parent.glmin -orient horizontal -font fixed -width 10 -bg $color -label "min grey level"
	    scale $parent.glmax -orient horizontal -font fixed -width 10 -bg $color -label "max grey level"
	    
	    pack $parent.voxel  -fill both
	    pack $parent.f1   -fill both
	    
	    #creates frames for menu
	    set submenu $parent.submenu 
	    frame $parent.submenu  -bg "#D8D0C2"
	    frame $submenu.context -height 26 -bg $subcolor
	    label $submenu.name -text "no selected object" -anchor e -bg $subcolor
	    pack $submenu.context -side left  -fill both
	    pack $submenu.name -side right
	    pack $submenu   -fill both
	    
	    #create min and max glscale
	    set minglscale [new glscale -min -in $parent.glmin]
	    set maxglscale [new glscale -max -in $parent.glmax]
	    
	    label $parent.voxel.v -font fixed  -bg $color -text "Voxel Position "
	    label $parent.voxel.l -font fixed  -bg $color 
	    pack $parent.voxel.v $parent.voxel.l  -side left
	    
	    pack  $parent.f2   -expand true -fill both
	    pack   $parent.glmax $parent.glmin  -fill x -side bottom -before $parent.f2
	    
	    frame $parent.f2.se -bg $color
	    
	    grid $parent.f2.se -column 1 -row 1
	    
	    if ![string compare $scene "none" ] {
		set inrv [new inrview $inr1  -noGLScale]
	    } else {
		set inrv 0
		foreach {i} [$scene -objects] {
		    if {[string match inrview* $i ]} {
			set inrv $i
		    }
		}
		if ![ string compare $inrv "0"] {
		    set inrv [new inrview $inr1  $scene -noGLScale]
		}
	    }
	    set scn [$inrv -scene]
	    #create first camera
	    set cam1 [new slicecam $geom -scene $scn -in $parent.f2.se -motion  $parent.voxel.l -useSlice true -useMenu true -menu $parent.submenu]
	    $mulview -add $cam1
	    #get background
	    set bg1 [$inrv -background $cam1]
	    #attach grey-level and opacity scales
	    $bg1 -greyLevel min $minglscale
	    $bg1 -greyLevel max $maxglscale
	    #get slice scale
	    set slicescale [$cam1 -slicescale]
	    
	    #add menu
	    menubutton $parent.f1.mv -text "Multi-view" -anchor w -menu $parent.f1.mv.m -bg $color
	    inrimage::multiviewmenu $parent.f1.mv.m  $mulview $inr1 1
	    pack $parent.f1.mv -side left
	    menubutton $parent.f1.o  -text "Objects" -menu $parent.f1.o.m -anchor w -bg $color
	    menu $parent.f1.o.m -bg $color -postcommand "
	    scan \[ $cam1 -select \] {%s} selectedObject;  
	    #delete previous items 
	    $parent.f1.o.m  delete 0 last
	    foreach {i} \[ \[$cam1 -scene\] -objects\] {
		$parent.f1.o.m  add radio -selectcolor \"black\" -variable selectedObject -label \$i -command \" $cam1 -select \$i \"
	    }"
	    pack  $parent.f1.o -side left
	    
	    menubutton $parent.f1.ao -text "Add Objects" -anchor w -menu $parent.f1.ao.m -bg $color
	    inrimage::addObjectMenu $parent.f1.ao.m $mulview $inr1 1
	    pack $parent.f1.ao -side left   
	    bind  $parent.f2 <Configure> "inrimage::resizeSingleGrid $mulview %W %h %w"
	}
	
	
	
	proc inrimage::inrlist { name cmd {toff 0} {color "#E8E0D2"}} {
	    menu $name -tearoff $toff -bg $color -postcommand "$name delete 0 last; foreach { i } \[which inr\] { $name add command -label \$i -command \[modules::menusubstitute {$cmd} ... \$i\] }" -bg $color
	}
	
	proc inrimage::inr4Dlist { name cmd {toff 0} {color "#E8E0D2"}} {
	    menu $name -tearoff $toff -bg $color -postcommand "$name delete 0 last; foreach { i } \[which inr4D\] { $name add command -label \$i -command \[modules::menusubstitute {$cmd} ... \$i\] }" -bg $color
	}
	proc inrimage::getScene2DFromInr { inr} {
	    set  val "none"
	    foreach {i} [ which inrview ] {
		set img [$i -inrimage]
		if {![string compare $inr   $img]} {set val [ $i -scene]}	
	    }
	    if { ![string compare $val "none"] } {
		foreach {i} [ which overinrview ] {
		    set img [$i -inrimage]
		    if {![string $inr   $img]} {set val [ $i -scene]}	
		}
	    }
	    if { ![string compare $val "none"] } {
		return [ new scn2D]
	    } else {
		return $val
	    }	
	}
	proc inrimage::getScene2DFromMultiview { mname} {
	    return [ [ [ lindex [$mname -background] 0 ] -camera ] -scene ]
	}
	proc inrimage::getInrFromCamera { cam} {
	    set  val "none"
	    foreach {i} [ which imageBgnd] {
		
		if {[string match  $cam [$i -camera] ]} {set val $i }	
	    }
	    if { [string compare $val "none"] } {
		return [$val -inrimage ]
	    } else {
		return "none"
	    }
	}
	proc inrimage::boundingBoxAlgo {img {menu  inrimage::viewerXCropMenu} } {
	    scan [ $img -size] "%u %u %u" sizeX sizeY sizeZ
	    scan [ $img -voxelToWorld [expr 1.0*$sizeX/6.0 ] [expr 5.0*$sizeY/6.0] [expr 1.0*$sizeZ/6.0] ] "%f %f %f" minX minY minZ
	    scan [ $img -voxelToWorld [expr 5.0*$sizeX/6.0 ] [expr 1.0*$sizeY/6.0] [expr 5.0*$sizeZ/6.0] ] "%f %f %f" maxX maxY maxZ
	    
	    set inrimage::mview [ getMultiviewFromImage $img ]
	    if ![string match $inrimage::mview none] {
		evaluate "set inrimage::cropImage $img;new bbox3D [ [ lindex [ $inrimage::mview -background ] 0 ] -camera ] $minX $minY $minZ $maxX $maxY $maxZ -color 0.0 1 1  -menu $menu " 
	    }
	}
	
	proc inrimage::getCmapFromMultiview { multiview {option "-scalemode"}} {
	    set  val "none"
	    foreach {i} [ [ $multiview -scene] -objects] {
		if {[string match  inrview* $i]} {set val $i}
		if {[string match  inr4Dview* $i]} {set val $i}
		if {[string match  overinrview* $i]} {set val $i}
		if {[string match  transinrview* $i]} {set val $i}
		if {[string match  overinr4Dview* $i]} {set val $i}
	    }
	    if { [string compare $val "none"] } {
		return  [ [$val -background [ lindex [$multiview -views] 0 ] ] $option]
	    } else {
		return "none"
	    }
	}
	proc inrimage::getInterpolationFromMultiview { multiview {option "-interpolation"}} {
	    set  val "none"
	    foreach {i} [ [ $multiview -scene] -objects] {
		if {[string match  inrview* $i]} {set val $i}
		if {[string match  inr4Dview* $i]} {set val $i}
		if {[string match  overinrview* $i]} {set val $i}
		if {[string match  transinrview* $i]} {set val $i}
		if {[string match  overinr4Dview* $i]} {set val $i}
	    }
	    if { [string compare $val "none"] } {
		return  [ [$val -background [ lindex [$multiview -views] 0 ] ] $option]
	    } else {
		return "none"
	    }
	}
	proc inrimage::setCmapFromMultiview { multiview cmap {option "-scalemode"} {cmoption "none"} } {
	    set  val "none"
	    foreach {i} [ [ $multiview -scene] -objects] {
		if {[string match  inrview* $i]} {set val $i}
		if {[string match  inr4Dview* $i]} {set val $i}
		if {[string match  overinrview* $i]} {set val $i}
		if {[string match  transinrview* $i]} {set val $i}
		if {[string match  overinr4Dview* $i]} {set val $i}
	    }
	    if { [string compare $val "none"] } {
		foreach {i}  [$multiview -views]  {
		    if { [ string compare cmoption "none" ] } {
			[ $val -background $i ] $option $cmap $cmoption
		    } else {
			[ $val -background $i ] $option $cmap
		    }
		}
	    } else {
		return "none"
	    }
	}
	proc inrimage::setInterpolationFromMultiview { multiview interp {option "-interpolation"}  } {
	    set  val "none"
	    foreach {i} [ [ $multiview -scene] -objects] {
		if {[string match  inrview* $i]} {set val $i}
		if {[string match  inr4Dview* $i]} {set val $i}
		if {[string match  overinrview* $i]} {set val $i}
		if {[string match  transinrview* $i]} {set val $i}
		if {[string match  overinr4Dview* $i]} {set val $i}
	    }
	    if { [string compare $val "none"] } {
		foreach {i}  [$multiview -views]  {
		    [ $val -background $i ] $option $interp
		}
	    } else {
		return "none"
	    }
	}
	proc inrimage::slicecamlist { name cmd {toff 0} {color "#E8E0D2"}} {
	    menu $name -tearoff $toff -bg $color -postcommand "$name delete 0 last; foreach { i } \[scalables\] { $name add command -label \$i -command \[modules::menusubstitute {$cmd} ... \$i\]}" -bg $color
	}
	
	proc inrimage::isSliceableInView  { sliceable scene} {
	    set val 0
	    foreach {i} [which surfview] {
		if ![string compare [ $i -scene] $scene] {
		    if ![string compare [ $i -mesh ] $sliceable ] {
			set val 1
		    }
		}
	    }
	    return $val
	}
	proc inrimage::getSliceableInView  { sliceable scene} {
	    set val "none"
	    foreach {i} [which surfview] {
		if ![string compare [ $i -scene] $scene] {
		    if ![string compare [ $i -mesh ] $sliceable ] {
			set val $i
		    }
		}
	    }
	    return $val
	}
	proc inrimage::isRoiInView  { sliceable scene} {
	    set val 0
	    foreach {i} [which roi] {
		if ![string compare [ $i -scene] $scene] {
		    if ![string compare [ $i -mesh ] $sliceable ] {
			set val 1
		    }
		}
	    }
	    return $val
	}
	proc inrimage::getRoiInView  { sliceable scene} {
	    set val "none"
	    foreach {i} [which roi] {
		if ![string compare [ $i -scene] $scene] {
		    if ![string compare [ $i -mesh ] $sliceable ] {
			set val $i
		    }
		}
	    }
	    return $val
	}
	proc inrimage::addObjectMenu { name mname img {toff 0} {color "#E8E0D2"}} {

	    set mn [menu $name -tearoff $toff -bg $color] 
	    $name add cascade -label "Surface Slice" -menu $name.surf
	    set scn   [ inrimage::getScene2DFromMultiview $mname] 
	    menu $name.surf -tearoff $toff -bg $color -postcommand "
	    set inrimage::scn \[ inrimage::getScene2DFromMultiview $mname \]; 
	    $name.surf delete 0 last; 
	    foreach {i} \[surfaceSliceables\] {
		set inrimage::view(\$i) \[ inrimage::isSliceableInView  \$i \${inrimage::scn} \];
		$name.surf add checkbutton -variable inrimage::view(\$i) -label \$i	-command \" if  \$inrimage::view(\$i) \{evaluate {\[inrimage::getSliceableInView  \$i \${inrimage::scn} \] -destroy } \} else  \{evaluate {new surfview \$i -scene \${inrimage::scn} } \} \" }"
		$name add command -label "Surface ROI..." -command "inrimage::roiDialog $img $scn $color"
#		menu $name.roi -tearoff $toff -bg $color -postcommand "set inrimage::scn \[ inrimage::getScene2DFromMultiview $mname \]; $name.roi delete 0 last; foreach {i} \[surfaceSliceables\] { set inrimage::view(\$i) \[ inrimage::isRoiInView  \$i \${inrimage::scn} \]; $name.roi add checkbutton -variable inrimage::view(\$i) -label \$i -command \" if  \$inrimage::view(\$i) \{evaluate {\[inrimage::getRoiInView  \$i \${inrimage::scn} \] -destroy } \} else  \{evaluate {new roi $img \$i boundary  \${inrimage::scn} } \} \" }"
	    }
	    proc inrimage::OldaddObjectMenu { name mname {toff 0} {color "#E8E0D2"}} {
		set mn [menu $name -tearoff $toff -bg $color] 
		if [string compare [isModuleLoaded tclSM2] no] {
		    sm2::addSM2View $mn $mname 0 $color
		}
		if [string compare [isModuleLoaded tclTriangulation] no] {
		    triangulation::addTrianView $mn $mname 0 $color
		}
		if [string compare [isModuleLoaded tclTetrahedrisation] no] {
		    tetrahedrisation::addTetraView $mn $mname 0 $color
		}
		if [string compare [isModuleLoaded tclSimulation] no] {
		    simulation::addSimuTetraView $mn $mname 0 $color
		}
	    }
	    proc inrimage::installROIEditMenu { viewer camera roi bg } {
		inrimage::installROIMenu $viewer $camera $roi $bg 
	    }
	    proc inrimage::installROIMenu { viewer camera roi bg } {
		
		if {![winfo exists $viewer.context.file]} {
		    menubutton $viewer.context.file -text "File" -menu $viewer.context.file.m -anchor w -bg $bg
		    set mfile [menu $viewer.context.file.m -bg $bg]
		    $mfile add command -label "Save ROI" -command "evaluate \"$roi -save \""
		    $mfile add command -label "Save ROI as..." -command "evaluate \"$roi -save \[tk_getSaveFile -filetypes {{\"ROI\" {*.roi } } } -parent . -title {Select a ROI name} \] \""
		    $mfile add separator
		    $mfile add command -label "Save as binary Image" -command "set im \[evaluate \"$roi -binary \"\]; \$im -save \[inrimage::saveImage \"binary.inr.gz\"\]"
		    $mfile add separator
		    $mfile add command -label "Destroy" -command "evaluate \"$roi -destroy\""
		    menubutton $viewer.context.display -text "Display" -menu $viewer.context.display.m -anchor w -bg $bg
		    set mdisplay [menu $viewer.context.display.m -bg $bg -postcommand "set inrimage::showROI \[ $roi -visibility \]"]
		    $mdisplay add command -label "ROI Color..." -command "set col \[ modules::selectColor  \[ $roi -color\] \]; evaluate \"$roi -color \[lindex \$col 0\] \[lindex \$col 1\] \[lindex \$col 2\] \""
		    #   $mdisplay add cascade -label "Display Mode" -menu   $mdisplay.sub3
		    #   set m3 [menu  $mdisplay.sub3 -tearoff 0 -postcommand "set inrimage::roim \[ $roi -greyLevel \] " ]
		    #  $m3 add radiobutton -variable inrimage::roim -label "Use Grey Level" -value "true" -command "evaluate \"$roi -greyLevel true \""
		    #  $m3 add radiobutton -variable inrimage::roim -label "Use Color" -value "false" -command "evaluate \"$roi -greyLevel false \""
		    
		    $mdisplay add checkbutton -label "Show ROI" -variable inrimage::showROI -onvalue "true" -offvalue "false" -command "evaluate \"$roi -visibility \$inrimage::showROI \""
		    
		    $mdisplay add cascade -label "ROI Opacity" -menu   $mdisplay.sub2
		    set m2 [menu  $mdisplay.sub2 -tearoff 0]
		    $m2 add command -label "100\%" -command "evaluate \"$roi -opacity full \""
		    $m2 add command -label "75\%" -command "evaluate \"$roi -opacity opacity75 \""
		    $m2 add command -label "50\%" -command "evaluate \"$roi -opacity opacity50 \""
		    $m2 add command -label "25\%" -command "evaluate \"$roi -opacity opacity25 \""
		    $m2 add command -label "12\%" -command "evaluate \"$roi -opacity opacity12 \""
		    
		    menubutton $viewer.context.stat -text "Algorithms" -menu $viewer.context.stat.m -anchor w -bg $bg
		    set mstat [menu $viewer.context.stat.m -bg $bg ]
		    $mstat add command -label "ROI Histogram..." -command "set h \[evaluate \"$roi -histogram\" \]; evaluate \"\$h -plot\""
		    $mstat add cascade -label "Attach" -menu $mstat.vi
		    menu $mstat.vi -bg $bg -tearoff 0 -postcommand "$mstat.vi delete 0 last; foreach {i } \[which inr\] { $mstat.vi add command -label \"\$i ( \[lindex  \[ split \[ \$i -name \] / \] end \])\" -command \"evaluate \\\" $roi -intensityImage \$i \\\" \" }"
		    
		    $mstat add command -label "Dilate 3D" -command "evaluate \"$roi -morpho dilation iter 1 con 6\""
		    $mstat add command -label "Erode 3D" -command "evaluate \"$roi -morpho erosion iter 1 con 6\""
		    $mstat add command -label "2D Closure (size 1)" -command "evaluate \"$roi -morpho dilation iter 1 con 4\";evaluate \"$roi -morpho erosion iter 1 con 4\" "  
		    $mstat add command -label "2D Closure (size 2)" -command "evaluate \"$roi -morpho dilation iter 2 con 4\";evaluate \"$roi -morpho erosion iter 2 con 4\" "
		    $mstat add command -label "3D Closure (size 1)" -command "evaluate \"$roi -morpho dilation iter 1 con 26\";evaluate \"$roi -morpho erosion iter 1 con 26\" "  
		    $mstat add command -label "3D Closure (size 2)" -command "evaluate \"$roi -morpho dilation iter 2 con 26\";evaluate \"$roi -morpho erosion iter 2 con 26\" "
		    
		    menubutton $viewer.context.name -text "ROI" -menu $viewer.context.name.m -anchor w -bg $bg
		    set mname [menu $viewer.context.name.m -bg $bg]
		    $mname add command -label "set Name..." -command "modules::entryDialog .{$roi}Name $bg {Set the region name} \"\[$roi -realName\]\" \"evaluate \{ $roi -realName ... \} \"" 
		    pack  $viewer.context.file -side left
		    pack  $viewer.context.display -side left
		    pack  $viewer.context.stat -side left
		    pack  $viewer.context.name -side left
		}
		
	    }
	    proc inrimage::uninstallROIMenu { viewer camera line} {
		# remove frame children
		set list [winfo children $viewer.context]
		foreach w $list { destroy $w}
		pack $viewer.context -fill x
		#remove popup
		destroy  $viewer.popup
		#reset selection mode
		$camera -motionMode camera
		#unbind popup
		bind [$camera -widget] <Button-3> ""
	    }
	    proc inrimage::uninstallROIEditMenu { viewer camera line} {
		# remove frame children
		set list [winfo children $viewer.context]
		foreach w $list { destroy $w}
		pack $viewer.context -fill x
		#remove popup
		destroy  $viewer.popup
		#reset selection mode
		$camera -motionMode camera
		#unbind popup
		bind [$camera -widget] <Button-3> ""
	    }
	    proc inrimage::colormapMenu { menu mname color {option "-colormap"}} {
		set mcmap [menu $menu -tearoff 0 -bg $color -postcommand "set inrimage::mcmap \[ $mname $option\] " ]
		$mcmap add radiobutton -variable inrimage::mcmap -label "Affine"  -value "affine" -command "$mname $option affine"
		$mcmap add radiobutton -variable inrimage::mcmap -label "Threshold"  -value "threshold" -command "$mname $option threshold"
		$mcmap add radiobutton -variable inrimage::mcmap -label "PET Colors"  -value "pet" -command "$mname $option pet"
		$mcmap add radiobutton -variable inrimage::mcmap -label "Jet Colors"  -value "jet" -command "$mname $option jet"
		$mcmap add radiobutton -variable inrimage::mcmap -label "SPECT Colors"  -value "spect" -command "$mname $option spect"
		$mcmap add radiobutton -variable inrimage::mcmap -label "Hot Iron"  -value "hotiron" -command "$mname $option hotiron"
		$mcmap add radiobutton -variable inrimage::mcmap -label "Blue"  -value "blue" -command "$mname $option blue"
		$mcmap add radiobutton -variable inrimage::mcmap -label "User Defined"  -value "user" -command "$mname $option user  \[ new cm \[ tk_getOpenFile -filetypes { {\"ColorMap File\" {.cmap}} {\"Inrimage\" {.inr} } {\"All\" {*} } }  \] \]"
	    }
	    proc inrimage::interpolationMenu { menu mname color {option "-interpolation"}} {
		set mcmap [menu $menu -tearoff 0 -bg $color -postcommand "set inrimage::minterp \[$mname -interpolation\] " ]
		$mcmap add radiobutton -variable inrimage::minterp -label "Nearest"  -value "nearest" -command "$mname -interpolation nearest"
		$mcmap add radiobutton -variable inrimage::minterp -label "Bilinear"  -value "bilinear" -command "$mname -interpolation bilinear"
	    }
	    proc inrimage::viewerMenu {widget mulview img color {toff 0}} {
		menubutton $widget.file -text "File" -anchor w -menu $widget.file.m -bg $color
		set mn [menu $widget.file.m -tearoff $toff -bg $color]
		$mn add command -label "Load Image..." -command {set inr [inrimage::loadImage];if [string compare $inr ""] { set inr [ evaluate "new inr $inr" ]; evaluate "view $inr" } }
		$mn add command -label "Save Image" -command "evaluate \"$img -save \[ $img -name \] \" "
		$mn add command -label "Save Image as..." -command "set name \[inrimage::saveImage\]; if \[string compare \$name {} \] { evaluate { $img -save \$name } }"
		$mn add command -label "New Image..." -command "inrimage::inrimageDialog $color"
		$mn add separator 
		$mn add cascade -label "Create Object From File" -menu $mn.load
		set mnew [menu $mn.load -tearoff 0 -bg $color]
		foreach i [scn2D -which file] {
		    $mnew add command -label [scn2D -realName $i ] -command "set name  \[tk_getOpenFile -filetypes {{$i {[scn2D -suffix $i]}} {All *}}\]; if \[string compare \$name {}\] {evaluate \"new $i \$name\"}"
		}
		$mn add cascade -label "Create Object" -menu $mn.new
		set mnew [menu $mn.new -tearoff 0 -bg $color]
		foreach i [scn2D -which none] {
		    $mnew add command -label [scn2D -realName $i ] -command "evaluate \"new $i\" "
		}
		foreach i [scn2D -which camera] {
		    $mnew add command -label [scn2D -realName $i ] -command {evaluate \"new $i -camera $name\"}
		}
		$mn add separator 
		$mn add command -label "Destroy image" -command "evaluate \" $img -destroy\" " 
		$mn add command -label "Destroy slicer" -command "evaluate \" $mulview -destroy\" " 
		pack $widget.file -side left
		
		menubutton $widget.viz -text "Visualisation" -anchor w -menu $widget.viz.m -bg $color
		set mn [menu $widget.viz.m -tearoff $toff -bg $color]
		$mn add cascade -label "Interpolation" -menu $mn.interpolation
		inrimage::interpolationMenu $mn.interpolation $mulview $color
		$mn add command -label "Record Slicer Animation..." -command "graphics2D::startRecording \[ \[ lindex \[ $mulview -background \] 0 \] -camera \] .$mulview.f2"
		$mn add cascade -label "Synchronize with other Slicer" -menu $mn.comp
		menu $mn.comp -bg $color -postcommand "
		set synchroList \[$mulview -synchronize\]
		#delete previous items 
		$mn.comp  delete 0 last
		foreach m \[which multiview\] {
		    if !\[string match \$m $mulview \] {
			if \[ string match *\$m* \$synchroList  \] {
			    set inrimage::sync(\$m) 1
			} else {
			    set inrimage::sync(\$m) 0
			}
			$mn.comp add checkbutton -label \"Slicer of \[\$m -image\] (\[ \[ \$m -image \] -name\] ) \" -variable inrimage::sync(\$m) -command \"if \$inrimage::sync(\$m) {evaluate \\\"$mulview -synchronize remove \$m \\\"} else { evaluate \\\"$mulview -synchronize  \$m \\\" } \"
		    }
		}
		"
		$mn add command -label "3D View of this Slicer" -command "new viewImg3D $mulview"
		
		$mn add cascade -label "View Image" -menu $mn.view
		menu $mn.view -tearoff 0 -postcommand "$mn.view delete 0 last; foreach {i } \[which inr\] { $mn.view add command -label \"\$i ( \[lindex  \[ split \[ \$i -name \] / \] end \])\" -command \"evaluate \\\" view \$i \\\" \" }"
		pack $widget.viz -side left
		
		button $widget.start -text "Start Computation" -anchor w -bg $color -command "evaluate \"\[inrimage::getScene2DFromMultiview $mulview \] -computation true \" "
		#"\[inrimage::getScene2DFromMultiview $mulview \] -computation true;inrimage::stopComputation $widget.start \[inrimage::getScene2DFromMultiview $mulview\] "
		pack $widget.start -side right
		foreach bg [$mulview -background] {
		    [$bg -camera] -widget button $widget 
		}
		
		menubutton $widget.o  -text "Objects" -menu $widget.o.m -anchor w -bg $color
		menu $widget.o.m -bg $color -postcommand "
		set scene \[inrimage::getScene2DFromMultiview $mulview\]
		set theCam \[ \[lindex \[$mulview -background\] 0\] -camera \]
		scan \[ \$theCam -select \] {%s} selectedObject;  
		#delete previous items 
		$widget.o.m  delete 0 last
		set listecam \[ \$scene -camera\]
		
		foreach {i} \[ \$scene -objects\] {
		    $widget.o.m  add radio -selectcolor \"black\" -variable selectedObject -label \$i -command \" foreach {cam} \[ list \$listecam \]  { evaluate \\\" \\\$cam -select \$i \\\"} \" 
		    }"
		    
		    pack  $widget.o -side left
		    
		    menubutton $widget.ao -text "Add Objects" -anchor w -menu $widget.ao.m -bg $color
		    inrimage::addObjectMenu $widget.ao.m $mulview $img 1
		    pack $widget.ao -side left   
		    
		}
		
		proc inrimage::stopComputation { widget scene } {
		    if [ winfo exists $widget] {
			$widget configure -text "Start Computation" -command "evaluate \"$scene -computation true\";inrimage::startComputation $widget $scene"
		    }
		}
		proc inrimage::startComputation { widget scene } {
		    if [ winfo exists $widget] {
			$widget configure -text "Stop Computation" -command "evaluate \"$scene -computation false\";inrimage::stopComputation $widget $scene"
		    }
		}
		
		proc inrimage::multiviewmenu { name mname img {toff 0} {color "#E8E0D2"}} {
		    set mn [menu $name -tearoff $toff -bg $color -postcommand " set inrimage::useAxis \[${mname} -showAxis\]"]
		    # set inrimage::activate \[${mname} -activate\]"]
		    $mn add command -label $mname -state disabled -command {}
		    #  $mn add checkbutton -label "Display axis" -variable inrimage::useAxis  -onvalue "true" -offvalue "false" -command "evaluate \"$mname -showAxis \$inrimage::useAxis\""
		    $mn add cascade -label "Navigation" -menu $mn.navigation
		    menu $mn.navigation  -tearoff 0 -bg $color
		    $mn.navigation add command -label "Voxel" -command "evaluate \"$mname -navmode VOXEL\""
		    $mn.navigation add command -label "Real" -command "evaluate \"$mname -navmode REAL\""
		    $mn add cascade -label "Zoom" -menu $mn.zoom
		    menu $mn.zoom -tearoff 0 -bg $color
		    $mn.zoom add command -label " 25 %" -command "evaluate \"$mname -widgetSize * 0.25\""
		    $mn.zoom add command -label " 50 %" -command "evaluate \"$mname -widgetSize * 0.5\""
		    $mn.zoom add command -label " 75 %" -command "evaluate \"$mname -widgetSize * 0.75\""
		    $mn.zoom add command -label "125 %" -command "evaluate \"$mname -widgetSize * 1.25\""
		    $mn.zoom add command -label "150 %" -command "evaluate \"$mname -widgetSize * 1.5\""
		    $mn.zoom add command -label "200 %" -command "evaluate \"$mname -widgetSize * 2\""
		    $mn.zoom add command -label "300 %" -command "evaluate \"$mname -widgetSize * 3\""
		    $mn.zoom add command -label "400 %" -command "evaluate \"$mname -widgetSize * 4\""
		    
		    
		    $mn add cascade -label "Interpolation" -menu $mn.interpolation
		    inrimage::interpolationMenu $mn.interpolation $mname $color
		    $mn add cascade -label "ColorMap" -menu $mn.colormap
		    inrimage::colormapMenu $mn.colormap $mname $color
		    $mn add separator
		    $mn add command -label "Voxel size..." -command "inrimage::voxelSizeDialog $img $color"
		    $mn add command -label "Save Image" -command "evaluate \"$img -save \[ $img -name \] \" "
		    $mn add command -label "Save Image as..." -command "set name \[inrimage::saveImage\]; if \[string compare \$name {}\] { evaluate {$img -save \$name} }"
		    
		    if ![string compare [limitedVersion] "false" ] { 
			$mn add separator
			$mn add cascade -label "Image Processing Commands" -menu $mn.image 
			inrimage::inrmenu $mn.image $img $mname
		    }
		    
		    $mn add separator
		    $mn add cascade -label "File..." -menu $mn.file
		    menu $mn.file -tearoff 0 -bg $color
		    
		    
		    $mn.file add command -label "Load Image..." -command {set inr [inrimage::loadImage];if [string compare $inr ""] { set inr [ evaluate "new inr $inr" ]; evaluate "view $inr" } }
		    $mn.file add command -label "New Image..." -command "inrimage::inrimageDialog $color"
		    $mn.file add cascade -label "View Image" -menu $mn.vi
		    menu $mn.vi -tearoff 0 -postcommand "$mn.vi delete 0 last; foreach {i } \[which inr\] { $mn.vi add command -label \"\$i ( \[lindex  \[ split \[ \$i -name \] / \] end \])\" -command \"evaluate \\\" view \$i \\\" \" }"
		    
		    $mn add separator
		    
		    
		    $mn add cascade -label "Landmarks..." -menu $mn.land
		    menu $mn.land -tearoff 0 -bg $color
		    $mn.land add command -label "Create Landmarks" -command "evaluate \"new lset -scene [inrimage::getScene2DFromMultiview $mname] \""
		    $mn.land add command -label "Load Landmarks" -command "evaluate \"new lset -scene [inrimage::getScene2DFromMultiview $mname] \[tk_getOpenFile -filetypes { {{Landmark Set} {.lset} } {{All} *} } -parent . -title {Select a Landmark Set} \] \" "
		    
		    $mn add separator
		    $mn add cascade -label "Compare" -menu $mn.comp
		    inrimage::inrlist $mn.comp "evaluate \"$mname -add \[... -slicecams \] \" " 0 $color
		    $mn add command -label "Set visible region..." -command "set inrimage::mview $mname; evaluate \"new bbox3D \[ lindex \[ split \[ $mname -views\] \] 0 \] -color green -menu  inrimage::viewerXVisibleMenu\""
		    $mn add command -label "Reset visible region" -command "evaluate \"$mname -visible all\""
		    #compute initialization bounding box
		    scan [ $img -size] "%u %u %u" sizeX sizeY sizeZ
		    scan [ $img -voxelToWorld [expr 1.0*$sizeX/6.0 ] [expr 5.0*$sizeY/6.0] [expr 1.0*$sizeZ/6.0] ] "%f %f %f" minX minY minZ
		    scan [ $img -voxelToWorld [expr 5.0*$sizeX/6.0 ] [expr 1.0*$sizeY/6.0] [expr 5.0*$sizeZ/6.0] ] "%f %f %f" maxX maxY maxZ
		    puts "minx=$minX maxx=$maxX miny=$minY maxy=$maxY"
		    $mn add command -label "Crop image..." -command "set inrimage::mview $mname; evaluate \"set inrimage::cropImage $img;new bbox3D \[ \[ lindex \[ $mname -background \] 0 \] -camera \] $minX $minY $minZ $maxX $maxY $maxZ -color 0.0 1 1  -menu  inrimage::viewerXCropMenu \""
		    $mn add command -label "Isolate image..." -command "set inrimage::mview $mname; evaluate \"set inrimage::cropImage $img;new bbox3D \[ \[ lindex \[ $mname -background \] 0 \] -camera \] $minX $minY $minZ $maxX $maxY $maxZ -color 1.0 1.0 0  -menu  inrimage::viewerXIsolateMenu \""
		    $mn add command -label "Zero image..." -command "set inrimage::mview $mname; evaluate \"set inrimage::cropImage $img;new bbox3D \[ \[ lindex \[ $mname -background \] 0 \] -camera \] $minX $minY $minZ $maxX $maxY $maxZ -color 1.0 0.0 1  -menu  inrimage::viewerXZeroMenu \""
		    
		    
		    $mn add command -label "Reformat..." -command "inrimage::setDrawingLineMode $img; inrimage::reformat $img $color;"
		    
		    $mn add cascade -label "Manual Registration..." -menu $mn.manreg
		    menu $mn.manreg  -tearoff 0 -bg $color -postcommand "$mn.manreg delete 0 end; foreach {i} \[which inr\] { if \[ string compare $img \$i \] { $mn.manreg add command -label \"\$i ( \[lindex  \[ split \[ \$i -name \] / \] end \])\" -command \"inrimage::manualRegistration $img \$i $mname \"} }"
		    
		    #	$mn add checkbutton -label "Activate" -variable inrimage::activate  -onvalue "true" -offvalue "false" -command "evaluate \"$mname -activate \$inrimage::activate\""
		    $mn add separator
		    $mn add command -label "Script Dialog" -command "if {!\[winfo exists .yav\]} {loadSource tclModules.tcl; loadSource yav++.tcl;yav::interface}"
		    $mn add separator
		    
		    $mn add cascade -label "Delete ..." -menu $mn.delete
		    menu $mn.delete -tearoff 0 -bg $color
		    
		    $mn.delete add command -label "Delete Image" -command "if !\[ string compare \[tk_messageBox -type okcancel -message {Really Delete Image ? }\] ok \] { evaluate \"$mname -destroy\"; evaluate \"$img -destroy\"}"
		    #$mn add separator
		    $mn.delete add command -label "Delete Viewer" -command "evaluate \"$mname -destroy\""
		}
		proc inrimage::multiview4Dmenu { name mname img {toff 0} {color "#E8E0D2"}} {
		    set mn [menu $name -tearoff $toff -bg $color -postcommand "set inrimage::useVoxelSize \[${mname} -ignoreVoxelSize\]; set inrimage::useAxis \[${mname} -axis\]; set inrimage::activate \[${mname} -activate\]"]
		    $mn add command -label $mname -state disabled -command {}
		    $mn add checkbutton -label "Use voxel size" -variable inrimage::useVoxelSize  -onvalue "false" -offvalue "true" -command "evaluate \"${mname} -ignoreVoxelSize \$inrimage::useVoxelSize\""
		    $mn add checkbutton -label "Display axis" -variable inrimage::useAxis  -onvalue "true" -offvalue "false" -command "evaluate \"$mname -axis \$inrimage::useAxis\""
		    $mn add cascade -label "Zoom" -menu $mn.zoom
		    menu $mn.zoom -tearoff 0 -bg $color
		    $mn.zoom add command -label " 25 %" -command "evaluate \"$mname -scale * 0.25\""
		    $mn.zoom add command -label " 50 %" -command "evaluate \"$mname -scale * 0.5\""
		    $mn.zoom add command -label " 75 %" -command "evaluate \"$mname -scale * 0.75\""
		    $mn.zoom add command -label "125 %" -command "evaluate \"$mname -scale * 1.25\""
		    $mn.zoom add command -label "150 %" -command "evaluate \"$mname -scale * 1.5\""
		    $mn.zoom add command -label "200 %" -command "evaluate \"$mname -scale * 2\""
		    $mn.zoom add command -label "300 %" -command "evaluate \"$mname -scale * 3\""
		    $mn.zoom add command -label "400 %" -command "evaluate \"$mname -scale * 4\""
		    $mn add cascade -label "Image Commands" -menu $mn.image
		    $mn add command -label "Set Voxel Size" -command "inrimage::voxel4DSizeDialog $img $color"
		    inrimage::inr4Dmenu $mn.image $img 
		    
		    $mn add cascade -label "ColorMap" -menu $mn.colormap
		    inrimage::colormapMenu $mn.colormap $mname $color  
		    $mn add separator
		    $mn add cascade -label "File..." -menu $mn.file
		    menu $mn.file -tearoff 0 -bg $color
		    
		    $mn.file add command -label "Save Image" -command "evaluate \"$img -save \[ $img -name \] \" "
		    $mn.file add command -label "Save Image as..." -command "set name \[inrimage::saveImage4D\]; if \[string compare \$name {}\] { evaluate \"$img -save \$name\" }"
		    $mn.file add command -label "Load Image..." -command {set inr [inrimage::loadImage4D];if [string compare $inr ""] { set inr [ evaluate "new inr $inr" ]; evaluate "inrimage::view4D $inr" } }
		    $mn.file add cascade -label "View Image" -menu $mn.vi
		    menu $mn.vi -tearoff 0 -postcommand "$mn.vi delete 0 last; foreach {i } \[which inr4D\] { $mn.vi add command -label \"\$i ( \[lindex  \[ split \[ \$i -name \] / \] end \])\" -command \"evaluate \\\"inrimage::view4D \$i \\\" \" }"
		    
		    $mn add separator
		    
		    $mn add cascade -label "Compare" -menu $mn.comp
		    inrimage::inr4Dlist $mn.comp "evaluate \"$mname -add \[... -slicecams \] \" " 0 $color
		    $mn add command -label "Set visible region..." -command "set inrimage::mview $mname; evaluate \"new bbox4D \[ lindex \[ split \[ $mname -views\] \] 0 \] -color green -menu  inrimage::viewerXVisibleMenu\""
		    $mn add command -label "Reset visible region" -command "evaluate \"$mname -visible all\""
		    $mn add command -label "Crop image..." -command "set inrimage::mview $mname; evaluate \"new bbox4D \[ lindex \[ split \[ $mname -views\] \] 0 \] -color cyan -menu  inrimage::viewerXCropMenu \""
		    $mn add separator
		    $mn add command -label "Script Dialog" -command "if {!\[winfo exists .yav\]} {loadSource tclModules.tcl; loadSource yav++.tcl;yav::interface}"
		    $mn add separator
		    $mn add command -label "destroy" -command "evaluate \"$mname -destroy\""
		}
		
		proc inrimage::inr4Dmenu { name iname {toff 0} {color "#E8E0D2"} } {
		    set mn [menu $name -tearoff $toff -bg $color]
		    
		    $mn add command -label $iname -state disabled -command {}
		    $mn add command -label "anisotropic diffusion..." -command "inrimage::anisoDiff4DDialog $iname $color"
		    $mn add separator
		    $mn add command -label "Save" -command "$iname -save"
		    $mn add command -label "Save As..." -command "$iname -save \[tk_getSaveFile -filetypes {{\"Inrimage 4D\" {.inr4D} } {All *}} -parent . -title {Save Inrimage4D as}\]"
		}
		
		proc inrimage::multiviewMergeMenu { name mname img img2 {toff 0} {color "#E8E0D2"}} {
		    set mn [menu $name -tearoff $toff -bg $color -postcommand "set inrimage::useVoxelSize \[${mname} -ignoreVoxelSize\]; set inrimage::useAxis \[${mname} -axis\]; set inrimage::activate \[${mname} -activate\]"]
		    $mn add command -label $mname -state disabled -command {}
		    $mn add checkbutton -label "Use voxel size" -variable inrimage::useVoxelSize  -onvalue "false" -offvalue "true" -command "evaluate \"${mname} -ignoreVoxelSize \$inrimage::useVoxelSize\""
		    $mn add checkbutton -label "Display axis" -variable inrimage::useAxis  -onvalue "true" -offvalue "false" -command "evaluate \"$mname -axis \$inrimage::useAxis\""
		    $mn add cascade -label "Zoom" -menu $mn.zoom
		    menu $mn.zoom -tearoff 0 -bg $color
		    $mn.zoom add command -label " 25 %" -command "evaluate \"$mname -scale * 0.25\""
		    $mn.zoom add command -label " 50 %" -command "evaluate \"$mname -scale * 0.5\""
		    $mn.zoom add command -label " 75 %" -command "evaluate \"$mname -scale * 0.75\""
		    $mn.zoom add command -label "125 %" -command "evaluate \"$mname -scale * 1.25\""
		    $mn.zoom add command -label "150 %" -command "evaluate \"$mname -scale * 1.5\""
		    $mn.zoom add command -label "200 %" -command "evaluate \"$mname -scale * 2\""
		    $mn.zoom add command -label "300 %" -command "evaluate \"$mname -scale * 3\""
		    $mn.zoom add command -label "400 %" -command "evaluate \"$mname -scale * 4\""
		    $mn add cascade -label "ColorMap image 1" -menu $mn.colormap
		    inrimage::colormapMenu $mn.colormap $mname $color
		    $mn add cascade -label "ColorMap image 2" -menu $mn.colormap2
		    inrimage::colormapMenu $mn.colormap2 $mname $color -scalemode2
		    if ![string compare [limitedVersion] "false" ] { 
			$mn add separator
			$mn add cascade -label "Image Commands Image 1" -menu $mn.image
			inrimage::inrmenu $mn.image $img  $mname
			$mn add cascade -label "Image Commands Image 2" -menu $mn.image2
			inrimage::inrmenu $mn.image2 $img2  $mname
		    }
		    $mn add separator
		    $mn add command -label "Load Image..." -command {set inr [inrimage::loadImage];if [string compare $inr ""] { set inr [ evaluate "new inr $inr" ]; evaluate "view $inr" } }
		    $mn add command -label "New Image..." -command "inrimage::inrimageDialog $color"
		    $mn add separator
		    $mn add command -label "Set visible region..." -command "set inrimage::mview $mname; evaluate \"new bbox3D \[ lindex \[ split \[ $mname -views\] \] 0 \] -color green -menu  inrimage::viewerXVisibleMenu\""
		    $mn add command -label "Reset visible region" -command "evaluate \"$mname -visible all\""
		    $mn add command -label "Crop image..." -command "set inrimage::mview $mname; evaluate \"new bbox3D \[ lindex \[ split \[ $mname -views\] \] 0 \] -color cyan -menu  inrimage::viewerXCropMenu \""
		    $mn add command -label "Isolate Region..." -command "set inrimage::mview $mname; evaluate \"new bbox3D \[ lindex \[ split \[ $mname -views\] \] 0 \] -color yellow -menu  inrimage::viewerXIsolateMenu \""
		    $mn add command -label "Zero Region..." -command "set inrimage::mview $mname; evaluate \"new bbox3D \[ lindex \[ split \[ $mname -views\] \] 0 \] -color magenta -menu  inrimage::viewerXZeroMenu \""
		    $mn add checkbutton -label "Activate" -variable inrimage::activate  -onvalue "true" -offvalue "false" -command "evaluate \"$mname -activate \$inrimage::activate\""
		    $mn add separator
		    $mn add command -label "Script Dialog" -command "if {!\[winfo exists .yav\]} {loadSource tclModules.tcl; loadSource yav++.tcl;yav::interface}"
		    $mn add separator
		    $mn add command -label "destroy" -command "evaluate \"$mname -destroy\""
		}
		proc inrimage::getABackground { image mn } {
		    set cam [ lindex [ $mn -views ] end ]
		    set scn [ $cam -scene]
		    set inrv "none"
		    foreach { o } [ $scn -objects ] { 
			if { [string match inrview* $o]} {set inrv $o}
		    }
		    if { [string compare $inrv "none"] } {
			set bg [ $o -background $cam ]
			return $bg
		    } else {
			return "none"
		    }
		}
		proc inrimage::windowImage { image mn } {
		    set cam [ lindex [ $mn -views ] end ]
		    set scn [ $cam -scene]
		    set inrv "none"
		    foreach { o } [ $scn -objects ] { 
			if { [string match inrview* $o]} {set inrv $o}	
			if {[string match  inr4Dview* $o]} {set inrv $o}	
			if {[string match  overinrview* $o]} {set inrv $o}
			if {[string match  transinrview* $o]} {set inrv $o}
			if {[string match  overinr4Dview* $o]} {set inrv $o}
		    }
		    if { [string compare $inrv "none"] } {
			set bg [ $o -background $cam ]
			set min [ [ $bg -greyLevel min ] -get ]
			set max [ [ $bg -greyLevel max ] -get ]
			
			return [evaluate " view \[evaluate \"$image -windowing min $min max $max\" \] " ]
		    }
		    else	return "none"
		}
		proc inrimage::inrslicecammenu { mn vname color} {
		    if {![winfo exists $mn.inr]} {
			$mn add separator
			set inr [$vname -inrimage]
			if [string compare $inr "no inrimage"] {
			    $mn add cascade -label $inr -menu $mn.inr
			    inrimage::inrmenu $mn.inr [$vname -inrimage] 0 0 $color
			    $mn add command -label "set gray level bounds" -command "\[$vname -inrimage\] -glbounds min \[\[$vname -minscale\] -get\] max \[\[$vname -maxscale\] -get\]"
			}
		    }
		}
		
		proc inrimage::slicecammenu { name vname {toff 0} {color "#E8E0D2"} } {
		    puts $vname
		    set inrimage::inrslicemenu [menu $name -tearoff $toff -bg $color -postcommand "set inrimage::useVoxelSize \[$vname -ignoreVoxelSize\]; set inrimage::activate \[$vname -activate\]; set inrimage::theImage \[$vname -inrimage\]; if {\[string compare $inrimage::theImage \"no inrimage\"\]} { inrimage::inrslicecammenu $name $vname $color}"]
		    set mn $inrimage::inrslicemenu
		    $mn add command -label $vname -state disabled -command {}
		    $mn add checkbutton -label "Use voxel size" -variable inrimage::useVoxelSize  -onvalue "false" -offvalue "true" -command "evaluate \"$vname -ignoreVoxelSize \$inrimage::useVoxelSize\""
		    $mn add cascade -label "Zoom" -menu $mn.zoom
		    menu $mn.zoom -tearoff 0 -bg $color
		    $mn.zoom add command -label " 25 %" -command "evaluate \"$vname -scale * 0.25\""
		    $mn.zoom add command -label " 50 %" -command "evaluate \"$vname -scale * 0.5\""
		    $mn.zoom add command -label " 75 %" -command "evaluate \"$vname -scale * 0.75\""
		    $mn.zoom add command -label "125 %" -command "evaluate \"$vname -scale * 1.25\""
		    $mn.zoom add command -label "150 %" -command "evaluate \"$vname -scale * 1.5\""
		    $mn.zoom add command -label "200 %" -command "evaluate \"$vname -scale * 2\""
		    $mn.zoom add command -label "300 %" -command "evaluate \"$vname -scale * 3\""
		    $mn.zoom add command -label "400 %" -command "evaluate \"$vname -scale * 4\""
		    $mn add cascade -label "Slice" -menu $mn.slice
		    menu $mn.slice -tearoff 0 -bg $color
		    $mn.slice add command -label "X" -command "evaluate \"$vname -geometry X\""
		    $mn.slice add command -label "Y" -command "evaluate \"$vname -geometry Y\""
		    $mn.slice add command -label "Z" -command "evaluate \"$vname -geometry Z\""
		    $mn.slice add command -label "alpha" -command "evaluate \"$vname -geometry alpha\""
		    $mn add cascade -label "View image" -menu $mn.image
		    inrimage::inrlist $mn.image "evaluate \"$vname -inrimage ...\"" 0 $color
		    $mn add command -label "reset visible region" -command "evaluate \"$vname -visible all\""
		    $mn add command -label "set visible region..." -command "evaluate \"new bbox3D \[ inrimage::getInrviewFromCamera  $vname\] -color green -menu  inrimage::viewerXVisibleMenu\""
		    $mn add checkbutton -label "activate" -variable inrimage::activate  -onvalue "true" -offvalue "false" -command "evaluate \"$vname -activate \$inrimage::activate\""
		    $mn add separator
		    $mn add command -label "destroy" -command "evaluate \"$vname -destroy\""
		}
		
		
		proc inrimage::inrmenu { name iname {mview 0} {toff 0} {color "#E8E0D2"}  } {
		    set mn [menu $name -tearoff $toff -bg $color]
		    
		    $mn add command -label $iname -state disabled -command {}
		    $mn add command -label "voxel size..." -command "inrimage::voxelSizeDialog $iname $color"
		    $mn add command -label "copy" -command "view \[evaluate \"$iname -copy\"\]"
		    $mn add cascade -label "convert" -menu $mn.convert
		    menu $mn.convert -tearoff 0 -bg $color
		    
		    $mn.convert add cascade -label "convert (cast)" -menu $mn.cast
		    menu $mn.cast -tearoff 0 -bg $color
		    $mn.cast add command -label "8 bits" -command "evaluate \"$iname -type cast 8bits\""
		    $mn.cast add command -label "16 bits signed" -command "evaluate \"$iname -type cast s16bits\""
		    $mn.cast add command -label "16 bits unsigned" -command "evaluate \"$iname -type cast 16bits\""
		    $mn.cast add command -label "32 bits signed" -command "evaluate \"$iname -type cast s32bits\""
		    $mn.cast add command -label "32 bits unsigned" -command "evaluate \"$iname -type cast 32bits\""
		    $mn.cast add command -label "64 bits signed" -command "evaluate \"$iname -type cast s64bits\""
		    $mn.cast add command -label "64 bits unsigned" -command "evaluate \"$iname -type cast 64bits\""
		    $mn.cast add command -label "float" -command "evaluate \"$iname -type cast float\""
		    $mn.cast add command -label "double" -command "evaluate \"$iname -type cast double\""
		    $mn.cast add command -label "RGB" -command "evaluate \"$iname -type cast rgb\""
		    $mn.cast add command -label "RGBA" -command "evaluate \"$iname -type cast rgba\""
		    $mn.cast add command -label "float vector" -command "evaluate \"$iname -type cast floatVector\""
		    $mn.cast add command -label "double vector" -command "evaluate \"$iname -type cast doubleVector\""
		    
		    $mn.convert add cascade -label "convert (scale)" -menu $mn.scale
		    menu $mn.scale -tearoff 0 -bg $color
		    $mn.scale add command -label "8 bits" -command "evaluate \"$iname -type scale 8bits\""
		    $mn.scale add command -label "16 bits signed" -command "evaluate \"$iname -type scale s16bits\""
		    $mn.scale add command -label "16 bits unsigned" -command "evaluate \"$iname -type scale 16bits\""
		    $mn.scale add command -label "32 bits signed" -command "evaluate \"$iname -type scale s32bits\""
		    $mn.scale add command -label "32 bits unsigned" -command "evaluate \"$iname -type scale 32bits\""
		    $mn.scale add command -label "64 bits signed" -command "evaluate \"$iname -type scale s64bits\""
		    $mn.scale add command -label "64 bits unsigned" -command "evaluate \"$iname -type scale 64bits\""
		    $mn.scale add command -label "float" -command "evaluate \"$iname -type scale float\""
		    $mn.scale add command -label "double" -command "evaluate \"$iname -type scale double\""
		    $mn.scale add command -label "RGB" -command "evaluate \"$iname -type scale rgb"
		    $mn.scale add command -label "RGBA" -command "evaluate \"$iname -type scale rgba\""
		    $mn.scale add command -label "float vector" -command "evaluate \"$iname -type scale floatVector\""
		    $mn.scale add command -label "double vector" -command "evaluate \"$iname -type scale doubleVector\""
		    $mn add separator
		    $mn add command -label "insert image..." -command "inrimage::melDialog $iname $color"
		    $mn add command -label "crop image..." -command "inrimage::cropDialog $iname $color"
		    $mn add cascade -label "flip" -menu $mn.flip
		    menu $mn.flip -tearoff 0 -bg $color
		    $mn.flip add command -label "along X" -command "evaluate \"$iname -flip X\""
		    $mn.flip add command -label "along Y" -command "evaluate \"$iname -flip Y\""
		    $mn.flip add command -label "along Z" -command "evaluate \"$iname -flip Z\""
		    
		    
		    
		    # 	$mn add separator
		    # 	$mn add cascade -label "interpolation" -menu $mn.interp
		    # 	menu $mn.interp -tearoff 0 -bg $color
		    # 	$mn.interp add command -label "nearest" -command "evaluate \"$iname -interpolation nearest\""
		    # 	$mn.interp add command -label "trilinear" -command "evaluate \"$iname -interpolation trilin\""
		    
		    # 	$mn add cascade -label "extrapolation" -menu $mn.extrap
		    # 	menu $mn.extrap -tearoff 0 -bg $color
		    # 	$mn.extrap add command -label "nearest" -command "evaluate \"$iname -extrapolation nearest\""
		    # 	$mn.extrap add command -label "to zero" -command "evaluate \"$iname -extrapolation tozero\""
		    
		    $mn add separator
		    $mn add command -label "arithmetic ..." -command "inrimage::arithmeticDialog $iname $color"
		    
		    $mn add separator
		    $mn add command -label "morphomathematic..." -command "inrimage::morphomathematicDialog $iname $color"
		    $mn add command -label "connexe..." -command "inrimage::connexeDialog $iname $color"
		    $mn add command -label "fill..." -command "inrimage::fillDialog $iname $color"
		    $mn add command -label "chamfer map ... " -command "inrimage::chamferDialog $iname $color"
		    
		    $mn add separator
		    $mn add cascade -label "logical operations" -menu $mn.logical
		    menu $mn.logical -tearoff 0 -bg $color
		    
		    $mn.logical add command -label "not" -command "evaluate \"$iname -logic not\""
		    $mn.logical add cascade -label "logical or" -menu $mn.or
		    inrimage::inrlist $mn.or "$iname -logic or ..." 0 $color
		    $mn.logical add cascade -label "logical and" -menu $mn.and
		    inrimage::inrlist $mn.and "$iname -logic and ..." 0 $color
		    $mn.logical add cascade -label "logical xor" -menu $mn.xor
		    inrimage::inrlist $mn.xor "$iname -logic xor ..." 0 $color
		    
		    $mn add separator
		    
		    $mn add command -label "DFT / DFT-1 3D" -command "evaluate \"$iname -dft 3D\""
		    $mn add command -label "DFT / DFT-1 2D" -command "evaluate \"$iname -dft 2D\""
		    
		    $mn add separator
		    $mn add command -label "histogram..." -command "set h \[ evaluate \"$iname -histogram\" \];evaluate \" \$h -plot\""
		    $mn add command -label "threshold..." -command "inrimage::thresholdDialog $iname  $mview $color"
		    $mn add command -label "apply windowing" -command "inrimage::windowImage $iname $mview"
		    $mn add command -label "eval function..." -command "inrimage::evalDialog $iname $color"
		    
		    $mn add separator
		    
		    $mn add cascade -label "Filtering" -menu $mn.filter
		    menu $mn.filter -tearoff 0 -bg $color
		    
		    $mn.filter add command -label "gradient..." -command "inrimage::gradientDialog $iname $color"
		    $mn.filter add command -label "laplacian..." -command "inrimage::laplacianDialog $iname $color"
		    $mn.filter add command -label "convolute..." -command "inrimage::convoluteDialog $iname $color"
		    $mn.filter add command -label "recursive filter..." -command "inrimage::recursiveFilterDialog $iname $color"
		    
		    $mn.filter add command -label "noise..." -command "inrimage::noiseDialog $iname $color"
		    $mn.filter add cascade -label "anisotropic diffusion" -menu $mn.filter.aniso
		    
		    menu $mn.filter.aniso -tearoff 0 -bg $color
		    
		    $mn.filter.aniso add command -label "scalar..." -command "inrimage::anisoDiffScalDialog $iname $color"
		    $mn.filter.aniso add command -label "matrix..." -command "inrimage::anisoDiffMatDialog $iname $color"
		    $mn.filter.aniso add command -label "vessels..." -command "inrimage::anisoDiffVesselsDialog $iname $color"
		    
		    $mn add separator
		    
		    $mn add command -label "crest extraction..." -command "if {!\[string compare \[isModuleLoaded tclEpinrimage \] no \]} { evaluate \"yav::setDependance;yav::loadModule tclEpinrimage yav::moduleDependance\"; if [winfo exists .yavModule ] {yav::updateModuleDialog .yavModule } }; epinrimage::crestextraction $iname $color"
		    
		    $mn add command -label "isosurface extraction..." -command "if {!\[string compare \[isModuleLoaded tclCIsosurf \] no \]} { evaluate \"yav::setDependance; yav::loadModule tclCIsosurf yav::moduleDependance\"; if [winfo exists .yavModule ] {yav::updateModuleDialog .yavModule } }; cisosurf::extractIsosurf $iname $color"
		    
		    
		}
		
		proc inrimage::viewerPopupMenu { slicecam {color "#E8E0D2"}} {
		    set mint [$slicecam -widget].m
		    if {![winfo exists $mint]} {
			inrimage::slicecammenu $mint $slicecam 0 $color
		    }
		    bind [$slicecam -widget] <Button-3> "tk_popup $mint %X %Y"
		}
		
		proc inrimage::viewerXIsolateMenu { context cam bbox {color "#E8E0D2"} } {
		    set mint [$cam -widget].crop
		    
		    if {![winfo exists $mint]} {
			set mn [menu $mint -tearoff 0 -bg $color]
			$mn add command -label $cam -state disabled -command {}
			$mn add command -label "Isolate Region in  Image $inrimage::cropImage" -command "scan \[$bbox -boxSize -org\] \"%f %f %f\" ox oy oz; scan \[$bbox -boxSize -end\] \"%f %f %f\" ex ey ez; scan \[ $inrimage::cropImage -worldToVoxel \$ox \$oy \$oz \]  \"%f %f %f\" ox2 oy2 oz2;scan \[ $inrimage::cropImage -worldToVoxel \$ex \$ey \$ez \]  \"%f %f %f\" ex2 ey2 ez2;evaluate \"$inrimage::cropImage -isolateRegion org \$ox2 \$oy2 \$oz2 end \$ex2 \$ey2 \$ez2 \";$bbox -destroy "
			$mn add command -label "Cancel" -command "$bbox -destroy"
		    }
		    
		    bind [$cam -widget] <Button-3> "tk_popup $mint %X %Y"
		}
		
		proc inrimage::viewerXZeroMenu { context cam bbox {color "#E8E0D2"} } {
		    set mint [$cam -widget].crop
		    
		    if {![winfo exists $mint]} {
			set mn [menu $mint -tearoff 0 -bg $color]
			$mn add command -label $cam -state disabled -command {}
			$mn add command -label "Zero Region in Image $inrimage::cropImage" -command "scan \[$bbox -boxSize -org\] \"%f %f %f\" ox oy oz; scan \[$bbox -boxSize -end\] \"%f %f %f\" ex ey ez; scan \[ $inrimage::cropImage -worldToVoxel \$ox \$oy \$oz \]  \"%f %f %f\" ox2 oy2 oz2;scan \[ $inrimage::cropImage -worldToVoxel \$ex \$ey \$ez \]  \"%f %f %f\" ex2 ey2 ez2;evaluate \"$inrimage::cropImage -zeroRegion org \$ox2 \$oy2 \$oz2 end \$ex2 \$ey2 \$ez2 \";$bbox -destroy "
			$mn add command -label "Cancel" -command "$bbox -destroy"
		    }
		    
		    bind [$cam -widget] <Button-3> "tk_popup $mint %X %Y"
		}
		
		
		proc inrimage::uninstallCropMenu {context camera object} {
		    set mint [$camera -widget].crop
		    
		    if {[winfo exists $mint]} {
			destroy $mint
		    }
		    bind [$camera -widget] <Button-3> ""
		}
		proc inrimage::viewerXCropMenu { context cam bbox {color "#E8E0D2"} } {
		    set mint [$cam -widget].crop
		    
		    if {![winfo exists $mint]} {
			set mn [menu $mint -tearoff 0 -bg $color]
			$mn add command -label $cam -state disabled -command {}
			$mn add command -label "Crop Image $inrimage::cropImage" -command "scan \[$bbox -boxSize -org\] \"%f %f %f\" ox oy oz; scan \[$bbox -boxSize -end\] \"%f %f %f\" ex ey ez; scan \[ $inrimage::cropImage -worldToVoxel \$ox \$oy \$oz \]  \"%f %f %f\" ox2 oy2 oz2;scan \[ $inrimage::cropImage -worldToVoxel \$ex \$ey \$ez \]  \"%f %f %f\" ex2 ey2 ez2;evaluate \"$inrimage::cropImage -crop org \$ox2 \$oy2 \$oz2 end \$ex2 \$ey2 \$ez2 \";$bbox -destroy "
			$mn add command -label "Cancel" -command "$bbox -destroy"
		    }
		    
		    bind [$cam -widget] <Button-3> "tk_popup $mint %X %Y"
		}
		
		
		proc inrimage::viewerXVisibleMenu { slicecam bbox {color "#E8E0D2"} } {
		    set mint [$slicecam -widget].visible
		    
		    if {![winfo exists $mint]} {
			set mn [menu $mint -tearoff 0 -bg $color]
			$mn add command -label $slicecam -state disabled -command {}
			$mn add command -label "set visible region" -command "evaluate \"$inrimage::mview -visible \[$bbox -boxSize -org\] \[$bbox -boxSize -end\] \"; $bbox -destroy"
			$mn add command -label "reset to all image" -command "$inrimage::mview -visible all"
			$mn add command -label "drop" -command "$bbox -destroy"
		    }
		    
		    bind [$slicecam -widget] <Button-3> "tk_popup $mint %X %Y"
		}
		
		proc inrimage::glscalemenu { sname {toff 0} {color "#E8E0D2"}} {
		    set name [$sname -widget].m
		    set mn [menu $name -tearoff $toff -bg $color -postcommand "set activate \[$sname -activate\]"]
		    
		    $mn add command -label $sname -state disabled -command {}
		    $mn add command -label "set value..." -command "graphics2D::setScaleValue $sname $color"
		    #    $mn add cascade -label "add" -menu $mn.add
		    #    menu $mn.add -tearoff $toff -bg $color -postcommand "$mn.add delete 0 last; foreach { i } \[ which multiview \] {$mn.add add command -label \$i -command \"evaluate { $sname -add \$i } \" }" 
		    #    $mn add cascade -label "remove" -menu $mn.remove
		    #    menu $mn.remove -tearoff $toff -bg $color -postcommand "$mn.remove delete 0 last; foreach { i } \[ $sname -objects \] {$mn.remove add command -label \$i -command \" evaluate { $sname -remove \$i} \" }" 
		    $mn add cascade -label "speed" -menu $mn.speed
		    menu $mn.speed -tearoff $toff -bg $color
		    $mn.speed add command -label "very slow" -command "evaluate \"$sname -maxSteps 1000\""
		    $mn.speed add command -label "slow" -command "evaluate \"$sname -maxSteps 200\""
		    $mn.speed add command -label "normal" -command "evaluate \"$sname -maxSteps 100\""
		    $mn.speed add command -label "fast" -command "evaluate \"$sname -maxSteps 30\""
		    $mn.speed add command -label "very fast" -command "evaluate \"$sname -maxSteps 10\""
		    $mn add checkbutton -label "activate" -variable inrimage::activate  -onvalue "true" -offvalue "false" -command "$sname -activate \$inrimage::activate"
		    $mn add separator
		    $mn add command -label "destroy" -command "$sname -destroy"
		    bind [$sname -widget] <Button-3> "tk_popup $name %X %Y"
		}
		
		proc inrimage::opacityscalemenu { sname {toff 0} {color "#E8E0D2"}} {
		    set name [$sname -widget].m
		    set mn [menu $name -tearoff $toff -bg $color -postcommand "set activate \[$sname -activate\]"]
		    
		    $mn add command -label $sname -state disabled -command {}
		    $mn add command -label "set value..." -command "graphics2D::setScaleValue $sname $color"
		    
		    #    $mn add cascade -label "add" -menu $mn.add
		    #    menu $mn.add -tearoff $toff -bg $color -postcommand "$mn.add delete 0 last; foreach { i } \[ which overinrbgrnd \] {$mn.add add command -label \$i -command \" evaluate {  $sname -add \$i } \" }" 
		    #    $mn add cascade -label "remove" -menu $mn.remove
		    #    menu $mn.remove -tearoff $toff -bg $color -postcommand "$mn.remove delete 0 last; foreach { i } \[ $sname -objects \] {$mn.remove add command -label \$i -command \" evaluate { $sname -remove \$i } \"}" 
		    $mn add cascade -label "speed" -menu $mn.speed
		    menu $mn.speed -tearoff $toff -bg $color
		    $mn.speed add command -label "very slow" -command "evaluate \"$sname -maxSteps 500\""
		    $mn.speed add command -label "slow" -command "evaluate \"$sname -maxSteps 100\""
		    $mn.speed add command -label "normal" -command "evaluate \"$sname -maxSteps 20\""
		    $mn.speed add command -label "fast" -command "evaluate \"$sname -maxSteps 10\""
		    $mn.speed add command -label "very fast" -command "evaluate \"$sname -maxSteps 5\""
		    $mn add checkbutton -label "activate" -variable inrimage::activate  -onvalue "true" -offvalue "false" -command "$sname -activate \$inrimage::activate"
		    $mn add separator
		    $mn add command -label "destroy" -command "$sname -destroy"
		    bind [$sname -widget] <Button-3> "tk_popup $name %X %Y"
		}
		
		
		proc inrimage::backgroundMenu { name camera {toff 0} {color "#E8E0D2"} } {
		    set mn  [menu $name -tearoff $toff -bg $color ]
		    $mn add command -label $camera -state disabled -command {}
		    
		    $mn add command -label "record camera..." -command "graphics2D::startRecording $camera"
		    $mn add command -label "save camera to ppm" -command "set name \[tk_getSaveFile -filetypes {{\"PPM File\" {*.ppm}} {\"All\" {*} }  } -parent . -title {Select a PPM Image File}\]; if \[string compare \$name {}\] { evaluate \"$camera -dumpToPPM \$name\" };"
		    bind [$camera -widget] <Button-3> "tk_popup $name %X %Y"
		}
		# set inrimage voxel size
		proc inrimage::imageInfoDialog { img color } {
		    if ![winfo exists .voxelSize] {
			set root .imageInfo
			toplevel $root -bg $color
			wm title $root "Image Information"
			set maxvs 5
			
			labelframe $root.f1 -text "Voxel Size" -bg $color
			scan "[$img -voxel]" "%f %f %f" vx vy vz
			set gr $vx
			if { $vy > $gr } { set gr $vy }
			if { $vz > $gr } { set gr $vz }
			if { $gr > [expr $maxvs - 3.0] } { set maxvs [expr $gr + 5.0] } 
			
			scale $root.f1.vx -label "VX" -from 0.01 -to $maxvs -resolution 0.01 -length 300 -orient horizontal -bg $color
			scale $root.f1.vy -label "VY" -from 0.01 -to $maxvs -resolution 0.01 -length 300 -orient horizontal -bg $color
			scale $root.f1.vz -label "VZ" -from 0.01 -to $maxvs -resolution 0.01 -length 300 -orient horizontal -bg $color
			$root.f1.vx set $vx
			$root.f1.vy set $vy
			$root.f1.vz set $vz
			bind $root.f1.vx <ButtonRelease-1> "evaluate \"$img -voxel \[$root.f1.vx get\] \[$root.f1.vy get\] \[$root.f1.vz get\]\" "
			bind $root.f1.vy <ButtonRelease-1> "evaluate \"$img -voxel \[$root.f1.vx get\] \[$root.f1.vy get\] \[$root.f1.vz get\]\" "
			bind $root.f1.vz <ButtonRelease-1> "evaluate \"$img -voxel \[$root.f1.vx get\] \[$root.f1.vy get\] \[$root.f1.vz get\]\" "
			
			frame $root.f
			labelframe $root.f.f2 -text "Image Size" -bg $color
			label $root.f.f2.row -text "Number of rows : [lindex  [$img -size] 0 ]" -justify left
			label $root.f.f2.col -text "Number of columns : [lindex [$img -size] 1 ]"  -justify left
			label $root.f.f2.plane -text "Number of planes : [lindex [$img -size] 2 ]"  -justify left
			
			
			labelframe $root.f.f3 -text "Image type" -bg $color
			label $root.f.f3.type -text "Image type : [$img -type]" -justify left
			
			frame $root.b -bg $color
			button $root.b.dismiss -text "Dismiss" -command "destroy $root" -bg $color
			
			pack $root.f1 $root.f1.vx $root.f1.vy $root.f1.vz 
			pack $root.f   -expand true -fill x
			pack $root.f.f2 $root.f.f3 -side left -expand true -fill x -fill y
			pack  $root.f.f2.row  $root.f.f2.col  $root.f.f2.plane $root.b -side top
			pack  $root.f.f3.type -side top
			if [string match *Vector [$img -type] ] {
			    label $root.f.f3.vdim -text "Vector Size : [ lindex [$img -size] 3]" -justify left
			    pack  $root.f.f3.vdim -side top
			}
			pack $root.b.dismiss -side left -padx 20 -pady 10
		    }
		}
		# set inrimage voxel size
		proc inrimage::voxelSizeDialog { img color } {
		    if ![winfo exists .voxelSize] {
			toplevel .voxelSize -bg $color
			wm title .voxelSize "Enter new voxel size"
			set maxvs 5
			
			scan "[$img -voxel]" "%f %f %f" vx vy vz
			set gr $vx
			if { $vy > $gr } { set gr $vy }
			if { $vz > $gr } { set gr $vz }
			if { $gr > [expr $maxvs - 3.0] } { set maxvs [expr $gr + 5.0] } 
			
			scale .voxelSize.vx -label "VX" -from 0.01 -to $maxvs -resolution 0.01 -length 300 -orient horizontal -bg $color
			bind .voxelSize.vx <Enter> { focus .voxelSize.vx }
			scale .voxelSize.vy -label "VY" -from 0.01 -to $maxvs -resolution 0.01 -length 300 -orient horizontal -bg $color
			bind .voxelSize.vy <Enter> { focus .voxelSize.vy }
			scale .voxelSize.vz -label "VZ" -from 0.01 -to $maxvs -resolution 0.01 -length 300 -orient horizontal -bg $color
			bind .voxelSize.vz <Enter> { focus .voxelSize.vz }
			.voxelSize.vx set $vx
			.voxelSize.vy set $vy
			.voxelSize.vz set $vz
			
			frame .voxelSize.b -bg $color
			button .voxelSize.b.ok -text "OK" -command "evaluate \"$img -voxel \[.voxelSize.vx get\] \[.voxelSize.vy get\] \[.voxelSize.vz get\]\"; destroy .voxelSize" -bg $color
			button .voxelSize.b.dismiss -text "Dismiss" -command "destroy .voxelSize" -bg $color
			
			pack .voxelSize.vx .voxelSize.vy .voxelSize.vz .voxelSize.b
			pack .voxelSize.b.ok .voxelSize.b.dismiss -side left -padx 20 -pady 10
		    }
		}
		
		# set inrimage voxel size
		proc inrimage::voxel4DSizeDialog { img color } {
		    if ![winfo exists .voxelSize] {
			toplevel .voxelSize -bg $color
			wm title .voxelSize "Enter new voxel size"
			set maxvs 5
			
			scan "[$img -voxel]" "%f %f %f %f" vx vy vz vt
			set gr $vx
			if { $vy > $gr } { set gr $vy }
			if { $vz > $gr } { set gr $vz }
			if { $gr > [expr $maxvs - 3.0] } { set maxvs [expr $gr + 5.0] } 
			
			scale .voxelSize.vx -label "VX" -from 0.01 -to $maxvs -resolution 0.01 -length 300 -orient horizontal -bg $color
			bind .voxelSize.vx <Enter> { focus .voxelSize.vx }
			scale .voxelSize.vy -label "VY" -from 0.01 -to $maxvs -resolution 0.01 -length 300 -orient horizontal -bg $color
			bind .voxelSize.vy <Enter> { focus .voxelSize.vy }
			scale .voxelSize.vz -label "VZ" -from 0.01 -to $maxvs -resolution 0.01 -length 300 -orient horizontal -bg $color
			bind .voxelSize.vz <Enter> { focus .voxelSize.vz }
			scale .voxelSize.vt -label "VT" -from 0.5 -to 15 -resolution 0.01 -length 300 -orient horizontal -bg $color
			bind .voxelSize.vt <Enter> { focus .voxelSize.vt }
			.voxelSize.vx set $vx
			.voxelSize.vy set $vy
			.voxelSize.vz set $vz
			.voxelSize.vt set $vt
			
			frame .voxelSize.b -bg $color
			button .voxelSize.b.ok -text "OK" -command "evaluate \"$img -voxel \[.voxelSize.vx get\] \[.voxelSize.vy get\] \[.voxelSize.vz get\] \[.voxelSize.vt get\]\"; destroy .voxelSize" -bg $color
			button .voxelSize.b.dismiss -text "Dismiss" -command "destroy .voxelSize" -bg $color
			
			pack .voxelSize.vx .voxelSize.vy .voxelSize.vz .voxelSize.vt .voxelSize.b
			pack .voxelSize.b.ok .voxelSize.b.dismiss -side left -padx 20 -pady 10
		    }
		}
		
		
		
		
		proc inrimage::inrOptionMenu { name {cmd ""} {color "#E8E0D2"} {theInr none}} {
		    if ![string compare $cmd ""] {
			set cmdf 0
		    } else {
			set cmdf 1
		    }
		    menubutton $name -background $color -menu $name.mn -indicatoron true -relief solid
		    if [string match $theInr "none"] {
			set theInr [lindex [which inr] 0]
		    } 
		    $name configure -text "$theInr ([$theInr -name])"
		    set  inrimage::mval $theInr
		    if $cmdf {
			menu $name.mn -tearoff 0 -bg $color -postcommand "$name.mn delete 0 last; foreach { i } \[which inr\] { $name.mn add radiobutton -variable inrimage::mval -label \" \$i (\[\$i -name\])\"  -command \"$name configure -text \\\" \$i (\\\[\\\$i -name\\\]) \\\"; \[modules::menusubstitute {$cmd} ... \$i\] \" }" -bg $color
		    }  else {
			menu $name.mn -tearoff 0 -bg $color -postcommand "$name.mn delete 0 last; foreach { i } \[which inr\] { $name.mn add radiobutton -variable inrimage::mval -label \" \$i (\[\$i -name\])\"  -command \"$name configure -text \\\" \$i (\\\[\\\$i -name\\\]) \\\";  \" }" -bg $color
			
		    }
		}
		
		
		
		proc inrimage::choiceFrame { fname title varname color args } {
		    frame $fname -bg $color
		    
		    label $fname.l -text $title -relief raised -bg $color
		    pack $fname.l -fill x
		    foreach { i } $args {
			set label [lindex $i 0]
			set val [lindex $i 1]
			radiobutton $fname.$val -text $label -variable $varname -value $val -bg $color -anchor w 
			pack $fname.$val -fill x
		    }
		}
		
		# apply an arithmetic operator on an inrimage
		proc inrimage::arithmeticDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .arith] {
			toplevel .arith -bg $color
			wm title .arith "Arithmetic operation"
			frame .arith.d -bg $color
			frame .arith.b -bg $color
			frame .arith.d.operand -bg $color
			
			inrimage::choiceFrame .arith.d.operator "arithmetic operator" inrimage::operator $color {" set value" set} {"+ (add)" add} {"- (substract)" sub} {"* (multiplicate)" mul} {"/ (divide)" div}
			set inrimage::operator add
			
			label .arith.d.operand.l -text "operand" -relief raised -bg $color
			radiobutton .arith.d.operand.cst -text "Constant" -variable inrimage::operand -value cst -bg $color -anchor w  -command ".arith.d.operand.menu configure -state disabled; .arith.d.operand.e configure -state normal"
			entry .arith.d.operand.e -fg black -bg white -relief sunken
			.arith.d.operand.e insert 0 "1.0"
			radiobutton .arith.d.operand.inr -text "Inrimage" -variable inrimage::operand -value inr -bg $color -anchor w  -command ".arith.d.operand.e configure -state disabled; .arith.d.operand.menu configure -state normal"
			inrimage::inrOptionMenu .arith.d.operand.menu "" $color
			#	    .arith.d.operand.menu configure -state disabled 
			set inrimage::operand cst
			
			button .arith.b.ok -text "OK" -command "if { !\[string compare \$inrimage::operand cst\] } { evaluate \"$img -arith \$inrimage::operator \[.arith.d.operand.e get\]\" } else { evaluate \"$img -arith \$inrimage::operator \$inrimage::mval\"}; destroy .arith" -bg $color
			button .arith.b.dismiss -text "Dismiss" -command "destroy .arith" -bg $color
			
			pack .arith.d.operand.l .arith.d.operand.cst .arith.d.operand.e .arith.d.operand.inr .arith.d.operand.menu -fill x
			
			pack .arith.d.operator .arith.d.operand -side left -expand true -fill both -padx 10 -pady 10
			pack .arith.b.ok .arith.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .arith.d .arith.b
		    }
		}
		# apply an arithmetic operator on an inrimage
		proc inrimage::logicDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .logic] {
			toplevel .logic -bg $color
			wm title .logic "Logic operation"
			frame .logic.d -bg $color
			frame .logic.b -bg $color
			frame .logic.d.operand -bg $color
			
			inrimage::choiceFrame .logic.d.operator "Logic operator" inrimage::operator $color {"not " not} {"or " or} {"xor (exclusive or)" xor} {"and " and} 
			set inrimage::operator and
			
			label .logic.d.operand.l -text "operand" -relief raised -bg $color
			radiobutton .logic.d.operand.cst -text "Constant" -variable inrimage::operand -value cst -bg $color -anchor w  -command ".logic.d.operand.menu configure -state disabled; .logic.d.operand.e configure -state normal"
			entry .logic.d.operand.e -fg black -bg white -relief sunken
			.logic.d.operand.e insert 0 "1.0"
			radiobutton .logic.d.operand.inr -text "Inrimage" -variable inrimage::operand -value inr -bg $color -anchor w  -command ".logic.d.operand.e configure -state disabled; .logic.d.operand.menu configure -state normal"
			inrimage::inrOptionMenu .logic.d.operand.menu "" $color
			.logic.d.operand.cst configure -state disabled 
			set inrimage::operand inr
			
			button .logic.b.ok -text "OK" -command "if { \[string compare \$inrimage::operator not\] } { evaluate \"$img -logic \$inrimage::operator \$inrimage::mval\" } else { evaluate \"$img -logic not\"}; destroy .logic" -bg $color
			button .logic.b.dismiss -text "Dismiss" -command "destroy .logic" -bg $color
			
			pack .logic.d.operand.l .logic.d.operand.cst .logic.d.operand.e .logic.d.operand.inr .logic.d.operand.menu -fill x
			
			pack .logic.d.operator .logic.d.operand -side left -expand true -fill both -padx 10 -pady 10
			pack .logic.b.ok .logic.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .logic.d .logic.b
		    }
		}
		proc inrimage::getMultiviewFromImage {inr} {
		    set res none
		    foreach i [which multiview] {
			if [ string match [$i -image] $inr ] {
			    set res $i
			}
		    }
		    return $res
		}
		# apply an arithmetic operator on an inrimage
		proc inrimage::morphomathematicDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .morpho] {
			toplevel .morpho -bg $color
			wm title .morpho "Morphomathematic operation"
			frame .morpho.d -bg $color
			frame .morpho.b -bg $color
			frame .morpho.d.operand -bg $color
			frame .morpho.d.element -bg $color
			
			inrimage::choiceFrame .morpho.d.operand.operator "morphomathematic operator" inrimage::operator $color {erosion ero} {dilation dil} {openning open} {closure close} {tophat tophat} {invtophat invtophat} {morphogradient grad} {lowermorphogradient lowgrad} {uppermorphogradient uppgrad} { medianfiltering median }
			set inrimage::operator ero
			
			inrimage::choiceFrame .morpho.d.operand.con "connexity" inrimage::con $color {"4 (2D edge)" 4} {"8 (2D vertex)" 8} {"6 (3D face)" 6} {"10 (????)" 10} {"18 (3D edge)" 18} {"26 (3D vertex)" 26} 
			set inrimage::con 26
			
			frame .morpho.d.operand.niter -bg $color
			label .morpho.d.operand.niter.l -text "number of iterations" -relief raise -bg $color
			scale .morpho.d.operand.niter.s -from 1 -to 20 -orient vertical -bg $color
			
			inrimage::choiceFrame .morpho.d.operand.mode "Mode" inrimage::mode $color {"Binary" binary} {"GreyLevel" greylevel}
			set inrimage::mode greylevel
			
			button .morpho.b.ok -text "OK" -command "evaluate \"$img -morpho \$inrimage::operator con \$inrimage::con  i \[.morpho.d.operand.niter.s get\] \"; destroy .morpho" -bg $color
			button .morpho.b.dismiss -text "Dismiss" -command "destroy .morpho" -bg $color 
			
			pack .morpho.d.operand.niter.l .morpho.d.operand.niter.s -fill y
			
			pack .morpho.d.operand.operator .morpho.d.operand.con .morpho.d.operand.niter .morpho.d.operand.mode -side left -expand true -fill both -padx 10 -pady 10
			#pack .morpho.d.element.l .morpho.d.element.r .morpho.d.element.b .morpho.d.element.list .morpho.d.element.center .morpho.d.element.lab_center -side left -expand true -fill x -padx 20 -pady 10
			pack .morpho.b.ok .morpho.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .morpho.d.operand .morpho.d.element -side top
			pack .morpho.d .morpho.b
		    }
		}
		
		
		proc inrimage::inrscale { name img color {minormax min}} {
		    scan [$img -glbounds] "%s %s" min max
		    if ![string compare [$img -floating] true] {
			set resol [expr $max / 1000.0 - $min / 1000.0]
		    } else {
			set resol 1
		    }
		    scale $name -from $min -to $max -bg $color -orient horiz -resolution $resol -length 255
		    bind $name <Enter> "focus $name"
		    if ![string compare $minormax min] {
			$name set $min
		    } else {
			$name set $max
		    }
		}
		
		proc inrimage::evalDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .evalinr] {
			set root .evalinr
			toplevel $root -bg $color
			wm title $root "Function Evaluation"
			
			frame $root.d -bg $color
			frame $root.h -bg $color
			frame $root.b -bg $color
			
			frame $root.d.eval -bg $color
			label $root.d.eval.l -bg $color -text "Enter Function:" -anchor w
			entry $root.d.eval.e -bg $color -fg black -relief sunken -width 70
			bind $root.d.eval.e <Return> "evaluate \"$img -eval \[ $root.d.eval.e get \] \""
			pack $root.d.eval.l $root.d.eval.e -fill x
			pack   $root.d.eval
			
			text $root.h.text -height 10 -wrap word -xscrollcommand "$root.h.xscroll set"  -yscrollcommand "$root.h.yscroll set"   -setgrid 1 -highlightthickness 0 -pady 2 -padx 3  
			scrollbar $root.h.xscroll -command "$root.h.text xview"  -highlightthickness 0 -orient horizontal 
			scrollbar $root.h.yscroll -command "$root.h.text yview"  -highlightthickness 0 -orient vertical 
			grid $root.h.text -in $root.h -padx 1 -pady 1 -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky news   
			grid $root.h.yscroll -in $root.h -padx 1 -pady 1 -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky news   
			grid $root.h.xscroll -in $root.h -padx 1 -pady 1 -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky news   
			grid rowconfig    $root.h 0 -weight 1 -minsize 0
			grid columnconfig $root.h 0 -weight 1 -minsize 0    
			
			$root.h.text insert 1.0 "Evaluates expression in function string.\n Supports the following arithmetic operators in the following order:\n \t  ^(power),\n\t /(division) or *(multiplication) \n\t +(addition) or -(subtraction)\n Operators with the same priority are processed from left to right. All other operators have lowest priority  and therefore processed from left to right as well.\n Special operators: \n\t |<(minimum),\n\t |>(maximum)\n Logical Operators(returns 1=true,0=false):\n\t   <=(Smaller or equal),\n\t  >=(Larger or equal),\n\t  ==(equal),\n\t   >(larger),\n\t  <(smaller),\n\t  &&(and),\n\t  ||(or).\n  Standard functions (angles are in radians):\n\t abs(),\n\t exp(),\n\t ceil()(rounds upwards),\n\t floor()(rounds downwards),\n\t log(),\n\t sqrt(),\n\t sin(),\n\t cos(),\n\t tan(),\n\t asin(),\n\t acos(),\n\t atan(),\n\t sinh(),\n\t cosh(),\n\t tanh().\n      Global functions (returns a scalar and calculates value based on the expression given as input to the function)):\n\t mean,\n\t min(minimum value),\n\t max(maximum value),\n\t med(median),\n\t std(estimated standard deviation),\n\t var(estimated variance).\n    Variables: \n\t x,y,z (pixel positions),\n\t inrX(X can be any number of a valid image).\n\n\n Examples: \n\t inr3 -eval inr1|<inr2  (each pixel of inr3 contains the  maximum of the corresponding pixels in inr1 and inr2), \n\t inr3 -eval inr1 -eval (x-64)^2+(y-64)^2+(z-64)^2<200  (creates a sphere),\n\t inr3 -eval inr1-mean(inr1)(set mean to zero), \n\t inr3 -eval (inr1-min(inr1))/(max(inr1)-min(inr1))*100  (normalizes image between 0 and 100),\n\t inr3 -eval med(sqrt(inr1^2/inr2)/(x+y+z)^3)*inr2 (I don't know).\n"
			$root.h.text mark set insert 1.0    
			#	    pack $root.h.text $root.h.xscroll $root.h.yscroll
			button $root.b.ok -text "Evaluate" -bg $color -command "evaluate \"$img -eval \[ $root.d.eval.e get \] \""
			button $root.b.dismiss -text "Dismiss" -command "destroy $root" -bg $color
			pack  $root.b.ok $root.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack $root.d $root.h $root.b 
		    }
		}
		
		
		proc inrimage::thresholdDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .threshold] {
			#get grey scale from mview
			set mview [inrimage::getMultiviewFromImage $img]
			if ![string match $mview none] {
			    scan [$mview -window] "%f %f" minScale maxScale
			    $mview -colormap threshold
			    if { [string match [$mview -GLScale min] ""] } {
				set createGL 1
			    } else {
				set minScale [ [$mview -GLScale min] -widget ]
				set maxScale [ [$mview -GLScale max] -widget ]
				set createGL 0
			    }
			} else {
			    scan [$img -glbounds] "%f %f" minScale maxScale
			}
			
			#copy of the original image
			set orgImg $img
			toplevel .threshold -bg $color
			wm title .threshold "Thresholding"
			
			frame .threshold.h -bg $color
			frame .threshold.d -bg $color
			frame .threshold.b -bg $color
			
			set histo [ $img -histogram ]
			modules::drawHistogramInFrame .threshold.h $histo $color
			set maxSample [$histo -stat maxNbSamples]
			pack .threshold.h 
			
			frame .threshold.d.th -bg $color
			if {$createGL} {
			    label .threshold.d.th.l1 -bg $color -text "Low threshold value" -anchor w
			    inrimage::inrscale .threshold.d.th.min $img $color min
			    label .threshold.d.th.l2 -bg $color -text "High threshold value" -anchor w 
			    inrimage::inrscale .threshold.d.th.max $img $color max
			    set minScale .threshold.d.th.min
			    set maxScale .threshold.d.th.max
			}
			
			set minLine [.threshold.h.g marker create line -coords "0 0 0 $maxSample" -outline "#FF0000"]
			bind $minScale <Enter> "focus $minScale"
			bind $minScale <Motion> ".threshold.h.g marker configure $minLine -coords \"\[ $minScale get \] 0 \[ $minScale get \] $maxSample\""
			
			
			set maxLine [.threshold.h.g marker create line -coords "[ $maxScale get ] 0 [ $maxScale get ] $maxSample" -outline "#00FF00" ]
			bind $maxScale <Enter> "focus $maxScale"
			bind $maxScale <Motion> ".threshold.h.g marker configure $maxLine -coords \"\[ $maxScale get \] 0 \[ $maxScale get \] $maxSample\""
			
			frame .threshold.d.fbg -bg $color
			label .threshold.d.fbg.l1 -bg $color -text "Thresholded image background value" -anchor w
			inrimage::inrscale .threshold.d.fbg.bg $img $color min
			radiobutton .threshold.d.fbg.crop -text "Keep voxels in \[min; max\]" -variable inrimage::cmd -value crop -bg $color -anchor w  -command ".threshold.d.fbg.fg configure -state disabled"
			radiobutton .threshold.d.fbg.nocrop -text "Set voxels in \[min; max\] to foreground" -variable inrimage::cmd -value nocrop -bg $color -anchor w  -command ".threshold.d.fbg.fg configure -state normal"
			label .threshold.d.fbg.l2 -bg $color -text "thresholded image foreground value" -anchor w
			inrimage::inrscale .threshold.d.fbg.fg $img $color max
			set inrimage::cmd nocrop
			
			frame .threshold.d.out -bg $color
			label .threshold.d.out.l1 -bg $color -text "Output of thresholding" -anchor w
			radiobutton .threshold.d.out.new -text "Put in new image" -variable inrimage::thout -value copy -bg $color -anchor w 
			radiobutton .threshold.d.out.repl -text "Replace image" -variable inrimage::thout -value repl -bg $color -anchor w 
			radiobutton .threshold.d.out.roi -text "Create ROI" -variable inrimage::thout -value roi -bg $color -anchor w 
			set inrimage::thout copy
			
			button .threshold.b.ok -text "OK" -bg $color -command "if \[string compare \$inrimage::thout repl\] {set img \[ evaluate \"$img -copy\" \] };  if !\[string compare \$inrimage::cmd crop \] { evaluate \"\$img -cropHistogramm min \[$minScale get\] max \[$maxScale get\] bg \[.threshold.d.fbg.bg get\] \" } else { evaluate \"\$img -threshold min \[$minScale get\] max \[$maxScale get\] bg \[.threshold.d.fbg.bg get\] fg \[.threshold.d.fbg.fg get\] \" }; if !\[string compare \$inrimage::thout copy\] { evaluate \"view \$img\" }; if !\[string compare \$inrimage::thout roi\] {evaluate \" new roi $orgImg \$img  \[inrimage::getScene2DFromMultiview $mview\]; \$img -destroy \" };destroy .threshold; $histo -destroy; if {!$createGL} { bind $minScale <Motion> \"\";bind $maxScale <Motion> \"\" }; $mview -colormap affine" 
			
			button .threshold.b.dismiss -text "Dismiss" -command "destroy .threshold;if {!$createGL} { bind $minScale <Motion> \"\";bind $maxScale <Motion> \"\";$mview -colormap affine }	" -bg $color
			
			pack .threshold.d.out.l1 .threshold.d.out.new .threshold.d.out.repl .threshold.d.out.roi -fill x
			if {$createGL} {
			    pack .threshold.d.th.l1 $minScale .threshold.d.th.l2 $maxScale -fill x
			} 
			
			pack .threshold.d.fbg.l1 .threshold.d.fbg.bg .threshold.d.fbg.crop .threshold.d.fbg.nocrop .threshold.d.fbg.l2 .threshold.d.fbg.fg -fill x
			
			pack .threshold.d.th .threshold.d.fbg .threshold.d.out -side left -fill both -pady 10 -padx 10
			
			
			pack .threshold.b.ok .threshold.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .threshold.d .threshold.b
		    }
		}
		
		
		
		
		proc inrimage::XYZFrame { fname title color X Y Z {valX 0} {valY 0} {valZ 0}} {
		    frame $fname -bg $color
		    
		    label $fname.l -text $title -relief raised -bg $color
		    pack $fname.l -fill x
		    scale $fname.x -from 0 -to $X -orient horiz -bg $color
		    $fname.x set $valX
		    bind $fname.x <Enter> "focus $fname.x"
		    scale $fname.y -from 0 -to $Y -orient horiz -bg $color
		    $fname.y set $valY
		    bind $fname.y <Enter> "focus $fname.y"
		    scale $fname.z -from 0 -to $Z -orient horiz -bg $color
		    $fname.z set $valZ
		    bind $fname.z <Enter> "focus $fname.z"
		    
		    pack $fname.l $fname.x $fname.y $fname.z  -fill x
		}
		
		
		
		proc inrimage::melBounds { img } {
		    scan [$img -size] "%u %u %u" x y z
		    .mel.d.in.x configure -to $x
		    .mel.d.in.y configure -to $y
		    .mel.d.in.z configure -to $z
		    .mel.d.size.x configure -to $x
		    .mel.d.size.y configure -to $y
		    .mel.d.size.z configure -to $z
		}
		
		
		proc inrimage::melDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .mel] {
			toplevel .mel -bg $color
			wm title .mel "Mel images"
			
			frame .mel.d -bg $color
			frame .mel.b -bg $color
			
			scan [$img -size] "%u %u %u" xout yout zout
			set xout [ expr $xout -1 ]  
			set yout [ expr $yout -1 ]  
			set zout [ expr $zout -1 ]  
			inrimage::XYZFrame .mel.d.out "Mel in $img at:" $color $xout $yout $zout 
			inrimage::XYZFrame .mel.d.in "Mel from:" $color 10 10 10
			inrimage::XYZFrame .mel.d.size "Mel box size:" $color 10 10 10
			
			inrimage::inrOptionMenu .mel.d.in.menu "inrimage::melBounds ..." $color
			pack .mel.d.in.menu -fill x -pady 10
			
			button .mel.b.ok -text "OK" -command "evaluate \"$img -mel \$inrimage::mval ixo \[.mel.d.out.x get\] iyo \[.mel.d.out.y get\] izo \[.mel.d.out.z get\] ixi \[.mel.d.in.x get\] iyi \[.mel.d.in.y get\] izi \[.mel.d.in.z get\] idx \[.mel.d.size.x get\] idy \[.mel.d.size.y get\] idz \[.mel.d.size.z get\]; destroy .mel\"" -bg $color
			button .mel.b.dismiss -text "Dismiss" -command "destroy .mel" -bg $color
			
			pack .mel.d.out .mel.d.in .mel.d.size -side left -fill both -pady 10 -padx 10
			
			pack .mel.b.ok .mel.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .mel.d .mel.b
		    }
		}
		proc inrimage::cropDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .crop] {
			toplevel .crop -bg $color
			wm title .crop "Crop Image"
			
			frame .crop.d -bg $color
			frame .crop.b -bg $color
			
			scan [$img -size] "%u %u %u" xout yout zout
			set xout [ expr $xout -1 ]  
			set yout [ expr $yout -1 ]  
			set zout [ expr $zout -1 ]  
			inrimage::XYZFrame .crop.d.first "First corner voxel" $color $xout $yout $zout 0 0 0 
			inrimage::XYZFrame .crop.d.second "Second corner voxel" $color $xout $yout $zout  $xout $yout $zout 
			
			button .crop.b.ok -text "OK" -command "evaluate \"$img -crop org  \[.crop.d.first.x get\]  \[.crop.d.first.y get\] \[.crop.d.first.z get\] end \[.crop.d.second.x get\] \[.crop.d.second.y get\]  \[.crop.d.second.z get\]; destroy .crop\"" -bg $color
			button .crop.b.dismiss -text "Dismiss" -command "destroy .crop" -bg $color
			
			pack .crop.d.first .crop.d.second -side left -fill both -pady 10 -padx 10
			
			pack .crop.b.ok .crop.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .crop.d .crop.b
		    }
		}
		
		proc inrimage::anisoDiffDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .anisoDiff] {
			toplevel .anisoDiff -bg $color
			wm title .anisoDiff "Anisotropic Diffusion"
			
			frame .anisoDiff.df -bg $color
			frame .anisoDiff.time -bg $color
			frame .anisoDiff.smooth -bg $color
			frame .anisoDiff.b -bg $color
			
			inrimage::choiceFrame .anisoDiff.df.choice "Diffusion function" inrimage::df $color {"Aubert" aubert} {"Perona and Malik (enhance)" perona} {"Weickert (enhance)" weickert} {"Perona and Malik 2" perona_2}   {"Perona and Malik 3" perona_3} {"Green" green}       
			scale .anisoDiff.df.quant -from 0 -to 100 -length 100 -resolution 1 -bg $color -variable inrimage::quant -orient horizontal -label "Quantile on gradient histogramm"
			
			
			scale .anisoDiff.time.step -from 0 -to 2 -length 300 -resolution 0.01 -bg $color -variable inrimage::dt -orient horizontal -label "Time Step"
			scale .anisoDiff.time.total -from 0 -to 10 -length 300 -resolution 0.1 -bg $color -variable inrimage::tmax -orient horizontal -label "Diffusion Time"
			inrimage::choiceFrame .anisoDiff.time.disk "Write on Disk temporary images ? (save memory)" inrimage::disk $color {"Yes" true} {"No" false}
			
			inrimage::choiceFrame .anisoDiff.smooth.choice "Gaussian Smoothing to compute diffusivity ?" inrimage::smooth $color {"Yes" true} {"No" false}
			scale .anisoDiff.smooth.sigma -from 0 -to 5 -length 300 -resolution 0.1 -bg $color -variable inrimage::sigma -orient horizontal -label "Standard deviation of Gaussian Smoothing"
			
			
			button .anisoDiff.b.ok -text "OK" -command "set cmd \"$img -anisotropicDiffusion \$inrimage::dt \$inrimage::tmax \$inrimage::quant \$inrimage::smooth \$inrimage::sigma \$inrimage::df \$inrimage::disk \"; view \[evaluate \$cmd \]; destroy .anisoDiff" -bg $color
			button .anisoDiff.b.dismiss -text "Dismiss" -command "destroy .anisoDiff" -bg $color
			
			pack .anisoDiff.df.choice .anisoDiff.df.quant -padx 10 -pady 10 -fill x
			pack .anisoDiff.smooth.choice .anisoDiff.smooth.sigma -padx 10 -pady 10
			pack .anisoDiff.df -side left -fill x
			pack .anisoDiff.smooth -side right
			pack .anisoDiff.time.step  .anisoDiff.time.total .anisoDiff.time.disk -fill x -padx 10 -pady 10
			pack .anisoDiff.time
			pack .anisoDiff.b.ok .anisoDiff.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .anisoDiff.b
			
		    }
		}
		proc inrimage::anisoDiff4DDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .anisoDiff] {
			toplevel .anisoDiff -bg $color
			wm title .anisoDiff "Anisotropic Diffusion 4D"
			
			frame .anisoDiff.df -bg $color
			frame .anisoDiff.time -bg $color
			frame .anisoDiff.smooth -bg $color
			frame .anisoDiff.b -bg $color
			
			inrimage::choiceFrame .anisoDiff.df.choice "Diffusion function" inrimage::df $color {"Aubert" aubert} {"Perona and Malik (enhance)" perona}  {"Weickert (enhance)" weickert} {"Perona and Malik 2" perona_2} {"Perona and Malik 3" perona_3} {"Green" green} 
			scale .anisoDiff.df.quant -from 0 -to 100 -length 100 -resolution 1 -bg $color -variable inrimage::quant -orient horizontal -label "Quantile on gradient histogramm"
			scale .anisoDiff.time.step -from 0 -to 2 -length 100 -resolution 0.01 -bg $color -variable inrimage::dt -orient horizontal -label "Time Step"
			scale .anisoDiff.time.total -from 0 -to 10 -length 100 -resolution 0.1 -bg $color -variable inrimage::tmax -orient horizontal -label "Diffusion Time"
			inrimage::choiceFrame .anisoDiff.time.disk "Write on Disk temporary images ? (save memory)" inrimage::disk $color {"Yes" true} {"No" false}
			
			inrimage::choiceFrame .anisoDiff.smooth.choice "Gaussian Smoothing for diffusivity" inrimage::smooth $color {"Yes" true} {"No" false}
			scale .anisoDiff.smooth.sigma -from 0 -to 5 -length 200 -resolution 0.1 -bg $color -variable inrimage::sigma -orient horizontal -label "Smoothing standard deviation"
			
			button .anisoDiff.b.ok -text "OK" -command "inrimage::view4D \[evaluate \"$img -anisotropicDiffusion \$inrimage::dt \$inrimage::tmax \$inrimage::quant \$inrimage::smooth \$inrimage::sigma \$inrimage::df \$inrimage::disk \" \] ; destroy .anisoDiff" -bg $color
			button .anisoDiff.b.dismiss -text "Dismiss" -command "destroy .anisoDiff" -bg $color
			
			pack .anisoDiff.df.choice .anisoDiff.df.quant -padx 10 -pady 10 -fill x
			pack .anisoDiff.smooth.choice .anisoDiff.smooth.sigma -padx 10 -pady 10
			pack .anisoDiff.df -side left -fill x
			pack .anisoDiff.smooth -side right
			pack .anisoDiff.time.step  .anisoDiff.time.total .anisoDiff.time.disk -fill x -padx 10 -pady 10
			pack .anisoDiff.time
			pack .anisoDiff.b.ok .anisoDiff.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .anisoDiff.b
			
		    }
		}
		
		proc inrimage::anisoDiffScalDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .anisoDiffScal] {
			toplevel .anisoDiffScal -bg $color
			wm title .anisoDiffScal "Scalar Anisotropic Diffusion"
			
			frame .anisoDiffScal.t -bg $color
			frame .anisoDiffScal.t.df -bg $color
			frame .anisoDiffScal.t.quant -bg $color -width 60
			frame .anisoDiffScal.t.time -bg $color
			frame .anisoDiffScal.t.smooth -bg $color
			frame .anisoDiffScal.b -bg $color
			
			inrimage::choiceFrame .anisoDiffScal.t.df.choice "Diffusion function" inrimage::df $color {"Aubert" aubert} {"Perona and Malik (enhance)" perona} {"Weickert (enhance)" weickert} {"Green" green} {"Perona and Malik 2" perona_2} {"Perona and Malik 3" perona_3}
			radiobutton .anisoDiffScal.t.quant.choice -text "Quantile of the gradient"  -variable inrimage::thresh -value -1.0 -bg $color -anchor w -command  {.anisoDiffScal.t.quant.quantx configure -state normal; .anisoDiffScal.t.quant.quanty configure -state normal ; .anisoDiffScal.t.quant.quantz configure -state normal; .anisoDiffScal.t.quant.threshold configure -state disabled; set inrimage::threshold -1.0}
			scale .anisoDiffScal.t.quant.quantx -from 0 -to 100 -length 300 -resolution 1 -bg $color -variable inrimage::quantx -orient horizontal -label "Quantile on gradient histogramm in x direction"
			scale .anisoDiffScal.t.quant.quanty -from 0 -to 100 -length 300 -resolution 1 -bg $color -variable inrimage::quanty -orient horizontal -label "Quantile on gradient histogramm in y direction"
			scale .anisoDiffScal.t.quant.quantz -from 0 -to 100 -length 300 -resolution 1 -bg $color -variable inrimage::quantz -orient horizontal -label "Quantile on gradient histogramm in z direction"
			radiobutton .anisoDiffScal.t.quant.choice1 -text "Constant Threshold"   -variable inrimage::thresh -value 1.0 -bg $color -anchor w -command {.anisoDiffScal.t.quant.quantx configure -state disabled ; .anisoDiffScal.t.quant.quanty configure -state disabled ; .anisoDiffScal.t.quant.quantz configure -state disabled; .anisoDiffScal.t.quant.threshold configure -state normal ; set inrimage::threshold 5.0  } 
			scale .anisoDiffScal.t.quant.threshold -from -1 -to 300 -length 300 -resolution 1 -bg $color -variable inrimage::threshold -orient horizontal -label "Constant Threshold on the gradient"
			
			
			scale .anisoDiffScal.t.time.step -from 0 -to 2 -length 300 -resolution 0.01 -bg $color -variable inrimage::dt -orient horizontal -label "Time Step"
			scale .anisoDiffScal.t.time.total -from 0 -to 10 -length 300 -resolution 0.1 -bg $color -variable inrimage::tmax -orient horizontal -label "Diffusion Time"
			inrimage::choiceFrame .anisoDiffScal.t.time.scheme  "Numerical Scheme" inrimage::scheme $color {"AOS Scheme" aos} {"Explicit Scheme" explicite}
			inrimage::choiceFrame .anisoDiffScal.t.time.disk "Write on Disk temporary buffers ?" inrimage::disk $color {"Yes" true} {"No" false}
			
			inrimage::choiceFrame .anisoDiffScal.t.smooth.choice "Gaussian Smoothing for diffusivity" inrimage::smooth $color {"Yes" true} {"No" false}
			scale .anisoDiffScal.t.smooth.sigma -from 0 -to 5 -length 300 -resolution 0.1 -bg $color -variable inrimage::sigma -orient horizontal -label "Standard deviation"
			
			button .anisoDiffScal.b.ok -text "OK" -command "view \[evaluate \"$img -anisotropicDiffusion \$inrimage::dt \$inrimage::tmax \$inrimage::quantx \$inrimage::quanty \$inrimage::quantz \$inrimage::threshold \$inrimage::smooth \$inrimage::sigma \$inrimage::df \$inrimage::disk scalar \$inrimage::scheme \" \] " -bg $color
			button .anisoDiffScal.b.dismiss -text "Dismiss" -command "destroy .anisoDiffScal" -bg $color
			
			pack .anisoDiffScal.t.df.choice .anisoDiffScal.t.quant.choice -padx 10 -pady 10 -fill x	
			pack .anisoDiffScal.t.df.choice .anisoDiffScal.t.quant.quantx -padx 10 -pady 10 -fill x	
			pack .anisoDiffScal.t.df.choice .anisoDiffScal.t.quant.quanty -padx 10 -pady 10 -fill x
			pack .anisoDiffScal.t.df.choice .anisoDiffScal.t.quant.quantz -padx 10 -pady 10 -fill x	
			pack .anisoDiffScal.t.df.choice .anisoDiffScal.t.quant.choice1 -padx 10 -pady 10 -fill x	
			pack .anisoDiffScal.t.df.choice .anisoDiffScal.t.quant.threshold -padx 10 -pady 10 -fill x
			pack .anisoDiffScal.t.smooth.choice .anisoDiffScal.t.smooth.sigma -padx 10 -pady 10
			pack .anisoDiffScal.t.df -side left -fill x	
			pack .anisoDiffScal.t.quant -side left -fill x
			pack .anisoDiffScal.t.smooth -side right
			pack .anisoDiffScal.t.time.step  .anisoDiffScal.t.time.total .anisoDiffScal.t.time.scheme .anisoDiffScal.t.time.disk -fill x -padx 10 -pady 10
			pack .anisoDiffScal.t.time
			pack .anisoDiffScal.b.ok .anisoDiffScal.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .anisoDiffScal.t .anisoDiffScal.b -side top
			
		    }
		}
		proc inrimage::anisoDiffMatDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .anisoDiffMat] {
			toplevel .anisoDiffMat -bg $color
			wm title .anisoDiffMat "Matrix Anisotropic Diffusion"
			
			frame .anisoDiffMat.t -bg $color
			frame .anisoDiffMat.t.df -bg $color
			frame .anisoDiffMat.t.quant -bg $color -width 60
			frame .anisoDiffMat.t.time -bg $color
			frame .anisoDiffMat.t.smooth -bg $color
			frame .anisoDiffMat.b -bg $color
			
			inrimage::choiceFrame .anisoDiffMat.t.df.choice "Diffusion function" inrimage::df $color {"Aubert" aubert} {"Perona and Malik (enhance)" perona} {"Weickert (enhance)" weickert} {"Green" green} {"Perona and Malik 2" perona_2} {"Perona and Malik 3" perona_3}
			
			radiobutton .anisoDiffMat.t.quant.choice -text "Quantile of the gradient"  -variable inrimage::thresh -value -1.0 -bg $color -anchor w -command  {.anisoDiffMat.t.quant.quantx configure -state normal;; .anisoDiffMat.t.quant.threshold configure -state disabled; set inrimage::threshold -1.0}
			scale .anisoDiffMat.t.quant.quantx -from 0 -to 100 -length 500 -resolution 1 -bg $color -variable inrimage::quantx -orient horizontal -label "Quantile on gradient histogramm"
			
			radiobutton .anisoDiffMat.t.quant.choice1 -text "Constant Threshold"   -variable inrimage::thresh -value 1.0 -bg $color -anchor w -command {.anisoDiffMat.t.quant.quantx configure -state disabled ;  .anisoDiffMat.t.quant.threshold configure -state normal ; set inrimage::threshold 5.0  } 
			scale .anisoDiffMat.t.quant.threshold -from -1 -to 300 -length 500 -resolution 1 -bg $color -variable inrimage::threshold -orient horizontal -label "Constant Threshold: choose a positive value"
			
			
			scale .anisoDiffMat.t.time.step -from 0 -to 2 -length 300 -resolution 0.01 -bg $color -variable inrimage::dt -orient horizontal -label "Time Step"
			scale .anisoDiffMat.t.time.total -from 0 -to 10 -length 300 -resolution 0.1 -bg $color -variable inrimage::tmax -orient horizontal -label "Diffusion Time"
			
			
			inrimage::choiceFrame .anisoDiffMat.t.smooth.choice "Gaussian Smoothing to compute diffusivity ?" inrimage::smooth $color {"Yes" true} {"No" false}
			scale .anisoDiffMat.t.smooth.sigma -from 0 -to 5 -length 300 -resolution 0.1 -bg $color -variable inrimage::sigma -orient horizontal -label "Standard deviation of Gaussian Smoothing"
			
			
			
			
			button .anisoDiffMat.b.ok -text "OK" -command "set cmd \"$img -anisotropicDiffusion \$inrimage::dt\ \$inrimage::tmax\ \$inrimage::quantx\ \$inrimage::quantx\ \$inrimage::quantx\ \$inrimage::threshold \$inrimage::smooth\ \$inrimage::sigma\ \$inrimage::df\ false matrix explicite\"; view \[evaluate \$cmd \]; destroy .anisoDiff" -bg $color
			button .anisoDiffMat.b.dismiss -text "Dismiss" -command "destroy .anisoDiffMat" -bg $color
			
			pack .anisoDiffMat.t.df.choice .anisoDiffMat.t.quant.choice -padx 10 -pady 10 -fill x	
			pack .anisoDiffMat.t.df.choice .anisoDiffMat.t.quant.quantx -padx 10 -pady 10 -fill x		
			pack .anisoDiffMat.t.df.choice .anisoDiffMat.t.quant.choice1 -padx 10 -pady 10 -fill x	
			pack .anisoDiffMat.t.df.choice .anisoDiffMat.t.quant.threshold -padx 10 -pady 10 -fill x
			pack .anisoDiffMat.t.smooth.choice .anisoDiffMat.t.smooth.sigma -padx 10 -pady 10
			pack .anisoDiffMat.t.df -side left -fill x	
			pack .anisoDiffMat.t.quant -side left -fill x
			pack .anisoDiffMat.t.smooth -side right
			pack .anisoDiffMat.t.time.step  .anisoDiffMat.t.time.total  -fill x -padx 10 -pady 10
			pack .anisoDiffMat.t.time
			pack .anisoDiffMat.b.ok .anisoDiffMat.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .anisoDiffMat.t .anisoDiffMat.b -side top 
			
		    }
		}
		proc inrimage::anisoDiffVesselsDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .anisoDiffVessels] {
			toplevel .anisoDiffVessels -bg $color
			wm title .anisoDiffVessels "Vessels enhancing Anisotropic Diffusion (Karl Krissian algorithms)"
			
			frame .anisoDiffVessels.t -bg $color
			frame .anisoDiffVessels.t.df -bg $color
			frame .anisoDiffVessels.t.quant -bg $color -width 60
			frame .anisoDiffVessels.t.time -bg $color
			frame .anisoDiffVessels.t.smooth -bg $color
			frame .anisoDiffVessels.b -bg $color
			
			radiobutton .anisoDiffVessels.t.df.type1  -text "A first method using minimal and maximal curvature (only in 3D)" -relief raised  -variable inrimage::td -value krissian -bg $color -anchor w -command {.anisoDiffVessels.t.df.choice1 configure -state disabled; .anisoDiffVessels.t.df.choice2 configure -state disabled ; .anisoDiffVessels.t.df.choice3 configure -state disabled;.anisoDiffVessels.t.df.choice4 configure -state disabled ; .anisoDiffVessels.t.df.choice5 configure -state disabled}
			radiobutton .anisoDiffVessels.t.df.type2  -text "A second method using minimal and maximal curvature and principal directions (very long in 3D)" -relief raised  -variable inrimage::td -value matkrissian -bg $color -anchor w -command {.anisoDiffVessels.t.df.choice1 configure -state normal ;.anisoDiffVessels.t.df.choice2 configure -state normal ; .anisoDiffVessels.t.df.choice3 configure -state normal ; .anisoDiffVessels.t.df.choice4 configure -state normal ; .anisoDiffVessels.t.df.choice5 configure -state normal}
			radiobutton .anisoDiffVessels.t.df.choice1 -text "Diffusion function of Aubert" -variable inrimage::df -value aubert -bg $color -anchor w
			radiobutton .anisoDiffVessels.t.df.choice2 -text "Diffusion function of Perona and Malik (enhance)" -variable inrimage::df -value perona -bg $color -anchor w
			radiobutton .anisoDiffVessels.t.df.choice3 -text "Diffusion function of Weickert (enhance)" -variable inrimage::df -value weickert -bg $color -anchor w
			radiobutton .anisoDiffVessels.t.df.choice4 -text "Diffusion function of Green" -variable inrimage::df -value green -bg $color -anchor w
			radiobutton .anisoDiffVessels.t.df.choice5 -text "Diffusion function of Perona and Malik 2 (no enhance)" -variable inrimage::df -value perona_2 -bg $color -anchor w
			radiobutton .anisoDiffVessels.t.df.choice5 -text "Diffusion function of Perona and Malik 3 (no enhance)" -variable inrimage::df -value perona_3 -bg $color -anchor w	
			
			radiobutton .anisoDiffVessels.t.quant.choice -text "Quantile of the gradient"  -variable inrimage::thresh -value -1.0 -bg $color -anchor w -command  {.anisoDiffVessels.t.quant.quantx configure -state normal;; .anisoDiffVessels.t.quant.threshold configure -state disabled; set inrimage::threshold -1.0}
			scale .anisoDiffVessels.t.quant.quantx -from 0 -to 100 -length 500 -resolution 1 -bg $color -variable inrimage::quantx -orient horizontal -label "Quantile on gradient histogramm"
			
			radiobutton .anisoDiffVessels.t.quant.choice1 -text "Constant Threshold"   -variable inrimage::thresh -value 1.0 -bg $color -anchor w -command {.anisoDiffVessels.t.quant.quantx configure -state disabled ;  .anisoDiffVessels.t.quant.threshold configure -state normal ; set inrimage::threshold 5.0  } 
			scale .anisoDiffVessels.t.quant.threshold -from -1 -to 300 -length 500 -resolution 1 -bg $color -variable inrimage::threshold -orient horizontal -label "Constant Threshold: choose a positive value"
			
			
			scale .anisoDiffVessels.t.time.step -from 0 -to 2 -length 300 -resolution 0.01 -bg $color -variable inrimage::dt -orient horizontal -label "Time Step"
			scale .anisoDiffVessels.t.time.total -from 0 -to 10 -length 300 -resolution 0.1 -bg $color -variable inrimage::tmax -orient horizontal -label "Diffusion Time"
			
			
			inrimage::choiceFrame .anisoDiffVessels.t.smooth.choice "Gaussian Smoothing to compute diffusivity ?" inrimage::smooth $color {"Yes" true} {"No" false}
			scale .anisoDiffVessels.t.smooth.sigma -from 0 -to 5 -length 300 -resolution 0.1 -bg $color -variable inrimage::sigma -orient horizontal -label "Standard deviation of Gaussian Smoothing"
			
			
			
			
			button .anisoDiffVessels.b.ok -text "OK" -command "set cmd \"$img -anisotropicDiffusion \$inrimage::dt\ \$inrimage::tmax\ \$inrimage::quantx\ \$inrimage::quantx\ \$inrimage::quantx\ \$inrimage::threshold \$inrimage::smooth\ \$inrimage::sigma\ \$inrimage::df\ false matrix explicite\"; view \[evaluate \$cmd \]; destroy .anisoDiff" -bg $color
			button .anisoDiffVessels.b.dismiss -text "Dismiss" -command "destroy .anisoDiffVessels" -bg $color
			
			pack .anisoDiffVessels.t.df.type1 .anisoDiffVessels.t.df.type2 .anisoDiffVessels.t.df.choice1 .anisoDiffVessels.t.df.choice2 .anisoDiffVessels.t.df.choice3  .anisoDiffVessels.t.df.choice4 .anisoDiffVessels.t.df.choice5 -padx 10 -pady 10 -fill x
			pack .anisoDiffVessels.t.df.choice5 .anisoDiffVessels.t.quant.choice -padx 10 -pady 10 -fill x	
			pack .anisoDiffVessels.t.df.choice5 .anisoDiffVessels.t.quant.quantx -padx 10 -pady 10 -fill x		
			pack .anisoDiffVessels.t.df.choice5 .anisoDiffVessels.t.quant.choice1 -padx 10 -pady 10 -fill x	
			pack .anisoDiffVessels.t.df.choice5 .anisoDiffVessels.t.quant.threshold -padx 10 -pady 10 -fill x
			pack .anisoDiffVessels.t.smooth.choice .anisoDiffVessels.t.smooth.sigma -padx 10 -pady 10
			pack .anisoDiffVessels.t.df -side left -fill x	
			pack .anisoDiffVessels.t.quant -side left -fill x
			pack .anisoDiffVessels.t.smooth -side right
			pack .anisoDiffVessels.t.time.step  .anisoDiffVessels.t.time.total  -fill x -padx 10 -pady 10
			pack .anisoDiffVessels.t.time
			pack .anisoDiffVessels.b.ok .anisoDiffVessels.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .anisoDiffVessels.t .anisoDiffVessels.b -side top 
			
		    }
		}
		
		proc inrimage::chamferDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .chamfer] {
			toplevel .chamfer -borderwidth 10 -relief groove -bg $color
			wm title .chamfer "Chamfer Map"
			
			frame .chamfer.myOpt -bg $color
			frame .chamfer.myBut -bg $color
			
			frame .chamfer.myOpt.maskOpt  -borderwidth 4 -bg $color
			frame .chamfer.myOpt.location -borderwidth 4 -bg $color
			frame .chamfer.myOpt.exactMap -borderwidth 4 -bg $color
			
			
			# Mask Options
			label .chamfer.myOpt.maskOpt.label -text "Mask Options" -relief raised -bg $color
			frame .chamfer.myOpt.maskOpt.maskDim
			frame .chamfer.myOpt.maskOpt.maskSiz
			label .chamfer.myOpt.maskOpt.maskDim.label -text "Mask dimension" -bg $color
			radiobutton .chamfer.myOpt.maskOpt.maskDim.2D -text "2D" -variable inrimage::dim -value "2D" -bg $color
			radiobutton .chamfer.myOpt.maskOpt.maskDim.3D -text "3D" -variable inrimage::dim -value "3D" -bg $color
			set inrimage::dim 3D
			pack  .chamfer.myOpt.maskOpt.maskDim.label -side top
			pack  .chamfer.myOpt.maskOpt.maskDim.2D .chamfer.myOpt.maskOpt.maskDim.3D -side left
			
			label .chamfer.myOpt.maskOpt.maskSiz.label -text "Mask size" -bg $color
			radiobutton .chamfer.myOpt.maskOpt.maskSiz.333 -text "3x3(x3)" -variable inrimage::size -value "3" -bg $color
			radiobutton .chamfer.myOpt.maskOpt.maskSiz.555 -text "5x5(x5)" -variable inrimage::size -value "5" -bg $color
			radiobutton .chamfer.myOpt.maskOpt.maskSiz.777 -text "7x7(x7)" -variable inrimage::size -value "7" -bg $color
			set inrimage::size 3
			pack .chamfer.myOpt.maskOpt.maskSiz.label .chamfer.myOpt.maskOpt.maskSiz.333 .chamfer.myOpt.maskOpt.maskSiz.555 .chamfer.myOpt.maskOpt.maskSiz.777
			
			pack .chamfer.myOpt.maskOpt.label .chamfer.myOpt.maskOpt.maskDim .chamfer.myOpt.maskOpt.maskSiz -side top
			
			
			# Map location
			label .chamfer.myOpt.location.label -text "Map Location" -relief raised -bg $color
			radiobutton .chamfer.myOpt.location.for -text "Foreground" -variable inrimage::location -value "1" -bg $color
			radiobutton .chamfer.myOpt.location.bac -text "Background" -variable inrimage::location -value "0" -bg $color
			radiobutton .chamfer.myOpt.location.bot -text "Both foreground and background" -variable inrimage::location -value "2" -bg $color
			set inrimage::location 1
			pack .chamfer.myOpt.location.label .chamfer.myOpt.location.for .chamfer.myOpt.location.bac .chamfer.myOpt.location.bot
			
			
			# Exact Map
			label .chamfer.myOpt.exactMap.label -text "Compute exact map" -relief raised -bg $color
			checkbutton .chamfer.myOpt.exactMap.cb -text "Exact Map" -variable inrimage::exactMap -onvalue "1" -offvalue "0" -bg $color
			radiobutton .chamfer.myOpt.exactMap.colorprop -text "Color Propagation"    -variable inrimage::propagation -value "1" -bg $color
			radiobutton .chamfer.myOpt.exactMap.posprop   -text "Position Propagation" -variable inrimage::propagation -value "2" -bg $color
			set inrimage::exactMap 0
			set inrimage::propagation 0
			pack .chamfer.myOpt.exactMap.label .chamfer.myOpt.exactMap.cb .chamfer.myOpt.exactMap.colorprop .chamfer.myOpt.exactMap.posprop
			
			pack .chamfer.myOpt.maskOpt .chamfer.myOpt.location .chamfer.myOpt.exactMap -side left
			
			
			frame .chamfer.myBut.ok -borderwidth 2 -relief sunken
			button .chamfer.myBut.ok.b      -text "OK" \
			  -command "set cmd \"$img -chamfer \$inrimage::dim size \$inrimage::size location \$inrimage::location exactmap \$inrimage::exactMap propagate \$inrimage::propagation\"; foreach i \[evaluate \$cmd\] { view \$i }; destroy .chamfer" -bg $color
			pack .chamfer.myBut.ok.b -padx 5 -pady 5
			button .chamfer.myBut.cancel -text "Cancel" \
			  -command "destroy .chamfer" -bg $color
			pack .chamfer.myBut.ok .chamfer.myBut.cancel -side left -expand true -fill x -padx 20 -pady 10
			
			
			pack .chamfer.myOpt .chamfer.myBut -side top
			
			
		    }
		    
		}
		
		
		proc inrimage::connexeDialog { img {color "#E8E0D2"}} {
		    if ![winfo exists .connexe] {
			toplevel .connexe -bg $color
			wm title .connexe "Connexe components"
			
			frame .connexe.d -bg $color
			frame .connexe.b -bg $color
			
			inrimage::choiceFrame .connexe.d.con "connexity" inrimage::con $color {"4 (2D edge)" 4} {"8 (2D vertex)" 8} {"6 (3D face)" 6} {"18 (3D edge)" 18} {"26 (3D vertex)" 26} 
			set inrimage::con 26
			
			frame .connexe.d.op -bg $color
			label  .connexe.d.op.l3 -text "Image thresholding" -relief raised -bg $color
			label .connexe.d.op.l1 -text "low threshold" -bg $color -anchor w
			inrimage::inrscale .connexe.d.op.s1 $img $color min
			label .connexe.d.op.l11 -text "high threshold" -bg $color -anchor w
			inrimage::inrscale .connexe.d.op.s11 $img $color max
			
			checkbutton .connexe.d.op.b3 -text "Hysteresis thresholding" -variable inrimage::oper -onvalue 1 -offvalue 0  -bg $color -anchor w  -command { if {$inrimage::oper == 1} {.connexe.d.op.s2 configure -state normal; } else {.connexe.d.op.s2 configure -state disabled; }}
			label .connexe.d.op.l2 -text "Keep only high threshold CC larger than:" -bg $color -anchor w
			scale .connexe.d.op.s2 -from 1 -to 10000 -length 200 -orient horiz -bg $color -state disabled
			.connexe.d.op.s2 configure -state disabled
			set inrimage::oper 0
			
			frame .connexe.d.cc -bg $color
			label  .connexe.d.cc.l1 -text "Connexe component" -relief raised -bg $color
			checkbutton .connexe.d.cc.b1 -text "Keep only CC larger than:" -variable inrimage::tcc -onvalue 1 -offvalue 0  -bg $color -anchor w -command { if { $inrimage::tcc == 1 } { .connexe.d.cc.s1 configure -state normal } else { .connexe.d.cc.s1 configure -state disabled } } 
			set inrimage::tcc 0
			scale .connexe.d.cc.s1 -from 1 -to 10000 -length 200 -orient horiz -bg $color -state disabled
			bind .connexe.d.cc.s1 <Enter> {focus .connexe.d.cc.s1}
			radiobutton .connexe.d.cc.b2 -text "Any number of CC" -variable inrimage::ncc -value all -bg $color -anchor w  -command { .connexe.d.cc.s2 configure -state disabled }
			radiobutton .connexe.d.cc.b3 -text "Given number of CC" -variable inrimage::ncc -value given -bg $color -anchor w  -command { .connexe.d.cc.s2 configure -state normal }
			scale .connexe.d.cc.s2 -from 1 -to 200 -length 200 -orient horiz -bg $color -state disabled
			radiobutton .connexe.d.cc.b4 -text "Only maximal CC" -variable inrimage::ncc -value max -bg $color -anchor w  -command { .connexe.d.cc.s2 configure -state disabled }
			set inrimage::ncc all
			
			frame .connexe.d.out -bg $color
			label  .connexe.d.out.l1 -text "Output image" -relief raised -bg $color
			radiobutton .connexe.d.out.b1 -text "binary" -variable inrimage::output -value binary  -bg $color -anchor w
			radiobutton .connexe.d.out.b2 -text "one grey level per CC" -variable inrimage::output -value label  -bg $color -anchor w
			set inrimage::output binary
			
			label .connexe.d.out.l11 -text "background" -bg $color -anchor w
			inrimage::inrscale .connexe.d.out.s1 $img $color min
			label .connexe.d.out.l2 -text "foreground" -bg $color -anchor w
			inrimage::inrscale .connexe.d.out.s2 $img $color max
			
			
			button .connexe.b.ok -text "OK" -command "set cmd \"$img -connexe con \$inrimage::con \"; set th \"lt \[.connexe.d.op.s1 get\] \"; set th \[ concat \$th \"ht \[.connexe.d.op.s11 get\] \"\]; set cmd \[concat \$cmd \$th\]; if \$inrimage::tcc { set cmd \[concat \$cmd \"tcc \[.connexe.d.cc.s1 get\]\"\]};if !\[string compare \$inrimage::ncc max\] { set cmd \[concat \$cmd max\]} elseif !\[string compare \$inrimage::ncc given\] { set cmd \[concat \$cmd \"ncc \[.connexe.d.cc.s2 get\]\"\]};set cmd \[concat \$cmd \"output \$inrimage::output\"\]; if {\$inrimage::oper == 1} { set cmd \[ concat \$cmd \"hyster tcc_ht \[.connexe.d.op.s2 get\]\"\]};  evaluate \$cmd; destroy .connexe" -bg $color
			button .connexe.b.dismiss -text "Dismiss" -command "destroy .connexe" -bg $color
			
			pack .connexe.d.op.l3 .connexe.d.op.l1 .connexe.d.op.s1 .connexe.d.op.b3 .connexe.d.op.l11 .connexe.d.op.s11 .connexe.d.op.l2 .connexe.d.op.s2 -fill x
			pack .connexe.d.cc.l1 .connexe.d.cc.b1 .connexe.d.cc.s1 .connexe.d.cc.b2 .connexe.d.cc.b3 .connexe.d.cc.s2 .connexe.d.cc.b4 -fill x
			pack .connexe.d.out.l1 .connexe.d.out.b1 .connexe.d.out.b2 .connexe.d.out.l11 .connexe.d.out.s1 .connexe.d.out.l2 .connexe.d.out.s2 -fill x
			pack .connexe.d.con .connexe.d.op .connexe.d.cc .connexe.d.out -side left -fill both -padx 10 -pady 10
			
			pack .connexe.b.ok .connexe.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .connexe.d .connexe.b
		    }
		}
		
		proc inrimage::gradientDialog { img {color "#E8E0D2"}} {
		    
		    if ![winfo exists .gradient] {
			toplevel .gradient -bg $color
			wm title .gradient "Gradient computation"
			
			frame .gradient.d -bg $color
			frame .gradient.b -bg $color
			
			frame .gradient.d.rec -bg $color
			radiobutton .gradient.d.rec.b1 -text "Recursive filters" -relief raised -variable inrimage::filter -value rec  -bg $color -anchor w -command { .gradient.d.rec.b2 configure -state normal; .gradient.d.rec.b3 configure -state normal; .gradient.d.rec.b4 configure -state normal; .gradient.d.rec.s1 configure -state normal; .gradient.d.sobel.s1 configure -state disabled }
			radiobutton .gradient.d.rec.b2 -text "Deriche step-edge" -variable inrimage::rfilter -value deriche  -bg $color -anchor w
			radiobutton .gradient.d.rec.b3 -text "Deriche gaussian" -variable inrimage::rfilter -value gaussian  -bg $color -anchor w
			radiobutton .gradient.d.rec.b4 -text "Marta" -variable inrimage::rfilter -value marta  -bg $color -anchor w
			set inrimage::rfilter deriche
			label .gradient.d.rec.l1 -text "Filter standard deviation" -bg $color -anchor w
			scale .gradient.d.rec.s1 -from 0.1 -to 20 -resolution 0.1 -orient horiz -bg $color
			.gradient.d.rec.s1 set 3
			bind .gradient.d.rec.s1 <Enter> { focus .gradient.d.rec.s1 }
			
			frame .gradient.d.sobel -bg $color
			radiobutton .gradient.d.sobel.b1 -text "Sobel filters" -relief raised -variable inrimage::filter -value sobel  -bg $color -anchor w -command { .gradient.d.rec.b2 configure -state disabled; .gradient.d.rec.b3 configure -state disabled; .gradient.d.rec.b4 configure -state disabled; .gradient.d.rec.s1 configure -state disabled; .gradient.d.sobel.s1 configure -state normal }
			label .gradient.d.sobel.l1 -text "Filter size" -bg $color -anchor w
			scale .gradient.d.sobel.s1 -from 3 -to 15 -orient horiz -bg $color -state disabled
			bind .gradient.d.sobel.s1 <Enter> { focus .gradient.d.sobel.s1 }
			
			set inrimage::filter rec
			
			frame .gradient.d.opt -bg $color
			label .gradient.d.opt.l1 -text "Options" -relief raised -bg $color
			radiobutton .gradient.d.opt.b1 -text "3D" -variable inrimage::dim -value "3D"  -bg $color -anchor w
			radiobutton .gradient.d.opt.b2 -text "2D" -variable inrimage::dim -value "2D"  -bg $color -anchor w
			set inrimage::dim 3D
			checkbutton .gradient.d.opt.b3 -text "Max gradient value along gradient direction" -variable max -onvalue max -offvalue ""  -bg $color -anchor w
			set max ""
			radiobutton .gradient.d.opt.b4 -text "Compute norm only" -variable inrimage::output -value ""  -bg $color -anchor w
			radiobutton .gradient.d.opt.b5 -text "Return gradient vectors" -variable inrimage::output -value "dir vectors"  -bg $color -anchor w
			radiobutton .gradient.d.opt.b6 -text "Sample gradient vectors" -variable inrimage::output -value "dir sample"  -bg $color -anchor w
			set inrimage::output ""
			checkbutton .gradient.d.opt.b7 -text "Low threshold" -variable lt -onvalue 1 -offvalue 0  -bg $color -anchor w -command { if $lt { .gradient.d.opt.s1 configure -state normal } else { .gradient.d.opt.s1 configure -state disabled } }
			inrimage::inrscale .gradient.d.opt.s1 $img $color min
			.gradient.d.opt.s1 configure -state disabled
			
			button .gradient.b.ok -text "OK" -command "set cmd \"$img -gradient \$inrimage::dim \$inrimage::output \$max \$inrimage::filter \"; if !\[string compare \$inrimage::filter rec\] { set cmd \[concat \$cmd \"\$inrimage::rfilter sigma \[.gradient.d.rec.s1 get\] \"\] } else { set cmd \[concat \$cmd \"sigma \[.gradient.d.sobel.s1 get\] \"\] }; if \$lt { set cmd \[concat \$cmd \"lt \[.gradient.d.opt.s1 get\]\"\]}; foreach i \[evaluate \$cmd\] { view \$i }; destroy .gradient" -bg $color
			button .gradient.b.dismiss -text "Dismiss" -command "destroy .gradient" -bg $color
			
			pack .gradient.d.rec.b1 .gradient.d.rec.b2 .gradient.d.rec.b3 .gradient.d.rec.b4 .gradient.d.rec.l1 .gradient.d.rec.s1 -fill x
			pack .gradient.d.sobel.b1 .gradient.d.sobel.l1 .gradient.d.sobel.s1 -fill x
			pack .gradient.d.opt.l1 .gradient.d.opt.b1 .gradient.d.opt.b2 -fill x
			pack .gradient.d.opt.b3 -fill x -pady 10
			pack .gradient.d.opt.b4 .gradient.d.opt.b5 .gradient.d.opt.b6 -fill x
			pack .gradient.d.opt.b7 -fill x -pady 10
			pack .gradient.d.opt.s1 -fill x
			pack .gradient.d.rec .gradient.d.sobel .gradient.d.opt -side left -fill both -padx 10 -pady 10
			
			pack .gradient.b.ok .gradient.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .gradient.d .gradient.b
		    }
		}
		
		
		proc inrimage::laplacianDialog { img {color "#E8E0D2"}} {
		    
		    if ![winfo exists .laplacian] {
			toplevel .laplacian -bg $color
			wm title .laplacian "Laplacian computation"
			
			frame .laplacian.d -bg $color
			frame .laplacian.b -bg $color
			
			label .laplacian.d.l1 -text "Recursive filters" -relief raised -bg $color
			radiobutton .laplacian.d.b1 -text "Deriche step-edge" -variable inrimage::rfilter -value deriche  -bg $color -anchor w
			radiobutton .laplacian.d.b2 -text "Deriche gaussian" -variable inrimage::rfilter -value gaussian  -bg $color -anchor w
			radiobutton .laplacian.d.b3 -text "Marta" -variable inrimage::rfilter -value marta  -bg $color -anchor w
			set inrimage::rfilter deriche
			label .laplacian.d.l2 -text "Filter standard deviation" -bg $color -anchor w
			scale .laplacian.d.s1 -from 0.1 -to 20 -resolution 0.1 -orient horiz -bg $color
			.laplacian.d.s1 set 3
			bind .laplacian.d.s1 <Enter> { focus .laplacian.d.s1 }
			
			button .laplacian.b.ok -text "OK" -command "evaluate \"$img -laplacian \$inrimage::rfilter sigma \[.laplacian.d.s1 get\]\"; destroy .laplacian" -bg $color
			button .laplacian.b.dismiss -text "Dismiss" -command "destroy .laplacian" -bg $color
			
			pack .laplacian.d.l1 .laplacian.d.b1 .laplacian.d.b2 .laplacian.d.b3 .laplacian.d.l2 .laplacian.d.s1 -fill x
			
			pack .laplacian.b.ok .laplacian.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .laplacian.d .laplacian.b -pady 10
		    }
		}
		
		
		proc inrimage::convoluteDialog { img {color "#E8E0D2"}} {
		    
		    if ![winfo exists .convolution] {
			toplevel .convolution -bg $color
			wm title .convolution "Filter convolution"
			
			frame .convolution.d -bg $color
			frame .convolution.b -bg $color
			
			inrimage::choiceFrame .convolution.d.filter "Filter type" inrimage::filter $color {"gaussian (2D)" "gauss 2D"} {"gaussian (3D)" "gauss 3D"} {"X smoothing" smoothX} {"Y smoothing" smoothY} {"Z smoothing" smoothZ} {"X first derivative" derX} {"Y first derivative" derY} {"Z first derivative" derZ} {"X second derivative" der2X} {"Y second derivative" der2Y} {"Z second derivative" der2Z} 
			set inrimage::filter "gauss 3D"
			
			frame .convolution.d.sigma -bg $color
			label .convolution.d.sigma.l1 -text "Filter half size" -relief raised -bg $color
			scale .convolution.d.sigma.s1 -from 1 -to 15 -orient horiz -bg $color
			bind .convolution.d.sigma.s1 <Enter> { focus .convolution.d.sigma.s1 }
			
			button .convolution.b.ok -text "OK" -command "evaluate \"$img -convolute filterSize \[.convolution.d.sigma.s1 get\] \$inrimage::filter\"; destroy .convolution" -bg $color
			button .convolution.b.dismiss -text "Dismiss" -command "destroy .convolution" -bg $color
			
			pack .convolution.d.sigma.l1 .convolution.d.sigma.s1 -fill x
			pack .convolution.d.filter .convolution.d.sigma -side left -fill both -padx 10 -pady 10
			pack .convolution.b.ok .convolution.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .convolution.d .convolution.b
		    }
		}
		
		
		proc inrimage::recursiveFilterDialog { img {color "#E8E0D2"}} {
		    
		    if ![winfo exists .recfilter] {
			toplevel .recfilter -bg $color
			wm title .recfilter "Recursive filtering"
			
			frame .recfilter.d -bg $color
			frame .recfilter.b -bg $color
			
			frame .recfilter.d.sigma -bg $color
			
			inrimage::choiceFrame .recfilter.d.rfilter "Recursive filter" inrimage::rfilter $color {"Deriche step-edge" deriche} {"Deriche gaussian" gaussian} {"Marta" marta}
			label .recfilter.d.rfilter.l2 -text "Filter standard deviation" -bg $color
			scale .recfilter.d.rfilter.s1 -from 0.1 -to 20.0 -resolution 0.1 -orient horiz -bg $color
			.recfilter.d.rfilter.s1 set 3.0
			bind .recfilter.d.rfilter.s1 <Enter> { focus .recfilter.d.rfilter.s1 }
			pack .recfilter.d.rfilter.l2 .recfilter.d.rfilter.s1 -fill x
			set inrimage::rfilter deriche
			
			inrimage::choiceFrame .recfilter.d.filter "Filter type" inrimage::filter $color {"gaussian (2D)" "gauss 2D"} {"gaussian (3D)" "gauss 3D"} {"X smoothing" smoothX} {"Y smoothing" smoothY} {"Z smoothing" smoothZ} {"X first derivative" derX} {"Y first derivative" derY} {"Z first derivative" derZ} {"X second derivative" der2X} {"Y second derivative" der2Y} {"Z second derivative" der2Z} 
			set inrimage::filter "gauss 3D"
			
			button .recfilter.b.ok -text "OK" -command "evaluate \"$img -recfilter \$inrimage::rfilter \$inrimage::filter sigma \[.recfilter.d.rfilter.s1 get\]\"; destroy .recfilter" -bg $color
			button .recfilter.b.dismiss -text "Dismiss" -command "destroy .recfilter" -bg $color
			
			pack .recfilter.d.rfilter .recfilter.d.filter -side left -fill both -padx 10 -pady 10
			pack .recfilter.b.ok .recfilter.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .recfilter.d .recfilter.b
		    }
		}
		
		
		proc inrimage::fillDialog { img {color "#E8E0D2"}} {
		    
		    if ![winfo exists .fill] {
			toplevel .fill -bg $color
			wm title .fill "Fill contours"
			
			frame .fill.d -bg $color
			frame .fill.b -bg $color
			
			label .fill.d.l1 -text "Contour options" -relief raised -bg $color
			radiobutton .fill.d.b1 -text "2D contours" -variable inrimage::dim -value "2D"  -bg $color -anchor w
			radiobutton .fill.d.b2 -text "3D contours" -variable inrimage::dim -value "3D"  -bg $color -anchor w
			set inrimage::dim "2D"
			
			label .fill.d.l2 -text "Background voxels value" -bg $color -anchor w
			inrimage::inrscale .fill.d.s1 $img $color min
			label .fill.d.l3 -text "Foreground voxels value" -bg $color -anchor w
			inrimage::inrscale .fill.d.s2 $img $color max
			
			button .fill.b.ok -text "OK" -command "evaluate \"$img -fill \$inrimage::dim bg \[.fill.d.s1 get\] fg \[.fill.d.s2 get\]\"; destroy .fill" -bg $color
			button .fill.b.dismiss -text "Dismiss" -command "destroy .fill" -bg $color
			
			pack .fill.d.l1 .fill.d.b1 .fill.d.b2 .fill.d.l2 .fill.d.s1 .fill.d.l3 .fill.d.s2 -fill x
			
			pack .fill.b.ok .fill.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .fill.d .fill.b
		    }
		}
		
		proc inrimage::noiseDialog { img {color "#E8E0D2"}} {
		    
		    if ![winfo exists .noise] {
			toplevel .noise -bg $color
			wm title .noise "Generate gaussian noisy box"
			
			frame .noise.d -bg $color
			frame .noise.b -bg $color
			
			frame .noise.d.par -bg $color
			label .noise.d.par.l1 -text "Noise parameters" -relief raised -bg $color
			radiobutton .noise.d.par.b1 -text "Mean value from image" -variable inrimage::fromimage -value 1  -bg $color -anchor w -command { .noise.d.par.mean configure -state disabled }
			radiobutton .noise.d.par.b2 -text "Fixed mean value" -variable inrimage::fromimage -value 0  -bg $color -anchor w -command { .noise.d.par.mean configure -state normal }
			set inrimage::fromimage 1
			inrimage::inrscale .noise.d.par.mean $img $color
			.noise.d.par.mean set 100.0
			.noise.d.par.mean configure -state disabled
			label .noise.d.par.l3 -text "Noise standard deviation" -bg $color -anchor w
			scale .noise.d.par.dev -from 0 -to 100.0 -resolution 0.1 -orient horiz -bg $color
			bind .noise.d.par.dev <Enter> { focus .noise.d.par.dev }
			.noise.d.par.dev set 3.0
			
			frame .noise.d.box -bg $color
			label .noise.d.box.l1 -text "Noise region" -relief raised -bg $color
			scan [$img -size] "%u %u %u" x y z
			set x [expr $x - 1]
			set y [expr $y - 1]
			set z [expr $z - 1]
			label .noise.d.box.l2 -text "From:" -bg $color -anchor w
			scale .noise.d.box.fx -from 0 -to $x -orient horiz -bg $color
			bind .noise.d.box.fx <Enter> { focus .noise.d.box.fx }
			scale .noise.d.box.fy -from 0 -to $y -orient horiz -bg $color
			bind .noise.d.box.fy <Enter> { focus .noise.d.box.fy }
			scale .noise.d.box.fz -from 0 -to $z -orient horiz -bg $color
			bind .noise.d.box.fz <Enter> { focus .noise.d.box.fz }
			label .noise.d.box.l3 -text "To:" -bg $color -anchor w
			scale .noise.d.box.tx -from 0 -to $x -orient horiz -bg $color
			.noise.d.box.tx set $x
			bind .noise.d.box.tx <Enter> { focus .noise.d.box.tx }
			scale .noise.d.box.ty -from 0 -to $y -orient horiz -bg $color
			.noise.d.box.ty set $y
			bind .noise.d.box.ty <Enter> { focus .noise.d.box.ty }
			scale .noise.d.box.tz -from 0 -to $z -orient horiz -bg $color
			.noise.d.box.tz set $z
			bind .noise.d.box.tz <Enter> { focus .noise.d.box.tz }
			
			button .noise.b.ok -text "OK" -command "if \$inrimage::fromimage { set mean \"\" } else { set mean \"mean \[.noise.d.par.mean get\]\"}; evaluate \"$img -noise \$mean dev \[.noise.d.par.dev get\] org \[.noise.d.box.fx get\] \[.noise.d.box.fy get\] \[.noise.d.box.fz get\] end \[.noise.d.box.tx get\] \[.noise.d.box.ty get\] \[.noise.d.box.tz get\]\"; destroy .noise" -bg $color
			button .noise.b.dismiss -text "Dismiss" -command "destroy .noise" -bg $color
			
			pack .noise.d.box.l1 .noise.d.box.l2 .noise.d.box.fx .noise.d.box.fy .noise.d.box.fz .noise.d.box.l3 .noise.d.box.tx .noise.d.box.ty .noise.d.box.tz -fill x
			pack .noise.d.par.l1 .noise.d.par.b1 .noise.d.par.b2 .noise.d.par.mean .noise.d.par.l3 .noise.d.par.dev -fill x
			pack .noise.d.par .noise.d.box -side left -padx 10 -pady 10 -fill both
			
			pack .noise.b.ok .noise.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .noise.d .noise.b
		    }
		}
		
		
		proc inrimage::inrimageDialog {{color "#E8E0D2"}} {
		    
		    if ![winfo exists .newinr] {
			toplevel .newinr -bg $color
			wm title .newinr "Create new inrimage"
			
			frame .newinr.d -bg $color
			frame .newinr.b -bg $color
			
			inrimage::choiceFrame .newinr.d.type "Type" inrimage::type $color {"8 bits unsigned" 8bits} {"16 bits signed" s16bits} {"16 bits unsigned" 16bits} {"32 bits signed" s32bits} {"32 bits unsigned" 32bits} {"64 bits signed" s64bits} {"64 bits unsigned" 64bits} {"float" float} {"double" double} {"RGB" rgb} {"RGBA" rgba} {"float vector" floatVector} {"double vector" doubleVector}
			set inrimage::type 8bits
			.newinr.d.type.8bits configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.16bits configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.s16bits configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.32bits configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.s32bits configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.64bits configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.s64bits configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.float configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.double configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.rgb configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.rgba configure -command { .newinr.d.size.s4 configure -state disabled }
			.newinr.d.type.floatVector configure -command { .newinr.d.size.s4 configure -state normal }
			.newinr.d.type.doubleVector configure -command { .newinr.d.size.s4 configure -state normal }
			
			frame .newinr.d.size -bg $color
			label .newinr.d.size.l1 -text "Size" -relief raised -bg $color
			scale .newinr.d.size.s1 -label "X" -from 1 -to 1024 -length 256 -orient horiz -bg $color
			.newinr.d.size.s1 set 100
			bind .newinr.d.size.s1 <Enter> { focus .newinr.d.size.s1 }
			scale .newinr.d.size.s2 -label "Y" -from 1 -to 1024 -length 256 -orient horiz -bg $color
			.newinr.d.size.s2 set 100
			bind .newinr.d.size.s2 <Enter> { focus .newinr.d.size.s2 }
			scale .newinr.d.size.s3 -label "Z" -from 1 -to 1024 -length 256 -orient horiz -bg $color
			.newinr.d.size.s3 set 100
			bind .newinr.d.size.s3 <Enter> { focus .newinr.d.size.s3 }
			scale .newinr.d.size.s4 -label "Vectorial dimension" -from 2 -to 30 -orient horiz -bg $color
			.newinr.d.size.s4 set 3
			.newinr.d.size.s4 configure -state disabled
			bind .newinr.d.size.s4 <Enter> { focus .newinr.d.size.s4 }
			
			button .newinr.b.ok -text "OK" -command "if { !\[string compare \$inrimage::type floatVector\] || !\[string compare \$inrimage::type doubleVector\] } { set inrimage::dim \[.newinr.d.size.s4 get\]} else { set inrimage::dim \"\" } ;view \[evaluate \"new inr x \[.newinr.d.size.s1 get\] y  \[.newinr.d.size.s2 get\] z \[.newinr.d.size.s3 get\] type \$inrimage::type \$inrimage::dim\"\]; destroy .newinr" -bg $color
			button .newinr.b.dismiss -text "Dismiss" -command "destroy .newinr" -bg $color
			
			pack .newinr.d.size.l1 .newinr.d.size.s1 .newinr.d.size.s2 .newinr.d.size.s3 -fill x
			pack .newinr.d.size.s4 -pady 20 -fill x
			
			pack .newinr.d.type .newinr.d.size -side left -padx 10 -pady 10 -fill both
			
			pack .newinr.b.ok .newinr.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack .newinr.d .newinr.b
		    }
		}
		
		proc inrimage::convertDialog {img {color "#E8E0D2"}} {
		    set root .castDialog
		    if ![winfo exists $root] {
			toplevel $root -bg $color
			wm title $root "Convert an image"
			
			frame $root.d -bg $color
			frame $root.b -bg $color
			
			inrimage::choiceFrame $root.d.type "Type" inrimage::type $color {"8 bits unsigned" 8bits} {"16 bits signed" s16bits} {"16 bits unsigned" 16bits} {"32 bits signed" s32bits} {"32 bits unsigned" 32bits} {"64 bits signed" s64bits} {"64 bits unsigned" 64bits} {"float" float} {"double" double} {"RGB" rgb} {"RGBA" rgba} {"float vector" floatVector} {"double vector" doubleVector}
			set inrimage::type 8bits
			
			# frame $root.d.method -bg $color
			inrimage::choiceFrame $root.d.method "Convertion MeThod" inrimage::method $color {"Cast Value" cast} {"Scale Value between min and max" scale}
			set inrimage::method cast
			
			button $root.b.ok -text "Apply" -command "evaluate \"$img -type \$inrimage::method \$inrimage::type \";destroy $root "
			button $root.b.dismiss -text "Dismiss" -command "destroy $root" -bg $color
			
			
			pack $root.d.type $root.d.method -side left -padx 10 -pady 10 -fill both
			
			pack $root.b.ok $root.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack $root.d $root.b
		    }
		}
		proc inrimage::flipDialog {img {color "#E8E0D2"}} {
		    set root .flipDialog
		    if ![winfo exists $root] {
			toplevel $root -bg $color
			wm title $root "Flip an image along a direction"
			
			frame $root.d -bg $color
			frame $root.b -bg $color
			
			inrimage::choiceFrame $root.d.dir "Choose a direction" inrimage::direction $color {"Along X" x} {"Along Y" y} {"Along Z" z}
			set inrimage::direction x
			
			button $root.b.ok -text "Apply" -command "evaluate \"$img -flip \[ string toupper \$inrimage::direction \] \";destroy $root "
			button $root.b.dismiss -text "Dismiss" -command "destroy $root" -bg $color
			
			
			pack $root.d.dir -side left -padx 10 -pady 10 -fill both
			
			pack $root.b.ok $root.b.dismiss -side left -expand true -fill x -padx 20 -pady 10
			pack $root.d $root.b
		    }
		}
		proc inrimage::updateLine { slicecam X Y } {
		    
		    
		    if [string compare $slicecam $inrimage::current_reformat_slicecam] {
			# on reinitialise tout 
			if [string compare $inrimage::current_reformat_slicecam no] {
			    [$inrimage::current_reformat_slicecam -widget] delete -tags reformat_current
			}
			set inrimage::current_reformat_slicecam $slicecam
			set inrimage::reformatLineSel ori
		    }
		    
		    
		    if ![string compare $inrimage::reformatLineSel ori] {
			set inrimage::reformatLineOriX $X
			set inrimage::reformatLineOriY $Y
			
			set inrimage::reformatLineSel end
		    } else {
			set inrimage::reformatLineEndX $X
			set inrimage::reformatLineEndY $Y
			
			[$inrimage::current_reformat_slicecam -widget] delete -tags reformat_current
			[$inrimage::current_reformat_slicecam -widget] create line $inrimage::reformatLineOriX $inrimage::reformatLineOriY $inrimage::reformatLineEndX $inrimage::reformatLineEndY  -width 1 -fill blue -tags reformat_current
			
			set inrimage::reformatLineSel ori
		    }
		    
		    set inrimage::reformatLineSlice [$inrimage::current_reformat_slicecam -slice]
		    
		}
		
		proc inrimage::interactiveLine { cam } {
		    if ![string compare [$cam -geometry] X] {
			bind [$cam -widget] <Motion> "$cam  -mouseMotion %x %y; \[$cam -motionlabel\] configure -text \[$cam -mousevoxel %x %y\]; if !\[string compare \$inrimage::reformatLineSel end \] { if !\[string compare \$inrimage::current_reformat_slicecam $cam\] {\[$cam -widget\] delete -tags reformat_current; \[$cam -widget\] create line \$inrimage::reformatLineOriX \$inrimage::reformatLineOriY \[lindex {$cam -mouseMotion %x %y} 2\] \[lindex {$cam -mouseMotion %x %y} 3\] -width 1 -fill blue -tags reformat_current} }"
		    }
		    if ![string compare [$cam -geometry] Y] {
			bind [$cam -widget] <Motion> "$cam  -mouseMotion %x %y; \[$cam -motionlabel\] configure -text \[$cam -mousevoxel %x %y\]; if !\[string compare \$inrimage::reformatLineSel end \] { if !\[string compare \$inrimage::current_reformat_slicecam $cam\] {\[$cam -widget\] delete -tags reformat_current; \[$cam -widget\] create line \$inrimage::reformatLineOriX \$inrimage::reformatLineOriY \[lindex {$cam -mouseMotion %x %y} 2\] \[lindex {$cam -mouseMotion %x %y} 3\] -width 1 -fill blue -tags reformat_current} }"
		    }
		    if ![string compare [$cam -geometry] Z] {
			bind [$cam -widget] <Motion> "$cam  -mouseMotion %x %y; \[$cam -motionlabel\] configure -text \[$cam -mousevoxel %x %y\]; if !\[string compare \$inrimage::reformatLineSel end \] { if !\[string compare \$inrimage::current_reformat_slicecam $cam\] {\[$cam -widget\] delete -tags reformat_current; \[$cam -widget\] create line \$inrimage::reformatLineOriX \$inrimage::reformatLineOriY \[lindex {$cam -mouseMotion %x %y} 2\] \[lindex {$cam -mouseMotion %x %y} 3\] -width 1 -fill blue -tags reformat_current} }"
		    }
		} 
		
		
		proc inrimage::setDrawingLineMode { inr } {
		    foreach {cam} [ $inr -slicecams ] { 
			bind [$cam -widget] <ButtonPress-1> "inrimage::updateLine $cam [lindex {$cam -button1Pressed %x %y} 2] [lindex {$cam -button1Pressed %x %y} 3]"
			bind [$cam -widget] <ButtonRelease-1> ""
			bind [$cam -widget] <Motion> "inrimage::interactiveLine $cam"
		    }
		    
		}
		
		proc inrimage::resetDrawingLineMode { inr } {
		    foreach {cam} [ $inr -slicecams ] { [$cam -widget] delete -tags reformat_current; bind [$cam -widget] <ButtonPress-1> ""
		    bind [$cam -widget] <ButtonRelease-1> "" 
		}
	    }
	    
	    
	    
	    proc inrimage::reformat { inr color } {
		
		if ![winfo exists .reformat] {
		    toplevel .reformat -bg $color
		    wm title .reformat "Reformat of an image"
		    frame .reformat.choice  -bg $color
		    frame .reformat.b -bg $color
		    
		    label .reformat.choice.l1  -text "Orientation of the line" -relief raised -bg $color -anchor w
		    radiobutton .reformat.choice.r1 -text "Horizontal" -variable inrimage::refo -value "h" -bg $color -anchor w
		    radiobutton .reformat.choice.r2 -text "Vertical" -variable inrimage::refo -value "v" -bg $color -anchor w
		    
		    set inrimage::refo h
		    
		    
		    button .reformat.b.ok -text "OK" -command "view \[ evaluate \" $inr -reformat \$inrimage::current_reformat_slicecam \$inrimage::reformatLineOriX \$inrimage::reformatLineOriY \$inrimage::reformatLineEndX \$inrimage::reformatLineEndY \$inrimage::refo \" \]" -bg $color
		    button .reformat.b.dismiss -text "Dismiss" -command "destroy .reformat; inrimage::resetDrawingLineMode $inr" -bg $color
		    
		    pack .reformat.choice.l1 .reformat.choice.r1 .reformat.choice.r2 -side top -fill x
		    
		    pack .reformat.b.ok .reformat.b.dismiss  -side left -padx 10 -pady 10
		    pack .reformat.choice .reformat.b -side top
		}
	    }
	    
	    # Cette procedure permet de faire du recalage manuel grace a des landmarks
	    proc inrimage::manualRegistration { img1 img2 mview1 } {
		
		
		set scn1 [ [ lindex [ $img1 -slicecams ] 0 ] -scene ]
		set scn2 [ [ lindex [ $img2 -slicecams ] 0 ] -scene ]
		set lset1 [ new lset -scene $scn1 ]
		set lset2 [ new lset -scene $scn2 ]
		set ext $img1-TO-$img2
		
		foreach {mv2} [ which multiview ] { if ![string compare [$mv2 -scene] $scn2] { }}
		
		
		if {![winfo exists .manualreg$ext]} {
		    toplevel .manualreg$ext -bg $yav::color
		    wm title .manualreg$ext "Mamual Registration"
		    
		    frame .manualreg$ext.titre -bg $yav::color
		    label .manualreg$ext.titre.l -text "List of Landmarks:" -bg $yav::color
		    pack .manualreg$ext.titre.l
		    
		    frame .manualreg$ext.soustitre  -bg $yav::color
		    label .manualreg$ext.soustitre.l1 -text "$img1 ([lindex [ split [ $img1 -name] / ] end ])" -bg $yav::color
		    label .manualreg$ext.soustitre.l2 -text "$img2 ([lindex [ split [ $img2 -name] / ] end ])" -bg $yav::color
		    pack .manualreg$ext.soustitre.l1 .manualreg$ext.soustitre.l2 -side left -fill x -expand true 
		    
		    frame .manualreg$ext.list -bg $yav::color
		    listbox .manualreg$ext.list.$lset1 -width 50 -bg white -yscrollcommand [list .manualreg$ext.list.scroll1 set]
		    listbox .manualreg$ext.list.$lset2 -width 50 -bg white -yscrollcommand [list .manualreg$ext.list.scroll2 set]
		    listbox .manualreg$ext.list.error -width 50 -bg white -yscrollcommand [list .manualreg$ext.list.scroll3 set]
		    bind .manualreg$ext.list.$lset1 <<ListboxSelect>> "set name \[ lindex \[.manualreg$ext.list.$lset1 get \[.manualreg$ext.list.$lset1 curselection \]\] 3\]; evaluate \" $lset1 -selectedLandmark \$name \"; evaluate \" $lset2 -selectedLandmark \$name \"; "
		    bind .manualreg$ext.list.$lset2 <<ListboxSelect>> "set name \[ lindex \[.manualreg$ext.list.$lset2 get \[.manualreg$ext.list.$lset2 curselection \]\] 3\]; evaluate \" $lset2 -selectedLandmark  \$name \"; evaluate \" $lset1 -selectedLandmark \$name \"; "
		    
		    set inrimage::ListBoxLandmarks [ linsert $inrimage::ListBoxLandmarks end .manualreg$ext.list.$lset1 .manualreg$ext.list.$lset2 ]
		    scrollbar .manualreg$ext.list.scroll1  -orient vertical -bg $yav::color  -command [list .manualreg$ext.list.$lset1 yview]
		    scrollbar .manualreg$ext.list.scroll2  -orient vertical -bg $yav::color  -command [list .manualreg$ext.list.$lset2 yview]
		    pack .manualreg$ext.list.$lset1 .manualreg$ext.list.scroll1 .manualreg$ext.list.$lset2 .manualreg$ext.list.scroll2 -fill both -expand true -side left
		    
		    frame .manualreg$ext.type  -bg $yav::color
		    label .manualreg$ext.type.l -text "Type of Registration:"  -bg $yav::color
		    radiobutton .manualreg$ext.type.r1 -text "Rigid"  -variable inrimage::registertype -value "rigid" -bg $yav::color
		    radiobutton .manualreg$ext.type.r2 -text "Similarity"  -variable inrimage::registertype -value "similarity" -bg $yav::color
		    radiobutton .manualreg$ext.type.r3 -text "Affine"  -variable inrimage::registertype -value "affine" -bg $yav::color
		    
		    pack .manualreg$ext.type.l .manualreg$ext.type.r1 .manualreg$ext.type.r2 .manualreg$ext.type.r3 -side left
		    
		    frame .manualreg$ext.resample  -bg $yav::color
		    set r1 [radiobutton .manualreg$ext.resample.i1 -text "$img1 ([lindex [ split [ $img1 -name] / ] end ])" -variable inrimage::registerimg -value "inr1" -bg $yav::color -command "set inrimage::resamplset 1"]
		    set r2 [radiobutton .manualreg$ext.resample.i2 -text "$img2 ([lindex [ split [ $img2 -name] / ] end ])" -variable inrimage::registerimg -value "inr2" -bg $yav::color -command "set inrimage::resamplset 2"]
		    checkbutton .manualreg$ext.resample.c -text "Resample"  -variable inrimage::reg_resample -onvalue "resample" -offvalue "" -bg $yav::color
		    
		    
		    pack .manualreg$ext.resample.c .manualreg$ext.resample.i1 .manualreg$ext.resample.i2 -side left
		    
		    frame .manualreg$ext.bot  -bg $yav::color
		    
		    button .manualreg$ext.bot.ok -text OK -command "set CMD \"$lset1 -register $lset2 \$inrimage::registertype \"; if !\[string compare \$inrimage::reg_resample resample \] { set newscn2D \[new scn2D\]; set CMD \[ concat \$CMD -resample \$inrimage::resamplset  -scene \$newscn2D \] }; puts \$CMD; set RES \[ evaluate \"\$CMD\"; \]; puts \$RES; set MATRES \[ lindex \[split \$RES\] 0 \]; if !\[string compare \$inrimage::reg_resample resample \] {set LSETRES \[ lindex \[split \$RES\] 1 \]; set VOX1 \[ new mat4D -name voxel$img1 -diag \[lindex \[$img1 -voxel \] 0\] \[lindex \[$img1 -voxel \] 1\] \[lindex \[$img1 -voxel \] 2\] 1 \]; set VOX2 \[ new mat4D -name voxel$img2 -diag \[lindex \[$img2 -voxel \] 0\] \[lindex \[$img2 -voxel \] 1\] \[lindex \[$img2 -voxel \] 2\] 1 \]; \$VOX2 -inv; \$VOX2 -mul \$MATRES; \$VOX2 -mul \$VOX1; if  !\[string compare \$inrimage::resamplset 1\] { set flo_dim_x \[ lindex \[ $img2 -size \] 0 \]; set flo_dim_y \[ lindex \[ $img2 -size \] 1 \]; set flo_dim_z \[ lindex \[ $img2 -size \] 2 \]; set flo_vox_x \[ lindex \[ $img2 -voxel \] 0 \]; set flo_vox_y \[ lindex \[ $img2 -voxel \] 1 \]; set flo_vox_z \[ lindex \[ $img2 -voxel \] 2 \]; set ref_reech \[ $img1 -transform cspline -mat \$VOX2 -inv\]; \$ref_reech -voxel \$flo_vox_x \$flo_vox_y \$flo_vox_z; set mview \[inrimage::viewInrimage \$ref_reech \$newscn2D \]; \$mview -addmview $mv2; $mview1 -addmview \$mview -transfo \$MATRES } else { set ref_dim_x \[ lindex \[ $img1 -size \] 0 \]; set ref_dim_y \[ lindex \[ $img1 -size \] 1 \]; set ref_dim_z \[ lindex \[ $img1 -size \] 2 \]; set ref_vox_x \[ lindex \[ $img1 -voxel \] 0 \]; set ref_vox_y \[ lindex \[ $img1 -voxel \] 1 \]; set ref_vox_z \[ lindex \[ $img1 -voxel \] 2 \]; set flo_reech \[ $img2 -transform cspline -mat \$VOX2 \]; \$flo_reech -voxel \$ref_vox_x \$ref_vox_y \$ref_vox_z; set mview \[inrimage::viewInrimage \$flo_reech \$newscn2D \]; \$mview -addmview $mview1; \$mview -addmview $mv2 -transfo \$MATRES}} "
		    
		    
		    button .manualreg$ext.bot.d -text Dismiss -command "destroy .manualreg$ext" -bg $yav::color
		    pack .manualreg$ext.bot.ok .manualreg$ext.bot.d -side left -expand true
		    
		    pack .manualreg$ext.titre .manualreg$ext.soustitre .manualreg$ext.list .manualreg$ext.type .manualreg$ext.resample .manualreg$ext.bot -side top -expand true -fill x -pady 10
		    
		}
		
	    }
	    
	    proc inrimage::displayManualSegError {lset1 lset2 } {
		puts $lset1 
		puts $lset2
		set res [ evaluate "$lset1 -computeError $lset2" ]
		
		puts $res
	    }
	    
	    proc inrimage::updateListBoxLandmarks { lset } {
		
		# On a une variable globale qui stocke la liste de toutes les listes box associees a ce landmark
		foreach {box} $inrimage::ListBoxLandmarks {
		    set sep [ lindex [ split $box . ] end ]
		    if ![string compare $sep $lset] {
			$box delete 0 end
			foreach {landmark} [$lset -landmarks] {
			    set x [ lindex [ split $landmark ] 1 ]
			    set y [ lindex [ split $landmark ] 2 ]
			    set z [ lindex [ split $landmark ] 3 ]
			    set name [ lindex [ split $landmark ] 7 ]
			    $box insert end "$x $y $z $name"
			}
		    }
		}
	    }
	    
	    